﻿<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/user_input_handler_registry.php';
class SmartEntryHandler
    implements UserInputHandler
{
    public function __construct(){
        UserInputHandlerRegistry::get_instance()->
            register_handler($this);
    }

    public function get_handler_id(){
        return 'entry';
    }

    public function handle_user_input(&$user_input, &$plugin_cookies){
		if (isset($user_input->control_id)){
			if ($user_input->control_id == 'reboot')
				return shell_exec('reboot');
			if ($user_input->control_id == 'power_off')
				return shell_exec('echo A15EBF00 > /proc/ir/button');
			if ($user_input->control_id == 'do_setup')
				return ActionFactory::open_folder('setup','Bazinga Настройки');
			if ($user_input->control_id == 'save_skin'){
				if (file_exists('/tmp/dune_skin_dir.txt')) 
					$skin_path = trim(str_replace('skin_dir =', '', file_get_contents('/tmp/dune_skin_dir.txt'))) . '/';
				else
					throw new Exception(get_class($this).': Can not determine the path to the active skin.');
				$custom_skin_path = file_exists('/persistfs')? '/persistfs/dune_skin/' : '/flashdata/dune_skin/';
				if (!file_exists($custom_skin_path))
					mkdir ($custom_skin_path);
				if (file_exists($custom_skin_path)) {
					foreach (glob($custom_skin_path . '*') as $file) {
						if (is_link($file)) {
							unlink($file);
						} else if (is_dir($file)) {
							shell_exec('rm -rf ' . $file . '/*');
							rmdir($file);
						} else unlink($file);
					}
				} else {
					throw new Exception(get_class($this).': Can not create custom skin.');
					return false;
				}
				foreach (glob($skin_path . '*') as $file) {
					hd_print($file);
					if ($file == $skin_path . 'images') {
						mkdir($custom_skin_path . 'images');
						foreach (glob($skin_path . 'images/*') as $images_file) {
							hd_print('    ' . $images_file);
							if ($images_file == $skin_path . 'images/bg.jpg') {
								copy($images_file, $custom_skin_path . 'images/' . basename($images_file));
							} else symlink($images_file, $custom_skin_path . 'images/' . basename($images_file));
						}
					} else if ($file == $skin_path . 'dune_skin_config.xml') {
						copy($file, $custom_skin_path . basename($file));
					} else {
						symlink($file, $custom_skin_path . basename($file));
					}
				}
				if (file_exists('/config/settings.properties')) {
					$system_settings_runtime = parse_ini_file('/config/settings.properties', 0, INI_SCANNER_RAW);
					$system_settings_runtime['gui_skin'] = 'custom';
					$output = '';
					foreach($system_settings_runtime as $k => $v) {
						$output .= "$k = $v" . PHP_EOL;
					}
					file_put_contents('/config/settings.properties', $output);
				}
				if (defined('CHANGE_SETTINGS_ACTION_ID'))
					return array(
						 GuiAction::handler_string_id => CHANGE_SETTINGS_ACTION_ID,
						 GuiAction::data => array(
							ChangeSettingsActionData::restart_gui => true,
							ChangeSettingsActionData::post_action => null));

				if (defined('RESTART_ACTION_ID'))
					return array(
						 GuiAction::handler_string_id => RESTART_ACTION_ID,
						 GuiAction::data => array(
							RestartActionData::reboot => false));

				exec('killall shell');
			}
			if ($user_input->control_id == 'newPluginIco'){
				$ini_array = parse_ini_file("/config/settings.properties");
				if ($ini_array['gui_skin'] != 'custom'){
					ControlFactory::add_multiline_label($defs, '', "Для задания иконки необходимо установить пользовательскую тему оформления из расширенного дюнастора или из zip файла или установить текущую тему пользовательской.
					Установить текущую тему пользовательской? Плеер будет перезагружен.",10);
					ControlFactory::add_close_dialog_and_apply_button($defs, $this, null, 'save_skin', 'Да', 300);
					ControlFactory::add_close_dialog_button($defs, 'Нет', 300);
					return  ActionFactory::show_dialog('Тема оформления не пользовательская!',$defs, true,950);
				}
				$prefix	 = '/persistfs';
				if (!file_exists('/persistfs'))
					$prefix	 = '/flashdata';
				$imgFoler = $prefix . '/dune_skin/plugins/icons/'.DuneSystem::$properties['plugin_name'].'/icons';
				if (!file_exists($imgFoler))
					mkdir($imgFoler, 0755, true);
				$sPath = $imgFoler . "/logo.png";
				if ((file_exists($sPath))&&(!isset($user_input->rewrite))){
					if (isset($user_input->remove)){
						unlink($sPath);
						rmdir($imgFoler);
						ControlFactory::add_multiline_label($defs, '', "Для применения удаления иконки необходима перезагрузка плеера!\nПерезагрузить плеер сейчас?", 8);
						ControlFactory::add_close_dialog_and_apply_button($defs, $this, null, 'reboot', 'Да', 300);
						ControlFactory::add_close_dialog_button($defs, 'Нет', 300);
						return ActionFactory::show_dialog('Необходима перезагрузка плеера', $defs, true, 800);
					}
					ControlFactory::add_close_dialog_and_apply_button($defs, $this, array('remove' => true), $user_input->control_id, 'Удалить', 300);
					ControlFactory::add_close_dialog_and_apply_button($defs, $this, array('rewrite' => true), $user_input->control_id, 'Перезаписать', 300);
					return  ActionFactory::show_dialog('Иконка плагина уже задана',$defs, true,850);
				}
				$media_url = MediaURL::encode (
					array(
						'screen_id'     => 'file_list',
						'save_file'		=> array(	
						'action' 		=> 'newPluginIco',
						'extension' 	=> 'png'
						),
					)
				);
				return ActionFactory::open_folder($media_url,'Выберите .png файл размером 200х200:');
			}
		}
		if ($user_input->handler_id == 'entry'){
			return ActionFactory::open_folder();
		}
    }
}

///////////////////////////////////////////////////////////////////////////
?>
