<?php
///////////////////////////////////////////////////////////////////////////

require_once 'Smart_vod_category.php';

///////////////////////////////////////////////////////////////////////////

class SmartMainMenuScreen extends AbstractPreloadedRegularScreen
implements UserInputHandler
{
    const ID = 'main_menu';
    public static function get_media_url_str(){
        return MediaURL::encode(array('screen_id' => self::ID));
    }

    ///////////////////////////////////////////////////////////////////////
    private $category_list;
	private $select_url = array();
	private $unlock = false;
	private $allCat = false;
	static $invalMainMenu = false;
    ///////////////////////////////////////////////////////////////////////

    public function __construct(){
        parent::__construct(
            self::ID, 
			$this->get_folder_views()
		);
		UserInputHandlerRegistry::get_instance()->
            register_handler($this);
    }

    ///////////////////////////////////////////////////////////////////////

    public function get_action_map(MediaURL $media_url, &$plugin_cookies){
		$add_action = UserInputHandlerRegistry::create_action($this, 'whats_new');
        $add_action['caption'] = 'Info';
        $actions[GUI_EVENT_KEY_B_GREEN] = $add_action;
		
        $add_action = ActionFactory::open_folder('setup','Настройки');
        $add_action['caption'] = 'Настройки';
        $actions[GUI_EVENT_KEY_C_YELLOW] = $add_action;
		$actions[GUI_EVENT_KEY_SETUP] = $add_action;
		
		$add_action = UserInputHandlerRegistry::create_action($this, 'classAction', array('action' => 'addUserFav'));
        $add_action['caption'] = 'Избранное+';
        $actions[GUI_EVENT_KEY_D_BLUE] = $add_action;
		
		$actions[GUI_EVENT_KEY_ENTER] = UserInputHandlerRegistry::create_action($this, 'add_actions');
		$actions[GUI_EVENT_KEY_PLAY] = UserInputHandlerRegistry::create_action($this, 'add_actions');
				
		$popup_menu_action = UserInputHandlerRegistry::create_action($this, 'popup_menu');
		$actions[GUI_EVENT_KEY_POPUP_MENU] = $popup_menu_action;
		
		$add_params['action_move'] = 'hide_id';
		$add_action = UserInputHandlerRegistry::create_action($this, 'id_move', $add_params);
		$actions[GUI_EVENT_KEY_CLEAR] = $add_action;
		
		$actions[GUI_EVENT_KEY_SEARCH] = UserInputHandlerRegistry::create_action($this, 'classAction', array('action' => 'search'));
		$useNumKey = HD::getItemsArr('useNumKey');
		foreach ($useNumKey as $k => $v){
			$params['openCat'] = $v;
			$actions[SmartConfig::$keyArr[$k]] = UserInputHandlerRegistry::create_action($this, 'add_actions', $params);
		}
		return $actions;
    }
	
	public function get_handler_id(){
		return self::ID;
	}
	
	public function handle_user_input(&$user_input, &$plugin_cookies){
		$parentalControl = isset($plugin_cookies->parentalControl) ? $plugin_cookies->parentalControl : '';
		if ($user_input->control_id == 'add_actions'){
			if (isset($user_input->openCat))
				$user_input->selected_media_url = $user_input->openCat; 
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			if ($parentalControl != ''){
				$lockCat = HD::getItemsArr('lockCat');
				if (isset($lockCat[$user_input->selected_media_url])){
					if(!isset($user_input->unlock)){
						$add_params['controlId']= $user_input->control_id;
						if (isset($user_input->openCat))
							$add_params['openCat']= $user_input->openCat;
						ControlFactory::add_text_field(
							$defs, $this, $add_params,
							'hide_pin_control', '',
							'', 1, 1, 0, 1, 500, 1 , 0
						);
						return  ActionFactory::show_dialog('Введите код:', $defs, true);
					}	
				}
			}
			
			if ($selected_media_url->screen_id == 'vod_torrserver'){
				if (TorrServer::getOnlineStatusServer() == true){
					if (!preg_match("|matrix|i", TorrServer::getStatusTorrServer()))
						return ActionFactory::show_title_dialog('Версия TorrServer устарела', null, 'Необходимо установить TorrServer MatriX', 0);
					HD::asyncExec('proc_close');
					VodTorrServerScreen::$counter = 0;
					TorrServer::actionGetTorrentList();
					if (isset($user_input->openCat))
						return ActionFactory::open_folder($user_input->selected_media_url, $selected_media_url->caption);
					return ActionFactory::open_folder();
				}else{
					if (HD::is_android() == true){
						$package = TorrServer::getTorrServerPackageName();
						if ($package == false){
							hd_silence_warnings();
							return TorrServer::meinMenuOpenFolderDialog($user_input, $plugin_cookies);
						}
					}
					$action = UserInputHandlerRegistry::create_action($this, 'classSetupTorrServer');
hd_print("EEE tni 2");
					return ActionFactory::show_title_dialog('TorrServer не запущен', $action, TorrServer::getIp(), 0);
				}
			}
			if ($selected_media_url->screen_id == 'vod_peerflixserver'){
				if (PeerflixServer::getOnlineStatusServer() == true){
					HD::asyncExec('proc_close');
					VodPeerflixServerScreen::$counter = 0;
					PeerflixServer::actionGetTorrentList();
					if (isset($user_input->openCat))
						return ActionFactory::open_folder($user_input->selected_media_url, $selected_media_url->caption);
					return ActionFactory::open_folder();
				}else if (PeerflixServer::getSlavePeerflixServer() == true){
					hd_silence_warnings();
					return PeerflixServer::startPeerflixServer($defs, $user_input);
				}
				$action = UserInputHandlerRegistry::create_action($this, 'classSetupPeerflixServer');
				return ActionFactory::show_title_dialog('Peerflix-Server не запущен', $action, PeerflixServer::getIp(), 0);
			}
			if ($selected_media_url->screen_id == 'vod_transmissionupnp'){
				if (TransmissionUPnP::getOnlineStatusServer() == true){
					HD::asyncExec('proc_close');
					VodTransmissionUPnPScreen::$counter = 0;
					TransmissionUPnP::actionGetTorrentList();
					TransmissionUPnP::actionGetSessionInfo();
					if (isset($user_input->openCat))
						return ActionFactory::open_folder($user_input->selected_media_url, $selected_media_url->caption);
					return ActionFactory::open_folder();
				}else if (TransmissionUPnP::getInstallTransmissionUPnP() == true){
					hd_silence_warnings();
					return TransmissionUPnP::startTransmissionUPnP($defs, $user_input);
				}
				if (HD::is_android() == true){
					$package = TransmissionUPnP::getTransmissionBTCPackageName();
					if ($package == false){
						hd_silence_warnings();
						return TransmissionUPnP::meinMenuOpenFolderDialog($user_input, $plugin_cookies);
					}
				}
				$action = UserInputHandlerRegistry::create_action($this, 'classSetupTransmissionUPnP');
				return ActionFactory::show_title_dialog('Transmission BTC UPnP не запущен', $action, TransmissionUPnP::getIp(), 0);
			}
			if ($selected_media_url->screen_id == 'vod_transmission'){
				if (Transmission::getOnlineStatusServer() == true){
					HD::asyncExec('proc_close');
					VodTransmissionScreen::$counter = 0;
					Transmission::actionGetTorrentList();
					Transmission::actionGetSessionInfo();
					if (isset($user_input->openCat))
						return ActionFactory::open_folder($user_input->selected_media_url, $selected_media_url->caption);
					return ActionFactory::open_folder();
				}else if (Transmission::getSlaveTransmission() == true){
					hd_silence_warnings();
					return Transmission::actionStartStopTransmission($defs, $user_input);
				}
				if (HD::is_android() == true){
					$package = TransmissionUPnP::getTransmissionBTCPackageName();
					if ($package == false){
						hd_silence_warnings();
						return TransmissionUPnP::meinMenuOpenFolderDialog($user_input, $plugin_cookies);
					}
				}
				$action = UserInputHandlerRegistry::create_action($this, 'classSetupTransmission');
				return ActionFactory::show_title_dialog('Transmission не запущен', $action, Transmission::getIp(), 0);
			}
			if (isset($user_input->openCat))
				return ActionFactory::open_folder($user_input->selected_media_url, $selected_media_url->caption);
			if (isset($selected_media_url->class_name)){
				$class_name = $selected_media_url->class_name;
				if ($class_name == 'search')
					$class_name = 'SmartSearchScreen';
				if (method_exists($class_name,'meinMenuOpenFolderDialog')){
					hd_silence_warnings();
					return $class_name::meinMenuOpenFolderDialog($user_input, $plugin_cookies);
				}
			}
			return ActionFactory::open_folder();
		}
		if ($user_input->control_id == 'classAction'){
			$defs = array();
			hd_silence_warnings();
			$user_input->parent_media_url = self::get_media_url_str();
			if (isset($user_input->indiClass)){
				$class_name = $user_input->indiClass;
				return $class_name::classAction ($defs, $user_input, $this->select_url);
			}
			return SmartConfig::classAction ($defs, $user_input, $this->select_url);
		}
		if ($user_input->control_id == 'classSetupTorrServer'){
			$defs = array();
			hd_silence_warnings();
			return TorrServer::setup($defs, $user_input);
		}
		if ($user_input->control_id == 'classSetupPeerflixServer'){
			$defs = array();
			hd_silence_warnings();
			return PeerflixServer::setup($defs, $user_input);
		}
		if ($user_input->control_id == 'classSetupTransmission'){
			$defs = array();
			hd_silence_warnings();
			return Transmission::setup($defs, $user_input);
		}
		if ($user_input->control_id == 'classSetupTransmissionUPnP'){
			$defs = array();
			hd_silence_warnings();
			return TransmissionUPnP::setup($defs, $user_input);
		}
		if ($user_input->control_id == 'parentalControlactions'){
			if (!isset($user_input->selected_media_url))
				return null;
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			if (isset($user_input->unlock_id)){
				if(!isset($user_input->unlock)){
					if ($parentalControl != ''){
						$params['unlock'] = true;
						$add_params['param'] = 'unlock_id';
						$add_params['vel'] = 1;
						$add_params['controlId']= $user_input->control_id;
						ControlFactory::add_text_field(
							$defs, $this, $add_params,
							'hide_pin_control', '',
							'', 1, 1, 0, 1, 500, 1 , 0
						);
						return  ActionFactory::show_dialog('Введите код:', $defs, true);
					}
				}
				$lockCat = HD::getItemsArr('lockCat');
				unset($lockCat[$user_input->selected_media_url]);
				HD::saveItemsArr('lockCat', $lockCat);
				return ActionFactory::invalidate_folders(array($user_input->parent_media_url));
			}
			if (isset($user_input->lock_id)){
				if (isset($user_input->apply)){
					$lockCat = HD::getItemsArr('lockCat');
					$lockCat[$user_input->selected_media_url] = 1;
					HD::saveItemsArr('lockCat', $lockCat);
					return ActionFactory::invalidate_folders(array($user_input->parent_media_url));
				}
				ControlFactory::add_multiline_label($defs, '', "Отключается через POPUP Menu открыть категорию.", 5);
				$add_params['apply'] = true;
				$add_params['lock_id'] = 1;
				ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id, 'Да', 250);
				ControlFactory::add_close_dialog_button($defs,'Нет', 250);
				return  ActionFactory::show_dialog("Закрыть категорию?", $defs, true, 700);
			}
		}
		if ($user_input->control_id == 'histori_clear'){
			HD::saveItemsArr('itemsHistory', array());
			return ActionFactory::show_title_dialog("История просмотра очищена");
		}
		if ($user_input->control_id == 'popup_menu'){
			if (isset($user_input->selected_media_url)){
				$selected_media_url = MediaURL::decode($user_input->selected_media_url);
				$class_name = $selected_media_url->class_name;
				$categories = $this->get_categories();
				if (preg_match("|_Class|",$class_name)){
					$mItems = $class_name::getPopUpMenuItems($selected_media_url, $user_input->parent_media_url);
					foreach ($mItems as $v){
						if ($v == 'is_separator')
							$menu_items [] =  array(
							GuiMenuItemDef::is_separator => true,);
						// else if ($v['params'] == 'classSetup')
							// $menu_items[] = array(
								// GuiMenuItemDef::caption => $v['caption'],
								// GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classSetup' . $class_name),
								// GuiMenuItemDef::icon_url => $v['icon_url'],
							// );
						else
							$menu_items[] = array(
								GuiMenuItemDef::caption => $v['caption'],
								GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', $v['params']),
								GuiMenuItemDef::icon_url => $v['icon_url'],
							);
					}
				}
				if ((isset($selected_media_url->hCaptions))||
				(isset($selected_media_url->movie_id))||
				(isset($selected_media_url->categoryId))){
					$paramsdel['action'] = 'addToMainMenu';
					$paramsdel['del'] = true;
					$menu_items[] = array(
						GuiMenuItemDef::caption => 'Удалить из Главного Меню',
						GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', $paramsdel),
						GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_delete')
					);
					$menu_items [] =  array(
					GuiMenuItemDef::is_separator => true,);
				}
				if ($class_name == 'itemsHistory'){
					$menu_items[] = array(
						GuiMenuItemDef::caption => 'Очистить Историю',
						GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'histori_clear'),
						GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_histori_clear')
					);
					$menu_items [] =  array(
					GuiMenuItemDef::is_separator => true,);
				}
				if ((preg_match("|userFav_|",$class_name))||($class_name == 'favorites')){
					$menu_items[] = array(
						GuiMenuItemDef::caption => 'Логин на myshows.me',
						GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'myshows_login'),
						GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_myshows')
					);
					if (preg_match("|userFav_|",$class_name)){
						$menu_items[] = array(
							GuiMenuItemDef::caption => 'Удалить Избранное',
							GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', array('action' => 'addUserFav', 'delUserFav' => true)),
							GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_delete')
						);
					}
				}
				if (isset($categories[$class_name]['smallIcon'])){
					$menu_items[] = array(
						GuiMenuItemDef::caption => 'Настройки ' . $categories[$class_name]['name'],
						GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classSetup' . $class_name),
						GuiMenuItemDef::icon_url => $categories[$class_name]['smallIcon']
					);
					unset ($categories[$class_name]);
				
					$menu_items [] =  array(
							GuiMenuItemDef::is_separator => true,);
					foreach ($categories as $class_name => $vel){
						if (isset($categories[$class_name]['smallIcon']))
							$menu_items[] = array(
								GuiMenuItemDef::caption => 'Настройки ' . $vel['name'],
								GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classSetup' . $class_name),
								GuiMenuItemDef::icon_url => $categories[$class_name]['smallIcon']
							);
					}
				}
				if ($parentalControl != ''){
					$menu_items [] =  array(
						GuiMenuItemDef::is_separator => true,);
					$lockCat = HD::getItemsArr('lockCat');
					if (isset($lockCat[$user_input->selected_media_url])){
						$caption = 'Открыть категорию';
						$params['unlock_id'] = 1;
						$icon_url = SmartConfig::getPluginIco('s_unlock');
					}else{
						$caption = 'Закрыть категорию';
						$params['lock_id'] = 1;
						$icon_url = SmartConfig::getPluginIco('s_lock');
					}
					$menu_items[] = array(
						GuiMenuItemDef::caption => $caption,
						GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'parentalControlactions', $params),
						GuiMenuItemDef::icon_url => $icon_url
					);
				}
			}
			$menu_items [] =  array(
					GuiMenuItemDef::is_separator => true,);
			if (isset($user_input->selected_media_url)){
				$menu_items [] =  array(
					GuiMenuItemDef::is_separator => true,);
				$add_params['action_move'] = 'on';
				$menu_items[] = array(
					GuiMenuItemDef::caption => 'Настройка вида меню',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'id_move', $add_params),
					GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_move')
				);
				if (!isset($selected_media_url->movie_id)){
					$menu_items [] =  array(
						GuiMenuItemDef::is_separator => true,);
					$add_params['action'] = 'add';
					$menu_items[] = array(
						GuiMenuItemDef::caption => 'Задать иконку',
						GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'icon_actions', $add_params),
						GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_add_icon')
					);
					$class_name = $selected_media_url->class_name;
					if (isset($selected_media_url->iconId))
						$class_name = $selected_media_url->iconId;
					if (file_exists(HD::get_data_path() . "/icons/$class_name.png")){
						$add_params['action'] = 'del';
						$menu_items[] = array(
							GuiMenuItemDef::caption => 'Удалить иконку',
							GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'icon_actions', $add_params),
							GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_del_background')
						);
					}
				}
			}
			$menu_items [] =  array(
				GuiMenuItemDef::is_separator => true,);
			$add_params['action'] = 'background_actions';
			$menu_items[] = array(
				GuiMenuItemDef::caption => 'Задать бекграунд',
				GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', $add_params),
				GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_add_background')
			);
			if (file_exists(HD::get_data_path() . "/icons/" . self::ID . "_bg.jpg")){
				$add_params['action'] = 'background_actions';
				$add_params['del'] = true;
				$menu_items[] = array(
					GuiMenuItemDef::caption => 'Удалить бекграунд',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', $add_params),
					GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_del_background')
				);
			}
			$menu_items [] =  array(
				GuiMenuItemDef::is_separator => true,);
			// $add_params['action'] = 'add';
			$menu_items[] = array(
				GuiMenuItemDef::caption => 'Назначить цифровую кнопку',
				GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'add_num'),
				GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_num')
			);
			return ActionFactory::show_popup_menu($menu_items);
		}

		if ($user_input->control_id == 'myshows_login'){
			hd_silence_warnings();
			return myShows_Class::login($user_input);
		}

		if ($user_input->control_id == 'add_num'){
			if (!isset($user_input->selected_media_url))
				return null;
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			$useNumKey = HD::getItemsArr('useNumKey');
			if (isset($user_input->key)){
				if (isset($useNumKey[$user_input->key]))
					unset($useNumKey[$user_input->key]);
				else
					$useNumKey[$user_input->key] = $user_input->selected_media_url;
				HD::saveItemsArr('useNumKey', $useNumKey);
				$action = UserInputHandlerRegistry::create_action($this, 'add_num');
				$post_action = ActionFactory::close_and_run($action);
				$parent_media_url = MediaURL::decode($user_input->parent_media_url);
				$actions = $this->get_action_map($parent_media_url, $plugin_cookies);
				$post_action = ActionFactory::change_behaviour($actions, 0, $post_action);
				return ActionFactory::invalidate_folders(array($user_input->parent_media_url), $post_action);
			}
			$width = 900;
			foreach (SmartConfig::$keyArr as $k => $v){
				$add_params['key'] = $k;
				$actions[$v] = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
			}
			ControlFactory::add_multiline_label($defs, '', 'Нажмите цифровую кнопку пульта 0-9 для того что бы привязать к ней категорию "' . $selected_media_url->caption . '"', 5);
			foreach ($useNumKey as $k => $v){
				$media_url = MediaURL::decode($v);
				$add_params['key'] = $k;
				ControlFactory::add_button(&$defs, $this, $add_params, $user_input->control_id, '', 'Удалить ' . $k, 300);
				ControlFactory::add_smart_label($defs, "", '<gap width="320"/><text dy="-69" color="15" size="normal">'.$media_url->caption.'</text>');
				ControlFactory::add_vgap($defs, -60);
			}
			$attrs['actions'] = $actions;
			return ActionFactory::show_dialog($selected_media_url->caption, $defs, true, $width, $attrs);
		}

		if ($user_input->control_id == 'icon_actions'){
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			$class_name = $selected_media_url->class_name;
			if (isset($selected_media_url->iconId))
				$class_name = $selected_media_url->iconId;
			if ($user_input->action == 'del'){
				if (!unlink(HD::get_data_path() . "/icons/$class_name.png"))
					return ActionFactory::show_title_dialog('Удаление не удалось!', null, HD::get_data_path() . "/icons/$class_name.png");
				$this->fetch_vod_categories();
				return ActionFactory::invalidate_folders(array($user_input->parent_media_url));
			}
			if ($user_input->action == 'add'){
				$this->category_list = null;
				$media_url = MediaURL::encode (
					array(
						'screen_id'     => 'file_list',
						'save_file'		=> array(	
							'parent' => $user_input->parent_media_url,
							'action' => 'plugin_ico',
							'arg' => $class_name,
							'extension' => 'png'
						),
					)
				);
				return ActionFactory::open_folder($media_url,'Задать бекграунд');
			}
		}
		
		if ($user_input->control_id == 'id_move'){
			if (!isset($user_input->selected_media_url))
				return null;
			$view_idx = isset($plugin_cookies->{"screen.".self::ID.".view_idx"}) ? $plugin_cookies->{"screen.".self::ID.".view_idx"} : 0;
			
			$add_params['action_move'] = 'up';
			$add_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
			$add_action['caption'] = 'Вверх';
			$actions[GUI_EVENT_KEY_B_GREEN] = $add_action;
			if ($view_idx == 2)
				$actions[GUI_EVENT_KEY_LEFT] = $add_action;
			
			$add_params['action_move'] = 'down';
			$add_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
			$add_action['caption'] = 'Вниз';
			$actions[GUI_EVENT_KEY_C_YELLOW] = $add_action;
			if ($view_idx == 2)
				$actions[GUI_EVENT_KEY_RIGHT] = $add_action;
			
			$add_params['action_move'] = 'up_id';
			$add_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
			$add_action['caption'] = 'Поднять вверх';
			$actions[GUI_EVENT_KEY_D_BLUE] = $add_action;
			
			$add_params['action_move'] = 'hide_id';
			$add_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
			$actions[GUI_EVENT_KEY_CLEAR] = $add_action;
			
			$add_params['action_move'] = 'upPopUpMenu';
			$add_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
			$actions[GUI_EVENT_KEY_POPUP_MENU] = $add_action;
			
			$add_params['action_move'] = 'off';
			$add_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
			$actions[GUI_EVENT_KEY_RETURN] = $add_action;
			$actions[GUI_EVENT_KEY_ENTER] = $add_action;
			if ($user_input->action_move == 'upPopUpMenu'){
				$add_params['action_move'] = 'up_id';
				$menu_items[] = array(
					GuiMenuItemDef::caption => 'Поднять вверх',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params),
					GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_queue_move_top')
				);
				$add_params['action_move'] = 'hide_id';
				$menu_items[] = array(
					GuiMenuItemDef::caption => 'Cкрыть/Bостановить Категорию',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params),
					GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_list')
				);
				$add_params['action_move'] = 'clear';
				$menu_items[] = array(
					GuiMenuItemDef::caption => 'Cброс Категорий',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params),
					GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_num')
				);
				return ActionFactory::show_popup_menu($menu_items);
			}
			if ($user_input->action_move == 'up_id'){
				$nbrCat = HD::getItemsArr('nbrCat');
				$fCat = array_flip($nbrCat);
				if (isset($nbrCat[$user_input->selected_media_url])){
					$k = $nbrCat[$user_input->selected_media_url];
					if ($k != 0){
						$up = $fCat[$k];
						unset ($fCat[$k]);
						array_unshift($fCat,$up);
						ksort ($fCat);
						$fCat = array_values ($fCat);
						$fCat = array_flip($fCat);
						HD::saveItemsArr('nbrCat', $fCat);
						$this->fetch_vod_categories();
						$post_action = ActionFactory::change_behaviour($actions, 0);
						return ActionFactory::invalidate_folders(array($user_input->parent_media_url), $post_action);
					}else
						return ActionFactory::show_title_dialog("Err!", null, 'Каталог в начале списка!');
				}else{
					echo $user_input->selected_media_url;
					foreach ($nbrCat as $k => $v)
						echo "$k => $v";
					return ActionFactory::show_title_dialog("Err!", null, 'Подробности в лог файле!');
				}
			}
			if (($user_input->action_move == 'down')||
				($user_input->action_move == 'up')){

				$nbrCat = HD::getItemsArr('nbrCat');
				$fCat = array_flip($nbrCat);
				if (isset($nbrCat[$user_input->selected_media_url])){
					$k = $nbrCat[$user_input->selected_media_url];
					if ($user_input->action_move == 'up'){
						if ($k == 0){
							$fCat[] = $fCat[$k];
							unset($fCat[0]);
							
						}else{
							$t = $fCat[$k - 1];
							$fCat[$k - 1] = $fCat[$k];
							$fCat[$k] = $t;
						}
					}
					if ($user_input->action_move == 'down'){
						if ($k == count($fCat) - 1){
							$fCat[-1] = $fCat[$k];
							unset($fCat[$k]);
						}else{
							$t = $fCat[$k + 1];
							$fCat[$k + 1] = $fCat[$k];
							$fCat[$k] = $t;
						}
					}
					ksort ($fCat);
					$fCat = array_values ($fCat);
					$fCat = array_flip($fCat);
					HD::saveItemsArr('nbrCat', $fCat);
					$this->fetch_vod_categories();
					$post_action = ActionFactory::change_behaviour($actions, 0);
					return ActionFactory::invalidate_folders(array($user_input->parent_media_url), $post_action);
					  
				}else{
					echo $user_input->selected_media_url;
					foreach ($nbrCat as $k => $v)
						echo "$k => $v";
					return ActionFactory::show_title_dialog("Err!", null, 'Подробности в лог файле!');
				}
			}
			if ($user_input->action_move == 'clear'){
				if($this->unlock == false){
					if ($parentalControl != ''){
						$add_params['controlId']= $user_input->control_id;
						$add_params['param'] = 'action_move';
						$add_params['vel'] = 'clear';
						ControlFactory::add_text_field(
							$defs, $this, $add_params,
							'hide_pin_control', '',
							'', 1, 1, 0, 1, 500, 1 , 0
						);
						return  ActionFactory::show_dialog('Введите код:', $defs, true);
					}
				}
				HD::saveItemsArr('nbrCat', array());
				HD::saveItemsArr('hideCat', array());
				HD::saveItemsArr('lockCat', array());
				$this->fetch_vod_categories();
				$post_action = ActionFactory::change_behaviour($actions, 0);
				return ActionFactory::invalidate_folders(array($user_input->parent_media_url), $post_action);
			}
			if ($user_input->action_move == 'hide_id'){
				$hideCat = HD::getItemsArr('hideCat');
				if (isset($hideCat[$user_input->selected_media_url])){
					if($this->unlock == false){
						if ($parentalControl != ''){
							$add_params['controlId']= $user_input->control_id;
							$add_params['param'] = 'action_move';
							$add_params['vel'] = 'hide_id';
							ControlFactory::add_text_field(
								$defs, $this, $add_params,
								'hide_pin_control', '',
								'', 1, 1, 0, 1, 500, 1 , 0
							);
							return  ActionFactory::show_dialog('Введите код:', $defs, true);
						}
					}
					unset($hideCat[$user_input->selected_media_url]);
				}else
					$hideCat[$user_input->selected_media_url] = 1;
				HD::saveItemsArr('hideCat', $hideCat);
				$post_action = ActionFactory::change_behaviour($actions, 0);
				return  ActionFactory::invalidate_folders(array($user_input->parent_media_url), $post_action);
			}
			if ($user_input->action_move == 'on'){
				$this->allSources = true;
				$this->unlock = false;
				ControlFactory::add_smart_label($defs, 
					"", 
					'<icon width="48" height="48">gui_skin://special_icons/controls_button_green.aai</icon><text color="15"> - двигать вверх</text>'
				);
				ControlFactory::add_vgap($defs, -20);
				ControlFactory::add_smart_label($defs, 
					"", 
					'<icon width="48" height="48">gui_skin://special_icons/controls_button_yellow.aai</icon><text color="15"> - двигать вниз</text>'
				);
				ControlFactory::add_vgap($defs, -20);
				ControlFactory::add_smart_label($defs, 
					"", 
					'<icon width="48" height="48">gui_skin://special_icons/controls_button_blue.aai</icon><text color="15"> - поднять вверх</text>'
				);
				ControlFactory::add_vgap($defs, -20);
				ControlFactory::add_smart_label($defs, 
					"", 
					'<icon width="131" height="53">gui_skin://special_icons/controls_button_clear.aai</icon><text color="15"> - скрыть/востановить</text>'
				);
				ControlFactory::add_vgap($defs, -20);
				ControlFactory::add_smart_label($defs, 
					"", 
					'<icon width="145" height="50">gui_skin://special_icons/controls_button_pop_up.aai</icon><text color="15"> - действия</text>'
				);
				ControlFactory::add_vgap($defs, -20);
				ControlFactory::add_smart_label($defs, 
					"", 
					'<icon width="131" height="53">gui_skin://special_icons/controls_button_enter.aai</icon><text color="15"> - выйти и применить</text>'
				);
				ControlFactory::add_vgap($defs, -20);
				ControlFactory::add_smart_label($defs, 
					"", 
					'<text color="15">RETURN - выйти и применить</text>'
				);
				ControlFactory::add_close_dialog_button($defs, 'ОК', 300);
				$post_action = ActionFactory::show_dialog("Help", $defs, true, 600);
				$post_action = ActionFactory::change_behaviour($actions, 0, $post_action);
				return  ActionFactory::invalidate_folders(array($user_input->parent_media_url), $post_action);
			}
			if ($user_input->action_move == 'off'){
				$this->allSources = false;
				$parent_media_url = MediaURL::decode($user_input->parent_media_url);
				$actions = $this->get_action_map($parent_media_url, $plugin_cookies);
				$post_action = ActionFactory::change_behaviour($actions, 0);
				return  ActionFactory::invalidate_folders(array($user_input->parent_media_url), $post_action);
			}
		}
		if ($user_input->control_id == 'hide_pin_control'){
			if (md5($user_input->hide_pin_control) == $plugin_cookies->parentalControl){
				$this->unlock = $params['unlock'] = true;
				if (isset($user_input->param))
					$params[$user_input->param] = $user_input->vel;
				$a = UserInputHandlerRegistry::create_action($this, $user_input->controlId, $params);
				return ActionFactory::close_dialog_and_run($a);
			}else
				return  ActionFactory::show_title_dialog('Код не верный!');
		}
		if ($user_input->control_id == 'whats_new'){
			$post_action = null;
			$doc = HD::http_get_document('http://dune-club.info/plugins/update/'.DuneSystem::$properties['plugin_name'].'/info.txt');
			ControlFactory::add_vgap($defs, -20);
			ControlFactory::add_img_label($defs, '', '<icon width="48" height="48">gui_skin://special_icons/controls_button_yellow.aai</icon><text dy="7" size="small"> - во время просмотра Sleep timer</text>', 0, 0, 0);
			ControlFactory::add_vgap($defs, -25);
			ControlFactory::add_img_label($defs, '', '<icon width="48" height="48">gui_skin://special_icons/controls_button_blue.aai</icon><text dy="7" size="small"> - во время просмотра Меню</text>', 0, 0, 0);
			ControlFactory::add_vgap($defs, -25);
			ControlFactory::add_img_label($defs, '', '<icon width="48" height="48">gui_skin://special_icons/controls_button_green.aai</icon><text dy="7" size="small"> - во время просмотра скорость закачки TorrServer и Peerflix</text>', 0, 0, 0);
			ControlFactory::add_multiline_label($defs, '', trim(strip_tags($doc)), 10);
			return ActionFactory::show_dialog('Информация об изменениях.', $defs, true, 1100);
		}
	}
    ///////////////////////////////////////////////////////////////////////

    public function get_all_folder_items(MediaURL $media_url, &$plugin_cookies){
        if ((is_null($this->category_list))||(self::$invalMainMenu == true)){
			self::$invalMainMenu = false;
            $this->fetch_vod_categories();
		}
        $category_list = $this->category_list;
        $items = array();
		$hideCat = HD::getItemsArr('hideCat');
		$lockCat = HD::getItemsArr('lockCat');		
        foreach ($category_list as $k => $c){
			$view_item_params = array(); $color = 15;
			$mUrl = $c->get_mUrl();
			$Item = MediaURL::decode($mUrl);
			if (isset($lockCat[$mUrl])){
				if (defined('ViewItemParams::item_sticker') === true)
					$view_item_params[ViewItemParams::item_sticker] = json_encode(HD::get_sticker(SmartConfig::getPluginIco('s_lock'), false, array('img_x' => -3, 'img_y' => 3)));
				
				if (defined('ViewItemParams::item_detailed_info_sticker') === true)
					$view_item_params[ViewItemParams::item_detailed_info_sticker] = $s_lock;
			}
			if (isset($hideCat[$mUrl])){
				if ((isset($this->allSources))&&($this->allSources == true)){
					$color = 17;
					$view_idx = isset($plugin_cookies->{"screen.".self::ID.".view_idx"}) ? $plugin_cookies->{"screen.".self::ID.".view_idx"} : 0;
					if ((defined('ViewItemParams::item_sticker') === true)&&($view_idx != 2)){
						$view_item_params[ViewItemParams::icon_sel_scale_factor] = 1.0;
						$view_item_params[ViewItemParams::item_sticker] = json_encode(HD::get_sticker(SmartConfig::getPluginIco('hide'), false, array('img_x' => 0, 'img_y' => 0)));
					}
				}else
					continue;
			}
			
			$view_item_params[ViewItemParams::item_caption_color] = $color;
			$view_item_params[ViewItemParams::icon_path] = $c->get_icon_path();
			$view_item_params[ViewItemParams::item_detailed_icon_path] = $c->get_icon_path();
			$view_item_params[ViewItemParams::item_detailed_info] = $c->get_description();
			if ($c->get_badge() == true){
				$view_item_params[ViewItemParams::item_badge_icon_path] = $c->get_badge();
				if ((defined('ViewItemParams::item_detailed_icon_width') === true)&&(!isset($Item->shape))){
					$view_item_params[ViewItemParams::item_detailed_icon_width] = 138;
					$view_item_params[ViewItemParams::item_detailed_icon_height] = 200;
				}
			}
						
            $items[$k] = array(
                PluginRegularFolderItem::media_url => $mUrl,
                PluginRegularFolderItem::caption => $c->get_caption(),
                PluginRegularFolderItem::view_item_params => $view_item_params
            );
        }
		ksort($items);
		$items = array_values ($items);
        return $items;
    }

    ///////////////////////////////////////////////////////////////////////
	public function get_categories(){
		$categories['search']['name'] = 'Поиск';
		$categories['search']['descr'] = '||Поиск|поиск по разным каталогам';
		
		$categories['favorites']['name'] = 'Избранное';
		$categories['favorites']['descr'] = '||Избранное|общее избранное';
		
		$categories['itemsHistory']['name'] = 'История';
		$categories['itemsHistory']['descr'] = '||История просмотра|может содержать не более 310 ранее просмотренных видео';

		$categories['TorrServer']['name'] = 'TorrServer';
		$categories['TorrServer']['descr'] = '||TorrServer|программа для просмотра торрент онлайн, кэш хранится в оперативной памяти';
		$categories['TorrServer']['smallIcon'] = SmartConfig::getPluginIco('s_torrserver');
		
		$categories['PeerflixServer']['name'] = 'PeerflixServer';
		$categories['PeerflixServer']['descr'] = '||PeerflixServer|программа для просмотра торрент онлайн, кэш хранится в на локальном диске';
		$categories['PeerflixServer']['smallIcon'] = SmartConfig::getPluginIco('s_peerflixserver');
		
		$categories['Transmission']['name'] = 'Transmission';
		$categories['Transmission']['descr'] = '||Transmission|управление закачками Transmission';
		$categories['Transmission']['smallIcon'] = SmartConfig::getPluginIco('s_transmission');
		
		$categories['TransmissionUPnP']['name'] = 'Transmission BTC';
		$categories['TransmissionUPnP']['descr'] = '||Transmission BTC UPnP|торренты онлайн через андроидное приложение Transmission BTC, для работы включите в настройках Transmission BTC UPnP Content Directory и последовательную загрузку';
		$categories['TransmissionUPnP']['smallIcon'] = SmartConfig::getPluginIco('s_transmissionupnp');
		
		$userFavList = HD::getItemsArr('userFavList');
		if (count($userFavList) > 0){
			foreach ($userFavList as $k => $v){
				$categories[$k]['name'] = $v;
				$categories[$k]['descr'] = "||$v|пользовательское Избранное";
			}
		}
		foreach (SmartConfig::getWox() as $class_name){
			$infArr = $class_name::getMainMenuInfo();
			if ($infArr == true){
				if (isset($infArr['name'])){
					$categories[$class_name]['name'] = $infArr['name'];
					$categories[$class_name]['descr'] = $infArr['descr'];
				}else{
					foreach ($infArr as $v){
						$categories[$v['mUrl']]['name'] = $v['name'];
						$categories[$v['mUrl']]['descr'] = $v['descr'];
						$categories[$v['mUrl']]['ico'] = $v['ico'];
					}
				}
			}
		}
		$mainMenuItems = HD::getItemsArr('mainMenuItems');
		if (count($mainMenuItems) > 0){
			foreach ($mainMenuItems as $k => $v){
				$media_url = MediaURL::decode($k);
				$class_name = $media_url->class_name;
				if (count($media_url->hCaptions) > 1)
					$iStr = implode ('|', $media_url->hCaptions);
				else
					$iStr = $media_url->hCaptions[0];
				$categories[$k]['name'] = $v;
				$categories[$k]['descr'] = "||$v|" . $iStr;
				if (isset($media_url->poster_url)){
					$categories[$k]['ico'] = $media_url->poster_url;
					if ((isset($media_url->shape))&&($media_url->shape == 'rectangle'))
						$categories[$k]['badge'] = SmartConfig::getPluginIco('mmFilmBadge2');
					else
						$categories[$k]['badge'] = SmartConfig::getPluginIco('mmFilmBadge');
					$categories[$k]['descr'] = "||$v";
					if (isset($media_url->caption_original))
						$categories[$k]['descr'] .= "|" . $media_url->caption_original;
					if (isset($media_url->year))
						$categories[$k]['descr'] .= "|" . $media_url->year;
					$categories[$k]['descr'] .= "|" . $iStr;
					if (isset($media_url->detailed_info))
						$categories[$k]['descr'] = $media_url->detailed_info;
				}
				else
					$categories[$k]['ico'] = SmartConfig::getPluginIco($class_name);
			}
		}
		return $categories;
	}
    private function fetch_vod_categories(){
		$categories = $this->get_categories();
        $this->category_list = array();
        $this->fill_categories($categories, $this->category_list);
    }
	public static function invalMainMenu(){
		self::$invalMainMenu = true;
	}
    ///////////////////////////////////////////////////////////////////////

    private function fill_categories($categories, &$obj_arr){
		$nbrCat = HD::getItemsArr('nbrCat');
		$fCat = array();
        foreach ($categories as $k => $v){
			if ($k == 'TorrServer')
				$mUrl = VodTorrServerScreen::get_media_url_str($k, array('caption' => $v['name']));
			else if ($k == 'PeerflixServer')
				$mUrl = VodPeerflixServerScreen::get_media_url_str($k, array('caption' => $v['name']));
			else if ($k == 'Transmission')
				$mUrl = VodTransmissionScreen::get_media_url_str($k, array('caption' => $v['name']));
			else if ($k == 'TransmissionUPnP')
				$mUrl = VodTransmissionUPnPScreen::get_media_url_str($k, array('caption' => $v['name']));
			else if ($k == 'Transmission')
				$mUrl = VodTransmissionScreen::get_media_url_str($k, array('caption' => $v['name']));
			else if ($k == 'search')
				$mUrl = SmartSearchScreen::get_media_url_str($k, array('caption' => $v['name']));
			else if (($k == 'favorites')||(preg_match("|userFav_|",$k)))
				$mUrl = VodFavoritesScreen::get_media_url_str($k, array('caption' => $v['name']));
			else if ($k == 'itemsHistory')
				$mUrl = VodHistoryScreen::get_media_url_str($k, array('caption' => $v['name']));
			else if (isset($v['ico']))
				$mUrl = $k;
			else if (preg_match("|_Class$|",$k))
				$mUrl = $k::get_media_url_str($k, array('caption' => $v['name']));
			else
				$mUrl = SmartVodListScreen::get_media_url_str($k, array('caption' => $v['name']));
			
			if (isset($v['ico']))
				$ico = $v['ico'];
			else
				$ico = SmartConfig::getPluginIco($k);
			
			if (isset($nbrCat[$mUrl]))
				$n = $nbrCat[$mUrl];
			else
				$n = count ($fCat) - 1000;
			$fCat[$mUrl] = $n;
			$cat = new SmartVodCategory(
				strval($k),
				strval($mUrl),
				strval($v['name']),
				strval($ico),
				strval($v['descr'])
			);
			unset($ico);
			if (isset($v['badge']))
				$cat->badge = $v['badge'];
			$obj_arr[$n] = $cat;
        }
		$diff1 = array_diff_key($fCat,$nbrCat);
		$diff2 = array_diff_key($nbrCat,$fCat);

		if ((!empty($diff1))||(!empty($diff2))){
			$fCat = array_flip($fCat);
			ksort($fCat);
			$fCat = array_values ($fCat);
			$fCat = array_flip($fCat);
			HD::saveItemsArr('nbrCat', $fCat);
		}
		ksort($obj_arr);
		$obj_arr = array_values ($obj_arr);
    }

    ///////////////////////////////////////////////////////////////////////

	private function get_folder_views(){
		$sandwich_cover = SmartConfig::getPluginIco('sandwich_cover');
		$sandwich_base = SmartConfig::getPluginIco('sandwich_base');
		$background_path = SmartConfig::getPluginIco(self::ID . '_bg');
		$paintBackground = (HD::getItemsArr('paintBackground') != array()) ? HD::getItemsArr('paintBackground') : array('paint_widget_background' => true, 'paint_content_box_background' => true, 'paint_path_box_background' => true, 'paint_details_box_background' => true);
		$extra_content_objects = 'label{x=1350}{y=805}{text=ver. '.HD::plugin_version().'}{color=15}';
		$paintSandwich = (HD::getItemStr('paintSandwich') != '') ? (bool)HD::getItemStr('paintSandwich') : true;
//==>
		$arr[0][PluginRegularFolderView::async_icon_loading] = true;

		$arr[0][PluginRegularFolderView::view_params][ViewParams::num_cols] =4;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::num_rows] = 3;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_details] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_sandwich] = $paintSandwich;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::sandwich_base] = $sandwich_base;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::sandwich_mask] = 'cut_icon://{name=sandwich_mask}';
		$arr[0][PluginRegularFolderView::view_params][ViewParams::sandwich_cover] = $sandwich_cover;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::sandwich_width] = 160;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::sandwich_height] = 160;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::sandwich_icon_upscale_enabled] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::sandwich_icon_keep_aspect_ratio] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_path] = $background_path;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_order] = 0;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_height] = 1080;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_width] = 1920;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::optimize_full_screen_background] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_item_info_in_details] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_auto_line_break] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_title_color] = 10;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_text_color] = 15;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::extra_content_objects] = $extra_content_objects;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_font_size] = (HD::getItemStr('detailedInfoFontSize') != '') ? HD::getItemStr('detailedInfoFontSize') : FONT_SIZE_SMALL;
		if (defined('ViewParams::paint_icon_badge_box') === true){
			$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_icon_badge_box] = true;
			$arr[0][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_height] = 160;
			$arr[0][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_width] = 160;
			$arr[0][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_dx] = -80;
            $arr[0][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_dy] = -103;
			$arr[0][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_sel_height] = 165;
			$arr[0][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_sel_width] = 165;
		}
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_widget_background] = $paintBackground['paint_widget_background'];
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_content_box_background] = $paintBackground['paint_content_box_background'];
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_path_box_background] = $paintBackground['paint_path_box_background'];
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_details_box_background] = $paintBackground['paint_details_box_background'];
		
		
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_layout] = HALIGN_CENTER;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_valign] = VALIGN_CENTER;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_caption] = true;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_scale_factor] = 1.0;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_scale_factor] = 1.1;
		if (defined('ViewItemParams::item_override_default_badge') === true)
			$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_override_default_badge] = true;
		$arr[0][PluginRegularFolderView::not_loaded_view_item_params] = array ();
//==>
//==>
		$arr[1][PluginRegularFolderView::async_icon_loading] = true;

		$arr[1][PluginRegularFolderView::view_params][ViewParams::num_cols] = 6;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::num_rows] = 4;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_details] = true;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_sandwich] = $paintSandwich;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_base] = $sandwich_base;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_mask] = 'cut_icon://{name=sandwich_mask}';
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_cover] = $sandwich_cover;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_width] = 160;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_height] = 160;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_icon_upscale_enabled] = true;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_icon_keep_aspect_ratio] = true;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_path] = $background_path;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_order] = 0;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_height] = 1080;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_width] = 1920;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::optimize_full_screen_background] = true;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_item_info_in_details] = true;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_auto_line_break] = true;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_title_color] = 10;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_text_color] = 15;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::extra_content_objects] = $extra_content_objects;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_font_size] = (HD::getItemStr('detailedInfoFontSize') != '') ? HD::getItemStr('detailedInfoFontSize') : FONT_SIZE_SMALL;
		if (defined('ViewParams::paint_icon_badge_box') === true){
			$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_icon_badge_box] = true;
			$arr[1][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_height] = 160;
			$arr[1][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_width] = 160;
			$arr[1][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_dx] = -80;
            $arr[1][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_dy] = -80;
			$arr[1][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_sel_height] = 165;
			$arr[1][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_sel_width] = 165;
		}
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_widget_background] = $paintBackground['paint_widget_background'];
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_content_box_background] = $paintBackground['paint_content_box_background'];
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_path_box_background] = $paintBackground['paint_path_box_background'];
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_details_box_background] = $paintBackground['paint_details_box_background'];
		
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_layout] = HALIGN_CENTER;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_valign] = VALIGN_CENTER;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_caption] = false;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_scale_factor] = 1.0;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_scale_factor] = 1.1;
		if (defined('ViewItemParams::item_override_default_badge') === true)
			$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_override_default_badge] = true;
		$arr[1][PluginRegularFolderView::not_loaded_view_item_params] = array ();
//==>
//==>
		$arr[2][PluginRegularFolderView::async_icon_loading] = true;

		$arr[2][PluginRegularFolderView::view_params][ViewParams::num_cols] = 1;              
		$arr[2][PluginRegularFolderView::view_params][ViewParams::num_rows] = 10;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_details] = true;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_item_info_in_details] = true;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_auto_line_break] = true;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_title_color] = 10;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_text_color] = 15;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::background_path] = $background_path;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::background_order] = 0;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::background_height] = 1080;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::background_width] = 1920;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_item_info_in_details] = true;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::extra_content_objects] = $extra_content_objects;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_font_size] = (HD::getItemStr('detailedInfoFontSize') != '') ? HD::getItemStr('detailedInfoFontSize') : FONT_SIZE_SMALL;
		if (defined('ViewParams::paint_icon_badge_box') === true){
			$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_icon_badge_box] = true;
			$arr[2][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_height] = 50;
			$arr[2][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_width] = 50;
			$arr[2][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_dx] = -590;
            $arr[2][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_dy] = -25;
			$arr[2][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_sel_height] = 55;
			$arr[2][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_sel_width] = 55;
		}
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_widget_background] = $paintBackground['paint_widget_background'];
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_content_box_background] = $paintBackground['paint_content_box_background'];
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_path_box_background] = $paintBackground['paint_path_box_background'];
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_details_box_background] = $paintBackground['paint_details_box_background'];
		
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_valign] = VALIGN_CENTER;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_keep_aspect_ratio] = true;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_height] = 50;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_caption_within_icon] = false;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_caption] = true;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_caption_width] = 1100;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_layout] = HALIGN_LEFT;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_dx] = 15;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_scale_factor] = 1.1;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_margin_left] = 5;
		// $arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_margin_bottom] = 5;
		// if (defined('ViewItemParams::item_override_default_badge') === true)
			// $arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_override_default_badge] = true;
		$arr[2][PluginRegularFolderView::not_loaded_view_item_params] = array ();
//==>
		return $arr;
	}
}
///////////////////////////////////////////////////////////////////////////
?>
