<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/default_dune_plugin.php';
require_once 'lib/utils.php';
require_once 'lib/sticker.php';
require_once 'lib/file_reader.php';
require_once 'lib/vod/vod_torrserver_screen.php';
require_once 'lib/vod/vod_peerflixserver_screen.php';
require_once 'lib/vod/vod_transmissionUPnP_screen.php';
require_once 'lib/vod/vod_transmission_screen.php';
require_once 'lib/wow/TorrServer.php';
require_once 'lib/wow/PeerflixServer.php';
require_once 'lib/wow/TransmissionRPC.class.php';
require_once 'lib/wow/TransmissionUPnP.php';
require_once 'lib/wow/Transmission.php';
require_once 'lib/wow/Trailers.php';
require_once 'lib/wow/Torrent.php';

// require_once 'lib/vod/vod_movie_screen.php';
require_once 'lib/vod/vod_series_list_screen.php';
require_once 'lib/vod/vod_season_list_screen.php';
require_once 'lib/vod/vod_favorites_screen.php';
require_once 'lib/vod/vod_history_screen.php';
require_once 'lib/vod/vod_random_screen.php';
require_once 'lib/vod/vod_source_list_screen.php';
require_once 'lib/vod/vod_list_screen.php';
require_once 'lib/vod/vod_rectangle_list_screen.php';
require_once 'lib/vod/vod_simple_list_screen.php';
require_once 'lib/vod/vod_torrents_screen.php';
require_once 'lib/vod/vod_tetragon_list_screen.php';
require_once 'adv_keyboards/adv_keyboard.php';
require_once 'Smart_config.php';
require_once 'Smart_vod.php';
require_once 'Smart_setup_screen.php';
require_once 'Smart_vod_category_list_screen.php';
require_once 'Smart_main_menu_screen.php';
require_once 'Smart_vod_list_screen.php';
require_once 'Smart_file_screen.php';
require_once 'Smart_search_screen.php';
require_once 'Smart_entry_handler.php';
foreach (SmartConfig::getWox() as $file)
	require_once "lib/wox/$file.php";
$movieViewed = (HD::getItemStr('movieViewed', true) !='') ? HD::getItemStr('movieViewed', true) : 0;
if ($movieViewed == 1)
	require_once 'lib/vod/movie_screen.php';
else
	require_once 'lib/vod/vod_movie_screen.php';
///////////////////////////////////////////////////////////////////////////

class SmartPlugin extends DefaultDunePlugin{
    public function __construct(){
        $port = HD::http_local_port();
        hd_print("EEE EEE HD_HTTP_LOCAL_PORT: $port");
        $this->vod = new SmartVod();
        $this->add_screen(new SmartSetupScreen());
		$this->add_screen(new SmartFileSystemScreen());
        $this->add_screen(new VodFavoritesScreen($this->vod));
		$this->add_screen(new VodHistoryScreen($this->vod));
		$this->add_screen(new VodTorrServerScreen($this->vod));
		$this->add_screen(new VodPeerflixServerScreen($this->vod));
		$this->add_screen(new VodtransmissionUPnPScreen($this->vod));
		$this->add_screen(new VodtransmissionScreen($this->vod));
        $this->add_screen(new SmartVodCategoryListScreen());
		$this->add_screen(new VodRandomScreen($this->vod));
		$this->add_screen(new SmartMainMenuScreen());
		$this->add_screen(new SmartSearchScreen($this->vod));
        $this->add_screen(new SmartVodListScreen($this->vod));
		$this->add_screen(new SmartVodRectangleListScreen($this->vod));
		$this->add_screen(new SmartVodSimpleListScreen($this->vod));
		$this->add_screen(new SmartVodTorrentsScreen($this->vod));
		$this->add_screen(new SmartVodTetragonListScreen($this->vod));
        $this->add_screen(new VodMovieScreen($this->vod));
        $this->add_screen(new VodSeriesListScreen($this->vod));
		$this->add_screen(new VodSeasonListScreen($this->vod));
		$this->add_screen(new VodSourceListScreen($this->vod));
		$this->entry_handler = new SmartEntryHandler();
    }
}

///////////////////////////////////////////////////////////////////////////
?>
