<?php
require_once 'lib/abstract_controls_screen.php';
class SmartSetupScreen extends AbstractControlsScreen{
	
    const ID = 'setup';
	private $spVer = 0;
	private $sPars = 0;
	public static function get_media_url_str(){
		$arr['screen_id'] = self::ID;
        return MediaURL::encode($arr);
    }
    public function __construct(){
        parent::__construct(self::ID);
    }

    public function do_get_control_defs(&$plugin_cookies){
        $defs = array();
		
		$link_api = '/tmp/plugins/link_api.php';
		if (file_exists('/persistfs/plugins_data'))
			$link_api = '/persistfs/plugins_data/link_api.php';
		if (file_exists("/system/dunehd/init") || getenv("FS_PREFIX"))
			$link_api = '/flashdata/plugins_data/link_api.php';
		$newVer = $oldVer = 0;
		if (file_exists($link_api)){
			if (preg_match('|##(.*?)##|', file_get_contents($link_api, null, null, 0, 50), $m))
				$oldVer = $m[1];
			$this->spVer = HD::http_get_document('http://dune-club.info/plugins/update/vlink_api.php');
		}
		if (trim($this->spVer) > trim($oldVer))
			$link_api = '/tmp/plugins/link_api.php';
		if (file_exists('/persistfs/plugins_data'))
			$link_api = '/persistfs/plugins_data/link_api.php';
		if (file_exists("/system/dunehd/init") || getenv("FS_PREFIX"))
			$link_api = '/flashdata/plugins_data/link_api.php';
		$newVer = $oldVer = 0;
		if (file_exists($link_api)){
			if (preg_match('|##(.*?)##|', file_get_contents($link_api, null, null, 0, 50), $m))
				$oldVer = $m[1];
			$this->spVer = HD::http_get_document('http://dune-club.info/plugins/update/vlink_api.php');
		}
		if (trim($this->spVer) > trim($oldVer))
			$this->add_button(
				$defs,'parser_update',
				"Новая версия парсеров: $this->spVer !!!",
				'Обновить', 0
			);
		else
			$this->add_button(
				$defs,'parser_del',
				"Текущая версия парсеров: $this->spVer",
				'Удалить', 0
			);
		ControlFactory::add_smart_label($defs, 
			"Папка DATA:", 
			'<text color="10" size="normal">'.HD::get_data_path().'</text>'
		);
		$gui_params['button_caption_centered'] = false;
		ControlFactory::add_button(&$defs, $this, null, 'data_dialog', '', 'Выгрузить/Загрузить/Очистить', 600, $gui_params);
		ControlFactory::add_button(&$defs, $this, null, 'pluginAppearance', 'Настройки Оформления плагина', 'Настройка', 600);
		ControlFactory::add_button(&$defs, $this, null, 'pluginDesignTheme', 'Тема Оформления плагина', 'Выгрузить/Загрузить', 600);
		ControlFactory::add_button(&$defs, $this, null, 'pin_dialog', 'PIN родительского контроля:', 'Изменить', 600);
		
		ControlFactory::add_button(&$defs, $this, null, 'aditionalSettings', 'Настройки видео:', 'Изменить', 600);
		$ini_array = parse_ini_file("/config/settings.properties");
		if ($ini_array['gui_skin'] == 'alt:Silver')
			ControlFactory::add_button(&$defs, $this, null, 'fixSkin', 'Silver Skin', 'Исправить цвета', 600);
		if (HD::is_android() == true){
			if (TorrServer::getTorrServerPackageName() == false){
				$add_params['installApp'] = 'TorrServer';
				ControlFactory::add_button(&$defs, $this, $add_params, 'install', 'TorrServer', 'Установить', 600);
			}
			if (TransmissionUPnP::getTransmissionBTCPackageName() == false){
				$add_params['installApp'] = 'transmissionBTC';
				ControlFactory::add_button(&$defs, $this, $add_params, 'install', 'Transmission BTC', 'Установить', 600);
			}
			if (!file_exists('/data/data/com.example.dunevoice')){
				$add_params['installApp'] = 'DuneVoice';
				ControlFactory::add_button(&$defs, $this, $add_params, 'install', 'DuneVoice', 'Установить', 600);
			}
		}
		return $defs;
    }

    public function get_control_defs(MediaURL $media_url, &$plugin_cookies){
        return $this->do_get_control_defs($plugin_cookies);
    }

    public function handle_user_input(&$user_input, &$plugin_cookies){
		if ($user_input->control_id == 'install'){
			if (isset($user_input->activity)){
				exec ("am start " . $user_input->name . "/" . $user_input->activity . " 2>&1");
				return null;
			}
			if ($user_input->installApp == 'DuneVoice'){
				$post_action = ActionFactory::reset_controls($this->do_get_control_defs($plugin_cookies));
				$post_action = ActionFactory::sleep_action(2000, $post_action);
				return ActionFactory::download_and_install_apk('DuneVoice', 'com.example.dunevoice', array('http://dune-club.info/plugins/update/_other/DuneVoice.apk'), false, $post_action);
			}
			if ($user_input->installApp == 'TorrServer'){
				if (isset($user_input->openTorrServerApp)){
					sleep (2);
					$package = TorrServer::getTorrServerPackageName();
					if ($package != false){
						$post_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $package);
						return ActionFactory::reset_controls($this->do_get_control_defs($plugin_cookies), $post_action);
					}else
						return ActionFactory::show_title_dialog( 'Андроид приложение TorrServer не найдено');
				}
				$add_params['installApp'] = 'TorrServer';
				$add_params['openTorrServerApp'] = true;
				$post_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
				$jsd = json_decode(HD::http_get_document('https://api.github.com/repos/YouROK/TorrServe/releases/latest'));
				if (isset($jsd->assets[0]->browser_download_url))
					return ActionFactory::download_and_install_apk('TorrServe MatriX', 'ru.yourok.torrserve', array($jsd->assets[0]->browser_download_url), false, $post_action);
				else
					return ActionFactory::show_title_dialog('Установка не удалась!');
			}
			if ($user_input->installApp == 'transmissionBTC'){
				if (isset($user_input->openTransmissionBTCApp)){
					sleep (2);
					$package = TransmissionUPnP::getTransmissionBTCPackageName();
					if ($package != false){
						$post_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $package);
						return ActionFactory::reset_controls($this->do_get_control_defs($plugin_cookies), $post_action);
					}else
						return ActionFactory::show_title_dialog( 'Андроид приложение TransmissionBTC не найдено');
				}
				$add_params['installApp'] = 'transmissionBTC';
				$add_params['openTransmissionBTCApp'] = true;
				$post_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
				$jsd = json_decode(HD::http_get_document('https://api.github.com/repos/AndreyPavlenko/transmissionbtc/releases/latest'));
				$download_url = false;
				if (isset($jsd->assets)){
					foreach ($jsd->assets as $v){
						if (preg_match('|armeabi|', $v->browser_download_url)){
							$download_url = $v->browser_download_url;
							break;
						}
					}
				}
				if ($download_url == true)
					return ActionFactory::download_and_install_apk('Transmission BTC', 'com.ap.transmission.btc', array($download_url), false, $post_action);
				else
					return ActionFactory::show_title_dialog('Установка не удалась!');
			}	
		}
		if ($user_input->control_id == 'aditionalSettings'){
			if ($user_input->action_type == 'confirm'){
				$params['initial_sel_ndx'] = $user_input->initial_sel_ndx;
				if (HD::saveItemStr('filmix_quality', $user_input->filmix_quality, true) == false)
					return ActionFactory::show_title_dialog("Сохранение не удалось");
				if (HD::saveItemStr('video_quality', $user_input->video_quality, true) == false)
					return ActionFactory::show_title_dialog("Сохранение не удалось");
				if (HD::is_android() == true)
					if (HD::saveItemStr('android_action', $user_input->android_action, true) == false)
						return ActionFactory::show_title_dialog("Сохранение не удалось");
				if (HD::saveItemStr('downViewed', $user_input->downViewed) == false)
					return ActionFactory::show_title_dialog("Сохранение не удалось");
				if (HD::saveItemStr('framesEpisode', $user_input->framesEpisode) == false)
					return ActionFactory::show_title_dialog("Сохранение не удалось");
				$params['runControlId'] = $user_input->control_id;
				return UserInputHandlerRegistry::create_action($this, 'close_and_run', $params);
			}
			$add_params['control_id']= $user_input->control_id;
			$w1 = 400; $color = 15;
			$vquality[1] = '360';
			$vquality[2] = '480';
			$vquality[3] = '720';
			$vquality[4] = '1080';
			$ini_arr = parse_ini_file('/tmp/run/versions.txt');
			if ((preg_match('|87\d\d|', $ini_arr['platform_kind']))||(HD::is_android() == true)){
				$vquality[5] = '1440p';
				$vquality[6] = '2160p (max.)';
			}
			$add_params['initial_sel_ndx'] = 0;
			$filmix_quality = (HD::getItemStr('filmix_quality', true) != '') ? HD::getItemStr('filmix_quality', true) : 1;
			ControlFactory::add_combobox($defs, $this, $add_params,
				'filmix_quality', '',
				$filmix_quality, $vquality, $w1, true, false
			);
			ControlFactory::add_smart_label($defs,"", '<gap width="' . ($w1 + 20) . '"/><text dy="-69" color="'.$color.'">качество видео Filmix*</text>');
			ControlFactory::add_vgap($defs, -80);
			ControlFactory::add_smart_label($defs, "", '<text color="23" size="small">*качество 720 доступно после логина</text>');
			ControlFactory::add_vgap($defs, 55);
			
			$video_quality = (HD::getItemStr('video_quality', true) != '') ? HD::getItemStr('video_quality', true) : 1;
			$add_params['initial_sel_ndx'] = $add_params['initial_sel_ndx'] + 1;
			ControlFactory::add_combobox($defs, $this, $add_params,
				'video_quality', '',
				$video_quality, $vquality, $w1, true, false
			);
			ControlFactory::add_smart_label($defs,"", '<gap width="' . ($w1 + 20) . '"/><text dy="-69" color="'.$color.'">качество видео*</text>');
			ControlFactory::add_vgap($defs, -80);
			ControlFactory::add_smart_label($defs, "", '<text color="23" size="small">*глобально для всех источников, кроме Filmix и торрентов</text>');
			ControlFactory::add_vgap($defs, 55);
			
			if (HD::is_android() == true){
				$add_params['initial_sel_ndx'] = $add_params['initial_sel_ndx'] + 1;
				$android_action = (HD::getItemStr('android_action', true) != '') ? HD::getItemStr('android_action', true) : 0;
				ControlFactory::add_vgap($defs, -75);
				$add_params['initial_sel_ndx'] = $add_params['initial_sel_ndx'] + 1;
				ControlFactory::add_combobox($defs, $this, $add_params,
					'android_action',
					'',
					$android_action, array('Нет', 'Да все', 'Только HLS v4'),  $w1, true, false
				);
				ControlFactory::add_smart_label($defs,"", '<gap width="' . ($w1 + 20) . '"/><text dy="-69" color="'.$color.'">использовать Android плеера</text>');
			}
			$downViewed = (HD::getItemStr('downViewed') != '') ? HD::getItemStr('downViewed') : 0;
			ControlFactory::add_vgap($defs, -75);
			$add_params['initial_sel_ndx'] = $add_params['initial_sel_ndx'] + 1;
			ControlFactory::add_combobox($defs, $this, $add_params,
				'downViewed', '',
				$downViewed, array('Да', 'Нет'),  $w1, true, false
			);
			ControlFactory::add_smart_label($defs,"", '<gap width="' . ($w1 + 20) . '"/><text dy="-69" color="'.$color.'">опускать просмотренные вниз</text>');
			$framesEpisode = (HD::getItemStr('framesEpisode') != '') ? HD::getItemStr('framesEpisode') : 1;
			ControlFactory::add_vgap($defs, -75);
			$add_params['initial_sel_ndx'] = $add_params['initial_sel_ndx'] + 1;
			ControlFactory::add_combobox($defs, $this, $add_params,
				'framesEpisode',
				'',
				$framesEpisode, array('Нет', 'Да', 'Кадры Нет'),  $w1, true, false
			);
			ControlFactory::add_smart_label($defs,"", '<gap width="' . ($w1 + 20) . '"/><text dy="-69" color="'.$color.'">кадры эпизодов и недостающие</text>');
			ControlFactory::add_vgap($defs, -75);
			$attrs['initial_sel_ndx'] = isset($user_input->initial_sel_ndx) ? $user_input->initial_sel_ndx : -1;
			return ActionFactory::show_dialog('Дополнительные настройки', $defs, true, 1100, $attrs);
		}
		if ($user_input->control_id === 'pluginDesignTheme'){
			$add_params = null;
			ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, 'importBazingaIconTheme', 'Загрузить тему оформления', 850);
			ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, 'createBazingaIconTheme', 'Выгрузить тему оформления', 850);
			ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, 'clearBazingaIconTheme', 'Очистить тему оформления', 850);
			ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, 'defaultBazingaIconTheme', 'Выгрузить тему по умолчанию', 850);
			return  ActionFactory::show_dialog("Тема оформления плагина",	$defs, true, 870);
		}
		if ($user_input->control_id === 'defaultBazingaIconTheme'){
			$media_url = MediaURL::encode(
				array(
					'screen_id'     => 'file_list',
					'save_data'		=> 'exportDefaultIconTheme'
				)
			);
			return ActionFactory::open_folder($media_url,'Выгрузить тему оформления плагина => Накопитель:');
		}
		if ($user_input->control_id === 'importBazingaIconTheme'){
			$media_url = MediaURL::encode (
				array(
					'screen_id'     => 'file_list',
					'save_file'		=> array(
						'action' 	=> 'importBazingaIconTheme',
						'fileName' 	=> DuneSystem::$properties['plugin_name'] . 'IconTheme.zip'
					),
				)
			);
			return ActionFactory::open_folder($media_url,'Выберите архив темы оформления');
		}
		if ($user_input->control_id === 'createBazingaIconTheme'){
			$media_url = MediaURL::encode(
				array(
					'screen_id'     => 'file_list',
					'save_data'		=> 'createBazingaIconTheme'
				)
			);
			return ActionFactory::open_folder($media_url, 'Выгрузить тему оформления');
		}
		if ($user_input->control_id === 'clearBazingaIconTheme'){
			if (isset($user_input->clear)){
				$dataDir = HD::get_data_path();
				if (file_exists($dataDir . '/icons'))
					shell_exec("rm -rf $dataDir/icons");
				$do = ActionFactory::restart();
				return ActionFactory::show_title_dialog("Тема оформления в плагине очищена",$do, 'Плеер будет перезагружен!', 800,1);
			}
			ControlFactory::add_multiline_label($defs, '', 'Для очистки темы оформления необходима перезагрузка плеера. Перезагрузить плеер сейчас?', 8);
			$params['clear'] = 1;
			$reboot = UserInputHandlerRegistry::create_action($this, 'clearBazingaIconTheme', $params);
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_reboot', 'Да', 250, $reboot);
			ControlFactory::add_close_dialog_button($defs, 'Нет', 250);
			return  ActionFactory::show_dialog('Необходима перезагрузка плеера',$defs, true,1000,$attrs);
		}
		if ($user_input->control_id === 'pluginAppearance'){
			$gui_params['button_caption_centered'] = false;
			$show_ops[1] = 'Да';
			$show_ops[0] = 'Нет';
			$transparencyDialogs = (HD::getItemStr('transparencyDialogs') != '') ? HD::getItemStr('transparencyDialogs') : 1;
			ControlFactory::add_label($defs, '', 'Прозрачность диалогов:');
			ControlFactory::add_vgap($defs, -10);
			$add_params['initial_sel_ndx'] = 0;
			$add_params['runControlId'] = $user_input->control_id;
			ControlFactory::add_combobox($defs, $this, $add_params,
				'transparencyDialogs',
				'',
				$transparencyDialogs, $show_ops, 850, true, false
			);
			$paintSandwich = (HD::getItemStr('paintSandwich') != '') ? HD::getItemStr('paintSandwich') : 1;
			ControlFactory::add_vgap($defs, -10);
			ControlFactory::add_label($defs, '', 'Белая рамка-стекло итемов:');
			ControlFactory::add_vgap($defs, -10);
			$this->add_combobox($defs,
				'paintSandwich', 
				'',
				$paintSandwich,  $show_ops, 850, true
			);
			$getMovieInfo = (HD::getItemStr('getMovieInfo', true) != '') ? HD::getItemStr('getMovieInfo', true) : 'max';
			ControlFactory::add_vgap($defs, -10);
			ControlFactory::add_label($defs, '', 'Расширенная информация карточки фильма:');
			ControlFactory::add_vgap($defs, -10);
			$this->add_combobox($defs,
				'getMovieInfo',
				'',
				$getMovieInfo, 
				array('min' => 'Нет (быстрей загрузка карточки)', 
				'medium' => 'Да (без MyShows)', 
				'max' => 'Да (медленней загрузка карточки)'
				), 850, true
			);
			$movieViewed = (HD::getItemStr('movieViewed', true) !='') ? HD::getItemStr('movieViewed', true) : 0;
			ControlFactory::add_vgap($defs, -10);
			ControlFactory::add_label($defs, '', 'Карточка фильма:');
			ControlFactory::add_vgap($defs, -10);
			ControlFactory::add_combobox($defs, $this, null,
				'movieViewed',
				'',
				$movieViewed, 
				array('Старая','Новая'),  850, true
			);
			if ($movieViewed == 0){
				$backgroundShow = (HD::getItemStr('backgroundShow') != '') ? HD::getItemStr('backgroundShow') : 1;
				ControlFactory::add_vgap($defs, -10);
				ControlFactory::add_label($defs, '', 'Карточка фильма (бекграунд):');
				ControlFactory::add_vgap($defs, -10);
				ControlFactory::add_combobox($defs, $this, null,
					'backgroundShow',
					'',
					$backgroundShow, $show_ops,  850, true
				);
			}
			$detailedInfoFontSize = (HD::getItemStr('detailedInfoFontSize') != '') ? HD::getItemStr('detailedInfoFontSize') : FONT_SIZE_SMALL;
			$font_size_ops[FONT_SIZE_SMALL]= 'Мелкий';
			$font_size_ops[FONT_SIZE_NORMAL]= 'Нормальный';
			ControlFactory::add_vgap($defs, -10);
			ControlFactory::add_label($defs, '', 'Шрифт правой панели:');
			ControlFactory::add_vgap($defs, -10);
			$this->add_combobox($defs,
				'detailedInfoFontSize',
				'',
				$detailedInfoFontSize, $font_size_ops, 850, true
			);
			ControlFactory::add_vgap($defs, -10);
			ControlFactory::add_label($defs, '', 'Бекграунды:');
			ControlFactory::add_vgap($defs, -10);
			ControlFactory::add_button(&$defs, $this, null, 'blockBackgroundActions', '', 'Изменить отображение', 850);
			$attrs['initial_sel_ndx'] = isset($user_input->initial_sel_ndx) ? $user_input->initial_sel_ndx : -1;
			return  ActionFactory::show_dialog("Настройки оформления:",	$defs, true, 950, $attrs);
		}
		if ($user_input->control_id == 'close_and_run'){
			$params = null;
			if (isset($user_input->initial_sel_ndx))
				$params['initial_sel_ndx'] = $user_input->initial_sel_ndx;
			$action = UserInputHandlerRegistry::create_action($this, $user_input->runControlId, $params);
			return ActionFactory::close_dialog_and_run($action);
		}
		if ($user_input->control_id == 'fixSkin'){
			if (!isset($user_input->sayYes)){
				ControlFactory::add_multiline_label($defs, '', "Для отображения всех цветов палитры необходимо исправить тему Silver. Палитра будет исправлена, тема установлена пользовательской и плеер будет перегружен.\nПродолжить?", 8);
				ControlFactory::add_close_dialog_and_apply_button($defs, $this, array('sayYes' => true), $user_input->control_id, 'Да', 300);
				ControlFactory::add_close_dialog_button($defs, 'Нет', 300);
				return  ActionFactory::show_dialog('Silver Skin Исправить цвета',$defs, true,930,$attrs);
			}
			
			if (file_exists('/tmp/dune_skin_dir.txt'))
				$skin_path = trim(str_replace('skin_dir =', '', file_get_contents('/tmp/dune_skin_dir.txt'))) . '/';
			else
				throw new Exception(get_class($this).': Can not determine the path to the active skin.');
			$custom_skin_path = file_exists('/persistfs')? '/persistfs/dune_skin/' : '/flashdata/dune_skin/';
			if (!file_exists($custom_skin_path))
				mkdir ($custom_skin_path);
			if (file_exists($custom_skin_path)){
				foreach (glob($custom_skin_path . '*') as $file) {
					if (is_link($file)) {
						unlink($file);
					} else if (is_dir($file)) {
						shell_exec('rm -rf ' . $file . '/*');
						rmdir($file);
					} else unlink($file);
				}
			}else{
				throw new Exception(get_class($this).': Can not create custom skin.');
				return false;
			}
			foreach (glob($skin_path . '*') as $file) {
				hd_print($file);
				if ($file == $skin_path . 'images') {
					mkdir($custom_skin_path . 'images');
					foreach (glob($skin_path . 'images/*') as $images_file) {
						hd_print('    ' . $images_file);
						if ($images_file == $skin_path . 'images/bg.jpg') {
							copy($images_file, $custom_skin_path . 'images/' . basename($images_file));
						} else symlink($images_file, $custom_skin_path . 'images/' . basename($images_file));
					}
				} else if ($file == $skin_path . 'dune_skin_config.xml')
					file_put_contents($custom_skin_path . basename($file), preg_replace('|<text_colors>.*?</text_colors>|ms','',file_get_contents($file)));
				else
					symlink($file, $custom_skin_path . basename($file));
			}
			if (file_exists('/config/settings.properties')) {
				$system_settings_runtime = parse_ini_file('/config/settings.properties', 0, INI_SCANNER_RAW);
				$system_settings_runtime['gui_skin'] = 'custom';
				$output = '';
				foreach($system_settings_runtime as $k => $v) {
					$output .= "$k = $v" . PHP_EOL;
				}
				file_put_contents('/config/settings.properties', $output);
			}
			if (defined('CHANGE_SETTINGS_ACTION_ID'))
				return array(
					 GuiAction::handler_string_id => CHANGE_SETTINGS_ACTION_ID,
					 GuiAction::data => array(
						ChangeSettingsActionData::restart_gui => true,
						ChangeSettingsActionData::post_action => null));

			if (defined('RESTART_ACTION_ID'))
				return array(
				     GuiAction::handler_string_id => RESTART_ACTION_ID,
				     GuiAction::data => array(
				        RestartActionData::reboot => false));
			exec('killall shell');
		}
		if ($user_input->control_id === 'backgroundShow'){
			HD::saveItemStr('backgroundShow', $user_input->backgroundShow);
			return ActionFactory::reset_controls($this->do_get_control_defs($plugin_cookies));
		}
		if ($user_input->control_id === 'transparencyDialogs'){
			HD::saveItemStr('transparencyDialogs', $user_input->transparencyDialogs);
			if (isset($user_input->initial_sel_ndx))
				$params['initial_sel_ndx'] = $user_input->initial_sel_ndx;
			$params['runControlId'] = $user_input->runControlId;
			$post_action = UserInputHandlerRegistry::create_action($this, 'close_and_run', $params);
			return ActionFactory::show_title_dialog('Сохранено', $post_action);
		}
		if ($user_input->control_id === 'paintSandwich'){
			HD::saveItemStr('paintSandwich', $user_input->paintSandwich);
			$post_action = ActionFactory::reset_controls($this->do_get_control_defs($plugin_cookies));
			return UserInputHandlerRegistry::create_action($this, 'reboot');
		}
		if ($user_input->control_id === 'movieViewed'){
			HD::saveItemStr('movieViewed', $user_input->movieViewed, true);
			return UserInputHandlerRegistry::create_action($this, 'reboot');
		}
		if ($user_input->control_id === 'getMovieInfo'){
			HD::saveItemStr('getMovieInfo', $user_input->getMovieInfo, true);
			$pluginCachePath = HD::get_data_path() . "/pluginCache/";
			if (file_exists($pluginCachePath))
				foreach(glob($pluginCachePath . '*.srz') as $v)
					unlink($v);
			return null;
		}
		if ($user_input->control_id === 'detailedInfoFontSize'){
			HD::saveItemStr('detailedInfoFontSize', $user_input->detailedInfoFontSize);
			return UserInputHandlerRegistry::create_action($this, 'reboot');
		}
		if ($user_input->control_id == 'blockBackgroundActions'){
			$paintBackground = (HD::getItemsArr('paintBackground') != array()) ? HD::getItemsArr('paintBackground') : array('paint_widget_background' => true, 'paint_content_box_background' => true, 'paint_path_box_background' => true, 'paint_details_box_background' => true);
			if (isset($user_input->save)){
				foreach ($paintBackground as $k => $v)
					$paintBackground[$k] = (bool)($user_input->$k);
				HD::saveItemsArr('paintBackground', $paintBackground);
				$post_action = UserInputHandlerRegistry::create_action($this, 'reboot');
				return ActionFactory::show_title_dialog('Сохранено', $post_action, 'Изменения отобразятся в категориях плагина.', 650);
			}
			$_ops[1] = 'Да';
			$_ops[0] = 'Нет';
			foreach ($paintBackground as $k => $v){
				$str = ucwords (str_replace('_', ' ', $k));
				ControlFactory::add_combobox($defs, $this, null,
					$k,
					$str,
					intval($v), $_ops, 0, false
				);
			}
			$add_params['save']= true;
			ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id, 'Применить');
			return ActionFactory::show_dialog("Бекграунды блоков", $defs, true);
		}
		if ($user_input->control_id === 'resetDataPath'){
			if (file_exists(DuneSystem::$properties['data_dir_path'] . '/data_dir_path'))
				unlink(DuneSystem::$properties['data_dir_path'] . '/data_dir_path');
			$path = HD::get_data_path(1);
			$post_action = UserInputHandlerRegistry::create_action($this, 'reboot');
			return ActionFactory::show_title_dialog('Расположение папки DATA сброшено!', $post_action, $path, 980);
		}
		if ($user_input->control_id === 'reboot'){
			$defs = array();
			if (isset($user_input->do_reboot))
				return ActionFactory::restart();
			if (isset($user_input->msg))
				$msg = $user_input->msg;
			else
				$msg = 'Перезагрузить плеер сейчас?';
			ControlFactory::add_multiline_label($defs, '', $msg, 8);
			$add_params['do_reboot'] = true;
			$reboot = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_reboot', 'Да', 250, $reboot);
			ControlFactory::add_close_dialog_button($defs, 'Нет', 250);
			return  ActionFactory::show_dialog('Необходима перезагрузка плеера',$defs, true,1000);
		}
		if ($user_input->control_id === 'data_path'){
			$media_url = MediaURL::encode(
				array(
					'screen_id'     => 'file_list',
					'save_data'		=> 'data_dir_path'
				)
			);
			$do_actions = ActionFactory::open_folder($media_url,'Расположение DATA:');
			return ActionFactory::close_dialog_and_run($do_actions);
		}
		if ($user_input->control_id === 'export_data'){
			$media_url = MediaURL::encode(
				array(
					'screen_id'     => 'file_list',
					'save_data'		=> 'export_data'
				)
			);
			$do_actions = ActionFactory::open_folder($media_url,'Выгрузить DATA Плагин => Накопитель:');
			return ActionFactory::close_dialog_and_run($do_actions);
		}
		if ($user_input->control_id === 'import_data'){
			$media_url = MediaURL::encode(
				array(
					'screen_id'     => 'file_list',
					'save_data'		=> 'import_data'
				)
			);
			$do_actions = ActionFactory::open_folder($media_url,'Загрузка DATA Накопитель => Плагин:');
			return ActionFactory::close_dialog_and_run($do_actions);
		}
		if ($user_input->control_id === 'import_file_data'){
			$media_url = MediaURL::encode(
				array(
					'screen_id'     => 'file_list',
					'save_file'		=> array(
						'action' 		=> 'import_file_data',
						'extension' 	=> 'all_extension'
					),
				)
			);
			$do_actions = ActionFactory::open_folder($media_url,'Выберите файл для загрузки в DATA');
			return ActionFactory::close_dialog_and_run($do_actions);
		}
		if ($user_input->control_id === 'data_dialog'){
			$defs = array();
			$gui_params['button_caption_centered'] = false;
			$width = 980;
			ControlFactory::add_smart_label($defs, 
				"", 
				'<text color="10" size="normal">'.HD::get_data_path().'</text>'
			);
			ControlFactory::add_button(&$defs, $this, $add_params=null, 'data_path', '', 'Изменить расположение папки DATA', $width, $gui_params);
			if (HD::get_data_path() != DuneSystem::$properties['data_dir_path'])
				ControlFactory::add_button(&$defs, $this, $add_params=null, 'resetDataPath', '', 'Сбросить расположение', $width, $gui_params);

			ControlFactory::add_button(&$defs, $this, $add_params=null, 'export_data', '', 'Выгрузить DATA (Плагин => Накопитель)', $width, $gui_params);
			ControlFactory::add_button(&$defs, $this, $add_params=null, 'import_data', '', 'Загрузить DATA (Накопитель => Плагин)', $width, $gui_params);
			ControlFactory::add_button(&$defs, $this, $add_params=null, 'import_file_data', '', 'Загрузить файл в DATA (Накопитель => Плагин)', $width, $gui_params);
			ControlFactory::add_button(&$defs, $this, $add_params=null, 'clear_data', '', 'Очистить DATA в плагине', $width, $gui_params);
			
			return  ActionFactory::show_dialog("Папка DATA", $defs, true, $width + 100);
		}
		if ($user_input->control_id === 'clear_data'){
			$ddp = DuneSystem::$properties['data_dir_path'] . '/data_dir_path';
			if (file_exists($ddp)) $ddpBak = file_get_contents($ddp);
			if (file_exists(DuneSystem::$properties['data_dir_path']))	shell_exec("rm -rf ".DuneSystem::$properties['data_dir_path']);
			if (!file_exists(DuneSystem::$properties['data_dir_path']))	mkdir(DuneSystem::$properties['data_dir_path'],0777,true);
			if (isset($ddpBak))	file_put_contents($ddp, $ddpBak);
			$do_actions = ActionFactory::show_title_dialog("Папка DATA в плагине очищена!",null, '', 800,1);
			return ActionFactory::close_dialog_and_run($do_actions);
		}
		if ($user_input->control_id == 'pin_dialog'){
			$defs = array();
			$parentalControl = isset($plugin_cookies->parentalControl) ? $plugin_cookies->parentalControl : '';
			if (isset($user_input->newParentalControl)){
				if(isset($user_input->oldParentalControl))
					if ($parentalControl != md5($user_input->oldParentalControl))
						return ActionFactory::show_title_dialog('Старый PIN родительского контроля указан не верно');
				if ($user_input->newParentalControl == ''){
					$plugin_cookies->parentalControl = '';
					$msg = 'PIN родительского контроля удален';
				}else{
					$plugin_cookies->parentalControl = md5($user_input->newParentalControl);
					$msg = 'Новый PIN родительского контроля сохранен';
				}
				return ActionFactory::show_title_dialog($msg);
			}
			if ($parentalControl == ''){
				ControlFactory::add_label($defs, '', 'Новый PIN родительского контроля');
				ControlFactory::add_text_field(&$defs,
				$this, null,
				'newParentalControl', '', '',
				1, 0, 0, 1, 710, 0, 0);
			}else{
				ControlFactory::add_label($defs, '', 'Старый PIN родительского контроля');
				ControlFactory::add_text_field(&$defs,
				$this, null,
				'oldParentalControl', '', '',
				1, 0, 0, 1, 710, 0, 0);
				ControlFactory::add_label($defs, '', 'Новый PIN родительского контроля');
				ControlFactory::add_text_field(&$defs,
				$this, null,
				'newParentalControl', '', '',
				1, 0, 0, 1, 710, 0, 0);
			}
			ControlFactory::add_smart_label($defs, "", '<text size="small">* PIN родительского контроля может содержать</text>');
			ControlFactory::add_vgap($defs, -25);
			ControlFactory::add_smart_label($defs, "", '<text size="small">любое количество любых символов</text>');
			$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id);
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,	'_vq', 'Применить', 0, $action);
            return ActionFactory::show_dialog('PIN родительского контроля', $defs, true);
		}
		if ($user_input->control_id == 'hide_pin_control'){
			if (md5($user_input->hide_pin_control) == $plugin_cookies->parentalControl){
				$params['unlock'] = true;
				$a = UserInputHandlerRegistry::create_action($this, $user_input->controlId, $params);
				return ActionFactory::close_dialog_and_run($a);
			}else
				return  ActionFactory::show_title_dialog('Код не верный!');
		}
		if ($user_input->control_id === 'parser_del'){
			$link_api = '/tmp/plugins/link_api.php';
			if (file_exists('/persistfs/plugins_data'))
				$link_api = '/persistfs/plugins_data/link_api.php';
			if (file_exists("/system/dunehd/init") || getenv("FS_PREFIX"))
				$link_api = '/flahdata/plugins_data/link_api.php';
			unlink($link_api);
			return UserInputHandlerRegistry::create_action($this, 'parser_update');
		}
		if ($user_input->control_id === 'parser_update'){
			$link_api = '/tmp/plugins/link_api.php';
			if (file_exists('/persistfs/plugins_data'))
				$link_api = '/persistfs/plugins_data/link_api.php';
			if (file_exists("/system/dunehd/init") || getenv("FS_PREFIX"))
				$link_api = '/flahdata/plugins_data/link_api.php';
			file_put_contents ($link_api, HD::http_get_document('http://dune-club.info/plugins/update/link_api.txt'));	
			$arg['msg'] = "После обновления парсеров для их применения необходима перезагрузка оболочки или выйти из плагина и на иконке плагина нажать кнопку пульта POP UP MENU выбрать пункт обновить!\nПерезагрузить плеер сейчас?";
			$action = UserInputHandlerRegistry::create_action($this, 'reboot', $arg);
			return ActionFactory::show_title_dialog('Парсеры обновлены!',$action,"Установлена версия: $this->spVer",800,1);
		}
        return ActionFactory::reset_controls($this->do_get_control_defs($plugin_cookies));
    }
}

///////////////////////////////////////////////////////////////////////////
?>
