<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/vod/abstract_vod.php';
require_once 'lib/vod/movie.php';
$link_api = link_api();
if (file_exists($link_api))
	require $link_api;
///////////////////////////////////////////////////////////////////////////

class SmartVod extends AbstractVod
{
    public function __construct(){
        parent::__construct(
            false,
            false,
            true
		);
    }

    ///////////////////////////////////////////////////////////////////////

    public function try_load_movie($movie_id, $class_name, $mUrl, &$plugin_cookies){
		$posterCashe = 0;
		$posterCasheHist = (HD::getItemStr('posterCasheHist') != '') ? HD::getItemStr('posterCasheHist') : 0;
		$arrCacheName = md5($movie_id . $class_name) . '.srz';
		$arrCachePath = HD::get_data_path() . "/pluginCache/" . $arrCacheName;
		$cachePosterUrl = HD::get_data_path() . "/pluginCache/" . md5($mUrl->get_raw_string()) . '.jpg';
		if (isset($this->currentFav))
			$posterCashe = (HD::getItemStr('posterCashe') != '') ? HD::getItemStr('posterCashe') : 0;
		if (isset($mUrl->torrentSourseClassName))
			$class_name = $mUrl->class_name = $mUrl->torrentSourseClassName;
		if (isset($mUrl->infoSourseClassName))
			$class_name = $mUrl->infoSourseClassName;
		$getMovieInfo = (HD::getItemStr('getMovieInfo', true) != '') ? HD::getItemStr('getMovieInfo', true) : 'max';
		if (file_exists($arrCachePath)){
			$arr = unserialize(file_get_contents($arrCachePath));
		}else if ((isset($this->favoritesItemMovieIds))&&(isset($this->favoritesItemMovieIds[$movie_id]))){
			$f = MediaURL::decode($this->favoritesItemMovieIds[$movie_id]);
			$cn = $f->class_name;
			$arr = $cn::load_movie($f->movie_id, $this->favoritesItemMovieIds[$movie_id], $getMovieInfo);
		}else
			$arr = $class_name::load_movie($movie_id, $mUrl, $getMovieInfo);
		
		if ((isset($arr['poster_url']))&&($arr['poster_url'] == 'plugin_file://icons/pixel.png'))
			$arr['poster_url'] = "plugin_file://icons/$class_name.png";
		if (file_exists($cachePosterUrl))
			$arr['poster_url'] = $cachePosterUrl;
        if ($arr === false){
            hd_print("Error: can not parse $movie_id, $class_name");
            throw new Exception('Illegal document');
        }
		if (($posterCashe == 1)&&(!file_exists($arrCachePath)))
			HD::pluginCache(serialize($arr), $arrCacheName);
        $movie = new Movie($movie_id);
        $movie->set_data(
			isset($arr['caption']) ? $arr['caption'] : 'err!',
			isset($arr['caption_original']) ? $arr['caption_original'] : '',
			isset($arr['description']) ? $arr['description'] : '',
			isset($arr['poster_url']) ? $arr['poster_url'] : 'plugin_file://icons/poster_none.png',
			isset($arr['length']) ? $arr['length'] : -1,
			isset($arr['year']) ? $arr['year'] : '',
			isset($arr['director']) ? $arr['director'] : '' ,
			isset($arr['scenario']) ? $arr['scenario'] : '',
			isset($arr['actors']) ? $arr['actors'] : '',
			isset($arr['genres']) ? $arr['genres'] : '',
			isset($arr['rate_imdb']) ? $arr['rate_imdb'] : '',
			isset($arr['rate_kinopoisk']) ? $arr['rate_kinopoisk'] : '',
			isset($arr['rate_mpaa']) ? $arr['rate_mpaa'] : '',
			isset($arr['country']) ? $arr['country'] : '',
			isset($arr['budget']) ? $arr['budget'] : '',
			isset($arr['details']) ? $arr['details'] : array(),
            isset($arr['rate_details']) ? $arr['rate_details'] : array()
		);
		if (isset($arr['background_urls']))
			$movie->background_urls = $arr['background_urls'];
		if (isset($arr['video_urls']))
			$movie->video_urls = $arr['video_urls'];
		if (isset($arr['class_info']))
			$movie->class_info = $arr['class_info'];
		if ((isset($mUrl->kpID))&&(!isset($movie->class_info['dbIDs']['kpID'])))
			$movie->class_info['dbIDs']['kpID'] = $mUrl->kpID;
		if (isset($arr['is_serial']))
			$movie->is_serial = true;
		if (isset($arr['setSeriesList'])){
			$movie->add_series_data(
				$arr['id'],
				$arr['title'],
				$arr['playback_url'],
				$arr['is_stream_url'],
				$arr['file_info']
			);
		}
		$histmUrl = $mUrl->get_raw_string();
		if (isset($arr['poster_url'])){
			$raw = json_decode($mUrl->get_raw_string(), true);
			if ((!isset($raw['poster_url']))||($raw['poster_url'] == "plugin_file://icons/$class_name.png")){
				$raw['poster_url'] = $arr['poster_url'];
				$histmUrl = MediaURL::encode($raw);
			}
		}
		$myShowsIds = HD::getItemsArr('myShowsIds');
		if (isset($myShowsIds[$movie_id]))
			$movie->class_info['dbIDs']['myShowsID'] = $myShowsIds[$movie_id];
		if ($posterCasheHist == 1)
			$movie->casheHistArr = $arr;
		$movie->history_mUrl = $histmUrl;
        $this->set_cached_movie($movie);
    }
	
	public function get_vod_stream_url($playback_url, &$plugin_cookies){
		static $counter = 0;
		static $old_playback_url = '';
		static $old_video_quality = '';
		static $stream_urls = "http://mp4://dune-club.info/plugins/update/1.mp4";
		if (preg_match('|filmix|', $playback_url))
			$video_quality = (HD::getItemStr('filmix_quality', true) != '') ? HD::getItemStr('filmix_quality', true) : 1;
		else
			$video_quality = (HD::getItemStr('video_quality', true) != '') ? HD::getItemStr('video_quality', true) : 1;
		echo "video_quality:$video_quality playback_url===> $playback_url";
		////////////////////////////////////////////////////////////////////////////////////
		//bbt                                                                             //
		//$stream_url = mUrl::get_link($playback_url, $video_quality);                    //
		////////////////////////////////////////////////////////////////////////////////////
		if (($old_playback_url != $playback_url)||($old_video_quality != $video_quality)){
			$stream_urls = mUrl::get_link($playback_url, $video_quality);
			if (is_array($stream_urls))
				$stream_url = $stream_urls[0];
			else
				$stream_url = $stream_urls;
			$old_playback_url = $playback_url;
			$old_video_quality = $video_quality;
			$counter = 0;
		}else{
			$counter++;
			if (is_array($stream_urls)){
				if (isset($stream_urls[$counter]))
					$stream_url = $stream_urls[$counter];
				else{
					echo 'accessibility stream error:' . $counter;
					$stream_url = "http://mp4://dune-club.info/plugins/update/1.mp4";
				}
			}else
				$stream_url = $stream_urls;
		}
		if ($counter > 4){
			echo 'accessibility stream error:' . $counter;
			$stream_url = "http://mp4://dune-club.info/plugins/update/1.mp4";
		}
		echo 'counter:' . $counter;
		////////////////////////////////////////////////////////////////////////////////////
		echo "stream_url===> $stream_url";
		return $stream_url;
	}
    ///////////////////////////////////////////////////////////////////////
    // Favorites.

    protected function load_favorites(&$plugin_cookies){
        $fav_movie_ids = $this->get_fav_movie_ids_from_cookies($plugin_cookies);

        foreach ($fav_movie_ids as $movie_id){
            if ($this->has_cached_short_movie($movie_id))
                continue;

            $this->ensure_movie_loaded($movie_id, $plugin_cookies);
        }

        $this->set_fav_movie_ids($fav_movie_ids);

        hd_print('The ' . count($fav_movie_ids) . ' favorite movies loaded.');
    }

    protected function do_save_favorite_movies(&$fav_movie_ids, &$plugin_cookies){
        $this->set_fav_movie_ids_to_cookies($plugin_cookies, $fav_movie_ids);
    }

    ///////////////////////////////////////////////////////////////////////

    public function get_fav_movie_ids_from_cookies(&$plugin_cookies){
        if (!isset($plugin_cookies->{'favorite_movies'}))
            return array();

        $arr = preg_split('/,/', $plugin_cookies->{'favorite_movies'});

        $ids = array();
        foreach ($arr as $id){
            if (preg_match('/\S/', $id))
                $ids[] = $id;
        }
        return $ids;
    }

    public function set_fav_movie_ids_to_cookies(&$plugin_cookies, &$ids){
        $plugin_cookies->{'favorite_movies'} = join(',', $ids);
    }

    public function get_vod_list_folder_views(){
        return array();
    }
}
function link_api(){
	$link_api = '/tmp/plugins/link_api.php';
	if (file_exists('/persistfs/plugins_data'))
		$link_api = '/persistfs/plugins_data/link_api.php';
	if (file_exists("/system/dunehd/init") || getenv("FS_PREFIX"))
		$link_api = '/flashdata/plugins_data/link_api.php';
	$newVer = $oldVer = 0;
	if (file_exists($link_api)){
		if (preg_match('|##(.*?)##|', file_get_contents($link_api, null, null, 0, 50), $m))
			$oldVer = $m[1];
		else
			unlink ($link_api);
		$newVer = HD::http_get_document('http://dune-club.info/plugins/update/vlink_api.php', array('silent'=>true));
		if (!is_numeric($newVer)){
			hd_print("$newVer");
			return $link_api;
		}
	}
	if ((trim($newVer) > trim($oldVer))|| (!file_exists($link_api))){
		$ddoc = HD::http_get_document('http://dune-club.info/plugins/update/link_api.txt', array('silent'=>true));
		if (!preg_match('|58d84f7b59268b296bb96460a304de42|',$ddoc)){
			hd_print($ddoc);
			return $link_api;
		}
		file_put_contents ($link_api, $ddoc);
		if (file_exists($link_api)){
			if (preg_match('|##(.*?)##|', file_get_contents($link_api, null, null, 0, 50), $m))
				$oldVer .= ' [updated: ' . $m[1] . ']';
		}
	}
	$info = "\nplugin=v" . HD::plugin_version();
	$info .= "\nparser=$oldVer ($newVer)\n";
	$info .= shell_exec ('cat /tmp/run/versions.txt');
	hd_print("$info");
	return $link_api;
}
///////////////////////////////////////////////////////////////////////////
?>
