<?php
///////////////////////////////////////////////////////////////////////////

require_once 'Smart_vod_category.php';

///////////////////////////////////////////////////////////////////////////

class SmartVodCategoryListScreen extends AbstractPreloadedRegularScreen
implements UserInputHandler {
    const ID = 'vod_category_list';

    public static function get_media_url_str($class_name, $arr=null){
		$arr['screen_id'] = self::ID;			
		$arr['class_name'] = $class_name;
        return MediaURL::encode($arr);
    }

    ///////////////////////////////////////////////////////////////////////

    private $category_list;
    private $category_index;
	private $unlock = false;
	private $allCat = false;
	static $needRefresh = false;
    ///////////////////////////////////////////////////////////////////////

    public function __construct(){
        parent::__construct(
            self::ID, 
			$this->get_folder_views()
		);
		UserInputHandlerRegistry::get_instance()->
            register_handler($this);
    }

    ///////////////////////////////////////////////////////////////////////

    public function get_action_map(MediaURL $media_url, &$plugin_cookies){
		$actions[GUI_EVENT_TIMER] = UserInputHandlerRegistry::create_action($this, 'timer');
		$add_params['action'] = 'addToMainMenu';
		$add_action = UserInputHandlerRegistry::create_action($this, 'classAction', $add_params);
        $add_action['caption'] = 'В Главное Меню';
        $actions[GUI_EVENT_KEY_B_GREEN] = $add_action;
		
		$add_action = ActionFactory::open_folder('setup','Настройки');
        $add_action['caption'] = 'Настройки';
        $actions[GUI_EVENT_KEY_C_YELLOW] = $add_action;
		$actions[GUI_EVENT_KEY_SETUP] = $add_action;
		
		$add_action = UserInputHandlerRegistry::create_action($this, 'addToFav');
        $add_action['caption'] = 'Избранное';
        $actions[GUI_EVENT_KEY_D_BLUE] = $add_action;
		
		$actions[GUI_EVENT_KEY_ENTER] = UserInputHandlerRegistry::create_action($this, 'add_actions');
		$actions[GUI_EVENT_KEY_PLAY] = UserInputHandlerRegistry::create_action($this, 'add_actions');
				
		$popup_menu_action = UserInputHandlerRegistry::create_action($this, 'popup_menu');
		$actions[GUI_EVENT_KEY_POPUP_MENU] = $popup_menu_action;
		
		$add_params['action_move'] = 'hide_id';
		$add_action = UserInputHandlerRegistry::create_action($this, 'id_move', $add_params);
		$actions[GUI_EVENT_KEY_CLEAR] = $add_action;
		
		$actions[GUI_EVENT_KEY_SEARCH] = UserInputHandlerRegistry::create_action($this, 'classAction', array('action' => 'search'));
		$class_name = $media_url->class_name;
		$actionsArr = $class_name::getScreenActionMapArr($media_url);
		foreach ($actionsArr as $k => $v){
			$params = false;
			if (isset($v['params']))
				$params = $v['params'];
			$add_action = UserInputHandlerRegistry::create_action($this, $v['create_action'], $params);
			if (isset($v['caption']))
				$add_action['caption'] = $v['caption'];
			$actions[$v['key']] = $add_action;
		}
		$useNumKey = HD::getItemsArr('useNumKey');
		foreach ($useNumKey as $k => $v){
			$params['openCat'] = $v;
			$actions[SmartConfig::$keyArr[$k]] = UserInputHandlerRegistry::create_action($this, 'add_actions', $params);
		}
		return $actions;
    }
	public function get_handler_id(){
		return self::ID;
	}
	
	public function handle_user_input(&$user_input, &$plugin_cookies){
		$parentalControl = isset($plugin_cookies->parentalControl) ? $plugin_cookies->parentalControl : '';
		if ($user_input->control_id == 'timer'){
			if (self::$needRefresh == true)
				return ActionFactory::invalidate_folders(array($user_input->parent_media_url));
			return null;
		}
		if ($user_input->control_id == 'add_actions'){
			if (isset($user_input->openCat))
				$user_input->selected_media_url = $user_input->openCat; 
			if ($parentalControl != ''){
				$lockCat = HD::getItemsArr('lockCat');
				if (isset($lockCat[$user_input->selected_media_url])){
					if(!isset($user_input->unlock)){
						$add_params['controlId']= $user_input->control_id;
						ControlFactory::add_text_field(
							$defs, $this, $add_params,
							'hide_pin_control', '',
							'', 1, 1, 0, 1, 500, 1 , 0
						);
						return  ActionFactory::show_dialog('Введите код:', $defs, true);
					}	
				}
			}
			if (isset($user_input->openCat)){
				$selected_media_url = MediaURL::decode($user_input->selected_media_url);
				return ActionFactory::open_folder($user_input->selected_media_url, $selected_media_url->caption);
			}
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			if ((isset($selected_media_url->categoryId))&&(($selected_media_url->categoryId == 'noll')||($selected_media_url->categoryId == 'nill')))
				return null;
			if ((isset($selected_media_url->categoryId))&&($selected_media_url->categoryId == 'addM3uDataDirPath'))
				return UserInputHandlerRegistry::create_action($this, 'classAction', array('action' => 'addM3uDataDirPath', 'indiClass' => 'm3uVOD_Class'));
			return ActionFactory::open_folder();
		}
		if ($user_input->control_id == 'hide_pin_control'){
			if (md5($user_input->hide_pin_control) == $plugin_cookies->parentalControl){
				$this->unlock = $params['unlock'] = true;
				if (isset($user_input->param))
					$params[$user_input->param] = $user_input->vel;
				$a = UserInputHandlerRegistry::create_action($this, $user_input->controlId, $params);
				return ActionFactory::close_dialog_and_run($a);
			}else
				return  ActionFactory::show_title_dialog('Код не верный!');
		}
		if ($user_input->control_id == 'popup_menu'){
			if (isset($user_input->selected_media_url)){
				$selected_media_url = MediaURL::decode($user_input->selected_media_url);
				$class_name = $selected_media_url->class_name;
				if (preg_match("|_Class|",$class_name)){
					$mItems = $class_name::getPopUpMenuItems($selected_media_url, $user_input->parent_media_url);
					foreach ($mItems as $v){
						if ($v == 'is_separator')
							$menu_items [] =  array(
							GuiMenuItemDef::is_separator => true,);
						// else if ($v['params'] == 'classSetup')
							// $menu_items[] = array(
								// GuiMenuItemDef::caption => $v['caption'],
								// GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classSetup' . $class_name),
								// GuiMenuItemDef::icon_url => $v['icon_url'],
							// );
						else
							$menu_items[] = array(
								GuiMenuItemDef::caption => $v['caption'],
								GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', $v['params']),
								GuiMenuItemDef::icon_url => $v['icon_url'],
							);
					}
				}
				if ($parentalControl != ''){
					$menu_items [] =  array(
						GuiMenuItemDef::is_separator => true,);
					$lockCat = HD::getItemsArr('lockCat');
					if (isset($lockCat[$user_input->selected_media_url])){
						$caption = 'Открыть категорию';
						$params['unlock_id'] = 1;
						$icon_url = SmartConfig::getPluginIco('s_unlock');
					}else{
						$caption = 'Закрыть категорию';
						$params['lock_id'] = 1;
						$icon_url = SmartConfig::getPluginIco('s_lock');
					}
					$menu_items[] = array(
						GuiMenuItemDef::caption => $caption,
						GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'parentalControlactions', $params),
						GuiMenuItemDef::icon_url => $icon_url
					);
				}
			}
			$menu_items [] =  array(
					GuiMenuItemDef::is_separator => true,);
			if (isset($user_input->selected_media_url)){
				$menu_items [] =  array(
					GuiMenuItemDef::is_separator => true,);
				$add_params['action_move'] = 'on';
				$menu_items[] = array(
					GuiMenuItemDef::caption => 'Настройка вида меню',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'id_move', $add_params),
					GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_move')
				);
				$menu_items [] =  array(
					GuiMenuItemDef::is_separator => true,);
				$add_params['action'] = 'add';
				$menu_items[] = array(
					GuiMenuItemDef::caption => 'Задать иконку',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'icon_actions', $add_params),
					GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_add_icon')
				);
				if (file_exists(HD::get_data_path() . "/icons/" . HD::strSanitizing($selected_media_url->caption) . ".png")){
					$add_params['action'] = 'del';
					$menu_items[] = array(
						GuiMenuItemDef::caption => 'Удалить иконку',
						GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'icon_actions', $add_params),
						GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_del_background')
					);
				}
			}
			$menu_items [] =  array(
				GuiMenuItemDef::is_separator => true,);
			$add_params['action'] = 'background_actions';
			$menu_items[] = array(
				GuiMenuItemDef::caption => 'Задать бекграунд',
				GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', $add_params),
				GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_add_background')
			);
			if (file_exists(HD::get_data_path() . "/icons/" . self::ID . "_bg.jpg")){
				$add_params['action'] = 'background_actions';
				$add_params['del'] = true;
				$menu_items[] = array(
					GuiMenuItemDef::caption => 'Удалить бекграунд',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', $add_params),
					GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_del_background')
				);
			}
			return ActionFactory::show_popup_menu($menu_items);
		}
		if ($user_input->control_id == 'id_move'){
			if (!isset($user_input->selected_media_url))
				return null;
			$view_idx = isset($plugin_cookies->{"screen.".self::ID.".view_idx"}) ? $plugin_cookies->{"screen.".self::ID.".view_idx"} : 0;
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			$class_name = $selected_media_url->class_name;
			$add_params['action_move'] = 'up';
			$add_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
			$add_action['caption'] = 'Вверх';
			$actions[GUI_EVENT_KEY_B_GREEN] = $add_action;
			if ($view_idx == 0)
				$actions[GUI_EVENT_KEY_LEFT] = $add_action;
			
			$add_params['action_move'] = 'down';
			$add_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
			$add_action['caption'] = 'Вниз';
			$actions[GUI_EVENT_KEY_C_YELLOW] = $add_action;
			if ($view_idx == 0)
				$actions[GUI_EVENT_KEY_RIGHT] = $add_action;
			
			$add_params['action_move'] = 'up_id';
			$add_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
			$add_action['caption'] = 'Поднять вверх';
			$actions[GUI_EVENT_KEY_D_BLUE] = $add_action;
			
			$add_params['action_move'] = 'hide_id';
			$add_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
			$actions[GUI_EVENT_KEY_CLEAR] = $add_action;
			
			$add_params['action_move'] = 'upPopUpMenu';
			$add_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
			$actions[GUI_EVENT_KEY_POPUP_MENU] = $add_action;
			
			$add_params['action_move'] = 'off';
			$add_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
			$add_action['caption'] = 'Выход';
			$actions[GUI_EVENT_KEY_RETURN] = $add_action;
			$actions[GUI_EVENT_KEY_ENTER] = $add_action;
			if ($user_input->action_move == 'upPopUpMenu'){
				$add_params['action_move'] = 'up_id';
				$menu_items[] = array(
					GuiMenuItemDef::caption => 'Поднять вверх',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params),
					GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_queue_move_top')
				);
				$add_params['action_move'] = 'hide_id';
				$menu_items[] = array(
					GuiMenuItemDef::caption => 'Cкрыть/Bостановить Категорию',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params),
					GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_list')
				);
				$add_params['action_move'] = 'clear';
				$menu_items[] = array(
					GuiMenuItemDef::caption => 'Cброс Категорий',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params),
					GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_num')
				);
				return ActionFactory::show_popup_menu($menu_items);
			}
			if ($user_input->action_move == 'up_id'){
				$nbrCategories = HD::getItemsArr($class_name . 'NbrCategories');
				$nbrCat = isset($nbrCategories[$user_input->parent_media_url]) ? $nbrCategories[$user_input->parent_media_url] : array();
				$fCat = array_flip($nbrCat);
				if (isset($nbrCat[$user_input->selected_media_url])){
					$k = $nbrCat[$user_input->selected_media_url];
					if ($k != 0){
						$up = $fCat[$k];
						unset ($fCat[$k]);
						array_unshift($fCat,$up);
						ksort ($fCat);
						$fCat = array_values ($fCat);
						$nbrCategories[$user_input->parent_media_url] = array_flip($fCat);
						HD::saveItemsArr($class_name . 'NbrCategories', $nbrCategories);
						$post_action = ActionFactory::change_behaviour($actions, 0);
						return ActionFactory::invalidate_folders(array($user_input->parent_media_url), $post_action);
					}else
						return ActionFactory::show_title_dialog("Err!", null, 'Каталог в начале списка!');
				}else{
					echo $user_input->selected_media_url;
					foreach ($nbrCat as $k => $v)
						echo "$k => $v";
					return ActionFactory::show_title_dialog("Err!", null, 'Подробности в лог файле!');
				}
			}
			if (($user_input->action_move == 'down')||
				($user_input->action_move == 'up')){
				
				$nbrCategories = HD::getItemsArr($class_name . 'NbrCategories');
				$nbrCat = isset($nbrCategories[$user_input->parent_media_url]) ? $nbrCategories[$user_input->parent_media_url] : array();
				$fCat = array_flip($nbrCat);
				if (isset($nbrCat[$user_input->selected_media_url])){
					$k = $nbrCat[$user_input->selected_media_url];
					if ($user_input->action_move == 'up'){
						if ($k == 0){
							$fCat[] = $fCat[$k];
							unset($fCat[0]);
							
						}else{
							$t = $fCat[$k - 1];
							$fCat[$k - 1] = $fCat[$k];
							$fCat[$k] = $t;
						}
					}
					if ($user_input->action_move == 'down'){
						if ($k == count($fCat) - 1){
							$fCat[-1] = $fCat[$k];
							unset($fCat[$k]);
						}else{
							$t = $fCat[$k + 1];
							$fCat[$k + 1] = $fCat[$k];
							$fCat[$k] = $t;
						}
					}
					ksort ($fCat);
					$fCat = array_values ($fCat);
					$nbrCategories[$user_input->parent_media_url] = array_flip($fCat);
					HD::saveItemsArr($class_name . 'NbrCategories', $nbrCategories);
					$post_action = ActionFactory::change_behaviour($actions, 0);
					return ActionFactory::invalidate_folders(array($user_input->parent_media_url), $post_action);
					  
				}else{
					echo $user_input->selected_media_url;
					foreach ($nbrCat as $k => $v)
						echo "$k => $v";
					return ActionFactory::show_title_dialog("Err!", null, 'Подробности в лог файле!');
				}
			}
			if ($user_input->action_move == 'clear'){
				if($this->unlock == false){
					if ($parentalControl != ''){
						$add_params['controlId']= $user_input->control_id;
						$add_params['param'] = 'action_move';
						$add_params['vel'] = 'clear';
						ControlFactory::add_text_field(
							$defs, $this, $add_params,
							'hide_pin_control', '',
							'', 1, 1, 0, 1, 500, 1 , 0
						);
						return  ActionFactory::show_dialog('Введите код:', $defs, true);
					}
				}
				$nbrCategories[$user_input->parent_media_url] = array();
				HD::saveItemsArr($class_name . 'NbrCategories', $nbrCategories);
				HD::saveItemsArr('hideCat', array());
				HD::saveItemsArr('lockCat', array());
				$post_action = ActionFactory::change_behaviour($actions, 0);
				return ActionFactory::invalidate_folders(array($user_input->parent_media_url), $post_action);
			}
			if ($user_input->action_move == 'hide_id'){
				$hideCat = HD::getItemsArr('hideCat');
				if (isset($hideCat[$user_input->selected_media_url])){
					if($this->unlock == false){
						if ($parentalControl != ''){
							$add_params['controlId']= $user_input->control_id;
							$add_params['param'] = 'action_move';
							$add_params['vel'] = 'hide_id';
							ControlFactory::add_text_field(
								$defs, $this, $add_params,
								'hide_pin_control', '',
								'', 1, 1, 0, 1, 500, 1 , 0
							);
							return  ActionFactory::show_dialog('Введите код:', $defs, true);
						}
					}
					unset($hideCat[$user_input->selected_media_url]);
				}else
					$hideCat[$user_input->selected_media_url] = 1;
				HD::saveItemsArr('hideCat', $hideCat);
				$post_action = ActionFactory::change_behaviour($actions, 0);
				return  ActionFactory::invalidate_folders(array($user_input->parent_media_url), $post_action);
			}
			if ($user_input->action_move == 'on'){
				$this->allSources = true;
				$this->unlock = false;
				ControlFactory::add_smart_label($defs, 
					"", 
					'<icon width="48" height="48">gui_skin://special_icons/controls_button_green.aai</icon><text color="15"> - двигать вверх</text>'
				);
				ControlFactory::add_vgap($defs, -20);
				ControlFactory::add_smart_label($defs, 
					"", 
					'<icon width="48" height="48">gui_skin://special_icons/controls_button_yellow.aai</icon><text color="15"> - двигать вниз</text>'
				);
				ControlFactory::add_vgap($defs, -20);
				ControlFactory::add_smart_label($defs, 
					"", 
					'<icon width="48" height="48">gui_skin://special_icons/controls_button_blue.aai</icon><text color="15"> - поднять вверх</text>'
				);
				ControlFactory::add_vgap($defs, -20);
				ControlFactory::add_smart_label($defs, 
					"", 
					'<icon width="131" height="53">gui_skin://special_icons/controls_button_clear.aai</icon><text color="15"> - скрыть/востановить</text>'
				);
				ControlFactory::add_vgap($defs, -20);
				ControlFactory::add_smart_label($defs, 
					"", 
					'<icon width="145" height="50">gui_skin://special_icons/controls_button_pop_up.aai</icon><text color="15"> - действия</text>'
				);
				ControlFactory::add_vgap($defs, -20);
				ControlFactory::add_smart_label($defs, 
					"", 
					'<icon width="131" height="53">gui_skin://special_icons/controls_button_enter.aai</icon><text color="15"> - выйти и применить</text>'
				);
				ControlFactory::add_vgap($defs, -20);
				ControlFactory::add_smart_label($defs, 
					"", 
					'<text color="15">RETURN - выйти и применить</text>'
				);
				ControlFactory::add_close_dialog_button($defs, 'ОК', 300);
				$post_action = ActionFactory::show_dialog("Help", $defs, true, 600);
				$post_action = ActionFactory::change_behaviour($actions, 0, $post_action);
				return  ActionFactory::invalidate_folders(array($user_input->parent_media_url), $post_action);
			}
			if ($user_input->action_move == 'off'){
				$this->allSources = false;
				$parent_media_url = MediaURL::decode($user_input->parent_media_url);
				$actions = $this->get_action_map($parent_media_url, $plugin_cookies);
				$post_action = ActionFactory::change_behaviour($actions, 0);
				return  ActionFactory::invalidate_folders(array($user_input->parent_media_url), $post_action);
			}
		}
		if ($user_input->control_id == 'parentalControlactions'){
			if (!isset($user_input->selected_media_url))
				return null;
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			if (isset($user_input->unlock_id)){
				if(!isset($user_input->unlock)){
					if ($parentalControl != ''){
						$params['unlock'] = true;
						$add_params['param'] = 'unlock_id';
						$add_params['vel'] = 1;
						$add_params['controlId']= $user_input->control_id;
						ControlFactory::add_text_field(
							$defs, $this, $add_params,
							'hide_pin_control', '',
							'', 1, 1, 0, 1, 500, 1 , 0
						);
						return  ActionFactory::show_dialog('Введите код:', $defs, true);
					}
				}
				$lockCat = HD::getItemsArr('lockCat');
				unset($lockCat[$user_input->selected_media_url]);
				HD::saveItemsArr('lockCat', $lockCat);
				return ActionFactory::invalidate_folders(array($user_input->parent_media_url));
			}
			if (isset($user_input->lock_id)){
				if (isset($user_input->apply)){
					$lockCat = HD::getItemsArr('lockCat');
					$lockCat[$user_input->selected_media_url] = 1;
					HD::saveItemsArr('lockCat', $lockCat);
					return ActionFactory::invalidate_folders(array($user_input->parent_media_url));
				}
				ControlFactory::add_multiline_label($defs, '', "Отключается через POPUP Menu открыть категорию.", 5);
				$add_params['apply'] = true;
				$add_params['lock_id'] = 1;
				ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id, 'Да', 250);
				ControlFactory::add_close_dialog_button($defs,'Нет', 250);
				return  ActionFactory::show_dialog("Закрыть категорию?", $defs, true, 700);
			}
		}
		if ($user_input->control_id == 'classAction'){
			$defs = array();
			hd_silence_warnings();
			if (isset($user_input->indiClass)){
				$selected_media_url = MediaURL::decode($user_input->selected_media_url);
				$class_name = $selected_media_url->class_name;
				return $class_name::classAction ($defs, $user_input, $this->select_url);
			}
			return SmartConfig::classAction ($defs, $user_input, $this->select_url);
		}
		if ($user_input->control_id == 'icon_actions'){
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			$icons_name = HD::strSanitizing($selected_media_url->caption);
			if ($user_input->action == 'del'){
				if (!unlink(HD::get_data_path() . "/icons/$icons_name.png"))
					return ActionFactory::show_title_dialog('Удаление не удалось!', null, HD::get_data_path() . "/icons/$class_name.png");
				return ActionFactory::invalidate_folders(array($user_input->parent_media_url));
			}
			if ($user_input->action == 'add'){
				$this->category_list = null;
				$media_url = MediaURL::encode (
					array(
						'screen_id'     => 'file_list',
						'save_file'		=> array(	
							'parent' => $user_input->parent_media_url,
							'action' => 'plugin_ico',
							'arg' => $icons_name,
							'extension' => 'png'
						),
					)
				);
				return ActionFactory::open_folder($media_url,'Задать иконку '. $selected_media_url->caption);
			}
		}
	}
    ///////////////////////////////////////////////////////////////////////

    public function get_all_folder_items(MediaURL $media_url, &$plugin_cookies){
		$class_name = $media_url->class_name;
		$category_list = $class_name::getVodCategories($media_url);
        $items = array();
		if ($category_list == false)
			return $items;
		if ((isset($category_list[0]['id']))&&($category_list[0]['id'] == 'noll'))
			self::$needRefresh = true;
		else
			self::$needRefresh = false;
		
		$hideCat = HD::getItemsArr('hideCat');
		$lockCat = HD::getItemsArr('lockCat');
		$s_lock = SmartConfig::getPluginIco('s_lock');
		$parent_media_url = $media_url->get_raw_string();
		$nbrCategories = HD::getItemsArr($class_name . 'NbrCategories');
		$nbrCat = isset($nbrCategories[$parent_media_url]) ? $nbrCategories[$parent_media_url] : array();
		$fCat = array();

		foreach ($category_list as $v){
			$color = 15;
			$view_item_params = $mArr = array();
			$mArr['categoryId'] = $v['id'];
			$mArr['caption'] = $v['caption'];
			if (isset($media_url->hCaptions))
				$mArr['hCaptions'] = $media_url->hCaptions;
			if (isset($media_url->caption))
				$mArr['hCaptions'][] = $media_url->caption;
			if (isset($v['playlist']))
				$mArr['playlist'] = $v['playlist'];
			if (isset($v['sectionId']))
				$mArr['sectionId'] = $v['sectionId'];
			$mUrl = $v['class']::get_media_url_str($class_name, $mArr);
			if (isset($nbrCat[$mUrl]))
				$n = $nbrCat[$mUrl];
			else
				$n = count ($fCat) - 1000;
			$fCat[$mUrl] = $n;
			if (isset($hideCat[$mUrl])){
				if ($this->allSources == true){
					$color = 17;
					$view_idx = isset($plugin_cookies->{"screen.".self::ID.".view_idx"}) ? $plugin_cookies->{"screen.".self::ID.".view_idx"} : 0;
					if ((defined('ViewItemParams::item_sticker') === true)&&($view_idx != 0)){
						$view_item_params[ViewItemParams::icon_sel_scale_factor] = 1.0;
						$view_item_params[ViewItemParams::item_sticker] = json_encode(HD::get_sticker(SmartConfig::getPluginIco('hide'), false, array('img_x' => 0, 'img_y' => 0)));
					}
				}else
					continue;
			}
			if (isset($v['icon_path']))
				$icon_path = SmartConfig::getPluginIco(HD::strSanitizing($v['icon_path']));
			else
				$icon_path = SmartConfig::getPluginIco(HD::strSanitizing($v['caption']));
			$view_item_params[ViewItemParams::icon_path] = $icon_path;
			$view_item_params[ViewItemParams::item_detailed_icon_path] = $icon_path;
			if (isset($v['detailed_icon']))
				$view_item_params[ViewItemParams::item_detailed_icon_path] = $v['detailed_icon'];
			$view_item_params[ViewItemParams::item_caption_color] = $color;
			if (isset($v['description']))
				$view_item_params[ViewItemParams::item_detailed_info] = '||' . $v['caption'] . '|' . $v['description'];
			
			if (isset($lockCat[$mUrl])){
				if (defined('ViewItemParams::item_sticker') === true)
					$view_item_params[ViewItemParams::item_sticker] = json_encode(HD::get_sticker($s_lock, false, array('img_x' => -3, 'img_y' => 3)));
				
				if (defined('ViewItemParams::item_detailed_info_sticker') === true)
					$view_item_params[ViewItemParams::item_detailed_info_sticker] = $s_lock;
			}
            $items[$n] = array(
                PluginRegularFolderItem::media_url => $mUrl,
                PluginRegularFolderItem::caption => $v['caption'],
                PluginRegularFolderItem::view_item_params => $view_item_params
            );
        }
		$diff1 = array_diff_key($fCat,$nbrCat);
		$diff2 = array_diff_key($nbrCat,$fCat);

		if ((!empty($diff1))||(!empty($diff2))){
			$fCat = array_flip($fCat);
			ksort($fCat);
			$fCat = array_values ($fCat);
			$nbrCategories[$parent_media_url] = array_flip($fCat);
			HD::saveItemsArr($class_name . 'NbrCategories', $nbrCategories);
		}
		ksort($items);
		$items = array_values ($items);
        return $items;
    }

    ///////////////////////////////////////////////////////////////////////

    private function get_folder_views(){
		$sandwich_cover = SmartConfig::getPluginIco('sandwich_cover');
		$sandwich_base = SmartConfig::getPluginIco('sandwich_base');
		$background_path = SmartConfig::getPluginIco(self::ID . '_bg');
		$paintBackground = (HD::getItemsArr('paintBackground') != array()) ? HD::getItemsArr('paintBackground') : array('paint_widget_background' => true, 'paint_content_box_background' => true, 'paint_path_box_background' => true, 'paint_details_box_background' => true);
		$paintSandwich = (HD::getItemStr('paintSandwich') != '') ? (bool)HD::getItemStr('paintSandwich') : true;
//==>
		$arr[0][PluginRegularFolderView::async_icon_loading] = true;
		
		$arr[0][PluginRegularFolderView::timer] = array(GuiTimerDef::delay_ms =>  1000);
		$arr[0][PluginRegularFolderView::view_params][ViewParams::num_cols] = 1;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::num_rows] = 10;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_details] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_item_info_in_details] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_auto_line_break] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_title_color] = 10;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_text_color] = 15;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_path] = $background_path;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_order] = 0;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_height] = 1080;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_width] = 1920;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_item_info_in_details] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_font_size] = (HD::getItemStr('detailedInfoFontSize') != '') ? HD::getItemStr('detailedInfoFontSize') : FONT_SIZE_SMALL;
		if (defined('ViewParams::paint_icon_badge_box') === true){
			$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_icon_badge_box] = true;
			$arr[0][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_height] = 50;
			$arr[0][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_width] = 50;
			$arr[0][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_dx] = -590;
            $arr[0][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_dy] = -25;
			$arr[0][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_sel_height] = 55;
			$arr[0][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_sel_width] = 55;
		}
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_widget_background] = $paintBackground['paint_widget_background'];
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_content_box_background] = $paintBackground['paint_content_box_background'];
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_path_box_background] = $paintBackground['paint_path_box_background'];
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_details_box_background] = $paintBackground['paint_details_box_background'];
		
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_valign] = VALIGN_CENTER;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_width] = 50;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_height] = 50;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_caption_within_icon] = false;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_caption] = true;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_caption_width] = 1100;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_layout] = HALIGN_LEFT;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_dx] = 15;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_scale_factor] = 1.1;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_margin_left] = 10;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_margin_bottom] = 5;

		$arr[0][PluginRegularFolderView::not_loaded_view_item_params] = array ();
//==>
//==>
		$arr[1][PluginRegularFolderView::async_icon_loading] = true;

		$arr[1][PluginRegularFolderView::timer] = array(GuiTimerDef::delay_ms =>  1000);
		$arr[1][PluginRegularFolderView::view_params][ViewParams::num_cols] =4;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::num_rows] = 3;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_details] = true;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_sandwich] = $paintSandwich;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_base] = $sandwich_base;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_mask] = 'cut_icon://{name=sandwich_mask}';
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_cover] = $sandwich_cover;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_width] = 160;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_height] = 160;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_icon_upscale_enabled] = true;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_icon_keep_aspect_ratio] = true;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_path] = $background_path;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_order] = 0;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_height] = 1080;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_width] = 1920;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::optimize_full_screen_background] = true;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_item_info_in_details] = true;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_auto_line_break] = true;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_title_color] = 10;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_text_color] = 15;
		if (defined('ViewParams::paint_icon_badge_box') === true){
			$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_icon_badge_box] = true;
			$arr[1][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_height] = 160;
			$arr[1][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_width] = 160;
			$arr[1][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_dx] = -80;
            $arr[1][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_dy] = -103;
			$arr[1][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_sel_height] = 165;
			$arr[1][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_sel_width] = 165;
		}
		$arr[1][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_font_size] = (HD::getItemStr('detailedInfoFontSize') != '') ? HD::getItemStr('detailedInfoFontSize') : FONT_SIZE_SMALL;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_widget_background] = $paintBackground['paint_widget_background'];
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_content_box_background] = $paintBackground['paint_content_box_background'];
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_path_box_background] = $paintBackground['paint_path_box_background'];
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_details_box_background] = $paintBackground['paint_details_box_background'];
		
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_layout] = HALIGN_CENTER;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_valign] = VALIGN_CENTER;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_caption] = true;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_scale_factor] = 1.0;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_scale_factor] = 1.1;
	
		$arr[1][PluginRegularFolderView::not_loaded_view_item_params] = array ();
//==>
//==>
		$arr[2][PluginRegularFolderView::async_icon_loading] = true;

		$arr[2][PluginRegularFolderView::timer] = array(GuiTimerDef::delay_ms =>  1000);
		$arr[2][PluginRegularFolderView::view_params][ViewParams::num_cols] = 6;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::num_rows] = 4;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_details] = true;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_sandwich] = $paintSandwich;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::sandwich_base] = $sandwich_base;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::sandwich_mask] = 'cut_icon://{name=sandwich_mask}';
		$arr[2][PluginRegularFolderView::view_params][ViewParams::sandwich_cover] = $sandwich_cover;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::sandwich_width] = 160;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::sandwich_height] = 160;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::sandwich_icon_upscale_enabled] = true;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::sandwich_icon_keep_aspect_ratio] = true;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::background_path] = $background_path;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::background_order] = 0;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::background_height] = 1080;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::background_width] = 1920;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::optimize_full_screen_background] = true;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_item_info_in_details] = true;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_auto_line_break] = true;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_title_color] = 10;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_text_color] = 15;
		if (defined('ViewParams::paint_icon_badge_box') === true){
			$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_icon_badge_box] = true;
			$arr[2][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_height] = 160;
			$arr[2][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_width] = 160;
			$arr[2][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_dx] = -80;
            $arr[2][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_dy] = -80;
			$arr[2][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_sel_height] = 165;
			$arr[2][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_sel_width] = 165;
		}
		$arr[2][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_font_size] = (HD::getItemStr('detailedInfoFontSize') != '') ? HD::getItemStr('detailedInfoFontSize') : FONT_SIZE_SMALL;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_widget_background] = $paintBackground['paint_widget_background'];
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_content_box_background] = $paintBackground['paint_content_box_background'];
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_path_box_background] = $paintBackground['paint_path_box_background'];
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_details_box_background] = $paintBackground['paint_details_box_background'];
		
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_layout] = HALIGN_CENTER;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_valign] = VALIGN_CENTER;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_caption] = false;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_scale_factor] = 1.0;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_scale_factor] = 1.1;

		$arr[2][PluginRegularFolderView::not_loaded_view_item_params] = array ();
//==>
		return $arr;
	}
}

///////////////////////////////////////////////////////////////////////////
?>
