<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/gcomps_screen.php';
require_once 'lib/control_factory.php';

abstract class AbstractGCompsScreen
    implements GCompsScreen
{
    private $id;

    ///////////////////////////////////////////////////////////////////////

    protected function __construct($id)
    {
        $this->id = $id;

        UserInputHandlerRegistry::get_instance()->
            register_handler($this);
    }

    ///////////////////////////////////////////////////////////////////////

    public function get_handler_id()
    { return 'gcomps_' . $this->id; }

    public function get_id()
    { return $this->id; }

    ///////////////////////////////////////////////////////////////////////

    public function get_timer(MediaURL $media_url, &$plugin_cookies)
    {
        return null;
    }

    public function get_state_properties(MediaURL $media_url, &$plugin_cookies)
    {
        return null;
    }

    public function invalidate()
    { }

    ///////////////////////////////////////////////////////////////////////

    public function get_folder_view(MediaURL $media_url, &$plugin_cookies)
    {
        $window_def = $this->get_window_def($media_url, $plugin_cookies);
        $actions = $this->get_action_map($media_url, $plugin_cookies);
        $timer = $this->get_timer($media_url, $plugin_cookies);
        $state_properties = $this->get_state_properties($media_url, $plugin_cookies);

        $folder_view = array
        (
            PluginGCompsFolderView::window_def => $window_def,
            PluginGCompsFolderView::actions => $actions,
            PluginGCompsFolderView::timer => $timer,
        );

        return array
        (
            PluginFolderView::multiple_views_supported  => false,
            // PluginFolderView::state_properties          => $state_properties,
            PluginFolderView::archive                   => null,
            PluginFolderView::view_kind                 => PLUGIN_FOLDER_VIEW_GCOMPS,
            PluginFolderView::data                      => $folder_view,
        );
    }
}

///////////////////////////////////////////////////////////////////////////
?>
