<?php
///////////////////////////////////////////////////////////////////////////
if (!class_exists('DuneSystem')){
	if (preg_match('|plugins/(.*?)/lib|', __DIR__, $matches)){
		$tmp_path = '/tmp/plugins/'.$matches[1];
		$plugin_name = $matches[1];
		$install_dir = str_replace('/lib/wox', '',  __DIR__);
		if (file_exists('/persistfs/plugins_data'))
			$data_dir = "/persistfs/plugins_data/$plugin_name";
		else
			$data_dir = "/flashdata/plugins_data/$plugin_name";
        $port = HD::http_local_port();
		$www_url = "http://127.0.0.1:$port/plugins/$plugin_name/";
		$cgi_url = "http://127.0.0.1:$port/cgi-bin/plugins/$plugin_name/";
	}

	function hd_print($str){
		echo $str;
	}
	class DuneSystem{
		public static $properties = array ();
	};
	DuneSystem::$properties['plugin_name']      = $plugin_name;
	DuneSystem::$properties['install_dir_path'] = $install_dir;
	DuneSystem::$properties['tmp_dir_path']     = $tmp_path;
	DuneSystem::$properties['plugin_www_url']   = $www_url;
	DuneSystem::$properties['plugin_cgi_url']   = $cgi_url;
	DuneSystem::$properties['data_dir_path']    = $data_dir;
}
class HD
{
    public static function is_map($a){
        return is_array($a) &&
            array_diff_key($a, array_keys(array_keys($a)));
    }

    ///////////////////////////////////////////////////////////////////////

    public static function has_attribute($obj, $n){
        $arr = (array) $obj;
        return isset($arr[$n]);
    }
    ///////////////////////////////////////////////////////////////////////

    public static function get_map_element($map, $key){
        return isset($map[$key]) ? $map[$key] : null;
    }

    ///////////////////////////////////////////////////////////////////////

    public static function starts_with($str, $pattern){
        return strpos($str, $pattern) === 0;
    }

    ///////////////////////////////////////////////////////////////////////

    public static function format_timestamp($ts, $fmt = null){
        // NOTE: for some reason, explicit timezone is required for PHP
        // on Dune (no builtin timezone info?).
		
        if (is_null($fmt))
            $fmt = 'Y:m:d H:i:s';

        $dt = new DateTime('@' . $ts);
        return $dt->format($fmt);
    }

    ///////////////////////////////////////////////////////////////////////

    public static function format_duration($msecs){
        $n = intval($msecs);

        if (strlen($msecs) <= 0 || $n <= 0)
            return "--:--";

        $n = $n / 1000;
        $hours = $n / 3600;
        $remainder = $n % 3600;
        $minutes = $remainder / 60;
        $seconds = $remainder % 60;

        if (intval($hours) > 0){
            return sprintf("%d:%02d:%02d", $hours, $minutes, $seconds);
        }
        else
        {
            return sprintf("%02d:%02d", $minutes, $seconds);
        }
    }

    ///////////////////////////////////////////////////////////////////////

    public static function encode_user_data($a, $b = null){
        $media_url = null;
        $user_data = null;

        if (is_array($a) && is_null($b)){
            $media_url = '';
            $user_data = $a;
        }
        else
        {
            $media_url = $a;
            $user_data = $b;
        }

        if (!is_null($user_data))
            $media_url .= '||' . json_encode($user_data);

        return $media_url;
    }

    ///////////////////////////////////////////////////////////////////////

    public static function decode_user_data($media_url_str, &$media_url, &$user_data){
        $idx = strpos($media_url_str, '||');

        if ($idx === false){
            $media_url = $media_url_str;
            $user_data = null;
            return;
        }

        $media_url = substr($media_url_str, 0, $idx);
        $user_data = json_decode(substr($media_url_str, $idx + 2));
    }

    ///////////////////////////////////////////////////////////////////////

    public static function create_regular_folder_range($items,
        $from_ndx = 0, $total = -1, $more_items_available = false){
        if ($total === -1)
            $total = $from_ndx + count($items);

        if ($from_ndx >= $total){
            $from_ndx = $total;
            $items = array();
        }
        else if ($from_ndx + count($items) > $total){
            array_splice($items, $total - $from_ndx);
        }

        return array
        (
            PluginRegularFolderRange::total => intval($total),
            PluginRegularFolderRange::more_items_available => $more_items_available,
            PluginRegularFolderRange::from_ndx => intval($from_ndx),
            PluginRegularFolderRange::count => count($items),
            PluginRegularFolderRange::items => $items
        );
    }

    ///////////////////////////////////////////////////////////////////////

    public static function http_get_document($url, $opts = null){
        $ch = curl_init();
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 	0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 	0);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT,    30);
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 	true);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER,    true);
        curl_setopt($ch, CURLOPT_TIMEOUT,           30);
        curl_setopt($ch, CURLOPT_USERAGENT,         'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/80.0.3987.122 Safari/537.36');
        curl_setopt($ch, CURLOPT_URL,               $url);
		curl_setopt($ch, CURLOPT_ENCODING,          'gzip,deflate');
        if (isset($opts)){
            foreach ($opts as $k => $v){
				if ($k == 'getHttpCode')
					$getHttpCode = true;
				else if ($k == 'hideUrl')
					$hideUrl = true;
				else if ($k == 'silent')
					$silent = true;
				else{
					
					curl_setopt($ch, $k, $v);
				}
			}
        }
		if (!isset($silent)){
			if (isset($opts[CURLOPT_PROXY]))
				if (!isset($silent))
					echo 'Use Proxy';
			if (isset($opts[CURLOPT_PROXYTYPE]))
				if (!isset($silent))
					echo 'Use Proxy: SOCKS5';
			if (isset($opts[CURLOPT_PROXYUSERPWD]))
				if (!isset($silent))
					echo 'Use Proxy: PROXYUSERPWD';
			if (isset($hideUrl)){
				if (!isset($silent))
					echo("HTTP fetching 'url'...");
			}else if (!isset($silent))
				echo("\nHTTP fetching '$url'...");
		}
        $content = curl_exec($ch);
        $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);

        if($content === false){
            $err_msg['Error:'] = "HTTP error $http_code (" . curl_error($ch) . ')';
			if (!isset($silent))
				echo($err_msg['Error:']);
        }
        if ($http_code != 200){
            $err_msg['Request:'] = "HTTP request failed ($http_code): " . self::http_status_code_to_string($http_code);
			if (!isset($silent))
				echo($err_msg['Request:']);
        }
        curl_close($ch);
		if ((!isset($err_msg))&&(!isset($silent)))
			echo("HTTP OK ($http_code)");
		if (isset($getHttpCode)){
			$err_msg['httpCode'] = $http_code;
			return $err_msg;
		}
        return $content;
    }
	public static function http_status_code_to_string($code){
        // Source: http://en.wikipedia.org/wiki/List_of_HTTP_status_codes

        switch( $code ){
            // 1xx Informational
            case 100: $string = 'Continue'; break;
            case 101: $string = 'Switching Protocols'; break;
            case 102: $string = 'Processing'; break; // WebDAV
            case 122: $string = 'Request-URI too long'; break; // Microsoft

            // 2xx Success
            case 200: $string = 'OK'; break;
            case 201: $string = 'Created'; break;
            case 202: $string = 'Accepted'; break;
            case 203: $string = 'Non-Authoritative Information'; break; // HTTP/1.1
            case 204: $string = 'No Content'; break;
            case 205: $string = 'Reset Content'; break;
            case 206: $string = 'Partial Content'; break;
            case 207: $string = 'Multi-Status'; break; // WebDAV

            // 3xx Redirection
            case 300: $string = 'Multiple Choices'; break;
            case 301: $string = 'Moved Permanently'; break;
            case 302: $string = 'Found'; break;
            case 303: $string = 'See Other'; break; //HTTP/1.1
            case 304: $string = 'Not Modified'; break;
            case 305: $string = 'Use Proxy'; break; // HTTP/1.1
            case 306: $string = 'Switch Proxy'; break; // Depreciated
            case 307: $string = 'Temporary Redirect'; break; // HTTP/1.1

            // 4xx Client Error
            case 400: $string = 'Bad Request'; break;
            case 401: $string = 'Unauthorized'; break;
            case 402: $string = 'Payment Required'; break;
            case 403: $string = 'Forbidden'; break;
            case 404: $string = 'Not Found'; break;
            case 405: $string = 'Method Not Allowed'; break;
            case 406: $string = 'Not Acceptable'; break;
            case 407: $string = 'Proxy Authentication Required'; break;
            case 408: $string = 'Request Timeout'; break;
            case 409: $string = 'Conflict'; break;
            case 410: $string = 'Gone'; break;
            case 411: $string = 'Length Required'; break;
            case 412: $string = 'Precondition Failed'; break;
            case 413: $string = 'Request Entity Too Large'; break;
            case 414: $string = 'Request-URI Too Long'; break;
            case 415: $string = 'Unsupported Media Type'; break;
            case 416: $string = 'Requested Range Not Satisfiable'; break;
            case 417: $string = 'Expectation Failed'; break;
            case 422: $string = 'Unprocessable Entity'; break; // WebDAV
            case 423: $string = 'Locked'; break; // WebDAV
            case 424: $string = 'Failed Dependency'; break; // WebDAV
            case 425: $string = 'Unordered Collection'; break; // WebDAV
            case 426: $string = 'Upgrade Required'; break;
			case 429: $string = 'Too Many Requests'; break;
            case 449: $string = 'Retry With'; break; // Microsoft
            case 450: $string = 'Blocked'; break; // Microsoft

            // 5xx Server Error
            case 500: $string = 'Internal Server Error'; break;
            case 501: $string = 'Not Implemented'; break;
            case 502: $string = 'Bad Gateway'; break;
            case 503: $string = 'Service Unavailable'; break;
            case 504: $string = 'Gateway Timeout'; break;
            case 505: $string = 'HTTP Version Not Supported'; break;
            case 506: $string = 'Variant Also Negotiates'; break;
            case 507: $string = 'Insufficient Storage'; break; // WebDAV
            case 509: $string = 'Bandwidth Limit Exceeded'; break; // Apache
            case 510: $string = 'Not Extended'; break;

            // Unknown code:
            default: $string = 'Unknown'; break;
        }
        return $string;
    }
    ///////////////////////////////////////////////////////////////////////

    public static function http_post_document($url, $post_data){
        return self::http_get_document($url,
            array
            (
                CURLOPT_POST => true,
                CURLOPT_POSTFIELDS => $post_data
            ));
    }

    ///////////////////////////////////////////////////////////////////////

    public static function parse_xml_document($doc){
        $xml = simplexml_load_string($doc);

        if ($xml === false){
            hd_print("Error: can not parse XML document.");
            hd_print("XML-text: $doc.");
            throw new Exception('Illegal XML document');
        }

        return $xml;
    }

    ///////////////////////////////////////////////////////////////////////

    public static function make_json_rpc_request($op_name, $params){
        static $request_id = 0;
        $request = array(
            'jsonrpc' => '2.0',
            'id' => ++$request_id,
            'method' => $op_name,
            'params' => $params
        );
        return $request;
    }

    ///////////////////////////////////////////////////////////////////////////

    public static function get_mac_addr(){
		# return string
		if (file_exists('/tmp/hw.def'))
			$result = file_get_contents('/tmp/hw.def');

		if (empty($result))
			$result = file_get_contents('/sys/class/net/eth0/address');
		
		return strtoupper(trim($result));
	}

    ///////////////////////////////////////////////////////////////////////////
	public static function eney($string, $str=null) {
		$yne = '24bbf7520df55afa88a18ff3e61e326f';
		if ($str == true){
			$result = '';
			$str = base64_decode($str);
			for($i = 0; $i < strlen($str); $i++) {
				$char = substr($str, $i, 1);
				$keychar = substr($yne, ($i % strlen($yne))-1, 1);
				$char = chr(ord($char) - ord($keychar));
				$result .= $char;
			}
			return $result;
		}
		$result = '';
		for($i = 0; $i < strlen($string); $i++) {
			$char = substr($string, $i, 1);
			$keychar = substr($yne, ($i % strlen($yne))-1, 1);
			$char = chr(ord($char) + ord($keychar));
			$result .= $char;
		}
		return base64_encode($result);
	}
    // TODO: localization
    private static $MONTHS = array(
        'January',
        'February',
        'March',
        'April',
        'May',
        'June',
        'July',
        'August',
        'September',
        'October',
        'November',
        'December',
    );
	public static function date_time(){
		$ini_array = parse_ini_file("/config/settings.properties");
        return ($ini_array['time_zone'] * -3600);
    }
	public static function localtime_TZ($tm){
        $time_str = exec("date +'%S|%M|%H|%d|%m|%Y|%w|%j' -d @$tm");
        $result = explode('|', $time_str);
        $result[4] -= 1;
        $result[5] -= 1900;
        $result[7] -= 1;
        $result[8] = 0;
        return $result;
    }
	private static function get_timezone_diff(){
        if (!is_file('/etc/TZ'))
            return 0;

        $timezone = trim(file_get_contents('/etc/TZ'));
        $time_part = substr($timezone, 3);
        if ($time_part == "")
            return 0;

        $is_negative = false;
        if ($time_part[0] == '-') {
            $is_negative = true;
            $time_part = substr($time_part, 1);
        } else if ($time_part[0] == '+') {
            $time_part = substr($time_part, 1);
        }

        $hour_part = '';
        $min_part = '';
        $pos = strpos($time_part, ':');
        if ($pos !== false) {
            $hour_part = substr($time_part, 0, $pos);
            $min_part = substr($time_part, $pos + 1);
        } else {
            $hour_part = $time_part;
        }

        $tz_diff = $hour_part * 60 + $min_part;
        $tz_diff *= 60;
        if (!$is_negative)
            $tz_diff = -$tz_diff;

        //hd_print("Timezone: $timezone, tz_diff: $tz_diff, time_part: $time_part");
        return $tz_diff;
    }
	public static function MY_localtime($tm, $use_tz){
        $timezone_diff = 0;
        if ($use_tz)
        {
            if (!is_file('/etc/TZ'))
            {
                // TODO: find out and implement more effective approach
                return self::localtime_TZ($tm);
            }
            $timezone_diff = self::get_timezone_diff();
        }

        return localtime($tm + $timezone_diff);
    }
	
    public static function format_date_time_date($tm, $use_tz = false){
        $lt = self::MY_localtime($tm, $use_tz);
        $mon = self::$MONTHS[$lt[4]];
        return sprintf("%02d %s %04d", $lt[3], $mon, $lt[5] + 1900);
    }

    private static function get_month_key($n){
        return "formatting_month_$n";
    }

    public static function format_date_time_date_ext($tm, $use_tz = false){
        $lt = self::MY_localtime($tm, $use_tz);
        $mon_key = self::get_month_key($lt[4]);
        return sprintf("%02d <key_global>%s</key_global> %04d",
            $lt[3], $mon_key, $lt[5] + 1900);
    }

    public static function format_date_time_time($tm, $with_sec = false, $use_tz = false){
        $lt = self::MY_localtime($tm, $use_tz);
        $str = sprintf("%02d:%02d", $lt[2], $lt[1]);
        if ($with_sec)
            $str .= sprintf(":%02d", $lt[0]);
        return $str;
    }

    public static function print_backtrace(){
        hd_print('Back trace:');
        foreach (debug_backtrace() as $f){
            hd_print(
                '  - ' . $f['function'] . 
                ' at ' . $f['file'] . ':' . $f['line']);
        }
    }
    
	public static function get_ip_address(){
        static $ip_address = null;
        if (is_null($ip_address)){
hd_print("EEE: get_ip_address()");
            if (!preg_match_all('/Link encap:Ethernet.*?inet addr: ?([^ ]+)/ms', `ifconfig`, $ips))
                preg_match_all('/eth0.*?Link encap:.*?inet addr: ?([^ ]+)/ms', `ifconfig`, $ips);
			if ($ips[1][0]!= '127.0.0.1')
				$ip_address = $ips[1][0];
			else if ($ips[1][1]!= '127.0.0.1')
				$ip_address = $ips[1][1];
        }
hd_print("EEE: get_ip_address(): $ip_address");
        return $ip_address;
    }
	public static function isDomainAvailible($domain, $timeout=null){
		if ($timeout==false)
			$timeout=1;
		$curlInit = curl_init($domain);
		curl_setopt($curlInit,CURLOPT_CONNECTTIMEOUT,$timeout);
		if (!preg_match('|/echo$|', $domain)){
			curl_setopt($curlInit,CURLOPT_HEADER,true);
			curl_setopt($curlInit,CURLOPT_NOBODY,true);
		}
		curl_setopt($curlInit,CURLOPT_RETURNTRANSFER,true);
		$response = curl_exec($curlInit);
		curl_close($curlInit);
		if ((preg_match('|/echo$|', $domain))&&($response))
			return $response;
		if ($response){
			if (!preg_match('/404/', $response))
				return true;
		}
		return false;
	}
	public static function isServerAvailable ($ip=null, $port=null){
hd_print("EEE isServerAvailable() ip='$ip', port='$port'");
		if ($ip == true){
			$ip = str_replace(array('https://', 'http://'), '', $ip);
			if ($port == true)
				$hosts[] = "$ip:$port";
			else
				$hosts[] = $ip;
		}else if (($port == true)&&(preg_match("/(\d{1,3}\.\d{1,3}\.\d{1,3})\.\d{1,3}$/", self::get_ip_address(), $match))) {
hd_print("EEE isServerAvailable ip prefix: ".$match[1]);
			for ($i = 1; $i<255; $i++)
                $hosts[] = $match[1] . ".$i:$port";
        }
		else
			return false;
		$timeout = 1;
		$trueArr = $status = $sockets = array();
		foreach ($hosts as $id => $host) {
			$s = @stream_socket_client ($host, $errno, $errstr, $timeout, STREAM_CLIENT_ASYNC_CONNECT|STREAM_CLIENT_CONNECT);
			if($s)
				$sockets[$id] = $s;
		}
		while (count($sockets)) {
			$read = $write = $sockets;
			hd_silence_warnings();
			$n = stream_select ($read, $write, $e = null, $timeout);
			hd_restore_warnings();
			if ($n > 0) {
				foreach ($read as $r) {
					$id = array_search($r, $sockets);
					$data = fread($r, 8192);
					if (strlen($data) == 0) {
						fclose($r);
						unset ($sockets[$id]);
					}else 
						$status[$id] = 1;
				}
				foreach ($write as $w) {
					$id = array_search($w, $sockets);
					hd_silence_warnings();
					@fwrite ($w, "HEAD / HTTP/1.0\r\nHost: " . $hosts[$id] . "\r\n\r\n");
					hd_restore_warnings();
				}
			}else
				break;
		}
		if (count($status) > 0)
			foreach ($status as $k => $v)
            {
				$trueArr [$hosts[$k]]= $hosts[$k];
hd_print("EEE isServerAvailable available at: " . $hosts[$k]);
            }
		if ($ip== true){
			if ($port == true){
				if(isset($trueArr ["$ip:$port"]))
					return true;
				else
					return false;
			}else{
				if(isset($trueArr [$ip]))
					return true;
				else
					return false;
			}
		}
		return $trueArr;
	}
	//////////////////////////////////////////////////////////////////
	public static function get_data_path($reset=null) {
		static $link = null;
		if ($reset== true)
			$link = null;
		if (is_null($link))	{
			$link = DuneSystem::$properties['data_dir_path'];
			if (file_exists($link . '/data_dir_path'))
				$link = smbtree::get_folder_info ('data_dir_path');
		}
		return $link;
	}
	/////////////////////////////////////////////////////////////////
	public static function getItemsArr($path, $macAdr=null) {
		$items = array();
		if ($macAdr==true)
			$path .= '_' . str_replace(":", "", self::get_mac_addr());
		if ($path=='data_dir_path')
			$link = DuneSystem::$properties['data_dir_path'] . '/'. $path;
		else
			$link = self::get_data_path() . '/'. $path;
		if (file_exists($link))
			$items = unserialize(file_get_contents($link));
		return $items;
	}
	public static function saveItemsArr($path, $items, $macAdr=null){
		if ($macAdr==true)
			$path .= '_' . str_replace(":", "", self::get_mac_addr());
		if ($path=='data_dir_path')
			$link = DuneSystem::$properties['data_dir_path'] . '/'. $path;
		else
			$link = self::get_data_path() . '/'. $path;
		if (file_put_contents ($link, serialize($items)) !== false)
			return true;
		else
			return false;
	}
	public static function saveItemStr($path, $item, $macAdr=null) {
		if ($macAdr == true)
			$path .= '_' . str_replace(":", "", self::get_mac_addr());
		$link = self::get_data_path() . "/$path";
		if (file_put_contents ($link, $item) !== false)
			return true;
		else
			return false;
	}
	public static function getItemStr($path, $macAdr=null) {
		$item = '';
		if ($macAdr == true)
			$path .= '_' . str_replace(":", "", self::get_mac_addr());
		$link = self::get_data_path() . "/$path";
		if (file_exists($link))
			$item = file_get_contents($link);
		return $item;
	}
	public static function get_item($path, $macAdr=null) {
		return self::getItemStr($path, $macAdr=null);
	}
	public static function saveItemTmpStr($path, $item) {
		$link = DuneSystem::$properties['tmp_dir_path'] . "/$path";
		if (file_put_contents ($link, $item) !== false)
			return true;
		else
			return false;
	}
	public static function getItemTmpStr($path) {
		$item = '';
		$link = DuneSystem::$properties['tmp_dir_path'] . "/$path";
		if (file_exists($link))
			$item = file_get_contents($link);
		return $item;
	}
	public static function getItemsTmpArr($path, $macAdr=null) {
		$items = array();
		if ($macAdr==true)
			$path .= '_' . str_replace(":", "", self::get_mac_addr());
		$link = DuneSystem::$properties['tmp_dir_path'] . "/$path";
		if (file_exists($link))
			$items = unserialize(file_get_contents($link));
		return $items;
	}
	public static function saveItemsTmpArr($path, $items, $macAdr=null){
		if ($macAdr==true)
			$path .= '_' . str_replace(":", "", self::get_mac_addr());
		$link = DuneSystem::$properties['tmp_dir_path'] . "/$path";
		if (file_put_contents ($link, serialize($items)) !== false)
			return true;
		else
			return false;
	}
	/////////////////////////////////////////////////////////
	public static function is_android(){
        return is_file("/system/dunehd/init");
    }
    public static function is_apk(){
        return (bool) getenv("HD_APK");
    }
    public static function http_local_port(){
        $port = getenv("HD_HTTP_LOCAL_PORT");
        return $port ? (int) $port : 80;
    }
	public static function get_platform_kind(){
		static $platform_kind = null;
		if (is_null($platform_kind)){
            if (getenv("HD_APK")) {
                $platform_kind = 'apk';
            } else {
                $ini_arr = parse_ini_file('/tmp/run/versions.txt');
                if (preg_match('|87\d\d|', $ini_arr['platform_kind']))
                    $platform_kind = '87xx';
                if (preg_match('|864\d|', $ini_arr['platform_kind']))
                    $platform_kind = '864x';
                if (preg_match('|867\d|', $ini_arr['platform_kind']))
                    $platform_kind = '867x';
                if (preg_match('|865\d|', $ini_arr['platform_kind']))
                    $platform_kind = '865x';
                if (preg_match('|android|', $ini_arr['platform_kind']))
                    $platform_kind = 'android';
            }
		}
		return $platform_kind;
	}
	public static function do_cmd($exec, $exec_str=null){
		$exec_file = DuneSystem::$properties['install_dir_path'] . "/www/cgi-bin/$exec.php";
		static $stdout = null;
		static $oldExec = null;
		$rb = false;
		if ($oldExec != $exec_str){
			if (preg_match('|action=(.*?)\s|', $exec_str, $m))
				self::saveItemTmpStr("/exec_result_" . trim($m[1]), '');
			if ($stdout == true){
				pclose($stdout);
				$stdout = null;
			}
			$rb = 1;
		}
		$output = '';
		if (!file_exists($exec_file)){
			echo 'err!' . $exec_file;
		}
		if ($stdout == true){
			if (preg_match('|action=(.*?)\s|', $exec_str, $m)){
				$output = self::getItemTmpStr('exec_result_' . trim($m[1]));
			}else
				while (!feof($stdout)) {
					$output.= fgets($stdout);
				}
			pclose($stdout);
		}
		// echo DuneSystem::$properties['install_dir_path'] . '/www/cgi-bin/php-cgi -f ' .  "$exec_file $exec_str";
		$stdout = popen(DuneSystem::$properties['install_dir_path'] . '/www/cgi-bin/php-cgi -f ' .  "$exec_file $exec_str", 'r');
		$oldExec = $exec_str;
		if ($rb == true){
			usleep (400000);
			return '';
		}
		return trim($output);
	}
	
	public static function asyncExec($cmd){
		static $process = null;
		static $return_value = null;
		static $pipes = null;
		static $oldСmd = null;
		if (is_resource($process)){
			$meta_info = proc_get_status($process);
			if ($oldСmd != $cmd){
				$return_value = null;
				fclose($pipes[1]);
				proc_close($process);
				$process = null;
				if ($cmd == 'proc_close')
					return false;
			}else if ($meta_info['running'] != 1){
				
				if (preg_match('|action=(.*?)\s|', $cmd, $m)){
					echo stream_get_contents($pipes[1]);
					$return_value = self::getItemTmpStr('exec_result_' . trim($m[1]));
				}else
					$return_value = stream_get_contents($pipes[1]);
				fclose($pipes[1]);
				proc_close($process);
				$process = null;
			}
		}else{
			if ($cmd == 'proc_close'){
				$return_value = null;
				return false;
			}
			$descriptorspec = array(
				0 => array("pipe", "r"),
				1 => array("pipe", "w"),
				2 => array("file", DuneSystem::$properties['tmp_dir_path'] . "/error-proc_open.txt", "a")
			);
			$process = proc_open($cmd, $descriptorspec, $pipes);
			$oldСmd = $cmd;
		}
		return trim($return_value);
	}
	public static function bigSum($bigNumFirst, $bigNumSecond){
		$sumBigNum = "";
		if (empty($bigNumFirst) || empty($bigNumSecond)) {
			return $bigNumFirst . $bigNumSecond;
		}
		$indexFirstNumber = strlen($bigNumFirst) - 1;
		$indexSecondNumber = strlen($bigNumSecond) - 1;
		$indexSum = $transferNum = 0;

		while ($indexFirstNumber >= 0 || $indexSecondNumber >= 0) {
			if ($indexFirstNumber < 0) {
				$sumTemp = (int)($bigNumSecond[$indexSecondNumber] + $transferNum);
			} elseif ($indexSecondNumber < 0) {
				$sumTemp = (int)($bigNumFirst[$indexFirstNumber] + $transferNum);
			} else {
				$sumTemp = (int)($bigNumFirst[$indexFirstNumber] + $bigNumSecond[$indexSecondNumber] + $transferNum);
			}

			if ($sumTemp >= 10) {
				$transferNum = 1;
				$sumTemp = $sumTemp - 10;
			} else {
				$transferNum = 0;
			}
			$sumBigNum[$indexSum] = $sumTemp;
			$indexFirstNumber--;
			$indexSecondNumber--;
			$indexSum++;
		}
		$sumBigNum = implode('',$sumBigNum);
		return strrev($sumBigNum);
	}
	public static function readableBytes($bytes, $bytesEnd=null, $time=null) {
		if ($bytesEnd== true)
			$bytes = ($bytes - $bytesEnd) / $time;
		if (intval($bytes) == 0)
			return '0 B';
		$bytes = floatval($bytes);
		$i = floor(log($bytes) / log(1024));
		$sizes = array('B', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB');
		return sprintf('%.02F', $bytes / pow(1024, $i)) * 1 . ' ' . $sizes[$i];
	}
	public static function sec_format_duration($secs, $r=null, $s=false){
        $n = intval($secs);

        if (strlen($secs) <= 0 || $n <= 0)
            return "--:--";

        $hours = $n / 3600;
        $remainder = $n % 3600;
        $minutes = $remainder / 60;
        $seconds = $remainder % 60;
		if ($r==false){
			if (intval($hours) > 0){
				if ($s == true)
					return sprintf("%d:%02d", $hours, $minutes);
				else
					return sprintf("%d:%02d:%02d", $hours, $minutes, $seconds);
			}else{
				if ($s == true)
					return sprintf("0:%02d", $minutes);
				else
					return sprintf("%02d:%02d", $minutes, $seconds);
			}
		}else{
			if (intval($hours) > 0){
				if ($s == true)
					return sprintf("%d hr. %02d min. ", $hours, $minutes);
				else
					return sprintf("%d hr. %02d min. %02d sec.", $hours, $minutes, $seconds);
			}else{
				if ($s == true)
					return sprintf("%02d min. ", $minutes);
				else
					return sprintf("%02d min. %02d sec.", $minutes, $seconds);
			}
		}
    }
	
	public static function get_filesize_str($size, $s=null){
		if($size < 1024){
			$size_num = $size;
			$size_suf = "B";
		}else if($size < 1048576){
			$size_num = round($size / 1024, 2);
			$size_suf = "kB";
		}else if($size < 1073741824){
			$size_num = round($size / 1048576, 2);
			$size_suf = "MB";
		}else{
			$size_num = round($size / 1073741824, 2);
			$size_suf = "GB";
		}
		if ($s== true)
			$size_suf .= "/s";
		return "$size_num $size_suf";
    }
	
	public static function get_android_action($arg = null, $action = null, $post_action = null){
		if ($action == false){
			if (preg_match('/jpg|png/i', $arg))
				$action = 'image';
			else if (preg_match('/\.torrent$/i', $arg))
				$action = 'torrent';
			else if (preg_match('/^magnet:\?xt=/i', $arg))
				$action = 'magnet';
			else if (preg_match('/\.m3u$/i', $arg))
				$action = 'm3u';
			else
				$action = 'video';
		}
			
		if ($action == 'video')
			exec ('am start -d "'.$arg.'" -t "video/*" -a android.intent.action.VIEW 2>&1');
		if ($action == 'm3u')
			exec ('am start -d "'.$arg.'" -t "audio/x-mpegurl" -a android.intent.action.VIEW 2>&1');
		if ($action == 'torrent'){
			if (preg_match('#(magnet:\?xt=urn:btih:.*?)\&#', $arg, $m))
				exec ('am start -D "'.$m[1].'" -t "application/x-bittorrent" -a android.intent.action.VIEW 2>&1');
			exec ('am start -d "'.$arg.'" -t "application/x-bittorrent" -a android.intent.action.VIEW 2>&1');
		}
		if ($action == 'magnet'){
			if (preg_match('#(magnet:\?xt=urn:btih:.*?)\&#', $arg, $m))
				$arg = $m[1];
			exec ('am start -D "'.$arg.'" -t "application/x-bittorrent" -a android.intent.action.VIEW 2>&1');
		}
		if ($action == 'image')
			exec ('am start -d "'.$arg.'" -t "image/*" -a android.intent.action.VIEW 2>&1');
		if ($post_action == true)
			return $post_action;
	}
	public static function getAndroidTime ($format){
		$airDate = exec('date');
		$date = new DateTime($airDate);
		if ($format =='timestamp')
			return strtotime($date->format('Y-m-d H:i:s'));
		return $date->format($format);
	}
	public static function getCurrentTime($format){
		if (self::is_android() == true)
			return self::getAndroidTime ($format);
		$unixTime = time() + HD::get_local_time_zone_offset();
		$strTime = strftime("%b %d %Y %H:%M:%S", $unixTime);
		$date = new DateTime($strTime);
		return $date->format($format);
	}
	public static function getUnixTimestamp (){
		if (self::is_android() == true)
			return self::getAndroidTime ('timestamp');
		return time();
	}
	//////////////// Автор (Author): Brigadir (forum.hdtv.ru)
	public static function get_local_time_zone_offset() {
		$local_tz = self::get_local_time_zone();
		if ($local_tz <> '') {
			$sign = 1;
			$sign_ch = substr($local_tz, 0, 1);
			if ($sign_ch == '-') {
				$sign = -1;
			} else if ($sign_ch == '+') {
				$sign = +1;
			} else return '';

			$tz_hh = intval(substr($local_tz, 1, 2));
			$tz_mm = intval(substr($local_tz, 3, 2));

			return $sign * ($tz_hh * 60 + $tz_mm) * 60;

		} else return 0;
	}
	public static function get_local_time_zone() {
		exec('TZ=`cat /etc/TZ` date +%z', $out, $rc);
		return (($rc != 0) || (count($out) != 1))? '' : $out[0];
	}
	
	public static function actionCrontabs ($cronStr = null){
		$cron_file = '/tmp/cron/crontabs/root';
		if ($cronStr==false){
			$cronArr = array();
			if (file_exists($cron_file))
				$cronArr = file($cron_file, FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
			return $cronArr;
		}
		if (self::is_android() == true){
			if (!file_exists($cron_file))
				exec("mkdir -p /tmp/cron/crontabs");
			exec("/system/dunehd/dunehd_service do \"touch $cron_file\"");
			exec("echo '$cronStr' > $cron_file");
			if (exec('pgrep -l crond') == true)
				exec('/system/dunehd/dunehd_service do "killall crond"');
			exec('/system/dunehd/dunehd_service do "crond -b -c /tmp/cron/crontabs"');
		}else{
			file_put_contents($cron_file, $cronStr);
			chmod($cron_file, 0575);
			shell_exec('crontab -e');
		}
	}
	
	public static function timeInfoShowRend($timeInfoShowRendSettings, $actions, $post_action=null){
		$currentTime = self::getCurrentTime('H:i');

		$comps = array();
		$position = isset($timeInfoShowRendSettings['position']) ? $timeInfoShowRendSettings['position'] : 0;
		$g = 1640; $v = 910;
		if ($position == 0)
			$g = $v = 0;
		if ($position == 1)
			$g = 0;
		if ($position == 2)
			$v = 0;
		$t1 = 70 + $g;
		$t2 = 50 + $v;
		$halo = isset($timeInfoShowRendSettings['halo']) ? $timeInfoShowRendSettings['halo'] : 0;
		$color = isset($timeInfoShowRendSettings['color']) ? $timeInfoShowRendSettings['color'] : 14;
		$background = isset($timeInfoShowRendSettings['background']) ? $timeInfoShowRendSettings['background'] : 0;
		$pluginFont = isset($timeInfoShowRendSettings['pluginFont']) ? $timeInfoShowRendSettings['pluginFont'] : 'normal';
		$showPrsntTime = isset($timeInfoShowRendSettings['showPrsntTime']) ? $timeInfoShowRendSettings['showPrsntTime'] : 0;
		$prsnt = isset($timeInfoShowRendSettings['prsnt']) ? $timeInfoShowRendSettings['prsnt'] : 0;
		$remainingTime = isset($timeInfoShowRendSettings['remainingTime']) ? $timeInfoShowRendSettings['remainingTime'] : 0;
		$b = $c = 5;
		if ($pluginFont == 'normal')
			$pluginFont = PLUGIN_FONT_NORMAL;
		else{
			$pluginFont = PLUGIN_FONT_SMALL;
			$c = 17;
		}
		if ($background == 1){
			if ($showPrsntTime != 0)
				$b = 25 - $c;
			ActionFactory::add_osd_image($comps, DuneSystem::$properties['install_dir_path'] . '/icons/centr2.png', $t1 - 10, $t2, 140, 70 + $b);
		}
		ActionFactory::add_osd_text($comps, $currentTime, $t1 + $c, $t2, $pluginFont, $color, (bool)$halo);
		if ($showPrsntTime == 1){
			ActionFactory::add_osd_text($comps, "$prsnt%", $t1 + 30, $t2 + 60 - $c, PLUGIN_FONT_SMALL, $color, (bool)$halo);
			$b = 25 - $c;
		}
		if ($showPrsntTime == 2){
			$c1 = 0;
			$l = strlen($remainingTime);
			if ($l < 6)
				$c1 = 18;
			ActionFactory::add_osd_text($comps, '-' . $remainingTime, $t1 + $c1, $t2 + 60 - $c, PLUGIN_FONT_SMALL, $color, (bool)$halo);
			$b = 25 - $c;
		}
		
		ActionFactory::add_osd_text($comps, $currentTime, $t1 + $c, $t2, $pluginFont, $color, (bool)$halo);
		$v = 120 * ($prsnt / 100);
		ActionFactory::add_osd_image($comps, DuneSystem::$properties['install_dir_path'] . '/icons/selection_top.aai', $t1, $t2 + 50 - $c, $v, 15);//'gui_skin://cut_images/selection/selection_top.aai'
		ActionFactory::add_osd_image($comps, DuneSystem::$properties['install_dir_path'] . '/icons/selection_dimmed_top.aai', $t1 + $v, $t2 + 50 - $c, 120 - $v, 15);//'gui_skin://cut_images/selection_dimmed/selection_dimmed_top.aai'
		return ActionFactory::update_osd($comps, ActionFactory::change_behaviour($actions, 1000, $post_action));
    }
	
	public static function plugin_version(){
		$xml = simplexml_load_file(DuneSystem::$properties['install_dir_path'].'/dune_plugin.xml');
		return strval($xml->version);
	}
	
	public static function get_storage_size($path, $arg=null){
		$d[0] = disk_free_space($path);
		$d[1] = disk_total_space($path);
		foreach ($d as $bytes){
			$si_prefix = array( 'B', 'KB', 'MB', 'GB', 'TB', 'EB', 'ZB', 'YB' );
			$base = 1024;
			$class = min((int)log($bytes , $base) , count($si_prefix) - 1);
			$size[] = sprintf('%1.2f' , $bytes / pow($base,$class)) . ' ' . $si_prefix[$class];
		}
		if ($arg==true){
			$arr['str'] = $size[0] . '/' . $size[1];
			if ($arg < $d[0])
				$arr['free_space'] = true;
			else
				$arr['free_space'] = false;
			return $arr;
		}
		return $size[0] . '/' . $size[1];
    }
	
	public static function get_storage_list(){
        $storages = array();
        $path = '/tmp/run/storage_list.xml';
		if (!file_exists($path))
			return;
        $xml = simplexml_load_file($path);
        if (!isset($xml->storages)) {
            hd_print("Warning: root element not 'storages' in $path.");
            return;
        }
        foreach ($xml->storages->children() as $storage){
            $elt_name = $storage->getName();
            if ($elt_name != 'storage')
                continue;
			if ($storage->fs_type == ''){
				exec('mount' ,$arr);
				foreach($arr as $v)
					if (preg_match('|on ' . $storage->mount_path . ' type (.*?) |', $v, $m))
						$storage->fs_type = $m[1];
			}
            if (intval($storage->is_persistfs_capable) == 1)
                continue;
            if (!isset($storage->name))
                continue;
            $arr = array(
                'id' => strval($storage->id),
                'kind' => strval($storage->kind),
                'name' => strval($storage->name),
                'uuid' => strval($storage->uuid),
                'mount_path' => strval($storage->mount_path),
				'fs_type' => strval ($storage->fs_type)
            );

            if (isset($storage->label))
                $arr['label'] = strval($storage->label);
            if (isset($storage->user_name))
                $arr['user_name'] = strval($storage->user_name);
            if (isset($storage->user_caption))
                $arr['user_caption'] = strval($storage->user_caption);
            $storages[] = (object) $arr;
        }
		return $storages;
    }
	public static function parseExtCommandState(){
		$ini_str = file_get_contents ('/tmp/run/ext_command.state');
		$state['playback_duration'] = 1;
		if (preg_match('|playback_duration =(.*)|', $ini_str, $m))
			$state['playback_duration'] = trim($m[1]);
		$state['playback_position'] = 0;
		if (preg_match('|playback_position =(.*)|', $ini_str, $m))
			$state['playback_position'] = trim($m[1]);
		return $state;
	}
	
	public static function get_sticker($img=null, $txt=null, $optArr = false){
		$img_x = 0; $img_y = 0; $img_halign='right'; $img_valign='top';
		$txt_x = 0; $txt_y = 0; $txt_halign='right'; $txt_valign='top'; $txt_color=15;
		if ($optArr == true)
			extract ($optArr);
		
		if ($img==true){
			if (is_array($img)){
				foreach ($img as $k => $im){
					$im_x = isset($img_x[$k]) ? $img_x[$k] : 0;
					$im_y = isset($img_y[$k]) ? $img_y[$k] : 0;
					$im_halign = isset($img_halign[$k]) ? $img_halign[$k] : 'right';
					$im_valign = isset($img_valign[$k]) ? $img_valign[$k] : 'top';
					$items[] = Sticker::item(Sticker::geom($im_x, $im_y, $im_halign, $im_valign), Sticker::icon($im));
				}
			}else
				$items[] = Sticker::item(Sticker::geom($img_x, $img_y, $img_halign, $img_valign), Sticker::icon($img));
		}
		if ($txt==true){
			if (is_array($txt)){
				foreach ($txt as $k => $tx){
					$tx_x = isset($txt_x[$k]) ? $txt_x[$k] : 0;
					$tx_y = isset($txt_y[$k]) ? $txt_y[$k] : 0;
					$tx_halign = isset($txt_halign[$k]) ? $txt_halign[$k] : 'right';
					$tx_valign = isset($txt_valign[$k]) ? $txt_valign[$k] : 'top';
					$tx_color = isset($txt_color[$k]) ? $txt_color[$k] : 15;
					$items[] = Sticker::item(Sticker::geom($tx_x, $tx_y, $tx_halign, $tx_valign), Sticker::text($tx, $tx_color));
				}
			}else
				$items[] = Sticker::item(Sticker::geom($txt_x, $txt_y, $txt_halign, $txt_valign), Sticker::text($txt, $txt_color));
        }
		return Sticker::sticker($items);
    }
	public static function strSanitizing($str, $skipTranslit = null){	
		$str = trim($str);
		$str = mb_strtolower($str, 'UTF-8');
		$str = preg_replace("/\W+/u", '', $str);
		if ($skipTranslit == false)
			$str = self::translit($str);
		return $str;
	}
	public static function translit($value){
		$converter = array(
			'а' => 'a',    'б' => 'b',    'в' => 'v',    'г' => 'g',    'д' => 'd',
			'е' => 'e',    'ё' => 'e',    'ж' => 'zh',   'з' => 'z',    'и' => 'i',
			'й' => 'y',    'к' => 'k',    'л' => 'l',    'м' => 'm',    'н' => 'n',
			'о' => 'o',    'п' => 'p',    'р' => 'r',    'с' => 's',    'т' => 't',
			'у' => 'u',    'ф' => 'f',    'х' => 'h',    'ц' => 'c',    'ч' => 'ch',
			'ш' => 'sh',   'щ' => 'sch',  'ь' => '',     'ы' => 'y',    'ъ' => '',
			'э' => 'e',    'ю' => 'yu',   'я' => 'ya',
	 
			'А' => 'A',    'Б' => 'B',    'В' => 'V',    'Г' => 'G',    'Д' => 'D',
			'Е' => 'E',    'Ё' => 'E',    'Ж' => 'Zh',   'З' => 'Z',    'И' => 'I',
			'Й' => 'Y',    'К' => 'K',    'Л' => 'L',    'М' => 'M',    'Н' => 'N',
			'О' => 'O',    'П' => 'P',    'Р' => 'R',    'С' => 'S',    'Т' => 'T',
			'У' => 'U',    'Ф' => 'F',    'Х' => 'H',    'Ц' => 'C',    'Ч' => 'Ch',
			'Ш' => 'Sh',   'Щ' => 'Sch',  'Ь' => '',     'Ы' => 'Y',    'Ъ' => '',
			'Э' => 'E',    'Ю' => 'Yu',   'Я' => 'Ya',
		);
	 
		$value = strtr($value, $converter);
		return $value;
	}
	public static function pCopyFolders ($sourceDir=null, $destDir=null){
		if (($sourceDir==false)||($destDir==false)){
			echo "sourceDir=$sourceDir | destDir=$destDir";
			return 'Err! sourceDir or destDir false';
		}
		if (!file_exists($destDir))
			mkdir($destDir, 0755, true);
		$dirIterator = new RecursiveDirectoryIterator($sourceDir, RecursiveDirectoryIterator::SKIP_DOTS);
		$iterator    = new RecursiveIteratorIterator($dirIterator, RecursiveIteratorIterator::SELF_FIRST);
		$i = $ii = 0;
		foreach ($iterator as $object) {
			$destPath = $destDir . DIRECTORY_SEPARATOR . $iterator->getSubPathName();
			if($object->isDir()){
				if (!file_exists($destPath))
					mkdir($destPath);
				$ii++;
			}else{
				if (!copy($object, $destPath))
					echo "не удалось скопировать $file...\n";
				else
					$i++;
			}
		}
		return "Скопировано: $i файлов и $ii директорий";
	}
	public static function str_remove_tag($str){
		$str = str_replace(array("&nbsp;","&thinsp;")," ",$str);
		$str = html_entity_decode(strip_tags($str), ENT_QUOTES,'UTF-8');
		$str = preg_replace('/^\:/', '', $str);
		$str = preg_replace('/ {2,}/', ' ', $str);
		$str = preg_replace('/	{2,}/', ' ', $str);
		$str = preg_replace("/\n{2,}/", "\n", $str);
		$str = trim($str);
		return $str;
	}
	public static function mb_str_split($str, $num=1){
		if (preg_match_all("#.{".$num."}#uis", $str, $arr)){
			foreach ($arr[0] as $v)
				$out[]= trim($v);
		}else
			$out[]= $str;
		return $out;
	}
	public static function get_upper($str){
        $first = mb_substr($str,0,1, 'UTF-8');
		$last = mb_substr($str,1);
		$first = mb_strtoupper($first, 'UTF-8');
		$last = mb_strtolower($last, 'UTF-8');
		$str = $first.$last;
        return $str;
    }
	public static function strimwidthCenter( $value, $length = 44, $sep = '...' ) {
		$valueEncoding = mb_detect_encoding( $value, 'auto', true );
		if ( $length >= mb_strwidth( $value, $valueEncoding ) ) {
			return $value;
		}
		$limited = '';
		$firstWidth = ceil( $length/2 );
		$secondStart = mb_strwidth( $value, $valueEncoding ) - ( $length - $firstWidth );
		$secondWidth = $length - $firstWidth +1;
		$limited = mb_strimwidth( $value, 0, $firstWidth, $sep, $valueEncoding ) . mb_substr( $value, $secondStart, $secondWidth, $valueEncoding );
		return $limited;
	}
	public static function createBazingaIconTheme($saveDir){
		$zip = new ZipArchive();
		$dataDir = self::get_data_path();
		$arkName = DuneSystem::$properties['plugin_name'] . 'IconTheme';
		$zip->open("$saveDir/$arkName.zip", ZipArchive::CREATE);
		if ($zip->addEmptyDir('icons') == true){
			$files = scandir($dataDir . '/icons/');
			foreach($files as $file){
				if ($file == '.' || $file == '..' ){continue;}
				$zip->addFile($dataDir . '/icons/' . $file, 'icons/'. $file);
			}
		}else{
			echo 'Невозможно создать директорию';
			return false;
		}
		$zip->close();
		return true;
	}
	public static function extractZipArchive($archivePath, $extractDir){
		$zip = new ZipArchive();   
		if ($zip->open($archivePath) !== TRUE){
			echo ("Не могу окрыть архив $archivePath");
			return false;
		}
		$zip->extractTo($extractDir);
		$zip->close();    
		echo "Архив извлечен в папку $extractDir!";
		return true;
	}
	public static function addToZip($source, $destination){
		if (!extension_loaded('zip') || !file_exists($source)) {
			return false;
		}
		$zip = new ZipArchive();
		if (!$zip->open($destination, ZIPARCHIVE::CREATE)) {
			return false;
		}
		$source = str_replace('\\', '/', realpath($source));
		if (is_dir($source) === true){
			$files = new RecursiveIteratorIterator(new RecursiveDirectoryIterator($source), RecursiveIteratorIterator::SELF_FIRST);
			foreach ($files as $file){
				$file = str_replace('\\', '/', $file);
				// Ignore "." and ".." folders
				if( in_array(substr($file, strrpos($file, '/')+1), array('.', '..')) )
					continue;
				$file = realpath($file);
				$file = str_replace('\\', '/', $file); 
				if (is_dir($file) === true){
					$zip->addEmptyDir(str_replace($source . '/', '', $file . '/'));
				}else if (is_file($file) === true){
					$zip->addFromString(str_replace($source . '/', '', $file), file_get_contents($file));
				}
			}
		}else if (is_file($source) === true){
			$zip->addFromString(basename($source), file_get_contents($source));
		}
		return $zip->close();
	}
	public static function imgCache($url, $name){
		if (!preg_match('|do\?img=|', $url))
			$url = DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . $url;
		$doc = file_get_contents($url);
		return self::pluginCache($doc, $name);
	}
	public static function pluginCache($doc, $name){
		$path = HD::get_data_path() . "/pluginCache/";
		if (!file_exists($path))
			if (!mkdir($path, 0777, true))
				die('Не удалось создать директории...');
		if (file_put_contents ($path . $name, $doc) !== false)
			return true;
		else{
			echo 'Сохранение не удалось: '. $path . $name;
			echo 'Folder: ' . self::get_storage_size($path);
			return false;
		}
			
	}
	public static function pluginCacheDel($m){
		$pluginCachePath = HD::get_data_path() . "/pluginCache/";
		$imgCachePath = $pluginCachePath . md5($m) . '.jpg';
		$mUrl = MediaURL::decode($m);
		$infoCachePath = $pluginCachePath . md5($mUrl->movie_id . $mUrl->class_name) . '.srz';
		if (file_exists($imgCachePath))
			if (!unlink($imgCachePath))
				echo "Удаление не удалось: " . $imgCachePath;
		if (file_exists($infoCachePath))
			if (!unlink($infoCachePath))
				echo "Удаление не удалось: " . $infoCachePath;
	}
	public static function pluginInfoCacheDel($m){
		$pluginCachePath = HD::get_data_path() . "/pluginCache/";
		$mUrl = MediaURL::decode($m);
		$infoCachePath = $pluginCachePath . md5($mUrl->movie_id . $mUrl->class_name) . '.srz';
		if (file_exists($infoCachePath))
			if (!unlink($infoCachePath))
				echo "Удаление не удалось: " . $infoCachePath;
	}
	public static function delDir($dir) {
		$files = array_diff(scandir($dir), array('.','..'));
		foreach ($files as $file) {
			(is_dir($dir.'/'.$file)) ? self::delDir($dir.'/'.$file) : unlink($dir.'/'.$file);
		}
		return rmdir($dir);
	}
////////////////////////////////////////////////////////////////////////
}

///////////////////////////////////////////////////////////////////////////
?>
