<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/abstract_gcomps_screen.php';
require_once 'lib/text_utils.php';
require_once 'lib/action_factory.php';
require_once 'lib/gcomps_factory.php';
require_once 'vod_series_list_screen.php';
require_once 'l.php';

class VodMovieScreen extends AbstractGCompsScreen {
    const ID = 'vod_movie';
	const ITEMS_PAGE_SIZE = 5;
	public $cur_media_url;
    public $cur_stack;
    public $cur_sel_kind;
    public $cur_button_sel;
    public $cur_item_sel;
    public $cur_item_top;
    private $main_media_url;
    private $main_stack;
    private $main_sel_kind;
    private $main_button_sel;
    private $main_item_id;
    public $cur_movie_id;
    public $cur_movie;
	public $cur_movie_obj;
    public $cur_movie_num_buttons;
    public $cur_movie_confirm_needed;
    public $cur_movie_edit_match_enabled;
    public $cur_person_id;
    public $cur_person;
    public $cur_object_ids;
    public $cur_object_list_sep_ndx;
	
    public static function get_media_url_str($class_name, $arr=null){
		$arr['screen_id'] = self::ID;			
		$arr['class_name'] = $class_name;
        return MediaURL::encode($arr);
    }

    ///////////////////////////////////////////////////////////////////////

    private $vod;

    public function __construct(Vod $vod){
        $this->vod = $vod;

        UserInputHandlerRegistry::get_instance()->
            register_handler($this);
		if (!isset(self::$RIGHT_PANEL_X)){
			L::static_init();
            self::static_init();
		}

    }

    ///////////////////////////////////////////////////////////////////////

    public function get_id()
	{ return self::ID; }

    public function get_handler_id()
	{ return self::ID; }

    ///////////////////////////////////////////////////////////////////////

    private static $HGAP;
    private static $RIGHT_PANEL_WIDTH;
    private static $RIGHT_PANEL_X;
    private static $RIGHT_PANEL_HEIGHT;
    private static $TOP_PANEL_HEIGHT;
    private static $CENTER_HEADER_HEIGHT;
    private static $RIGHT_BG_X;
    private static $RIGHT_BG_WIDTH;
    private static $DARKEN_COLOR = "#C0000000";

    private static function static_init(){
        self::$HGAP = L::$PANEL_H_GAP / 2;
        self::$RIGHT_PANEL_X =
            L::$SCREEN_LEFT + L::$VOD_POSTER_WIDTH + L::$PANEL_H_GAP;
        self::$RIGHT_PANEL_WIDTH =
            L::$WIDTH - L::$SCREEN_RIGHT - self::$RIGHT_PANEL_X;
        self::$RIGHT_PANEL_HEIGHT = L::$HEIGHT -
            L::$VOD_PANEL_TOP - L::$PANEL_BOTTOM_OFFSET;

        self::$TOP_PANEL_HEIGHT = L::$VOD_BUTTON_HEIGHT * 4 + L::$PAR_VGAP_BIG +
            L::$VOD_DESCRIPTION_HR_TOP + L::$VOD_DESCRIPTION_HR_BOTTOM;
        self::$CENTER_HEADER_HEIGHT = 12 + L::$VOD_BUTTON_HEIGHT * 4;

        self::$RIGHT_BG_X = self::$RIGHT_PANEL_X - self::$HGAP; 
        self::$RIGHT_BG_WIDTH = L::$WIDTH - self::$RIGHT_BG_X;
    }

    private static function get_button_caption($ndx){
        switch ($ndx){
            case 0:
                return 'Смотреть';
            case 1:
                return 'Описание';
            case 2:
                return 'Трейлеры';
            case 3:
                return 'Похожие';
            case 4:
                return 'Связанные';
            case 5:
                return 'Сиквелы';
			case 6:
                return 'Актеры';
            default:
                return '';
        }
    }

    ///////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////

    private function get_play_action($media_url){
		$caption = $this->left_button_caption;
		$this->vod->seasons_media_url['screen_counter'] = 0;
		if ($caption == 'Просмотр'){
			$media_url = MediaURL::decode($this->mUrl);
			$caption = $media_url->caption;
		}
		VodSourceListScreen::$filter = false;
		return ActionFactory::open_folder($this->mUrl, $caption);
    }

    ///////////////////////////////////////////////////////////////////////

    private function do_get_confirm_hints_pane_geom($button_sel){
        $h = L::$VOD_BUTTON_HEIGHT + L::$COLOR_ICON_TEXT_DY;
        if ($button_sel == 0)
            return GCompGeom::place_top_left(-1, $h, self::$RIGHT_PANEL_X, L::$HEIGHT);
        else
            return GCompGeom::place_top_left(-1, $h, self::$RIGHT_PANEL_X, L::$HEIGHT - L::$HINTS_BOTTOM_OFFSET);
    }

    private function do_get_top_pane_geom($button_sel){
        $h = L::$VOD_PANEL_TOP + self::$TOP_PANEL_HEIGHT;
        if ($button_sel == 0)
            return GCompGeom::place_top_left(self::$RIGHT_BG_WIDTH, $h, self::$RIGHT_BG_X, -$h);

        if ($button_sel == 1 && $this->cur_movie_confirm_needed)
            return GCompGeom::place_top_left(self::$RIGHT_BG_WIDTH, $h, self::$RIGHT_BG_X, 0);

        return GCompGeom::place_top_left(self::$RIGHT_BG_WIDTH, $h, self::$RIGHT_BG_X, -$h);
    }

    private function do_get_movie_center_geom($button_sel){
        if ($button_sel == 0){
            return GCompGeom::place_bottom_left(
                self::$RIGHT_PANEL_WIDTH, self::$CENTER_HEADER_HEIGHT,
                0, 0);
        }

        if ($button_sel == 1 && $this->cur_movie_confirm_needed){
            return GCompGeom::place_top_left(
                self::$RIGHT_PANEL_WIDTH,
                self::$RIGHT_PANEL_HEIGHT - self::$TOP_PANEL_HEIGHT,
                0,
                self::$TOP_PANEL_HEIGHT);
        }

        return GCompGeom::place_top_left(
            self::$RIGHT_PANEL_WIDTH, self::$RIGHT_PANEL_HEIGHT,
            0, 0);
    }

    private function do_get_center_bg_geom($button_sel){
        $extend_bg_top = $button_sel > 1 ||
            ($button_sel == 1 && !$this->cur_movie_confirm_needed);
        $top = ($extend_bg_top ? L::$VOD_PANEL_TOP : 0) +
            ($button_sel == 0 ? 5 : 0);
        $dh = $top +
            ($button_sel > 0 ? L::$PANEL_BOTTOM_OFFSET : L::$VOD_PANEL_BOTTOM);
        return GCompGeom::place_same_size(
            L::$SCREEN_RIGHT + self::$HGAP, $dh,
            -self::$HGAP, -$top,
            "movie_center_pane");
    }

    private function do_get_sel_geom($sel_kind, $button_sel, $item_sel){
        if ($sel_kind == 0){
            return GCompGeom::place_same_size(
                10, -2, -10, 5, "btn$button_sel");
        }else{
            return GCompGeom::place_same_size(
                0, 16, 0, -8, "item$item_sel");
        }
    }

    ///////////////////////////////////////////////////////////////////////

    private function do_get_item_geom($item_pos, $button_sel){
		if ($button_sel == 2){
			$sel_poster_height = 55;
			$panel_width = 1350;
		}else{
			$sel_poster_height = L::$VOD_LIST_SEL_POSTER_HEIGHT;
			$panel_width = L::$VOD_PEOPLE_PANEL_WIDTH;
		}
		$row_height = $sel_poster_height + L::$VOD_LIST_ICON_V_PADDING * 2;
		$y = L::$VOD_LIST_ICON_V_PADDING + $row_height * $item_pos +  (int) ($row_height / 2) - 10;
        return self::place_top_left_by_center(
            $panel_width,
            $sel_poster_height,
            0,
			$y
		);
    }

    private function do_get_item_img_geom($item_ndx, $selected, $button_sel){
		if ($button_sel == 2){
			$sel_poster_width = 55;
			$sel_poster_height =55;
			$poster_width = 50;
			$poster_height = 50;
		}else{
			$sel_poster_width = L::$VOD_LIST_SEL_POSTER_WIDTH;
			$sel_poster_height = L::$VOD_LIST_SEL_POSTER_HEIGHT;
			$poster_width = L::$VOD_LIST_POSTER_WIDTH;
			$poster_height = L::$VOD_LIST_POSTER_HEIGHT;
		}
		
        if ($selected){
            return GCompGeom::place_left_center(
				$sel_poster_width,
				$sel_poster_height,
                L::$VOD_LIST_ICON_X_OFFSET,
                0);
        }

        return GCompGeom::place_left_center(
			$poster_width,
			$poster_height,
            L::$VOD_LIST_ICON_X_OFFSET,
            0);
    }

    private static function do_get_item_text_geom($x){
        $h = L::$LIST_TEXT_SIZE + L::$LIST_TEXT_BOTTOM * 2;
        // $y = L::$VOD_LIST_POSTER_HEIGHT / 2 - $h + L::$LIST_TEXT_BOTTOM;
        return GCompGeom::place_top_left(
            L::$VOD_PEOPLE_PANEL_WIDTH - L::$PANEL_H_PADDING - $x, 
			$h,
            $x,
			-10
		);
    }

    private static function do_get_item_text_geom2($x){
        $h = L::$LIST_TEXT_SIZE + L::$LIST_TEXT_BOTTOM * 2;
        $y = L::$VOD_LIST_POSTER_HEIGHT / 2 - L::$LIST_TEXT_BOTTOM;
        return GCompGeom::place_top_left(
            L::$VOD_PEOPLE_PANEL_WIDTH - L::$PANEL_H_PADDING - $x, $h,
            $x, $y);
    }

    private static function do_get_item_text_size($selected){
        return $selected ? L::$LIST_TEXT_SIZE : L::$TEXT_SIZE;
    }

    private static function do_get_item_text_color($selected){
        if ($selected)
            return "#FFFFFFE0";
        else
            return "#FFAFAFA0";
    }

    private static function do_get_item_text_color2($selected){
        if ($selected)
            return "#FFAFAFA0";
        else
            return "#FF808080";
    }

    ///////////////////////////////////////////////////////////////////////

    private static function do_get_button_color($selected){
        if ($selected)
            return "#FFFFFFE0";
        else
            return "#FFAFAFA0";
    }

    private function do_get_left_bg_def(){
        $panel_w = L::$SCREEN_LEFT + L::$VOD_POSTER_WIDTH + self::$HGAP;

        return GCompsFactory::get_rect_def(
            GCompGeom::place_top_left($panel_w, L::$HEIGHT, 0, 0), 
            null, self::$DARKEN_COLOR);
    }

    private function do_get_center_bg_def($button_sel){
        $panel_w = L::$WIDTH - L::$SCREEN_RIGHT -
            L::$SCREEN_LEFT - L::$VOD_POSTER_WIDTH - self::$HGAP;

        $def = GCompsFactory::get_rect_def(
            $this->do_get_center_bg_geom($button_sel),
            null, self::$DARKEN_COLOR);
        $def[GComponentDef::id] = "center_bg";
        return $def;
    }

    private function do_get_right_bg_def(){
        return GCompsFactory::get_rect_def(
            GCompGeom::place_top_left(
                L::$SCREEN_RIGHT, L::$HEIGHT - L::$PANEL_TOP_OFFSET,
                L::$WIDTH - L::$SCREEN_RIGHT, L::$PANEL_TOP_OFFSET), 
            null, self::$DARKEN_COLOR);
    }

    private function do_get_poster_panel_def($movie){
        $poster_url = $movie->poster_url;
        $not_loaded_url = "plugin_file://icons/poster_none.png";
        $load_failed_url = "plugin_file://icons/poster_none.png";
        $low_quality_url = $movie->poster_url;

        $img_def = GCompsFactory::get_image_def(
            GCompGeom::place_top_left(
                L::$VOD_POSTER_WIDTH, L::$VOD_POSTER_HEIGHT, 0, 0),
            null, $poster_url, false, true,
            $not_loaded_url, $load_failed_url, $low_quality_url);
        $defs = array();
        $defs[] = GCompsFactory::get_ppane_def(null,
            GCompGeom::place_top_left(
                L::$VOD_POSTER_WIDTH, L::$VOD_POSTER_HEIGHT, 0, 0),
            array($img_def));

        $y = L::$VOD_POSTER_HEIGHT + L::$VOD_POSTER_BOTTOM - L::$TEXT_BOTTOM;
        for ($i = 0; $i < $this->cur_movie_num_buttons; $i++){
            $h = L::$TEXT_SIZE + L::$TEXT_BOTTOM * 2;
            $button_def = GCompsFactory::get_ttf_label_def(
                GCompGeom::place_top_left(
                    L::$VOD_POSTER_WIDTH - L::$VOD_BUTTON_TEXT_LEFT,
                    $h,
                    L::$VOD_BUTTON_TEXT_LEFT, 
                    $y + (L::$VOD_BUTTON_HEIGHT - $h) / 2),
                null, self::get_button_caption($i), 1,
                self::do_get_button_color($i == $this->cur_button_sel), 
                L::$TEXT_SIZE);
            $button_def[GComponentDef::id] = "btn$i";
            $defs[] = $button_def;

            $y += L::$VOD_BUTTON_HEIGHT;
        }

        return GCompsFactory::get_panel_def("poster_pane",
            GCompGeom::place_top_left(
                L::$VOD_POSTER_WIDTH, -1,
                L::$SCREEN_LEFT, L::$VOD_PANEL_TOP),
            null,
            $defs);
    }

    private static function do_get_country_str($movie){
        if ($movie->year <= 0)
            return "%ext%".$movie->country;
        if ($movie->country == '')
            return $movie->year;
        return "%ext%$movie->year, $movie->country";
    }

    private function do_get_confirm_hints_pane_children($button_sel){
        $geom = GCompGeom::place_top_left(-1, L::$VOD_BUTTON_HEIGHT);
        $defs = array();
        $defs[] = GCompsFactory::get_image_def($geom, null, "plugin_file://icons/popup.png");
		$defs[] = GCompsFactory::get_ttf_label_def(
		GCompGeom::place_next_right_align_top(
			-1, L::$VOD_BUTTON_HEIGHT,
			0, -L::$COLOR_ICON_TEXT_DY),
			GCompMargins::all(L::$TEXT_ICON_HGAP, 0, L::$HINTS_SMALL_HGAP, 0),
			'Действия', 
			1, "#FFAFAFA0", L::$TEXT_SIZE
		);

		$geom = GCompGeom::place_next_right_align_top(
		-1, L::$COLOR_BUTTON_HEIGHT,
		0, L::$COLOR_ICON_TEXT_DY);
        

        if ($button_sel <= 1){
            $defs[] = GCompsFactory::get_image_def($geom, null,
                "plugin_file://icons/p_plus_p_minus.png");
            $defs[] = GCompsFactory::get_ttf_label_def(
                GCompGeom::place_next_right_align_top(
                    -1, L::$VOD_BUTTON_HEIGHT,
                    0, -L::$COLOR_ICON_TEXT_DY),
                GCompMargins::all(L::$TEXT_ICON_HGAP, 0, L::$HINTS_SMALL_HGAP, 0),
                'Прокрутка', 
                1, "#FFAFAFA0", L::$TEXT_SIZE);
			
        }
		 $defs[] = GCompsFactory::get_image_def(
                GCompGeom::place_next_right_align_top(
                    -1, L::$COLOR_BUTTON_HEIGHT,
                    0, L::$COLOR_ICON_TEXT_DY),
                null,
                'gui_skin://special_icons/controls_button_green.aai');

            $defs[] = GCompsFactory::get_ttf_label_def(
                GCompGeom::place_next_right_align_top(
                    -1, L::$VOD_BUTTON_HEIGHT,
                    0, -L::$COLOR_ICON_TEXT_DY),
                GCompMargins::all(L::$TEXT_ICON_HGAP, 0, L::$HINTS_SMALL_HGAP, 0),
                'Поиск', 
                1, "#FFAFAFA0", L::$TEXT_SIZE);
			if (isset($this->cur_movie->class_info['dbIDs']['kpID'])){
				$defs[] = GCompsFactory::get_image_def(
					GCompGeom::place_next_right_align_top(
						-1, L::$COLOR_BUTTON_HEIGHT,
						0, L::$COLOR_ICON_TEXT_DY),
					null,
					'gui_skin://special_icons/controls_button_yellow.aai');

				$defs[] = GCompsFactory::get_ttf_label_def(
					GCompGeom::place_next_right_align_top(
						-1, L::$VOD_BUTTON_HEIGHT,
						0, -L::$COLOR_ICON_TEXT_DY),
					GCompMargins::all(L::$TEXT_ICON_HGAP, 0, L::$HINTS_SMALL_HGAP, 0),
					'Отзывы', 
					1, "#FFAFAFA0", L::$TEXT_SIZE);
			}
			 $defs[] = GCompsFactory::get_image_def(
                GCompGeom::place_next_right_align_top(
                    -1, L::$COLOR_BUTTON_HEIGHT,
                    0, L::$COLOR_ICON_TEXT_DY),
                null,
                'gui_skin://special_icons/controls_button_blue.aai');

            $defs[] = GCompsFactory::get_ttf_label_def(
                GCompGeom::place_next_right_align_top(
                    -1, L::$VOD_BUTTON_HEIGHT,
                    0, -L::$COLOR_ICON_TEXT_DY),
                GCompMargins::all(L::$TEXT_ICON_HGAP, 0, L::$HINTS_SMALL_HGAP, 0),
                'Избранное', 
                1, "#FFAFAFA0", L::$TEXT_SIZE);
        return $defs;
    }

    private function do_get_confirm_hints_pane($button_sel){
        return GCompsFactory::get_panel_def("confirm_hints_pane",
            $this->do_get_confirm_hints_pane_geom($button_sel),
            null, $this->do_get_confirm_hints_pane_children($button_sel));
    }

    private function do_get_confirm_question_pane(){
        $defs = array();

        $defs[] = GCompsFactory::get_image_def(

            GCompGeom::place_top_left(
                -1, L::$VOD_BUTTON_HEIGHT, 0, L::$COLOR_ICON_TEXT_DY),
            null,
            "plugin_file://icons/red.png");

        $defs[] = GCompsFactory::get_ttf_label_def(
            GCompGeom::place_next_right_align_top(
                -1, L::$VOD_BUTTON_HEIGHT,
                0, -L::$COLOR_ICON_TEXT_DY),
            GCompMargins::all(L::$TEXT_ICON_HGAP, 0, L::$HINTS_SMALL_HGAP, 0),
            T::t("action_wrong_association"), 
            1, "#FFFFFFE0", L::$TEXT_SIZE);

        $defs[] = GCompsFactory::get_image_def(
            GCompGeom::place_next_right_align_top(
                L::$COLOR_BUTTON_WIDTH, L::$COLOR_BUTTON_HEIGHT,
                0, L::$COLOR_ICON_TEXT_DY),
            null,
            "plugin_file://icons/green.png");

        $defs[] = GCompsFactory::get_ttf_label_def(
            GCompGeom::place_next_right_align_top(
                -1, L::$VOD_BUTTON_HEIGHT,
                0, -L::$COLOR_ICON_TEXT_DY),
            GCompMargins::all(L::$TEXT_ICON_HGAP, 0, L::$HINTS_SMALL_HGAP, 0),
            T::t("action_confirm_this_movie"), 
            1, "#FFFFFFE0", L::$TEXT_SIZE);

        $defs[] = GCompsFactory::get_image_def(
            GCompGeom::place_next_right_align_top(
                L::$COLOR_BUTTON_WIDTH, L::$COLOR_BUTTON_HEIGHT,
                0, L::$COLOR_ICON_TEXT_DY),
            null,
            "plugin_file://icons/yellow.png");

        $defs[] = GCompsFactory::get_ttf_label_def(
            GCompGeom::place_next_right_align_top(
                -1, L::$VOD_BUTTON_HEIGHT,
                0, -L::$COLOR_ICON_TEXT_DY),
            GCompMargins::all(L::$TEXT_ICON_HGAP, 0, L::$HINTS_SMALL_HGAP, 0),
            T::t("action_confirm_trailer"), 
            1, "#FFFFFFE0", L::$TEXT_SIZE);

        $defs[] = GCompsFactory::get_image_def(
            GCompGeom::place_next_right_align_top(
                L::$COLOR_BUTTON_WIDTH, L::$COLOR_BUTTON_HEIGHT,
                0, L::$COLOR_ICON_TEXT_DY),
            null,
            "plugin_file://icons/blue.png");

        $defs[] = GCompsFactory::get_ttf_label_def(
            GCompGeom::place_next_right_align_top(
                -1, L::$VOD_BUTTON_HEIGHT,
                0, -L::$COLOR_ICON_TEXT_DY),
            GCompMargins::left(L::$TEXT_ICON_HGAP),
            T::t("action_confirm_bonus"), 
            1, "#FFFFFFE0", L::$TEXT_SIZE);

        $h = L::$COLOR_BUTTON_HEIGHT + L::$VOD_DESCRIPTION_HR_TOP + 3;
        $defs[] = GCompsFactory::get_rect_def(
            GCompGeom::place_top_left(
                self::$RIGHT_PANEL_WIDTH - 50, 3, 0, $h - 3), 
            null, "#FF404040");

        return GCompsFactory::get_panel_def("confirm_q_pane",
            GCompGeom::bottom(-1, $h),
            null, $defs);
    }

    private function do_get_confirm_pane($movie){
        $file = $this->do_get_first_not_confirmed_file();

        $w = self::$RIGHT_PANEL_WIDTH - 50;

        $defs = array();
        $defs[] = GCompsFactory::get_ttf_label_def(
            GCompGeom::top($w, L::$VOD_BUTTON_HEIGHT),
            null, T::t("msg_file_movie_match_confirmation_required"), 
            1, "#FFAFAFA0", L::$TEXT_SIZE);

        $defs[] = GCompsFactory::get_ttf_label_def(
            GCompGeom::left(),
            GCompMargins::right(L::$PANEL_H_GAP),
            T::key_global("navigator_label_file"), 
            1, "#FFAFAFA0", L::$TEXT_SIZE);

        $defs[] = GCompsFactory::get_ttf_label_def(
            GCompGeom::center(),
            null, $file->path, 
            2, "#FFFFFFE0", L::$TEXT_SIZE);

        $defs[] = $this->do_get_confirm_question_pane();

        return GCompsFactory::get_panel_def("confirm_pane",
            GCompGeom::place_top_left(
                $w, -1, self::$HGAP, L::$VOD_PANEL_TOP),
            null, $defs);
    }

    private function do_get_top_pane($movie, $button_sel){
        $defs = array();

        $h = L::$VOD_PANEL_TOP + self::$TOP_PANEL_HEIGHT;

        $defs[] = GCompsFactory::get_rect_def(
            GCompGeom::place_top_left(
                self::$RIGHT_BG_WIDTH, $h, 0, 0), 
            null, self::$DARKEN_COLOR);

        $defs[] = $this->do_get_confirm_pane($movie);

        return GCompsFactory::get_panel_def("top_pane",
            $this->do_get_top_pane_geom($button_sel),
            null,
            $defs);
    }

    private function do_get_movie_play_or_info_panel_children($movie, $button_sel){
        $y = -5;
        $defs = array();
        $movie_title = $movie->name != '' ? $movie->name : ' ';
        $defs[] = GCompsFactory::get_ttf_label_def(
            GCompGeom::place_top_left(
                self::$RIGHT_PANEL_WIDTH - 50, L::$VOD_BUTTON_HEIGHT,
                0, $y),
            null, $movie_title, 1, "#FFFFFF40", L::$BIG_TEXT_SIZE);
		if (isset($movie->rate_details['   '])){
            $str = 'Статус: ' . $movie->rate_details['   '];
            $geom = GCompGeom::place_top_right(
                -1, L::$VOD_BUTTON_HEIGHT, -50, $y);
            $defs[] = GCompsFactory::get_ttf_label_def($geom,
                null, $str, 1, "#FFF5F5F5", L::$TEXT_SIZE);
        }
        $y += L::$VOD_BUTTON_HEIGHT + 12;
		if (isset($movie->rate_details['Сезонов:'])){
            $str = 'Сезонов: ' . $movie->rate_details['Сезонов:'];
            $geom = GCompGeom::place_top_right(
                -1, L::$VOD_BUTTON_HEIGHT, -50, $y);
            $defs[] = GCompsFactory::get_ttf_label_def($geom,
                null, $str, 1, "#FFF5F5F5", L::$TEXT_SIZE);
        }
		if (isset($movie->rate_details['  '])){
            $str = 'Премьера: ' . $movie->rate_details['  '];
            $geom = GCompGeom::place_top_right(
                -1, L::$VOD_BUTTON_HEIGHT, -250, $y);
            $defs[] = GCompsFactory::get_ttf_label_def($geom,
                null, $str, 1, "#FFF5F5F5", L::$TEXT_SIZE);
        }
        if ($movie->name_original != ''){
            $defs[] = GCompsFactory::get_ttf_label_def(
                GCompGeom::place_top_left(
                    self::$RIGHT_PANEL_WIDTH - 50, L::$VOD_BUTTON_HEIGHT,
                    0, $y),
                null, $movie->name_original, 1, "#FFF5F5F5", L::$TEXT_SIZE);
        }
        $y += L::$VOD_BUTTON_HEIGHT;

        if ($movie->genres_str != ''){
            $defs[] = GCompsFactory::get_ttf_label_def(
                GCompGeom::place_top_left(
                    self::$RIGHT_PANEL_WIDTH - 250, L::$VOD_BUTTON_HEIGHT,
                    0, $y),
                null, "%ext%" . $movie->genres_str, 1, "#FFAFAFA0", L::$TEXT_SIZE);
        }
		
        if ($movie->length_min > 0){
            $str = "%ext%<key_global>dune_tv_movie_length_min__1<p>$movie->length_min</p></key_global>";
            $geom = GCompGeom::place_top_right(
                -1, L::$VOD_BUTTON_HEIGHT, -50, $y);
            $defs[] = GCompsFactory::get_ttf_label_def($geom,
                null, $str, 1, "#FFAFAFA0", L::$TEXT_SIZE,
                "label");
			$defs[] = GCompsFactory::get_image_def(
                GCompGeom::place_next_left_align_top(
                    L::$IMDB_WIDTH, L::$IMDB_HEIGHT,
                    -L::$VOD_INFO_RATING_ICON_RIGHT,
                    L::$IMDB_ICON_TEXT_DY),
                null, 'gui_skin://osd_icons/wait.aai');
        }
        $y += L::$VOD_BUTTON_HEIGHT;

        $country_str = self::do_get_country_str($movie);
        if ($country_str != ''){
            $defs[] = GCompsFactory::get_ttf_label_def(
                GCompGeom::place_top_left(
                    self::$RIGHT_PANEL_WIDTH - 250, L::$VOD_BUTTON_HEIGHT,
                    0, $y),
                null, $country_str, 1, "#FFFFFF40", L::$TEXT_SIZE);
        }
        if ($movie->rate_imdb != ''){
            $imdb = sprintf("%.1f", $movie->rate_imdb);

            $defs[] = GCompsFactory::get_ttf_label_def(
                GCompGeom::place_top_right(
                    -1, L::$VOD_BUTTON_HEIGHT, -50, $y),
                null, $imdb, 1, "#FFAFAFA0", L::$TEXT_SIZE,
                "imdb_label");

            $defs[] = GCompsFactory::get_image_def(
                GCompGeom::place_next_left_align_top(
                    L::$IMDB_WIDTH, L::$IMDB_HEIGHT,
                    -L::$VOD_INFO_RATING_ICON_RIGHT,
                    L::$IMDB_ICON_TEXT_DY),
                null, "plugin_file://icons/imdb.png");
        }
		if ($movie->rate_kinopoisk != ''){
            $kp = sprintf("%.1f", $movie->rate_kinopoisk);

            $defs[] = GCompsFactory::get_ttf_label_def(
                GCompGeom::place_top_right(
                    -1, L::$VOD_BUTTON_HEIGHT, -200, $y),
                null, $kp, 1, "#FFAFAFA0", L::$TEXT_SIZE,
                "imdb_label");

            $defs[] = GCompsFactory::get_image_def(
                GCompGeom::place_next_left_align_top(
                    L::$IMDB_WIDTH, L::$IMDB_HEIGHT,
                    -L::$VOD_INFO_RATING_ICON_RIGHT,
                    L::$IMDB_ICON_TEXT_DY),
                null, "plugin_file://icons/kp.png");
        }
		if (isset($movie->rate_details['MyShows:'])){
            $kp = sprintf("%.1f", $movie->rate_details['MyShows:']);

            $defs[] = GCompsFactory::get_ttf_label_def(
                GCompGeom::place_top_right(
                    -1, L::$VOD_BUTTON_HEIGHT, -350, $y),
                null, $kp, 1, "#FFAFAFA0", L::$TEXT_SIZE,
                "label");

            $defs[] = GCompsFactory::get_image_def(
                GCompGeom::place_next_left_align_top(
                    L::$IMDB_WIDTH, L::$IMDB_HEIGHT,
                    -L::$VOD_INFO_RATING_ICON_RIGHT,
                    L::$IMDB_ICON_TEXT_DY),
                null, "plugin_file://icons/s_myshows.png");
        }
        $y += L::$VOD_BUTTON_HEIGHT;

        {
            $x2 = 300; // TODO: revise
            $col2_w = self::$RIGHT_PANEL_WIDTH - 50 - $x2;

            if ($movie->actors_str != '' ||
                 $movie->directors_str != '' ||
                 $movie->scenarios_str != ''){
                $y += L::$VOD_MOVIE_DESCRIPTION_VGAP;
            }
			if (isset($movie->details["Слоган:"])){
                $geom = GCompGeom::place_top_left(
                    -1, L::$VOD_BUTTON_HEIGHT, 0, $y);
                $defs[] = GCompsFactory::get_ttf_label_def($geom,
                    null, 'Слоган:',
                    1, "#FFFFFF40", L::$TEXT_SIZE);

                $def = GCompsFactory::get_ttf_label_def(
                    GCompGeom::place_top_left(
                        $col2_w, L::$VOD_BUTTON_HEIGHT, 0, 0),
                    null, $movie->details["Слоган:"], 1, "#FFAFAFA0", L::$TEXT_SIZE);

                $defs[] = GCompsFactory::get_ppane_def("directors_ppane",
                    GCompGeom::place_top_left(
                        $col2_w, L::$VOD_BUTTON_HEIGHT, $x2, $y),
                    array($def));

                $y += L::$VOD_BUTTON_HEIGHT;
            }
			
            if (isset($movie->details["Продюсеры"])){
                $geom = GCompGeom::place_top_left(
                    -1, L::$VOD_BUTTON_HEIGHT, 0, $y);
                $defs[] = GCompsFactory::get_ttf_label_def($geom,
                    null, 'Продюсеры: ',
                    1, "#FFFFFF40", L::$TEXT_SIZE);

                $def = GCompsFactory::get_ttf_label_def(
                    GCompGeom::place_top_left(
                        $col2_w, L::$VOD_BUTTON_HEIGHT, 0, 0),
                    null, $movie->details["Продюсеры"], 1, "#FFAFAFA0", L::$TEXT_SIZE);

                $defs[] = GCompsFactory::get_ppane_def("actors_ppane",
                    GCompGeom::place_top_left(
                        $col2_w, L::$VOD_BUTTON_HEIGHT, $x2, $y),
                    array($def));

                $y += L::$VOD_BUTTON_HEIGHT;
            }

            if ($movie->directors_str != ''){
                $geom = GCompGeom::place_top_left(
                    -1, L::$VOD_BUTTON_HEIGHT, 0, $y);
                $defs[] = GCompsFactory::get_ttf_label_def($geom,
                    null, T::key_global("dune_tv_movie_directors"),
                    1, "#FFFFFF40", L::$TEXT_SIZE);

                $def = GCompsFactory::get_ttf_label_def(
                    GCompGeom::place_top_left(
                        $col2_w, L::$VOD_BUTTON_HEIGHT, 0, 0),
                    null, $movie->directors_str, 1, "#FFAFAFA0", L::$TEXT_SIZE);

                $defs[] = GCompsFactory::get_ppane_def("directors_ppane",
                    GCompGeom::place_top_left(
                        $col2_w, L::$VOD_BUTTON_HEIGHT, $x2, $y),
                    array($def));

                $y += L::$VOD_BUTTON_HEIGHT;
            }

            if ($movie->scenarios_str != ''){
                $geom = GCompGeom::place_top_left(
                    -1, L::$VOD_BUTTON_HEIGHT, 0, $y);
                $defs[] = GCompsFactory::get_ttf_label_def($geom,
                    null, T::key_global("dune_tv_movie_scenario"),
                    1, "#FF808080", L::$TEXT_SIZE);

                $def = GCompsFactory::get_ttf_label_def(
                    GCompGeom::place_top_left(
                        $col2_w, L::$VOD_BUTTON_HEIGHT, 0, 0),
                    null, $movie->scenarios_str, 1, "#FFAFAFA0", L::$TEXT_SIZE);

                $defs[] = GCompsFactory::get_ppane_def("scenario_ppane",
                    GCompGeom::place_top_left(
                        $col2_w, L::$VOD_BUTTON_HEIGHT, $x2, $y),
                    array($def));

                $y += L::$VOD_BUTTON_HEIGHT;
            }
			if ($movie->actors_str != ''){
                $geom = GCompGeom::place_top_left(
                    -1, L::$VOD_BUTTON_HEIGHT, 0, $y);
                $defs[] = GCompsFactory::get_ttf_label_def($geom,
                    null, T::key_global("dune_tv_movie_cast"),
                    1, "#FFFFFF40", L::$TEXT_SIZE);

                $def = GCompsFactory::get_ttf_label_def(
                    GCompGeom::place_top_left(
                        $col2_w, L::$VOD_BUTTON_HEIGHT, 0, 0),
                    null, $movie->actors_str, 1, "#FFAFAFA0", L::$TEXT_SIZE);

                $defs[] = GCompsFactory::get_ppane_def("actors_ppane",
                    GCompGeom::place_top_left(
                        $col2_w, L::$VOD_BUTTON_HEIGHT, $x2, $y),
                    array($def));

                $y += L::$VOD_BUTTON_HEIGHT;
            }
            if ($movie->description != ''){
                $y += L::$VOD_MOVIE_DESCRIPTION_VGAP;
				
                $geom = GCompGeom::place_top_left(
                    self::$RIGHT_PANEL_WIDTH - 50, -1, 0, $y);
				
                $defs[] = GCompsFactory::get_ttf_label_def($geom,
                    null, $movie->description, 0, "#FFFFFFE0", L::$TEXT_SIZE);
				$geom = GCompGeom::place_below_left(
                        self::$RIGHT_PANEL_WIDTH - 50, 3,
                        0, L::$VOD_DESCRIPTION_HR_TOP);
                $defs[] = GCompsFactory::get_rect_def($geom, null, "#FF404040");
				
				
                if (isset($movie->details)){
                    foreach ($movie->details as $k => $v){
						 if (preg_match('|Факт|', $k)){
							$defs[] = GCompsFactory::get_ttf_label_def($geom,
							null, 'Знаете ли вы, что:',
							1, "#FFFFFF40", L::$TEXT_SIZE);
							 $geom = GCompGeom::place_below_left(
							self::$RIGHT_PANEL_WIDTH - 50, 3,
							0, L::$VOD_DESCRIPTION_HR_TOP);
							$defs[] = GCompsFactory::get_rect_def($geom, null, "#FF404040");

							$geom = GCompGeom::place_below_left(
							self::$RIGHT_PANEL_WIDTH - 50, -1,
							0, L::$VOD_DESCRIPTION_HR_BOTTOM);
							$defs[] = GCompsFactory::get_ttf_label_def($geom,
							null, $k .': '. $v, 0, "#FFAFAFA0", L::$TEXT_SIZE);
						 }
						
					}
					
                }
            }
			
        }

        $spane_height = !$this->cur_movie_confirm_needed ?
            self::$RIGHT_PANEL_HEIGHT :
            self::$RIGHT_PANEL_HEIGHT - self::$TOP_PANEL_HEIGHT;
        $spane_def = GCompsFactory::get_vertical_spane_def("movie_center_spane",
            GCompGeom::place_top_left(
                self::$RIGHT_PANEL_WIDTH, $spane_height,
                0, 0),
            null, $defs);

        $mid_pane_defs = array();
        $mid_pane_defs[] = $spane_def;
        $right_pane_defs[] = GCompsFactory::get_panel_def("movie_center_pane",
            $this->do_get_movie_center_geom($button_sel),
            null, $mid_pane_defs);

        return $right_pane_defs;
    }

    private function do_get_movie_play_panel_children($movie){
        return $this->do_get_movie_play_or_info_panel_children($movie, 0);
    }

    private function do_get_movie_info_panel_children($movie){
        return $this->do_get_movie_play_or_info_panel_children($movie, 1);
    }

    private static function place_top_left_by_center($w, $h, $x, $y){
        return GCompGeom::geom($w, $h, null,
            GCompGeom::align($x, $y, null, null,
                HALIGN_LEFT, VALIGN_CENTER, HALIGN_LEFT, VALIGN_TOP));
    }

	private function do_get_movie_objects_panel_def($movie, $button_sel, $item_sel, $item_top){
        $this->cur_object_info = $this->cur_object_ids = $cur_object_ids = $defs = array();
		$item_ndx = 0;
		if (!isset($movie->trailers)){
			$i=0;
			secondTry:
			$str = HD::asyncExec($this->cmdAsyncExec);
			if (!empty($str)){
				if ($str != '[]'){
					$infArr = json_decode($str);
					foreach ($infArr as $k => $v){
						$this->cur_movie->{$k} = $v;
						$movie->{$k} = $v;
					}
				}
			}else if ($i < 20){
				$i++;
				sleep (1);
				goto secondTry;
			}
		}
        $row_height = L::$VOD_LIST_SEL_POSTER_HEIGHT + L::$VOD_LIST_ICON_V_PADDING * 2;
        $y = $row_height * $item_top + L::$VOD_LIST_ICON_V_PADDING;
		$cur_object_ids = array();
		if (($button_sel == 2)&&(isset($movie->trailers)))
			$cur_object_ids =  $movie->trailers;
		if (($button_sel == 3)&&(isset($movie->class_info['dbIDs']['kpID'])))
			$cur_object_ids =  Kinopoisk_Class::getKPFilmsListsArr($movie->class_info['dbIDs']['kpID'], 3);
		if (($button_sel == 4)&&(isset($movie->class_info['dbIDs']['kpID'])))
			$cur_object_ids =  Kinopoisk_Class::getKPFilmsListsArr($movie->class_info['dbIDs']['kpID'], 4);
		if (($button_sel == 5)&&(isset($movie->class_info['dbIDs']['kpID'])))
			$cur_object_ids =  Kinopoisk_Class::getKPFilmsListsArr($movie->class_info['dbIDs']['kpID'], 5);
		if (($button_sel == 6)&&(isset($movie->class_info['dbIDs']['kpID'])))
			$cur_object_ids = Kinopoisk_Class::getKPCreatorsListsArr($movie->class_info['dbIDs']['kpID']);
        foreach ($cur_object_ids as $k => $v){
			$role = '';
            if ($button_sel == 6){
                $image_url = Kinopoisk_Class::http_get_img("http://st.kp.yandex.net/images/actor_iphone/iphone360_".$v->id.".jpg");
                $not_loaded_url = "plugin_file://icons/loading_person_photo.png";
                $load_failed_url = "plugin_file://icons/loading_person_photo.png";
				if ($v->nameRU != ''){
					$title = $v->nameRU;
					$captionEN = $v->nameEN;
				}else{
					$title = $v->nameEN;
					$captionEN = '';
				}
				if ($captionEN != '')
					$title .= ' (' .$captionEN.')';
				if ($v->professionText != '')
					$role = str_replace("ры", "р",$v->professionText);
				if ((isset($v->description))&&($v->description != ''))
					$role = $v->description;
				$this->cur_object_ids[] = $v->id;
				$this->cur_object_info[$v->id]['title'] = $title;
				$this->cur_object_info[$v->id]['image_url'] = $image_url;
			}
			if ($button_sel == 2){
                $image_url = $v->file_info->icon_path;
                $not_loaded_url = "plugin_file://icons/poster_none.png";
                $load_failed_url = "plugin_file://icons/poster_none.png";
                $title = $v->title;
				$this->cur_object_ids[] = $v->id;
            }
			if (($button_sel == 3)||($button_sel == 4)||($button_sel == 5)){
                $image_url =  Kinopoisk_Class::http_get_img("http://st.kp.yandex.net/images/film_iphone/iphone360_$v->id.jpg");
                $not_loaded_url = "plugin_file://icons/poster_none.png";
                $load_failed_url = "plugin_file://icons/poster_none.png";
                $title = $v->nameRU;
				if ((isset($v->nameEN))&&($v->nameEN != ''))
					$role = $v->nameEN;
				$this->cur_object_ids[] = $v->id;
                $this->cur_object_info[$v->id]['title'] = $title;
				$this->cur_object_info[$v->id]['image_url'] = $image_url;
            }

            $selected = $item_ndx == $item_sel;

            $x1 = L::$VOD_LIST_ICON_X_OFFSET;
            $img_def = GCompsFactory::get_image_def(
				$this->do_get_item_img_geom($item_ndx, $selected, $button_sel),
                null, 
				$image_url, 
				false, 
				true, 
				$not_loaded_url, 
				$load_failed_url
			);
            $img_def[GComponentDef::id] = "img$item_ndx";
			if ($button_sel != 2)
				$x1 += L::$VOD_LIST_POSTER_WIDTH + L::$VOD_LIST_ICON_RIGHT + L::$VOD_LIST_TEXT_INDENT;
			else
				$x1 = 70;
            $geom = self::do_get_item_text_geom($x1);
			
            $name_def = GCompsFactory::get_ttf_label_def($geom,
                null, $title, 1, self::do_get_item_text_color($selected),
                self::do_get_item_text_size($selected));
            $name_def[GComponentDef::id] = "name$item_ndx";

            $geom = self::do_get_item_text_geom2($x1);
            $role_def = GCompsFactory::get_ttf_label_def($geom,
                null, $role, 1, self::do_get_item_text_color2($selected), 
                self::do_get_item_text_size($selected));
            $role_def[GComponentDef::id] = "role$item_ndx";

            $defs[] = GCompsFactory::get_panel_def("item$item_ndx",
                $this->do_get_item_geom($item_ndx - $item_top, $button_sel),
                null,
                array(
                    $img_def, $name_def, $role_def
                ));
            $y += $row_height;
			$item_ndx++;
        }

        return GCompsFactory::get_panel_def("movie_info_pane",
            GCompGeom::place_top_left(
                L::$VOD_PEOPLE_PANEL_WIDTH, L::$VOD_PANEL_HEIGHT,
                0, 0),
            null,
            $defs);
    }
    
    public static function object_info_panel_get_children($movie, $button_sel, $item_sel){
        $cur_object_ids = $defs = array();
		if (($button_sel == 2)&&(isset($movie->trailers)))
			$cur_object_ids =  (array)$movie->trailers;
		if (($button_sel == 3)&&(isset($movie->class_info['dbIDs']['kpID'])))
			$cur_object_ids =  Kinopoisk_Class::getKPFilmsListsArr($movie->class_info['dbIDs']['kpID'], 3);
		if (($button_sel == 4)&&(isset($movie->class_info['dbIDs']['kpID'])))
			$cur_object_ids =  Kinopoisk_Class::getKPFilmsListsArr($movie->class_info['dbIDs']['kpID'], 4);
		if (($button_sel == 5)&&(isset($movie->class_info['dbIDs']['kpID'])))
			$cur_object_ids =  Kinopoisk_Class::getKPFilmsListsArr($movie->class_info['dbIDs']['kpID'], 5);
		if (($button_sel == 6)&&(isset($movie->class_info['dbIDs']['kpID'])))
			$cur_object_ids = Kinopoisk_Class::getKPCreatorsListsArr($movie->class_info['dbIDs']['kpID']);

        if (isset($cur_object_ids[$item_sel])){
			$v = $cur_object_ids[$item_sel];
			$is_person = $button_sel == 6;
            if ($is_person){
                $image_url = Kinopoisk_Class::http_get_img("http://st.kp.yandex.net/images/actor_iphone/iphone360_".$v->id.".jpg");
                $not_loaded_url = "plugin_file://icons/loading_person_photo.png";
                $load_failed_url = "plugin_file://icons/loading_person_photo.png";
                $low_quality_url = "plugin_file://icons/loading_person_photo.png";
            }
			if ($button_sel == 2){
                $image_url = $movie->poster_url;
                $not_loaded_url = "plugin_file://icons/poster_none.png";
                $load_failed_url = "plugin_file://icons/poster_none.png";
                $low_quality_url = "plugin_file://icons/loading_person_photo.png";
            }
			if (($button_sel == 3)||($button_sel == 4)||($button_sel == 5)){
                $image_url =  Kinopoisk_Class::http_get_img("http://st.kp.yandex.net/images/film_iphone/iphone360_$v->id.jpg");
                $not_loaded_url = "plugin_file://icons/poster_none.png";
                $load_failed_url = "plugin_file://icons/poster_none.png";
				$low_quality_url = "plugin_file://icons/loading_person_photo.png";
            }

            $defs[] = GCompsFactory::get_image_def(
                GCompGeom::place_top_left(
                    L::$VOD_POSTER_WIDTH, 
					L::$VOD_POSTER_HEIGHT,
                    0, 
					0
				),
                null, 
				$image_url, 
				false, 
				true,
                $not_loaded_url, 
				$load_failed_url, 
				$low_quality_url
			);

            $w = L::$VOD_PERSON_INFO_PANEL_WIDTH;
            $y_offset = L::$VOD_INFO_POSTER_BOTTOM;

            if ($is_person){
				if ($v->nameRU != ''){
					$props['Имя:'] = $v->nameRU;
					if ($v->nameEN != '')
						$props['Имя eng:'] = $v->nameEN;
				}else
					$props['Имя eng:'] = $v->nameEN;

                if ($v->professionText != '')
                    $props[1] = str_replace("ры", "р",$v->professionText);
                if ((isset($v->description))&&($v->description != ''))
                    $props[2] = $v->description;

                $w1 = $w - L::$VOD_INFO_TEXT_INDENT;
                $x1 = L::$VOD_INFO_TEXT_INDENT;

                $ndx = 0;
                foreach ($props as $key => $value){
                    if (!is_numeric($key))
					$defs[] = GCompsFactory::get_ttf_label_def(
                        GCompGeom::place_below_left(
                            $w, -1, $ndx == 0 ? 0 : -$x1, $ndx == 0 ? $y_offset : 0),
                        null, $key, 1, "#FF808080", L::$TEXT_SIZE);

                    $defs[] = GCompsFactory::get_ttf_label_def(
                        GCompGeom::place_below_left($w1, -1, $x1, -L::$PAR_VGAP_SMALL),
                        null, $value, 2, "#FFAFAFA0", L::$TEXT_SIZE);

                    $ndx++;
                }
            }
			if ($button_sel == 3){
                $y_offset = L::$VOD_INFO_POSTER_BOTTOM + L::$IMDB_ICON_TEXT_DY;
                if ($v->rating != ''){
                    $sub_defs[] = GCompsFactory::get_image_def(
                        GCompGeom::place_below_left(
                            L::$IMDB_WIDTH, L::$IMDB_HEIGHT, 0, 0),
                        null, "plugin_file://icons/kp.png");

                    $x = L::$VOD_INFO_RATING_ICON_RIGHT;
                    $y = -L::$IMDB_ICON_TEXT_DY;

                    $kp = sprintf("%.1f", $v->rating);

                    $sub_defs[] = GCompsFactory::get_ttf_label_def(
                        GCompGeom::place_next_right_align_top(
                            -1, L::$VOD_BUTTON_HEIGHT, $x, $y),
                        null, $kp, 1, "#FFAFAFA0", L::$TEXT_SIZE);

                    $defs[] = GCompsFactory::get_ppane_def(null,
                        GCompGeom::place_below_left(
                            -1, -1, 0, $y_offset),
                        $sub_defs);
                    $y_offset = 0;
                }

                if ((isset ($v->filmLength))&& ($v->filmLength != '')){
					$length = '';
					if (preg_match("/(\d*):(\d\d)/i", $v->filmLength, $tmp))
						$length = ($tmp[1]*60+$tmp[2]);
                    $txt = "%ext%<key_global>dune_tv_movie_length_min__1<p>$length</p></key_global>";
                    $defs[] = GCompsFactory::get_ttf_label_def(
                        GCompGeom::place_below_left(
                            $w, -1, 0, $y_offset),
                        null, $txt, 1, "#FFAFAFA0", L::$TEXT_SIZE);
                }
				if ((isset ($v->year))&& ($v->year != '')){
					$y_offset = L::$VOD_INFO_POSTER_BOTTOM + L::$IMDB_ICON_TEXT_DY;
					$defs[] = GCompsFactory::get_ttf_label_def(
                        GCompGeom::place_below_left(
                            $w, -1, 0, $y_offset),
                        null, "Год: " . $v->year, 1, "#FFAFAFA0", L::$TEXT_SIZE);
				}
            }
        }
        return $defs;
    }

    private function do_get_object_info_panel_children($movie, $button_sel, $item_sel){
        return self::object_info_panel_get_children($movie, $button_sel, $item_sel);
    }

    private function do_get_object_info_panel_def($movie, $button_sel, $item_sel){
        return GCompsFactory::get_panel_def("object_info_panel",
            GCompGeom::place_top_right(
                L::$VOD_PERSON_INFO_PANEL_WIDTH, -1,
                0, 0),
            null,
            $this->do_get_object_info_panel_children($movie, $button_sel, $item_sel));
    }

    private function do_get_movie_objects_right_panel_children($movie, $button_sel, $item_sel, $item_top){
        $defs = array(
            $this->do_get_movie_objects_panel_def($movie, $button_sel, $item_sel, $item_top),
            $this->do_get_object_info_panel_def($movie, $button_sel, $item_sel),
        );

        return array(GCompsFactory::get_panel_def("movie_center_pane",$this->do_get_movie_center_geom($button_sel), null, $defs));
    }

    private function do_get_right_panel_children($button_sel, $item_sel, $item_top){
        if ($button_sel == 0)
            return $this->do_get_movie_play_panel_children($this->cur_movie);
        if ($button_sel == 1)
            return $this->do_get_movie_info_panel_children($this->cur_movie);
        if (($button_sel >= 2)&&($button_sel <= 6))
            return $this->do_get_movie_objects_right_panel_children($this->cur_movie, $button_sel, $item_sel, $item_top);
        return array();
    }

    private function do_get_right_panel_def($button_sel, $item_sel, $item_top){
        return GCompsFactory::get_panel_def("right_panel",
            GCompGeom::place_top_left(
                self::$RIGHT_PANEL_WIDTH,
                L::$HEIGHT - L::$VOD_PANEL_TOP - L::$VOD_PANEL_BOTTOM,
                self::$RIGHT_PANEL_X,
                L::$VOD_PANEL_TOP),
            NULL,
            $this->do_get_right_panel_children($button_sel, $item_sel, $item_top));
    }

    private function do_get_comp_defs($sel_kind, $button_sel, $item_sel, $item_top){
        $defs = array();
        if ($this->cur_movie == null)
            return $defs;

        $defs[] = $this->do_get_left_bg_def();
        $defs[] = $this->do_get_center_bg_def($button_sel);

        if ($this->cur_movie_confirm_needed)
            $defs[] = $this->do_get_top_pane($this->cur_movie, $button_sel);

        $defs[] = GCompsFactory::get_image_def(
            GCompGeom::place_top_left(
                L::$VOD_BACK_ARROW_SIZE,
                L::$VOD_BACK_ARROW_SIZE,
                L::$VOD_BACK_ARROW_LEFT2,
                L::$HEIGHT - L::$VOD_PANEL_BOTTOM - L::$VOD_BACK_ARROW_SIZE - 5),
            null, "plugin_file://icons/back.png");

        $sel_def = GCompsFactory::get_image_def(
            $this->do_get_sel_geom($sel_kind, $button_sel, $item_sel), null,
            "plugin_file://icons/pic3.aai", false, true);
        $sel_def[GComponentDef::id] = "sel";
        $defs[] = $sel_def;

        $defs[] = $this->do_get_poster_panel_def($this->cur_movie);
        $defs[] = $this->do_get_right_panel_def($button_sel, $item_sel, $item_top);
        $defs[] = $this->do_get_confirm_hints_pane($button_sel);
        return $defs;
    }
	protected function add_comp_items(&$items, $button_id){
        foreach ($this->cur_object_ids as $id){
            $this->add_comp_item_by_id($items, $button_id, $id);
		}
    }
	protected function add_comp_item_by_id(&$items, $button_id, $id){
        if ($button_id == 2){
			if ((isset($this->cur_movie->trailers))&&(count($this->cur_movie->trailers) > 0)){
				$items[] = GCompsFactory::get_comp_item_def(
					$id, $this->cur_movie->trailers->$id->title, $this->cur_movie->trailers->$id->file_info->icon_path);
			}
		}
		if ($button_id > 2)
			$items[] = GCompsFactory::get_comp_item_def(
                $id, $this->cur_object_info[$id]['title'], $this->cur_object_info[$id]['image_url']);
		
    }
	protected function get_default_comp_item_load_failed_url($button_id){
        if ($button_id == 6)
            return "plugin_file://icons/loading_person_photo.png";
		else
			 return "plugin_file://icons/poster_none.png";
        return null;
    }
	private function do_get_ui_state($sel_state, $bg_url=null, $poster_url=null){
        $items = array();
        $view_params = null;
        if ($sel_state->sel_kind == 0){
            for ($i = 0; $i < $this->cur_movie_num_buttons; $i++){
                $caption = self::get_button_caption($i);
                $items[] = GCompsFactory::get_button_item_def($i, $caption);
            }

            $title = null;
            $loading_url = null;
            $load_failed_url = null;
        }else if ($sel_state->sel_kind == 1){
            $button_id = $this->cur_button_sel;
            $this->add_comp_items($items, $button_id);
            $title = self::get_button_caption($button_id);
            $view_params = array(
                'loading_url' => $this->get_default_comp_item_loading_url($button_id),
                'load_failed_url' => $this->get_default_comp_item_load_failed_url($button_id),
            );
        }

        return GCompsFactory::get_gcomp_ui_state_def($items, $title, $bg_url, $poster_url, $view_params);
    }
	protected function get_default_comp_item_loading_url($button_id){
        if ($button_id > 1 && $button_id < 6)
            return "plugin_file://icons/poster_none.png";
        if ($button_id == 6)
            return "plugin_file://icons/loading_person_photo.png";
        return null;
    }
    public function get_window_def(MediaURL $media_url, &$plugin_cookies){    
		$this->vod->folder_entered($media_url, $plugin_cookies);
		$this->vod->folder_movie = $media_url->get_raw_string();
        $this->sync_current_folder($media_url, false);
		if (isset($this->vod->ifx)){
			$this->vod->clear_cached_movie();
			unset($this->cur_movie_id);
			unset($this->cur_movie);
			unset($this->vod->ifx);
		}
        if (!isset($this->cur_movie))
            $this->ensure_movie($media_url->get_raw_string());
		
		$nlbg = $bg = SmartConfig::getPluginIco(self::ID . '_bg');
		if (isset($this->cur_movie->background_urls))
			$bg =  $this->cur_movie->background_urls[array_rand($this->cur_movie->background_urls)];
		$ui_state = null;
		if (HD::is_android() == true)
			$ui_state = $this->do_get_ui_state($this->get_selection_state(), $bg, $this->cur_movie->poster_url);
		///////////////////////////////////
        return GCompsFactory::get_window_def(
			$this->do_get_comp_defs(
				$this->cur_sel_kind, 
				$this->cur_button_sel,	
				$this->cur_item_sel, 
				$this->cur_item_top
			),
			$ui_state,
			$bg,
			'rgb(0,0,0)',
			$nlbg,
			true,
			0x00
		);
    }
	protected static function do_get_selection_state($slideshow,
        $sel_kind, $button_id, $item_sel, $item_top, $item_id){
        return (object) array(
            'slideshow' => $slideshow,
            'sel_kind' => $sel_kind,
            'button_id' => $button_id,
            'item_sel' => $item_sel,
            'item_top' => $item_top,
            'item_id' => $item_id);
    }
	public function get_selection_state(){
        return self::do_get_selection_state(
            null,
            $this->cur_sel_kind,
            $this->cur_button_sel,
            $this->cur_item_sel,
            $this->cur_item_top,
            $this->cur_item_sel);
    }
    public function get_action_map(MediaURL $media_url, &$plugin_cookies){
		if (!isset($this->cur_movie))
			return;
		$actions = array();
		$actions[GUI_EVENT_KEY_ENTER]				= UserInputHandlerRegistry::create_action($this, 'enter');
		$actions[GUI_EVENT_KEY_LEFT]				= UserInputHandlerRegistry::create_action($this, 'change', array('op' => 'left'));
		$actions[GUI_EVENT_KEY_RETURN]				= UserInputHandlerRegistry::create_action($this, 'change', array('op' => 'left'));
		$actions[GUI_EVENT_KEY_RIGHT]				= UserInputHandlerRegistry::create_action($this, 'change', array('op' => 'right'));
		$actions[GUI_EVENT_KEY_P_PLUS]				= UserInputHandlerRegistry::create_action($this, 'change', array('op' => 'page_up'));
		$actions[GUI_EVENT_KEY_P_MINUS]				= UserInputHandlerRegistry::create_action($this, 'change', array('op' => 'page_down'));
		$actions[GUI_EVENT_KEY_UP]					= UserInputHandlerRegistry::create_action($this, 'change', array('op' => 'up'));
		$actions[GUI_EVENT_KEY_DOWN]				= UserInputHandlerRegistry::create_action($this, 'change', array('op' => 'down'));
		
		$actions[GUI_EVENT_KEY_1] = UserInputHandlerRegistry::create_action($this, 'change', array('op' => 'key', 'num' => 0));
		$actions[GUI_EVENT_KEY_2] = UserInputHandlerRegistry::create_action($this, 'change', array('op' => 'key', 'num' => 1));
		$actions[GUI_EVENT_KEY_3] = UserInputHandlerRegistry::create_action($this, 'change', array('op' => 'key', 'num' => 2));
		$actions[GUI_EVENT_KEY_4] = UserInputHandlerRegistry::create_action($this, 'change', array('op' => 'key', 'num' => 3));
		$actions[GUI_EVENT_KEY_5] = UserInputHandlerRegistry::create_action($this, 'change', array('op' => 'key', 'num' => 4));
		$actions[GUI_EVENT_KEY_6] = UserInputHandlerRegistry::create_action($this, 'change', array('op' => 'key', 'num' => 5));
		$actions[GUI_EVENT_KEY_7] = UserInputHandlerRegistry::create_action($this, 'change', array('op' => 'key', 'num' => 6));
		
		$actions[GUI_EVENT_KEY_SETUP]				=  ActionFactory::open_folder('setup', "Настройки");
		$actions[GUI_EVENT_KEY_POPUP_MENU]			= UserInputHandlerRegistry::create_action($this, 'rightButtonAction');
		$actions[GUI_EVENT_MENU_PLAYBACK_FINISH]	= UserInputHandlerRegistry::create_action($this, 'menu_playback_finish');
			
			
		$actions[GUI_EVENT_KEY_SEARCH]				= ActionFactory::open_folder('search_screen',"Поиск");
		$actions[GUI_EVENT_KEY_B_GREEN]				= UserInputHandlerRegistry::create_action($this, 'classAction', array('action' => 'search'));
		if (isset($this->cur_movie->class_info['dbIDs']['kpID']))
			$actions[GUI_EVENT_KEY_C_YELLOW]		= UserInputHandlerRegistry::create_action($this, 'classAction', array('action' => 'reviews', 'indiClass' => 'Kinopoisk_Class', 'kpID' => $this->cur_movie->class_info['dbIDs']['kpID']));

		$actions[GUI_EVENT_KEY_D_BLUE]				= UserInputHandlerRegistry::create_action($this, 'classAction', array('action' => 'addToFav'));
		$actions[GUI_EVENT_KEY_INFO]				= UserInputHandlerRegistry::create_action($this, "reload");
		if (HD::is_android() == true)
			$actions[GUI_EVENT_UI_ACTION] 			= UserInputHandlerRegistry::create_action($this,'ui_action');

		return $actions;
    }
	public function get_cur_sel_state_str()
    {
        return isset($this->cur_sel_state) ?
            json_encode($this->cur_sel_state) : null;
    }
    public function handle_user_input(&$user_input, &$plugin_cookies){
        $media_url = MediaURL::decode($user_input->parent_media_url);
        $this->sync_current_folder($media_url, true);
        if (!isset($this->cur_movie))
            return null;
        if (!isset($user_input->control_id))
            return null;
		
        $new_ui_state = $change_defs = null;
        $need_enter = $this->cur_sel_kind == 1 &&($user_input->control_id == 'enter' || (isset($user_input->ui_action) && $user_input->ui_action == 'enter') || ($user_input->control_id == 'change' && $user_input->op == 'right'));

		if ($need_enter){
            if ($this->cur_item_sel >= count($this->cur_object_ids))
                return null;
            $object_id = $this->cur_object_ids[$this->cur_item_sel];
			if (isset($user_input->ui_action_item_id))
				$object_id = $user_input->ui_action_item_id;
			if ($this->cur_button_sel == 2){
				if ((isset ($this->cur_movie->trailers->{$object_id}->id))&&
				($this->cur_movie->trailers->{$object_id}->id == 'empty'))
					return null;
				if (isset ($this->cur_movie->trailers->{$object_id}->file_info->hls_v4)){
					if (HD::is_android() == true){
						$android_action = (HD::getItemStr('android_action', true) != '') ? HD::getItemStr('android_action', true) : 0;
						if ($android_action == 2){
							if (isset($this->cur_movie->history_mUrl)){
								$itemsHistory = HD::getItemsArr('itemsHistory');
								if (isset($itemsHistory[$this->cur_movie->history_mUrl]))
									unset ($itemsHistory[$this->cur_movie->history_mUrl]);
								$history_str = "||Просмотрено: ".date("d.m.Y") .'|'. $selected_media_url->name . $selected_media_url->detailed_info;
								$itemsHistory = array($this->cur_movie->history_mUrl => $history_str) + $itemsHistory;
								$posterCasheHist = (HD::getItemStr('posterCasheHist') != '') ? HD::getItemStr('posterCasheHist') : 0;
								if ($posterCasheHist == 1){
									$output = array_slice($itemsHistory, 310);
									$cachePath = HD::get_data_path() . "/pluginCache/";
									if (count($output) > 0){
										foreach ($output as $k => $v){
											$cUrl = MediaURL::decode($k);
											$arrCachePath = $cachePath . md5($cUrl->movie_id . $cUrl->class_name) . '.srz';
											$cachePosterUrl = $cachePath . md5($k) . '.jpg';
											if (file_exists($cachePosterUrl))
												shell_exec('rm -rf "'.$cachePosterUrl.'" &');
											if (file_exists($arrCachePath))
												shell_exec('rm -rf "'.$arrCachePath.'" &');
										}
									}
									if (isset($this->cur_movie->casheHistArr)){
										$cUrl = MediaURL::decode($this->cur_movie->history_mUrl);
										$arrCachePath = $cachePath . md5($cUrl->movie_id . $cUrl->class_name) . '.srz';
										if (!file_exists($arrCachePath)){
											$cachePosterUrl = $cachePath . md5($k) . '.jpg';
											if (!file_exists($arrCachePath))
												HD::imgCache($cUrl->poster_url, md5($this->cur_movie->history_mUrl) . '.jpg');
											HD::pluginCache(serialize($this->cur_movie->casheHistArr), md5($cUrl->movie_id . $cUrl->class_name) . '.srz');
										}
									}
								}
								$itemsHistory = array_slice($itemsHistory, 0, 310);
								HD::saveItemsArr('itemsHistory', $itemsHistory);
							}
							if ($this->cur_movie->trailers->{$object_id}->file_info->is_stream_url == false)
								$url = mUrl::get_link($this->cur_movie->trailers->{$object_id}->playback_url, 5);
							else
								$url = $this->cur_movie->trailers->{$object_id}->playback_url;
							return HD::get_android_action($url, 'video');
						}
					}
				}
				$this->cur_movie->series_list = array();
				foreach ($this->cur_movie->trailers as $id => $item){
					if (isset($item->file_info)){
						$item->file_info->parent_media_url = $user_input->parent_media_url;
						$file_info = (array)$item->file_info;
					}
					$this->cur_movie->add_series_data(
						$item->id,
						$item->title,
						$item->playback_url,
						false,
						$file_info
					);
				}
				return ActionFactory::vod_play($this->cur_movie->get_vod_info($object_id,0));
            }
			if (( $this->cur_button_sel == 3)||( $this->cur_button_sel == 4)||( $this->cur_button_sel == 5)){
				$this->cbsHistr[] = $this->cur_button_sel;
				$this->cisHistr[] = $this->cur_item_sel;
				$this->coiHistr[] = $this->cur_object_ids;
				return ActionFactory::open_folder(self::get_media_url_str('Kinopoisk_Class', array('movie_id' => $object_id, 'caption' => $this->cur_object_info[$object_id]['title'], 'poster_url' => $this->cur_object_info[$object_id]['image_url'])), $this->cur_object_info[$object_id]['title']);
			}
			if ( $this->cur_button_sel == 6){
				return ActionFactory::open_folder(SmartVodListScreen::get_media_url_str('Kinopoisk_Class', array('categoryId' => 'KPPeople' . $object_id)), $this->cur_object_info[$object_id]['title']);
			}
        }
		if ($user_input->control_id == 'coi'){
			$this->cur_object_ids = array_pop($this->coiHistr);
			return null;
		}
		
        if ($user_input->control_id == 'enter')
            $op = 'right';

        if ($user_input->control_id == 'menu_playback_finish'){
			if ( $this->cur_button_sel == 2){
				//todo: gone
			}
        }
		if ($user_input->control_id == 'classAction'){
			$defs = array();
			hd_silence_warnings();
			if ((isset($user_input->delMyShowId))||(isset($user_input->delSearchKpId))){
				$this->vod->clear_cached_movie();
				$this->cur_movie_id = null;
				$this->cur_movie = null;
			}
			if (isset($user_input->indiClass)){
				$class_name = $user_input->indiClass;
				return $class_name::classAction ($defs, $user_input);
			}
			return SmartConfig::classAction ($defs, $user_input);
		}
		if ($user_input->control_id == 'rightButtonAction'){
			$defs = array();
			hd_silence_warnings();
			if (isset($this->vod->mShowsA))
				$user_input->mShowsA = $this->vod->mShowsA;
			return SmartConfig::rightButtonAction ($this->cur_movie, $user_input, $this->left_button_caption);
		}
		if ($user_input->control_id == 'ifx'){
			$this->vod->ifx = true;
			return ActionFactory::invalidate_folders(array($user_input->inv), $post_action);
		}
        if (isset($op) || isset($user_input->ui_action) || $user_input->control_id == 'change'){
			if ($user_input->control_id == 'ui_action'){
				if ($user_input->ui_action == 'return'){
					$op = 'left';
				}else{
					$op = 'key';
					
					// $op_id = $user_input->ui_action_item_id;
					// if ($this->item_id_to_sel_ndx($op_id) === false)
						// return null;
				}

				if (($user_input->ui_action == 'enter')&&($user_input->ui_action_item_id < 2))
					$op = 'right';
				
			}
			if (!isset($op))
                $op = $user_input->op;
            if ($op == 'left' && $this->cur_sel_kind == 0){
				$this->cur_button_sel = $this->cur_sel_kind = 0;
				$action = null;
				if ((isset($this->cbsHistr))&&(count($this->cbsHistr)>0)){
					$this->cur_sel_kind = 1;
					$this->cur_button_sel = array_pop($this->cbsHistr);
					$this->cur_item_sel = array_pop($this->cisHistr);
					
					$action = UserInputHandlerRegistry::create_action($this, 'coi');
				}
                return ActionFactory::close_and_run($action);
			}

            $new_sel_kind = $this->cur_sel_kind;
            $new_button_sel = $this->cur_button_sel;
            $new_item_sel = $this->cur_item_sel;
            $new_item_top = $this->cur_item_top;

            $y_offset = 0;
            if ($this->cur_button_sel == 1){
                if ($op == 'page_up')
                    $y_offset = -L::$VOD_SCROLL_SIZE;
                else if ($op == 'page_down')
                    $y_offset = L::$VOD_SCROLL_SIZE;
            }

            if ($op == 'right'){
                if ($this->cur_sel_kind != 0)
                    return null;
                if ($this->cur_button_sel == 1)
                    return $this->get_play_action($user_input->parent_media_url);
                if ($this->cur_button_sel == 0)
                    return $this->get_play_action($user_input->parent_media_url);
                $new_sel_kind = 1;
            }else if ($op == 'left'){
                $new_sel_kind=0;
            }else if ($op == 'up'){
                if ($this->cur_sel_kind == 0){
					if ($this->cur_button_sel ==0)
						$new_button_sel = $this->cur_movie_num_buttons - 1;
					else
						$new_button_sel = max(0, $this->cur_button_sel - 1);
                }else{
                    $new_item_sel = max(0, $this->cur_item_sel - 1);
                    $new_item_top = self::get_item_top($new_item_sel, count($this->cur_object_ids));
                }
            }else if ($op == 'down'){
                if ($this->cur_sel_kind == 0){
					if ($this->cur_movie_num_buttons == $this->cur_button_sel + 1)
						$new_button_sel = 0;
					else
						$new_button_sel = min($this->cur_movie_num_buttons - 1, $this->cur_button_sel + 1);
                }else{
                    $new_item_sel = min(count($this->cur_object_ids) - 1, $this->cur_item_sel + 1);
                    $new_item_top = self::get_item_top($new_item_sel, count($this->cur_object_ids));
                }
			}else if ($op == 'key'){
				$cur_sel_kind = 0;
				$new_sel_kind = 0;
				if (isset($user_input->ui_action_item_id)){
					
					$new_button_sel = $user_input->ui_action_item_id;
					if ($new_button_sel > 1)
						$new_sel_kind = 1;
				}else
					$new_button_sel = $user_input->num;
            }
            if ($new_button_sel != $this->cur_button_sel){
                $new_item_sel = 0;
                $new_item_top = 0;
            }
			if ($new_item_sel == -1){
				$new_item_sel = 1;
			}
            if ($y_offset != 0){
                $change_defs[] = GCompsFactory::get_change_def(
                    'movie_center_spane', 
					null, 
					null,
                    GCompsFactory::get_view_position_def(
						0, 
						$y_offset
					)
				);
            }
			$new_sel_state = self::do_get_selection_state(
				null,
				$new_sel_kind,
				$new_button_sel,
				$new_item_sel,
				$new_item_top,
				$new_item_sel
			);
			
            if ($new_sel_kind != $this->cur_sel_kind || $new_button_sel != $this->cur_button_sel || $new_item_sel != $this->cur_item_sel){
			
				$transition = GCOMP_TRANSITION_DEFAULT;

                if ($new_button_sel == $this->cur_button_sel && $new_item_top != $this->cur_item_top)
                    $transition = GCOMP_TRANSITION_NONE;
                $change_defs[] = GCompsFactory::get_change_def('sel',
                    $this->do_get_sel_geom(
                        $new_sel_kind, $new_button_sel, $new_item_sel),
                    null, null, null, null, $transition);
                if ($new_button_sel != $this->cur_button_sel){
                    $this->apply_button_change($new_button_sel);

                    $change_defs[] = GCompsFactory::get_change_def(
                        "btn".$this->cur_button_sel, null,
                        array('color' => self::do_get_button_color(false)));
                    $change_defs[] = GCompsFactory::get_change_def(
                        "btn".$new_button_sel, null,
                        array('color' => self::do_get_button_color(true)));

                    $move = $new_button_sel == 0 || $this->cur_button_sel == 0;
                    $fade_transition = GCOMP_TRANSITION_NONE;

                    $change_defs[] = GCompsFactory::get_change_def(
                        "top_pane",
                        $this->do_get_top_pane_geom($new_button_sel),
                        null, null, null, null,
                        $move ? GCOMP_TRANSITION_DEFAULT : GCOMP_TRANSITION_NONE);

                    $change_defs[] = GCompsFactory::get_change_def(
                        "center_bg",
                        $this->do_get_center_bg_geom($new_button_sel),
                        null, null, null, null,
                        $move ? GCOMP_TRANSITION_DEFAULT : GCOMP_TRANSITION_NONE);

                    if (($move)&&($new_button_sel != $this->cur_movie_num_buttons-1)){
						if (($new_button_sel == 0)&&($this->cur_button_sel == $this->cur_movie_num_buttons-1))
						$change_defs[] = GCompsFactory::get_change_def('right_panel',
                            null, null, null, null,
                            $this->do_get_right_panel_children(
                                $new_button_sel, $new_item_sel, $new_item_top),
                            $fade_transition);
						$change_defs[] = GCompsFactory::get_change_def(
                            "movie_center_pane",
                            $this->do_get_movie_center_geom($new_button_sel),
                            null, null, null, null, GCOMP_TRANSITION_DEFAULT);

                        $change_defs[] = GCompsFactory::get_change_def(
                            "confirm_hints_pane",
                            $this->do_get_confirm_hints_pane_geom($new_button_sel),
                            null, null, null, null, GCOMP_TRANSITION_DEFAULT);

                        if ($new_button_sel == 0)
                        {
                            $change_defs[] = GCompsFactory::get_change_def(
                                'movie_center_spane', null, null,
                                GCompsFactory::get_view_position_def(0, -10000));
                        }
                    }else{
                        $change_defs[] = GCompsFactory::get_change_def('right_panel',
                            null, null, null, null,
                            $this->do_get_right_panel_children(
                                $new_button_sel, $new_item_sel, $new_item_top),
                            $fade_transition);

                        $change_defs[] = GCompsFactory::get_change_def("confirm_hints_pane",
                            null, null, null, null,
                            $this->do_get_confirm_hints_pane_children(
                                $new_button_sel),
                            GCOMP_TRANSITION_NONE);

                    }
                }else if ($new_item_sel != $this->cur_item_sel){
                    if ($new_item_top != $this->cur_item_top){
                        $from = 0;
                        $to = count($this->cur_object_ids);
                        for ($i = $from; $i < $to; $i++){
                            $change_defs[] = GCompsFactory::get_change_def(
                                "item".$i,
								$this->do_get_item_geom($i - $new_item_top, $this->cur_button_sel),
                                null, null, null, null, $transition);
                        }
                    }
                    $change_defs[] = GCompsFactory::get_change_def(
                        "img".$this->cur_item_sel,
                        $this->do_get_item_img_geom($this->cur_item_sel, false, $this->cur_button_sel),
                        null, null, null, null, $transition
					);
                    $change_defs[] = GCompsFactory::get_change_def(
                        "img".$new_item_sel,
                        $this->do_get_item_img_geom($new_item_sel, true, $this->cur_button_sel),
                        null, null, null, null, $transition
					);

                    $change_defs[] = GCompsFactory::get_change_def(
                        "name".$this->cur_item_sel, null,
                        array(
                            'text_size' => self::do_get_item_text_size(false),
                            'color' => self::do_get_item_text_color(false),
                        ),
                        null, null, null, $transition);
                    $change_defs[] = GCompsFactory::get_change_def(
                        "name".$new_item_sel, null,
                        array(
                            'text_size' => self::do_get_item_text_size(true),
                            'color' => self::do_get_item_text_color(true),
                            ),
                        null, null, null, $transition);

                    $change_defs[] = GCompsFactory::get_change_def(
                        "role".$this->cur_item_sel, null,
                        array(
                            'text_size' => self::do_get_item_text_size(false),
                            'color' => self::do_get_item_text_color2(false),
                        ),
                        null, null, null, $transition);
                    $change_defs[] = GCompsFactory::get_change_def(
                        "role".$new_item_sel, null,
                        array(
                            'text_size' => self::do_get_item_text_size(true),
                            'color' => self::do_get_item_text_color2(true),
                        ),
                        null, null, null, $transition);

                    $change_defs[] = GCompsFactory::get_change_def('object_info_panel',
                        null, null, null, null,
                        $this->do_get_object_info_panel_children($this->cur_movie, 
                            $new_button_sel, $new_item_sel),
                        GCOMP_TRANSITION_NONE);
                }
				if ($this->cur_button_sel != 6){
					$fade_transition = GCOMP_TRANSITION_NONE;
					$change_defs[] = GCompsFactory::get_change_def('right_panel',
						null, null, null, null,
						$this->do_get_right_panel_children(
						$new_button_sel, $new_item_sel, $new_item_top),
						GCOMP_TRANSITION_DEFAULT
					);

					$change_defs[] = GCompsFactory::get_change_def("confirm_hints_pane",
						null, null, null, null,
						$this->do_get_confirm_hints_pane_children(
						$new_button_sel),
						GCOMP_TRANSITION_NONE
					);
				}
				if ($new_sel_kind != $this->cur_sel_kind){
					$this->cur_button_sel = $new_button_sel;
					$new_ui_state = $this->do_get_ui_state($new_sel_state);
				}
                $this->cur_sel_kind = $new_sel_kind;
                $this->cur_item_sel = $new_item_sel;
                $this->cur_item_top = $new_item_top;
                $this->cur_button_sel = $new_button_sel;
            }
        }

        if (!isset($change_defs))
            return null;
        $num_steps = isset($y_offset) && $y_offset != 0 ? 8 : 5;
        $this->cur_sel_state = $this->get_selection_state();
		return GCompsFactory::change_gcomps($this,
                $change_defs, false, $num_steps, null,
                null, $new_ui_state);
    }
	//////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////

    public static function get_item_top($item_sel, $num_items,
        $items_page_size=self::ITEMS_PAGE_SIZE){
        $item_top = $item_sel - intval($items_page_size / 2);
        if ($item_top > $num_items - $items_page_size)
            $item_top = $num_items - $items_page_size;
        return max(0, $item_top);
    }

    public function enter_folder($media_url_str){
        $media_url = MediaURL::decode($media_url_str);
        $this->cur_media_url = $media_url;
        $this->cur_stack = isset($media_url) ? $media_url : '';

        $this->cur_sel_kind = 0;
        $this->cur_button_sel = 0;
        $this->cur_item_sel = 0;
        $this->cur_item_top = 0;
        $this->main_media_url = null;
        if (isset($media_url->movie_id))
            $ok = $this->ensure_movie($media_url_str);
        return $ok;
    }

    private function assign_main_state(){
        $this->main_media_url = $this->cur_media_url;
        $this->main_stack = $this->cur_stack;
        $this->main_sel_kind = $this->cur_sel_kind;
        $this->main_button_sel = $this->cur_button_sel;
        $this->main_item_id = count($this->cur_object_ids) == 0 ?  null : $this->cur_object_ids[$this->cur_item_sel];
    }

    public function handle_going_to_reload_all_folders($media_url_str){
        $media_url = MediaURL::decode($media_url_str);
        if (self::media_urls_equivalent($media_url, $this->cur_media_url)){
            $this->assign_main_state();
        }else{
            $this->main_media_url = $media_url;
            $this->main_stack = isset($media_url) ? $media_url : '';
            $this->main_sel_kind = 0;
            $this->main_button_sel = 0;
            $this->main_item_id = null;
        }
    }

    public function sync_current_folder(MediaURL $new_media_url, $change_main_state){
		
		if (self::media_urls_equivalent($new_media_url, $this->cur_media_url)){
            if ($change_main_state)
                $this->main_media_url = null;
            return;
        }
        if (!$change_main_state && !isset($this->main_media_url)){
            $this->enter_folder($new_media_url->get_raw_string());
            return;
        }
        $new_stack = isset($new_media_url) ? $new_media_url : '';
        $new_is_movie = isset($new_media_url->movie_id);
        $restoring_main_state = false;
        if (isset($this->main_media_url)){
            $this->cur_media_url = $this->main_media_url;
            $this->cur_stack = $this->main_stack;
            $restoring_main_state = self::media_urls_equivalent($new_media_url, $this->main_media_url);
        }else if (!$change_main_state)
            $this->assign_main_state();
        if ($restoring_main_state){
            $prev_object_id = $this->main_item_id;
            $this->cur_sel_kind = $this->main_sel_kind;
            $this->cur_button_sel = $this->main_button_sel;
        }
        $this->cur_media_url = $new_media_url;
        $this->cur_stack = $new_stack;
        if ($new_is_movie)
            $this->ensure_movie($new_media_url->get_raw_string());

        if ($this->cur_sel_kind == 0){
            $this->cur_item_sel = 0;
            $this->cur_item_top = 0;
        }else{
			if (isset($prev_object_id)){
				$this->cur_item_sel = array_search($prev_object_id, $this->cur_object_ids);
				if (false === $this->cur_item_sel)
					$this->cur_item_sel = 0;
			}
            $this->cur_item_top = self::get_item_top($this->cur_item_sel, count($this->cur_object_ids));
        }
        if ($change_main_state)
            $this->main_media_url = null;
    }

    private static function media_urls_equivalent($media_url1, $media_url2){
        if (!isset($media_url2))
            return false;

        $s1 = isset($media_url1) ? $media_url1 : '';
        $s2 = isset($media_url2) ? $media_url2 : '';
        if ($s1 != $s2)
            return false;

        $v1 = isset($media_url1->movie_id) ? $media_url1->movie_id : $media_url1->person_id;
        $v2 = isset($media_url2->movie_id) ? $media_url2->movie_id : $media_url2->person_id;
        return $v1 == $v2;
    }

    private function eval_movie_list_sep_ndx(){
        $prev_movie_num_files = null;
        for ($i = 0; $i < count($this->cur_object_ids); $i++){
            $movie_id = $this->cur_object_ids[$i];
            $movie_num_files = DataModel::get_instance()->
                get_files_count_by_movie_id($movie_id);

            if ($prev_movie_num_files > 0 && $movie_num_files == 0)
                return $i;

            $prev_movie_num_files = $movie_num_files;
        }
        return -1;
    }

    public function apply_button_change($button_sel){
        $is_movie = isset($this->cur_media_url->movie_id);
        $this->cur_object_list_sep_ndx = -1;
        if (!$is_movie){
            $this->cur_object_ids = array();
        }

        if (($button_sel == 3)||($button_sel == 4)||($button_sel == 5)){
            $this->cur_object_ids =  $this->get_related_movie_ids($this->cur_movie_id);
            if (!isset($this->cur_object_ids)){
                $this->cur_object_ids = array();
                return false;
            }

            usort($this->cur_object_ids, 'self::cmp_movie_ids');
            if (count($this->cur_object_ids) > self::MAX_NUM_MOVIE_SUBITEMS)
                array_splice($this->cur_object_ids, self::MAX_NUM_MOVIE_SUBITEMS);

            $this->cur_object_list_sep_ndx = $this->eval_movie_list_sep_ndx();
        }
        else if ($button_sel == 6){
            $this->cur_object_ids = array(); // TODO
        }
        else
            $this->cur_object_ids = array();
        return true;
    }
	public function get_related_movie_ids($movie_id){
        return null;
		if (isset($this->related_movie_ids_by_movie_id[$movie_id]))
            return $this->related_movie_ids_by_movie_id[$movie_id];

        $result = false;
        if (!isset($result))
            return null;

        $movie_ids = $this->parse_short_movie_list($result);
        if (!isset($movie_ids))
            return null;

        $this->related_movie_ids_by_movie_id[$movie_id] = $movie_ids;
        return $movie_ids;
    }

    private function ensure_movie($media_url_str){
        $this->cur_person_id = null;
        $this->cur_person = null;
        if (isset($this->cur_movie_id) && $this->cur_media_url->movie_id == $this->cur_movie_id)
            return true;
		$media_url = MediaURL::decode($media_url_str);
		
		if ((isset($this->vod->seasons_media_url['movie_screen']))&&
		($this->vod->seasons_media_url['movie_screen'] != $media_url_str))
			$this->vod->seasons_media_url = null;
		$this->vod->seasons_media_url['movie_screen'] = $media_url_str;
		if (isset($this->vod->seasons_media_url['seasons']))
			unset($this->vod->seasons_media_url['seasons']);
		$this->cur_movie_id = $media_url->movie_id;
		$this->cur_movie = $this->vod->get_loaded_movie($media_url, $plugin_cookies);
		$params['media_url']['class_name'] = $media_url->class_name;
		if (isset($this->cur_movie->class_info['trailers']))
			$params['movie']['class_info']['trailers'] = $this->cur_movie->class_info['trailers'];
		if (isset($this->cur_movie->class_info['dbIDs']['kpID']))
			$params['movie']['class_info']['dbIDs']['kpID'] = $this->cur_movie->class_info['dbIDs']['kpID'];
		$params['movie']['poster_url'] = $this->cur_movie->poster_url;
		$params['movie']['description'] = $this->cur_movie->description;
		$params['movie']['name'] = $this->cur_movie->name;
		$params['movie']['name_original'] = $this->cur_movie->name_original;
		$params['movie']['country'] = $this->cur_movie->country;
		$params['movie']['year'] = $this->cur_movie->year;
		HD::asyncExec('proc_close');
		if (!isset($this->cur_movie->class_info['noTrailers'])){
			$this->cmdAsyncExec = DuneSystem::$properties['install_dir_path'] . '/www/cgi-bin/php-cgi -f ' .  DuneSystem::$properties['install_dir_path'] . "/www/cgi-bin/classActions.php action=getMovieScreenInf class_name=Trailers params=" . urlencode(json_encode($params));
			// echo "\nhttp://".HD::get_ip_address()."/cgi-bin/plugins/".DuneSystem::$properties['plugin_name']."/classActions?action=getMovieScreenInf&class_name=Trailers&params=" . urlencode(json_encode($params));
			$str = HD::asyncExec($this->cmdAsyncExec);
		}
		///////////////////////////////////
		$class_name = $media_url->class_name;
		$mArr['movie_id'] = $this->cur_movie->id;
		if (isset($media_url->links))
			$mArr['links'] = $media_url->links;
		if (isset($this->cur_movie->class_info['goToScreen'])){
			$goToScreen = $this->cur_movie->class_info['goToScreen'];
			$this->mUrl = $goToScreen::get_media_url_str($class_name, $mArr);
			if ($goToScreen == 'SmartVodTorrentsScreen')
				$this->left_button_caption = 'Торренты';
		}else{
			$this->mUrl = VodSourceListScreen::get_media_url_str($class_name, $mArr);
			$this->left_button_caption = 'Источники';
		}
		if (isset($this->vod->currentFav)){
			$currentFav = MediaURL::decode($this->vod->currentFav);
			$saveFoldersArr = HD::getItemsArr($currentFav->class_name . '_saveFoldersArr');
			if (isset($saveFoldersArr[$media_url->movie_id]['mUrl'])){
				$this->mUrl = $saveFoldersArr[$media_url->movie_id]['mUrl'];
				$this->left_button_caption = 'Просмотр';
			}
		}
				
        if (!isset($this->cur_movie)){
            $this->cur_movie_confirm_needed = false;
            $this->cur_movie_edit_match_enabled = false;
            return false;
        }
        if (!$this->apply_button_change($this->cur_button_sel))
            return false;
		if (isset($this->cur_movie->class_info['dbIDs']['kpID']))
			$this->cur_movie_num_buttons = 7;
		else if (isset($this->cur_movie->class_info['noTrailers']))
			$this->cur_movie_num_buttons = 2;
		else 
			$this->cur_movie_num_buttons = 3;
        $this->update_cur_movie_confirm_needed();
        return true;
    }

    public function update_cur_movie_confirm_needed(){
        $this->cur_movie_confirm_needed = false;
        $this->cur_movie_edit_match_enabled = false;
        $this->cur_movie_search_association_enabled = false;
    }

    public static function cmp_movie_ids($id1, $id2){
        $has_files1 = DataModel::get_instance()->get_files_count_by_movie_id($id1) > 0 ? 1 : 0;
        $has_files2 = DataModel::get_instance()->get_files_count_by_movie_id($id2) > 0 ? 1 : 0;
        if ($has_files1 != $has_files2)
            return $has_files2 - $has_files1;
        $m1 = DunemdbCache::get_instance()->movie_by_id[$id1];
        $m2 = DunemdbCache::get_instance()->movie_by_id[$id2];
        $y1 = isset($m1) ? $m1->year : -1;
        $y2 = isset($m2) ? $m2->year : -1;
        if ($y1 == -1 || $y1 != $y2)
            return $y2 - $y1;
        return strnatcasecmp($m1->title, $m2->title);
    }

    ///////////////////////////////////////////////////////////////////////
	
}
///////////////////////////////////////////////////////////////////////////
?>

