<?php
///////////////////////////////////////////////////////////////////////////

require_once 'Smart_vod_category.php';

///////////////////////////////////////////////////////////////////////////

class VodFavoritesScreen extends AbstractPreloadedRegularScreen
implements UserInputHandler {
    const ID = 'vod_favorites';

    public static function get_media_url_str($class_name, $arr=null){
		$arr['screen_id'] = self::ID;			
		$arr['class_name'] = $class_name;
        return MediaURL::encode($arr);
    }

    ///////////////////////////////////////////////////////////////////////

	private $vod;
	private $openSaveFolder;
	private $upNew;
	private $folderArr;
	private $oldFav = false;
	static $needRefresh = true;
    ///////////////////////////////////////////////////////////////////////

    public function __construct(Vod $vod){
        $this->vod = $vod;
        parent::__construct(
            self::ID, 
			$this->get_folder_views()
		);
		UserInputHandlerRegistry::get_instance()->
            register_handler($this);
    }

    ///////////////////////////////////////////////////////////////////////

    public function get_action_map(MediaURL $media_url, &$plugin_cookies){
		$this->view_idx = isset($plugin_cookies->{"screen.".self::ID.".view_idx"}) ? $plugin_cookies->{"screen.".self::ID.".view_idx"} : 0;
		$actions[GUI_EVENT_KEY_SEARCH] = UserInputHandlerRegistry::create_action($this, 'classAction', array('action' => 'search'));
		
		$add_params['action_move'] = 'up';
		$add_action = UserInputHandlerRegistry::create_action($this, 'favItemsUpAndDown', $add_params);
        $add_action['caption'] = 'Поднять';
        $actions[GUI_EVENT_KEY_B_GREEN] = $add_action;
		
		$add_params['action_move'] = 'down';
		$add_action = UserInputHandlerRegistry::create_action($this, 'favItemsUpAndDown', $add_params);
        $add_action['caption'] = 'Опустить';
		$actions[GUI_EVENT_KEY_C_YELLOW] = $add_action;
		
		
        $add_action = UserInputHandlerRegistry::create_action($this, 'itemsFavoritesDelete');
        $add_action['caption'] = 'Удалить';
		$actions[GUI_EVENT_KEY_CLEAR] = $add_action;
		$actions[GUI_EVENT_KEY_D_BLUE] = $add_action;
		
		$actions[GUI_EVENT_KEY_SETUP] = ActionFactory::open_folder('setup','Настройки');
		
		$params['event_key'] = 'enter';
		$actions[GUI_EVENT_KEY_ENTER]		= UserInputHandlerRegistry::create_action($this, 'add_actions',$params);
		$params['event_key'] = 'play';
		$actions[GUI_EVENT_KEY_PLAY] 		= UserInputHandlerRegistry::create_action($this, 'add_actions',$params);
				
		$popup_menu_action = UserInputHandlerRegistry::create_action($this, 'popup_menu');
		$actions[GUI_EVENT_KEY_POPUP_MENU] = $popup_menu_action;
		$actions[GUI_EVENT_TIMER] = UserInputHandlerRegistry::create_action($this, 'timer');
		$useNumKey = HD::getItemsArr('useNumKey');
		foreach ($useNumKey as $k => $v){
			$params['openCat'] = $v;
			$actions[SmartConfig::$keyArr[$k]] = UserInputHandlerRegistry::create_action($this, 'add_actions', $params);
		}
		$this->openSaveFolder = (bool)(HD::getItemStr('openSaveFolder') != '') ? HD::getItemStr('openSaveFolder') : 1;
		$this->upNew = (bool)(HD::getItemStr('upNew') != '') ? HD::getItemStr('upNew') : 1;
		$this->posterCashe = (HD::getItemStr('posterCashe') != '') ? HD::getItemStr('posterCashe') : 0;
		$mShowsA = HD::getItemsArr('mShowsA');
		if (isset($mShowsA[$media_url->class_name])){
			$this->vod->mShowsA = $mShowsA[$media_url->class_name]->access_token;
			$notifications = (HD::getItemStr('notifications') !='') ? HD::getItemStr('notifications') : 1;
			if ($notifications > 0){
				$day = strtotime(date('d.m.Y'));
				if ($day != HD::getItemStr ('newES' . $media_url->class_name)){
					HD::saveItemStr('newES' . $media_url->class_name, $day);
					$this->newES = $notifications;
				}
			}
			$actions[GUI_EVENT_KEY_INFO] = UserInputHandlerRegistry::create_action($this, 'showNewEsInfo');
		}else if (isset($this->vod->mShowsA))
			unset($this->vod->mShowsA);
		return $actions;
    }
	public function get_handler_id(){
		return self::ID;
	}
	
	public function handle_user_input(&$user_input, &$plugin_cookies){
		if ($user_input->control_id == 'timer'){
			$action = null;
			if ((isset($this->newES))&&($this->newES == true)){
				$action = UserInputHandlerRegistry::create_action($this, 'showNewEs', array('notifications' => $this->newES));
				unset($this->newES);
			}
			if (self::$needRefresh == true)
				return ActionFactory::invalidate_folders(array($user_input->parent_media_url), $action);
			return null;
		}
		if ($user_input->control_id == 'showNewEsInfo'){
			$parent_media_url = MediaURL::decode($user_input->parent_media_url);
			$newES = myShows_Class::getNewES($this->vod->mShowsA, 1, $parent_media_url->class_name);
			if ($newES == false)
				ControlFactory::add_multiline_label($defs, '', "Новых эпизодов нет", 2);
			else{
				foreach ($newES as $k => $v){
					ControlFactory::add_smart_label($defs,"", '<icon width="320" height="180">'. myShows_Class::http_get_img($v->show->image) . '</icon>');
					ControlFactory::add_vgap($defs, -75);
					$new = '';
					if ($v->episode->episodeNumber == 1)
						$new = '<text color="4" size="normal">[NEW Season] </text>';
					ControlFactory::add_smart_label($defs,"", '<gap width="335"/>'.$new.'<text color="15" size="normal">'.$v->show->title.'</text>');
					ControlFactory::add_vgap($defs, -30);
					ControlFactory::add_smart_label($defs,"", '<gap width="335"/><text color="7" size="small">'.$v->show->titleOriginal.'</text>');
					ControlFactory::add_vgap($defs, -30);
					if ($v->show->status == 'TBD/On The Bubble')
						$v->show->status = 'Пауза';
					else if ($v->show->status == 'Returning Series')
						$v->show->status = 'Продолжается';
					else if ($v->show->status == 'Canceled/Ended')
						$v->show->status = 'Завершен';
					else if ($v->show->status == 'New Series')
						$v->show->status = 'Новый!';
					ControlFactory::add_smart_label($defs,"", '<gap width="335"/><text color="18" size="small">Статус: </text><text color="10" size="small">'.$v->show->status.'</text><text color="18" size="small"> Всего сезонов: </text><text color="10" size="small">'.$v->show->totalSeasons.'</text>');
					ControlFactory::add_vgap($defs, -30);
					ControlFactory::add_smart_label($defs,"", '<gap width="335"/><text color="18" size="small">NEW: </text><text color="10" size="small">'.$v->episode->shortName.' </text><text color="15" size="small">'.$v->episode->title.'</text>');
					ControlFactory::add_vgap($defs, -30);
					$date = new DateTime($v->episode->airDate);
					ControlFactory::add_smart_label($defs,"", '<gap width="335"/><text color="18" size="small">Дата выхода: </text><text color="15" size="small">'.$date->format('d.m.Y').'</text>');
					ControlFactory::add_vgap($defs, -25);
					$action = UserInputHandlerRegistry::create_action($this, 'classAction', array('action' => 'addToFavFromNotifi', 'indiClass' => 'myShows_Class', 'info' => json_encode($v)));
					ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, $k, 'Добавить в Избранное', 430, $action);
					ControlFactory::add_vgap($defs, 10);
				}
			}
			return ActionFactory::show_dialog('Новые эпизоды', $defs, true, 1100);
		}
		if ($user_input->control_id == 'showNewEs'){
			if (!isset($user_input->selected_control_id))
				$user_input->selected_control_id = 0;
			$parent_media_url = MediaURL::decode($user_input->parent_media_url);
			$newES = myShows_Class::getNewES($this->vod->mShowsA, $user_input->notifications, $parent_media_url->class_name);
			if ($newES == false)
				return null;
			else{
				foreach ($newES as $k => $v){
					ControlFactory::add_smart_label($defs,"", '<icon width="320" height="180">'. myShows_Class::http_get_img($v->show->image) . '</icon>');
					ControlFactory::add_vgap($defs, -75);
					$new = '';
					if ($v->episode->episodeNumber == 1)
						$new = '<text color="4" size="normal">[NEW Season] </text>';
					ControlFactory::add_smart_label($defs,"", '<gap width="335"/>'.$new.'<text color="15" size="normal">'.$v->show->title.'</text>');
					ControlFactory::add_vgap($defs, -30);
					ControlFactory::add_smart_label($defs,"", '<gap width="335"/><text color="7" size="small">'.$v->show->titleOriginal.'</text>');
					ControlFactory::add_vgap($defs, -30);
					if ($v->show->status == 'TBD/On The Bubble')
						$v->show->status = 'Пауза';
					else if ($v->show->status == 'Returning Series')
						$v->show->status = 'Продолжается';
					else if ($v->show->status == 'Canceled/Ended')
						$v->show->status = 'Завершен';
					else if ($v->show->status == 'New Series')
						$v->show->status = 'Новый!';
					ControlFactory::add_smart_label($defs,"", '<gap width="335"/><text color="18" size="small">Статус: </text><text color="10" size="small">'.$v->show->status.'</text><text color="18" size="small"> Всего сезонов: </text><text color="10" size="small">'.$v->show->totalSeasons.'</text>');
					ControlFactory::add_vgap($defs, -30);
					ControlFactory::add_smart_label($defs,"", '<gap width="335"/><text color="18" size="small">NEW: </text><text color="10" size="small">'.$v->episode->shortName.' </text><text color="15" size="small">'.$v->episode->title.'</text>');
					ControlFactory::add_vgap($defs, -30);
					$date = new DateTime($v->episode->airDate);
					ControlFactory::add_smart_label($defs,"", '<gap width="335"/><text color="18" size="small">Дата выхода: </text><text color="15" size="small">'.$date->format('d.m.Y').'</text>');
					ControlFactory::add_vgap($defs, -25);
					$action = UserInputHandlerRegistry::create_action($this, 'classAction', array('action' => 'addToFavFromNotifi', 'indiClass' => 'myShows_Class', 'info' => json_encode($v)));
					ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, $k, 'Добавить в Избранное', 430, $action);
					ControlFactory::add_vgap($defs, 10);
				}
			}
			if ($user_input->selected_control_id == 0){
				$counter = 10;
				if (isset($user_input->counter))
					$counter = $user_input->counter - 1;
				$add_params['counter'] = $counter;
				$add_params['notifications'] = $user_input->notifications;
				$actions = UserInputHandlerRegistry::create_action($this, 'showNewEs', $add_params);
				if ($counter == 0)
					$actions = null;
				$attrs['timer'] = ActionFactory::timer(1000);//, array('clear_on_keypress' => true));
				$attrs['actions'][GUI_EVENT_TIMER] = ActionFactory::close_dialog_and_run($actions);
				ControlFactory::add_smart_label($defs,"", '<text color="23" size="small">Окно закроется через: ' . $counter . ' сек. Или кнопка Return пульта ДУ.</text>');
			}
			$attrs['initial_sel_ndx'] = isset($user_input->selected_control_id) ? $user_input->selected_control_id : -1;
			return ActionFactory::show_dialog('Новые эпизоды', $defs, true, 1100, $attrs);
		}
		if ($user_input->control_id == 'itemsFavoritesDelete'){
			if (!isset($user_input->selected_media_url))
				return null;
			$parent_media_url = MediaURL::decode($user_input->parent_media_url);
			if ($this->openSaveFolder == true)
				$add_params['del_media_url'] = $this->folderArr[$user_input->selected_media_url];
			$add_params['action'] = 'addToFav';
			$add_params['favAction'] ='delete2';
			$add_params['selectFav'] = $parent_media_url->class_name;
			return UserInputHandlerRegistry::create_action($this, 'classAction', $add_params);
		}
		if ($user_input->control_id == 'favItemsUpAndDown'){
			if (!isset($user_input->selected_media_url))
				return null;
			$parent_media_url = MediaURL::decode($user_input->parent_media_url);
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			if ((isset($selected_media_url->categoryId))&&($selected_media_url->categoryId = 'mm'))
				return null;
			$itemsFavorites = HD::getItemsArr($parent_media_url->class_name);
			$fCat = array_flip($itemsFavorites);
			if (isset($itemsFavorites[$user_input->selected_media_url])){
				$k = $itemsFavorites[$user_input->selected_media_url];
				if ($user_input->action_move == 'up'){
					if ($k == 0){
						$fCat[] = $fCat[$k];
						unset($fCat[0]);		
					}else{
						$t = $fCat[$k - 1];
						$fCat[$k - 1] = $fCat[$k];
						$fCat[$k] = $t;
					}
				}
				if ($user_input->action_move == 'down'){
					if ($k == count($fCat) - 1){
						$fCat[-1] = $fCat[$k];
						unset($fCat[$k]);
					}else{
						$t = $fCat[$k + 1];
						$fCat[$k + 1] = $fCat[$k];
						$fCat[$k] = $t;
					}
				}
				ksort ($fCat);
				$fCat = array_values ($fCat);
				$itemsFavorites = array_flip($fCat);
				if (HD::saveItemsArr($parent_media_url->class_name, $itemsFavorites) != true)
					return ActionFactory::show_title_dialog("Сохранение не удалось");
				return ActionFactory::invalidate_folders(array($user_input->parent_media_url));
			}else{
				echo $user_input->selected_media_url;
				foreach ($itemsFavorites as $k => $v)
					echo "$k => $v";
				return ActionFactory::show_title_dialog("Err!", null, 'Подробности в лог файле!');
			}
		}
		if ($user_input->control_id == 'add_actions'){
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			if ((!class_exists($selected_media_url->class_name))||
			((isset($selected_media_url->infoSourseClassName))&&(!class_exists($selected_media_url->infoSourseClassName))))
				return UserInputHandlerRegistry::create_action($this, 'itemsFavoritesDelete');
			if (isset($user_input->openCat))
				$user_input->selected_media_url = $user_input->openCat; 
			if (isset($user_input->openCat))
				return ActionFactory::open_folder($user_input->selected_media_url, $selected_media_url->caption);
			$this->vod->currentFav = $user_input->parent_media_url;
			$this->vod->currentFavItem = $this->folderArr[$user_input->selected_media_url];
			if ($user_input->event_key == 'play'){
				$user_input->selected_media_url = $this->folderArr[$user_input->selected_media_url];
				$selected_media_url = MediaURL::decode($user_input->selected_media_url);
				return ActionFactory::open_folder($user_input->selected_media_url, $selected_media_url->caption);
			}
			return ActionFactory::open_folder();
		}
		if ($user_input->control_id == 'popup_menu'){
			if (isset($user_input->selected_media_url)){
				$selected_media_url = MediaURL::decode($user_input->selected_media_url);
				$class_name = $selected_media_url->class_name;
				if (!isset($selected_media_url->categoryId)){
					$menu_items[] = array(
						GuiMenuItemDef::caption => 'Удалить из Избранного',
						GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'itemsFavoritesDelete'),
						GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_addToFav')
					);
					if (class_exists($class_name)){
						$userFavList = HD::getItemsArr('userFavList');
						if (count($userFavList) > 0)
							$menu_items[] = array(
								GuiMenuItemDef::caption => 'Перенести в другое Избранное',
								GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', array('action' => 'moveToFav')),
								GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_arrow')
							);
					}
					$menu_items [] =  array(
						GuiMenuItemDef::is_separator => true,);
				}else if ((isset($selected_media_url->categoryId))&&($selected_media_url->categoryId == 'mm')){
					if (class_exists($class_name))
						$menu_items[] = array(
							GuiMenuItemDef::caption => 'Уведомления о выходе серии',
							GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', array('action' => 'shwntf', 'indiClass' => 'myShows_Class')),
							GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_myshows')
						);
				}
				if (class_exists($class_name))
					$menu_items[] = array(
						GuiMenuItemDef::caption => 'Добавить новое Избранное',
						GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', array('action' => 'addUserFav')),
						GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_user')
					);
				$menu_items[] = array(
					GuiMenuItemDef::caption => 'Настройки Избранного',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', array('action' => 'favSetup')),
					GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_setup')
				);
				$menu_items [] =  array(
					GuiMenuItemDef::is_separator => true,);
				$menu_items[] = array(
					GuiMenuItemDef::caption => 'Поиск',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', array('action' => 'search')),
					GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_ssearch')
				);
				$menu_items [] =  array(
					GuiMenuItemDef::is_separator => true,);
				if ((class_exists($class_name))&&(preg_match("|_Class|",$class_name))){
					$mItems = $class_name::getPopUpMenuItems($selected_media_url, $user_input->parent_media_url);
					foreach ($mItems as $v){
						if ($v == 'is_separator')
							$menu_items [] =  array(
							GuiMenuItemDef::is_separator => true,);
						else
							$menu_items[] = array(
								GuiMenuItemDef::caption => $v['caption'],
								GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', $v['params']),
								GuiMenuItemDef::icon_url => $v['icon_url'],
							);
					}
				}
			}
			$menu_items [] =  array(
				GuiMenuItemDef::is_separator => true,);
			$add_params['action'] = 'background_actions';
			$menu_items[] = array(
				GuiMenuItemDef::caption => 'Задать бекграунд',
				GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', $add_params),
				GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_add_background')
			);
			if (file_exists(HD::get_data_path() . "/icons/" . self::ID . "_bg.jpg")){
				$add_params['action'] = 'background_actions';
				$add_params['del'] = true;
				$menu_items[] = array(
					GuiMenuItemDef::caption => 'Удалить бекграунд',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', $add_params),
					GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_del_background')
				);
			}
			return ActionFactory::show_popup_menu($menu_items);
		}
		if ($user_input->control_id == 'classAction'){
			$defs = array();
			hd_silence_warnings();
			if (isset($user_input->indiClass)){
				$selected_media_url = MediaURL::decode($user_input->selected_media_url);
				$class_name = $user_input->indiClass;//$selected_media_url->class_name;
				return $class_name::classAction ($defs, $user_input, $this->select_url);
			}
			return SmartConfig::classAction ($defs, $user_input, $this->select_url);
		}
	}
    ///////////////////////////////////////////////////////////////////////

    public function get_all_folder_items(MediaURL $media_url, &$plugin_cookies){
        $items = array();
		if ($this->oldFav != $media_url->class_name){
			$this->oldFav = $media_url->class_name;
			self::$needRefresh = true;
		}
		$checkFav = SmartConfig::getFavSeries($media_url->class_name);
		$pluginCachePath = HD::get_data_path() . "/pluginCache/";
		if ($checkFav == true)
			self::$needRefresh = false;
		else 
			$checkFav = array();
		$itemsFavorites = HD::getItemsArr($media_url->class_name);
		$saveFoldersArr = HD::getItemsArr($media_url->class_name . '_saveFoldersArr');
		$checkFolders = false;
		if ((isset($this->vod->mShowsA))&&(!isset($this->myShows[$this->vod->mShowsA]))){
			$jsd = VideoInfo::get_profile_myshows ($this->vod->mShowsA);
			if (!isset($jsd->user->login)){
				$mShowsA = HD::getItemsArr('mShowsA');
				$jsds = myShows_Class::mShowsAccRefresh($mShowsA[$media_url->class_name]->refresh_token, $media_url->class_name);
				$jsd = VideoInfo::get_profile_myshows ($jsds->access_token);
			}
			if (isset($jsd->user->login)){
				$info = 'myShows: ' . $jsd->user->login;
				$info .= '||Просмотренно эпизодов:|' . $jsd->stats->watchedEpisodes;
				$info .= '||Не просмотренно:|' . $jsd->stats->remainingEpisodes;
				$info .= '||Всего эпизодов:|' . $jsd->stats->totalEpisodes;
				$info .= '||Просмотренно дней:|' . $jsd->stats->watchedDays;
				$info .= '||Не просмотренно дней:|' . $jsd->stats->remainingDays;
				$info .= '||Всего дней:|' . $jsd->stats->totalDays;
				
				if (defined('ViewItemParams::item_detailed_icon_width') === true){
					$view_item_params[ViewItemParams::item_detailed_icon_width] = 200;
					$view_item_params[ViewItemParams::item_detailed_icon_height] = 200;
				}
				if ($this->view_idx != 3){
					$view_item_params[ViewItemParams::icon_width] = 200;
					$view_item_params[ViewItemParams::icon_height] = 200;
					$view_item_params[ViewItemParams::icon_sel_scale_factor] = 1.0;
					if ($this->view_idx < 2)
					if (defined('ViewItemParams::item_sticker') === true){
						$imgArr[1] = 'plugin_file://icons/ms.png';
						$geoArr['img_x'][1] = -2; 
						$geoArr['img_y'][1] = 2;
						$geoArr['img_halign'][1] = 'right';
						$view_item_params[ViewItemParams::item_sticker] = json_encode(HD::get_sticker($imgArr, null, $geoArr));
					}
				}
				if ($this->view_idx == 3)
					$view_item_params[ViewItemParams::icon_keep_aspect_ratio] = true;
				$view_item_params[ViewItemParams::item_paint_caption] = true;
				$view_item_params[ViewItemParams::item_detailed_info] = $info;
				$view_item_params[ViewItemParams::icon_path] =  DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . $jsd->user->avatar;
				$mUrl = SmartVodRectangleListScreen::get_media_url_str('myShows_Class' ,array('categoryId'=> 'mm', 'favMyShows' => $media_url->class_name, 'mShowsA' => $this->vod->mShowsA));
				$this->folderArr[$mUrl] = $mUrl;
				$this->myShows[$this->vod->mShowsA] = array(
					PluginRegularFolderItem::media_url => $mUrl,
					PluginRegularFolderItem::caption => 'myShows: ' . $jsd->user->login,
					PluginRegularFolderItem::view_item_params => $view_item_params
				);
			}
		}
		
		foreach ($itemsFavorites as $m => $k){
			$color = 15; $starred = false;
			$view_item_params = array();
			$favoritesItem = MediaURL::decode($m);
			
			if (isset($favoritesItem->caption))
				$caption = $favoritesItem->caption;
			else if ($favoritesItem->data->caption)
				$caption = $favoritesItem->data->caption;
			else{
				$caption = 'N/A';
				echo 'favErr!';
				print_r ($favoritesItem);
			}
			$detailed_info = '||' . $caption;
			if (isset($favoritesItem->caption_original))
				$detailed_info .= '|' . $favoritesItem->caption_original;
			else
				$detailed_info .= '|' . $caption;
			if (isset($favoritesItem->year))
				$detailed_info .= '|' . $favoritesItem->year;
			if (isset($favoritesItem->hCaptions)){
				if (count($favoritesItem->hCaptions) > 1)
					$detailed_info .= '|' .  implode ('|', $favoritesItem->hCaptions);
				else
					$detailed_info .= '|' .  $favoritesItem->hCaptions[0];
			}
			////////////////////////////////////////////////////////
			if (isset($saveFoldersArr[$favoritesItem->movie_id])){
				if ($this->view_idx > 1){
					if (defined('ViewItemParams::item_extra_info')){
						$extra_item = array(
							'type' => 'icon',
							'url' => 'plugin_file://icons/save2.png',
							'alt' => 'Save'
						);
						$item_extra_info = array(
							'items' => array(
								array(
									'type' => 'gap', 
									'width' => 107
								),
								$extra_item,
							)
						);
						$view_item_params[ViewItemParams::item_extra_info] = json_encode($item_extra_info);
					}else
						$starred = true;
				}else{
					if (defined('ViewItemParams::item_sticker') === true){
						$imgArr[1] = 'plugin_file://icons/save2.png';
						$geoArr['img_x'][1] = -2; 
						$geoArr['img_y'][1] = 2;
						$geoArr['img_halign'][1] = 'right';
						$view_item_params[ViewItemParams::item_sticker] = json_encode(HD::get_sticker($imgArr, null, $geoArr));
					}else
						$starred = true;
				}
				if (defined('ViewItemParams::item_detailed_info_sticker') === true)
					$view_item_params[ViewItemParams::item_detailed_info_sticker] = 'plugin_file://icons/save2.png';
				
				if (isset($saveFoldersArr[$favoritesItem->movie_id]['mUrlSelSeason'])){
					$mUrlSelSeason = MediaURL::decode($saveFoldersArr[$favoritesItem->movie_id]['mUrlSelSeason']);
					if (isset($mUrlSelSeason->detailed_info))
						$detailed_info .=  $mUrlSelSeason->detailed_info;
				}
				
				if (isset($saveFoldersArr[$favoritesItem->movie_id]['series'])){
					if ((isset($checkFav[$favoritesItem->movie_id]))&&(count($checkFav[$favoritesItem->movie_id]) > 0)){
						$new = '||Новые серии:';
						$img = 'plugin_file://icons/new2.png';
						$alt = 'NEW';
						foreach ($checkFav[$favoritesItem->movie_id] as $jk => $nSeriesCapt){
							$new .= "|$nSeriesCapt";
							if ($jk == 'x'){
								$img = 'plugin_file://icons/err2.png';
								$alt = 'Er!';
							}
						}
						$detailed_info = $new .  $detailed_info;
						if ($this->upNew == true)
							$k = -1000 + $k;
						$color = 18;
						if ($this->view_idx > 1){
							if(defined('ViewItemParams::item_extra_info')){
								$extra_item = array('type' => 'icon',
								'url' => $img,
								'alt' => $alt
								);
								$item_extra_info = array(
								'items' => array(
								array('type' => 'gap', 'width' => 107),
								$extra_item,
								));
								$view_item_params[ViewItemParams::item_extra_info] = json_encode($item_extra_info);
							}else
								$starred = true;
						}else{
							if (defined('ViewItemParams::item_sticker') === true){
								$imgArr[1] = $img;
								$geoArr['img_x'][1] = -2; 
								$geoArr['img_y'][1] = 2;
								$geoArr['img_halign'][1] = 'right';
								$view_item_params[ViewItemParams::item_sticker] = json_encode(HD::get_sticker($imgArr, null, $geoArr));
							}else
								$starred = true;
						}
						if (defined('ViewItemParams::item_detailed_info_sticker') === true)
							$view_item_params[ViewItemParams::item_detailed_info_sticker] = $img;
					}else if (self::$needRefresh != false){
						if ($this->view_idx > 1){
							if(defined('ViewItemParams::item_extra_info')){
								$extra_item = array('type' => 'icon',
								'url' => 'plugin_file://icons/check2.png',
								'alt' => 'Check'
								);
								$item_extra_info = array(
								'items' => array(
								array('type' => 'gap', 'width' => 107),
								$extra_item,
								));
								$view_item_params[ViewItemParams::item_extra_info] = json_encode($item_extra_info);
							}else
								$starred = true;
						}else{
							if (defined('ViewItemParams::item_sticker') === true){
								$imgArr[1] = 'plugin_file://icons/check2.png';
								$geoArr['img_x'][1] = -2; 
								$geoArr['img_y'][1] = 2;
								$geoArr['img_halign'][1] = 'right';
								$view_item_params[ViewItemParams::item_sticker] = json_encode(HD::get_sticker($imgArr, null, $geoArr));
							}else
								$starred = true;
						}
						if (defined('ViewItemParams::item_detailed_info_sticker') === true)
							$view_item_params[ViewItemParams::item_detailed_info_sticker] = 'plugin_file://icons/check2.png';
					}
				}
				if ($this->openSaveFolder == true){
					$mUrl = $saveFoldersArr[$favoritesItem->movie_id]["mUrl"];
					$f = MediaURL::decode($mUrl);
					$this->vod->favoritesItemMovieIds[$f->movie_id] = $m;
				}else
					$mUrl = $m;
			}else
				$mUrl = $m;
			/////////////////////////////////////////
			if (!class_exists($favoritesItem->class_name)){
				$color = 17;
				$k = -1000 + $k;
				$detailed_info = '||Каталог (источник) ' . str_replace("_Class", "", $favoritesItem->class_name) . ' плагином больше не поддерживается|Нажмите кнопку ENTER что бы удалить из Избранного' . $detailed_info;
				if (defined('ViewItemParams::item_detailed_info_sticker') === true)
					$view_item_params[ViewItemParams::item_detailed_info_sticker] = SmartConfig::getPluginIco('s_delete');
				if ((defined('ViewItemParams::item_sticker') === true)&&($this->view_idx < 2)){
					$txtArr = array();
					$imgArr[1] = SmartConfig::getPluginIco('s_delete');
					$geoArr['img_x'][1] = -4; 
					$geoArr['img_y'][1] = 4;
					$geoArr['img_halign'][1] = 'right';
					
					$view_item_params[ViewItemParams::item_sticker] = json_encode(HD::get_sticker($imgArr, $txtArr, $geoArr));
				}
			}
			$view_item_params[ViewItemParams::item_detailed_info] = $detailed_info;
			if ($this->posterCashe == 1){
				$imgCachePath = $pluginCachePath . md5($m) . '.jpg';
				if (file_exists($imgCachePath))
					$favoritesItemPosterUrl = $imgCachePath;
				else{
					if (!preg_match('|do\?img=|', $favoritesItem->poster_url))
						$favoritesItem->poster_url = DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . $favoritesItem->poster_url;
					$favoritesItemPosterUrl = $favoritesItem->poster_url . '&savePath=' . urlencode($imgCachePath);
				}
			}else 
				$favoritesItemPosterUrl = $favoritesItem->poster_url;
			$view_item_params[ViewItemParams::icon_path] = $favoritesItemPosterUrl;
			$view_item_params[ViewItemParams::item_detailed_icon_path] = $favoritesItemPosterUrl;
			if (isset($favoritesItem->shape)){
				if (($favoritesItem->shape == 'tetragon')&&($this->view_idx < 2))
					$view_item_params[ViewItemParams::icon_path] = str_replace("/icons/", '/icons/shape_', $favoritesItem->poster_url);
			}else if (defined('ViewItemParams::item_detailed_icon_width') === true){
				$view_item_params[ViewItemParams::item_detailed_icon_width] = 172;
				$view_item_params[ViewItemParams::item_detailed_icon_height] = 250;
			}
			$this->folderArr[$mUrl] = $m;
			$view_item_params[ViewItemParams::item_caption_color] = $color;
            $items[$k] = array(
                PluginRegularFolderItem::media_url => $mUrl,
                PluginRegularFolderItem::caption => $caption,
                PluginRegularFolderItem::view_item_params => $view_item_params,
				PluginRegularFolderItem::starred => $starred
            );
		}
		ksort($items);
		if ((isset($this->vod->mShowsA))&&(isset($this->myShows[$this->vod->mShowsA])))
			array_unshift($items, $this->myShows[$this->vod->mShowsA]);
		$items = array_values($items);
        return $items;
    }

    ///////////////////////////////////////////////////////////////////////
    private function get_folder_views(){
		$sandwich_cover = SmartConfig::getPluginIco('sandwich_cover2');
		$sandwich_base = SmartConfig::getPluginIco('poster_none');
		$sandwich_base2 = SmartConfig::getPluginIco('badge1');
		$background_path = SmartConfig::getPluginIco(self::ID . '_bg');
		$paintBackground = (HD::getItemsArr('paintBackground') != array()) ? HD::getItemsArr('paintBackground') : array('paint_widget_background' => true, 'paint_content_box_background' => true, 'paint_path_box_background' => true, 'paint_details_box_background' => true);
		$paintSandwich = (HD::getItemStr('paintSandwich') != '') ? (bool)HD::getItemStr('paintSandwich') : true;
		
		$arr[0][PluginRegularFolderView::async_icon_loading] = true;
		$arr[0][PluginRegularFolderView::timer] = array(GuiTimerDef::delay_ms =>  500);
		$arr[0][PluginRegularFolderView::view_params][ViewParams::num_cols] = 5;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::num_rows] = 2;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_details] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_item_info_in_details] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_auto_line_break] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_title_color] = 10;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_text_color] = 15;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_font_size] = (HD::getItemStr('detailedInfoFontSize') != '') ? HD::getItemStr('detailedInfoFontSize') : FONT_SIZE_SMALL;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_sandwich] = $paintSandwich;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::sandwich_base] = $sandwich_base;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::sandwich_mask] = 'cut_icon://{name=sandwich_mask}';
		$arr[0][PluginRegularFolderView::view_params][ViewParams::sandwich_cover] = $sandwich_cover;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::sandwich_width] = 206;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::sandwich_height] = 300;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::sandwich_icon_upscale_enabled] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::sandwich_icon_keep_aspect_ratio] = false;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_path] = $background_path;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_order] = 0;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_height] = 1080;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_width] = 1920;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::optimize_full_screen_background] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_widget_background] = $paintBackground['paint_widget_background'];
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_content_box_background] = $paintBackground['paint_content_box_background'];
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_path_box_background] = $paintBackground['paint_path_box_background'];
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_details_box_background] = $paintBackground['paint_details_box_background'];
		
		$arr[0][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[0][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_width] = 206;
		$arr[0][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_height] = 300;
		$arr[0][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_path] = $sandwich_base2;
        
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_layout] = HALIGN_CENTER;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_valign] = VALIGN_CENTER;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_caption] = false;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_scale_factor] = 1.0;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_scale_factor] = 1.1;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_width] = 206;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_height] = 300;
		
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_margin_top] = 0;
		
		$arr[1][PluginRegularFolderView::async_icon_loading] = true;
		$arr[1][PluginRegularFolderView::timer] = array(GuiTimerDef::delay_ms =>  500);
		$arr[1][PluginRegularFolderView::view_params][ViewParams::num_cols] = 4;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::num_rows] = 2;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_details] = true;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_item_info_in_details] = true;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_auto_line_break] = true;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_title_color] = 10;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_text_color] = 15;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_font_size] = (HD::getItemStr('detailedInfoFontSize') != '') ? HD::getItemStr('detailedInfoFontSize') : FONT_SIZE_SMALL;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_sandwich] = $paintSandwich;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_base] = $sandwich_base;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_mask] = 'cut_icon://{name=sandwich_mask}';
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_cover] = $sandwich_cover;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_width] = 206;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_height] = 300;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_icon_upscale_enabled] = true;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_icon_keep_aspect_ratio] = false;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_path] = $background_path;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_order] = 0;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_height] = 1080;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_width] = 1920;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::optimize_full_screen_background] = true;
		if (defined('ViewParams::details_box_width') === true){
			$arr[1][PluginRegularFolderView::view_params][ViewParams::details_box_width] = 635;
			$arr[1][PluginRegularFolderView::view_params][ViewParams::content_box_x] = 100;
			$arr[1][PluginRegularFolderView::view_params][ViewParams::content_box_width] = 1070;
		}
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_widget_background] = $paintBackground['paint_widget_background'];
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_content_box_background] = $paintBackground['paint_content_box_background'];
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_path_box_background] = $paintBackground['paint_path_box_background'];
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_details_box_background] = $paintBackground['paint_details_box_background'];
		
		$arr[1][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[1][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_width] = 206;
		$arr[1][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_height] = 300;
		$arr[1][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_path] = $sandwich_base2;
        
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_layout] = HALIGN_CENTER;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_valign] = VALIGN_CENTER;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_caption] = false;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_scale_factor] = 1.0;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_scale_factor] = 1.1;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_width] = 206;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_height] = 300;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_margin_top] = 0;
		
		$arr[2][PluginRegularFolderView::async_icon_loading] = true;
		$arr[2][PluginRegularFolderView::timer] = array(GuiTimerDef::delay_ms =>  500);
		$arr[2][PluginRegularFolderView::view_params][ViewParams::num_cols] = 1;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::num_rows] = 4;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_details] = true;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_item_info_in_details] = true;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_auto_line_break] = true;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_title_color] = 10;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_text_color] = 15;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_font_size] = (HD::getItemStr('detailedInfoFontSize') != '') ? HD::getItemStr('detailedInfoFontSize') : FONT_SIZE_SMALL;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::background_path] = $background_path;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::background_order] = 0;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::background_height] = 1080;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::background_width] = 1920;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::optimize_full_screen_background] = true;
		if (defined('ViewParams::paint_icon_badge_box') === true){
			$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_icon_badge_box] = true;
			$arr[2][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_width] = 105;
			$arr[2][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_height] = 155;
			$arr[2][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_dx] = -580;
			$arr[2][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_sel_width] = 110;
			$arr[2][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_sel_height] = 160;
		}
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_widget_background] = $paintBackground['paint_widget_background'];
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_content_box_background] = $paintBackground['paint_content_box_background'];
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_path_box_background] = $paintBackground['paint_path_box_background'];
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_details_box_background] = $paintBackground['paint_details_box_background'];
		
		$arr[2][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[2][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_width] = 110;
		$arr[2][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_height] = 160;
		$arr[2][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_path] = $sandwich_base2;
		
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_layout] = HALIGN_LEFT;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_valign] = VALIGN_CENTER;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_caption] = false;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_scale_factor] = 1.0;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_scale_factor] = 1.1;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_width] = 110;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_height] = 160;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_dx] = 4;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_dy] = -7;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_margin_top] = 0;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_caption] = true;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_caption_width] = 1030;
		
		$arr[3][PluginRegularFolderView::async_icon_loading] = true;
		$arr[3][PluginRegularFolderView::timer] = array(GuiTimerDef::delay_ms =>  500);
		$arr[3][PluginRegularFolderView::view_params][ViewParams::num_cols] = 1;
		$arr[3][PluginRegularFolderView::view_params][ViewParams::num_rows] = 10;
		$arr[3][PluginRegularFolderView::view_params][ViewParams::paint_details] = true;
		$arr[3][PluginRegularFolderView::view_params][ViewParams::paint_item_info_in_details] = true;
		$arr[3][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_auto_line_break] = true;
		$arr[3][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_title_color] = 10;
		$arr[3][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_text_color] = 15;
		$arr[3][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_font_size] = (HD::getItemStr('detailedInfoFontSize') != '') ? HD::getItemStr('detailedInfoFontSize') : FONT_SIZE_SMALL;
		$arr[3][PluginRegularFolderView::view_params][ViewParams::background_path] = $background_path;
		$arr[3][PluginRegularFolderView::view_params][ViewParams::background_order] = 0;
		$arr[3][PluginRegularFolderView::view_params][ViewParams::background_height] = 1080;
		$arr[3][PluginRegularFolderView::view_params][ViewParams::background_width] = 1920;
		$arr[3][PluginRegularFolderView::view_params][ViewParams::optimize_full_screen_background] = true;
		
		$arr[3][PluginRegularFolderView::view_params][ViewParams::paint_widget_background] = $paintBackground['paint_widget_background'];
		$arr[3][PluginRegularFolderView::view_params][ViewParams::paint_content_box_background] = $paintBackground['paint_content_box_background'];
		$arr[3][PluginRegularFolderView::view_params][ViewParams::paint_path_box_background] = $paintBackground['paint_path_box_background'];
		$arr[3][PluginRegularFolderView::view_params][ViewParams::paint_details_box_background] = $paintBackground['paint_details_box_background'];
		
		$arr[3][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[3][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_width] = 34;
		$arr[3][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_height] = 50;
		$arr[3][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_path] = $sandwich_base2;
		
		$arr[3][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[3][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_layout] = HALIGN_LEFT;
		$arr[3][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_valign] = VALIGN_CENTER;
		$arr[3][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_caption] = false;
		$arr[3][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_scale_factor] = 1.0;
		$arr[3][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_scale_factor] = 1.1;
		$arr[3][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_width] = 34;
		$arr[3][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_height] = 50;
		$arr[3][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_dx] = 5;
		$arr[3][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_dy] = -5;
		$arr[3][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_margin_top] = 0;
		$arr[3][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_caption] = true;
		$arr[3][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_caption_width] = 1100;

		return $arr;
	}
}

///////////////////////////////////////////////////////////////////////////
?>
