<?php
///////////////////////////////////////////////////////////////////////////

require_once 'Smart_vod_category.php';

///////////////////////////////////////////////////////////////////////////

class VodHistoryScreen extends AbstractPreloadedRegularScreen
implements UserInputHandler {
    const ID = 'vod_history';

    public static function get_media_url_str($class_name, $arr=null){
		$arr['screen_id'] = self::ID;			
		$arr['class_name'] = $class_name;
        return MediaURL::encode($arr);
    }

    ///////////////////////////////////////////////////////////////////////

    private $category_list;
    private $category_index;

    ///////////////////////////////////////////////////////////////////////

    public function __construct(){
        parent::__construct(
            self::ID, 
			$this->get_folder_views()
		);
		UserInputHandlerRegistry::get_instance()->
            register_handler($this);
    }

    ///////////////////////////////////////////////////////////////////////

    public function get_action_map(MediaURL $media_url, &$plugin_cookies){
		$this->view_idx = isset($plugin_cookies->{"screen.".self::ID.".view_idx"}) ? $plugin_cookies->{"screen.".self::ID.".view_idx"} : 0;
		$add_action = UserInputHandlerRegistry::create_action($this, 'classAction', array('action' => 'search'));
        $add_action['caption'] = 'Поиск';
		$actions[GUI_EVENT_KEY_SEARCH] = $add_action;
        $actions[GUI_EVENT_KEY_B_GREEN] = $add_action;
		
		$add_action = UserInputHandlerRegistry::create_action($this, 'itemsHistoryDelete');
        $add_action['caption'] = 'Удалить';
        $actions[GUI_EVENT_KEY_C_YELLOW] = $add_action;
		$actions[GUI_EVENT_KEY_CLEAR] = $add_action;
		
		$actions[GUI_EVENT_KEY_SETUP] = ActionFactory::open_folder('setup','Настройки');
		
		$add_action = UserInputHandlerRegistry::create_action($this, 'classAction', array('action' => 'addToFav'));
        $add_action['caption'] = 'Избранное';
        $actions[GUI_EVENT_KEY_D_BLUE] = $add_action;
		
		$actions[GUI_EVENT_KEY_ENTER] = UserInputHandlerRegistry::create_action($this, 'add_actions');
		$actions[GUI_EVENT_KEY_PLAY] = UserInputHandlerRegistry::create_action($this, 'add_actions');
				
		$popup_menu_action = UserInputHandlerRegistry::create_action($this, 'popup_menu');
		$actions[GUI_EVENT_KEY_POPUP_MENU] = $popup_menu_action;
		$this->posterCasheHist = (HD::getItemStr('posterCasheHist') != '') ? HD::getItemStr('posterCasheHist') : 0;
		$useNumKey = HD::getItemsArr('useNumKey');
		foreach ($useNumKey as $k => $v){
			$params['openCat'] = $v;
			$actions[SmartConfig::$keyArr[$k]] = UserInputHandlerRegistry::create_action($this, 'add_actions', $params);
		}
		return $actions;
    }
	public function get_handler_id(){
		return self::ID;
	}
	
	public function handle_user_input(&$user_input, &$plugin_cookies){
		if ($user_input->control_id == 'itemsHistoryDelete'){
			if (!isset($user_input->selected_media_url))
				return null;
			$parent_media_url = MediaURL::decode($user_input->parent_media_url);
			$itemsHistory = HD::getItemsArr($parent_media_url->class_name);
			if (isset($itemsHistory[$user_input->selected_media_url])){
				unset ($itemsHistory[$user_input->selected_media_url]);
				if (HD::saveItemsArr($parent_media_url->class_name, $itemsHistory) != true)
					return ActionFactory::show_title_dialog("Сохранение не удалось.");
				HD::pluginCacheDel($user_input->selected_media_url);
			}
			return ActionFactory::invalidate_folders(array($user_input->parent_media_url));
		}
		if ($user_input->control_id == 'add_actions'){
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			if (!class_exists($selected_media_url->class_name))
				return UserInputHandlerRegistry::create_action($this, 'itemsHistoryDelete');
			if (isset($user_input->openCat))
				$user_input->selected_media_url = $user_input->openCat; 
			if (isset($user_input->openCat)){
				
				return ActionFactory::open_folder($user_input->selected_media_url, $selected_media_url->caption);
			}
			return ActionFactory::open_folder();
		}
		if ($user_input->control_id == 'popup_menu'){
			if (isset($user_input->selected_media_url)){
				$selected_media_url = MediaURL::decode($user_input->selected_media_url);
				$class_name = $selected_media_url->class_name;
				
				$menu_items[] = array(
					GuiMenuItemDef::caption => 'Удалить из Истории просмотра',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'itemsHistoryDelete'),
					GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_delete')
				);
				if (class_exists($class_name)){
					$menu_items [] =  array(
						GuiMenuItemDef::is_separator => true,);
					$menu_items[] = array(
						GuiMenuItemDef::caption => 'Избранное',
						GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', array('action' => 'addToFav')),
						GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_addToFav')
					);
				}
				$menu_items [] =  array(
					GuiMenuItemDef::is_separator => true,);
				$menu_items[] = array(
					GuiMenuItemDef::caption => 'Поиск',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', array('action' => 'search')),
					GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_ssearch')
				);
				
				if ((class_exists($class_name))&&(preg_match("|_Class|",$class_name))){
					$mItems = $class_name::getPopUpMenuItems($selected_media_url, $user_input->parent_media_url);
					foreach ($mItems as $v){
						if ($v == 'is_separator')
							$menu_items [] =  array(
							GuiMenuItemDef::is_separator => true,);
						else
							$menu_items[] = array(
								GuiMenuItemDef::caption => $v['caption'],
								GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', $v['params']),
								GuiMenuItemDef::icon_url => $v['icon_url'],
							);
					}
				}
			}
			$menu_items [] =  array(
				GuiMenuItemDef::is_separator => true,);
			$menu_items[] = array(
					GuiMenuItemDef::caption => 'Настройки Истории',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', array('action' => 'histSetup')),
					GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_setup')
				);
			$menu_items [] =  array(
				GuiMenuItemDef::is_separator => true,);
			$add_params['action'] = 'background_actions';
			$menu_items[] = array(
				GuiMenuItemDef::caption => 'Задать бекграунд',
				GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', $add_params),
				GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_add_background')
			);
			if (file_exists(HD::get_data_path() . "/icons/" . self::ID . "_bg.jpg")){
				$add_params['action'] = 'background_actions';
				$add_params['del'] = true;
				$menu_items[] = array(
					GuiMenuItemDef::caption => 'Удалить бекграунд',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', $add_params),
					GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_del_background')
				);
			}
			return ActionFactory::show_popup_menu($menu_items);
		}
		if ($user_input->control_id == 'classAction'){
			$defs = array();
			hd_silence_warnings();
			if (isset($user_input->indiClass)){
				$selected_media_url = MediaURL::decode($user_input->selected_media_url);
				$class_name = $selected_media_url->class_name;
				return $class_name::classAction ($defs, $user_input, $this->select_url);
			}
			return SmartConfig::classAction ($defs, $user_input, $this->select_url);
		}
	}
    ///////////////////////////////////////////////////////////////////////

    public function get_all_folder_items(MediaURL $media_url, &$plugin_cookies){
        $items = array();
		$itemsHistory = HD::getItemsArr($media_url->class_name);
		$pluginCachePath = HD::get_data_path() . "/pluginCache/";
		foreach ($itemsHistory as $mUrl => $detailed_info){
			$item_caption_color = 15;
			$view_item_params = array();
			$historyItem = MediaURL::decode($mUrl);
			if ($this->posterCasheHist == 1){
				$imgCachePath = $pluginCachePath . md5($mUrl) . '.jpg';
				if (file_exists($imgCachePath))
					$itemPosterUrl = $imgCachePath;
				else{
					if (!preg_match('|do\?img=|', $historyItem->poster_url))
						$historyItem->poster_url = DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . $historyItem->poster_url;
					$itemPosterUrl = $historyItem->poster_url . '&savePath=' . urlencode($imgCachePath);
				}
			}else $itemPosterUrl = $historyItem->poster_url;
			
			$view_item_params[ViewItemParams::icon_path] = $itemPosterUrl;
			$view_item_params[ViewItemParams::item_detailed_icon_path] = $itemPosterUrl;
			if (!class_exists($historyItem->class_name)){
				$item_caption_color = 17;
				$detailed_info = '||Каталог (источник) ' . str_replace("_Class", "", $historyItem->class_name) . ' плагином больше не поддерживается|Нажмите кнопку ENTER что бы удалить из Истории' . $detailed_info;
				if (defined('ViewItemParams::item_detailed_info_sticker') === true)
					$view_item_params[ViewItemParams::item_detailed_info_sticker] = SmartConfig::getPluginIco('s_delete');
				if ((defined('ViewItemParams::item_sticker') === true)&&($this->view_idx < 2)){
					$txtArr = array();
					$imgArr[1] = SmartConfig::getPluginIco('s_delete');
					$geoArr['img_x'][1] = -4; 
					$geoArr['img_y'][1] = 4;
					$geoArr['img_halign'][1] = 'right';
					
					$view_item_params[ViewItemParams::item_sticker] = json_encode(HD::get_sticker($imgArr, $txtArr, $geoArr));
				}
			}
			$view_item_params[ViewItemParams::item_caption_color] = $item_caption_color;
			$view_item_params[ViewItemParams::item_detailed_info] = $detailed_info;
			if (isset($favoritesItem->shape)){
				if (($favoritesItem->shape == 'tetragon')&&($this->view_idx < 2))
					$view_item_params[ViewItemParams::icon_path] = str_replace("/icons/", '/icons/shape_', $favoritesItem->poster_url);
			}else if (defined('ViewItemParams::item_detailed_icon_width') === true){
				$view_item_params[ViewItemParams::item_detailed_icon_width] = 172;
				$view_item_params[ViewItemParams::item_detailed_icon_height] = 250;
			}
			if (isset($historyItem->caption))
				$caption = $historyItem->caption;
			else if (isset($historyItem->data)){
				if (preg_match('|%7B%22|', $historyItem->data))
					$historyItem->data = json_decode(urldecode($historyItem->data));
				if (isset($historyItem->data->caption))
					$caption = $historyItem->data->caption;
			}else{
				$caption = 'N/A';
				echo 'histErr!';
				print_r ($historyItem);
			}
            $items[] = array(
                PluginRegularFolderItem::media_url => $mUrl,
                PluginRegularFolderItem::caption => $caption,
                PluginRegularFolderItem::view_item_params => $view_item_params
            );
        }
        return $items;
    }

    ///////////////////////////////////////////////////////////////////////	
    private function get_folder_views(){
		$sandwich_cover = SmartConfig::getPluginIco('sandwich_cover2');
		$sandwich_base = SmartConfig::getPluginIco('poster_none');
		$sandwich_base2 = SmartConfig::getPluginIco('badge1');
		$background_path = SmartConfig::getPluginIco(self::ID . '_bg');
		$paintBackground = (HD::getItemsArr('paintBackground') != array()) ? HD::getItemsArr('paintBackground') : array('paint_widget_background' => true, 'paint_content_box_background' => true, 'paint_path_box_background' => true, 'paint_details_box_background' => true);
		$paintSandwich = (HD::getItemStr('paintSandwich') != '') ? (bool)HD::getItemStr('paintSandwich') : true;
		
		$arr[0][PluginRegularFolderView::async_icon_loading] = true;
		//$arr[0][PluginRegularFolderView::timer] = array(GuiTimerDef::delay_ms =>  1000);
		$arr[0][PluginRegularFolderView::view_params][ViewParams::num_cols] = 5;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::num_rows] = 2;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_details] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_item_info_in_details] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_auto_line_break] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_title_color] = 10;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_text_color] = 15;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_font_size] = (HD::getItemStr('detailedInfoFontSize') != '') ? HD::getItemStr('detailedInfoFontSize') : FONT_SIZE_SMALL;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_sandwich] = $paintSandwich;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::sandwich_base] = $sandwich_base;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::sandwich_mask] = 'cut_icon://{name=sandwich_mask}';
		$arr[0][PluginRegularFolderView::view_params][ViewParams::sandwich_cover] = $sandwich_cover;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::sandwich_width] = 206;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::sandwich_height] = 300;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::sandwich_icon_upscale_enabled] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::sandwich_icon_keep_aspect_ratio] = false;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_path] = $background_path;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_order] = 0;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_height] = 1080;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_width] = 1920;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::optimize_full_screen_background] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_widget_background] = $paintBackground['paint_widget_background'];
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_content_box_background] = $paintBackground['paint_content_box_background'];
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_path_box_background] = $paintBackground['paint_path_box_background'];
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_details_box_background] = $paintBackground['paint_details_box_background'];
		
		$arr[0][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[0][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_width] = 206;
		$arr[0][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_height] = 300;
		$arr[0][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_path] = $sandwich_base2;
        
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_layout] = HALIGN_CENTER;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_valign] = VALIGN_CENTER;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_caption] = false;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_scale_factor] = 1.0;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_scale_factor] = 1.1;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_width] = 206;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_height] = 300;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_margin_top] = 0;
		
		$arr[1][PluginRegularFolderView::async_icon_loading] = true;
		//$arr[1][PluginRegularFolderView::timer] = array(GuiTimerDef::delay_ms =>  1000);
		$arr[1][PluginRegularFolderView::view_params][ViewParams::num_cols] = 4;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::num_rows] = 2;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_details] = true;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_item_info_in_details] = true;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_auto_line_break] = true;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_title_color] = 10;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_text_color] = 15;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_font_size] = (HD::getItemStr('detailedInfoFontSize') != '') ? HD::getItemStr('detailedInfoFontSize') : FONT_SIZE_SMALL;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_sandwich] = $paintSandwich;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_base] = $sandwich_base;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_mask] = 'cut_icon://{name=sandwich_mask}';
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_cover] = $sandwich_cover;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_width] = 206;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_height] = 300;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_icon_upscale_enabled] = true;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_icon_keep_aspect_ratio] = false;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_path] = $background_path;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_order] = 0;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_height] = 1080;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_width] = 1920;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::optimize_full_screen_background] = true;
		if (defined('ViewParams::details_box_width') === true){
			$arr[1][PluginRegularFolderView::view_params][ViewParams::details_box_width] = 635;
			$arr[1][PluginRegularFolderView::view_params][ViewParams::content_box_x] = 100;
			$arr[1][PluginRegularFolderView::view_params][ViewParams::content_box_width] = 1070;
		}
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_widget_background] = $paintBackground['paint_widget_background'];
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_content_box_background] = $paintBackground['paint_content_box_background'];
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_path_box_background] = $paintBackground['paint_path_box_background'];
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_details_box_background] = $paintBackground['paint_details_box_background'];
		
		$arr[1][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[1][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_width] = 206;
		$arr[1][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_height] = 300;
		$arr[1][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_path] = $sandwich_base2;
        
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_layout] = HALIGN_CENTER;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_valign] = VALIGN_CENTER;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_caption] = false;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_scale_factor] = 1.0;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_scale_factor] = 1.1;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_width] = 206;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_height] = 300;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_margin_top] = 0;
		
		$arr[2][PluginRegularFolderView::async_icon_loading] = true;
		//$arr[2][PluginRegularFolderView::timer] = array(GuiTimerDef::delay_ms =>  1000);
		$arr[2][PluginRegularFolderView::view_params][ViewParams::num_cols] = 1;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::num_rows] = 4;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_details] = true;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_item_info_in_details] = true;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_auto_line_break] = true;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_title_color] = 10;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_text_color] = 15;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_font_size] = (HD::getItemStr('detailedInfoFontSize') != '') ? HD::getItemStr('detailedInfoFontSize') : FONT_SIZE_SMALL;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::background_path] = $background_path;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::background_order] = 0;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::background_height] = 1080;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::background_width] = 1920;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::optimize_full_screen_background] = true;
		if (defined('ViewParams::paint_icon_badge_box') === true){
			$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_icon_badge_box] = true;
			$arr[2][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_width] = 105;
			$arr[2][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_height] = 155;
			$arr[2][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_dx] = -580;
			$arr[2][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_sel_width] = 110;
			$arr[2][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_sel_height] = 160;
		}
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_widget_background] = $paintBackground['paint_widget_background'];
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_content_box_background] = $paintBackground['paint_content_box_background'];
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_path_box_background] = $paintBackground['paint_path_box_background'];
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_details_box_background] = $paintBackground['paint_details_box_background'];
		
		$arr[2][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[2][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_width] = 110;
		$arr[2][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_height] = 160;
		$arr[2][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_path] = $sandwich_base2;
		
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_layout] = HALIGN_LEFT;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_valign] = VALIGN_CENTER;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_caption] = false;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_scale_factor] = 1.0;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_scale_factor] = 1.1;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_width] = 110;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_height] = 160;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_dx] = 4;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_dy] = -7;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_margin_top] = 0;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_caption] = true;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_caption_width] = 1030;
		
		$arr[3][PluginRegularFolderView::async_icon_loading] = true;
		//$arr[3][PluginRegularFolderView::timer] = array(GuiTimerDef::delay_ms =>  1000);
		$arr[3][PluginRegularFolderView::view_params][ViewParams::num_cols] = 1;
		$arr[3][PluginRegularFolderView::view_params][ViewParams::num_rows] = 10;
		$arr[3][PluginRegularFolderView::view_params][ViewParams::paint_details] = true;
		$arr[3][PluginRegularFolderView::view_params][ViewParams::paint_item_info_in_details] = true;
		$arr[3][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_auto_line_break] = true;
		$arr[3][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_title_color] = 10;
		$arr[3][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_text_color] = 15;
		$arr[3][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_font_size] = (HD::getItemStr('detailedInfoFontSize') != '') ? HD::getItemStr('detailedInfoFontSize') : FONT_SIZE_SMALL;
		$arr[3][PluginRegularFolderView::view_params][ViewParams::background_path] = $background_path;
		$arr[3][PluginRegularFolderView::view_params][ViewParams::background_order] = 0;
		$arr[3][PluginRegularFolderView::view_params][ViewParams::background_height] = 1080;
		$arr[3][PluginRegularFolderView::view_params][ViewParams::background_width] = 1920;
		$arr[3][PluginRegularFolderView::view_params][ViewParams::optimize_full_screen_background] = true;
		
		$arr[3][PluginRegularFolderView::view_params][ViewParams::paint_widget_background] = $paintBackground['paint_widget_background'];
		$arr[3][PluginRegularFolderView::view_params][ViewParams::paint_content_box_background] = $paintBackground['paint_content_box_background'];
		$arr[3][PluginRegularFolderView::view_params][ViewParams::paint_path_box_background] = $paintBackground['paint_path_box_background'];
		$arr[3][PluginRegularFolderView::view_params][ViewParams::paint_details_box_background] = $paintBackground['paint_details_box_background'];
		
		$arr[3][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[3][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_width] = 34;
		$arr[3][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_height] = 50;
		$arr[3][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_path] = $sandwich_base2;
		
		$arr[3][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[3][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_layout] = HALIGN_LEFT;
		$arr[3][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_valign] = VALIGN_CENTER;
		$arr[3][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_caption] = false;
		$arr[3][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_scale_factor] = 1.0;
		$arr[3][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_scale_factor] = 1.1;
		$arr[3][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_width] = 34;
		$arr[3][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_height] = 50;
		$arr[3][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_dx] = 5;
		$arr[3][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_dy] = -5;
		$arr[3][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_margin_top] = 0;
		$arr[3][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_caption] = true;
		$arr[3][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_caption_width] = 1100;

		return $arr;
	}
}

///////////////////////////////////////////////////////////////////////////
?>
