<?php
require_once 'Smart_vod_list_screen.php';
class SmartVodListScreen extends VodListScreen{
	const ID = 'vod_list';
	public static function get_media_url_str($class_name, $arr=null){
		$arr['screen_id'] = self::ID;
		$arr['class_name'] = $class_name;
        return MediaURL::encode($arr);
    }
    public function __construct(Vod $vod){
		$this->vod = $vod;
        parent::__construct($vod, self::ID, $this->get_folder_views());
    }
	public function get_folder_views(){
		$sandwich_cover = SmartConfig::getPluginIco('sandwich_cover2');
		$sandwich_base = SmartConfig::getPluginIco('poster_none');
		$sandwich_base2 = SmartConfig::getPluginIco('badge1');
		$background_path = SmartConfig::getPluginIco(self::ID . '_bg');
		$paintBackground = (HD::getItemsArr('paintBackground') != array()) ? HD::getItemsArr('paintBackground') : array('paint_widget_background' => true, 'paint_content_box_background' => true, 'paint_path_box_background' => true, 'paint_details_box_background' => true);
		$item_detailed_info_font_size = (HD::getItemStr('detailedInfoFontSize') != '') ? HD::getItemStr('detailedInfoFontSize') : FONT_SIZE_SMALL;
		$paintSandwich = (HD::getItemStr('paintSandwich') != '') ? (bool)HD::getItemStr('paintSandwich') : true;
		
		$arr[0][PluginRegularFolderView::async_icon_loading] = true;
		//$arr[0][PluginRegularFolderView::timer] = array(GuiTimerDef::delay_ms =>  1000);
		$arr[0][PluginRegularFolderView::view_params][ViewParams::num_cols] = 5;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::num_rows] = 2;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_details] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_item_info_in_details] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_auto_line_break] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_title_color] = 10;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_text_color] = 15;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_font_size] = $item_detailed_info_font_size;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_sandwich] = $paintSandwich;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::sandwich_base] = $sandwich_base;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::sandwich_mask] = 'cut_icon://{name=sandwich_mask}';
		$arr[0][PluginRegularFolderView::view_params][ViewParams::sandwich_cover] = $sandwich_cover;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::sandwich_width] = 206;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::sandwich_height] = 300;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::sandwich_icon_upscale_enabled] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::sandwich_icon_keep_aspect_ratio] = false;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_path] = $background_path;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_order] = 0;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_height] = 1080;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_width] = 1920;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::optimize_full_screen_background] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_widget_background] = $paintBackground['paint_widget_background'];
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_content_box_background] = $paintBackground['paint_content_box_background'];
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_path_box_background] = $paintBackground['paint_path_box_background'];
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_details_box_background] = $paintBackground['paint_details_box_background'];
		
		$arr[0][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[0][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_width] = 206;
		$arr[0][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_height] = 300;
		$arr[0][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_path] = $sandwich_base2;
        
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_layout] = HALIGN_CENTER;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_valign] = VALIGN_CENTER;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_caption] = false;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_scale_factor] = 1.0;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_scale_factor] = 1.1;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_width] = 206;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_height] = 300;
		if (defined('ViewItemParams::item_detailed_icon_width') === true){
			$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_detailed_icon_width] = 200;
			$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_detailed_icon_height] = 291;
		}
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_margin_top] = 0;
		
		$arr[1][PluginRegularFolderView::async_icon_loading] = true;
		//$arr[1][PluginRegularFolderView::timer] = array(GuiTimerDef::delay_ms =>  1000);
		$arr[1][PluginRegularFolderView::view_params][ViewParams::num_cols] = 4;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::num_rows] = 2;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_details] = true;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_item_info_in_details] = true;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_auto_line_break] = true;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_title_color] = 10;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_text_color] = 15;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_font_size] = $item_detailed_info_font_size;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_sandwich] = $paintSandwich;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_base] = $sandwich_base;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_mask] = 'cut_icon://{name=sandwich_mask}';
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_cover] = $sandwich_cover;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_width] = 206;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_height] = 300;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_icon_upscale_enabled] = true;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_icon_keep_aspect_ratio] = false;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_path] = $background_path;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_order] = 0;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_height] = 1080;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_width] = 1920;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::optimize_full_screen_background] = true;
		if (defined('ViewParams::details_box_width') === true){
			$arr[1][PluginRegularFolderView::view_params][ViewParams::details_box_width] = 635;
			$arr[1][PluginRegularFolderView::view_params][ViewParams::content_box_x] = 100;
			$arr[1][PluginRegularFolderView::view_params][ViewParams::content_box_width] = 1070;
		}
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_widget_background] = $paintBackground['paint_widget_background'];
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_content_box_background] = $paintBackground['paint_content_box_background'];
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_path_box_background] = $paintBackground['paint_path_box_background'];
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_details_box_background] = $paintBackground['paint_details_box_background'];
		
		$arr[1][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[1][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_width] = 206;
		$arr[1][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_height] = 300;
		$arr[1][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_path] = $sandwich_base2;
        
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_layout] = HALIGN_CENTER;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_valign] = VALIGN_CENTER;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_caption] = false;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_scale_factor] = 1.0;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_scale_factor] = 1.1;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_width] = 206;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_height] = 300;
		if (defined('ViewItemParams::item_detailed_icon_width') === true){
			$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_detailed_icon_width] = 200;
			$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_detailed_icon_height] = 291;
		}
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_margin_top] = 0;
		
		$arr[2][PluginRegularFolderView::async_icon_loading] = true;
		//$arr[2][PluginRegularFolderView::timer] = array(GuiTimerDef::delay_ms =>  1000);
		$arr[2][PluginRegularFolderView::view_params][ViewParams::num_cols] = 1;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::num_rows] = 4;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_details] = true;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_item_info_in_details] = true;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_auto_line_break] = true;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_title_color] = 10;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_text_color] = 15;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_font_size] = $item_detailed_info_font_size;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::background_path] = $background_path;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::background_order] = 0;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::background_height] = 1080;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::background_width] = 1920;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::optimize_full_screen_background] = true;
		if (defined('ViewParams::paint_icon_badge_box') === true){
			$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_icon_badge_box] = true;
			$arr[2][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_width] = 105;
			$arr[2][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_height] = 155;
			$arr[2][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_dx] = -580;
			$arr[2][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_sel_width] = 110;
			$arr[2][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_sel_height] = 160;
		}
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_widget_background] = $paintBackground['paint_widget_background'];
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_content_box_background] = $paintBackground['paint_content_box_background'];
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_path_box_background] = $paintBackground['paint_path_box_background'];
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_details_box_background] = $paintBackground['paint_details_box_background'];
		
		$arr[2][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[2][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_width] = 110;
		$arr[2][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_height] = 160;
		$arr[2][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_path] = $sandwich_base2;
		
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_layout] = HALIGN_LEFT;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_valign] = VALIGN_CENTER;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_caption] = false;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_scale_factor] = 1.0;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_scale_factor] = 1.1;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_width] = 110;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_height] = 160;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_dx] = 4;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_dy] = -7;
		if (defined('ViewItemParams::item_detailed_icon_width') === true){
			$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_detailed_icon_width] = 200;
			$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_detailed_icon_height] = 291;
		}
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_margin_top] = 0;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_caption] = true;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_caption_width] = 1030;
		
		$arr[3][PluginRegularFolderView::async_icon_loading] = true;
		//$arr[3][PluginRegularFolderView::timer] = array(GuiTimerDef::delay_ms =>  1000);
		$arr[3][PluginRegularFolderView::view_params][ViewParams::num_cols] = 1;
		$arr[3][PluginRegularFolderView::view_params][ViewParams::num_rows] = 10;
		$arr[3][PluginRegularFolderView::view_params][ViewParams::paint_details] = true;
		$arr[3][PluginRegularFolderView::view_params][ViewParams::paint_item_info_in_details] = true;
		$arr[3][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_auto_line_break] = true;
		$arr[3][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_title_color] = 10;
		$arr[3][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_text_color] = 15;
		$arr[3][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_font_size] = $item_detailed_info_font_size;
		$arr[3][PluginRegularFolderView::view_params][ViewParams::background_path] = $background_path;
		$arr[3][PluginRegularFolderView::view_params][ViewParams::background_order] = 0;
		$arr[3][PluginRegularFolderView::view_params][ViewParams::background_height] = 1080;
		$arr[3][PluginRegularFolderView::view_params][ViewParams::background_width] = 1920;
		$arr[3][PluginRegularFolderView::view_params][ViewParams::optimize_full_screen_background] = true;
		
		$arr[3][PluginRegularFolderView::view_params][ViewParams::paint_widget_background] = $paintBackground['paint_widget_background'];
		$arr[3][PluginRegularFolderView::view_params][ViewParams::paint_content_box_background] = $paintBackground['paint_content_box_background'];
		$arr[3][PluginRegularFolderView::view_params][ViewParams::paint_path_box_background] = $paintBackground['paint_path_box_background'];
		$arr[3][PluginRegularFolderView::view_params][ViewParams::paint_details_box_background] = $paintBackground['paint_details_box_background'];
		
		$arr[3][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[3][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_width] = 34;
		$arr[3][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_height] = 50;
		$arr[3][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_path] = $sandwich_base2;
		
		$arr[3][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[3][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_layout] = HALIGN_LEFT;
		$arr[3][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_valign] = VALIGN_CENTER;
		$arr[3][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_caption] = false;
		$arr[3][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_scale_factor] = 1.0;
		$arr[3][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_scale_factor] = 1.1;
		$arr[3][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_width] = 34;
		$arr[3][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_height] = 50;
		$arr[3][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_dx] = 5;
		$arr[3][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_dy] = -5;
		if (defined('ViewItemParams::item_detailed_icon_width') === true){
			$arr[3][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_detailed_icon_width] = 200;
			$arr[3][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_detailed_icon_height] = 291;
		}
		$arr[3][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_margin_top] = 0;
		$arr[3][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_caption] = true;
		$arr[3][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_caption_width] = 1100;

		return $arr;
    }
}
?>