<?php
require_once 'lib/vod/vod.php';
require_once 'lib/abstract_preloaded_regular_screen.php';
class VodPeerflixServerScreen extends AbstractPreloadedRegularScreen
    implements UserInputHandler
{
    const ID = 'vod_peerflixserver';

    public static function get_media_url_str($class_name, $arr=null){
		$arr['screen_id'] = self::ID;
		$arr['class_name'] = $class_name;
        return MediaURL::encode($arr);
    }

    ///////////////////////////////////////////////////////////////////////

    private $vod;
	static $counter = 0;
	private $showIp;
    public function __construct(Vod $vod){
        $this->vod = $vod;
        parent::__construct(self::ID,
           $this->get_folder_views());

        UserInputHandlerRegistry::get_instance()->register_handler($this);
    }

    ///////////////////////////////////////////////////////////////////////

    public function get_action_map(MediaURL $media_url, &$plugin_cookies){
		
        $params['event_key'] = 'enter';
        $actions[GUI_EVENT_KEY_ENTER]		= UserInputHandlerRegistry::create_action($this, 'add_action',$params);
		
		$params['event_key'] = 'play';
        $actions[GUI_EVENT_KEY_PLAY] 		= UserInputHandlerRegistry::create_action($this, 'add_action',$params);
		
		$actions[GUI_EVENT_TIMER] = UserInputHandlerRegistry::create_action($this, 'timer');
		
		$popup_menu_action = UserInputHandlerRegistry::create_action($this, 'popup_menu');
		$actions[GUI_EVENT_KEY_POPUP_MENU] = $popup_menu_action;
		
		$actions[GUI_EVENT_KEY_SETUP] = ActionFactory::open_folder('setup');
		
		$params['action'] = 'peerflixServerActionRem';
		$add_action							= UserInputHandlerRegistry::create_action($this, 'classAction', $params);
		$add_action['caption']				= 'Удалить';
		$actions[GUI_EVENT_KEY_B_GREEN] 	= $add_action;
		
		$add_action = UserInputHandlerRegistry::create_action($this, 'classSetupPeerflixServer');
		$add_action['caption'] = 'Настройки Peerflix-Server';
		$actions[GUI_EVENT_KEY_C_YELLOW] = $add_action;
		if (isset($this->vod->currentFav))
			unset ($this->vod->currentFav);
		return $actions;
    }

    public function get_handler_id(){ return self::ID; }

    public function handle_user_input(&$user_input, &$plugin_cookies){
        // foreach ($user_input as $key => $value)
            // hd_print("  $key => $value");
		if ($user_input->control_id == 'popup_menu'){
			$selected_media_url = (object)array();
			if (isset($user_input->selected_media_url))
				$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			$parent_media_url = MediaURL::decode($user_input->parent_media_url);
			if (isset($parent_media_url->class_name)){
				$class_name = $parent_media_url->class_name;
				$mItems = $class_name::getPopUpMenuItems($selected_media_url, $parent_media_url);
				foreach ($mItems as $v){
					if ($v == 'is_separator')
						$menu_items [] =  array(
						GuiMenuItemDef::is_separator => true,);
					else if ($v['params'] == 'classSetup')
						$menu_items[] = array(
							GuiMenuItemDef::caption => $v['caption'],
							GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classSetup' . $class_name),
							GuiMenuItemDef::icon_url => $v['icon_url'],
						);
					else if (isset($v['conID']))
						$menu_items[] = array(
							GuiMenuItemDef::caption => $v['caption'],
							GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, $v['conID'], $v['params']),
							GuiMenuItemDef::icon_url => $v['icon_url'],
						);
					else
						$menu_items[] = array(
							GuiMenuItemDef::caption => $v['caption'],
							GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', $v['params']),
							GuiMenuItemDef::icon_url => $v['icon_url'],
						);
				}
			}
			if ($user_input->selected_media_url != 'addLocalTorrent'){
				$menu_items [] =  array(
					GuiMenuItemDef::is_separator => true,);
				$add_params['action'] = 'background_actions';
				$add_params['indiClass'] = 'SmartConfig';
				$menu_items[] = array(
					GuiMenuItemDef::caption => 'Задать бекграунд',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', $add_params),
					GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_add_background')
				);
				if (file_exists(HD::get_data_path() . "/icons/" . self::ID . "_bg.jpg")){
					$add_params['action'] = 'background_actions';
					$add_params['indiClass'] = 'SmartConfig';
					$add_params['del'] = true;
					$menu_items[] = array(
						GuiMenuItemDef::caption => 'Удалить бекграунд',
						GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', $add_params),
						GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_del_background')
					);
				}
			}
			return ActionFactory::show_popup_menu($menu_items);
		}
		if ($user_input->control_id == 'classSetupPeerflixServer'){
			$defs = array();
			hd_silence_warnings();
			return PeerflixServer::setup($defs, $user_input);
		}
		if ($user_input->control_id == 'classAction'){
			$defs = array();
			if (($user_input->selected_media_url =='dummy')||
				($user_input->selected_media_url =='addLocalTorrent')||
				(!isset($user_input->selected_media_url))
			)return null;
			if (isset($user_input->indiClass)){
				$selected_media_url = MediaURL::decode($user_input->selected_media_url);
				$class_name = $user_input->indiClass;
				hd_silence_warnings();
				return $class_name::classAction ($defs, $user_input, $this->select_url);
			}
			$parent_media_url = MediaURL::decode($user_input->parent_media_url);
			$class_name = $parent_media_url->class_name;
			hd_silence_warnings();
			return $class_name::classAction ($defs, $user_input);
		}
		if ($user_input->control_id == 'timer'){
			$parent_media_url = MediaURL::decode($user_input->parent_media_url);
			$actions = $this->get_action_map($parent_media_url,$plugin_cookies);
			return ActionFactory::invalidate_folders(array($user_input->parent_media_url));
		}
        if ($user_input->control_id == 'add_action'){
            if (!isset($user_input->selected_media_url))
                return null;
			if ($user_input->selected_media_url == 'addLocalTorrent')
				return UserInputHandlerRegistry::create_action($this, 'addLocalTorrent');
			if (preg_match('|^hashing_|', $user_input->selected_media_url))
				return null;
			if ($user_input->selected_media_url == 'dummy')
				return UserInputHandlerRegistry::create_action($this, 'classSetupPeerflixServer');
			$media_url = MediaURL::decode($user_input->selected_media_url);
			PeerflixServer::peerflixServerActionGet($media_url->movie_id);
			PeerflixServer::set_movie($media_url->movie_id, $media_url->data);
            return ActionFactory::open_folder();
		}
        if ($user_input->control_id == 'addLocalTorrent'){
			$media_url = MediaURL::encode (
				array(
					'screen_id'     => 'file_list',
					'save_file'		=> array(	
						'action' 		=> 'addLocalTorrentPeerflixServer',
						'extension' 	=> 'torrent'
					),
				)
			);
			return ActionFactory::open_folder($media_url,'Выберите .torrent файл:');
        }

        return null;
    }

    ///////////////////////////////////////////////////////////////////////

    public function get_all_folder_items(MediaURL $media_url, &$plugin_cookies){
        $this->vod->folder_entered($media_url, $plugin_cookies);
        $items = array();
		$torrentObj = PeerflixServer::actionGetTorrentList();
		if ($torrentObj == true){
			$vip[ViewItemParams::icon_path] = 'plugin_file://icons/add.png';
			$vip[ViewItemParams::item_detailed_info] = '||Peerflix-Server IP:|' . $this->showIp . '||Загрузить торрент файл|Добавляет в Peerflix-Server торрент файл c локального диска или по сети';
			$vip[ViewItemParams::item_caption_color] = 10;
			if (defined('FONT_SIZE_LARGE') === true)
				$vip[ViewItemParams::item_caption_font_size] = FONT_SIZE_LARGE;
			$items[] = array(
				PluginRegularFolderItem::media_url => 'addLocalTorrent',
				PluginRegularFolderItem::caption => 'Загрузить торрент файл',
				PluginRegularFolderItem::view_item_params => $vip
			);
			if (is_array($torrentObj)){
				$torrentObj = array_reverse($torrentObj);
				$peerflixServerInf = HD::getItemsArr('PeerflixServerInf');
				foreach ($torrentObj as $torrent){
					$color = 15;
					$detailed_icon = 'plugin_file://icons/'.$media_url->class_name.'.png';
					$view_item_params = array();
					if (isset($torrent->name)){
						$caption = $torrent->name;
						$detailed_info = '||' . implode( ' ', HD::mb_str_split($caption, 23));
						if (isset($torrent->length))
							$detailed_info .= '|' . HD::readableBytes($torrent->length);
						$icon_path = 'plugin_file://icons/s_torrent.png';
						$description = 'Peerflix-Server';
						if (isset($peerflixServerInf[$torrent->infoHash])){
							$inf = json_decode($peerflixServerInf[$torrent->infoHash]);
							$description = $inf->overview;
							$detailed_icon =  $inf->poster_path;
							$detailed_info .= "||" .  $inf->title . 
							"|" .  $inf->year . 
							"||" . $inf->original_title . 
							"|" . $description;
							
							if (defined('ViewParams::details_box_width') === true){
								$view_item_params[ViewItemParams::item_detailed_icon_width] = 200;
								$view_item_params[ViewItemParams::item_detailed_icon_height] = 291;
							}
						}
						$arr['movie_id'] = $torrent->infoHash;
						$arr['class_name'] = $media_url->class_name;
						$arr['detailed_info'] = $detailed_info;
						$arr['data']['caption'] = $caption;
						$arr['data']['poster_url'] =  $detailed_icon;
						$arr['data']['description'] = $description;
						$mUrl = VodSeriesListScreen::get_media_url_str($media_url->class_name, $arr);
						if ($torrent->ready != true){
							$mUrl = 'hashing_' . $torrent->infoHash;
							$icon_path = 'plugin_file://icons/roundarr.png';
							$detailed_info .= '||Хеширование'.str_repeat(".", rand(0, 10)) .'|Это может занять какоето время в зависимости от размера файла';
							$color = 23;
						}
					}else{
						$caption = 'Добавление...';
						$icon_path = 'plugin_file://icons/question.png';
						$detailed_info = '||Добавление'.str_repeat(".", rand(0, 10)) .'|Долгое добавление торрента говорит о том что нет раздающих';
						$mUrl = 'dummy';
						$color = 5;
					}
					
					$view_item_params[ViewItemParams::item_caption_color] = $color;
					$view_item_params[ViewItemParams::icon_path] = $icon_path;
					$view_item_params[ViewItemParams::item_detailed_info] = $detailed_info;
					$view_item_params[ViewItemParams::item_detailed_icon_path] = $detailed_icon;
					
					
					
					$items[] = array(
						PluginRegularFolderItem::media_url => $mUrl,
						PluginRegularFolderItem::caption => $caption,
						PluginRegularFolderItem::view_item_params => $view_item_params
					);
				}
			}
		}else{
			self::$counter++;
			$this->select_url = array();
			$this->showIp = PeerflixServer::getIp();
			$counter = HD::sec_format_duration(self::$counter);
			$caption = "Ожидание ответа от Peerflix-Server Прошло: $counter";
			$item_detailed_info = "||Peerflix-Server|{$this->showIp}||Ожидание ответа от Peerflix-Server | Прошло: $counter";
			$icon_path = 'plugin_file://icons/s_peerflixserver.png';
			$detailed_icon = 'plugin_file://icons/PeerflixServer.png';
			$color = 15;
			if (self::$counter > 60){
				$caption = "Peerflix-Server {$this->showIp} не отвечает! Прошло: $counter";
				$item_detailed_info = "||Внимание Peerflix-Server не запущен или не отвечает|Перезапустите Peerflix-Server по адресу {$this->showIp} или измените IP адрес Peerflix-Server| Прошло: $counter";
				$icon_path = 'plugin_file://icons/0.png';
				$detailed_icon = 'plugin_file://icons/0.png';
				$color = 21;
			}
			$items[] = array(
				PluginRegularFolderItem::media_url => 'dummy',
				PluginRegularFolderItem::caption => $caption,
				PluginRegularFolderItem::view_item_params => array(
					ViewItemParams::icon_path => $icon_path,
					ViewItemParams::item_detailed_icon_path => $detailed_icon,
					ViewItemParams::item_detailed_info => $item_detailed_info,
					ViewItemParams::item_caption_color => $color,
				)
			);
		}
        return $items;
    }
	private function get_folder_views(){
		$background_path = SmartConfig::getPluginIco(self::ID . '_bg');
		$arr[0][PluginRegularFolderView::async_icon_loading] = true;
		$arr[0][PluginRegularFolderView::timer] = array(GuiTimerDef::delay_ms => 1000);
		$arr[0][PluginRegularFolderView::view_params][ViewParams::num_cols] = 1;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::num_rows]= 10;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_details] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_item_info_in_details] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_auto_line_break] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_title_color] = 10;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_text_color] = 15;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_font_size] = (HD::getItemStr('detailedInfoFontSize') != '') ? HD::getItemStr('detailedInfoFontSize') : FONT_SIZE_SMALL;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_path] = $background_path;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_order] = 0;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_height] = 1080;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_width] = 1920;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::optimize_full_screen_background] = true;
		
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_layout] = HALIGN_LEFT;
        $arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_valign] = VALIGN_CENTER;
        $arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_dx] = 10;
        $arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_dy] = -5;
        $arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_caption_dx] = 60;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_width] = 50;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_height] = 50;
		
		$arr[0][PluginRegularFolderView::not_loaded_view_item_params]= array ();
		
		
		////////////////////////////////////////////////////////////////////////////////////////////
		$arr[1][PluginRegularFolderView::async_icon_loading] = true;
		$arr[1][PluginRegularFolderView::timer] = array(GuiTimerDef::delay_ms => 1500);
		$arr[1][PluginRegularFolderView::view_params][ViewParams::num_cols] = 1;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::num_rows]= 10;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_details] = false;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_font_size] = (HD::getItemStr('detailedInfoFontSize') != '') ? HD::getItemStr('detailedInfoFontSize') : FONT_SIZE_SMALL;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_path] = $background_path;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_order] = 0;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_height] = 1080;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_width] = 1920;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::optimize_full_screen_background] = true;
		
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_layout] = HALIGN_LEFT;
        $arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_valign] = VALIGN_CENTER;
        $arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_dx] = 10;
        $arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_dy] = -5;
        $arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_caption_dx] = 60;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_width] = 50;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_height] = 50;
		
		$arr[1][PluginRegularFolderView::not_loaded_view_item_params]= array ();
		////////////////////////////////////////////////////////////////////////////////////////////
		
		
        return $arr;
    }
    public function get_archive(MediaURL $media_url){
        return $this->vod->get_archive($media_url);
    }
}

?>
