<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/vod/vod.php';
require_once 'lib/abstract_preloaded_regular_screen.php';

///////////////////////////////////////////////////////////////////////////

class VodSeasonListScreen extends AbstractPreloadedRegularScreen
implements UserInputHandler {
    const ID = 'vod_season';

    public static function get_media_url_str($class_name, $arr=null){
		$arr['screen_id'] = self::ID;			
		$arr['class_name'] = $class_name;
        return MediaURL::encode($arr);
    }

    ///////////////////////////////////////////////////////////////////////
	private $vod;
    ///////////////////////////////////////////////////////////////////////
	
    public function __construct(Vod $vod){
        parent::__construct(self::ID, $this->get_folder_views());
        $this->vod = $vod;
		UserInputHandlerRegistry::get_instance()->
            register_handler($this);
    }

    ///////////////////////////////////////////////////////////////////////

    public function get_action_map(MediaURL $media_url, &$plugin_cookies){
		$add_params['action'] = 'addToMainMenu';
		$add_action = UserInputHandlerRegistry::create_action($this, 'classAction', $add_params);
        $add_action['caption'] = 'В Главное Меню';
        $actions[GUI_EVENT_KEY_B_GREEN] = $add_action;
		
		$add_action = ActionFactory::open_folder('setup','Настройки');
        $add_action['caption'] = 'Настройки';
        $actions[GUI_EVENT_KEY_C_YELLOW] = $add_action;
		$actions[GUI_EVENT_KEY_SETUP] = $add_action;
		
		$add_params['action'] = 'addToFav';
		$add_action = UserInputHandlerRegistry::create_action($this, 'classAction', $add_params);
        $add_action['caption'] = 'Избранное';
        $actions[GUI_EVENT_KEY_D_BLUE] = $add_action;
		
		$actions[GUI_EVENT_KEY_ENTER] = UserInputHandlerRegistry::create_action($this, 'add_actions');
		$actions[GUI_EVENT_KEY_PLAY] = UserInputHandlerRegistry::create_action($this, 'add_actions');
				
		$popup_menu_action = UserInputHandlerRegistry::create_action($this, 'popup_menu');
		$actions[GUI_EVENT_KEY_POPUP_MENU] = $popup_menu_action;
		
		$actions[GUI_EVENT_KEY_SEARCH] = UserInputHandlerRegistry::create_action($this, 'classAction', array('action' => 'search'));
		$useNumKey = HD::getItemsArr('useNumKey');
		foreach ($useNumKey as $k => $v){
			$params['openCat'] = $v;
			$actions[SmartConfig::$keyArr[$k]] = UserInputHandlerRegistry::create_action($this, 'add_actions', $params);
		}
		// $actions[GUI_EVENT_TIMER] = UserInputHandlerRegistry::create_action($this, 'timer');
		return $actions;
    }
	public function get_handler_id(){
		return self::ID;
	}
	
	public function handle_user_input(&$user_input, &$plugin_cookies){
		$parentalControl = isset($plugin_cookies->parentalControl) ? $plugin_cookies->parentalControl : '';
		// if ($user_input->control_id == 'timer'){
			// return ActionFactory::invalidate_folders(array($user_input->parent_media_url));
		// }
		if ($user_input->control_id == 'add_actions'){
			if (isset($user_input->openCat))
				$user_input->selected_media_url = $user_input->openCat; 
			$this->vod->seasons_media_url['screen_counter'] = $this->vod->seasons_media_url['screen_counter'] + 1;
			if (isset($user_input->openCat)){
				$selected_media_url = MediaURL::decode($user_input->selected_media_url);
				return ActionFactory::open_folder($user_input->selected_media_url, $selected_media_url->caption);
			}
			return ActionFactory::open_folder();
		}
		if ($user_input->control_id == 'popup_menu'){
			if (isset($user_input->selected_media_url)){
				$selected_media_url = MediaURL::decode($user_input->selected_media_url);
				$class_name = $selected_media_url->class_name;
				$add_params['action'] = 'addToFav';
				$menu_items[] = array(
					GuiMenuItemDef::caption => 'Избранное',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', $add_params),
					GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_addToFav')
				);
				$menu_items [] =  array(
					GuiMenuItemDef::is_separator => true,);
				if (preg_match("|_Class|",$class_name)){
					$mItems = $class_name::getPopUpMenuItems($selected_media_url, $user_input->parent_media_url);
					foreach ($mItems as $v){
						if ($v == 'is_separator')
							$menu_items [] =  array(
							GuiMenuItemDef::is_separator => true,);
						// else if ($v['params'] == 'classSetup')
							// $menu_items[] = array(
								// GuiMenuItemDef::caption => $v['caption'],
								// GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classSetup' . $class_name),
								// GuiMenuItemDef::icon_url => $v['icon_url'],
							// );
						else
							$menu_items[] = array(
								GuiMenuItemDef::caption => $v['caption'],
								GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', $v['params']),
								GuiMenuItemDef::icon_url => $v['icon_url'],
							);
					}
				}
			}
			$menu_items [] =  array(
					GuiMenuItemDef::is_separator => true,);
			$menu_items [] =  array(
				GuiMenuItemDef::is_separator => true,);
			$add_params['action'] = 'background_actions';
			$menu_items[] = array(
				GuiMenuItemDef::caption => 'Задать бекграунд',
				GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', $add_params),
				GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_add_background')
			);
			if (file_exists(HD::get_data_path() . "/icons/" . self::ID . "_bg.jpg")){
				$add_params['action'] = 'background_actions';
				$add_params['del'] = true;
				$menu_items[] = array(
					GuiMenuItemDef::caption => 'Удалить бекграунд',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', $add_params),
					GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_del_background')
				);
			}
			return ActionFactory::show_popup_menu($menu_items);
		}
		if ($user_input->control_id == 'classAction'){
			$defs = array();
			hd_silence_warnings();
			if (isset($user_input->indiClass)){
				$selected_media_url = MediaURL::decode($user_input->selected_media_url);
				$class_name = $selected_media_url->class_name;
				return $class_name::classAction ($defs, $user_input, $this->select_url);
			}
			return SmartConfig::classAction ($defs, $user_input, $this->select_url);
		}
	}
    ///////////////////////////////////////////////////////////////////////

    public function get_all_folder_items(MediaURL $media_url, &$plugin_cookies){
		$class_name = $media_url->class_name;
		$movie = $this->vod->get_loaded_movie($media_url, $plugin_cookies);
		$framesEpisode = (HD::getItemStr('framesEpisode') != '') ? HD::getItemStr('framesEpisode') : 1;
		if ($framesEpisode == 1)
			$posters_list = TheMovieDatabase_Class::get_themoviedbId_posters($media_url->movie_id, $movie);
		$raw_string = $media_url->get_raw_string();
		$source_list = $class_name::getSeasons($media_url);
        $items = array();
		foreach ($source_list as $v){
			$view_item_params = $mArr = array();
			if (isset($v['link']))
				$mArr['link'] = $v['link'];
			if ((preg_match('|езон (\d+)|', $v['caption'], $m))||
				(preg_match('#(\d+)\D*?езон#', $v['caption'], $m))){
					if (isset($posters_list[$m[1]])){
						$v['poster_url'] = $posters_list[$m[1]]['poster_path'];
						$v['detailed_info'] .= '||Количество эпизодов:|' . $posters_list[$m[1]]['episode_count'];
					}
			}
			$mArr['caption'] = $v['caption'];
			$mArr['detailed_info'] = $v['detailed_info'];
			$mArr['class_name'] = $v['class_name'];
			$mArr['movie_id'] = $media_url->movie_id;
			$mArr['poster_url'] = $v['poster_url'];
			if (isset($media_url->hash_patrs)){
				$mArr['hash_patrs'] = (array)$media_url->hash_patrs;
				if (isset($v['season']))
					$mArr['hash_patrs']['season'] = $v['season'];
			}
			if (isset($media_url->description))
				$mArr['description'] = $media_url->description;
			if ($media_url->infoSourseClassName)
				$mArr['infoSourseClassName'] = $media_url->infoSourseClassName;
			$mUrl = $v['goTo']::get_media_url_str($v['class_name'],$mArr);
			if (isset($v['season']))
				$this->vod->seasons_media_url['seasons'][$raw_string][$v['season']] = $mUrl;
			$view_item_params[ViewItemParams::icon_path] = $v['poster_url'];
			$view_item_params[ViewItemParams::item_detailed_icon_path] = $v['poster_url'];
			if (isset($v['detailed_info']))
				$view_item_params[ViewItemParams::item_detailed_info] = $v['detailed_info'];
            $items[] = array(
                PluginRegularFolderItem::media_url => $mUrl,
                PluginRegularFolderItem::caption => $v['caption'],
                PluginRegularFolderItem::view_item_params => $view_item_params
            );
        }
        return $items;
    }

    ///////////////////////////////////////////////////////////////////////

    private function get_folder_views(){
		// $sandwich_cover = SmartConfig::getPluginIco('sandwich_cover');
		// $sandwich_base = SmartConfig::getPluginIco('sandwich_base');
		$sandwich_base2 = SmartConfig::getPluginIco('badge1');
		$background_path = SmartConfig::getPluginIco(self::ID . '_bg');
		$paintBackground = (HD::getItemsArr('paintBackground') != array()) ? HD::getItemsArr('paintBackground') : array('paint_widget_background' => true, 'paint_content_box_background' => true, 'paint_path_box_background' => true, 'paint_details_box_background' => true);
		$paintSandwich = (HD::getItemStr('paintSandwich') != '') ? (bool)HD::getItemStr('paintSandwich') : true;
//==>	
	
		$arr[0][PluginRegularFolderView::async_icon_loading] = true;
		//$arr[0][PluginRegularFolderView::timer] = array(GuiTimerDef::delay_ms =>  1000);
		$arr[0][PluginRegularFolderView::view_params][ViewParams::num_cols] = 1;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::num_rows] = 4;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_details] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_item_info_in_details] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_auto_line_break] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_title_color] = 10;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_text_color] = 15;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_font_size] = (HD::getItemStr('detailedInfoFontSize') != '') ? HD::getItemStr('detailedInfoFontSize') : FONT_SIZE_SMALL;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_path] = $background_path;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_order] = 0;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_height] = 1080;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_width] = 1920;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::optimize_full_screen_background] = true;
		if (defined('ViewParams::paint_icon_badge_box') === true){
			$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_icon_badge_box] = true;
			$arr[0][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_width] = 105;
			$arr[0][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_height] = 155;
			$arr[0][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_dx] = -580;
			$arr[0][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_sel_width] = 110;
			$arr[0][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_sel_height] = 160;
		}
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_widget_background] = $paintBackground['paint_widget_background'];
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_content_box_background] = $paintBackground['paint_content_box_background'];
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_path_box_background] = $paintBackground['paint_path_box_background'];
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_details_box_background] = $paintBackground['paint_details_box_background'];
		
		$arr[0][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[0][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_width] = 110;
		$arr[0][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_height] = 160;
		$arr[0][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_path] = $sandwich_base2;
		
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_layout] = HALIGN_LEFT;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_valign] = VALIGN_CENTER;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_caption] = false;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_scale_factor] = 1.0;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_scale_factor] = 1.1;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_width] = 110;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_height] = 160;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_dx] = 4;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_dy] = -7;
		if (defined('ViewItemParams::item_detailed_icon_width') === true){
			$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_detailed_icon_width] = 200;
			$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_detailed_icon_height] = 291;
		}
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_margin_top] = 0;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_caption] = true;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_caption_width] = 1030;	
//==>
		$arr[1][PluginRegularFolderView::async_icon_loading] = true;
		//$arr[1][PluginRegularFolderView::timer] = array(GuiTimerDef::delay_ms =>  1000);
		$arr[1][PluginRegularFolderView::view_params][ViewParams::num_cols] = 1;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::num_rows] = 10;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_details] = true;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_item_info_in_details] = true;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_auto_line_break] = true;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_title_color] = 10;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_text_color] = 15;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_font_size] = (HD::getItemStr('detailedInfoFontSize') != '') ? HD::getItemStr('detailedInfoFontSize') : FONT_SIZE_SMALL;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_path] = $background_path;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_order] = 0;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_height] = 1080;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_width] = 1920;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::optimize_full_screen_background] = true;
		
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_widget_background] = $paintBackground['paint_widget_background'];
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_content_box_background] = $paintBackground['paint_content_box_background'];
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_path_box_background] = $paintBackground['paint_path_box_background'];
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_details_box_background] = $paintBackground['paint_details_box_background'];
		
		$arr[1][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[1][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_width] = 34;
		$arr[1][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_height] = 50;
		$arr[1][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_path] = $sandwich_base2;
		
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_layout] = HALIGN_LEFT;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_valign] = VALIGN_CENTER;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_caption] = false;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_scale_factor] = 1.0;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_scale_factor] = 1.1;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_width] = 34;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_height] = 50;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_dx] = 5;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_dy] = -5;
		if (defined('ViewItemParams::item_detailed_icon_width') === true){
			$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_detailed_icon_width] = 200;
			$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_detailed_icon_height] = 291;
		}
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_margin_top] = 0;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_caption] = true;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_caption_width] = 1120;
//==>		

//==>
		return $arr;
	}
}

///////////////////////////////////////////////////////////////////////////
?>
