<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/vod/vod.php';
require_once 'lib/abstract_preloaded_regular_screen.php';

class VodSeriesListScreen extends AbstractPreloadedRegularScreen
    implements UserInputHandler
{
    const ID = 'vod_series';

     public static function get_media_url_str($class_name, $arr=null){
		$arr['screen_id'] = self::ID;			
		$arr['class_name'] = $class_name;
        return MediaURL::encode($arr);
    }

    ///////////////////////////////////////////////////////////////////////

    private $vod;
	private $gbSort = array();
	private $select_url = array();
	private $lastLink = null;
	private $addTorrent = false;
	static $downViewed = false;
	static $series_ndx;
    public function __construct(Vod $vod){
        $this->vod = $vod;
        parent::__construct(self::ID, $this->get_folder_views());
		UserInputHandlerRegistry::get_instance()->register_handler($this);
    }
	
    ///////////////////////////////////////////////////////////////////////

    public function get_action_map(MediaURL $media_url, &$plugin_cookies){
        $params['event_key'] = 'enter';
        $actions[GUI_EVENT_KEY_ENTER]		= UserInputHandlerRegistry::create_action($this, 'add_action',$params);
		$params['event_key'] = 'play';
        $actions[GUI_EVENT_KEY_PLAY] 		= UserInputHandlerRegistry::create_action($this, 'add_action',$params);
		
		$add_action = UserInputHandlerRegistry::create_action($this, 'viewed');
		$add_action['caption'] = 'Просм./Не просм.';
		$actions[GUI_EVENT_KEY_B_GREEN] = $add_action;
		
		$add_action = UserInputHandlerRegistry::create_action($this, 'smartConfigClassAction', array('action' => 'aditionalSettings'));
		$add_action['caption'] = 'Настройки видео';
		$actions[GUI_EVENT_KEY_C_YELLOW] = $add_action;
		if (isset($this->vod->currentFav)){
			$currentFav = MediaURL::decode($this->vod->currentFav);
			$saveFoldersArr = HD::getItemsArr($currentFav->class_name . '_saveFoldersArr');
			$add_action = UserInputHandlerRegistry::create_action($this, 'saveFolder');
			$add_action['caption'] = 'Сохранить папку';
			if (isset($saveFoldersArr[$media_url->movie_id]))
				$add_action['caption'] = 'Удалить папку';
			$actions[GUI_EVENT_KEY_D_BLUE] = $add_action;
		}
        
		$popup_menu_action = UserInputHandlerRegistry::create_action($this, 'popup_menu');
		$actions[GUI_EVENT_KEY_POPUP_MENU] = $popup_menu_action;
		$actions[GUI_EVENT_TIMER] = UserInputHandlerRegistry::create_action($this, 'timer');
		$actions[GUI_EVENT_KEY_SETUP] = ActionFactory::open_folder('setup');
		$actions[GUI_EVENT_KEY_SELECT] = UserInputHandlerRegistry::create_action($this, 'select');
		$actions[GUI_EVENT_KEY_CLEAR] = UserInputHandlerRegistry::create_action($this, 'clearSelectUrls');
		if (defined('GUI_EVENT_MENU_PLAYBACK_FINISH') === true)
			$actions[GUI_EVENT_MENU_PLAYBACK_FINISH] = UserInputHandlerRegistry::create_action($this, 'playback_finish');
		$class_name = $media_url->class_name;
		$actionsArr = $class_name::getScreenActionMapArr($media_url);
		foreach ($actionsArr as $k => $v){
			$params = false;
			if (isset($v['params']))
				$params = $v['params'];
			$add_action = UserInputHandlerRegistry::create_action($this, $v['create_action'], $params);
			if (isset($v['caption']))
				$add_action['caption'] = $v['caption'];
			$actions[$v['key']] = $add_action;
		}
		return $actions;
    }

    ///////////////////////////////////////////////////////////////////////
	public function get_handler_id(){ return self::ID; }
	
	public function handle_user_input(&$user_input, &$plugin_cookies){
        // foreach ($user_input as $key => $value)
            // hd_print("  $key => $value");
		if ($user_input->control_id == 'playback_finish'){
			if (self::$downViewed != false){
				$parent_media_url = MediaURL::decode($user_input->parent_media_url);
				$range = HD::create_regular_folder_range($this->grange);
				return ActionFactory::update_regular_folder($range, false, self::$series_ndx);
			}
			return null;
		}
		if ($user_input->control_id == 'saveFolder'){
			$parent_media_url = MediaURL::decode($user_input->parent_media_url);
			$currentFav = MediaURL::decode($this->vod->currentFav);
			$saveFoldersArr = HD::getItemsArr($currentFav->class_name . '_saveFoldersArr');
			if (((isset($this->vod->seasons_media_url['seasons']))&&
			(!isset($saveFoldersArr[$parent_media_url->movie_id])))||
			((!isset($saveFoldersArr[$parent_media_url->movie_id]))&&(isset($parent_media_url->tType))&&($parent_media_url->tType =='torrent'))){
				if (isset($user_input->folderApply)){
					if ((isset($parent_media_url->tType))&&($parent_media_url->tType =='torrent'))
						$mUrlSeasons = $parent_media_url->movie_id;
					else
						$mUrlSeasons = key($this->vod->seasons_media_url['seasons']);
					$saveFoldersArr[$parent_media_url->movie_id]['mUrl'] = $user_input->parent_media_url;
					$saveFoldersArr[$parent_media_url->movie_id]['mUrlSeasons'] = $mUrlSeasons;
					foreach ($this->vod->seasons_media_url['seasons'][$mUrlSeasons] as $k => $v){
						if (HD::strSanitizing($k) == HD::strSanitizing($parent_media_url->hash_patrs->season)){
							$saveFoldersArr[$parent_media_url->movie_id]['mUrlSelSeason'] = $v;
							break;
						}
					}
					if ($user_input->folderApply == 'yes'){
						$class_name = $parent_media_url->class_name;
						// $series = $class_name::get_series_list($parent_media_url, $parent_media_url->poster_url);
						foreach ($this->movie->series_list as $item)
							$saveFoldersArr[$parent_media_url->movie_id]['series'][md5($user_input->parent_media_url)][$item->id] = 1;
					}
					if (HD::saveItemsArr($currentFav->class_name . '_saveFoldersArr', $saveFoldersArr) == false)
						return ActionFactory::show_title_dialog("Сохранение не удалось");
					$invArr = array($user_input->parent_media_url);
					if (isset($this->vod->seasons_media_url['movie_screen']))
						$invArr[] = $this->vod->seasons_media_url['movie_screen'];
					if (isset($this->vod->currentFav))
						$invArr[] = $this->vod->currentFav;
					$post_action = ActionFactory::invalidate_folders($invArr);
					$post_action = ActionFactory::open_folder($user_input->parent_media_url, $parent_media_url->caption, $post_action);
					if (isset($this->vod->seasons_media_url['skipCloseAndRun']))
						unset($this->vod->seasons_media_url['skipCloseAndRun']);
					else
						$post_action = ActionFactory::close_and_run($post_action);
					$post_action = ActionFactory::close_and_run($post_action);
					$caption = 'Папка сохранена';
					if ($this->vod->seasons_media_url['screen_counter'] == 3){
						unset ($this->vod->seasons_media_url['screen_counter']);
						$post_action = ActionFactory::close_and_run($post_action);
					}
					$post_action = ActionFactory::close_and_run($post_action);
					$this->vod->ifx = true;
					return ActionFactory::show_title_dialog($caption, $post_action, $parent_media_url->caption, 800);
				}
				$params['folderApply'] = 'yes';
				ControlFactory::add_close_dialog_and_apply_button($defs, $this, $params, $user_input->control_id, 'Да', 500);
				$params['folderApply'] = 'no';
				ControlFactory::add_close_dialog_and_apply_button($defs, $this, $params, $user_input->control_id, 'Нет', 500);
				return  ActionFactory::show_dialog("Отслеживать новые серии?", $defs, true);
			}else{
				if (isset($saveFoldersArr[$parent_media_url->movie_id])){
					if (isset($saveFoldersArr[$parent_media_url->movie_id]['mUrlSeasons'])){
						$mUrlSeasons = $saveFoldersArr[$parent_media_url->movie_id]['mUrlSeasons'];
						$selNdx = null;
						if (isset($saveFoldersArr[$parent_media_url->movie_id]['mUrlSelSeason']))
							$selNdx = $saveFoldersArr[$parent_media_url->movie_id]['mUrlSelSeason'];
						
						if ((!isset($user_input->listSeasonsApply))&&(!isset($parent_media_url->tType))){
							$params['listSeasonsApply'] = 'yes';
							ControlFactory::add_close_dialog_and_apply_button($defs, $this, $params, $user_input->control_id, 'Да', 500);
							$params['listSeasonsApply'] = 'no';
							ControlFactory::add_close_dialog_and_apply_button($defs, $this, $params, $user_input->control_id, 'Нет', 500);
							return  ActionFactory::show_dialog("Открыть список сезонов?", $defs, true);
						}
					}
					unset ($saveFoldersArr[$parent_media_url->movie_id]);
					$err = "Удаление не удалось";
					$action = 'del';
				}else{
					$saveFoldersArr[$parent_media_url->movie_id]['mUrl'] = $user_input->parent_media_url;
					$err = "Сохранение не удалось";
					$action = 'add';
				}
				if (HD::saveItemsArr($currentFav->class_name . '_saveFoldersArr', $saveFoldersArr) == false)
					return ActionFactory::show_title_dialog($err);
				else{
					if ($action == 'add'){
						$invArr = array($user_input->parent_media_url, $this->vod->seasons_media_url['movie_screen']);
						if (isset($this->vod->currentFav))
							$invArr[] = $this->vod->currentFav;
						$post_action = ActionFactory::invalidate_folders($invArr);
						$post_action = ActionFactory::open_folder($user_input->parent_media_url, $parent_media_url->caption, $post_action);
						
						echo 'screen_counter:' . $this->vod->seasons_media_url['screen_counter'];
						$post_action = ActionFactory::close_and_run($post_action);
						$caption = 'Папка сохранена';
					}else{
						$invArr = array();
						if (isset($this->vod->seasons_media_url['movie_screen']))
							$invArr[] = $this->vod->seasons_media_url['movie_screen'];
						if (isset($this->vod->currentFav))
							$invArr[] = $this->vod->currentFav;
						$post_action = ActionFactory::invalidate_folders($invArr);
						if ((isset($mUrlSeasons))&&(isset($user_input->listSeasonsApply))&&($user_input->listSeasonsApply == 'yes')){
							$this->vod->seasons_media_url['skipCloseAndRun'] = 1;
							$post_action = ActionFactory::open_folder($mUrlSeasons, 'Сезоны', $post_action, $selNdx);
						}else{
							$mArr['movie_id'] = $parent_media_url->movie_id;
							$media_url = VodSourceListScreen::get_media_url_str($parent_media_url->class_name, $mArr);
							$post_action = ActionFactory::open_folder($media_url, 'Источники', $post_action);
						}
						$caption = 'Папка удалена';
					}
					$this->vod->ifx = true;
					$post_action = ActionFactory::close_and_run($post_action);
					return ActionFactory::show_title_dialog($caption, $post_action, $parent_media_url->caption, 800);
				}
			}
		}
		if ($user_input->control_id == 'clearSelectUrls'){
			$this->select_url = array();
			return ActionFactory::invalidate_folders(array($user_input->parent_media_url));
		}
		if ($user_input->control_id == 'select'){
            if (!isset($user_input->selected_media_url))
                return null;
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			if ($selected_media_url->series_id != 'dummy'){
				if (isset($this->select_url[$selected_media_url->movie_id][$user_input->selected_media_url]))
					unset ($this->select_url[$selected_media_url->movie_id][$user_input->selected_media_url]);
				else
					$this->select_url[$selected_media_url->movie_id][$user_input->selected_media_url] = $user_input->selected_media_url;
				$parent_media_url = MediaURL::decode($user_input->parent_media_url);
				$range = $this->get_folder_range($parent_media_url, 0, $plugin_cookies);
				return ActionFactory::update_regular_folder($range, true, $user_input->sel_ndx + 1);
			}
			return null;
		}
		if ($user_input->control_id == 'selectAndroidAction'){
			$parent_media_url = MediaURL::decode($user_input->parent_media_url);
			$class_name = $parent_media_url->class_name;
			if (($class_name == 'TorrServer')||($class_name == 'PeerflixServer')){
				$params['action'] = 'selectAndroidAction';
				if (isset($user_input->playAll))
					$params['playAll'] = 1;
				return UserInputHandlerRegistry::create_action($this, 'classAction', $params);
			}else{//bazinga
				echo 'todo';
			}
		}
		if ($user_input->control_id == 'popup_menu'){
			$selected_media_url = (object)array();
			if (isset($user_input->selected_media_url))
				$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			$parent_media_url = MediaURL::decode($user_input->parent_media_url);
			if ((isset($this->movie->mShowsA))&&(isset($this->movie->class_info["dbIDs"]["myShowsID"]))){
				$watchedMyShows = myShows_Class::getWatchedMyShows($this->movie->class_info["dbIDs"]["myShowsID"], $this->movie->mShowsA);
				if (isset($selected_media_url->file_info->myShowsShowID)){
					$caption = 'Просмотренно myShows';
					$arg = 'add';
					if (isset($watchedMyShows[$selected_media_url->file_info->myShowsShowID])){
						$caption = 'Не просмотренно myShows';
						$arg = 'del';
					}
					$menu_items[] = array(
						GuiMenuItemDef::caption => $caption,
						GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', array('action' => 'watchMyShows', 'indiClass' => 'myShows_Class', 'accessToken'=> $this->movie->mShowsA, 'myShowsID' => $this->movie->class_info["dbIDs"]["myShowsID"], 'arg' => $arg)),
						GuiMenuItemDef::icon_url => $this->myshows
					);
				}
				if (isset($selected_media_url->file_info->myShowsShowID))
					$menu_items[] = array(
						GuiMenuItemDef::caption => 'Коментарии с myShows к эпизоду',
						GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', array('action' => 'reviews', 'indiClass' => 'myShows_Class', 'mShowsA'=> $this->movie->mShowsA, 'myShowsID' => $this->movie->class_info["dbIDs"]["myShowsID"], 'myShowsShowID' => $selected_media_url->file_info->myShowsShowID, 'series_name' => $selected_media_url->name, 'favMyShows' => $this->movie->currentFavItem)),
						GuiMenuItemDef::icon_url => $this->myshows
					);
			}
			if (isset($parent_media_url->class_name)){
				$class_name = $parent_media_url->class_name;
				$select_url = false;
				if (isset($this->select_url[$selected_media_url->movie_id]))
					$select_url = $this->select_url[$selected_media_url->movie_id];
				$mItems = $class_name::getPopUpMenuItems($selected_media_url, $user_input->parent_media_url);
				foreach ($mItems as $v){
					if ($v == 'is_separator')
						$menu_items [] =  array(
						GuiMenuItemDef::is_separator => true,);
					else if ($v['params'] == 'classSetup')
						$menu_items[] = array(
							GuiMenuItemDef::caption => $v['caption'],
							GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classSetup' . $class_name),
							GuiMenuItemDef::icon_url => $v['icon_url'],
						);
					else
						$menu_items[] = array(
							GuiMenuItemDef::caption => $v['caption'],
							GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', $v['params']),
							GuiMenuItemDef::icon_url => $v['icon_url'],
						);
				}
			}
			if (HD::is_android() == true){
				$menu_items[] = array(
					GuiMenuItemDef::caption => 'Играть Файл через Android',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'playDirectly', array('is_android' => true)),
					GuiMenuItemDef::icon_url => 'plugin_file://icons/s_android.png'
				);
				$menu_items[] = array(
					GuiMenuItemDef::caption => 'Играть Все файлы через Android',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'playDirectly', array('is_android' => true, 'playAll' => true)),
					GuiMenuItemDef::icon_url => 'plugin_file://icons/s_android.png'
				);
			}
			$menu_items[] = array(
				GuiMenuItemDef::caption => 'Проиграть файл напрямую',
				GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'playDirectly'),
				GuiMenuItemDef::icon_url => 'plugin_file://icons/s_play.png'
			);
			$menu_items[] = array(
				GuiMenuItemDef::caption => 'Проиграть все файлы напрямую',
				GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'playDirectly', array('playAll' => true)),
				GuiMenuItemDef::icon_url => 'plugin_file://icons/s_play.png'
			);
			$menu_items [] =  array(
				GuiMenuItemDef::is_separator => true,);
			$menu_items[] = array(
				GuiMenuItemDef::caption => 'Снять все отметки о просмотре',
				GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'clearViewedItems'),
				GuiMenuItemDef::icon_url => 'plugin_file://icons/s_unselect.png'
			);
			$menu_items[] = array(
				GuiMenuItemDef::caption => 'Отметить все просмотренным',
				GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'markViewedItems'),
				GuiMenuItemDef::icon_url => 'plugin_file://icons/s_select.png'
			);
			if ((isset($class_name))
				&&($class_name != 'TorrServer')
				&&($class_name != 'PeerflixServer')
				&&($class_name != 'Transmission')
				&&($class_name != 'TransmissionUPnP')
			){
				$menu_items [] =  array(
					GuiMenuItemDef::is_separator => true,);
				$add_params['action'] = 'background_actions';
				$menu_items[] = array(
					GuiMenuItemDef::caption => 'Задать бекграунд',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', $add_params),
					GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_add_background')
				);
				if (file_exists(HD::get_data_path() . "/icons/" . self::ID . "_bg.jpg")){
					$add_params['action'] = 'background_actions';
					$add_params['del'] = true;
					$menu_items[] = array(
						GuiMenuItemDef::caption => 'Удалить бекграунд',
						GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', $add_params),
						GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_del_background')
					);
				}
			}
			return ActionFactory::show_popup_menu($menu_items);
		}
		if ($user_input->control_id == 'playDirectly'){
			if (!isset($user_input->selected_media_url))
                return null;
			$start_index = $post_action = null;
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			if ($selected_media_url->class_name == "Filmix_Class")
				$video_quality = (HD::getItemStr('filmix_quality', true) != '') ? HD::getItemStr('filmix_quality', true) : 1;
			else
				$video_quality = (HD::getItemStr('video_quality', true) != '') ? HD::getItemStr('video_quality', true) : 1;
			if (isset($this->movie->history_mUrl)){
				$itemsHistory = HD::getItemsArr('itemsHistory');
				if (isset($itemsHistory[$this->movie->history_mUrl]))
					unset ($itemsHistory[$this->movie->history_mUrl]);
				$history_str = "||Просмотрено: ".date("d.m.Y") .'|'. $selected_media_url->name . $selected_media_url->detailed_info;
				$itemsHistory = array($this->movie->history_mUrl => $history_str) + $itemsHistory;
				$posterCasheHist = (HD::getItemStr('posterCasheHist') != '') ? HD::getItemStr('posterCasheHist') : 0;
				if ($posterCasheHist == 1){
					$output = array_slice($itemsHistory, 310);
					$cachePath = HD::get_data_path() . "/pluginCache/";
					if (count($output) > 0){
						foreach ($output as $k => $v){
							$cUrl = MediaURL::decode($k);
							$arrCachePath = $cachePath . md5($cUrl->movie_id . $cUrl->class_name) . '.srz';
							$cachePosterUrl = $cachePath . md5($k) . '.jpg';
							if (file_exists($cachePosterUrl))
								shell_exec('rm -rf "'.$cachePosterUrl.'" &');
							if (file_exists($arrCachePath))
								shell_exec('rm -rf "'.$arrCachePath.'" &');
						}
					}
					if (isset($this->movie->casheHistArr)){
						$cUrl = MediaURL::decode($this->movie->history_mUrl);
						$arrCachePath = $cachePath . md5($cUrl->movie_id . $cUrl->class_name) . '.srz';
						if (!file_exists($arrCachePath)){
							$cachePosterUrl = $cachePath . md5($k) . '.jpg';
							if (!file_exists($arrCachePath))
								HD::imgCache($cUrl->poster_url, md5($this->movie->history_mUrl) . '.jpg');
							HD::pluginCache(serialize($this->movie->casheHistArr), md5($cUrl->movie_id . $cUrl->class_name) . '.srz');
						}
					}
				}
				$itemsHistory = array_slice($itemsHistory, 0, 310);
				HD::saveItemsArr('itemsHistory', $itemsHistory);
			}
			$url = DuneSystem::$properties['plugin_www_url'] . 'bazinga.m3u';
			$sPath = '/tmp/www/plugins/' . DuneSystem::$properties['plugin_name'] . '/bazinga.m3u';
			$m3u = "#EXTM3U";
			if (isset($user_input->playAll)){
				$i = 0;
				foreach ($this->movie->series_list as $series){
					$m3u .= "\n#EXTINF:-1," . $series->name;
					if ($series->playback_url_is_stream_url == true)
						$m3u .= "\n" . $series->playback_url;
					else
						$m3u .= "\n" . mUrl::get_link($series->playback_url, $video_quality);
					if ($selected_media_url->playback_url == $series->playback_url)
						$start_index = $i;
					$i++;
				}
				file_put_contents($sPath, $m3u);
			}else{
				$m3u .= "\n#EXTINF:-1," . $selected_media_url->name;
				if ($selected_media_url->is_stream_url == true)
					$m3u .= "\n" .  $selected_media_url->playback_url;
				else{
					$link = str_replace(array ('https://mp4://','http://mp4://'), array ('https://', 'http://'), mUrl::get_link($selected_media_url->playback_url, $video_quality));
					$m3u .= "\n" . $link; 
				}
				file_put_contents($sPath, $m3u);
				$viewedItemsArr = HD::getItemsArr('viewedItemsArr');
				if (isset($this->vod->currentFav)){
					$currentFav = MediaURL::decode($this->vod->currentFav);
					$saveFoldersArr = HD::getItemsArr($currentFav->class_name . '_saveFoldersArr');
				}
				if (isset($selected_media_url->series_id)){
					$viewedItemsArr[$selected_media_url->series_id] = 'viewed';
					if (isset($saveFoldersArr)){
						if (isset($saveFoldersArr[$selected_media_url->movie_id]['series'][md5($user_input->parent_media_url)])){
							if (!isset($saveFoldersArr[$selected_media_url->movie_id]['series'][md5($user_input->parent_media_url)][$selected_media_url->series_id])){
								$saveFoldersArr[$selected_media_url->movie_id]['series'][md5($user_input->parent_media_url)][$selected_media_url->series_id] = 1;
								$sfa = 1;
							}
							if (isset($this->vod->currentFav)){
								if (isset(SmartConfig::$newFavItems[$currentFav->class_name][$selected_media_url->movie_id][$selected_media_url->series_id])){
									$sfa2 = 1;
									unset(SmartConfig::$newFavItems[$currentFav->class_name][$selected_media_url->movie_id][$selected_media_url->series_id]);
								}
							}
						}
					}
					HD::saveItemsArr('viewedItemsArr', $viewedItemsArr);
					if (isset($sfa))
						HD::saveItemsArr($currentFav->class_name . '_saveFoldersArr', $saveFoldersArr);
					if (isset($user_input->is_android)){
						$selIdx = $user_input->sel_ndx;
						if (self::$downViewed == true)
							$selIdx++;
						$parent_media_url = MediaURL::decode($user_input->parent_media_url);
						$range = $this->get_folder_range($parent_media_url, 0, $plugin_cookies);
						$post_action = ActionFactory::update_regular_folder($range, true, $selIdx);
						if (isset($sfa2))
							$post_action = ActionFactory::invalidate_folders(array($this->vod->currentFav), $post_action);
					}else{
						$post_action = ActionFactory::launch_media_url($url, $post_action, array('start_index' => $start_index));
						$invArr[] = $user_input->parent_media_url;
						if (isset($sfa2))
							$invArr[] = $this->vod->currentFav;
						return ActionFactory::invalidate_folders($invArr, $post_action);
					}
				}
			}
			file_put_contents($sPath, $m3u);
			if (isset($user_input->is_android)){
				if (!isset($user_input->playAll)){
					if ($selected_media_url->is_stream_url == true)
						$url = $selected_media_url->playback_url;
					else
						$url = $link;
				}
				return HD::get_android_action($url, 'video', $post_action);
			}
			return ActionFactory::launch_media_url($url, null, array('start_index' => $start_index, 'caption' => caption));
		}
		if ($user_input->control_id == 'classSetupTorrServer'){
			$defs = array();
			hd_silence_warnings();
			return TorrServer::setup($defs, $user_input);
		}
		if ($user_input->control_id == 'classSetupPeerflixServer'){
			$defs = array();
			hd_silence_warnings();
			return PeerflixServer::setup($defs, $user_input);
		}
		if ($user_input->control_id == 'classSetupTransmission'){
			$defs = array();
			hd_silence_warnings();
			return Transmission::setup($defs, $user_input);
		}
		if ($user_input->control_id == 'classSetupTransmissionUPnP'){
			$defs = array();
			hd_silence_warnings();
			return TransmissionUPnP::setup($defs, $user_input);
		}		
		if ($user_input->control_id == 'smartConfigClassAction'){
			$defs = array();
			hd_silence_warnings();
			return SmartConfig::classAction ($defs, $user_input, $this->select_url);
		}
		if ($user_input->control_id == 'classAction'){
			$defs = array();
			if (isset($user_input->indiClass)){
				$class_name = $user_input->indiClass;
				hd_silence_warnings();
				return $class_name::classAction ($defs, $user_input, $this->select_url);
			}
			$parent_media_url = MediaURL::decode($user_input->parent_media_url);
			$class_name = $parent_media_url->class_name;
			if ((isset($user_input->action))&&($user_input->action == 'gbSortFolders')){
				$selected_media_url = (object)array();
				if (isset($user_input->selected_media_url))
					$selected_media_url = MediaURL::decode($user_input->selected_media_url);
				if (isset($selected_media_url->movie_id)){
					if (isset($this->gbSort[$selected_media_url->movie_id]))
						unset($this->gbSort[$selected_media_url->movie_id]);
					else
						$this->gbSort[$selected_media_url->movie_id] = true;
				}
				return ActionFactory::invalidate_folders(array($user_input->parent_media_url));
			}
			hd_silence_warnings();
			$select_url = $this->select_url;
			$this->select_url = array();
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			return SmartConfig::classAction ($defs, $user_input, $select_url[$selected_media_url->movie_id]);
		}
		if ($user_input->control_id == 'markViewedItems'){
			$parent_media_url = MediaURL::decode($user_input->parent_media_url);
			$viewedItemsArr = HD::getItemsArr('viewedItemsArr');
			foreach ($this->movie->series_list as $series){
				if (!isset($viewedItemsArr[$series->id]))
					$viewedItemsArr[$series->id] = 'viewed';
			}
			HD::saveItemsArr('viewedItemsArr', $viewedItemsArr);
			return ActionFactory::invalidate_folders(array($user_input->parent_media_url));
		}
		if ($user_input->control_id == 'clearViewedItems'){
			$parent_media_url = MediaURL::decode($user_input->parent_media_url);
			$viewedItemsArr = HD::getItemsArr('viewedItemsArr');
			foreach ($this->movie->series_list as $series){
				if (isset($viewedItemsArr[$series->id]))
					unset ($viewedItemsArr[$series->id]);
			}
			HD::saveItemsArr('viewedItemsArr', $viewedItemsArr);
			return ActionFactory::invalidate_folders(array($user_input->parent_media_url));
		}
		if ($user_input->control_id == 'addTorrent'){
			hd_silence_warnings();
			return SmartConfig::userTorrentAction ($user_input, $this->movie);
		}
		if ($user_input->control_id == 'timer'){
			if ($this->addTorrent == true){
				$this->addTorrent = false;
				return UserInputHandlerRegistry::create_action($this, 'addTorrent');
			}
			$parent_media_url = MediaURL::decode($user_input->parent_media_url);
			if (($parent_media_url->class_name == 'PeerflixServer')||($parent_media_url->class_name == 'TransmissionUPnP'))
				return ActionFactory::invalidate_folders(array($user_input->parent_media_url));
			if ($parent_media_url->class_name == 'TorrServer'){
				$torrentId = $parent_media_url->movie_id;
				if (isset($parent_media_url->torrentId))
					$torrentId = $parent_media_url->torrentId;
				$jsd = TorrServer::torrserverActionGet($torrentId);
				if ($jsd == false){
					return ActionFactory::close_and_run();
				}else{
					$actions = $this->get_action_map($parent_media_url,$plugin_cookies);
					return  ActionFactory::change_behaviour($actions, 1000);
				}
			}
			return null;
		}
		if ($user_input->control_id == 'viewed'){
			if (!isset($user_input->selected_media_url))
                return null;
			HD::saveItemsTmpArr('viewedItemsTmpArr', array());
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			$viewedItemsArr = HD::getItemsArr('viewedItemsArr');
			if (isset($this->vod->currentFav)){
				$currentFav = MediaURL::decode($this->vod->currentFav);
				$saveFoldersArr = HD::getItemsArr($currentFav->class_name . '_saveFoldersArr');
			}
			if (isset($this->select_url[$selected_media_url->movie_id])){
				foreach ($this->select_url[$selected_media_url->movie_id] as $v){
					$media_url = MediaURL::decode($v);
					if (isset($media_url->series_id)){
						if (isset($viewedItemsArr[$media_url->series_id]))
							unset ($viewedItemsArr[$media_url->series_id]);
						else
							$viewedItemsArr[$media_url->series_id] = 'viewed';
						if (isset($saveFoldersArr)){
							if (isset($saveFoldersArr[$media_url->movie_id]['series'][md5($user_input->parent_media_url)])){
								if (!isset($saveFoldersArr[$media_url->movie_id]['series'][md5($user_input->parent_media_url)][$media_url->series_id])){
									$saveFoldersArr[$media_url->movie_id]['series'][md5($user_input->parent_media_url)][$media_url->series_id] = 1;
									$sfa = 1;
								}
							}
							if (isset($this->vod->currentFav)){
								if (isset(SmartConfig::$newFavItems[$currentFav->class_name][$selected_media_url->movie_id][$selected_media_url->series_id])){
									unset(SmartConfig::$newFavItems[$currentFav->class_name][$selected_media_url->movie_id][$selected_media_url->series_id]);
									$sfa2 = 1;
								}
							}
						}
					}
				}
				$this->select_url = array();
				HD::saveItemsArr('viewedItemsArr', $viewedItemsArr);
				
			}else{
				if (isset($selected_media_url->series_id)){
					if (isset($viewedItemsArr[$selected_media_url->series_id]))
						unset ($viewedItemsArr[$selected_media_url->series_id]);
					else{
						$viewedItemsArr[$selected_media_url->series_id] = 'viewed';
					}
					if (isset($saveFoldersArr)){
						if (isset($saveFoldersArr[$selected_media_url->movie_id]['series'][md5($user_input->parent_media_url)])){
							if (!isset($saveFoldersArr[$selected_media_url->movie_id]['series'][md5($user_input->parent_media_url)][$selected_media_url->series_id])){
								$saveFoldersArr[$selected_media_url->movie_id]['series'][md5($user_input->parent_media_url)][$selected_media_url->series_id] = 1;
								$sfa = 1;
							}
							if (isset($this->vod->currentFav)){
								if (isset(SmartConfig::$newFavItems[$currentFav->class_name][$selected_media_url->movie_id][$selected_media_url->series_id])){
									$sfa2 = 1;
									unset(SmartConfig::$newFavItems[$currentFav->class_name][$selected_media_url->movie_id][$selected_media_url->series_id]);
								}
							}
						}
					}
					HD::saveItemsArr('viewedItemsArr', $viewedItemsArr);
				}
			}
			if (isset($sfa))
				HD::saveItemsArr($currentFav->class_name . '_saveFoldersArr', $saveFoldersArr);
			$selIdx = $user_input->sel_ndx;
			if (self::$downViewed == true)
				$selIdx++;
			$parent_media_url = MediaURL::decode($user_input->parent_media_url);
			$range = $this->get_folder_range($parent_media_url, 0, $plugin_cookies);
			$action = ActionFactory::update_regular_folder($range, true, $selIdx);
			if (isset($sfa2))
				return ActionFactory::invalidate_folders(array($this->vod->currentFav), $action);
			return $action;
		}
        if ($user_input->control_id == 'add_action'){
            if (!isset($user_input->selected_media_url))
                return null;
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			if ($selected_media_url->playback_url == 'dummy')
				return null;
			if (HD::is_android() == true){
				$android_action = (HD::getItemStr('android_action', true) != '') ? HD::getItemStr('android_action', true) : 0;
				if ($android_action == 1)
					return UserInputHandlerRegistry::create_action($this, 'playDirectly', array('is_android' => true));
				if ($android_action == 2){
					if (isset($selected_media_url->file_info->hls_v4))
						return UserInputHandlerRegistry::create_action($this, 'playDirectly', array('is_android' => true));
				}
			}
			if ((isset($selected_media_url->file_info->class_name))&&
			($selected_media_url->file_info->class_name == 'TorrServer')&&
			($user_input->event_key == 'enter')){
				$preloadTorrServ = (HD::getItemStr('preloadTorrServ', true) !='') ? HD::getItemStr('preloadTorrServ', true) : 1;
				if ($preloadTorrServ == 1){
					TorrServer::torrserverActionPreload($selected_media_url->playback_url);
					if (isset($selected_media_url->torrentId))
						$params['hash'] = $selected_media_url->torrentId;
					else if (isset($selected_media_url->file_info->torrentId))
						$params['hash'] = $selected_media_url->file_info->torrentId;
					else
						$params['hash'] = $selected_media_url->movie_id;
					return UserInputHandlerRegistry::create_action($this, 'doPreload', $params);
				}
			}
			return ActionFactory::vod_play();
        }
		if ($user_input->control_id == 'doPreload'){
			$stat = TorrServer::torrserverActionGet($user_input->hash);
			if (((isset($user_input->stat))&&($user_input->stat == 2)&&($stat->stat == 3))||
			((isset($stat->preloaded_bytes))&&(isset($stat->preload_size))&&((($stat->preloaded_bytes / $stat->preload_size) * 100) > 98)))
				return ActionFactory::vod_play();
			else{
				if (isset($user_input->counter))
					$counter = $user_input->counter + 1;
				else
					$counter = 2;
				if (isset($stat->preloaded_bytes))
					ControlFactory::add_smart_label($defs, "", 
					'<text color="10" size="normal">Буфер: </text><text color="15" size="normal">'. round(($stat->preloaded_bytes / $stat->preload_size) * 100) . '% ('.HD::get_filesize_str($stat->preloaded_bytes) . '/' .  HD::get_filesize_str($stat->preload_size). ')</text>');
				if (isset($stat->active_peers)){
					if (isset($stat->preloaded_bytes))
						ControlFactory::add_vgap($defs, (-30));
					ControlFactory::add_smart_label($defs, "", 
					'<text color="10" size="normal">Пиры: </text><text color="15" size="normal">'. $stat->active_peers . '/' . $stat->total_peers . '</text>');
				}
				if (isset($stat->download_speed)){
					if ((isset($stat->preloaded_bytes))||(isset($stat->active_peers)))
						ControlFactory::add_vgap($defs, (-30));
					ControlFactory::add_smart_label($defs, "",
					'<text color="10" size="normal">Скорость загрузки: </text><text color="15" size="normal">'. HD::get_filesize_str(intval($stat->download_speed)) .	'</text>');
				}
				ControlFactory::add_label($defs, '', "Прошло : " . HD::sec_format_duration($counter / 2));
				$params['counter'] = $counter;
				$params['hash'] = $user_input->hash;
				$params['stat'] = $stat->stat;
				$action = UserInputHandlerRegistry::create_action($this, 'doPreload', $params);
				$attrs['timer'] = ActionFactory::timer(500);
				$attrs['actions'] = array(GUI_EVENT_TIMER => ActionFactory::close_dialog_and_run($action));
				return  ActionFactory::show_dialog($stat->stat_string, $defs, true, 650, $attrs);
			}
		}
        return null;
    }
    public function get_all_folder_items(MediaURL $media_url, &$plugin_cookies){
        $this->vod->folder_entered($media_url, $plugin_cookies);
        $this->movie = $this->vod->get_loaded_movie($media_url, $plugin_cookies);
		
		self::$downViewed = (bool)(HD::getItemStr('downViewed') != '') ? HD::getItemStr('downViewed') : 0;
        if ($this->movie === null){
            // TODO: dialog?
            return array();
        }
		if (isset($this->vod->currentFav)){
			$this->movie->currentFav = $this->vod->currentFav;
			if (isset($this->vod->currentFavItem))
				$this->movie->currentFavItem = $this->vod->currentFavItem;
			if (isset($this->vod->mShowsA))
				$this->movie->mShowsA = $this->vod->mShowsA;
		}
		if ($media_url->class_name == 'm3uVOD_Class'){
			if ($this->lastLink != $media_url->caption){
				$this->lastLink = $media_url->caption;
				$this->movie->series_list = array();
			}
		}else if (isset($media_url->link)){
			if ($this->lastLink != $media_url->link){
				$this->lastLink = $media_url->link;
				$this->movie->series_list = array();
			}
		}else{
			$this->lastLink = null;
			$this->movie->series_list = array();
		}
		if ($this->movie->series_list == array())
			$this->select_url = array();
		if (($media_url->class_name == 'PeerflixServer')||($media_url->class_name == 'TransmissionUPnP'))
			$this->movie->series_list = array();
		if ($this->movie->series_list == array()){
			$class_name = $media_url->class_name;
			if (isset($media_url->torrentClassName))
				$class_name = $media_url->torrentClassName;
			$series = $class_name::get_series_list($media_url, $this->movie);
			$getMovieInfo = (HD::getItemStr('getMovieInfo', true) != '') ? HD::getItemStr('getMovieInfo', true) : 'max';
			$framesEpisode = 0;
			if (($getMovieInfo == 'max')&&(isset($this->movie->class_info['dbIDs']['myShowsID']))){
				$myShowsEpisodes = myShows_Class::getSearchMyShowsEpisodes($this->movie->class_info['dbIDs']['myShowsID']);
				$framesEpisode = (HD::getItemStr('framesEpisode') != '') ? HD::getItemStr('framesEpisode') : 1;
			}
			if ($series == 'addTorrent')
				$this->addTorrent = true;
			else
				foreach ($series as $id => $item){
					$title = $item['title'];
					if (isset($item['file_info'])){
						$item['file_info']['parent_media_url'] = urlencode($media_url->get_raw_string());
						$file_info = $item['file_info'];
					}
					if (isset($myShowsEpisodes)){
						$se = VideoInfo::tvshow_se_parse($item['title']);
						if ($se == true){
							$s = $se['S'];
							if (isset($myShowsEpisodes[$se['S']][$se['E']])){
								$eInf = $myShowsEpisodes[$se['S']][$se['E']];
								if (($eInf->image != '')&&($framesEpisode == 1)){
									$file_info['series_img'] = myShows_Class::http_get_img($eInf->image);
									if (isset($file_info['details_box_width']))
										unset($file_info['details_box_width']);
								}
								if ($eInf->shortName != '')
									$title = $eInf->shortName;
								if ($eInf->title != '')
									$title .= ' - ' . $eInf->title;
								if ($eInf->id != '')
									$file_info['myShowsShowID'] = $eInf->id;
								if ($eInf->shortName != '')
									$file_info['shortName'] = $eInf->shortName;
								if (preg_match("|(\d*?)-(\d*?)-(\d*)|", $eInf->airDate,$matches))
									$file_info['airDate'] = $matches[3].'.'.$matches[2].'.'.$matches[1];
								else
									$file_info['airDate'] = $eInf->airDate;
								unset($myShowsEpisodes[$se['S']][$se['E']]);
							}
						}
					}
					if (isset($media_url->torrentId))
						$file_info['torrentId'] = $media_url->torrentId;
					$this->movie->add_series_data(
						$item['id'],
						$title,
						$item['playback_url'],
						$item['is_stream_url'],
						$file_info
					);
				}
				if ((isset($myShowsEpisodes))&&($framesEpisode != 0)&&(isset($s))){
					$myShowsEpisodes = array_reverse($myShowsEpisodes[$s]);
					foreach ($myShowsEpisodes as $v){
						$file_info = array();
						if (($v->image != '')&&($framesEpisode == 1))
							$file_info['series_img'] = myShows_Class::http_get_img($v->image);
						else
							$file_info['details_box_width'] = true;
						$file_info['poster_url'] = $media_url->poster_url;
						$file_info['icon_path'] = $this->unmovieIco;
						if ($v->shortName != '')
							$title = $v->shortName;
						if ($v->title != '')
							$title .= ' - ' . $v->title;
						if ($v->id != '')
							$file_info['myShowsShowID'] = $v->id;
						if ($v->shortName != '')
							$file_info['shortName'] = $v->shortName;
						if (preg_match("|(\d*?)-(\d*?)-(\d*)|", $v->airDate,$matches))
							$file_info['airDate'] = $matches[3].'.'.$matches[2].'.'.$matches[1];
						else
							$file_info['airDate'] = $v->airDate;
						if (isset($tvshow_se['S']))
							$media_url->hash_patrs->season = $s;
						if (isset($tvshow_se['E']))
							$media_url->hash_patrs->episode = $v->episodeNumber;
						$id = md5(implode("", (array)$media_url->hash_patrs) . $v->id);
						$this->movie->add_series_data(
							$id,
							$title,
							'dummy',
							false,
							$file_info
						);
					}
				}
		}
        $items = array();
		$i = 0;
		$viewedItemsArr = HD::getItemsArr('viewedItemsArr');
		$viewedItemsTmpArr = HD::getItemsTmpArr('viewedItemsTmpArr');
		if (count($viewedItemsTmpArr) > 0){
			foreach ($viewedItemsTmpArr as $k => $v){
				if (isset($viewedItemsArr[$k]))
					$viewedItemsArr[$k] = array_merge( $viewedItemsArr[$k], $v);
				else
					$viewedItemsArr[$k] = $v;
			}
		}
		if (isset($this->vod->currentFav)){
			$currentFav = MediaURL::decode($this->vod->currentFav);
			$saveFoldersArr = HD::getItemsArr($currentFav->class_name . '_saveFoldersArr');
		}
		$watchedMyShows = array();
		if ((isset($this->movie->mShowsA))&&(isset($this->movie->class_info["dbIDs"]["myShowsID"])))
			$watchedMyShows = myShows_Class::getWatchedMyShows($this->movie->class_info["dbIDs"]["myShowsID"], $this->movie->mShowsA);
		foreach ($this->movie->series_list as $series){
			$n = $i; $color = 15; $starred = false;
			$view_item_params = array();
			$name = $series->name;
			$icon_path = $this->movieIco;
			if (isset($series->file_info['icon_path']))
				$icon_path = $series->file_info['icon_path'];
			else if (preg_match("/\.(?:mp3|wav|og(?:g|a)|flac|midi?|rm|m4a|aac|wma|mka|ape|jpg|png)$/i",$series->playback_url))
				$icon_path = $this->musicIco;
			$detailed_info = '||' . implode( ' ', HD::mb_str_split($name, 23));
			if (isset($series->file_info['airDate']))
				$detailed_info .= '|' . $series->file_info['airDate'];
			if (isset($series->file_info['size'])){
				$name .= ' ('.$series->file_info['size'].')';
				$detailed_info .= '|Размер: ' . $series->file_info['size'];
			}
			if (isset($series->file_info['series_img']))
				$detailed_icon = $series->file_info['series_img'];
			else
				$detailed_icon = $series->file_info['poster_url'];
			$mUrl = MediaURL::encode(
				array(
					'screen_id' => self::ID,
					'movie_id' => $this->movie->id,
					'name' => $series->name,
					'series_id'  => $series->id,
					'playback_url'  => $series->playback_url,
					'is_stream_url'  => $series->playback_url_is_stream_url,
					'file_info' => $series->file_info
				)
			);
			if (isset($series->file_info['qltyMax'])){
				if(defined('ViewItemParams::item_extra_info')){
					$extra_item = array('type' => 'text', 'color' => 23, 'text' => $series->file_info['qltyMax']);
					$item_extra_info = array(
						'items' => array(
						array('type' => 'gap', 'width' => 50),
						$extra_item,
					));
						$view_item_params[ViewItemParams::item_extra_info] = json_encode($item_extra_info);
					
				}
			}else if (isset($series->file_info['airDate'])){
				if(defined('ViewItemParams::item_extra_info')){
					$extra_item = array('type' => 'text', 'color' => 23, 'text' => $series->file_info['airDate']);
					$item_extra_info = array(
						'items' => array(
						array('type' => 'gap', 'width' => 50),
						$extra_item,
					));
						$view_item_params[ViewItemParams::item_extra_info] = json_encode($item_extra_info);
					
				}
			}
			if (isset($saveFoldersArr)){
				if (isset($saveFoldersArr[$media_url->movie_id]['series'][md5($media_url->get_raw_string())])){
					if ((!isset($saveFoldersArr[$media_url->movie_id]['series'][md5($media_url->get_raw_string())][$series->id]))&&
					($series->playback_url != 'dummy')){
						$color = 19;
						$icon_path = $this->newmovieIco;
						if(defined('ViewItemParams::item_extra_info')){
							$extra_item = array(
								'type' => 'icon',
								'url' => 'plugin_file://icons/new2.png',
								'alt' => 'NEW'
							);
							$item_extra_info = array(
								'items' => array(
									array(
										'type' => 'gap', 
										'width' => 107
									),
									$extra_item,
								)
							);
							$view_item_params[ViewItemParams::item_extra_info] = json_encode($item_extra_info);
						
						}
					}
				}
			}
			if (isset($viewedItemsArr[$series->id])){
				if ($viewedItemsArr[$series->id] =='viewed'){
					$n = 1000 + $i;
				}else{
					$tt = '['.HD::sec_format_duration($viewedItemsArr[$series->id]['p']) . '/' . HD::sec_format_duration($viewedItemsArr[$series->id]['d']) . '] ';
					if ($viewedItemsArr[$series->id]['d'] > 0)
						$prsnt =  round(($viewedItemsArr[$series->id]['p']/$viewedItemsArr[$series->id]['d'])* 100);
					else
						$prsnt = 0;
					$name = $tt . $name;
					$detailed_info = "||Просмотренно: $prsnt %|$tt| " . $detailed_info;
					if ($prsnt > 95)
						$n = 1000 + $i;
				}
				$color = 3; 
				$icon_path = $this->viewedIco;
			}
			if (isset($series->file_info['selected'])){
				if($series->file_info['selected']){
					if (defined('ViewItemParams::item_sticker') === true){
						$view_item_params[ViewItemParams::item_sticker] = json_encode(self::get_sticker('plugin_file://icons/ss_dload.png'));
						$view_item_params[ViewItemParams::item_detailed_info_sticker] = 'plugin_file://icons/ss_dload.png';
					}else
						$starred = true;
					$detailed_info .= '|Файл загружается';
				}else
					$detailed_info .= '|  ';
			}
			if (isset($this->select_url[$this->movie->id][$mUrl]))
				$color = 18;
			if (isset($series->file_info['detailed_info']))
				$detailed_info .= $series->file_info['detailed_info'];
			if (isset($series->file_info['qltyMax']))
				$detailed_info .= "||Качество видео|" . $series->file_info['qltyMax'];
			if (isset($series->file_info['myShowsShowID'])){
				if (isset($watchedMyShows[$series->file_info['myShowsShowID']])){
					$icon_path = $this->myshows;
					$date = new DateTime($watchedMyShows[$series->file_info['myShowsShowID']]);
					$detailed_info = '||Просмотренно:|' . $date->format('d.m.Y H:i') . $detailed_info;
				}
			}
			$view_item_params[ViewItemParams::icon_path] = $icon_path;
			$view_item_params[ViewItemParams::item_detailed_info] = $detailed_info;
			$view_item_params[ViewItemParams::item_detailed_icon_path] = $detailed_icon;
			if ($series->playback_url == 'dummy')
				$color = 23;
			$view_item_params[ViewItemParams::item_caption_color] = $color;
			if ((defined('ViewParams::details_box_width') === true)&&
				(!preg_match('|plugin_file|', $detailed_icon))&&
				(isset($series->file_info['details_box_width']))
				){
				$view_item_params[ViewItemParams::item_detailed_icon_width] = 200;
				$view_item_params[ViewItemParams::item_detailed_icon_height] = 291;
			}
			if (self::$downViewed == true)
				$n = $i;
			if (isset($this->gbSort[$this->movie->id])){
				if (!preg_match('|GB|', $series->file_info['size']))
					$n = $n +1000;
			}
			if (isset($series->file_info['stiker_img'])){
				if (defined('ViewItemParams::item_sticker') === true){
					$view_item_params[ViewItemParams::item_sticker] = json_encode(self::get_sticker($series->file_info['stiker_img']));
					$view_item_params[ViewItemParams::item_detailed_info_sticker] = $series->file_info['stiker_img'];
				}
			}
			if(defined('ViewItemParams::item_extra_info')){
				if (isset($series->file_info['percent'])){
					$percent = $series->file_info['percent'];
					$extra_item = $percent == 100 ?
					array('type' => 'icon',
					'url' => 'plugin_file://icons/watched.png',
					'alt' => '100%') :
					array('type' => 'text', 'color' => '10', 'text' => "$percent%");
					$item_extra_info = array(
					'items' => array(
					array('type' => 'gap', 'width' => 40),
					$extra_item,
					));
					$view_item_params[ViewItemParams::item_extra_info] = json_encode($item_extra_info);
				}
			}
			$items[$n] = array(
                PluginRegularFolderItem::media_url => $mUrl,
                PluginRegularFolderItem::caption => $name,
                PluginRegularFolderItem::view_item_params => $view_item_params,
				PluginRegularFolderItem::starred => $starred
            );
			$i++;
        }
		ksort($items);
		$items = array_values($items);
		$this->grange = $items;
        return $items;
    }

    ///////////////////////////////////////////////////////////////////////

    private function get_folder_views(){
		$this->movieIco = SmartConfig::getPluginIco('movie');
		$this->musicIco = SmartConfig::getPluginIco('music');
		$this->viewedIco = SmartConfig::getPluginIco('viewed');
		$this->newmovieIco = SmartConfig::getPluginIco('newmovie');
		$this->unmovieIco = SmartConfig::getPluginIco('unmovie');
		$this->myshows = SmartConfig::getPluginIco('s_myshows');
		///////////////////////////////////////////////
		$sandwich_base2 = SmartConfig::getPluginIco('badge1');
		$background_path = SmartConfig::getPluginIco(self::ID . '_bg');
		$paintBackground = (HD::getItemsArr('paintBackground') != array()) ? HD::getItemsArr('paintBackground') : array('paint_widget_background' => true, 'paint_content_box_background' => true, 'paint_path_box_background' => true, 'paint_details_box_background' => true);
		$arr[0][PluginRegularFolderView::async_icon_loading] = true;
		$arr[0][PluginRegularFolderView::timer] = array(GuiTimerDef::delay_ms => 1000);
		$arr[0][PluginRegularFolderView::view_params][ViewParams::num_cols] = 1;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::num_rows]= 10;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_details] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_item_info_in_details] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_auto_line_break] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_title_color] = 10;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_text_color] = 15;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_font_size] = (HD::getItemStr('detailedInfoFontSize') != '') ? HD::getItemStr('detailedInfoFontSize') : FONT_SIZE_SMALL;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_path] = $background_path;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_order] = 0;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_height] = 1080;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_width] = 1920;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::optimize_full_screen_background] = true;
		// if (defined('ViewParams::paint_icon_badge_box') === true){
			// $arr[0][PluginRegularFolderView::view_params][ViewParams::paint_icon_badge_box] = true;
			// $arr[0][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_width] = 50;
			// $arr[0][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_height] = 50;
			// $arr[0][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_dx] = -580;
			// $arr[0][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_sel_width] = 55;
			// $arr[0][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_sel_height] = 55;
		// }
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_layout] = HALIGN_LEFT;
        $arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_valign] = VALIGN_CENTER;
        $arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_dx] = 10;
        $arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_dy] = -5;
        $arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_caption_dx] = 60;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_width] = 50;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_height] = 50;
		
		$arr[0][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[0][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_width] = 50;
		$arr[0][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_height] = 50;
		$arr[0][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_path] = $sandwich_base2;
		
		////////////////////////////////////////////////////////////////////////////////////////
		$arr[1][PluginRegularFolderView::async_icon_loading] = true;
		$arr[1][PluginRegularFolderView::timer] = array(GuiTimerDef::delay_ms => 1000);
		$arr[1][PluginRegularFolderView::view_params][ViewParams::num_cols] = 1;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::num_rows]= 10;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_details] = false;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_path] = $background_path;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_order] = 0;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_height] = 1080;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_width] = 1920;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::optimize_full_screen_background] = true;
		// if (defined('ViewParams::paint_icon_badge_box') === true){
			// $arr[1][PluginRegularFolderView::view_params][ViewParams::paint_icon_badge_box] = true;
			// $arr[1][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_width] = 50;
			// $arr[1][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_height] = 50;
			// $arr[1][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_dx] = -810;
			// $arr[1][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_sel_width] = 55;
			// $arr[1][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_sel_height] = 55;
		// }
        $arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_layout] = HALIGN_LEFT;
        $arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_valign] = VALIGN_CENTER;
        $arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_dx] = 10;
        $arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_dy] = -5;
        $arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_caption_dx] = 60;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_width] = 50;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_height] = 50;
		
		$arr[1][PluginRegularFolderView::not_loaded_view_item_params]= array ();
		
		return $arr;
    }
	public static function get_sticker($img=null, $txt=null){
		if ($img==true)
			$items[] = Sticker::item(
				Sticker::geom(0, 0), Sticker::icon($img)
			);
		if ($txt==true)
		$items[] = Sticker::item(
			Sticker::geom(0, 0), Sticker::text($txt, 14));
		
        return Sticker::sticker($items);
    }
    public function get_archive(MediaURL $media_url){
        return $this->vod->get_archive($media_url);
    }
}

///////////////////////////////////////////////////////////////////////////
?>
