<?php
require_once 'Smart_vod_list_screen.php';
class SmartVodSimpleListScreen extends VodListScreen{
	const ID = 'vod_simplelist';
	public static function get_media_url_str($class_name, $arr=null){
		$arr['screen_id'] = self::ID;			
		$arr['class_name'] = $class_name;
        return MediaURL::encode($arr);
    }
    public function __construct(Vod $vod){
        parent::__construct($vod, self::ID, $this->get_folder_views());
    }
	public function get_folder_views(){
		$sandwich_cover = SmartConfig::getPluginIco('sandwich_cover3');
		$sandwich_base = SmartConfig::getPluginIco('poster_none');
		$sandwich_base2 = SmartConfig::getPluginIco('badge1');
		$background_path = SmartConfig::getPluginIco(self::ID . '_bg');
		$paintBackground = (HD::getItemsArr('paintBackground') != array()) ? HD::getItemsArr('paintBackground') : array('paint_widget_background' => true, 'paint_content_box_background' => true, 'paint_path_box_background' => true, 'paint_details_box_background' => true);
		$item_detailed_info_font_size = (HD::getItemStr('detailedInfoFontSize') != '') ? HD::getItemStr('detailedInfoFontSize') : FONT_SIZE_SMALL;
		$paintSandwich = (HD::getItemStr('paintSandwich') != '') ? (bool)HD::getItemStr('paintSandwich') : true;
		
		
		$arr[0][PluginRegularFolderView::async_icon_loading] = true;
		//$arr[0][PluginRegularFolderView::timer] = array(GuiTimerDef::delay_ms =>  1000);
		$arr[0][PluginRegularFolderView::view_params][ViewParams::num_cols] = 1;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::num_rows] = 10;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_details] = false;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_path] = $background_path;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_order] = 0;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_height] = 1080;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_width] = 1920;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::optimize_full_screen_background] = true;
		
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_widget_background] = $paintBackground['paint_widget_background'];
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_content_box_background] = $paintBackground['paint_content_box_background'];
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_path_box_background] = $paintBackground['paint_path_box_background'];
		
		$arr[0][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[0][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_width] = 50;
		$arr[0][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_height] = 50;
		$arr[0][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_path] = $sandwich_base2;
		
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_layout] = HALIGN_LEFT;
        $arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_valign] = VALIGN_CENTER;
        $arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_dx] = 10;
        $arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_dy] = -5;
        $arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_caption_dx] = 60;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_width] = 50;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_height] = 50;
		
		$arr[1][PluginRegularFolderView::async_icon_loading] = true;
		//$arr[1][PluginRegularFolderView::timer] = array(GuiTimerDef::delay_ms =>  1000);
		$arr[1][PluginRegularFolderView::view_params][ViewParams::num_cols] = 1;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::num_rows] = 10;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_details] = true;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_item_info_in_details] = true;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_auto_line_break] = true;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_title_color] = 10;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_text_color] = 15;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_font_size] = $item_detailed_info_font_size;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_path] = $background_path;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_order] = 0;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_height] = 1080;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_width] = 1920;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::optimize_full_screen_background] = true;
		
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_widget_background] = $paintBackground['paint_widget_background'];
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_content_box_background] = $paintBackground['paint_content_box_background'];
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_path_box_background] = $paintBackground['paint_path_box_background'];
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_details_box_background] = $paintBackground['paint_details_box_background'];
		
		$arr[1][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[1][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_width] = 50;
		$arr[1][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_height] = 50;
		$arr[1][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_path] = $sandwich_base2;
		
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_layout] = HALIGN_LEFT;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_valign] = VALIGN_CENTER;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_caption] = false;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_scale_factor] = 1.0;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_scale_factor] = 1.1;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_width] = 50;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_height] = 50;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_dx] = 5;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_dy] = -5;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_margin_top] = 0;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_caption] = true;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_caption_width] = 1100;
		return $arr;
    }
}
?>