<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/vod/vod.php';
require_once 'lib/abstract_preloaded_regular_screen.php';

///////////////////////////////////////////////////////////////////////////

class VodSourceListScreen extends AbstractPreloadedRegularScreen
implements UserInputHandler {
    const ID = 'vod_source_list';

    public static function get_media_url_str($class_name, $arr=null){
		$arr['screen_id'] = self::ID;			
		$arr['class_name'] = $class_name;
        return MediaURL::encode($arr);
    }

    ///////////////////////////////////////////////////////////////////////
	private $vod;
	private $allSources = false;
	private $unlock = false;
	static $needRefresh = true;
	static $filter = false;
	private $counter = 0;
	private $currClassName = 0;
    ///////////////////////////////////////////////////////////////////////
	
    public function __construct(Vod $vod){
        parent::__construct(self::ID, $this->get_folder_views());
        $this->vod = $vod;
		UserInputHandlerRegistry::get_instance()->
            register_handler($this);
    }

    ///////////////////////////////////////////////////////////////////////

    public function get_action_map(MediaURL $media_url, &$plugin_cookies){
		$add_params['action'] = 'addToMainMenu';
		$add_action = UserInputHandlerRegistry::create_action($this, 'classAction', $add_params);
        $add_action['caption'] = 'В Главное Меню';
        $actions[GUI_EVENT_KEY_B_GREEN] = $add_action;
		
		$add_params['action_move'] = 'on';
		$add_action = UserInputHandlerRegistry::create_action($this, 'id_move', $add_params);
        $add_action['caption'] = 'Источники';
        $actions[GUI_EVENT_KEY_C_YELLOW] = $add_action;

		$actions[GUI_EVENT_KEY_SETUP] = ActionFactory::open_folder('setup','Настройки');
		
		$add_params['action_move'] = 'hide_id';
		$add_action = UserInputHandlerRegistry::create_action($this, 'id_move', $add_params);
		$actions[GUI_EVENT_KEY_CLEAR] = $add_action;
		
		$sourseTypeSkip = (HD::getItemStr('sourseTypeSkip', true) != '') ? HD::getItemStr('sourseTypeSkip', true) : 0;
		if ($sourseTypeSkip == 0){
			if (self::$filter == false){
				$add_params['filter'] = 'torrentSource';
				$caption = 'Все';
			}else if (self::$filter == 'torrentSource'){
				$add_params['filter'] = 'onlineSource';
				$caption = 'Торренты';
			}else if (self::$filter == 'onlineSource'){
				$add_params['filter'] = 'all';
				$caption = 'Онлайн';
			}
			$add_action = UserInputHandlerRegistry::create_action($this, 'filter', $add_params);
			$add_action['caption'] = $caption;
			$actions[GUI_EVENT_KEY_D_BLUE] = $add_action;
		}else{
			$add_params['action'] = 'addToFav';
			$add_action = UserInputHandlerRegistry::create_action($this, 'classAction', $add_params);
			$add_action['caption'] = 'Избранное';
			$actions[GUI_EVENT_KEY_D_BLUE] = $add_action;
		}
		$params['event_key'] = 'enter';
		$actions[GUI_EVENT_KEY_ENTER]		= UserInputHandlerRegistry::create_action($this, 'add_actions',$params);
		$params['event_key'] = 'play';
		$actions[GUI_EVENT_KEY_PLAY] 		= UserInputHandlerRegistry::create_action($this, 'add_actions',$params);;

		$popup_menu_action = UserInputHandlerRegistry::create_action($this, 'popup_menu');
		$actions[GUI_EVENT_KEY_POPUP_MENU] = $popup_menu_action;

		$actions[GUI_EVENT_KEY_SEARCH] = UserInputHandlerRegistry::create_action($this, 'classAction', array('action' => 'search'));
		$useNumKey = HD::getItemsArr('useNumKey');
		foreach ($useNumKey as $k => $v){
			$params['openCat'] = $v;
			$actions[SmartConfig::$keyArr[$k]] = UserInputHandlerRegistry::create_action($this, 'add_actions', $params);
		}
		$actions[GUI_EVENT_TIMER] = UserInputHandlerRegistry::create_action($this, 'timer');
		return $actions;
    }
	public function get_handler_id(){
		return self::ID;
	}
	
	public function handle_user_input(&$user_input, &$plugin_cookies){
		$parentalControl = isset($plugin_cookies->parentalControl) ? $plugin_cookies->parentalControl : '';
		if ($user_input->control_id == 'filter'){
			echo $user_input->filter;
			if ($user_input->filter == 'all')
				self::$filter = false;
			else
				self::$filter = $user_input->filter;
			$parent_media_url = MediaURL::decode($user_input->parent_media_url);
			$actions = $this->get_action_map($parent_media_url, $plugin_cookies);
			$post_action = ActionFactory::invalidate_folders(array($user_input->parent_media_url));
			return  ActionFactory::change_behaviour($actions, 500, $post_action);
		}
		if ($user_input->control_id == 'timer'){
			if (self::$needRefresh == true)
				return ActionFactory::invalidate_folders(array($user_input->parent_media_url));
			return null;
		}
		if ($user_input->control_id == 'add_actions'){
			if (($user_input->selected_media_url == '"inWork"')||
			($user_input->selected_media_url == '"completed"')){
				if (($user_input->selected_media_url == '"inWork"')&&
				($user_input->event_key == 'play')){
					SmartConfig::$idx = SmartConfig::$idx + 1;
					unset(SmartConfig::$processedSources[1000]);
					return  ActionFactory::show_title_dialog('Источник пропущен!');
				}
				return null;
			}
			if (isset($user_input->openCat))
				$user_input->selected_media_url = $user_input->openCat; 
			$this->vod->seasons_media_url['screen_counter'] = $this->vod->seasons_media_url['screen_counter'] + 1;
			if (isset($user_input->openCat)){
				$selected_media_url = MediaURL::decode($user_input->selected_media_url);
				return ActionFactory::open_folder($user_input->selected_media_url, $selected_media_url->caption);
			}
			return ActionFactory::open_folder();
		}
		if ($user_input->control_id == 'hide_pin_control'){
			if (md5($user_input->hide_pin_control) == $plugin_cookies->parentalControl){
				$this->unlock = $params['unlock'] = true;
				if (isset($user_input->param))
					$params[$user_input->param] = $user_input->vel;
				$a = UserInputHandlerRegistry::create_action($this, $user_input->controlId, $params);
				return ActionFactory::close_dialog_and_run($a);
			}else
				return  ActionFactory::show_title_dialog('Код не верный!');
		}
		if ($user_input->control_id == 'popup_menu'){
			if (isset($user_input->selected_media_url)){
				$selected_media_url = MediaURL::decode($user_input->selected_media_url);
				$class_name = $selected_media_url->class_name;
				$add_params['action'] = 'addToFav';
				$menu_items[] = array(
					GuiMenuItemDef::caption => 'Избранное',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', $add_params),
					GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_addToFav')
				);
				$menu_items [] =  array(
					GuiMenuItemDef::is_separator => true,);
				if (preg_match("|_Class|",$class_name)){
					$mItems = $class_name::getPopUpMenuItems($selected_media_url, $user_input->parent_media_url);
					foreach ($mItems as $v){
						if ($v == 'is_separator')
							$menu_items [] =  array(
							GuiMenuItemDef::is_separator => true,);
						// else if ($v['params'] == 'classSetup')
							// $menu_items[] = array(
								// GuiMenuItemDef::caption => $v['caption'],
								// GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classSetup' . $class_name),
								// GuiMenuItemDef::icon_url => $v['icon_url'],
							// );
						else
							$menu_items[] = array(
								GuiMenuItemDef::caption => $v['caption'],
								GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', $v['params']),
								GuiMenuItemDef::icon_url => $v['icon_url'],
							);
					}
				}
				$menu_items [] =  array(
					GuiMenuItemDef::is_separator => true,);
				
				$add_params['action_move'] = 'on';
				$menu_items[] = array(
					GuiMenuItemDef::caption => 'Настройка вида меню',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'id_move', $add_params),
					GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_move')
				);
				$menu_items [] =  array(
					GuiMenuItemDef::is_separator => true,);
				$add_params['action'] = 'add';
				$menu_items[] = array(
					GuiMenuItemDef::caption => 'Задать иконку',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'icon_actions', $add_params),
					GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_add_icon')
				);
				if (isset($selected_media_url->iconId))
					$class_name = $selected_media_url->iconId;
				if (file_exists(HD::get_data_path() . "/icons/$class_name.png")){
					$add_params['action'] = 'del';
					$menu_items[] = array(
						GuiMenuItemDef::caption => 'Удалить иконку',
						GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'icon_actions', $add_params),
						GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_del_background')
					);
				}
			}
			$menu_items [] =  array(
				GuiMenuItemDef::is_separator => true,);
			$add_params['action'] = 'background_actions';
			$menu_items[] = array(
				GuiMenuItemDef::caption => 'Задать бекграунд',
				GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', $add_params),
				GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_add_background')
			);
			if (file_exists(HD::get_data_path() . "/icons/" . self::ID . "_bg.jpg")){
				$add_params['action'] = 'background_actions';
				$add_params['del'] = true;
				$menu_items[] = array(
					GuiMenuItemDef::caption => 'Удалить бекграунд',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', $add_params),
					GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_del_background')
				);
			}
			return ActionFactory::show_popup_menu($menu_items);
		}
		if ($user_input->control_id == 'id_move'){
			
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			$class_name = $selected_media_url->class_name;
						
			$add_params['action_move'] = 'sourseTypeOnOff';
			$add_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
			$actions[GUI_EVENT_KEY_SELECT]	= $add_action;
			
			$add_params['action_move'] = 'up';
			$add_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
			$add_action['caption'] = 'Вверх';
			$actions[GUI_EVENT_KEY_B_GREEN] = $add_action;
			$actions[GUI_EVENT_KEY_LEFT] = $add_action;
			
			$add_params['action_move'] = 'down';
			$add_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
			$add_action['caption'] = 'Вниз';
			$actions[GUI_EVENT_KEY_C_YELLOW] = $add_action;
			$actions[GUI_EVENT_KEY_RIGHT] = $add_action;
			
			$add_params['action_move'] = 'up_id';
			$add_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
			$add_action['caption'] = 'Поднять вверх';
			$actions[GUI_EVENT_KEY_D_BLUE] = $add_action;
			
			$add_params['action_move'] = 'upPopUpMenu';
			$add_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
			$actions[GUI_EVENT_KEY_POPUP_MENU] = $add_action;
			
			$add_params['action_move'] = 'off';
			$add_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
			$add_action['caption'] = 'Выход';
			$actions[GUI_EVENT_KEY_RETURN] = $add_action;
			$actions[GUI_EVENT_KEY_ENTER] = $add_action;
			
			$add_params['action_move'] = 'hide_id';
			$add_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
			$actions[GUI_EVENT_KEY_CLEAR] = $add_action;
			
			if ($user_input->action_move == 'upPopUpMenu'){
				$add_params['action_move'] = 'up_id';
				$menu_items[] = array(
					GuiMenuItemDef::caption => 'Поднять вверх',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params),
					GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_queue_move_top')
				);
				$add_params['action_move'] = 'hide_id';
				$menu_items[] = array(
					GuiMenuItemDef::caption => 'Cкрыть/Bостановить источник',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params),
					GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_list')
				);
				$add_params['action_move'] = 'sourseTypeOnOff';
				$menu_items[] = array(
					GuiMenuItemDef::caption => 'Cкрыть категорию (онлайн/торренты)',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params),
					GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_list')
				);
				$add_params['action_move'] = 'clear';
				$menu_items[] = array(
					GuiMenuItemDef::caption => 'Cброс Источников',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params),
					GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_num')
				);
				return ActionFactory::show_popup_menu($menu_items);
			}
			if ($user_input->action_move == 'on'){
				$this->allSources = true;
				$this->unlock = false;
				ControlFactory::add_smart_label($defs, 
					"", 
					'<icon width="48" height="48">gui_skin://special_icons/controls_button_green.aai</icon><text color="15"> - двигать вверх</text>'
				);
				ControlFactory::add_vgap($defs, -20);
				ControlFactory::add_smart_label($defs, 
					"", 
					'<icon width="48" height="48">gui_skin://special_icons/controls_button_yellow.aai</icon><text color="15"> - двигать вниз</text>'
				);
				ControlFactory::add_vgap($defs, -20);
				ControlFactory::add_smart_label($defs, 
					"", 
					'<icon width="48" height="48">gui_skin://special_icons/controls_button_blue.aai</icon><text color="15"> - поднять вверх</text>'
				);
				ControlFactory::add_vgap($defs, -20);
				ControlFactory::add_smart_label($defs, 
					"", 
					'<icon width="131" height="53">gui_skin://special_icons/controls_button_clear.aai</icon><text color="15"> - скрыть/востановить</text>'
				);
				ControlFactory::add_vgap($defs, -20);
				ControlFactory::add_smart_label($defs, 
					"", 
					'<icon width="145" height="50">gui_skin://special_icons/controls_button_pop_up.aai</icon><text color="15"> - действия</text>'
				);
				ControlFactory::add_vgap($defs, -20);
				ControlFactory::add_smart_label($defs, 
					"", 
					'<icon width="131" height="53">gui_skin://special_icons/controls_button_enter.aai</icon><text color="15"> - выйти и применить</text>'
				);
				ControlFactory::add_vgap($defs, -20);
				ControlFactory::add_smart_label($defs, 
					"", 
					'<text color="15">RETURN - выйти и применить</text>'
				);
				ControlFactory::add_close_dialog_button($defs, 'ОК', 300);
				$post_action = ActionFactory::show_dialog("Help", $defs, true, 600);
				$post_action = ActionFactory::change_behaviour($actions, 0, $post_action);
				return  ActionFactory::invalidate_folders(array($user_input->parent_media_url), $post_action);
			}
			
			if ($user_input->action_move == 'off'){
				$this->allSources = false;
				SmartConfig::getVodSources('sourcesIsNull');
				$parent_media_url = MediaURL::decode($user_input->parent_media_url);
				$actions = $this->get_action_map($parent_media_url, $plugin_cookies);
				$post_action = ActionFactory::invalidate_folders(array($user_input->parent_media_url));
				return  ActionFactory::change_behaviour($actions, 0, $post_action);
			}
			if ($user_input->action_move == 'clear'){
				if($this->unlock == false){
					if ($parentalControl != ''){
						$add_params['controlId']= $user_input->control_id;
						$add_params['param'] = 'action_move';
						$add_params['vel'] = 'clear';
						ControlFactory::add_text_field(
							$defs, $this, $add_params,
							'hide_pin_control', '',
							'', 1, 1, 0, 1, 500, 1 , 0
						);
						return  ActionFactory::show_dialog('Введите код:', $defs, true);
					}
				}
				HD::saveItemsArr('nbrSources', array());
				HD::saveItemStr('sourseTypeSkip', 0, true);
				HD::saveItemsArr('hideSources',  array(), true);
				$post_action = ActionFactory::change_behaviour($actions, 0);
				return ActionFactory::invalidate_folders(array($user_input->parent_media_url), $post_action);
			}
			if ($user_input->action_move == 'sourseTypeOnOff'){
				$add_params['control_id']= $user_input->control_id;
				$add_params['action_move'] = $user_input->action_move;
				if ((isset($user_input->selected_control_id))&&(isset($user_input->action_type))){
					if ($user_input->selected_control_id == 'sourseTypeSkip')
						if (HD::saveItemStr('sourseTypeSkip', $user_input->sourseTypeSkip, true) == false)
							return ActionFactory::show_title_dialog("Сохранение не удалось");
					$post_action = ActionFactory::change_behaviour($actions, 0);
					$post_action = ActionFactory::close_dialog_and_run($post_action);
					return  ActionFactory::invalidate_folders(array($user_input->parent_media_url), $post_action);
				}
				$sourseTypeSkip = (HD::getItemStr('sourseTypeSkip', true) != '') ? HD::getItemStr('sourseTypeSkip', true) : 0;
				
				ControlFactory::add_combobox($defs, $this, $add_params,
					'sourseTypeSkip',
					'',
					$sourseTypeSkip, array('Не скрывать', 'Скрыть источники торренты', 'Скрыть источники онлайн'),  0, true, false
				);
				return ActionFactory::show_dialog('Скрытие категорий', $defs, true, 0, $attrs);
			}
			if (!isset($user_input->selected_media_url))
				return null;
			if ($user_input->action_move == 'up_id'){
				$nbrSources = HD::getItemsArr('nbrSources');
				$fCat = array_flip($nbrSources);
				if (isset($nbrSources[$user_input->selected_media_url])){
					$k = $nbrSources[$user_input->selected_media_url];
					if ($k != 0){
						$up = $fCat[$k];
						unset ($fCat[$k]);
						array_unshift($fCat,$up);
						ksort ($fCat);
						$fCat = array_values ($fCat);
						$nbrSources = array_flip($fCat);
						HD::saveItemsArr('nbrSources', $nbrSources);
						$post_action = ActionFactory::change_behaviour($actions, 0);
						return ActionFactory::invalidate_folders(array($user_input->parent_media_url), $post_action);
					}else
						return ActionFactory::show_title_dialog("Err!", null, 'Источник в начале списка!');
				}else{
					echo $user_input->selected_media_url;
					foreach ($nbrCat as $k => $v)
						echo "$k => $v";
					return ActionFactory::show_title_dialog("Err!", null, 'Подробности в лог файле!');
				}
			}
			if (($user_input->action_move == 'down')||
				($user_input->action_move == 'up')){
				$nbrSources = HD::getItemsArr('nbrSources');
				$fCat = array_flip($nbrSources);
				if (isset($nbrSources[$user_input->selected_media_url])){
					$k = $nbrSources[$user_input->selected_media_url];
					if ($user_input->action_move == 'up'){
						if ($k == 0){
							$fCat[] = $fCat[$k];
							unset($fCat[0]);
							
						}else{
							$t = $fCat[$k - 1];
							$fCat[$k - 1] = $fCat[$k];
							$fCat[$k] = $t;
						}
					}
					if ($user_input->action_move == 'down'){
						if ($k == count($fCat) - 1){
							$fCat[-1] = $fCat[$k];
							unset($fCat[$k]);
						}else{
							$t = $fCat[$k + 1];
							$fCat[$k + 1] = $fCat[$k];
							$fCat[$k] = $t;
						}
					}
					ksort ($fCat);
					$fCat = array_values ($fCat);
					$nbrSources = array_flip($fCat);
					HD::saveItemsArr('nbrSources', $nbrSources);
					$post_action = ActionFactory::change_behaviour($actions, 0);
					return ActionFactory::invalidate_folders(array($user_input->parent_media_url), $post_action);
					  
				}else{
					echo $user_input->selected_media_url;
					foreach ($nbrSources as $k => $v)
						echo "$k => $v";
					return ActionFactory::show_title_dialog("Err!", null, 'Подробности в лог файле!');
				}
			}
			if ($user_input->action_move == 'hide_id'){
				
				$sourseTypeSkip = (HD::getItemStr('sourseTypeSkip', true) != '') ? HD::getItemStr('sourseTypeSkip', true) : 0;
				if ($sourseTypeSkip != 0){
					$source_list = SmartConfig::getAllVodSources();
					$type = $source_list[$user_input->selected_media_url]['type'];
					if ((($sourseTypeSkip == 1)&&(!preg_match("|onlineSource|",$type)))
						||(($sourseTypeSkip == 2)&&(preg_match("|onlineSource|",$type)))){
						$add_params['action_move'] = 'sourseTypeOnOff';
						return UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
					}
				}
				$hideSources = HD::getItemsArr('hideSources', true);
				if (isset($hideSources[$user_input->selected_media_url])){
					if($this->unlock == false){
						if ($parentalControl != ''){
							$add_params['controlId']= $user_input->control_id;
							$add_params['param'] = 'action_move';
							$add_params['vel'] = 'hide_id';
							ControlFactory::add_text_field(
								$defs, $this, $add_params,
								'hide_pin_control', '',
								'', 1, 1, 0, 1, 500, 1 , 0
							);
							return  ActionFactory::show_dialog('Введите код:', $defs, true);
						}
					}
					unset($hideSources[$user_input->selected_media_url]);
				}else
					$hideSources[$user_input->selected_media_url] = 1;
				HD::saveItemsArr('hideSources', $hideSources, true);
				$post_action = ActionFactory::change_behaviour($actions, 0);
				return  ActionFactory::invalidate_folders(array($user_input->parent_media_url), $post_action);
			}
		}
		
		if ($user_input->control_id == 'classAction'){
			$defs = array();
			hd_silence_warnings();
			if (isset($user_input->indiClass)){
				$selected_media_url = MediaURL::decode($user_input->selected_media_url);
				$class_name = $selected_media_url->class_name;
				return $class_name::classAction ($defs, $user_input, $this->select_url);
			}
			return SmartConfig::classAction ($defs, $user_input, $this->select_url);
		}
		if ($user_input->control_id == 'icon_actions'){
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			$class_name = $selected_media_url->class_name;
			if (isset($selected_media_url->iconId))
				$class_name = $selected_media_url->iconId;
			if ($user_input->action == 'del'){
				if (!unlink(HD::get_data_path() . "/icons/$class_name.png"))
					return ActionFactory::show_title_dialog('Удаление не удалось!', null, HD::get_data_path() . "/icons/$class_name.png");
				return ActionFactory::invalidate_folders(array($user_input->parent_media_url));
			}
			if ($user_input->action == 'add'){
				$media_url = MediaURL::encode (
					array(
						'screen_id'     => 'file_list',
						'save_file'		=> array(	
							'parent' => $user_input->parent_media_url,
							'action' => 'plugin_ico',
							'arg' => $class_name,
							'extension' => 'png'
						),
					)
				);
				return ActionFactory::open_folder($media_url,'Задать бекграунд');
			}
		}
	}
    ///////////////////////////////////////////////////////////////////////

    public function get_all_folder_items(MediaURL $media_url, &$plugin_cookies){
		$view_idx = isset($plugin_cookies->{"screen.".self::ID.".view_idx"}) ? $plugin_cookies->{"screen.".self::ID.".view_idx"} : 0;
		$class_name = $media_url->class_name;
		$movie = $this->vod->get_loaded_movie($media_url, $plugin_cookies);
		if (!isset($movie->class_info['dbIDs']['kpID'])){
			$kpIDs = HD::getItemsArr('kpIDs');
			if (isset($kpIDs[$media_url->movie_id]))
				$movie->class_info['dbIDs']['kpID'] = $kpIDs[$media_url->movie_id];
			if (!isset($movie->class_info['dbIDs']['kpID'])){
				$year = '';
				if (($movie->year != -1)&&(preg_match("#^(\d{4})#",$movie->year, $mch)))
					$year = $mch[1];
				else if (preg_match("#(\d{4})#",$movie->country, $mch))
					$year = $mch[1];
				$kpID = Kinopoisk_Class::searchKpId ($movie->name, $movie->name_original, $year);
				if ($kpID == true)
					$movie->class_info['dbIDs']['kpID'] = $kpID;
			}
			if (!isset($movie->class_info['dbIDs']['kpID']))
				$movie->class_info['dbIDs']['kpID'] = false;
		}
		$items = array();
		if ($this->allSources == true){
			$source_list = SmartConfig::getAllVodSources($media_url);
			$hideSources = HD::getItemsArr('hideSources', true);
			$nbrSources = HD::getItemsArr('nbrSources');
			$sourseTypeSkip = (HD::getItemStr('sourseTypeSkip', true) != '') ? HD::getItemStr('sourseTypeSkip', true) : 0;
			foreach ($source_list as $k => $v){
				$color = 15;
				$view_item_params[ViewItemParams::icon_path] = $v['icon_path'];
				$view_item_params[ViewItemParams::item_detailed_icon_path] = $v['detailed_icon_path'];
				if (isset($hideSources[$v['class_name']])){
					$color = 17;
					$v['caption'] = $v['caption'] . ' (откл.)';
				}
				if (($sourseTypeSkip == 1)&&(!preg_match("|onlineSource|",$v['type']))){
					$color = 17;
					if(defined('ViewItemParams::item_extra_info')){
						$extra_item = array('type' => 'text', 'color' => 23, 'text' => 'Категория Торренты скрыта');
						$item_extra_info = array(
							'items' => array(
							array('type' => 'gap', 'width' => 20),
							$extra_item,
						));
							$view_item_params[ViewItemParams::item_extra_info] = json_encode($item_extra_info);
					}
					$v['detailed_info'] = $v['detailed_info'] . '||Внимание|для востановление категории нажмите кнопку popup menu';
				}
				if (($sourseTypeSkip == 2)&&(preg_match("|onlineSource|",$v['type']))){
					$color = 17;
					if(defined('ViewItemParams::item_extra_info')){
						$extra_item = array('type' => 'text', 'color' => 23, 'text' => 'Категория Онлайн скрыта');
						$item_extra_info = array(
							'items' => array(
							array('type' => 'gap', 'width' => 20),
							$extra_item,
						));
							$view_item_params[ViewItemParams::item_extra_info] = json_encode($item_extra_info);
					}
					$v['detailed_info'] = $v['detailed_info'] . '||Внимание|для востановление категории нажмите кнопку popup menu';
				}
				$view_item_params[ViewItemParams::item_detailed_info] = $v['detailed_info'];
				$view_item_params[ViewItemParams::item_caption_color] = $color;
				if (defined('ViewItemParams::item_detailed_info_sticker') === true)
					$view_item_params[ViewItemParams::item_detailed_info_sticker] = $v['type'];

				$n = isset($nbrSources[$k]) ? $nbrSources[$k] : count ($items) - 1000;
				$items[$n] = array(
					PluginRegularFolderItem::media_url => $v['class_name'],
					PluginRegularFolderItem::caption => $v['caption'],
					PluginRegularFolderItem::view_item_params => $view_item_params
				);
			}
			ksort($items);
			$items = array_values ($items);
			return $items;
		}
		$source_list = SmartConfig::getVodSources($class_name, $movie, $media_url);
		if (isset($source_list['linkArr'])){
			$source_list['className']::$linkArr = $source_list['linkArr'];
			unset ($source_list['linkArr'], $source_list['className']);
		}
		foreach ($source_list as $k => $v){
			if (self::$filter != false){
				if ((!preg_match("|".self::$filter."|",$v['type']))
					&&(isset($v['type'])))
					continue;
			}
			$view_item_params = $mArr = array();
			if (isset($v['detailed_info']))
				$view_item_params[ViewItemParams::item_detailed_info] = $v['detailed_info'];
			if (isset($v['inWork'])){
				$mUrl = MediaURL::encode('inWork');
				$view_item_params[ViewItemParams::item_caption_color] = 17;
				$view_item_params[ViewItemParams::icon_path] = SmartConfig::getPluginIco('roundarr');
				if ($v['class_name'] === $this->currClassName)
					$this->counter++;
				else{
					$this->currClassName = $v['class_name'];
					$this->counter = 0;
				}
				$v['caption'] .= ' ' . round($this->counter / 2) . ' сек.';
				if (isset($v['detailed_info']))
					$view_item_params[ViewItemParams::item_detailed_info] = $v['detailed_info'] . "||Внимание|Что бы пропустить этот источник нажмите кнопку PLAY";
			}else if (isset($v['slist'])){
				$mUrl = MediaURL::encode('completed');
				$view_item_params[ViewItemParams::item_caption_color] = 17;
				$view_item_params[ViewItemParams::icon_path] = SmartConfig::getPluginIco('unselect');
			}else if (isset($v['completed'])){
				$mUrl = MediaURL::encode('completed');
				$view_item_params[ViewItemParams::item_caption_color] = 17;
				$view_item_params[ViewItemParams::icon_path] = SmartConfig::getPluginIco('7');
			}else if (isset($v['goTo'])){
				if (isset($v['link']))
					$mArr['link'] = $v['link'];
				$mArr['caption'] = $v['caption'];
				$mArr['detailed_info'] = $v['detailed_info'];
				$mArr['poster_url'] = $v['detailed_icon_path'];
				$mArr['movie_id'] = $media_url->movie_id;
				if (isset($v['hash_patrs']))
					$mArr['hash_patrs'] = $v['hash_patrs'];
				if (isset($v['description']))
					$mArr['description'] = $v['description'];
				if ($v['class_name'] != $class_name)
					$mArr['infoSourseClassName'] = $class_name;
				if (isset($media_url->links))
					$mArr['links'] = $media_url->links;
				if (isset($v['iconId']))
					$mArr['iconId'] = $v['iconId'];
				$mUrl = $v['goTo']::get_media_url_str($v['class_name'], $mArr);
			}else{
				foreach($v as $ek => $ev)
					echo "Err \$v: $ek => $ev";
				$mUrl = MediaURL::encode('Err');
			}
			if ((defined('ViewItemParams::item_detailed_info_sticker') === true)&&(isset($v['type'])))
				$view_item_params[ViewItemParams::item_detailed_info_sticker] = $v['type'];
			if ((!isset($view_item_params[ViewItemParams::icon_path]))&&(isset($v['icon_path'])))
				$view_item_params[ViewItemParams::icon_path] = $v['icon_path'];
			if (isset($v['detailed_icon_path']))
				$view_item_params[ViewItemParams::item_detailed_icon_path] = $v['detailed_icon_path'];
			if ((isset($v['link']))||(isset($v['pstr']))){
				if (defined('ViewItemParams::item_detailed_icon_width') === true){
					$view_item_params[ViewItemParams::item_detailed_icon_width] = 200;
					$view_item_params[ViewItemParams::item_detailed_icon_height] = 291;
				}
			}
			
			if ((defined('ViewItemParams::item_sticker') === true)&&($view_idx == 0)){
				if (isset($v['left_bottom'])){
					$txtArr[2] = $v['left_bottom'];
					$geoArr['txt_color'][2] = 23;
					$geoArr['txt_x'][2] = 100; 
					$geoArr['txt_y'][2] = 7;
					$geoArr['txt_halign'][2] = 'left';
					$geoArr['txt_valign'][2] = 'bottom';
					$view_item_params[ViewItemParams::item_sticker] = json_encode(HD::get_sticker($imgArr=array(), $txtArr, $geoArr));
				}
			}
            $items[] = array(
                PluginRegularFolderItem::media_url => $mUrl,
                PluginRegularFolderItem::caption => $v['caption'],
                PluginRegularFolderItem::view_item_params => $view_item_params
            );
        }
        return $items;
    }

    ///////////////////////////////////////////////////////////////////////

    private function get_folder_views(){
		$sandwich_base2 = SmartConfig::getPluginIco('badge1');
		$background_path = SmartConfig::getPluginIco(self::ID . '_bg');
		$paintBackground = (HD::getItemsArr('paintBackground') != array()) ? HD::getItemsArr('paintBackground') : array('paint_widget_background' => true, 'paint_content_box_background' => true, 'paint_path_box_background' => true, 'paint_details_box_background' => true);

		$arr[0][PluginRegularFolderView::async_icon_loading] = true;
		$arr[0][PluginRegularFolderView::timer] = array(GuiTimerDef::delay_ms =>  500);
		$arr[0][PluginRegularFolderView::view_params][ViewParams::num_cols] = 1;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::num_rows] = 7;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_details] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_item_info_in_details] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_auto_line_break] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_title_color] = 10;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_text_color] = 15;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_font_size] = (HD::getItemStr('detailedInfoFontSize') != '') ? HD::getItemStr('detailedInfoFontSize') : FONT_SIZE_SMALL;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_path] = $background_path;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_order] = 0;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_height] = 1080;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_width] = 1920;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::optimize_full_screen_background] = true;
		
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_widget_background] = $paintBackground['paint_widget_background'];
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_content_box_background] = $paintBackground['paint_content_box_background'];
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_path_box_background] = $paintBackground['paint_path_box_background'];
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_details_box_background] = $paintBackground['paint_details_box_background'];
		
		$arr[0][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[0][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_width] = 70;
		$arr[0][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_height] = 70;
		$arr[0][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_path] = $sandwich_base2;
		
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_layout] = HALIGN_LEFT;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_valign] = VALIGN_CENTER;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_scale_factor] = 1.0;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_scale_factor] = 1.1;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_width] = 70;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_height] = 70;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_dx] = 5;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_dy] = -5;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_caption_dy]=-15;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_caption_sel_dy]=-15;
		
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_margin_top] = 0;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_caption] = true;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_caption_width] = 1080;
		///////////////////////////////////////////////////
		$arr[1][PluginRegularFolderView::async_icon_loading] = true;
		$arr[1][PluginRegularFolderView::timer] = array(GuiTimerDef::delay_ms =>  500);
		$arr[1][PluginRegularFolderView::view_params][ViewParams::num_cols] = 1;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::num_rows] = 10;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_details] = true;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_item_info_in_details] = true;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_auto_line_break] = true;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_title_color] = 10;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_text_color] = 15;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_font_size] = (HD::getItemStr('detailedInfoFontSize') != '') ? HD::getItemStr('detailedInfoFontSize') : FONT_SIZE_SMALL;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_path] = $background_path;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_order] = 0;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_height] = 1080;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_width] = 1920;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::optimize_full_screen_background] = true;
		
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_widget_background] = $paintBackground['paint_widget_background'];
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_content_box_background] = $paintBackground['paint_content_box_background'];
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_path_box_background] = $paintBackground['paint_path_box_background'];
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_details_box_background] = $paintBackground['paint_details_box_background'];
		
		$arr[1][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[1][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_width] = 50;
		$arr[1][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_height] = 50;
		$arr[1][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_path] = $sandwich_base2;
		
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_layout] = HALIGN_LEFT;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_valign] = VALIGN_CENTER;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_scale_factor] = 1.0;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_scale_factor] = 1.1;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_width] = 50;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_height] = 50;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_dx] = 5;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_dy] = -5;

		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_margin_top] = 0;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_caption] = true;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_caption_width] = 1100;
		return $arr;
	}
}

///////////////////////////////////////////////////////////////////////////
?>
