<?php
require_once 'Smart_vod_list_screen.php';
class SmartVodTetragonListScreen extends VodListScreen{
	const ID = 'vod_tetragonlist';
	public static function get_media_url_str($class_name, $arr=null){
		$arr['screen_id'] = self::ID;			
		$arr['class_name'] = $class_name;
        return MediaURL::encode($arr);
    }
    public function __construct(Vod $vod){
        parent::__construct($vod, self::ID, $this->get_folder_views());
    }
	private function get_folder_views(){
		$sandwich_cover = SmartConfig::getPluginIco('sandwich_cover');
		$sandwich_base = SmartConfig::getPluginIco('sandwich_base');
		$background_path = SmartConfig::getPluginIco(self::ID . '_bg');
		$paintBackground = (HD::getItemsArr('paintBackground') != array()) ? HD::getItemsArr('paintBackground') : array('paint_widget_background' => true, 'paint_content_box_background' => true, 'paint_path_box_background' => true, 'paint_details_box_background' => true);
		$paintSandwich = (HD::getItemStr('paintSandwich') != '') ? (bool)HD::getItemStr('paintSandwich') : true;
//==>
		$arr[0][PluginRegularFolderView::async_icon_loading] = true;

		$arr[0][PluginRegularFolderView::view_params][ViewParams::num_cols] =4;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::num_rows] = 3;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_details] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_sandwich] = $paintSandwich;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::sandwich_base] = $sandwich_base;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::sandwich_mask] = 'cut_icon://{name=sandwich_mask}';
		$arr[0][PluginRegularFolderView::view_params][ViewParams::sandwich_cover] = $sandwich_cover;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::sandwich_width] = 160;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::sandwich_height] = 160;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::sandwich_icon_upscale_enabled] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::sandwich_icon_keep_aspect_ratio] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_path] = $background_path;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_order] = 0;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_height] = 1080;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_width] = 1920;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::optimize_full_screen_background] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_item_info_in_details] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_auto_line_break] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_title_color] = 10;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_text_color] = 15;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_font_size] = (HD::getItemStr('detailedInfoFontSize') != '') ? HD::getItemStr('detailedInfoFontSize') : FONT_SIZE_SMALL;
		if (defined('ViewParams::paint_icon_badge_box') === true){
			$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_icon_badge_box] = true;
			$arr[0][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_height] = 160;
			$arr[0][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_width] = 160;
			$arr[0][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_dx] = -80;
            $arr[0][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_dy] = -103;
			$arr[0][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_sel_height] = 165;
			$arr[0][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_sel_width] = 165;
		}
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_widget_background] = $paintBackground['paint_widget_background'];
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_content_box_background] = $paintBackground['paint_content_box_background'];
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_path_box_background] = $paintBackground['paint_path_box_background'];
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_details_box_background] = $paintBackground['paint_details_box_background'];
		
		
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_layout] = HALIGN_CENTER;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_valign] = VALIGN_CENTER;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_caption] = true;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_scale_factor] = 1.0;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_scale_factor] = 1.1;
		if (defined('ViewItemParams::item_override_default_badge') === true)
			$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_override_default_badge] = true;
		$arr[0][PluginRegularFolderView::not_loaded_view_item_params] = array ();
//==>
//==>
		$arr[1][PluginRegularFolderView::async_icon_loading] = true;

		$arr[1][PluginRegularFolderView::view_params][ViewParams::num_cols] = 6;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::num_rows] = 4;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_details] = true;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_sandwich] = $paintSandwich;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_base] = $sandwich_base;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_mask] = 'cut_icon://{name=sandwich_mask}';
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_cover] = $sandwich_cover;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_width] = 160;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_height] = 160;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_icon_upscale_enabled] = true;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::sandwich_icon_keep_aspect_ratio] = true;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_path] = $background_path;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_order] = 0;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_height] = 1080;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_width] = 1920;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::optimize_full_screen_background] = true;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_item_info_in_details] = true;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_auto_line_break] = true;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_title_color] = 10;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_text_color] = 15;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_font_size] = (HD::getItemStr('detailedInfoFontSize') != '') ? HD::getItemStr('detailedInfoFontSize') : FONT_SIZE_SMALL;
		if (defined('ViewParams::paint_icon_badge_box') === true){
			$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_icon_badge_box] = true;
			$arr[1][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_height] = 160;
			$arr[1][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_width] = 160;
			$arr[1][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_dx] = -80;
            $arr[1][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_dy] = -80;
			$arr[1][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_sel_height] = 165;
			$arr[1][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_sel_width] = 165;
		}
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_widget_background] = $paintBackground['paint_widget_background'];
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_content_box_background] = $paintBackground['paint_content_box_background'];
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_path_box_background] = $paintBackground['paint_path_box_background'];
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_details_box_background] = $paintBackground['paint_details_box_background'];
		
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_layout] = HALIGN_CENTER;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_valign] = VALIGN_CENTER;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_caption] = false;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_scale_factor] = 1.0;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_scale_factor] = 1.1;
		if (defined('ViewItemParams::item_override_default_badge') === true)
			$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_override_default_badge] = true;
		$arr[1][PluginRegularFolderView::not_loaded_view_item_params] = array ();
//==>
//==>
		$arr[2][PluginRegularFolderView::async_icon_loading] = true;

		$arr[2][PluginRegularFolderView::view_params][ViewParams::num_cols] = 1;              
		$arr[2][PluginRegularFolderView::view_params][ViewParams::num_rows] = 10;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_details] = true;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_item_info_in_details] = true;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_auto_line_break] = true;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_title_color] = 10;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_text_color] = 15;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::background_path] = $background_path;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::background_order] = 0;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::background_height] = 1080;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::background_width] = 1920;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_item_info_in_details] = true;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_font_size] = (HD::getItemStr('detailedInfoFontSize') != '') ? HD::getItemStr('detailedInfoFontSize') : FONT_SIZE_SMALL;
		if (defined('ViewParams::paint_icon_badge_box') === true){
			$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_icon_badge_box] = true;
			$arr[2][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_height] = 50;
			$arr[2][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_width] = 50;
			$arr[2][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_dx] = -590;
            $arr[2][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_dy] = -25;
			$arr[2][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_sel_height] = 55;
			$arr[2][PluginRegularFolderView::view_params][ViewParams::icon_badge_box_sel_width] = 55;
		}
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_widget_background] = $paintBackground['paint_widget_background'];
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_content_box_background] = $paintBackground['paint_content_box_background'];
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_path_box_background] = $paintBackground['paint_path_box_background'];
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_details_box_background] = $paintBackground['paint_details_box_background'];
		
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_valign] = VALIGN_CENTER;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_keep_aspect_ratio] = true;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_height] = 50;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_caption_within_icon] = false;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_caption] = true;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_caption_width] = 1100;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_layout] = HALIGN_LEFT;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_dx] = 15;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_scale_factor] = 1.1;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_margin_left] = 5;
		// $arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_margin_bottom] = 5;
		// if (defined('ViewItemParams::item_override_default_badge') === true)
			// $arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_override_default_badge] = true;
		$arr[2][PluginRegularFolderView::not_loaded_view_item_params] = array ();
//==>
		return $arr;
	}
}
?>