<?php
require_once 'lib/vod/vod.php';
require_once 'lib/abstract_preloaded_regular_screen.php';
class VodTorrServerScreen extends AbstractPreloadedRegularScreen
    implements UserInputHandler
{
    const ID = 'vod_torrserver';

    public static function get_media_url_str($class_name, $arr=null){
		$arr['screen_id'] = self::ID;
		$arr['class_name'] = $class_name;
        return MediaURL::encode($arr);
    }

    ///////////////////////////////////////////////////////////////////////

    private $vod;
	static $counter = 0;
	private $showIp;
    public function __construct(Vod $vod){
        $this->vod = $vod;
        parent::__construct(self::ID,
           $this->get_folder_views());

        UserInputHandlerRegistry::get_instance()->register_handler($this);
    }

    ///////////////////////////////////////////////////////////////////////

    public function get_action_map(MediaURL $media_url, &$plugin_cookies){
		$this->view_idx = isset($plugin_cookies->{"screen.".self::ID.".view_idx"}) ? $plugin_cookies->{"screen.".self::ID.".view_idx"} : 0;
        $params['event_key'] = 'enter';
        $actions[GUI_EVENT_KEY_ENTER]		= UserInputHandlerRegistry::create_action($this, 'add_action',$params);
		
		$params['event_key'] = 'play';
        $actions[GUI_EVENT_KEY_PLAY] 		= UserInputHandlerRegistry::create_action($this, 'add_action',$params);
		
		$actions[GUI_EVENT_TIMER] = UserInputHandlerRegistry::create_action($this, 'timer');
		
		$popup_menu_action = UserInputHandlerRegistry::create_action($this, 'popup_menu');
		$actions[GUI_EVENT_KEY_POPUP_MENU] = $popup_menu_action;
		
		$actions[GUI_EVENT_KEY_SETUP] = ActionFactory::open_folder('setup');
		
		$params['action'] = 'torrserverActionRem';
		$add_action							= UserInputHandlerRegistry::create_action($this, 'classAction', $params);
		$add_action['caption']				= 'Удалить';
		$actions[GUI_EVENT_KEY_B_GREEN] 	= $add_action;
		
		$add_action = UserInputHandlerRegistry::create_action($this, 'classSetupTorrServer');
		$add_action['caption'] = 'Настройки TorrServe';
		$actions[GUI_EVENT_KEY_C_YELLOW] = $add_action;
		if (isset($this->vod->currentFav))
			unset ($this->vod->currentFav);
		return $actions;
    }

    public function get_handler_id(){ return self::ID; }

    public function handle_user_input(&$user_input, &$plugin_cookies){
        // foreach ($user_input as $key => $value)
            // hd_print("  $key => $value");
		if ($user_input->control_id == 'popup_menu'){
			$selected_media_url = (object)array();
			if (isset($user_input->selected_media_url))
				$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			$parent_media_url = MediaURL::decode($user_input->parent_media_url);
			if (isset($parent_media_url->class_name)){
				$class_name = $parent_media_url->class_name;
				$mItems = $class_name::getPopUpMenuItems($selected_media_url, $parent_media_url);
				foreach ($mItems as $v){
					if ($v == 'is_separator')
						$menu_items [] =  array(
						GuiMenuItemDef::is_separator => true,);
					else if ($v['params'] == 'classSetup')
						$menu_items[] = array(
							GuiMenuItemDef::caption => $v['caption'],
							GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classSetup' . $class_name),
							GuiMenuItemDef::icon_url => $v['icon_url'],
						);
					else if (isset($v['conID']))
						$menu_items[] = array(
							GuiMenuItemDef::caption => $v['caption'],
							GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, $v['conID'], $v['params']),
							GuiMenuItemDef::icon_url => $v['icon_url'],
						);
					else
						$menu_items[] = array(
							GuiMenuItemDef::caption => $v['caption'],
							GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', $v['params']),
							GuiMenuItemDef::icon_url => $v['icon_url'],
						);
				}
			}
			if ($user_input->selected_media_url != 'addLocalTorrent'){
				$menu_items [] =  array(
					GuiMenuItemDef::is_separator => true,);
				$add_params['action'] = 'background_actions';
				$add_params['indiClass'] = 'SmartConfig';
				$menu_items[] = array(
					GuiMenuItemDef::caption => 'Задать бекграунд',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', $add_params),
					GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_add_background')
				);
				if (file_exists(HD::get_data_path() . "/icons/" . self::ID . "_bg.jpg")){
					$add_params['action'] = 'background_actions';
					$add_params['del'] = true;
					$menu_items[] = array(
						GuiMenuItemDef::caption => 'Удалить бекграунд',
						GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', $add_params),
						GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_del_background')
					);
				}
			}
			return ActionFactory::show_popup_menu($menu_items);
		}
		if ($user_input->control_id == 'classSetupTorrServer'){
			$defs = array();
			hd_silence_warnings();
			return TorrServer::setup($defs, $user_input);
		}
		if ($user_input->control_id == 'classAction'){
			$defs = array();
			if (isset($user_input->newKpId)){
				$this->vod->clear_cached_movie();
				$this->vod->clear_movie_cache();
			}
			if (($user_input->selected_media_url =='dummy')||
				($user_input->selected_media_url =='addLocalTorrent')||
				(!isset($user_input->selected_media_url))
			)return null;
			if (isset($user_input->indiClass)){
				$selected_media_url = MediaURL::decode($user_input->selected_media_url);
				$class_name = $user_input->indiClass;
				hd_silence_warnings();
				return $class_name::classAction ($defs, $user_input, $this->select_url);
			}
			$parent_media_url = MediaURL::decode($user_input->parent_media_url);
			$class_name = $parent_media_url->class_name;
			hd_silence_warnings();
			return $class_name::classAction ($defs, $user_input);
		}
		if ($user_input->control_id == 'timer'){
			$parent_media_url = MediaURL::decode($user_input->parent_media_url);
			$actions = $this->get_action_map($parent_media_url,$plugin_cookies);
			return ActionFactory::invalidate_folders(array($user_input->parent_media_url));
		}
        if ($user_input->control_id == 'add_action'){
            if (!isset($user_input->selected_media_url))
                return null;
			if ($user_input->selected_media_url == 'addLocalTorrent')
				return UserInputHandlerRegistry::create_action($this, 'addLocalTorrent');
			if ($user_input->selected_media_url == 'dummy')
				return UserInputHandlerRegistry::create_action($this, 'classSetupTorrServer');
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);	
			TorrServer::set_movie($selected_media_url->movie_id, $selected_media_url->data);
            return ActionFactory::open_folder();
		}
        if ($user_input->control_id == 'addLocalTorrent'){
			$media_url = MediaURL::encode (
				array(
					'screen_id'     => 'file_list',
					'save_file'		=> array(	
						'action' 		=> 'addLocalTorrentTorrServer',
						'extension' 	=> 'torrent'
					),
				)
			);
			return ActionFactory::open_folder($media_url,'Выберите .torrent файл:');
        }

        return null;
    }

    ///////////////////////////////////////////////////////////////////////

    public function get_all_folder_items(MediaURL $media_url, &$plugin_cookies){
        $this->vod->folder_entered($media_url, $plugin_cookies);
        $items = array();
		$torrentObj = TorrServer::actionGetTorrentList();
		if ($torrentObj == true){
			$view_item_params[ViewItemParams::icon_path] = 'plugin_file://icons/add.png';
			$view_item_params[ViewItemParams::item_detailed_info] = '||TorrServer IP:|' . $this->showIp . '||Загрузить торрент файл|Добавляет в TorrServer торрент файл c локального диска или по сети';
			$view_item_params[ViewItemParams::item_caption_color] = 10;
			if (defined('FONT_SIZE_LARGE') === true)
				$view_item_params[ViewItemParams::item_caption_font_size] = FONT_SIZE_LARGE;
			if ($this->view_idx == 2){
				$view_item_params[ViewItemParams::icon_width] = 200;
				$view_item_params[ViewItemParams::icon_height] = 200;
			}
			if (defined('ViewParams::details_box_width') === true){
				$view_item_params[ViewItemParams::item_detailed_icon_width] = 200;
				$view_item_params[ViewItemParams::item_detailed_icon_height] = 200;
			}
			$items[] = array(
				PluginRegularFolderItem::media_url => 'addLocalTorrent',
				PluginRegularFolderItem::caption => 'Загрузить торрент файл',
				PluginRegularFolderItem::view_item_params => $view_item_params
			);
			if (is_array($torrentObj)){
				$torrServInf = HD::getItemsArr('TorrServerInf');
				foreach ($torrentObj as $torrent){
					$torrent_name = '';
					$caption = 'n/a';
					if ($torrent->title != ''){
						$caption = $torrent->title;
						if ((isset($torrent->name))&&($torrent->title != $torrent->name))
							$torrent_name = '|' . implode( ' ', str_split($torrent->name, 23));
					}else if (isset($torrent->name))
						$caption = $torrent->name;
					else{
						$jsd = TorrServer::torrserverActionGet($torrent->hash);
						if ($jsd->title != ''){
							$caption = $jsd->title;
							if ((isset($jsd->name))&&($jsd->title != $jsd->name))
								$jsd_name = '|' . implode( ' ', str_split($jsd->name, 23));
						}else if (isset($jsd->name))
							$caption = $jsd->name;
					}
					$view_item_params = array();
					$detailed_icon = 'plugin_file://icons/'.$media_url->class_name.'.png';
					$detailed_info = '||' . implode( ' ', HD::mb_str_split($caption, 23));
					if (isset($torrent->Length))
						$detailed_info .= '|' . HD::readableBytes($torrent->Length);
					if (isset($torrent->AddTime))
						$detailed_info .= '||Дата добавления:|' . date ('d.m.Y G:i', $torrent->AddTime);
					$icon_path = 'plugin_file://icons/s_torrent.png';
					$description = 'TorrServe';
					if (isset($torrent->torrent_size)){
						$torrent_size = HD::readableBytes($torrent->torrent_size);
						$detailed_info .= '|' . $torrent_size;
						$description .= "\n" . $torrent_size;
					}
					if (isset($torrent->file_stats)){
						$icon_path = 'plugin_file://icons/torrent2.png';
						$detailed_info .= '|Файлов: ' . count($torrent->file_stats);
					}else
						$icon_path = 'plugin_file://icons/torrent.png';
					if (isset($torrent->stat_string))
						$detailed_info .= '|Статус: ' . $torrent->stat_string;
					if (isset($torrent->timestamp))
						$detailed_info .= '|Дата:' . date ('d.m.Y G:i', $torrent->timestamp);
					
					if (isset($torrent->download_speed)){
						$detailed_info .= '||Download: ' .  HD::readableBytes($torrent->download_speed) . '/c';
						if (isset($torrent->total_peers)){
							$c1 = $c2 = '';
							$c = '|Peers: All';
							$tp = $torrent->total_peers;
							if (isset($torrent->active_peers)){
								$ap = '/' . $torrent->active_peers ;
								$c1 = '/Active';
							}
							if (isset($torrent->pending_peers)){
								$pp = '/' . $torrent->pending_peers;
								$c2 = '/Pending';
							}
							$detailed_info .= $c . $c1 . $c2 . '|' . $tp . $ap . $pp;
						}else
							$detailed_info .= '|n/a';
					}
					if (isset($torrent->upload_speed)){
						$detailed_info .= '||Upload: ' .  HD::readableBytes($torrent->upload_speed) . '/c';
						if (isset($torrent->connected_seeders))
							$detailed_info .= '|Connected Seeders: ' .  $torrent->connected_seeders;
						else
							$detailed_info .= '|n/a';
					}
					if (isset($torrServInf[$torrent->hash])){
						$_infs = json_decode( $torrServInf[$torrent->hash]);
						$torrent->poster = $_infs->poster_path;
						$detailed_info = '||'. $_infs->title .'|'.$_infs->original_title . $detailed_info;
						$description = $_infs->overview;
					}
					if ($torrent->poster != ''){
                        $port = HD::http_local_port();
						$detailed_icon = preg_replace("|http://127.0.0.1:$port/cgi-bin/plugins/.*?/do\?img=|",DuneSystem::$properties['plugin_cgi_url'].'do?img=', $torrent->poster);
						if (defined('ViewParams::details_box_width') === true){
							$view_item_params[ViewItemParams::item_detailed_icon_width] = 167;
							$view_item_params[ViewItemParams::item_detailed_icon_height] = 250;
						}
					}
					if ($this->view_idx == 2){
						$icon_path = $detailed_icon;
						if ($detailed_icon == 'plugin_file://icons/'.$media_url->class_name.'.png')
							$icon_path = SmartConfig::getPluginIco('poster_none');
					}
					$view_item_params[ViewItemParams::icon_path] = $icon_path;
					$view_item_params[ViewItemParams::item_detailed_info] = $detailed_info;
					$view_item_params[ViewItemParams::item_detailed_icon_path] = $detailed_icon;
					
					$arr['movie_id'] = $torrent->hash;
					$arr['class_name'] = $media_url->class_name;
						$arr_data['caption'] = $caption;
						$arr_data['poster_url'] =  $detailed_icon;
						$arr_data['description'] = $description;
					$arr['data'] = urlencode(json_encode ($arr_data));
					$arr['detailed_info'] = $detailed_info;
					$items[] = array(
						PluginRegularFolderItem::media_url => VodSeriesListScreen::get_media_url_str($media_url->class_name, $arr),
						PluginRegularFolderItem::caption => $caption,
						PluginRegularFolderItem::view_item_params => $view_item_params
					);
				}
			}
		}else{
			self::$counter++;
			$this->select_url = array();
			$this->showIp = TorrServer::getIp();
			$counter = HD::sec_format_duration(self::$counter);
			$caption = "Ожидание ответа от TorrServer Прошло: $counter";
			$item_detailed_info = '||TorrServer IP:|' . $this->showIp . "||Ожидание ответа от TorrServer | Прошло: $counter";
			$icon_path = SmartConfig::getPluginIco('TorrServer');
			$detailed_icon = SmartConfig::getPluginIco('TorrServer');
			$color = 15;
			if (self::$counter > 60){
				$caption = "TorrServer " . $this->showIp . " не отвечает! Прошло: $counter";
				$item_detailed_info = "||Внимание TorrServer не запущен или не отвечает|Перезапустите TorrServer по адресу " . $this->showIp . " или измените IP адрес TorrServer| Прошло: $counter";
				$icon_path = 'plugin_file://icons/0.png';
				$detailed_icon = 'plugin_file://icons/0.png';
				$color = 21;
			}
			$view_item_params = array(
				ViewItemParams::icon_path => $icon_path,
				ViewItemParams::item_detailed_icon_path => $detailed_icon,
				ViewItemParams::item_detailed_info => $item_detailed_info,
				ViewItemParams::item_caption_color => $color
			);
			if ($this->view_idx == 2){
				$view_item_params[ViewItemParams::icon_width] = 200;
				$view_item_params[ViewItemParams::icon_height] = 200;
			}
			if (defined('ViewParams::details_box_width') === true){
				$view_item_params[ViewItemParams::item_detailed_icon_width] = 200;
				$view_item_params[ViewItemParams::item_detailed_icon_height] = 200;
			}
			$items[] = array(
				PluginRegularFolderItem::media_url => 'dummy',
				PluginRegularFolderItem::caption => $caption,
				PluginRegularFolderItem::view_item_params => $view_item_params
			);
		}
        return $items;
    }
	private function get_folder_views(){
		$sandwich_cover = SmartConfig::getPluginIco('sandwich_cover2');
		$sandwich_base = SmartConfig::getPluginIco('poster_none');
		$sandwich_base2 = SmartConfig::getPluginIco('badge1');
		$background_path = SmartConfig::getPluginIco(self::ID . '_bg');
		$paintBackground = (HD::getItemsArr('paintBackground') != array()) ? HD::getItemsArr('paintBackground') : array('paint_widget_background' => true, 'paint_content_box_background' => true, 'paint_path_box_background' => true, 'paint_details_box_background' => true);
		$item_detailed_info_font_size = (HD::getItemStr('detailedInfoFontSize') != '') ? HD::getItemStr('detailedInfoFontSize') : FONT_SIZE_SMALL;
		$paintSandwich = (HD::getItemStr('paintSandwich') != '') ? (bool)HD::getItemStr('paintSandwich') : true;
		////////////////////////////////////////////////////////////////////////////////////////////
		$arr[0][PluginRegularFolderView::async_icon_loading] = true;
		$arr[0][PluginRegularFolderView::timer] = array(GuiTimerDef::delay_ms => 1000);
		$arr[0][PluginRegularFolderView::view_params][ViewParams::num_cols] = 1;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::num_rows]= 10;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_details] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_item_info_in_details] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_auto_line_break] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_title_color] = 10;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_text_color] = 15;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_font_size] = $item_detailed_info_font_size;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_path] = $background_path;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_order] = 0;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_height] = 1080;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_width] = 1920;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::optimize_full_screen_background] = true;
		
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_layout] = HALIGN_LEFT;
        $arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_valign] = VALIGN_CENTER;
        $arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_dx] = 10;
        $arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_dy] = -5;
        $arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_caption_dx] = 60;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_width] = 50;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_height] = 50;
		
		$arr[0][PluginRegularFolderView::not_loaded_view_item_params]= array ();
		
		
		////////////////////////////////////////////////////////////////////////////////////////////
		$arr[1][PluginRegularFolderView::async_icon_loading] = true;
		$arr[1][PluginRegularFolderView::timer] = array(GuiTimerDef::delay_ms => 1000);
		$arr[1][PluginRegularFolderView::view_params][ViewParams::num_cols] = 1;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::num_rows]= 10;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_details] = false;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_font_size] = $item_detailed_info_font_size;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_path] = $background_path;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_order] = 0;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_height] = 1080;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_width] = 1920;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::optimize_full_screen_background] = true;
		
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_layout] = HALIGN_LEFT;
        $arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_valign] = VALIGN_CENTER;
        $arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_dx] = 10;
        $arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_dy] = -5;
        $arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_caption_dx] = 60;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_width] = 50;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_height] = 50;
		
		$arr[1][PluginRegularFolderView::not_loaded_view_item_params]= array ();
		////////////////////////////////////////////////////////////////////////////////////////////
		$arr[2][PluginRegularFolderView::async_icon_loading] = true;
		$arr[2][PluginRegularFolderView::timer] = array(GuiTimerDef::delay_ms =>  1000);
		$arr[2][PluginRegularFolderView::view_params][ViewParams::num_cols] = 5;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::num_rows] = 2;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_details] = true;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_item_info_in_details] = true;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_auto_line_break] = true;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_title_color] = 10;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_text_color] = 15;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_font_size] = $item_detailed_info_font_size;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_sandwich] = $paintSandwich;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::sandwich_base] = $sandwich_base2;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::sandwich_mask] = 'cut_icon://{name=sandwich_mask}';
		$arr[2][PluginRegularFolderView::view_params][ViewParams::sandwich_cover] = $sandwich_cover;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::sandwich_width] = 206;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::sandwich_height] = 300;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::sandwich_icon_upscale_enabled] = true;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::sandwich_icon_keep_aspect_ratio] = false;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::background_path] = $background_path;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::background_order] = 0;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::background_height] = 1080;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::background_width] = 1920;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::optimize_full_screen_background] = true;
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_widget_background] = $paintBackground['paint_widget_background'];
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_content_box_background] = $paintBackground['paint_content_box_background'];
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_path_box_background] = $paintBackground['paint_path_box_background'];
		$arr[2][PluginRegularFolderView::view_params][ViewParams::paint_details_box_background] = $paintBackground['paint_details_box_background'];
		
		$arr[2][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[2][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_width] = 206;
		$arr[2][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_height] = 300;
		$arr[2][PluginRegularFolderView::not_loaded_view_item_params][ViewItemParams::icon_path] = $sandwich_base;
        
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_icon] = true;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_layout] = HALIGN_CENTER;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_valign] = VALIGN_CENTER;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_paint_caption] = false;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_scale_factor] = 1.0;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_scale_factor] = 1.1;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_width] = 206;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_height] = 300;
		$arr[2][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_sel_margin_top] = 0;
				
        return $arr;
    }
    public function get_archive(MediaURL $media_url){
        return $this->vod->get_archive($media_url);
    }
}

?>
