<?php
require_once 'lib/vod/vod.php';
require_once 'lib/abstract_preloaded_regular_screen.php';
class VodTransmissionScreen extends AbstractPreloadedRegularScreen
    implements UserInputHandler
{
    const ID = 'vod_transmission';
	static $counter = 0;
	private $counter2 = 0;
	public $torrentArr = array();
	public $torrentItemsArr = array();
	private $select_url = array();
    public static function get_media_url_str($class_name, $arr=null){
		$arr['screen_id'] = self::ID;			
		$arr['class_name'] = $class_name;
        return MediaURL::encode($arr);
    }

    ///////////////////////////////////////////////////////////////////////

    private $vod;
	private $showIp;
	static $sort = 0;
    public function __construct(Vod $vod){
        $this->vod = $vod;
        parent::__construct(self::ID,
           $this->get_folder_views());

        UserInputHandlerRegistry::get_instance()->register_handler($this);
    }

    ///////////////////////////////////////////////////////////////////////

    public function get_action_map(MediaURL $media_url, &$plugin_cookies=null){
		
        $params['event_key'] = 'enter';
        $actions[GUI_EVENT_KEY_ENTER]		= UserInputHandlerRegistry::create_action($this, 'add_action',$params);
		
		$params['event_key'] = 'play';
        $actions[GUI_EVENT_KEY_PLAY] 		= UserInputHandlerRegistry::create_action($this, 'add_action',$params);
		
		$actions[GUI_EVENT_TIMER] = UserInputHandlerRegistry::create_action($this, 'timer');
		
		$popup_menu_action = UserInputHandlerRegistry::create_action($this, 'popup_menu');
		$actions[GUI_EVENT_KEY_POPUP_MENU] = $popup_menu_action;
		
		$actions[GUI_EVENT_KEY_SETUP] = ActionFactory::open_folder('setup');
		if (!isset($media_url->movie_id)){
			$params['action'] = 'transmissionActionStartStop';
			$add_action							= UserInputHandlerRegistry::create_action($this, 'classAction', $params);
			$add_action['caption']				= 'Остановить';
		}else{
			$params['action'] = 'transmissionActionFileStartStop';
			$add_action							= UserInputHandlerRegistry::create_action($this, 'classAction', $params);
			$add_action['caption']				= 'Остановить';
		}
		$actions[GUI_EVENT_KEY_B_GREEN] 	= $add_action;
		
		$add_action = UserInputHandlerRegistry::create_action($this, 'classSetupTransmission');
		$add_action['caption'] = 'Настройки';
		$actions[GUI_EVENT_KEY_C_YELLOW] = $add_action;
		
		if (!isset($media_url->movie_id)){
			$actions[GUI_EVENT_KEY_INFO] = UserInputHandlerRegistry::create_action($this, 'info');
			self::$sort = (HD::getItemStr('sort', true) !='') ? HD::getItemStr('sort', true) : 0;
			$params['action'] = 'sort';
			$add_action							= UserInputHandlerRegistry::create_action($this, 'classAction', $params);
			if (self::$sort == 0)
				$add_action['caption'] = 'Сорт: очередь';
			if (self::$sort == 1)
				$add_action['caption'] = 'Сорт: название';
			if (self::$sort == 2)
				$add_action['caption'] = 'Сорт: новые';
		}else{
			$actions[GUI_EVENT_KEY_RETURN] = UserInputHandlerRegistry::create_action($this, 'return');
			$params['action'] = 'transmissionActionPriority';
			$add_action							= UserInputHandlerRegistry::create_action($this, 'classAction', $params);
			$add_action['caption'] = 'Приоритет';
		}
		$actions[GUI_EVENT_KEY_D_BLUE] = $add_action;
		
		$actions[GUI_EVENT_KEY_SELECT] = UserInputHandlerRegistry::create_action($this, 'select');
		$actions[GUI_EVENT_KEY_CLEAR] = UserInputHandlerRegistry::create_action($this, 'unselect');
		return $actions;
    }

    public function get_handler_id(){ return self::ID; }

    public function handle_user_input(&$user_input, &$plugin_cookies){
		if ($user_input->control_id == 'unselect'){
			$this->select_url = array();
            return ActionFactory::invalidate_folders(array($user_input->parent_media_url));
		}
		if ($user_input->control_id == 'return'){
			$this->select_url = array();
			$i=0;
			HD::asyncExec('proc_close');
			do {
				$str = Transmission::actionGetTorrentList();
				$i++;
				usleep(50000);
			} while (($i < 100)&&($str==false));
			return ActionFactory::close_and_run();
		}
		if ($user_input->control_id == 'info'){
			$defs = array();
			if ((!isset($user_input->selected_media_url))||
			($user_input->selected_media_url == 'dummy'))
                return null;
			$attrs['initial_sel_ndx'] = isset($user_input->initial_sel_ndx) ? $user_input->initial_sel_ndx : -1;
			$width = 1350;
			if ($user_input->selected_media_url == 'addLocalTorrent'){
				$statsObj = Transmission::getStats();
				if ($statsObj == true){
					ControlFactory::add_smart_label($defs, "", '<gap width="160"/><text color="15">Текущая сессия</text>');// ControlFactory::add_label($defs, 'Текущая сессия', '');
					ControlFactory::add_vgap($defs, -20);
					ControlFactory::add_smart_label($defs, "", '<text color="17">Активные торренты: </text><text color="15">'.$statsObj->arguments->activeTorrentCount.'</text>');// ControlFactory::add_label($defs, 'Активные торренты', $statsObj->arguments->activeTorrentCount);
					ControlFactory::add_vgap($defs, -20);
					ControlFactory::add_smart_label($defs, "", '<text color="17">Неактивные торренты: </text><text color="15">'.$statsObj->arguments->pausedTorrentCount.'</text>');// ControlFactory::add_label($defs, 'Приостановленные торренты', $statsObj->arguments->pausedTorrentCount);
					ControlFactory::add_vgap($defs, -20);
					ControlFactory::add_smart_label($defs, "", '<text color="17">Bсе торренты: </text><text color="15">'.$statsObj->arguments->torrentCount.'</text>');// ControlFactory::add_label($defs, 'Bсе торренты', $statsObj->arguments->torrentCount);
					ControlFactory::add_vgap($defs, -20);
					$rateDownload = '0 B/s';
					if (isset($statsObj->arguments->downloadSpeed))
						$rateDownload = HD::readableBytes($statsObj->arguments->downloadSpeed) . '/s';
					ControlFactory::add_smart_label($defs, "", '<text color="17">Скорость загрузки: </text><text color="15">'.$rateDownload.'</text>');// ControlFactory::add_label($defs, 'Скорость загрузки' , $rateDownload);
					ControlFactory::add_vgap($defs, -20);
					$rateUpload = '0 B/s';
					if (isset($statsObj->arguments->uploadSpeed))
						$rateUpload = HD::readableBytes($statsObj->arguments->uploadSpeed) . '/s';
					ControlFactory::add_smart_label($defs, "", '<text color="17">Скорость отдачи: </text><text color="15">'.$rateUpload.'</text>');// ControlFactory::add_label($defs, 'Скорость отдачи' , $rateUpload);
					ControlFactory::add_vgap($defs, -20);
					ControlFactory::add_smart_label($defs, "", '<text color="17">Загружено: </text><text color="15">'.HD::readableBytes($statsObj->arguments->current_stats->downloadedBytes).'</text>');// ControlFactory::add_label($defs, 'Загружено', HD::readableBytes($statsObj->arguments->current_stats->downloadedBytes));
					ControlFactory::add_vgap($defs, -20);
					ControlFactory::add_smart_label($defs, "", '<text color="17">Роздано: </text><text color="15">'.HD::readableBytes($statsObj->arguments->current_stats->uploadedBytes).'</text>');// ControlFactory::add_label($defs, 'Роздано', HD::readableBytes($statsObj->arguments->current_stats->uploadedBytes));
					ControlFactory::add_vgap($defs, -20);
					ControlFactory::add_smart_label($defs, "", '<text color="17">Файлов добавленно: </text><text color="15">'.$statsObj->arguments->current_stats->filesAdded.'</text>');
					ControlFactory::add_vgap($defs, -20);
					ControlFactory::add_smart_label($defs, "", '<text color="17">Активно: </text><text color="15">'.HD::sec_format_duration($statsObj->arguments->current_stats->secondsActive, true).'</text>');
					ControlFactory::add_smart_label($defs, "", '<gap width="160"/><text color="15">За все время</text>');
					ControlFactory::add_vgap($defs, -20);
					ControlFactory::add_smart_label($defs, "", '<text color="17">Загружено: </text><text color="15">'.HD::readableBytes($statsObj->arguments->cumulative_stats->downloadedBytes).'</text>');// ControlFactory::add_label($defs, 'Загружено', HD::readableBytes($statsObj->arguments->current_stats->downloadedBytes));
					ControlFactory::add_vgap($defs, -20);
					ControlFactory::add_smart_label($defs, "", '<text color="17">Роздано: </text><text color="15">'.HD::readableBytes($statsObj->arguments->cumulative_stats->uploadedBytes).'</text>');
					ControlFactory::add_vgap($defs, -20);
					ControlFactory::add_smart_label($defs, "", '<text color="17">Файлов добавленно: </text><text color="15">'.$statsObj->arguments->cumulative_stats->filesAdded.'</text>');
					ControlFactory::add_vgap($defs, -20);
					ControlFactory::add_smart_label($defs, "", '<text color="17">Активно: </text><text color="15">'.HD::sec_format_duration($statsObj->arguments->cumulative_stats->secondsActive, true).'</text>');
					ControlFactory::add_vgap($defs, -20);
					ControlFactory::add_smart_label($defs, "", '<text color="17">Сессий: </text><text color="15">'.$statsObj->arguments->cumulative_stats->sessionCount.'</text>');
					$attrs['timer'] = ActionFactory::timer(1000);
					$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id);
					$attrs['actions'] = array(GUI_EVENT_TIMER => ActionFactory::close_dialog_and_run($action));
					return ActionFactory::show_dialog('Статистика', $defs, true, ($width / 2), $attrs);
				}else{
					if (isset($user_input->counter)){
						if ($user_input->counter == 21)
							return ActionFactory::show_title_dialog('Err!',null, $url,0,1);
						$params['counter'] = $user_input->counter + 1;
					}else
						$params['counter'] = 1;
					return UserInputHandlerRegistry::create_action($this, $user_input->control_id, $params);
				}
			}
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			if (!isset($user_input->preloaded)){
				$i=0;
				HD::asyncExec('proc_close');
				do {
					$str = Transmission::actionGetTorrentFileList($selected_media_url->movie_id);
					$i++;
					usleep(50000);
				} while (($i < 100)&&($str==false));
			}
			$torrentObj = Transmission::actionGetTorrentFileList($selected_media_url->movie_id);
			$status = 'Err!';
			if ($torrentObj == true){
				$torrent = $torrentObj->arguments->torrents[0];
				ControlFactory::add_vgap($defs, -20);
				ControlFactory::add_smart_label($defs, "", '<text color="10" size="tiny">'.$torrent->name.'</text>');
				ControlFactory::add_vgap($defs, -40);
				ControlFactory::add_smart_label($defs, "", '<text color="14" size="tiny">'.$torrent->downloadDir.'</text>');
				ControlFactory::add_vgap($defs, -40);
				ControlFactory::add_label($defs, 'Добавлен', date('d.m.Y H:i:s', $torrent->addedDate + HD::date_time()));
				if (isset($torrent->doneDate)){
					ControlFactory::add_vgap($defs, -20);
					ControlFactory::add_label($defs, 'Завершен', date('d.m.Y H:i:s', $torrent->doneDate + HD::date_time()));
				}
				if (isset($torrent->activityDate)){
					ControlFactory::add_vgap($defs, -20);
					ControlFactory::add_label($defs, 'Последняя активность', date('d.m.Y H:i:s', $torrent->activityDate + HD::date_time()));
				}
				ControlFactory::add_vgap($defs, -45);
				ControlFactory::add_label($defs, '', '____________________________________');
				$rateDownload = '0 B/s';
				if (isset($torrent->rateDownload))
					$rateDownload = HD::readableBytes($torrent->rateDownload) . '/s';
				ControlFactory::add_vgap($defs, -20);
				ControlFactory::add_label($defs, 'Скорость загрузки' , $rateDownload);
				$downloadedEver = '0 B';
				if (isset($torrent->downloadedEver))
					$downloadedEver = HD::readableBytes($torrent->downloadedEver);
				$percentDone = 0;
				if (isset($torrent->percentDone))
					$percentDone = $torrent->percentDone;
				if (isset($torrent->downloadedEver)){
					ControlFactory::add_vgap($defs, -20);
					ControlFactory::add_label($defs, 'Загружено', HD::readableBytes($torrent->downloadedEver) . ' (' . round($percentDone * 100) . '%)');
				}
				ControlFactory::add_vgap($defs, -20);
				ControlFactory::add_progressbar(&$defs, round($percentDone * 100), $width - 500);
				if (isset($torrent->sizeWhenDone)){
					ControlFactory::add_vgap($defs, -20);
					ControlFactory::add_label($defs, 'Размер', HD::readableBytes($torrent->sizeWhenDone));
				}
				if ($torrent->eta != '-1'){
					ControlFactory::add_vgap($defs, -20);
					ControlFactory::add_label($defs, 'Осталось', HD::sec_format_duration($torrent->eta, true));
				}
				if (isset($torrent->secondsDownloading)){
					ControlFactory::add_vgap($defs, -20);
					ControlFactory::add_label($defs, 'Время загрузки', HD::sec_format_duration($torrent->secondsDownloading, true));
				}
				if (isset($torrent->corruptEver)){
					ControlFactory::add_vgap($defs, -20);
					ControlFactory::add_label($defs, 'Ошибки хеша', HD::readableBytes($torrent->corruptEver));
				}
				ControlFactory::add_vgap($defs, -20);
				$peersSendingToUs = $peersConnected = 0;
				if (isset($torrent->peersSendingToUs))
					$peersSendingToUs = $torrent->peersSendingToUs;
				if (isset($torrent->peersConnected))
					$peersConnected = $torrent->peersConnected;
				ControlFactory::add_label($defs, 'Пиры (загрузка)',  $peersSendingToUs .' из '. $peersConnected);
				ControlFactory::add_vgap($defs, -45);
				ControlFactory::add_label($defs, '', '____________________________________');
				$rateUpload = '0 B/s';
				if (isset($torrent->rateUpload))
					$rateUpload = HD::readableBytes($torrent->rateUpload) . '/s';
				ControlFactory::add_vgap($defs, -20);
				ControlFactory::add_label($defs, 'Скорость отдачи' , $rateUpload);
				
				$uploadedEver = '0 B';
				if (isset($torrent->uploadedEver))
					$uploadedEver = HD::readableBytes($torrent->uploadedEver);
				ControlFactory::add_vgap($defs, -20);
				$ratio = '';
				if ((isset($torrent->uploadRatio))&&($torrent->uploadRatio != '-1'))
					$ratio = ' (ratio ' .  round($torrent->uploadRatio, 2) . ')';
				ControlFactory::add_label($defs, 'Роздано', $uploadedEver . $ratio);
				if (isset($torrent->secondsSeeding)){
					ControlFactory::add_vgap($defs, -20);
					ControlFactory::add_label($defs, 'Время раздачи', HD::sec_format_duration($torrent->secondsSeeding, true));
				}
				ControlFactory::add_vgap($defs, -20);
				$peersGettingFromUs = $peersConnected = 0;
				if (isset($torrent->peersGettingFromUs))
					$peersGettingFromUs = $torrent->peersGettingFromUs;
				if (isset($torrent->peersConnected))
					$peersConnected = $torrent->peersConnected;
				ControlFactory::add_label($defs, 'Пиры (загрузка)',  $peersGettingFromUs .' из '. $peersConnected);
				ControlFactory::add_vgap($defs, -45);
				ControlFactory::add_label($defs, '', '____________________________________');
				$allDload = $allUpload = '';
				foreach ($torrentObj->arguments->torrents as $key => $torrent){
					if (isset($torrent->rateDownload))
						$allDload = HD::bigSum($allDload, $torrent->rateDownload);
					if (isset($torrent->rateUpload))
						$allUpload = HD::bigSum($allUpload, $torrent->rateUpload);
				}
				ControlFactory::add_vgap($defs, -20);
				ControlFactory::add_smart_label($defs, "Все торренты", '<text color="14" size="normal">Download: </text><text color="10" size="normal">'.HD::readableBytes($allDload).'</text><text color="14" size="normal"> Upload: </text><text color="10" size="normal">'.HD::readableBytes($allUpload).'</text>');
				// ControlFactory::add_vgap($defs, -45);
				// ControlFactory::add_label($defs, '', '____________________________________');
				
				$status = '';
				if (isset($torrent->status))
					$status = 'Status: ' . Transmission::getStatusString($torrent->status);
				$attrs['timer'] = ActionFactory::timer(1000);
				$params['preloaded'] = 1;
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $params);
				
				$attrs['actions'] = array(
				GUI_EVENT_TIMER => ActionFactory::close_dialog_and_run($action),
				GUI_EVENT_KEY_RETURN => UserInputHandlerRegistry::create_action($this, 'return')
				);
			}
			return ActionFactory::show_dialog($status, $defs, true, $width, $attrs);
		}
		if ($user_input->control_id == 'select'){
            if (!isset($user_input->selected_media_url))
                return null;
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			if ($selected_media_url->series_id != 'dummy'){
				if (isset($this->select_url[$user_input->selected_media_url]))
					unset ($this->select_url[$user_input->selected_media_url]);
				else
					$this->select_url[$user_input->selected_media_url] = $user_input->selected_media_url;
				$parent_media_url = MediaURL::decode($user_input->parent_media_url);
				$range = $this->get_folder_range($parent_media_url, 0, $plugin_cookies);
				return ActionFactory::update_regular_folder($range, true, $user_input->sel_ndx + 1);
			}
			return null;
		}
		if ($user_input->control_id == 'popup_menu'){
			$selected_media_url = (object)array();
			if (isset($user_input->selected_media_url))
				$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			$parent_media_url = MediaURL::decode($user_input->parent_media_url);
			if (isset($parent_media_url->class_name)){
				$class_name = $parent_media_url->class_name;
				$mItems = $class_name::getPopUpMenuItems($selected_media_url, $parent_media_url, $this->select_url);
				foreach ($mItems as $v){
					if ($v == 'is_separator')
						$menu_items [] =  array(
						GuiMenuItemDef::is_separator => true,);
					else if ($v['params'] == 'classSetup')
						$menu_items[] = array(
							GuiMenuItemDef::caption => $v['caption'],
							GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classSetup' . $class_name),
							GuiMenuItemDef::icon_url => $v['icon_url'],
						);
					else if ($v['params'] == 'info')
						$menu_items[] = array(
							GuiMenuItemDef::caption => $v['caption'],
							GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'info'),
							GuiMenuItemDef::icon_url => $v['icon_url'],
						);
					else if (isset($v['params']))
						$menu_items[] = array(
							GuiMenuItemDef::caption => $v['caption'],
							GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', $v['params']),
							GuiMenuItemDef::icon_url => $v['icon_url'],
						);
				}
			}
			if (isset($selected_media_url->movie_id)){
				$menu_items [] =  array(
					GuiMenuItemDef::is_separator => true,);
				$menu_items[] = array(
					'caption' => 'Выделить (Select)',
					'params' => UserInputHandlerRegistry::create_action($this, 'select'),
					'icon_url' => 'plugin_file://icons/s_select.png',
				);
				$menu_items[] = array(
					'caption' => 'Снять выделение (Clear)',
					'params' => UserInputHandlerRegistry::create_action($this, 'unselect'),
					'icon_url' => 'plugin_file://icons/s_unselect.png',
				);
			}
			if (($user_input->selected_media_url != 'addLocalTorrent')
				&&($class_name != 'TorrServer')
				&&($class_name != 'PeerflixServer')
				&&($class_name != 'Transmission')
				&&($class_name != 'TransmissionUPnP')
			){
				$menu_items [] =  array(
					GuiMenuItemDef::is_separator => true,);
				$add_params['action'] = 'background_actions';
				$add_params['indiClass'] = 'SmartConfig';
				$menu_items[] = array(
					GuiMenuItemDef::caption => 'Задать бекграунд',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', $add_params),
					GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_add_background')
				);
				if (file_exists(HD::get_data_path() . "/icons/" . self::ID . "_bg.jpg")){
					$add_params['action'] = 'background_actions';
					$add_params['indiClass'] = 'SmartConfig';
					$add_params['del'] = true;
					$menu_items[] = array(
						GuiMenuItemDef::caption => 'Удалить бекграунд',
						GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', $add_params),
						GuiMenuItemDef::icon_url => SmartConfig::getPluginIco('s_del_background')
					);
				}
			}
			return ActionFactory::show_popup_menu($menu_items);
		}
		if ($user_input->control_id == 'classSetupTransmission'){
			$defs = array();
			hd_silence_warnings();
			return Transmission::setup($defs, $user_input);
		}
		if ($user_input->control_id == 'classAction'){
			$defs = array();
			if ((($user_input->selected_media_url =='dummy')||
				($user_input->selected_media_url =='addLocalTorrent')||
				(!isset($user_input->selected_media_url))
			)&&($user_input->action != 'sort'))return null;
			$parent_media_url = MediaURL::decode($user_input->parent_media_url);
			$class_name = $parent_media_url->class_name;
			hd_silence_warnings();
			$select_url = $this->select_url;
			$this->select_url = array();
			return $class_name::classAction ($defs, $user_input, $select_url);
		}
		if ($user_input->control_id == 'timer'){
			$parent_media_url = MediaURL::decode($user_input->parent_media_url);
			return ActionFactory::invalidate_folders(array($user_input->parent_media_url));
		}
        if ($user_input->control_id == 'add_action'){
            if (!isset($user_input->selected_media_url))
                return null;
			if ($user_input->selected_media_url == 'addLocalTorrent')
				return UserInputHandlerRegistry::create_action($this, 'addLocalTorrent');
			if ($user_input->selected_media_url == 'dummy')
				return UserInputHandlerRegistry::create_action($this, 'classSetupTransmission');
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			if (isset($selected_media_url->movie_id)){
				$i=0;
				HD::asyncExec('proc_close');
				do {
					$str = Transmission::actionGetTorrentFileList($selected_media_url->movie_id);
					$i++;
					usleep(50000);
				} while (($i < 100)&&($str==false));
			}
			if (isset($selected_media_url->id))
					return null;
			$this->select_url = array();
			self::$counter=0;
            return ActionFactory::open_folder();
		}
        if ($user_input->control_id == 'addLocalTorrent'){
			$media_url = MediaURL::encode (
				array(
					'screen_id'     => 'file_list',
					'save_file'		=> array(	
						'action' 		=> 'addLocalTorrentTransmission',
						'extension' 	=> 'torrent'
					),
				)
			);
			return ActionFactory::open_folder($media_url,'Выберите .torrent файл:');
        }

        return null;
    }

    ///////////////////////////////////////////////////////////////////////

    public function get_all_folder_items(MediaURL $media_url, &$plugin_cookies){
        $this->vod->folder_entered($media_url, $plugin_cookies);
		$view_idx = isset($plugin_cookies->{"screen.".self::ID.".view_idx"}) ? $plugin_cookies->{"screen.".self::ID.".view_idx"} : 0;
        $items = array();
		if (isset($media_url->movie_id))
			$torrentObj = Transmission::actionGetTorrentFileList($media_url->movie_id);
		else
			$torrentObj = Transmission::actionGetTorrentList();
		if ($this->counter2 == 1)
			Transmission::actionGetSessionInfo();
		if ($torrentObj == true){
			$this->torrentArr = $this->torrentItemsArr = array();
			// if (isset($torrentObj->arguments->torrents)){
				if (isset($media_url->movie_id)){
					if (isset($torrentObj->arguments->torrents))
					foreach ($torrentObj->arguments->torrents[0]->files as $id => $file){
						$view_item_params = array();
						$color = 15; $starred = false; $percent = 0;
						$path_parts = pathinfo($file->name);
						$caption = $path_parts['basename'];
						$detailed_icon = 'plugin_file://icons/pixel.png';
						
						$detailed_info = '';
						$detailed_info .= '||Загружено: ';
						
						if (isset($file->bytesCompleted))
							$percent = round((floatval($file->bytesCompleted) / floatval($file->length) ) * 100);
						$detailed_info .=  $percent . '%';
						
						if (isset($file->bytesCompleted))
							$detailed_info .= '|' . HD::readableBytes($file->bytesCompleted);
						if (isset($file->length))
							$detailed_info .= '|из ' . HD::readableBytes($file->length);
						
						$icon_path = 'plugin_file://icons/file4.png';
						foreach($torrentObj->arguments->torrents[0]->priorities as $idx => $vdx)
							$priorities[$idx] = $vdx;
						if (!isset($torrentObj->arguments->torrents[0]->fileStats[$id]->wanted)){
							$icon_path = 'plugin_file://icons/file1.png';
							$detailed_info .= '||Приоритет:|не загружать';
						}else if (isset($priorities[$id])){
							if ($priorities[$id]== 1){
								$icon_path = 'plugin_file://icons/file2.png';
								$detailed_info .= '||Приоритет:|высокий';
							}
							if ($priorities[$id] == -1){
								$icon_path = 'plugin_file://icons/file3.png';
								$detailed_info .= '||Приоритет:|низкий';
							}
						}else{
							$icon_path = 'plugin_file://icons/file4.png';
							$detailed_info .= '||Приоритет:|нормальный';
						}
						if ($percent == 100)
							$icon_path = 'plugin_file://icons/file.png';
						
						$view_item_params[ViewItemParams::icon_path] = $icon_path;
						$view_item_params[ViewItemParams::item_detailed_info] = $detailed_info;
						$view_item_params[ViewItemParams::item_detailed_icon_path] = $detailed_icon;
						if(defined('ViewItemParams::item_extra_info')){
							$extra_item = $percent == 100 ?
							array('type' => 'icon',
							'url' => 'plugin_file://icons/watched.png',
							'alt' => '100%') :
							array('type' => 'text', 'color' => '10', 'text' => "$percent%");
							$item_extra_info = array(
							'items' => array(
								array('type' => 'gap', 'width' => 40),
								$extra_item,
							));
							$view_item_params[ViewItemParams::item_extra_info] = json_encode($item_extra_info);
							$view_item_params[ViewItemParams::item_caption_dy]=-10;
							$view_item_params[ViewItemParams::item_caption_sel_dy]=-10;
						}
						if(defined('ViewItemParams::item_sticker')){
							$txt = '';
							if ($view_idx == 1)
								$txt = HD::readableBytes($file->bytesCompleted) . " из " . HD::readableBytes($file->length);
							$view_item_params[ViewItemParams::item_sticker] = json_encode(self::get_sticker($percent, $txt));
						}
						$arr['id'] = $id;
						$arr['data']['caption'] = $caption;
						$arr['data']['movie_id'] = $media_url->movie_id;
						$arr['data']['percent'] =  $percent;
						$arr['data']['file_name'] =  $file->name;
						$arr['data']['downloadDir'] =  $torrentObj->arguments->torrents[0]->downloadDir;
						$arr['data']['hashString'] =  $torrentObj->arguments->torrents[0]->hashString;
						$arr['data']['poster_url'] =  'plugin_file://icons/Transmission.png';
						$arr['data']['description'] = 'Transmission';
						$arr['data']['key'] = $id;
						if (!isset($torrentObj->arguments->torrents[0]->fileStats[$id]->wanted))
							$arr['data']['wanted'] = 0;
						else
							$arr['data']['wanted'] = 1;
						$mUrl = self::get_media_url_str($media_url->class_name, $arr);
						if (isset($this->select_url[$mUrl]))
							$color = 18;
						$view_item_params[ViewItemParams::item_caption_color] = $color;
						$items2[] = $caption;
						$this->torrentItemsArr[] = $id;
						$items1[] = array(
							PluginRegularFolderItem::media_url => $mUrl,
							PluginRegularFolderItem::caption => $caption,
							PluginRegularFolderItem::starred => $starred,
							PluginRegularFolderItem::view_item_params => $view_item_params
						);
					}
					if (isset($items2)){
						$flipped = array_flip($items2);
						ksort($flipped);
						foreach ($flipped as $v)
							$items[] = $items1[$v];
					}
				}else{
					$allDload = $allUpload = '';
					$i = 0;
					if (isset($torrentObj->arguments->torrents))
					foreach ($torrentObj->arguments->torrents as $key => $torrent){
						$view_item_params = array();
						$color = 15; $starred = false;
						$rateDownload = $rateUpload = $percent = 0;
						$caption = $torrent->name;
						$detailed_icon = 'plugin_file://icons/pixel.png';
						if (isset(Transmission::$sessionInfo['alt_speed_enabled']))
							$detailed_icon = 'plugin_file://icons/s_tortuga.png';
						$detailed_info = '';// . implode( ' ', HD::mb_str_split($caption, 23));
						$detailed_info .= '||Загружено: ';
						if (isset($torrent->percentDone)){
							$percent = round($torrent->percentDone * 100);
							$detailed_info .=  $percent . '%';
						}
						if (isset($torrent->downloadedEver))
							$detailed_info .= '|' . HD::readableBytes($torrent->downloadedEver);
						if (isset($torrent->sizeWhenDone))
							$detailed_info .= '|из ' . HD::readableBytes($torrent->sizeWhenDone);
						if (isset($torrent->rateDownload)){
							$rateDownload = HD::readableBytes($torrent->rateDownload) . '/s';
							$detailed_info .= '||Скорость загрузки:|' . $rateDownload;
							$allDload = HD::bigSum($allDload, $torrent->rateDownload);
						}
						if ($torrent->eta != '-1')
						$detailed_info .= '||Осталось:|' . HD::sec_format_duration($torrent->eta);
						if (isset($torrent->peersSendingToUs)){
							$detailed_info .= '||Пиры (загрузка):|'. $torrent->peersSendingToUs .' из '. $torrent->peersConnected;
						}
						$detailed_info .= '||Роздано: ';
						if ((isset($torrent->uploadRatio))&&($torrent->uploadRatio != '-1'))
							$detailed_info .= '(ratio '. round($torrent->uploadRatio, 2) .')';
						if (isset($torrent->uploadedEver))
							$detailed_info .= '|' . HD::readableBytes($torrent->uploadedEver);
						else
							$detailed_info .= '|n/a';
						if (isset($torrent->rateUpload)){
							$rateUpload = HD::readableBytes($torrent->rateUpload) . '/s';
							$detailed_info .= '||Скорость отдачи:|' . HD::readableBytes($torrent->rateUpload) . '/s';
							$allUpload = HD::bigSum($allUpload, $torrent->rateUpload);
						}			
						
						if (isset($torrent->peersGettingFromUs)){
							$detailed_info .= '||Пиры (отдача):|'. $torrent->peersGettingFromUs .' из '. $torrent->peersConnected;
						}
						if (isset($torrent->recheckProgress)){
							$percent =  round($torrent->recheckProgress * 100);
							$detailed_info .= '||Проверка торрента:|'. $percent .'%';
						}
						if (isset($torrent->errorString)){
							$detailed_info .= '||Ошибка торрента:|'. $torrent->errorString;
						}
						$icon_path = 'plugin_file://icons/00.png';
						$this->torrentArr[] = $torrent->id;
						if (isset($torrent->status)){
							$icon_path = 'plugin_file://icons/'.$torrent->status.'.png';
							if ($torrent->status == 0)
								$detailed_info .= '||Состояние:|пауза';
							else if ($torrent->status == 1)
								$detailed_info .= '||Состояние:|ожидание проверки';
							else if ($torrent->status == 2)
								$detailed_info .= '||Состояние:|проверка';
							else if ($torrent->status == 3)
								$detailed_info .= '||Состояние:|ожидание';
							else if ($torrent->status == 4)
								$detailed_info .= '||Состояние:|загрузка';
							else if ($torrent->status == 5)
								$detailed_info .= '||Состояние:|ожидание раздачи';
							else if ($torrent->status == 6)
								$detailed_info .= '||Состояние:|раздача';
							else if ($torrent->isFinished == 1){
								$detailed_info .= '||Состояние:|завершен';
								$icon_path = 'plugin_file://icons/7.png';
							}else if ($torrent->isStalled == 1)
								$detailed_info .= '||Состояние:|приостановлен';
						}else if ((isset($torrent->percentDone))&&($torrent->percentDone == 1)){
							$detailed_info .= '||Состояние:|завершен';
							$icon_path = 'plugin_file://icons/7.png';
						}else if ((!isset($torrent->percentDone))||($torrent->percentDone != 1)){
							$detailed_info .= '||Состояние:|пауза';
							$icon_path = 'plugin_file://icons/1.png';
						}
						
						if (isset($torrent->addedDate))
							$detailed_info .= '||Добавлен:|'. date('d.m.Y H:i:s', $torrent->addedDate + HD::date_time());
						$description = 'Transmission';

						$view_item_params[ViewItemParams::icon_path] = $icon_path;
						$view_item_params[ViewItemParams::item_detailed_info] = $detailed_info;
						$view_item_params[ViewItemParams::item_detailed_icon_path] = $detailed_icon;
						if(defined('ViewItemParams::item_extra_info')){
							$extra_item = $percent == 100 ?
							array('type' => 'icon',
							'url' => 'plugin_file://icons/watched.png',
							'alt' => '100%') :
							array('type' => 'text', 'color' => '10', 'text' => "$percent%");
							$item_extra_info = array(
							'items' => array(
								array('type' => 'gap', 'width' => 40),
								$extra_item,
							));
							$view_item_params[ViewItemParams::item_extra_info] = json_encode($item_extra_info);
							$view_item_params[ViewItemParams::item_caption_dy]=-10;
							$view_item_params[ViewItemParams::item_caption_sel_dy]=-10;
						}
						if(defined('ViewItemParams::item_sticker')){
							$txt = '';
							if ($view_idx == 1)
								$txt = "D: $rateDownload * U: $rateUpload";
							$view_item_params[ViewItemParams::item_sticker] = json_encode(self::get_sticker($percent, $txt));
						}
						$arr['movie_id'] = $torrent->id;
						$arr['data']['caption'] = $caption;
						$arr['data']['poster_url'] =  $detailed_icon;
						$arr['data']['description'] = $description;
						$arr['data']['hashString'] = $torrent->hashString;
						$arr['data']['key'] = $key;
						$mUrl = self::get_media_url_str($media_url->class_name, $arr);
						if (isset($this->select_url[$mUrl]))
							$color = 18;
						$view_item_params[ViewItemParams::item_caption_color] = $color;
						if (self::$sort == 0){
							if (isset($torrent->queuePosition))
								$n = (intval($torrent->queuePosition) + 1);
							else
								$n = 1;
						}else if (self::$sort == 1)
							$n = $caption;
						else if (self::$sort == 2)
							$n = $torrent->addedDate;
						else
							$n = $i;
						if (isset($items[$n]))
							$n = $n + 1;
						$items[$n] = array(
							PluginRegularFolderItem::media_url => $mUrl,
							PluginRegularFolderItem::caption => $caption,
							PluginRegularFolderItem::starred => $starred,
							PluginRegularFolderItem::view_item_params => $view_item_params
						);
						$i++;
					}
					ksort($items);
					if (self::$sort == 2)
						$items = array_reverse($items);
						
					$items = array_values($items);
					
					$dLs = HD::readableBytes($allDload);
					$ULs = HD::readableBytes($allUpload);					
					$detailed_info ='||Загрузить торрент файл| в Transmission c локального диска или по сети';
					if (isset(Transmission::$sessionInfo['download_dir_free_space'])){
						$downloadDirFreeSpace = HD::readableBytes(Transmission::$sessionInfo['download_dir_free_space']);
						$detailed_info .= '||Свободное место:|' . $downloadDirFreeSpace;
					}
					$detailed_info .= '||Transmission:|'.$this->showIp;
					if (isset(Transmission::$sessionInfo['version']))
						$detailed_info .='|ver. ' . Transmission::$sessionInfo['version'];
					$detailed_info .= "||D: $dLs/s||U: $ULs/s";
					$view_item_params[ViewItemParams::icon_path] = 'plugin_file://icons/add.png';
					$view_item_params[ViewItemParams::item_detailed_info] = $detailed_info;
					$view_item_params[ViewItemParams::item_caption_color] = 10;
					if (defined('FONT_SIZE_LARGE') === true)
						$view_item_params[ViewItemParams::item_caption_font_size] = FONT_SIZE_LARGE;
					if(defined('ViewItemParams::item_extra_info')){
						$extra_item = array('type' => 'text', 'color' => '14', 'text' => "D:$dLs/s U:$ULs/s");
						$item_extra_info = array(
						'items' => array(
							array('type' => 'gap', 'width' => 10),
							$extra_item,
						));
						$view_item_params[ViewItemParams::item_extra_info] = json_encode($item_extra_info);
					}
					$addLocalTorrent = array(
						PluginRegularFolderItem::media_url => 'addLocalTorrent',
						PluginRegularFolderItem::caption => 'Загрузить',
						PluginRegularFolderItem::view_item_params => $view_item_params
					);
					if (count($items) > 0)
						array_unshift($items, $addLocalTorrent);
					else
						$items[] = $addLocalTorrent;
				}
			// }
		}else{
			self::$counter++;
			$this->select_url = array();
			$this->showIp = Transmission::getIp();
			$counter = HD::sec_format_duration(self::$counter);
			$caption = "Ожидание ответа от Transmission Прошло: $counter";
			$item_detailed_info = "||Transmission|{$this->showIp}||Ожидание ответа от Transmission | Прошло: $counter";
			$icon_path = 'plugin_file://icons/s_transmission.png';
			$detailed_icon = 'plugin_file://icons/Transmission.png';
			$color = 15;
			if (self::$counter > 60){
				$caption = "Transmission {$this->showIp} не отвечает! Прошло: $counter";
				$item_detailed_info = "||Внимание Transmission не запущен или не отвечает|Перезапустите Transmission по адресу {$this->showIp} или измените IP адрес Transmission | Прошло: $counter";
				$icon_path = 'plugin_file://icons/s_0.png';
				$detailed_icon = 'plugin_file://icons/0.png';
				$color = 21;
			}
			$items[] = array(
				PluginRegularFolderItem::media_url => 'dummy',
				PluginRegularFolderItem::caption => $caption,
				PluginRegularFolderItem::view_item_params => array(
					ViewItemParams::icon_path => $icon_path,
					ViewItemParams::item_detailed_icon_path => $detailed_icon,
					ViewItemParams::item_detailed_info => $item_detailed_info,
					ViewItemParams::item_caption_color => $color,
				)
			);
		}
		$this->counter2++;
		if ($this->counter2 == 11)
			$this->counter2 = 0;
        return $items;
    }
	public static function get_sticker($prsnt, $txt){
		$q = round($prsnt * 10, -2);
		$items[] = Sticker::item(
			Sticker::geom($q + 20, 65), Sticker::icon("plugin_file://icons/bar/$q.png")
		);
		$strlen = iconv_strlen($txt,'UTF-8');
		$items[] = Sticker::item(
			Sticker::geom((1040 + ($strlen * 20)), 45), Sticker::text($txt, 14));
		
        return Sticker::sticker($items);
    }
	private function get_folder_views(){
		$background_path = SmartConfig::getPluginIco(self::ID . '_bg');
		$arr[0][PluginRegularFolderView::async_icon_loading] = true;
		$arr[0][PluginRegularFolderView::timer] = array(
		GuiTimerDef::delay_ms =>  1000);
		$arr[0][PluginRegularFolderView::view_params][ViewParams::num_cols] = 1;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::num_rows]= 7;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_details] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::paint_item_info_in_details] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_auto_line_break] = true;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_title_color] = 10;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_text_color] = 15;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_font_size] = (HD::getItemStr('detailedInfoFontSize') != '') ? HD::getItemStr('detailedInfoFontSize') : FONT_SIZE_SMALL;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_path] = $background_path;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_order] = 0;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_height] = 1080;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::background_width] = 1920;
		$arr[0][PluginRegularFolderView::view_params][ViewParams::optimize_full_screen_background] = true;
		
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_layout] = HALIGN_LEFT;
        $arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_valign] = VALIGN_CENTER;
        $arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_dx] = 10;
        $arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_dy] = -5;
        $arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_caption_dx] = 90;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_width] = 85;
		$arr[0][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_height] = 85;
		
		$arr[0][PluginRegularFolderView::not_loaded_view_item_params]= array ();
		
		
		////////////////////////////////////////////////////////////////////////////////////////////
		$arr[1][PluginRegularFolderView::async_icon_loading] = true;
		$arr[1][PluginRegularFolderView::timer] = array(GuiTimerDef::delay_ms => 1000);
		$arr[1][PluginRegularFolderView::view_params][ViewParams::num_cols] = 1;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::num_rows]= 7;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::paint_details] = false;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::item_detailed_info_font_size] = (HD::getItemStr('detailedInfoFontSize') != '') ? HD::getItemStr('detailedInfoFontSize') : FONT_SIZE_SMALL;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_path] = $background_path;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_order] = 0;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_height] = 1080;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::background_width] = 1920;
		$arr[1][PluginRegularFolderView::view_params][ViewParams::optimize_full_screen_background] = true;
		
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_layout] = HALIGN_LEFT;
        $arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_valign] = VALIGN_CENTER;
        $arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_dx] = 10;
        $arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_dy] = -5;
        $arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::item_caption_dx] = 90;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_width] = 85;
		$arr[1][PluginRegularFolderView::base_view_item_params][ViewItemParams::icon_height] = 85;
		
		$arr[1][PluginRegularFolderView::not_loaded_view_item_params]= array ();
		////////////////////////////////////////////////////////////////////////////////////////////
		
		
        return $arr;
    }
    public function get_archive(MediaURL $media_url){
        return $this->vod->get_archive($media_url);
    }
	
}

?>
