<?php
class PeerflixServer
{
	static $do_cmd = null;
	static $peerflixServerIp = null;
	static $peerflixServerItems = null;
	public static function getIp(){
        if (null === self::$peerflixServerIp){
			$peerflixServerIp = (HD::getItemStr('peerflixServerIp', 1) != '') ? HD::getItemStr('peerflixServerIp', 1) : false;
			if (($peerflixServerIp == '')&&(self::getInstallPeerflixServer() == true)){
				$peerflixServerIp = 'http://127.0.0.1:9000';
				HD::saveItemStr('peerflixServerIp', $peerflixServerIp, true);
				HD::saveItemStr('dunePeerflixServerIp', 1, true);
			}
            self::$peerflixServerIp = $peerflixServerIp;
        }
        return self::$peerflixServerIp;
    }
	public static function setPeerflixServerIp($inputStr){
		$path_parts = parse_url($inputStr);
		if (isset($path_parts['host']))
			$peerflixServerIp = $path_parts['host'];
		else if (isset($path_parts['path']))
			$peerflixServerIp = $path_parts['path'];
		$ip_address = HD::get_ip_address();
		if (($peerflixServerIp == '127.0.0.1')||($ip_address == $peerflixServerIp)){
			if (self::getInstallPeerflixServer() != true)
				return array(
					'caption' => 'Error!',
					'descr' => "IP адрес Peerflix-Server: $peerflixServerIp указан не верно. Локальный Peerflix-Server не найден. Необходима установка Peerflix-Server на это устройство или указывайте IP адрес другого устройства в сети с установленным Peerflix-Server."
				);
			$peerflixServerIp = '127.0.0.1';
		}else if ($peerflixServerIp == ''){
			if (self::getIp() != ''){
				if (HD::saveItemStr('peerflixServerIp', $peerflixServerIp, true) == true){
					self::$peerflixServerIp = $peerflixServerIp;
					HD::saveItemStr('dunePeerflixServerIp', 0, true);
					return array(
						'caption' => 'Сохранено',
						'descr' =>  "Удален IP адрес Peerflix-Server: " . self::getIp()
					);
				}else
					return array(
					'caption' => 'Error!',
					'descr' => "Сохранение не удалось"
					);
			}else
				return array(
					'caption' => 'Error!',
					'descr' => "IP адрес Peerflix-Server не указан. Укажите IP адрес устройства с установленным Peerflix-Server."
				);
		}
		if (isset($path_parts['port']))
			$peerflixServerIp .= ':' . $path_parts['port'];
		else
			$peerflixServerIp .= ':9000';
		if (isset($path_parts['scheme']))
			$peerflixServerIp = $path_parts['scheme'] .  '://' . $peerflixServerIp;
		else
			$peerflixServerIp = 'http://' . $peerflixServerIp;
		if (HD::saveItemStr('peerflixServerIp', $peerflixServerIp, true) == true){
			$peerflixServerHistory = HD::getItemsArr('peerflixServerHistory');
			$peerflixServerHistory = array_reverse($peerflixServerHistory);
			$peerflixServerHistory[$peerflixServerIp] = $peerflixServerIp;
			$peerflixServerHistory = array_reverse($peerflixServerHistory);
			$peerflixServerHistory = array_slice($peerflixServerHistory, 0, 10);
			HD::saveItemsArr('peerflixServerHistory', $peerflixServerHistory);
			if (isset($path_parts['host']))
				$host = $path_parts['host'];
			else if (isset($path_parts['path']))
				$host = $path_parts['path'];
			$dunePeerflixServerIp = 0;
			if (preg_match("/(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})/", $host, $m))
				if (HD::isDomainAvailible("http://$host/cgi-bin/do?cmd=status") == true)
					$dunePeerflixServerIp = 1;
			HD::saveItemStr('dunePeerflixServerIp', $dunePeerflixServerIp, true);
			self::$peerflixServerIp = $peerflixServerIp;
			return array(
				'caption' => 'Сохранено',
				'descr' => "IP Peerflix-Server: $peerflixServerIp",
			);
		}else
			return array(
				'caption' => 'Error!',
				'descr' => "IP адрес Peerflix-Server: $peerflixServerIp cохранить не удалось",
			);
	}
	
	public static function getInstallPeerflixServer($obj=null){
		$configPath[] = '/opt/etc/.config/peerflix-server/config.json';
		$configPath[] = '/flashdata/plugins_data/PeerflixServer/home/.config/peerflix-server/config.json';
		if ($obj == true){
			foreach ($configPath as $v){
				if (file_exists($v)){
					if (file_put_contents ($v, json_encode($obj)) !== false){
						return true;
					}
				}
			}
		}else{
			foreach ($configPath as $v){
				if (file_exists($v)){
					return json_decode (file_get_contents ($v));
				}
			}
		}
		return false;
	}
	public static function getLocalPeerflixServer(){
		if (self::getIp() != 'http://127.0.0.1:9000')
			return false;
		return self::getInstallPeerflixServer();
	}
	public static function getOnlineStatusServer(){
		$peerflixServerIp = self::getIp();
		if ($peerflixServerIp != ''){
			$cmd = HD::isDomainAvailible($peerflixServerIp);//$cmd = HD::isServerAvailable($peerflixServerIp);
			if($cmd == true)
				return $cmd;
		}
		return false;
	}
	public static function getSlavePeerflixServerApp($host){
		if (HD::isDomainAvailible("http://$host/cgi-bin/plugins/PeerflixServer/service_api?cmd=peerflix_status") == true)
			return 'PeerflixServer';
		else
			return 'Entware';
	}
	public static function getSlavePeerflixServer(){
		$dunePeerflixServerIp = (HD::getItemStr('dunePeerflixServerIp',true) !='') ? HD::getItemStr('dunePeerflixServerIp', true) : 0;
		if (($dunePeerflixServerIp == 1)||(self::getLocalPeerflixServer() == true))
			return true;
		return false;
	}
	public static function checkPeerflixServerKill(){
		if (self::getInstallPeerflixServer() == true){
			if (self::getOnlineStatusServer() == true){
				$path_parts = parse_url(self::getIp());
				$cmd = 'wget -O - "http://127.0.0.1/cgi-bin/plugins/Entware/service_api?cmd=peerflix_stop"';
				echo HD::asyncExec($cmd);
				HD::asyncExec('proc_close');
			}
		}
	}
	
	public function restartPeerflixServer($defs, $user_input){
		hd_restore_warnings();
		$params['counter'] = 1;
		$params['action'] = 'restart';
		if (isset($user_input->counter))
			$params['counter'] = $user_input->counter + 1;
		if (!isset($user_input->peerflixActionPerformed)){
			$peerflixServerIp = self::getIp();
			$path_parts = parse_url($peerflixServerIp);
			if ((self::getLocalPeerflixServer() == true)&&
			(TorrServer::getLocalTorrServer() == true)){
				if (HD::get_platform_kind() == '87xx'){
					//HD::check_transmission_kill();
					TorrServer::checkTorrServerKill();
					echo '---';
				}
			}
			$cmdAsyncExec = 'wget -O - "http://'.$path_parts['host'].'/cgi-bin/plugins/'.self::getSlavePeerflixServerApp($path_parts['host']).'/service_api?cmd=peerflix_restart"';
			$result = HD::asyncExec($cmdAsyncExec);
		}else
			$result = true;
		if ($result == true){
			if (self::getOnlineStatusServer() == true){
				HD::asyncExec('proc_close');
				$params = null;
				$params['counter'] = $user_input->counter + 1;
				$action = null;
			}else{
				$params['peerflixActionPerformed'] = 1;
				
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $params);
			}
		}else
			$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $params);
		ControlFactory::add_smart_label($defs, '', '<text size="small">Прошло: '.HD::sec_format_duration($params['counter'])." сек. </text>");
		$attrs['timer'] = ActionFactory::timer(1000);
		$attrs['actions'] = array(GUI_EVENT_TIMER => ActionFactory::close_dialog_and_run($action));
		return  ActionFactory::show_dialog('Перезапуск Peerflix-server', $defs, true, 0, $attrs);
	}
	
	public function startPeerflixServer($defs, $user_input){
		hd_restore_warnings();
		$params['counter'] = 1;
		if(isset($user_input->unlock))
			$params['unlock'] = true;
		if (isset($user_input->counter))
			$params['counter'] = $user_input->counter + 1;
		if (!isset($user_input->peerflixActionPerformed)){
			$peerflixServerIp = self::getIp();
			$path_parts = parse_url($peerflixServerIp);
			if ((self::getLocalPeerflixServer() == true)&&
			(TorrServer::getLocalTorrServer() == true)){
				if (HD::get_platform_kind() == '87xx'){
					//HD::check_transmission_kill();
					TorrServer::checkTorrServerKill();
					echo '---';
				}
			}
			$cmdAsyncExec = 'wget -O - "http://'.$path_parts['host'].'/cgi-bin/plugins/'.self::getSlavePeerflixServerApp($path_parts['host']).'/service_api?cmd=peerflix_start"';
			$result = HD::asyncExec($cmdAsyncExec);
		}else
			$result = true;
		if ($result == true){
			if (self::getOnlineStatusServer() == true){
				HD::asyncExec('proc_close');
				
				$params['counter'] = $user_input->counter + 1;
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $params);
			}else{
				$params['peerflixActionPerformed'] = 1;
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $params);
			}
		}else
			$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $params);
		ControlFactory::add_smart_label($defs, '', '<text size="small">Прошло: '.HD::sec_format_duration($params['counter'])." сек. </text>");
		$attrs['timer'] = ActionFactory::timer(1000);
		$attrs['actions'] = array(GUI_EVENT_TIMER => ActionFactory::close_dialog_and_run($action));
		return  ActionFactory::show_dialog('Запуск Peerflix-server', $defs, true, 0, $attrs);
	}
	
	public function setup($defs, $user_input){
		hd_restore_warnings();
		$attrs['initial_sel_ndx'] = isset($user_input->initial_sel_ndx) ? $user_input->initial_sel_ndx : -1;
		$width = 1050;
		$peerflixServerIp = self::getIp();
		$cmd = self::getOnlineStatusServer();
		$slavePeerflixServer = self::getSlavePeerflixServer();
		$localPeerflixServer = self::getLocalPeerflixServer();
		$add_params = null;
		if (isset($user_input->class_name))
			$add_params['class_name'] = $user_input->class_name;
		if ((isset($user_input->allPeerflixDload))&&($user_input->selected_control_id == 'allPeerflixDload')){
			HD::saveItemStr('allPeerflixDload', $user_input->allPeerflixDload, true);
			return null;
		}
		if ((isset($user_input->addPeerflixServerInf))&&($user_input->selected_control_id == 'addPeerflixServerInf')){
			HD::saveItemStr('addPeerflixServerInf', $user_input->addPeerflixServerInf, true);
			return null;
		}
		if ((isset($user_input->action))&&($user_input->action == 'tmpFolder')){
			if (isset($user_input->tmp_dir)){
	
				if ($user_input->tmp_dir == 'def'){
					$localPeerflixServer->tmp = '/D/torrent-stream';
					$user_input->tmp_dir = "Не выбрано";
				}else
					$localPeerflixServer->tmp = $user_input->tmp_dir;
				if (self::getInstallPeerflixServer($localPeerflixServer) == true){
					if ($cmd == true)
						$params['action'] = 'restart';
					$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $params);
					return ActionFactory::show_title_dialog('Сохранено', $action, $user_input->tmp_dir);
				}else
					return ActionFactory::show_title_dialog('Сохранение не удалось');
			}
			$tmp_dir = $localPeerflixServer->tmp;
			if ($localPeerflixServer->tmp != '/D/torrent-stream')
				$tmp_dir = 'def';
			$tmp_ops['def'] = 'Выберите';
			foreach (HD::get_storage_list() as $obj){
				$path = '/tmp/mnt/storage/' . $obj->name;
				if (preg_match("|ext\d|", $obj->fs_type))
					$tmp_ops[$path] = $obj->name  . ' (' . HD::get_storage_size($path) .') ' . $obj->fs_type;
			}
			ControlFactory::add_multiline_label($defs, '', 'Выберите накопитель для закачки торрентов во временную папку. Он должен быть постоянно подключен к плееру и файловая система ext!', 8);
			ControlFactory::add_combobox($defs, $this, null,
				'tmp_dir', '',
				$tmp_dir, $tmp_ops, $width - 100, false, false
			);
			
			ControlFactory::add_vgap($defs, 30);
			
			$params['action']= 'tmpFolder';
			$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $params);
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'apply_subscription', 'Применить', 350, $action);
			return ActionFactory::show_dialog("Папка для временных файлов", $defs, true, $width);
		}
		if ((isset($user_input->action))&&(
			($user_input->action == 'stop')||
			($user_input->action == 'start')||
			($user_input->action == 'restart')
		)){
			$params['counter'] = 1;
			$params['action'] = $user_input->action;
			if ('stop' == $user_input->action)
				$peerflixCaption = 'Остановка Peerflix-server';
			if ('start' == $user_input->action)
				$peerflixCaption = 'Запуск Peerflix-server';
			if ('restart' == $user_input->action)
				$peerflixCaption = 'Перезапуск Peerflix-server';
			if (isset($user_input->counter))
				$params['counter'] = $user_input->counter + 1;
			if ((isset($user_input->action))&&(!isset($user_input->peerflixActionPerformed))){
				$path_parts = parse_url($peerflixServerIp);
				if ((self::getLocalPeerflixServer() == true)&&
				(TorrServer::getLocalTorrServer() == true)){
					if (HD::get_platform_kind() == '87xx'){
						//HD::check_transmission_kill();
						TorrServer::checkTorrServerKill();
						echo '---';
					}
				}
				$cmdAsyncExec = 'wget -O - "http://'.$path_parts['host'].'/cgi-bin/plugins/'.self::getSlavePeerflixServerApp($path_parts['host']).'/service_api?cmd=peerflix_'.$user_input->action.'"';
				$result = HD::asyncExec($cmdAsyncExec);
			}else
				$result = true;
			if ($result == true){
				if ($user_input->action == 'stop')
					$a = false;
				else
					$a = true;
				if (self::getOnlineStatusServer() == $a){
					HD::asyncExec('proc_close');
					$params = null;
					$params['counter'] = $user_input->counter + 1;
					$params['initial_sel_ndx'] = 3;
					$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $params);
				}else{
					$params['peerflixActionPerformed'] = 1;
					$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $params);
				}
			}else
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $params);
			ControlFactory::add_smart_label($defs, '', '<text size="small">Прошло: '.HD::sec_format_duration($params['counter'])." сек. </text>");
			$attrs['timer'] = ActionFactory::timer(1000);
			$attrs['actions'] = array(GUI_EVENT_TIMER => ActionFactory::close_dialog_and_run($action));
			return  ActionFactory::show_dialog($peerflixCaption, $defs, true, 0, $attrs);
		}	
		if ((isset($user_input->action))&&($user_input->action == 'setConnections')){
			if (isset($user_input->connections)){
				if ($user_input->connections == 0){
					if (isset($localPeerflixServer->connections))
						unset ($localPeerflixServer->connections);
					$user_input->connections = "Неограничено";
				}else
					$localPeerflixServer->connections = $user_input->connections;
				if (self::getInstallPeerflixServer($localPeerflixServer) == true){
					if ($cmd == true)
						$params['action'] = 'restart';
					$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $params);
					return ActionFactory::show_title_dialog('Сохранено', $action, "Максимальное количество пиров: " . $user_input->connections);
				}else
					return ActionFactory::show_title_dialog('Сохранение не удалось');
			}
			ControlFactory::add_multiline_label($defs, '', "Значение максимальное количество пиров влияет на скорость закачки торрента, но чем больше скорость закачки тем медленее стартует воспроизведение торрента на локальном плеере.", 10);
			
			if (isset($localPeerflixServer->connections))
				$connections = $localPeerflixServer->connections;
			else
				$connections = 0;
			$connections_ops[0] = "Неограничено";
			for ($i = 1; $i<51; $i++)
				$connections_ops[$i] = $i;
			ControlFactory::add_combobox($defs, $this, null,
				'connections', '',
				$connections, $connections_ops, $width - 100, false, false
			);
			ControlFactory::add_vgap($defs, 30);
			$add_params['action']= 'setConnections';
			$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'apply_subscription', 'Применить', 350, $action);
			return ActionFactory::show_dialog("Максимальное количество пиров", $defs, true, $width);
		}	
		if ((isset($user_input->action))&&($user_input->action == 'verify')){
			if ($localPeerflixServer->verify == true)
				$localPeerflixServer->verify = false;
			else
				$localPeerflixServer->verify = true;
			if (self::getInstallPeerflixServer($localPeerflixServer) == true){
				$params['initial_sel_ndx'] = 4;
				if ($cmd == true)
					$params['action'] = 'restart';
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $params);
				return ActionFactory::show_title_dialog('Сохранено', $action, $user_input->tmp_dir);
			}else
				return ActionFactory::show_title_dialog('Сохранение не удалось');
		}	
		if ((isset($user_input->action))&&($user_input->action == 'peerflixServerSearch')){
			$peerflixServerIp_ops = HD::isServerAvailable(null, '9000');
			if (count($peerflixServerIp_ops) > 0){
				ControlFactory::add_vgap($defs, -10);
				ControlFactory::add_smart_label($defs, "", 
						'<text size="small">Найдено: '. count($peerflixServerIp_ops) .'</text>'
					);
				ControlFactory::add_vgap($defs, -10);
				$add_params['control_id']= $user_input->control_id;
				$peerflixServerIp_ops[''] = "Выберите";
				ControlFactory::add_combobox($defs, $this, $add_params,
					'peerflixServerIp', '',
					'', $peerflixServerIp_ops, $width - 100, true, false
				);
				ControlFactory::add_vgap($defs, -10);
				ControlFactory::add_smart_label($defs, "", 
						'<text size="small">*Выберите нужный из списка если их несколько</text>'
					);
			}else{
				ControlFactory::add_multiline_label($defs, '', 'Запущенных Peerflix-Server в локальной сети не найденно, запустите Peerflix-Server на каком либо устройстве если же запущенный Peerflix-Server имеет не стандартный порт укажите "IP адрес:порт" вручную. ', 5);
				$gui_params['button_caption_centered'] = 1;
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id);
				ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_do', 'Ok', 300, $action, $gui_params);
			}
			return ActionFactory::show_dialog('Запущенные Peerflix-Server в локальной сети', $defs, true, $width, $attrs);
		}
		if ((isset($user_input->peerflixServerIp))&&(isset($user_input->action_type))){
			if ((isset($user_input->peerflixServerHistoryIp))&&($user_input->peerflixServerHistoryIp != 'na'))
				$user_input->peerflixServerIp = $user_input->peerflixServerHistoryIp;
			if ($user_input->peerflixServerIp == 'Укажите IP адрес (:порт - необязательно)')
				$user_input->peerflixServerIp = '';
			$sArr = self::setPeerflixServerIp ($user_input->peerflixServerIp);
			if ($sArr['caption'] == 'Error!'){
				$actions = UserInputHandlerRegistry::create_action($this, $user_input->control_id);
				return ActionFactory::show_title_dialog($sArr['caption'], $actions, $sArr['descr'], $width);
			}
			$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id);
			if ($user_input->action_type == 'confirm')
				return ActionFactory::close_dialog_and_run($action);
			else
				return $action;
		}
		if ($peerflixServerIp == ''){
			if (HD::get_platform_kind() == '87xx')
				$ipDescr = 'Что бы использовать локальный Peerflix-Server установите плагин Entware и установите в нем Peerflix-Server или у';
			else if (HD::get_platform_kind() == 'android')
				$ipDescr = 'Что бы использовать локальный Peerflix-Server установите плагин Peerflix-Server или у';
			else
				$ipDescr = 'У';
			$ipDescr .= "кажите IP адрес устройства с Peerflix-Server:";
			$peerflixServerIp = 'Укажите IP адрес (:порт - необязательно)';			
		}else
			$ipDescr = "IP адрес Peerflix-Server:";
		
		ControlFactory::add_vgap($defs, -10);
		ControlFactory::add_multiline_label($defs, '', $ipDescr, 5);
		ControlFactory::add_vgap($defs, -10);
		$add_params['control_id']= $user_input->control_id;
		ControlFactory::add_text_field(
			$defs, $this, $add_params,
			'peerflixServerIp', '',
			$peerflixServerIp, 0, 0, 0, 0, $width - 100, 1, 0
		);
		$peerflixServerHistory = HD::getItemsArr('peerflixServerHistory');
		if (count($peerflixServerHistory) > 0){
			$peerflixServerHistoryOps['na'] = 'Ранее использованные Peerflix-Server';
			foreach ($peerflixServerHistory as $k => $v)
				$peerflixServerHistoryOps[$k] = $k;
			$add_params['control_id']= $user_input->control_id;
			ControlFactory::add_vgap($defs, -10);
			ControlFactory::add_combobox($defs, $this, $add_params,
				'peerflixServerHistoryIp',
				'',
				'na', $peerflixServerHistoryOps,  $width - 100, true, false
			);
		}
		ControlFactory::add_vgap($defs, -10);
		$add_params_search['action']= 'peerflixServerSearch';
		ControlFactory::add_button_close(&$defs, $this, $add_params_search, $user_input->control_id, '', 'Найти запущенные Peerflix-Server', $width - 100);
		if ($peerflixServerIp != 'Укажите IP адрес (:порт - необязательно)'){
			$tt ='';
			if ($slavePeerflixServer == true)
				$tt = '<icon width="48" height="48">'.DuneSystem::$properties['install_dir_path'].'/icons/s_dune_logo.png</icon><icon width="20" height="48">'.DuneSystem::$properties['install_dir_path'].'/icons/pixel.png</icon>';
			if ($cmd == true){
				ControlFactory::add_smart_label($defs, 
				"", 
				$tt . '<text color="10" size="normal">Peerflix-server </text><icon width="115" height="25">'.DuneSystem::$properties['install_dir_path'].'/icons/online.png</icon>');
				if ($slavePeerflixServer == true){
					$add_params['action']= 'stop';
					ControlFactory::add_button_close(&$defs, $this, $add_params, $user_input->control_id, '', 'Остановить Peerflix-server', $width - 100);
					ControlFactory::add_vgap($defs, -10);
					$add_params['action']= 'restart';
					ControlFactory::add_button_close(&$defs, $this, $add_params, $user_input->control_id, '', 'Перезапустить Peerflix-server', $width - 100);
				}
			}else{
				ControlFactory::add_smart_label($defs, 
					"", 
					$tt . '<text color="8" size="normal">Peerflix-Server </text><icon width="115" height="25">'.DuneSystem::$properties['install_dir_path'].'/icons/offline.png</icon>'
				);
				if ($slavePeerflixServer == true){
					$add_params['action']= 'start';
					if ($localPeerflixServer->tmp != '/D/torrent-stream')
						ControlFactory::add_button_close(&$defs, $this, $add_params, $user_input->control_id, '', 'Запустить Peerflix-Server', $width - 100);
				}
			}
			if ($peerflixServerIp == 'http://127.0.0.1:9000'){
				if ($localPeerflixServer->tmp != '/D/torrent-stream'){
					ControlFactory::add_vgap($defs, -10);
					$add_params['action']= 'setConnections';
					ControlFactory::add_button_close(&$defs, $this, $add_params, $user_input->control_id, '', "Количество пиров [" . $localPeerflixServer->connections . "]", $width - 100);
					$verify = 'Проверка торрента (Выключено)';
					if ($localPeerflixServer->verify == true)
						$verify = 'Проверка торрента (Включено)';
					$add_params['action']= 'verify';
					ControlFactory::add_vgap($defs, -10);
					ControlFactory::add_button_close(&$defs, $this, $add_params, $user_input->control_id, '', $verify, $width - 100);
					
					ControlFactory::add_smart_label($defs, "", 
						'<text  size="small" color="10">Папка временных файлов Peerflix-server: </text><text color="15" size="small">'.HD::get_storage_size($localPeerflixServer->tmp).'</text>'
					);
					ControlFactory::add_vgap($defs, -35);
					ControlFactory::add_smart_label($defs, 
						'', 
						'<text color="10" size="tiny">' . $localPeerflixServer->tmp . '</text>'
					);
					$caption = 'Изменить расположение';
					ControlFactory::add_vgap($defs, -30);
				}else{
					ControlFactory::add_smart_label($defs,
						"", 
						'<text color="10">Папка временных файлов Peerflix-server: </text>'
					);
					$caption = 'Выберите расположение';
				}
				$add_params['action']= 'tmpFolder';
				ControlFactory::add_button_close(&$defs, $this, $add_params, $user_input->control_id, '', $caption, $width - 100);
				// ControlFactory::add_smart_label($defs, "", 
					// '<text size="tiny">*127.0.0.1 локальный Peerflix-Server установленный на этом плеере</text>'
				// );
			}
			$showOps[0] = 'Нет';
			$showOps[1] = 'Да';
			$add_params['control_id']= $user_input->control_id;
			ControlFactory::add_vgap($defs, -10);
			ControlFactory::add_multiline_label($defs, '', "Запускать докачку всех файлов торрента после остановки воспрозведения?", 2);				
			ControlFactory::add_vgap($defs, -10);
			$allPeerflixDload = (HD::getItemStr('allPeerflixDload',true) !='') ? HD::getItemStr('allPeerflixDload', true) : 0;
			ControlFactory::add_combobox($defs, $this, $add_params,
			'allPeerflixDload', '',
			$allPeerflixDload, $showOps, $width - 100, true, false);
			if (DuneSystem::$properties['plugin_name'] != 'torrent_center'){
				
				ControlFactory::add_vgap($defs, -30);
				ControlFactory::add_multiline_label($defs, '', "Добавлять обложку и описание в Peerflix-server?", 2);
				ControlFactory::add_vgap($defs, -10);
				$addPeerflixServerInf = (HD::getItemStr('addPeerflixServerInf', true) !='') ? HD::getItemStr('addPeerflixServerInf', true) : 0;
				ControlFactory::add_combobox($defs, $this, $add_params,
				'addPeerflixServerInf', '',
				$addPeerflixServerInf, $showOps, $width - 100, true, false);
			}
			
		}
		return ActionFactory::show_dialog('Настройки Peerflix-Server', $defs, true, $width, $attrs);
	}
	public static function getPopUpMenuItems ($selected_media_url, $parent_media_url){
		if (!is_object($parent_media_url))
			$parent_media_url = MediaURL::decode($parent_media_url);
		if (isset($selected_media_url->movie_id)){
			$menu_items[] = array(
				'caption' => 'Удалить из Peerflix-Server',
				'params' => array ('indiClass' => 'PeerflixServer', 'action' => 'peerflixServerActionRem'),
				'icon_url' => 'plugin_file://icons/s_0.png'
			);
			$menu_items[] = array(
				'caption' => 'Задать обложку и описание',
				
				'params' => array ('indiClass' => 'SmartConfig', 'action' => 'addItemInfo'),
				'icon_url' => 'plugin_file://icons/s_info.png'
			);
			$menu_items[] = 'is_separator';
		}
		if (isset($selected_media_url->playback_url)){
			
			$menu_items[] = array(
				'caption' => 'Большие файлы в начало списка',
				'params' => array ('action' => 'gbSortFolders'),
				'icon_url' => 'plugin_file://icons/s_gbSortFolders.png'
			);
			if ($selected_media_url->file_info->selected == '')
				$menu_items[] = array(
					'caption' => 'Запустить закачку этого файла',
					'params' => array ('indiClass' => 'PeerflixServer', 'action' => 'allPirflixFileStartStop', 'allPirflixFileAction' =>  'start'),
					'icon_url' => 'plugin_file://icons/s_download.png'
				);
			else
				$menu_items[] = array(
					'caption' => 'Остановить закачку этого файла',
					'params' => array ('indiClass' => 'PeerflixServer', 'action' => 'allPirflixFileStartStop', 'allPirflixFileAction' =>  'stop'),
					'icon_url' => 'plugin_file://icons/s_stop.png'
				);

		}
		$menu_items[] = 'is_separator';
		if ($parent_media_url->screen_id != 'vod_peerflixserver')
			$menu_items[] = array(
				'caption' => 'Перейти в Peerflix-Server',
				'params' => array ('indiClass' => 'PeerflixServer', 'action' => 'screenPeerflixServer'),
				'icon_url' => 'plugin_file://icons/s_peerflixserver.png'
			);
		if (self::getSlavePeerflixServer() == true){
			$menu_items[] = array(
				'caption' => 'Перезапуск сервера Peerflix-Server',
				'params' => array ('indiClass' => 'PeerflixServer', 'action' => 'restart'),
				'icon_url' => 'plugin_file://icons/s_restart.png'
			);
		}
		$menu_items[] = array(
			'caption' => 'Настройки Peerflix-Server',
			'params' =>  'classSetup',
			'icon_url' => 'plugin_file://icons/s_peerflixserver.png'
		);
		$menu_items[] = 'is_separator';
		return $menu_items;
	}
	public static function peerflixServerAddTorrent($path, $movie){
		$tmp = explode ('.', HD::get_ip_address());
		if ((!preg_match("|".$tmp[0]."|", self::getIp()))&&
			(!preg_match("|magnet:\?xt=|",$path))&&
			(!preg_match("|127\.0\.0\.1|", self::getIp()))
		)
			$hash = self::peerflixServerActionUpload('/tmp/www/temp.torrent');
		else
			$hash = self::peerflixServerActionAdd ($path);
		if ($hash == true){
			$addPeerflixServerInf = (HD::getItemStr('addPeerflixServerInf', true) !='') ? HD::getItemStr('addPeerflixServerInf', true) : 0;
			if ($addPeerflixServerInf == 1){
				$infoArr["title"] = $movie->name;
				$infoArr["original_title"] = $movie->name_original;
				$infoArr["poster_path"] = str_replace('http://127.0.0.1/cgi-bin/plugins/Bazinga3/do?img=', '', $movie->poster_url);
				$infoArr["overview"] = $movie->description;
				$infoArr["year"] = $movie->year;
				if (isset($movie->class_info['dbIDs']))
					$infoArr["dbIDs"] = $movie->class_info['dbIDs'];
				$peerflixServerInf = HD::getItemsArr('PeerflixServerInf');
				$peerflixServerInf[$hash] = json_encode($infoArr);
				HD::saveItemsArr('PeerflixServerInf', $peerflixServerInf);
			}
		}
		return $hash;
	}
	public function addPeerflixServerAction($defs, $user_input){
		hd_restore_warnings();
		$params['hash'] = $user_input->hash;
		$params['counter2'] = 1;
		if (isset($user_input->counter2))
			$params['counter2'] = $user_input->counter2 + 1;	
		ControlFactory::add_label($defs, '', "Прошло : " . HD::sec_format_duration($params['counter2']));

		if (isset($user_input->delPeerflixServerTorrent)){
			if (!isset($user_input->hash))
				return ActionFactory::show_title_dialog('Err!');
			PeerflixServer::peerflixServerActionRem($user_input->hash);
			return ActionFactory::show_title_dialog('Удалено');
		}
		if (isset($user_input->goPeerflixServerScreen)){
			$post_action = ActionFactory::invalidate_folders(array(VodPeerflixServerScreen::get_media_url_str('PeerflixServer')));
			if (isset($user_input->selected_media_url)){
				$selected_media_url = MediaURL::decode($user_input->selected_media_url);
				if (defined('PLUGIN_REPLACE_PATH_ACTION_ID') === true){
					PeerflixServer::actionGetTorrentList();
					$action = ActionFactory::replace_path($selected_media_url->windowCounter - 1, null, $post_action);
				}else
					$action = ActionFactory::launch_media_url('plugin_launcher://{name='.DuneSystem::$properties['plugin_name'].'}', ActionFactory::open_folder(VodPeerflixServerScreen::get_media_url_str('PeerflixServer'),'PeerflixServer'));
			}else
				$action = ActionFactory::launch_media_url('plugin_launcher://{name='.DuneSystem::$properties['plugin_name'].'}', ActionFactory::open_folder(VodPeerflixServerScreen::get_media_url_str('PeerflixServer'),'PeerflixServer'));
			return $action;
		}
		$jsd = PeerflixServer::peerflixServerActionGet($user_input->hash);
		if ($jsd == true){
			if (isset($user_input->counter)){
				$params['counter'] = $user_input->counter - 1;
				if ($user_input->counter == 0)
					$params['goPeerflixServerScreen'] = 1;
			}else
				$params['counter'] = 5;
		}
		$a_params['delPeerflixServerTorrent'] = 1;
		$a_params['hash'] = $user_input->hash;
		$a_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $a_params);
		ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'apply_subscription', 'Удалить', 300, $a_action);
		ControlFactory::add_vgap($defs, (-10));
		ControlFactory::add_smart_label($defs, "", '<text color="10" size="tiny">* удаляет из базы Peerflix-Server, кнопка Return оставляет в Peerflix-Server</text>');
		if (isset($user_input->counter)){
			ControlFactory::add_vgap($defs, (-30));
			ControlFactory::add_smart_label($defs,"", '<text color="18" size="tiny">Переход в Peerflix-Server через: </text><text color="15" size="tiny">'.$user_input->counter.' сек. </text>');
			ControlFactory::add_vgap($defs, (-40));
			ControlFactory::add_smart_label($defs,"", '<text color="18" size="tiny">Для добавления других .torrent файлов кнопка Return пульта ДУ.</text>');
		}
		$attrs['timer'] = ActionFactory::timer(1000);
		$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $params);
		$attrs['actions'] = array(GUI_EVENT_TIMER => ActionFactory::close_dialog_and_run($action));
		return  ActionFactory::show_dialog('Добавление', $defs, true, 1000, $attrs);
	}
	
	public function classAction ($defs, $user_input, $select_url = null){
		hd_restore_warnings();
		$caption = 'Error!';
		$msg = 'classAction: action';
		$post_action = null;
		$selected_media_url = (object)array();
		if (isset($user_input->selected_media_url))
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
		$parent_media_url = MediaURL::decode($user_input->parent_media_url);
		if ($user_input->action == 'screenPeerflixServer'){
			PeerflixServer::actionGetTorrentList();
			return ActionFactory::open_folder(VodPeerflixServerScreen::get_media_url_str($parent_media_url->class_name), $parent_media_url->class_name);
		}
		if ($user_input->action == 'getPeerflixServerHashInfo'){
			$params['action'] = $user_input->action;
			$params['indiClass'] = 'PeerflixServer';
			$params['hash'] = $user_input->hash;
			$params['counter'] = 1;
			if (isset($user_input->counter))
				$params['counter'] = $user_input->counter + 1;	
			ControlFactory::add_label($defs, '', "Прошло : " . HD::sec_format_duration($params['counter']));

			if (isset($user_input->delPeerflixServerTorrent)){
				PeerflixServer::peerflixServerActionRem($user_input->delPeerflixServerTorrent);
				return ActionFactory::show_title_dialog('Удалено');
			}
			if (isset($user_input->goToScreen)){
				if (!isset($selected_media_url->movie_id))
					return ActionFactory::invalidate_folders(array($user_input->parent_media_url));
				$mArr['movie_id'] = $selected_media_url->movie_id;
				$mArr['torrentId'] = $user_input->hash;
				$mArr['torrentClassName'] = 'PeerflixServer';
				$mArr['torrentSourseClassName'] = $selected_media_url->class_name;
				$mArr['poster_url'] = $selected_media_url->poster_url;
				$mArr['class_name'] = $selected_media_url->class_name;
				$mArr['torrent_id'] = $selected_media_url->torrent_id;
				$mArr['tType'] = $selected_media_url->tType;
				if (isset($selected_media_url->detailed_info))
					$mArr['detailed_info'] = $selected_media_url->detailed_info;
				if (isset($selected_media_url->description))
					$mArr['description'] = $selected_media_url->description;
				$mUrl = VodSeriesListScreen::get_media_url_str("PeerflixServer",$mArr);
				return ActionFactory::open_folder($mUrl, $selected_media_url->caption);	
			}
			$jsd = PeerflixServer::peerflixServerActionGet($user_input->hash);
			if ($jsd == true){
				if (isset($user_input->countdown)){
					$params['countdown'] = $user_input->countdown - 1;
					if ($user_input->countdown == 0)
						$params['goToScreen'] = true;
				}else
					$params['countdown'] = 3;
			}
			ControlFactory::add_close_dialog_and_apply_button($defs, $this, array('action' => $user_input->action,	'indiClass' => 'PeerflixServer', 'delPeerflixServerTorrent' => $user_input->hash), $user_input->control_id, 'Удалить', 300);
			ControlFactory::add_vgap($defs, (-10));
			ControlFactory::add_smart_label($defs, "", '<text color="10" size="tiny">* удаляет из базы Peerflix-Server, кнопка Return оставляет в Peerflix-Server</text>');
			if (isset($user_input->countdown)){
				ControlFactory::add_vgap($defs, (-30));
				ControlFactory::add_smart_label($defs,"", '<text color="18" size="tiny">Переход в Peerflix-Server через: </text><text color="15" size="tiny">'.$user_input->countdown.' сек. </text>');
				ControlFactory::add_vgap($defs, (-40));
				ControlFactory::add_smart_label($defs,"", '<text color="18" size="tiny">Для добавления других .torrent файлов кнопка Return пульта ДУ.</text>');
			}
			$attrs['timer'] = ActionFactory::timer(1000);
			$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $params);
			$attrs['actions'] = array(GUI_EVENT_TIMER => ActionFactory::close_dialog_and_run($action));
			return  ActionFactory::show_dialog('Добавление в Peerflix-Server', $defs, true, 1000, $attrs);
		}
		if ($user_input->action == 'restart'){
			hd_silence_warnings();
			return self::restartPeerflixServer($defs, $user_input);
		}
		if ($user_input->action == 'selectAndroidAction'){
			if (isset($selected_media_url->playback_url)){
				if (isset($user_input->playAll))
					$arg = self::getIp() . '/torrents/'.$selected_media_url->movie_id.'/files';
				else
					$arg = $selected_media_url->playback_url;
				return HD::get_android_action($arg);
			}
		}
		if ($user_input->action == 'allPirflixFileStartStop'){
			if (isset($selected_media_url->file_info->torrentId))
				$movie_id =  $selected_media_url->file_info->torrentId;
			else
				$movie_id =  $selected_media_url->movie_id;
			$jsd = json_decode (file_get_contents(self::getIp() . "/torrents/" . $movie_id));
			if ($select_url == true){
				foreach ($select_url[$selected_media_url->movie_id] as $v){
					$vMu = MediaURL::decode($v);
					$urlArr[$vMu->playback_url] = $vMu->playback_url;
				}
				foreach ($jsd->files as $index => $file)
					if (isset($urlArr[self::getIp() . $file->link]))
						self::peerflixServerActionDloadAll($movie_id, $user_input->allPirflixFileAction, ($index + 1));
				$action = UserInputHandlerRegistry::create_action($this, 'clearSelectUrls');
			}else{
				$action = null;
				foreach ($jsd->files as $index => $file){
					if (self::getIp() . $file->link == $selected_media_url->playback_url){
						self::peerflixServerActionDloadAll($movie_id, $user_input->allPirflixFileAction, ($index + 1));
					}
				}
			}
			return ActionFactory::show_title_dialog('Выполнено', $action);
		}
		if ($user_input->action == 'allStartStop'){
			$width = 600;
			if (isset($user_input->allPirflixFilesAction)){
				if (isset($selected_media_url->file_info->torrentId))
					$movie_id =  $selected_media_url->file_info->torrentId;
				else
					$movie_id =  $selected_media_url->movie_id;
				
				self::peerflixServerActionDloadAll($movie_id, $user_input->allPirflixFilesAction);
				return ActionFactory::show_title_dialog('Выполнено');
			}
			$params['action'] =  'allStartStop';
			$params['allPirflixFilesAction'] =  'stop';
			$params['indiClass'] = 'PeerflixServer';
			ControlFactory::add_button_close(&$defs, $this, $params, $user_input->control_id, '', 'Остановить все', $width - 100);
			$params['allPirflixFilesAction'] =  'start';
			ControlFactory::add_button_close(&$defs, $this, $params, $user_input->control_id, '', 'Запустить все', $width - 100);
			return ActionFactory::show_dialog('Pirflix-Server', $defs, true, $width);
		}
		if ($user_input->action == 'peerflixServerActionRem'){
			if (isset($selected_media_url->movie_id)){
				if (isset($selected_media_url->torrentId))
					self::peerflixServerActionRem($selected_media_url->torrentId);
				else if (isset($selected_media_url->file_info->torrentId))
					self::peerflixServerActionRem($selected_media_url->file_info->torrentId);
				else
					self::peerflixServerActionRem($selected_media_url->movie_id);
				self::actionGetTorrentList();
				$action = ActionFactory::invalidate_folders(array($user_input->parent_media_url, VodPeerflixServerScreen::get_media_url_str($parent_media_url->class_name)));
				if ($parent_media_url->screen_id == "vod_series")
					return ActionFactory::replace_path(1, null, $action);
				return $action;
			}else
				return false;
		}
		return ActionFactory::show_title_dialog($caption, $post_action, $msg, 0);
	}
	public static function peerflixServerActionDloadAll($movie_id, $action, $index=null){
		$opts [CURLOPT_POST] = true;
		$opts [CURLOPT_POSTFIELDS] = "";
		$url = self::getIp() . "/torrents/".$movie_id."/" . $action;
		if ($index == true)
			$url .= '/' . ($index - 1);
		$doc = HD::http_get_document($url, $opts);
		echo $doc;
	}
	public static function peerflixServerActionStat($movie_id){
		$peerflixServerIp = self::getIp();
		$str = file_get_contents("$peerflixServerIp/torrents/$movie_id/stats");
		$str = preg_replace('/("down"):\s*?(.*?),/', '\\1:"\\2",', $str);
		$str = preg_replace('/("up"):\s*?(.*?)}/', '\\1:"\\2"}', $str);
		$jsd = json_decode($str);
		if(isset($jsd->traffic)){
			$jsd->traffic->down = HD::readableBytes($jsd->traffic->down);
			$jsd->traffic->up = HD::readableBytes($jsd->traffic->up);
			$jsd->speed->down = HD::readableBytes($jsd->speed->down) . '/s';
			$jsd->speed->up = HD::readableBytes($jsd->speed->up) . '/s';
		}
		return $jsd;
	}
	public static function peerflixServerActionRem($movie_id){
		$peerflixServerInf = HD::getItemsArr('PeerflixServerInf');
		if (isset($peerflixServerInf[$movie_id])){
			unset($peerflixServerInf[$movie_id]);
			HD::saveItemsArr('PeerflixServerInf', $peerflixServerInf);
		}
		$header[0] = "Content-type: application/json";
		$opts[CURLOPT_HTTPHEADER] = $header;
		$opts[CURLOPT_CUSTOMREQUEST] = 'DELETE';
		return json_decode(HD::http_get_document(self::getIp() . '/torrents/' . $movie_id, $opts));
	}
	public static function peerflixServerActionGet($movie_id){
		self::$do_cmd = 1;
		$str = HD::do_cmd('run', 'action=torrentPeerflixSeries peerflixServerIp=' . self::getIp() . ' peerflixId=' . $movie_id);
		if (!empty($str)){
			if ($str == '[]')
				return true;
			return json_decode ($str);
		}
		return false;
	}
	public static function actionGetTorrentList(){
		$cmdAsyncExec = DuneSystem::$properties['install_dir_path'] . '/www/cgi-bin/php-cgi -f ' .  DuneSystem::$properties['install_dir_path'] . "/www/cgi-bin/run.php action=torrentPeerflixServerList peerflixServerIp=" . self::getIp();
		$str = HD::asyncExec($cmdAsyncExec);
		if (!empty($str)){
			if ($str == '[]')
				return true;
			return json_decode ($str);
		}
		return false;
	}
	public static function peerflixServerActionAdd ($tUrl){
		echo $tUrl;
		$header[0] = "Content-type: application/json";
		$otps[CURLOPT_HTTPHEADER] = $header;
		$otps[CURLOPT_TIMEOUT] = 1;
		$otps[CURLOPT_POSTFIELDS] = '{"link":"' . $tUrl . '"}';
		$jsd = json_decode(HD::http_get_document(self::getIp() . "/torrents", $otps));
		if ($jsd->infoHash == false){
			$i = 0;
			do {
				sleep (4);
				$jsd = json_decode(HD::http_get_document(self::getIp() . "/torrents", $otps));
				$i++;
			} while (($i < 2)&&(!is_object($jsd)));
		}
		if ($jsd->infoHash == false)
			return false;
		return $jsd->infoHash;
	}
	public static function peerflixServerActionUpload ($tUrl){

		$jsd = json_decode(HD::http_post_document(self::getIp() .'/upload',array('file'=>'@'.$tUrl)));
		if ($jsd == false)
			return false;
		return $jsd->infoHash;
	}
	public static function getScreenActionMapArr ($parent_media_url){
		// if ($parent_media_url->screen_id != 'vod_series'){
			// $actionsArr[0]['create_action'] = 'classAction';
			// $actionsArr[0]['params'] = array ('indiClass' => 'PeerflixServer', 'action' => 'peerflixServerActionRem');
			// $actionsArr[0]['caption'] = 'Удалить';
			// $actionsArr[0]['key'] = GUI_EVENT_KEY_D_BLUE;
		// }
		$actionsArr[1]['create_action'] = 'classAction';
		$actionsArr[1]['params'] = array ('indiClass' => 'PeerflixServer', 'action' => 'allStartStop');
		$actionsArr[1]['caption'] = 'Start/Stop All';
		$actionsArr[1]['key'] = GUI_EVENT_KEY_C_YELLOW;
		return $actionsArr;
	}
	public static function load_movie($movie_id, $mUrl, $getMovieInfo){
		if (isset(self::$peerflixServerItems[$movie_id]))
			return self::$peerflixServerItems[$movie_id];
		else{
			if (isset($mUrl->data))
				return (array)$mUrl->data;
			return false;
		}
	}
	public static function set_movie($movie_id, $obj){
		self::$peerflixServerItems[$movie_id] = (array)$obj;
	}
	public static function get_series_list($media_url, $movie){
		if (isset($media_url->torrentId)){
			$jsd = self::peerflixServerActionGet($media_url->torrentId);
			if ($jsd == false)
				return 'addTorrent';
		}else
			$jsd = self::peerflixServerActionGet($media_url->movie_id);
		if ($jsd == true){
			$items = array();
			foreach ($jsd->files as $key => $vel){
				$pathinfo = pathinfo($vel->path);
				if (((isset($pathinfo['extension']))&&(!preg_match("/mp3|wav|og(?:g|a)|flac|dts|ac3|rm|aac|wma|mka|ape|mpeg|ra?m|avi|mp(?:g|e|4)|mov|divx|asf|qt|wmv|m\dv|rv|vob|asx|ogm|mkv|m2ts|ts/i",$pathinfo['extension'])))||(!isset($pathinfo['extension'])))
					continue;
				$title = pathinfo($vel->name, PATHINFO_BASENAME);
				$items[$title]['id'] = md5 ($title);//to be continue
				$items[$title]['title'] = $title;
				if(isset($vel->length))
					$items[$title]['file_info']['size'] = HD::readableBytes($vel->length);
				$items[$title]['playback_url'] = self::getIp() . $vel->link;
				$items[$title]['is_stream_url'] = true;
				$items[$title]['file_info']['poster_url'] = $movie->poster_url;
				$items[$title]['file_info']['class_name'] = $media_url->class_name;
				$items[$title]['file_info']['selected'] = $vel->selected;
				$items[$title]['file_info']['details_box_width'] = true;
				if (isset($media_url->detailed_info))
					$items[$title]['file_info']['detailed_info'] = $media_url->detailed_info;
				if (isset( $media_url->torrentId))
					$items[$title]['file_info']['torrentId'] = $media_url->torrentId;
				else
					$items[$title]['file_info']['torrentId'] = $media_url->movie_id;
				if (isset($selected_media_url->tType))
				$items[$title]['file_info']['tType'] = $selected_media_url->tType;
				$items[$title]['file_info']['torrentClassName'] = 'PeerflixServer';
			}
			ksort($items);
			return $items;
		}else return array();
	}
	public static function getInfoRend($hash, $actions, $post_action=null){
		$comps = array();
		echo "==>$hash";
		$stat = self::peerflixServerActionStat($hash);
		ActionFactory::add_osd_image($comps, DuneSystem::$properties['install_dir_path'] . '/icons/centr.png', 0, 0, 1920, 350);
		$y = 0;
		
		ActionFactory::add_osd_text($comps, 'Download Speed:', 100, $y + 50, PLUGIN_FONT_NORMAL, 19, 0);
		if (isset($stat->speed->down))
			ActionFactory::add_osd_text($comps, $stat->speed->down, 470, $y + 50, PLUGIN_FONT_NORMAL, 15, 0);
				
		ActionFactory::add_osd_text($comps, 'Upload Speed:', 100, $y + 100, PLUGIN_FONT_NORMAL, 19, 0);
		if (isset($stat->speed->up))
			ActionFactory::add_osd_text($comps, $stat->speed->up, 470, $y + 100, PLUGIN_FONT_NORMAL, 15, 0);
		
		if (isset($stat->peers->unchocked)){
			ActionFactory::add_osd_text($comps, 'Active Peers/Total Peers:', 100, $y + 150, PLUGIN_FONT_NORMAL, 19, 0);
			ActionFactory::add_osd_text($comps, $stat->peers->unchocked .'/'. $stat->peers->total, 620, $y + 150, PLUGIN_FONT_NORMAL, 15, 0);
		}
				
		ActionFactory::add_osd_text($comps, 'Loaded Size:', 100, $y + 200, PLUGIN_FONT_NORMAL, 19, 0);
		if (isset($stat->traffic->down))
			ActionFactory::add_osd_text($comps, $stat->traffic->down, 380, $y + 200, PLUGIN_FONT_NORMAL, 15, 0);
		
		ActionFactory::add_osd_text($comps, 'Uploaded Size:', 100, $y + 250, PLUGIN_FONT_NORMAL, 19, 0);
		if (isset($stat->traffic->up))
			ActionFactory::add_osd_text($comps, $stat->traffic->up, 410, $y + 250, PLUGIN_FONT_NORMAL, 15, 0);
		return ActionFactory::update_osd($comps, ActionFactory::change_behaviour($actions, 1000, $post_action));
	}
}
?>