<?
if (!class_exists('DuneSystem')){
	if (preg_match('|plugins/(.*?)/lib|', __DIR__, $matches)){
		$tmp_path = '/tmp/plugins/'.$matches[1];
		$plugin_name = $matches[1];
		$install_dir = str_replace('/lib/wox', '',  __DIR__);
		if (file_exists('/persistfs/plugins_data'))
			$data_dir = "/persistfs/plugins_data/$plugin_name";
		else
			$data_dir = "/flashdata/plugins_data/$plugin_name";
        $port = HD::http_local_port();
		$www_url = "http://127.0.0.1:$port/plugins/$plugin_name/";
		$cgi_url = "http://127.0.0.1:$port/cgi-bin/plugins/$plugin_name/";
	}

	function hd_print($str){
		echo $str;
	}
	class DuneSystem{
		public static $properties = array ();
	};
	DuneSystem::$properties['plugin_name']      = $plugin_name;
	DuneSystem::$properties['install_dir_path'] = $install_dir;
	DuneSystem::$properties['tmp_dir_path']     = $tmp_path;
	DuneSystem::$properties['plugin_www_url']   = $www_url;
	DuneSystem::$properties['plugin_cgi_url']   = $cgi_url;
	DuneSystem::$properties['data_dir_path']    = $data_dir;
}

class Trailers {
	static $apiKey = null;
	public static function getApiKey(){
		if (null === self::$apiKey){
			$ylb_api_key = Youtube::get_ylb_api_key();
			self::$apiKey = $ylb_api_key['api_key'];
		}
		return self::$apiKey;
	}
	public static function getScreenActionMapArr($media_url){
		$actionMapArr = array();
		return $actionMapArr;
	}
	public static function getPopUpMenuItems ($selected_media_url, $parent_media_url){
		$menu_items = array();
		return $menu_items;
	}
	public static function get_series_list($media_url, $movie){
		$items = array();
		if (isset($movie->class_info['noTrailers']))
			return $items;
		$hideSources = HD::getItemsArr('hideSources', true);
		if (isset($hideSources["Trailers"])){
			$items['empty']['id'] = 'empty';
			$items['empty']['title'] = 'Трейлеры отключены в Источниках';
			$items['empty']['playback_url'] = 'empty';
			$items['empty']['is_stream_url'] = false;
			$items['empty']['file_info']['icon_path'] = 'plugin_file://icons/s_info.png';
			return $items;
		}
		if (isset($movie->class_info['trailers'])){
			foreach ($movie->class_info['trailers'] as $k => $trailer){
				if (is_array($trailer)){
					if (isset($trailer['classFunction'])){
						$class = $trailer['classFunction']['class'];
						require_once str_replace('/lib/wow', '', __DIR__) . "/lib/wox/$class.php";
						$items = $class::loadTrailers($trailer['classFunction'], $movie);
					}else{
						$items[md5 ($trailer['url'])]['id'] = md5 ($trailer['url']);
						$items[md5 ($trailer['url'])]['title'] = $trailer['name'];
						$items[md5 ($trailer['url'])]['playback_url'] = $trailer['url'];
						$items[md5 ($trailer['url'])]['is_stream_url'] = true;
						$items[md5 ($trailer['url'])]['file_info']['details_box_width'] = true;
						if(isset($trailer['hls_v4']))
							$items[md5 ($trailer['url'])]['file_info']['hls_v4'] = true;
						$items[md5 ($trailer['url'])]['file_info']['poster_url'] = $movie->poster_url;
						$items[md5 ($trailer['url'])]['file_info']['class_name'] = $media_url->class_name;
						$items[md5 ($trailer['url'])]['file_info']['description'] = $movie->description;
						$items[md5 ($trailer['url'])]['file_info']['detailed_info'] = '||Трейлер|' . $movie->name . '|'  . $movie->name_original . '||' . $movie->description;
						if(preg_match('/yout/i', $trailer['url']))
							$items[md5 ($trailer['url'])]['file_info']['icon_path'] = 'plugin_file://icons/s_youtube.png';
						else if(isset($trailer['icon_path']))
							$items[md5 ($trailer['url'])]['file_info']['icon_path'] = $trailer['icon_path'];
						else
							$items[md5 ($trailer['url'])]['file_info']['icon_path'] = 'plugin_file://icons/s_kinopoisk.png';
					}
				}else if(preg_match('/[a-z0-9_-]{11}/i', $trailer, $matches)){
					$jsd = json_decode(HD::http_get_document("https://www.googleapis.com/youtube/v3/videos?id=".$matches[0]."&key=".self::getApiKey()."&part=snippet"));
					$items[md5 ($jsd->items[0]->id)]['id'] = md5 ($jsd->items[0]->id);
					$items[md5 ($jsd->items[0]->id)]['title'] = 'YouTube Трейлер - '. $movie->name;
					$items[md5 ($jsd->items[0]->id)]['playback_url'] = 'http://www.youtube.com/watch?v='.$jsd->items[0]->id;
					$items[md5 ($jsd->items[0]->id)]['is_stream_url'] = false;
					
					$items[md5 ($jsd->items[0]->id)]['file_info']['poster_url'] = str_replace("https", "http",$jsd->items[0]->snippet->thumbnails->medium->url);//self::http_get_img ($jsd->items[0]->snippet->thumbnails->medium->url);
					$items[md5 ($jsd->items[0]->id)]['file_info']['class_name'] = $media_url->class_name;
					$items[md5 ($jsd->items[0]->id)]['file_info']['description'] = HD::str_remove_tag($jsd->items[0]->snippet->description);
					$items[md5 ($jsd->items[0]->id)]['file_info']['detailed_info'] = '||YouTube Трейлер|'.$movie->name.'||' . HD::str_remove_tag($jsd->items[0]->snippet->title) .'|' . HD::str_remove_tag($jsd->items[0]->snippet->description);
					$items[md5 ($jsd->items[0]->id)]['file_info']['icon_path'] = 'plugin_file://icons/s_youtube.png';
				}
			}
		}
		if (isset($movie->class_info['dbIDs']['kpID'])){
			$jsd = Kinopoisk_Class::getKPinfoUnOff ("/v2.2/films/" . $movie->class_info['dbIDs']['kpID'] . "/videos");
			if (isset($jsd->trailers))
				foreach ($jsd->trailers as $v){
					$items[md5 ($v->url)]['id'] = md5 ($v->url);
					$items[md5 ($v->url)]['title'] =  $v->name;
					$items[md5 ($v->url)]['playback_url'] = $v->url;
					$items[md5 ($v->url)]['is_stream_url'] = false;
					$items[md5 ($v->url)]['file_info']['icon_path'] = 'plugin_file://icons/s_youtube.png';
					if ($v->site == "KINOPOISK_WIDGET"){
						$items[md5 ($v->url)]['file_info']['icon_path'] = 'plugin_file://icons/s_kinopoisk.png';
						$items[md5 ($v->url)]['file_info']['hls_v4'] = true;
					}
					$items[md5 ($v->url)]['file_info']['class_name'] = $media_url->class_name;
					$items[md5 ($v->url)]['file_info']['description'] = $movie->description;
					$items[md5 ($v->url)]['file_info']['detailed_info'] = '||Трейлер|' . $movie->name . '|'  . $movie->name_original . '||' . $movie->description;
				}
			$yohohoArr['kpID'] = $movie->class_info['dbIDs']['kpID'];
		}
		$yohohoArr['name'] = $movie->name;
		if (HD::strSanitizing($movie->name_original) != HD::strSanitizing($movie->name))
			$yohohoArr['name_original'] = $movie->name_original;
		if (preg_match_all('|(\d\d\d\d)|', $movie->country, $m)){
			if (isset($m[1][1]))
				$yohohoArr['year'] = $m[1][0]." - ".$m[1][1];
			else
				$yohohoArr['year'] = $m[1][0];
		}else
			$yohohoArr['year'] = $movie->year;
		$yohohoArr['return'] = 'trailer';
		$yohohoTrailerUrl= self::parseYohohoPage($yohohoArr);
		
		if (($yohohoTrailerUrl == true)&&(isset($yohohoTrailerUrl->iframe))){
			if(preg_match('/[a-z0-9_-]{11}/i', $yohohoTrailerUrl->iframe, $matches)){
				$jsd = json_decode(HD::http_get_document("https://www.googleapis.com/youtube/v3/videos?id=".$matches[0]."&key=".self::getApiKey()."&part=snippet"));
				$items[md5 ($jsd->items[0]->id)]['id'] = md5 ($jsd->items[0]->id);
				$items[md5 ($jsd->items[0]->id)]['title'] = 'YouTube Трейлер (Yohoho) - '. $movie->name;
				$items[md5 ($jsd->items[0]->id)]['playback_url'] = 'http://www.youtube.com/watch?v='.$jsd->items[0]->id;
				$items[md5 ($jsd->items[0]->id)]['is_stream_url'] = false;
				
				$items[md5 ($jsd->items[0]->id)]['file_info']['poster_url'] = str_replace("https", "http",$jsd->items[0]->snippet->thumbnails->medium->url);//self::http_get_img ($jsd->items[0]->snippet->thumbnails->medium->url);
				$items[md5 ($jsd->items[0]->id)]['file_info']['class_name'] = $media_url->class_name;
				$items[md5 ($jsd->items[0]->id)]['file_info']['description'] = HD::str_remove_tag($jsd->items[0]->snippet->description);
				$items[md5 ($jsd->items[0]->id)]['file_info']['detailed_info'] = '||YouTube Трейлер (Yohoho)|'.$movie->name.'||' . HD::str_remove_tag($jsd->items[0]->snippet->title) .'|' . HD::str_remove_tag($jsd->items[0]->snippet->description);
				$items[md5 ($jsd->items[0]->id)]['file_info']['icon_path'] = 'plugin_file://icons/s_youtube.png';
			}
		}
		
		$jsds['jsd'][0] = json_decode(HD::http_get_document("https://www.googleapis.com/youtube/v3/search?order=relevance&part=snippet&q=".urlencode($movie->name ." трейлер")."&relevanceLanguage=ru&type=video&maxResults=1&alt=json&key=" . self::getApiKey()));
		$jsds['title'][0] = 'YouTube Трейлер - '. $movie->name;
		if (HD::strSanitizing($movie->name_original) != HD::strSanitizing($movie->name)){
			$jsds['jsd'][1] = json_decode(HD::http_get_document("https://www.googleapis.com/youtube/v3/search?order=relevance&part=snippet&q=".urlencode($movie->name_original ." trailer")."&relevanceLanguage=ru&type=video&maxResults=1&alt=json&key=" . self::getApiKey()));
			$jsds['title'][1] = 'YouTube Trailer - '. $movie->name_original;
		}
		foreach ($jsds['jsd'] as $k => $jsd){
			if (isset($jsd->items[0]->id->videoId)){
				$items[md5 ($jsd->items[0]->id->videoId)]['id'] = md5 ($jsd->items[0]->id->videoId);
				$items[md5 ($jsd->items[0]->id->videoId)]['title'] = $jsds['title'][$k];
				$items[md5 ($jsd->items[0]->id->videoId)]['playback_url'] = 'http://www.youtube.com/watch?v='.$jsd->items[0]->id->videoId;
				$items[md5 ($jsd->items[0]->id->videoId)]['is_stream_url'] = false;
				
				$items[md5 ($jsd->items[0]->id->videoId)]['file_info']['poster_url'] = str_replace("https", "http", $jsd->items[0]->snippet->thumbnails->medium->url);
				$items[md5 ($jsd->items[0]->id->videoId)]['file_info']['class_name'] = $media_url->class_name;
				$items[md5 ($jsd->items[0]->id->videoId)]['file_info']['description'] = HD::str_remove_tag($jsd->items[0]->snippet->description);
				$items[md5 ($jsd->items[0]->id->videoId)]['file_info']['detailed_info'] = '||YouTube Трейлер|'.$movie->name.'||' . HD::str_remove_tag($jsd->items[0]->snippet->title) .'|' . HD::str_remove_tag($jsd->items[0]->snippet->description);
				$items[md5 ($jsd->items[0]->id->videoId)]['file_info']['icon_path'] = 'plugin_file://icons/s_youtube.png';
			}
		}
		return $items;
	}
	public static function parseYohohoPage($argArr){
		static $yLinkArr = null;
		if (isset($argArr['kpID']))
			$postStr = 'kinopoisk=' . $argArr['kpID'];
		else{
			$capStr = $argArr['name'];
			if (isset($argArr['name_original']))
				$capStr .= ' / ' . $argArr['name_original'];
			if (isset($argArr['year']))
				$capStr .= ' (' . $argArr['year'] . ')';
			$postStr = "title=".urlencode($capStr);
		}
		if (!isset($yLinkArr[$postStr])){
			if (count($yLinkArr) > 20)
				$yLinkArr = null;
			$header[] = "origin: https://4h0y.gitlab.io";
			$header[] = "referer: https://4h0y.gitlab.io";
			$opts [CURLOPT_HTTPHEADER] = $header;
			$opts [CURLOPT_POST] = true;
			$opts [CURLOPT_POSTFIELDS] = "$postStr&player=collaps,bazon,ustore,alloha,hdvb,videocdn,kodik,pleer,iframe,videospider,en,lookbase,ashdi,trailer,torrent";
			$jsd = json_decode (HD::http_get_document('https://ahoy.yohoho.online/', $opts));
			$yLinkArr[$postStr] = (array)$jsd;
		}
		if (isset($argArr['return'])){
			if (isset($yLinkArr[$postStr][$argArr['return']]))
				return $yLinkArr[$postStr][$argArr['return']];
		}else if (isset($yLinkArr[$postStr]))
			return $yLinkArr[$postStr];
		return false;
	}
	public static function http_get_img ($url){
		if (preg_match("|https|",$url))
			return DuneSystem::$properties['plugin_cgi_url'] . "do?img=" .  $url;	
		return $url;
	}
}
?>
