<?
if (!class_exists('DuneSystem')){
	if (preg_match('|plugins/(.*?)/lib|', __DIR__, $matches)){
		$tmp_path = '/tmp/plugins/'.$matches[1];
		$plugin_name = $matches[1];
		$install_dir = str_replace('/lib/wox', '',  __DIR__);
		if (file_exists('/persistfs/plugins_data'))
			$data_dir = "/persistfs/plugins_data/$plugin_name";
		else
			$data_dir = "/flashdata/plugins_data/$plugin_name";
		$www_url = "http://127.0.0.1/plugins/$plugin_name/";
		$cgi_url = "http://127.0.0.1/cgi-bin/plugins/$plugin_name/";
	}

	function hd_print($str){
		echo $str;
	}
	class DuneSystem{
		public static $properties = array ();
	};
	DuneSystem::$properties['plugin_name']      = $plugin_name;
	DuneSystem::$properties['install_dir_path'] = $install_dir;
	DuneSystem::$properties['tmp_dir_path']     = $tmp_path;
	DuneSystem::$properties['plugin_www_url']   = $www_url;
	DuneSystem::$properties['plugin_cgi_url']   = $cgi_url;
	DuneSystem::$properties['data_dir_path']    = $data_dir;
}
class KinoTrend_Class {
	static $cName = 'KinoTrend';
	static $className = 'KinoTrend_Class';
  static $DomainName = null;
  public static function getDomainName(){
		if (null === self::$DomainName)
			self::$DomainName = (HD::getItemStr(self::$cName . 'DomainName') != '') ? HD::getItemStr(self::$cName . 'DomainName') : 'http://kino-trend.ru';
		return self::$DomainName;
	}
	public static function getMainMenuInfo(){
		return array (
			'name' => self::$cName,
			'descr' => '||'.self::$cName.'|это каталог, с помощью которого вы сможете просмотреть или скачать новые торренты фильмов, появившиеся за несколько месяцев.'
		);
	}
	public static function get_media_url_str($k, $arr=null){
		if ($arr == true)
			return SmartVodListScreen::get_media_url_str($k, $arr);
		return SmartVodListScreen::get_media_url_str($k);
	}
	public static function getScreenActionMapArr($media_url){
		$actionsArr = array();
		return $actionsArr;
	}
	public static function getPopUpMenuItems ($selected_media_url, $parent_media_url){
		$menu_items = array();
    if ($parent_media_url == 'main_menu'){
     $menu_items[] = array(
				'caption' => 'Задать зеркало ' . self::$cName,
				'params' => array ('action' => 'mirror'),
				'icon_url' => SmartConfig::getPluginIco('' . self::$className)
			);
    }
		$parent_media_url = MediaURL::decode($parent_media_url);
		if ($parent_media_url->screen_id == 'vod_torrentlist'){
			
			$menu_items[] = array(
				'caption' => 'Изменить действие для торрентов',
				'params' => array ('action' => 'torrentActionSetup'),
				'icon_url' => SmartConfig::getPluginIco('s_torrent')
			);
			$menu_items[] = array(
				'caption' => 'Выбрать действие торрента',
				'conID' => 'add_actions',
				'params' => array ('torrentAction' => 1),
				'icon_url' => SmartConfig::getPluginIco('s_list')
			);
			$menu_items[] = 'is_separator';
			$menu_items[] = array(
				'caption' => 'Настройки TorrServer',
				'conID' => 'classSetupTorrServer',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_torrserver')
			);
			$menu_items[] = array(
				'caption' => 'Настройки PeerflixServer',
				'conID' => 'classSetupPeerflixServer',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_peerflixserver')
			);
			$menu_items[] = array(
				'caption' => 'Настройки Transmission',
				'conID' => 'classSetupTransmission',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_transmission')
			);
			$menu_items[] = array(
				'caption' => 'Настройки Transmission UPnP',
				'conID' => 'classSetupTransmissionUPnP',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_transmissionupnp')
			);
			$menu_items[] = 'is_separator';
		}
		if ((isset($parent_media_url->screen_id))&&($parent_media_url->screen_id != 'vod_series')){
			$menu_items[] = array(
				'caption' => 'Добавить в Главное меню',
				'params' => array ('action' => 'addToMainMenu'),
				'icon_url' => SmartConfig::getPluginIco('s_home')
			);
		}
		return $menu_items;
	}
	public static function getShortMovieRange ($media_url, &$m_feed){
		$items = array();
		if ($m_feed === 'end')
			return $items;
		$data = file_get_contents(self::getDomainName() . '/kinotrend/data.json');
		$data =  preg_replace('/("\w+"):\s*?(\d+),/', '\\1:"\\2",', $data);
		$data_json = json_decode ($data);
		$m_feed = 'end';
		if (isset($data_json->movies)){
			foreach ($data_json->movies as $movie){
				$caption = $caption_original = HD::str_remove_tag($movie->nameRU);
				if ($movie->nameOriginal != '')
					$caption_original = HD::str_remove_tag($movie->nameOriginal);
				$id = $movie->filmID;
				$poster_url = self::http_get_img($movie->posterURL);
				$short_movie = new ShortMovie(
					strval($id),
					strval($caption),
					strval($poster_url)
				);
				$info = '||' . $caption;
				$info .= '|' . $caption_original;
				$info .= '|| ' .  HD::str_remove_tag($movie->country);
				$info .= '||' . $movie->year;
				$info .= '||' .  $movie->filmLength . ' min.';
				$info .= '||' . $movie->genre;
				$info .= '||КП рейтинг: ' .  $movie->ratingKP;
				$info .= '||IMDB рейтинг: ' .  $movie->ratingIMDb;
				$short_movie->year = $movie->year;
				$short_movie->description = HD::str_remove_tag($movie->description);
				$info .= '||' . $short_movie->description;
				$short_movie->links['arr']  = $movie->torrents;
				$short_movie->links['className']  = self::$className;
				$short_movie->info = $info;
				$short_movie->newClassName = 'Kinopoisk_Class';
				array_push ($items, $short_movie);
			}
		}
		return $items;
	}
	public static function getVodSourceInfo($v){
		$ico = SmartConfig::getPluginIco(self::$className);
		$sources['caption'] = self::$cName;
		$sources['detailed_info'] = '||'.self::$cName.'|Магниты c '.self::$cName.'. Отображаются только в каталоге ' .self::$cName;
		$sources['icon_path'] = $ico;
		$sources['detailed_icon_path'] = $ico;
		$sources['goTo'] = 'SmartVodTorrentsScreen';
		$sources['class_name'] = $v;
		$sources['variable'] = true;
		$sources['type'] = SmartConfig::getPluginIco('torrentSource');
		return $sources;
	}
	public static function getShortTorrentRange ($movie, $media_url, &$m_feed){
		$items = array();
		if ($m_feed === 'end')
			return $items;
		$m_feed = 'end';
		$icon_path_magnet = SmartConfig::getPluginIco('s_magnet');
		$icon_path_torrent = SmartConfig::getPluginIco('s_torrent');
		foreach ($media_url->links->arr as $k => $v){
			$size = HD::readableBytes($v->size);
			$info = '||' . $v->type . 
			'|Размер: '. $size . 
			'||S: '. $v->seeders . ' L: '. $v->leechers . 
			'||Date: '. $v->date;
						
			$short_movie = new ShortMovie(
				strval($v->magnet),
				strval($v->type),
				strval($movie->poster_url)
			);
			$short_movie->tType = 'magnet';
			$short_movie->extra_item = $size;
			$short_movie->icon_path = $icon_path_magnet;
			$short_movie->info = $info;
			$short_movie->details_box_width = true;
			array_push ($items, $short_movie);
		}
		return $items;
	}
	public static function getTorrentFile($torrent_id, $dloadPath=null){
		$torrentFile["status"] = true;
		$torrentFile["path"] = $torrent_id;
		return $torrentFile;
	}
	public static function http_get_img ($url){
		if (!preg_match("|^http|",$url))
			$url = self::getDomainName() . $url;
		// return $url;
		return DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . $url;
	}
}
?>