<?php
if (!class_exists('DuneSystem')){
	if (preg_match('|plugins/(.*?)/lib|', __DIR__, $matches)){
		$tmp_path = '/tmp/plugins/'.$matches[1];
		$plugin_name = $matches[1];
		$install_dir = str_replace('/lib/wox', '',  __DIR__);
		if (file_exists('/persistfs/plugins_data'))
			$data_dir = "/persistfs/plugins_data/$plugin_name";
		else
			$data_dir = "/flashdata/plugins_data/$plugin_name";
        $port = HD::http_local_port();
		$www_url = "http://127.0.0.1:$port/plugins/$plugin_name/";
		$cgi_url = "http://127.0.0.1:$port/cgi-bin/plugins/$plugin_name/";
	}

	function hd_print($str){
		echo $str;
	}
	class DuneSystem{
		public static $properties = array ();
	};
	DuneSystem::$properties['plugin_name']      = $plugin_name;
	DuneSystem::$properties['install_dir_path'] = $install_dir;
	DuneSystem::$properties['tmp_dir_path']     = $tmp_path;
	DuneSystem::$properties['plugin_www_url']   = $www_url;
	DuneSystem::$properties['plugin_cgi_url']   = $cgi_url;
	DuneSystem::$properties['data_dir_path']    = $data_dir;
}
class Kinogo_Class {
	static $cName = 'Kinogo';
	static $className = 'Kinogo_Class';
	static $DomainName = null;
	static $proxyArr = null;
	static $proxyArrMd5 = null;
	static $proxy = null;
	public static function getDomainName(){
		if (null === self::$DomainName)
			self::$DomainName = (HD::getItemStr(self::$cName . 'DomainName') != '') ? HD::getItemStr(self::$cName . 'DomainName') : 'https://kinogo.la';
		return self::$DomainName;
	}
	public static function getMainMenuInfo(){
		return array (
			'name' => self::$cName,
			'descr' => '||'.self::$cName.'|каталог видео с сайта ' . self::$cName . '||Если сайт не доступен используйте прокси или VPN, а так же официальные зеркала (сайты с похожим дизайном и названием могут не являтся зеркалом)'
		);
	}
	public static function get_media_url_str($k, $arr=null){
		if ($arr == true)
			return SmartVodCategoryListScreen::get_media_url_str($k, $arr);
		return SmartVodCategoryListScreen::get_media_url_str($k);
	}
	public static function getSearchMediaUrlStr($k, $arr=null){
		return SmartVodListScreen::get_media_url_str($k, $arr);
	}
	public static function getScreenActionMapArr($media_url){
		$actionsArr = array();
		if((isset($media_url->categoryId))&&((preg_match('|all_|', $media_url->categoryId))||
			(preg_match('|_genre_|', $media_url->categoryId))||
			(preg_match('|_country|', $media_url->categoryId)))){
			$actionsArr[0]['create_action'] = 'classAction';
			$actionsArr[0]['params'] = array ('indiClass' => self::$className,'action' => 'sort');
			$actionsArr[0]['caption'] = 'Сортировки';
			$actionsArr[0]['key'] = GUI_EVENT_KEY_C_YELLOW;
		}
		return $actionsArr;
	}
	public static function getPopUpMenuItems ($selected_media_url, $parent_media_url){
		$menu_items = array();
		if ($parent_media_url == 'main_menu'){
			$menu_items[] = array(
				'caption' => 'Задать зеркало ' . self::$cName,
				'params' => array ('action' => 'mirror'),
				'icon_url' => SmartConfig::getPluginIco('s_' . self::$className)
			);
			$menu_items[] = array(
				'caption' => 'Прокси для ' . self::$cName,
				'params' => array ('action' => 'proxy'),
				'icon_url' => SmartConfig::getPluginIco('s_proxy')
			);
			$menu_items[] = 'is_separator';
		}
		$parent_media_url = MediaURL::decode($parent_media_url);
		if ((isset($parent_media_url->screen_id))&&($parent_media_url->screen_id != 'vod_series')){
			$menu_items[] = array(
				'caption' => 'Добавить в Главное меню',
				'params' => array ('action' => 'addToMainMenu'),
				'icon_url' => SmartConfig::getPluginIco('s_home')
			);
		}
		return $menu_items;
	}
	public static function getVodCategories($media_url){
		static $categories = null;
		if (is_null($categories)){
			$categories['categories'][] = array('id'=> 'search', 'class' => 'SmartSearchScreen', 'caption' => 'Поиск');
			$doc = iconv('WINDOWS-1251', 'UTF-8',self::http_get_document(self::getDomainName()));
			$categories['categories'][] = array('id'=> '/', 'class' => 'SmartVodListScreen', 'caption' => 'Все');
			$categories['categories'][] = array('id'=> '/film/premiere/', 'class' => 'SmartVodListScreen', 'caption' => 'Премьеры');
			$categories['categories'][] = array('id'=> '/serial/', 'class' => 'SmartVodListScreen', 'caption' => 'Сериалы');
			$categories['categories'][] = array('id'=> '/anime/', 'class' => 'SmartVodListScreen', 'caption' => 'Аниме');
			$categories['categories'][] = array('id'=> '/mult/', 'class' => 'SmartVodListScreen', 'caption' => 'Мультфильмы');
			$categories['categories'][] = array('id'=> '/tv/', 'class' => 'SmartVodListScreen', 'caption' => 'TV');
			if (preg_match_all('|<i style="font-size:14px;">(.+?)<.*?</div>|ms', $doc, $matches)){
				foreach ($matches[1] as $k => $v){
					$categories['categories'][] = array('id'=> $k + 1, 'class' => 'SmartVodCategoryListScreen', 'caption' => HD::str_remove_tag($v));
					if (preg_match_all('|href="(.+?)".*?>(.+?)<|ms', $matches[0][$k], $match)){
						foreach ($match[1] as $key => $vel){
							$name = HD::str_remove_tag($match[2][$key]);
							if (($name != '')&&(!preg_match('|action=mobile|i',$vel)))
								$categories['subCategories'][$k + 1][] = array('id'=> HD::str_remove_tag($vel), 'class' => 'SmartVodListScreen', 'caption' => $name);
						}
					}
				}
			}
		}
		if (isset($media_url->categoryId))
			return $categories['subCategories'][$media_url->categoryId];
		return $categories['categories'];
	}
	public static function getShortMovieRange ($media_url, &$m_feed){
		if ($m_feed === 'end')
			return $items;
		$url =  self::getDomainName() . $media_url->categoryId;
		if ($m_feed > 0)
			$url .= 'page/'. ($m_feed+1) . '/';
		$doc = iconv('WINDOWS-1251', 'UTF-8',self::http_get_document($url));
		++$m_feed;
		if (preg_match('|<span>Позже</span>|', $doc))
			$m_feed = 'end';
		return self::parseSitePage($doc);
	}
	public static function getSearchShortMovieRange ($keyword, &$m_feed){
		if (is_object($keyword))
			$keyword = $keyword->searchStr;
		if ($m_feed === 'end')
			return array();
		$result_from= 1;
		if ($m_feed > 0)
			$result_from = $m_feed * 10 +1;
		$opts [CURLOPT_POST] = true;
		$opts [CURLOPT_POSTFIELDS] = "do=search&subaction=search&search_start=".( $m_feed + 1 )."&full_search=0&result_from=$result_from&titleonly=3&story=" . iconv('UTF-8', 'WINDOWS-1251', $keyword);
		$doc = iconv('WINDOWS-1251', 'UTF-8', self::http_get_document(self::getDomainName() . '/index.php?do=search', $opts));
		++$m_feed;
		if (preg_match('|<span>Позже</span>|', $doc))
			$m_feed = 'end';
		return self::parseSitePage($doc);
	}
	public static function parseSitePage($doc){
		$items = array();
		if (preg_match_all ('|<h2.+?href="(http.+?)".*?>(.+?)<.+?src="(/uploads.+?)".*?class="icons|ms', $doc, $match)){
			foreach ($match[1] as $k => $v){
				$v = str_replace (self::getDomainName(), '', $v);
				$qlty = $year =  false;
				$name	= HD::str_remove_tag($match[2][$k]);
				if (preg_match('|(.*)\((.*?)\)|', $name, $mm)){
					$name = HD::str_remove_tag($mm[1]);
					$year = HD::str_remove_tag($mm[2]);
				}
				$img = $match[3][$k];
				if (!preg_match('|^http|',$match[3][$k]))
					$img = self::getDomainName() . $match[3][$k];
				$info = '||' . $name;				
				if (($year == true)&&(preg_match('|зон|',$year)))
					$info .= '|' . $year;
				if (preg_match('|выпуска:.*?>(.+?)<br|ms', $match[0][$k], $matches))
					$year = HD::str_remove_tag($matches[1]);
				if ($year == true)
					$info .= '|' . $year;
				
				if (preg_match('|Качество:</b>(.+?)<|ms', $match[0][$k], $matches)){
					$qlty = HD::str_remove_tag($matches[1]);
					$info .= '|' . $qlty;
				}
				if (preg_match('|Перевод:.*?>(.+?)<|ms', $match[0][$k], $matches))
					$info .= ' ' . HD::str_remove_tag($matches[1]);
				if (preg_match('|Страна:.*?>(.+?)<|ms', $match[0][$k], $matches))
					$info .= '|' . HD::str_remove_tag($matches[1]);
				if (preg_match('|Жанр:.*?>(.+?)<br|ms', $match[0][$k], $matches))
					$info .= '|' . HD::str_remove_tag($matches[1]);
				if (preg_match('|Продолжительность:.*?>(.+?)<br|ms', $match[0][$k], $matches))
					$info .= '|' . HD::str_remove_tag($matches[1]);
				if (preg_match('|news-id-.*?inline;">(.+?)<br|ms', $match[0][$k], $matches))
					$info .= '||' . HD::str_remove_tag($matches[1]);
				if (class_exists('ShortMovie')){
					$short_movie = new ShortMovie(
						strval($v),
						strval($name),
						strval(self::http_get_img ($img))
					);
					$short_movie->info = $info;
					if ($qlty == true){
						$short_movie->right_top_img = $short_movie->left_bottom_img = false;
						$right_top_img = SmartConfig::getQualityIco($qlty);
						$short_movie->right_top_img = $right_top_img;
					}
					array_push ($items, $short_movie);
				}else{
					$items[$v]['url'] = $v;
					$items[$v]['infoArr']['caption'] = $name;
					$items[$v]['infoArr']['poster_url'] = $img;
					$items[$v]['infoArr']['detailed_info'] = $info;
				}
			}
		}
		return $items;
	}
	public static function load_movie($movie_id, $mUrl, $getMovieInfo){
		$arr = array();
		$arr['caption'] = $arr['class_info']['catalog_info']['caption'] = $mUrl->caption;
		$arr['poster_url'] = $arr['class_info']['catalog_info']['poster_url'] = $mUrl->poster_url;
		if (isset($mUrl->caption_original))
			$arr['caption_original'] = $arr['class_info']['catalog_info']['caption_original'] = $mUrl->caption_original;
		if (isset($mUrl->year))
			$arr ['year'] = $arr['class_info']['catalog_info']['year'] = $mUrl->year;
		if (!preg_match("|^http|",$movie_id))
			$url = self::getDomainName() . $movie_id;
		else
			$url = preg_replace('#((http.*)://.+?\/)#i', self::getDomainName() . "/", $movie_id);
		$doc = iconv('WINDOWS-1251', 'UTF-8',self::http_get_document($url));
		$arr['caption_original'] = '';
		 if (preg_match('|<h1>(.+?)</h1>|ms', $doc, $matches)){
			$arr['caption'] = HD::str_remove_tag($matches[1]);
			if (preg_match('|(.*)\((.*?)\)|', $arr['caption'], $mm)){
				$arr['caption'] = $mm[1];
				$arr['year'] =  $mm[2];
			}
		}
		if (preg_match('|fullimg">.*?href="(.+?)"|ms', $doc, $matches))
			$arr['poster_url'] = self::http_get_img ($matches[1]);
		if (preg_match('|class="fullimg">(.*?)<div class="quote">|ms', $doc, $matches))
			$arr['description'] = str_replace("\n", "", HD::str_remove_tag($matches[1]));
		if (preg_match('|трана:</b>(.+?)<br|ms', $doc, $matches))
			$arr['country'] = HD::str_remove_tag($matches[1]);
		if (preg_match('|анр:</b>(.+?)<br|ms', $doc, $matches))
			$arr['genres'] = HD::str_remove_tag($matches[1]);
		if (preg_match('|ыпуска:</b>(.+?)<br|ms', $doc, $matches))
			$arr['year'] = HD::str_remove_tag($matches[1]);
		if (preg_match('|ежиссер:</b>(.*?)<br|ms', $doc, $matches))
			$arr['director'] = HD::str_remove_tag($matches[1]);
		if (preg_match('|олях:</b>(.*?)</div|ms', $doc, $matches))
			$arr['actors'] = HD::str_remove_tag($matches[1]);
		if (preg_match('|тельность:.*?(\d+?) мин|ms', $doc, $matches))
			$arr['length'] = trim(HD::str_remove_tag($matches[1]));
		if (preg_match('|ачество:</b>(.+?)<br|ms', $doc, $matches))
			$arr['caption_original'] .= HD::str_remove_tag($matches[1]);
		if (preg_match('|еревод:</b>(.+?)<br|ms', $doc, $matches))
			$arr['caption_original'] .= "\n" . HD::str_remove_tag($matches[1]);
		if (preg_match('|<i><span id="selection_index_(.*?)"|ms', $doc, $matches))
			if (($matches[1] != '')&&($matches[1] != '1111111'))
				$arr['class_info']['dbIDs']['kpID'] = $matches[1];
		else if (preg_match("|string_name=(.+?)'|ms", $doc, $matches))
			if (($matches[1] != '')&&($matches[1] != '1111111'))
				$arr['class_info']['dbIDs']['kpID'] = $matches[1];
		else{
			$kpIDs = HD::getItemsArr('kpIDs');
			if (isset($kpIDs[$movie_id]))
				$arr['class_info']['dbIDs']['kpID'] = $kpIDs[$movie_id];
		}
		if ($getMovieInfo != 'min')
			$arr = SmartConfig::getMovieInfoArr($getMovieInfo, $movie_id, $mUrl, $arr);
		if (preg_match("|\/(\d+?)-|", $movie_id, $matches)){
			$arrId = kinoGo::getIframe ($matches[1], 'video_id');
			if ($arrId == true)
				$arr['class_info']['linksArr'][self::$className] = $arrId;
		}
		return $arr;
	}
	public static function getVodSourceInfo($v){
		$ico = SmartConfig::getPluginIco($v);
		$arr['caption'] = self::$cName;
		$arr['icon_path'] = $ico;
		$arr['detailed_icon_path'] = $ico;
		$arr['class_name'] = $v;
		$arr['detailed_info'] = '||' . self::$cName . '|видео с сайта '.self::$cName.'. Поиск видео на сайте '.self::$cName.' производится по названию возможны неточности.';
		$arr['type'] = SmartConfig::getPluginIco('onlineSource');
		return $arr;
	}
	public static function getIframe($params){
		$iframeInfo = array();
		$urls = false;
		if ((isset($params['caption_original']))&&(preg_match('|(.*?)\n|', $params['caption_original'], $m)))
			$params['caption_original'] = $m[1];
		if ((isset($params['country']))&&(preg_match('|(\d{4})|', $params['country'], $m))){
			$params['year'] = $m[1];
			unset($params['country']);
		}
		if (isset($params['linksArr'][self::$className])){
			foreach ($params['linksArr'][self::$className] as $k => $v){
				if (($k == 'm')||(preg_match('|^http|', $k)))
					$k = self::$cName;
				if (preg_match("|EpisodId_|", $v))
					$iframeInfo['urls'][$k]['goTo'] = 'VodSeriesListScreen';
				else
					$iframeInfo['urls'][$k]['goTo'] = 'VodSeasonListScreen';
				$iframeInfo['urls'][$k]['link'] = $v;
			}
			return $iframeInfo;
		}
		if (HD::strSanitizing($params['caption_original'], true) != HD::strSanitizing($params['caption'], true)){
			$year = 'null';
			if (isset($params['caption_original'])){
				$keyword = $params['caption_original'];
				$m_feed= 0;
				$arr = self::getSearchShortMovieRange ($keyword, $m_feed);
				foreach ($arr as $k => $v){
					if (HD::strSanitizing($keyword) == HD::strSanitizing($v['infoArr']['caption'])){
						extract ($v);
						$iframeInfo['infoArr'] = $infoArr;
						break;
					}
				}
			}
		}
		if (!isset($url)){
			$keyword = $params['caption'];
			$m_feed= 0;
			$arr = self::getSearchShortMovieRange ($keyword, $m_feed);
			foreach ($arr as $k => $v){
				if (HD::strSanitizing($keyword, true) == HD::strSanitizing($v['infoArr']['caption'], true)){
					extract ($v);
					$iframeInfo['infoArr'] = $infoArr;
					break;
				}
			}
			if (!isset($url))
				if ((isset($arr[0]))&&(is_array($arr))){
					extract ($arr[0]);
					$iframeInfo['infoArr'] = $infoArr;
				}
		}
		if (isset($url))
			if (preg_match("|\/(\d+?)-|", $url, $matches))
				$urls = kinoGo::getIframe ($matches[1], 'video_id');
			
		if ($urls == true){
			foreach ($urls as $k => $v){
				if (preg_match("|EpisodId_|", $v))
					$iframeInfo['urls'][$k]['goTo'] = 'VodSeriesListScreen';
				else
					$iframeInfo['urls'][$k]['goTo'] = 'VodSeasonListScreen';
				$iframeInfo['urls'][$k]['link'] = $v;
			}
			return $iframeInfo;
		}else{
			echo "\n".self::$cName.":search failed";
			return array("status"=>false);
		}
		return $iframeInfo;
	}
	public static function getSeasons($media_url){
		$urls = kinoGo::getIframe ($media_url->link, 'seasons');
		foreach ($urls as $k => $v){
			$uArr[$k]['caption'] = $k;
			$uArr[$k]['link'] = $v;
			$uArr[$k]['detailed_info'] = '||' . $k . $media_url->detailed_info;
			$uArr[$k]['class_name'] = $media_url->class_name;
			$uArr[$k]['poster_url'] = $media_url->poster_url;
			$uArr[$k]['goTo'] = 'VodSeasonListScreen';
			if (preg_match("|SeasonId|",$v)){
				$uArr[$k]['season'] = $k;
				$uArr[$k]['goTo'] = 'VodSeriesListScreen';
			}
		}
		return $uArr;
	}
	public static function get_series_list($media_url, $movie){
		if (preg_match('|EpisodId_|', $media_url->link)){
			$qltyMax = false;
			if (preg_match('|(.+?)\sQ:(\d+)|', $media_url->caption, $m))
				$qltyMax = $m[2];
			$hash_patrs = $media_url->caption;
			if (isset($media_url->hash_patrs)){
				$hash_patrs = implode("", (array)$media_url->hash_patrs);
			}
			$items[$media_url->caption]['id'] = md5 ($hash_patrs);
			$items[$media_url->caption]['title'] = $media_url->caption;
			$items[$media_url->caption]['playback_url'] = $media_url->link;
			$items[$media_url->caption]['is_stream_url'] = false;
			$items[$media_url->caption]['file_info']['poster_url'] = $media_url->poster_url;
			$items[$media_url->caption]['file_info']['details_box_width'] = true;
			$items[$media_url->caption]['file_info']['class_name'] = $media_url->class_name;
			if (isset($media_url->description))
				$items[$media_url->caption]['file_info']['description'] = $media_url->description;
			$items[$media_url->caption]['file_info']['detailed_info'] = $media_url->detailed_info;
			if ($qltyMax == true)
				$items[$media_url->caption]['file_info']['qltyMax'] = $qltyMax;
			return $items;
		}
		$episodes  = kinoGo::getIframe($media_url->link, 'episodes');
		if ($episodes == true){
			$items = array();
			foreach ($episodes as $key => $vel){
				$qltyMax = false;
				if (preg_match('|(.+?)\sQ:(\d+?)$|', $key, $m)){
					$key = $m[1];
					$qltyMax = $m[2];
				}
				$tvshow_se = VideoInfo::tvshow_se_parse($key);
				if (isset($tvshow_se['S']))
					$media_url->hash_patrs->season = $tvshow_se['S'];
				if (isset($tvshow_se['E']))
					$media_url->hash_patrs->episode = $tvshow_se['E'];
				else
					$media_url->hash_patrs->episode = $key;
				$hash_patrs = implode("", (array)$media_url->hash_patrs);
				$items[$key]['id'] = md5 ($hash_patrs);
				$items[$key]['title'] = $key;
				$items[$key]['playback_url'] = $vel;
				$items[$key]['is_stream_url'] = false;
				$items[$key]['file_info']['poster_url'] = $media_url->poster_url;
				$items[$key]['file_info']['details_box_width'] = true;
				$items[$key]['file_info']['class_name'] = $media_url->class_name;
				$items[$key]['file_info']['detailed_info'] = $media_url->detailed_info;
				if (isset($media_url->description))
					$items[$key]['file_info']['description'] = $media_url->description;
				if ($qltyMax == true)
					$items[$key]['file_info']['qltyMax'] = $qltyMax;
			}
		}
		return $items;
	}
	public static function http_get_img ($url){
		if (self::$proxy == true){
			$path_parts = parse_url(self::getDomainName());
			if (!preg_match("|^http|",$url))
				return DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . self::getDomainName() . $url . "&proxy=" . self::$cName;
			if (preg_match("|".$path_parts['host']."|",$url))
				return DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . $url . "&proxy=" . self::$cName;
		}
		if (!preg_match("|^http|",$url))
			$url = self::getDomainName() . $url;
		return DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . $url;
	}
	public static function http_get_document ($url, $opts=null){
		
		if (is_null(self::$proxy)){
			self::$proxy = false;
			$sitesProxy = HD::getItemsArr('sitesProxy');
			if (isset($sitesProxy[self::$cName])){
				$proxySettings = (HD::getItemsArr('proxySettings') != array()) ? HD::getItemsArr('proxySettings') : array();
				if (isset($proxySettings['proxy'])){
					self::$proxy['proxy'] = $proxySettings['proxy'];
					if ((isset($proxySettings['proxyType']))&&($proxySettings['proxyType'] == 'SOCKS5'))
						self::$proxy['proxyType'] = $proxySettings['proxyType'];
					if (isset($proxySettings['proxyAccount']))
						self::$proxy['proxyAccount'] = $proxySettings['proxyAccount'];
				}
			}
		}
		if (self::$proxy == true){
			$opts[CURLOPT_PROXY] = self::$proxy['proxy'];
			if (isset(self::$proxy['proxyType']))
				$opts[CURLOPT_PROXYTYPE] = CURLPROXY_SOCKS5;
			if (isset(self::$proxy['proxyAccount']))
				$opts[CURLOPT_PROXYUSERPWD] = self::$proxy['proxyAccount'];
		}
		$header[] = 'cache-control: max-age=0';
		$header[] = 'upgrade-insecure-requests: 1';
		$header[] = 'origin: ' . self::getDomainName();
		$header[] = 'content-type: application/x-www-form-urlencoded';
		$header[] = 'accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3;q=0.9' ;
		$header[] = 'referer: '.self::getDomainName().'/index.php?do=search';
		$header[] = 'accept-language: ru,uk;q=0.9,en-US;q=0.8,en;q=0.7,en-GB;q=0.6' ;
		$opts[CURLOPT_HTTPHEADER] = $header;
		return HD::http_get_document($url, $opts);
	}
}
?>
