<?php
if (!class_exists('DuneSystem')){
	if (preg_match('|plugins/(.*?)/lib|', __DIR__, $matches)){
		$tmp_path = '/tmp/plugins/'.$matches[1];
		$plugin_name = $matches[1];
		$install_dir = str_replace('/lib/wox', '',  __DIR__);
		if (file_exists('/persistfs/plugins_data'))
			$data_dir = "/persistfs/plugins_data/$plugin_name";
		else
			$data_dir = "/flashdata/plugins_data/$plugin_name";
        $port = HD::http_local_port();
		$www_url = "http://127.0.0.1:$port/plugins/$plugin_name/";
		$cgi_url = "http://127.0.0.1:$port/cgi-bin/plugins/$plugin_name/";
	}

	function hd_print($str){
		echo $str;
	}
	class DuneSystem{
		public static $properties = array ();
	};
	DuneSystem::$properties['plugin_name']      = $plugin_name;
	DuneSystem::$properties['install_dir_path'] = $install_dir;
	DuneSystem::$properties['tmp_dir_path']     = $tmp_path;
	DuneSystem::$properties['plugin_www_url']   = $www_url;
	DuneSystem::$properties['plugin_cgi_url']   = $cgi_url;
	DuneSystem::$properties['data_dir_path']    = $data_dir;
}



class NNMclub_Class {
	static $cName = 'NNM-Club';
	static $className = 'NNMclub_Class';
	static $DomainName = null;
	static $proxyArr = null;
	static $proxyArrMd5 = null;
	static $proxy = null;
	static $logIn = 'noCheck';
	public static function getDomainName(){
		if (null === self::$DomainName)
			self::$DomainName = (HD::getItemStr(self::$cName . 'DomainName') != '') ? HD::getItemStr(self::$cName . 'DomainName') : 'http://nnmclub.to';
		return self::$DomainName;
	}
	public static function getMainMenuInfo(){
		return array (
			'name' => self::$cName,
			'descr' => '||'.self::$cName.'|каталог и источник торрентов с сайта '.self::$cName.'.||Внимание:|Авторизация работает только на с http версией сайта||Если сайт не доступен используйте прокси или VPN, а так же официальные зеркала (сайты с похожим дизайном и названием могут не являтся зеркалом)'
		);
	}
	public static function get_media_url_str($k, $arr=null){
		if ($arr == true)
			return SmartVodCategoryListScreen::get_media_url_str($k, $arr);
		return SmartVodCategoryListScreen::get_media_url_str($k);
	}
	public static function getSearchMediaUrlStr($k, $arr = null){
		return SmartVodSimpleListScreen::get_media_url_str($k, $arr);
	}
	public static function checkLogIn(){
		if (self::$logIn == 'noCheck'){
			$eney = HD::getItemsArr('eney');
			if (isset($eney[self::$cName])){
				$ul = HD::eney('l', $eney[self::$cName][0]);
				$up = HD::eney('p', $eney[self::$cName][1]);
				if (file_exists(self::cookie())){
					$doc = HD::http_get_document(self::getDomainName());
					if (preg_match('|login.php\?logout=true|', $doc))
						self::$logIn = 'true';
				}
				if (self::$logIn == 'noCheck'){
					$cgr = self::testEneyIn();
					if ($cgr == false)
						self::$logIn = 'false';
					else
						self::$logIn = 'true';
				}
			}else
				self::$logIn = 'false';
		}
		return self::$logIn;
	}
	public static function testEneyIn($ul = null, $up = null){
		if ($ul == false){
			$eney = HD::getItemsArr('eney');
			if (isset($eney[self::$cName])){
				$ul = HD::eney('l', $eney[self::$cName][0]);
				$up = HD::eney('p', $eney[self::$cName][1]);
			}else
				return false;
		}
		if (file_exists(self::cookie()))
			unlink(self::cookie());
		$opts [CURLOPT_COOKIEJAR]	= self::cookie();
		$opts[CURLOPT_POST] = true;
		$opts[CURLOPT_POSTFIELDS] = "username=$ul&password=$up&autologin=on&redirect=&login=%C2%F5%EE%E4";
		$doc = iconv('windows-1251', 'UTF-8', self::http_get_document(self::getDomainName() . '/forum/login.php',$opts));
		if (preg_match("|login.php\?logout=true|",$doc)){
			self::$logIn = 'true';
			return true;
		}else{
			self::$logIn = 'false';
			if (file_exists(self::cookie()))
				unlink(self::cookie());
			return false;
		}
	}
	public static function getPopUpMenuItems ($selected_media_url, $parent_media_url){
		$menu_items = array();
		if ($parent_media_url == 'main_menu'){
			$menu_items[] = array(
				'caption' => base64_decode('0JDQstGC0L7RgNC40LfQsNGG0LjRjyDQvdCwIA') . self::$cName,
				'params' => array ('action' => 'eneyIn'),
				'icon_url' => SmartConfig::getPluginIco('s_user')
			);
			$menu_items[] = array(
				'caption' => 'Задать зеркало ' . self::$cName,
				'params' => array ('action' => 'mirror'),
				'icon_url' => SmartConfig::getPluginIco('s_' . self::$className)
			);
			$menu_items[] = array(
				'caption' => 'Прокси для ' . self::$cName,
				'params' => array ('action' => 'proxy'),
				'icon_url' => SmartConfig::getPluginIco('s_proxy')
			);
			$menu_items[] = 'is_separator';
		}
		$parent_media_url = MediaURL::decode($parent_media_url);
		if ($parent_media_url->screen_id == 'vod_torrentlist'){
			
			$menu_items[] = array(
				'caption' => 'Изменить действие для торрентов',
				'params' => array ('action' => 'torrentActionSetup'),
				'icon_url' => SmartConfig::getPluginIco('s_torrent')
			);
			$menu_items[] = array(
				'caption' => 'Выбрать действие торрента',
				'conID' => 'add_actions',
				'params' => array ('torrentAction' => 1),
				'icon_url' => SmartConfig::getPluginIco('s_list')
			);
			$menu_items[] = 'is_separator';
			$menu_items[] = array(
				'caption' => 'Настройки TorrServer',
				'conID' => 'classSetupTorrServer',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_torrserver')
			);
			$menu_items[] = array(
				'caption' => 'Настройки PeerflixServer',
				'conID' => 'classSetupPeerflixServer',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_peerflixserver')
			);
			$menu_items[] = array(
				'caption' => 'Настройки Transmission',
				'conID' => 'classSetupTransmission',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_transmission')
			);
			$menu_items[] = array(
				'caption' => 'Настройки Transmission UPnP',
				'conID' => 'classSetupTransmissionUPnP',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_transmissionupnp')
			);
			$menu_items[] = 'is_separator';
		}
		if ((isset($parent_media_url->screen_id))&&($parent_media_url->screen_id != 'vod_series')){
			$menu_items[] = array(
				'caption' => 'Добавить в Главное меню',
				'params' => array ('action' => 'addToMainMenu'),
				'icon_url' => SmartConfig::getPluginIco('s_home')
			);
		}
		
		return $menu_items;
	}
	public static function getScreenActionMapArr($media_url){
		$actionsArr = array();
		return $actionsArr;
	}
	public static function getVodCategories($media_url){
		static $categories = null;
		if (is_null($categories)){
			$categories[] = array('id'=> 'search', 'class' => 'SmartSearchScreen', 'caption' => 'Поиск');
			$categories[] = array('id'=> '/forum/portal.php?s=platinum', 'class' => 'SmartVodListScreen', 'caption' => 'Платиновые раздачи');
			$doc = iconv('windows-1251', 'UTF-8', self::http_get_document(self::getDomainName()));
			self::checkLogIn();
			if(preg_match_all ('|<a class="genmed" href="(portal.php.*?)".*?>(.*?)<|ms', $doc, $match))
				foreach ($match[2] as $k =>  $v)
					if (!preg_match('|recommend|', $match[1][$k]))
						$categories[] = array('id'=> '/forum/' . $match[1][$k], 'class' => 'SmartVodListScreen', 'caption' => HD::str_remove_tag($v));
		}
		return $categories;
	}
	public static function getShortMovieRange ($media_url, &$m_feed){
		if ($m_feed === 'end')
			return $items;
		$doc = iconv('windows-1251', 'UTF-8', self::http_get_document(self::getDomainName() . $media_url->categoryId . '&start=' . ($m_feed * 16)));
		++$m_feed;
		if (!preg_match('|">След.</a>|', $doc))
			$m_feed = 'end';
		return self::parseSitePage($doc);
	}
	public static function getSearchShortMovieRange ($keyword, &$m_feed){
		if (is_object($keyword))
			$keyword = $keyword->searchStr;
		if ($m_feed === 'end')
			return array();
		$doc = iconv('windows-1251', 'UTF-8', HD::http_get_document(self::getDomainName() . '/forum/portal.php?q=' .urlencode (iconv('UTF-8', 'windows-1251', $keyword)). '&start=' . ($m_feed * 16)));
		++$m_feed;
		if (!preg_match('|">След.</a>|', $doc))
			$m_feed = 'end';
		return self::parseSitePage($doc);
	}
	public static function parseSitePage($doc){
		$items = array();
		$ico = SmartConfig::getPluginIco(self::$className);
		if (preg_match_all('|pgenmed" href="(.*?)".*?">(.*?)</.*?title="(.*?)".*?Img".*?class="pims">(.*?)</.*?bold">(.*?)<.*?х">(.*?)<.*?т">(.*?)<|ms', $doc, $matches)){
			foreach ($matches[1] as $k => $v){
				$caption = HD::str_remove_tag($matches[2][$k]);
				if (preg_match('|image.php\?link=(.*?)"|ms', $matches[0][$k], $match))
					$poster_url = self::http_get_img (urldecode($match[1]));
				else
					$poster_url = SmartConfig::getPluginIco(self::$className);
				$short_movie = new ShortMovie(
					strval('/forum/' . trim($v)),
					strval($caption),
					strval($poster_url)
				);
				$info = '||' . $caption;
				$size = HD::str_remove_tag($matches[5][$k]);
				if (preg_match('|отдачи">(.*?)<|ms', $matches[0][$k], $match))
					$s  = HD::str_remove_tag($matches[6][$k]) . ' (' . HD::str_remove_tag($match[1]) . ')';
				else
					$s	= HD::str_remove_tag($matches[6][$k]);
				if (preg_match('|скачивания">(.*?)<|ms', $matches[0][$k], $match))
					$l	= HD::str_remove_tag($matches[7][$k]) . ' (' . HD::str_remove_tag($match[1]). ')';
				else
					$l	= HD::str_remove_tag($matches[7][$k]);
				$info .= '|Размер: ' . $size;
				$info .= '||Seed: ' . $s . ' Leech: ' . $l;
				$info .= '||Коментариев: ' . HD::str_remove_tag($matches[4][$k]);
				$info .= '||' . HD::str_remove_tag($matches[3][$k]);
				$short_movie->details_box_width = true;
				$short_movie->extra_item = $size;
				$short_movie->info = $info;
				array_push ($items, $short_movie);
			}
		}
		return $items;
	}
	public static function load_movie($movie_id, $mUrl, $getMovieInfo){
		$arr = array();
		$arr['caption'] = $arr['class_info']['catalog_info']['caption'] = $mUrl->caption;
		$arr['poster_url'] = $arr['class_info']['catalog_info']['poster_url'] = $mUrl->poster_url;
		if (isset($mUrl->caption_original))
			$arr['caption_original'] = $arr['class_info']['catalog_info']['caption_original'] = $mUrl->caption_original;
		if (isset($mUrl->year))
			$arr ['year'] = $arr['class_info']['catalog_info']['year'] = $mUrl->year;
		
		if (!preg_match("|^http|",$movie_id))
			$movie_id = self::getDomainName() . $movie_id;
		$doc = iconv('windows-1251', 'UTF-8', self::http_get_document($movie_id));
		if (preg_match('|<h1.*?">(.*?)</h1>|ms', $doc, $match))
			$capt = $arr ['caption'] = HD::str_remove_tag($match[1]);
		if (preg_match('|class="postImg.*?link=(.*?)"|ms', $doc, $match))
			$arr['poster_url'] = $match[1];
		
		if (preg_match('|<div class="postbody".*?>(.*?)<table|ms', $doc, $match)){
			$match[1] = preg_replace("|<br.*?>|", "\n", $match[1]);
			$arr ['description'] = HD::str_remove_tag($match[1]);
		}
		if (preg_match_all('|class="postImg.*?link=(.*?)"|ms', $match[1], $match)){
			unset ($match[1][0]);
			unset ($match[1][1]);
			$arr ['background_urls'] = $match[1];
		}
		if (preg_match('|kinopoisk.ru/film/(\d*)|ms', $doc, $match))
			$arr['class_info']['dbIDs']['kpID'] = $match[1];
		else if (preg_match('|kinopoisk.ru/rating/(\d*?)\.|ms', $doc, $match))
			$arr['class_info']['dbIDs']['kpID'] = $match[1];
		else{
			$kpIDs = HD::getItemsArr('kpIDs');
			if (isset($kpIDs[$movie_id]))
				$arr['class_info']['dbIDs']['kpID'] = $kpIDs[$movie_id];
		}
		if (preg_match('|imdb.com/title/tt(\d*?)/|ms', $doc, $match))
			$arr['class_info']['dbIDs']['imdbID'] = 'tt'. $match[1];
		if (!isset($arr['class_info']['dbIDs']['kpID'])){
			$arr['class_info']['goToScreen'] = 'SmartVodTorrentsScreen';
			$arr['class_info']['noTrailers'] = true;
		}else
			$arr = SmartConfig::getMovieInfoArr($getMovieInfo, $movie_id, $mUrl, $arr);
		if ($capt == $arr['caption'])
			$arr['class_info']['goToScreen'] = 'SmartVodTorrentsScreen';
		if (preg_match('|арегистрирован:(.*?)</tr>|ms', $doc, $match))
			$add_date = HD::str_remove_tag($match[1]);
		if (preg_match('|азмер:(.*?)</tr>|ms', $doc, $match))
			$size = HD::str_remove_tag($match[1]);
		if (preg_match('|eeders:(.*?)</tr>|ms', $doc, $match))
			$seed = HD::str_remove_tag($match[1]);
		if (preg_match('|eechers:(.*?)</tr>|ms', $doc, $match))
			$leech = HD::str_remove_tag($match[1]);
		if (preg_match('|genmed"><b><a href="(.+?)"|', $doc, $match)){
			$torrentId = $match[1];
			$arr['class_info']['torrent'][self::$className][$torrentId]['caption'] = $capt;
			$arr['class_info']['torrent'][self::$className][$torrentId]['type'] = 'torrent';
			$arr['class_info']['torrent'][self::$className][$torrentId]['size'] = $size;
			$arr['class_info']['torrent'][self::$className][$torrentId] ['add_date'] = $add_date;
			$arr['class_info']['torrent'][self::$className][$torrentId] ['S'] = $seed;
			$arr['class_info']['torrent'][self::$className][$torrentId] ['L'] = $leech;
		}
		if (preg_match('|href="magnet:\?xt=(.*?)"|ms', $doc, $match)){
			$torrentId = 'magnet:?xt='.$match[1];
			$arr['class_info']['torrent'][self::$className][$torrentId]['caption'] = $capt;
			$arr['class_info']['torrent'][self::$className][$torrentId]['type'] = 'magnet';
			$arr['class_info']['torrent'][self::$className][$torrentId]['size'] = $size;
			$arr['class_info']['torrent'][self::$className][$torrentId] ['add_date'] = $add_date;
			$arr['class_info']['torrent'][self::$className][$torrentId] ['S'] = $seed;
			$arr['class_info']['torrent'][self::$className][$torrentId] ['L'] = $leech;
		}
		return $arr;
	}
	public static function getVodSourceInfo($v){
		// self::checkLogIn();
		$ico = SmartConfig::getPluginIco(self::$className);
		$sources['caption'] = self::$cName;
		$sources['detailed_info'] = '||'.self::$cName.'|Торрент файлы найденные на '.self::$cName.' по названию. Так как поиск производится по названию возможны неточности.';
		$sources['icon_path'] = $ico;
		$sources['detailed_icon_path'] = $ico;
		$sources['goTo'] = 'SmartVodTorrentsScreen';
		$sources['class_name'] = $v;
		$sources['type'] = SmartConfig::getPluginIco('torrentSource');
		return $sources;
	}
	public static function getShortTorrentRange ($movie, $media_url, &$m_feed){
		$items = array();
		self::checkLogIn();
		if ($m_feed === 'end')
			return $items;
		if (isset($movie->class_info['torrent'][self::$className])){
			foreach ($movie->class_info['torrent'][self::$className] as $k => $v){
				$caption = $v['caption'];
				$short_movie = new ShortMovie(
					strval(trim($k)),
					strval($caption),
					strval($movie->poster_url)
				);
				$short_movie->icon_path = SmartConfig::getPluginIco('s_' . $v['type']);
				$short_movie->tType = $v['type'];
				$info = '||' . $caption . '|'. self::$cName;
				
				$info .= '||Размер|' . $v['size'];
				$info .= '||Seed:|' . $v ['S'];
				$info .= '||Leech:|' . $v['L'];
				$info .= '||Добавлен:|' . $v['add_date'];
				$short_movie->info = $info;
				$short_movie->extra_item = $v['size'];
				array_push ($items, $short_movie);
			}
			$m_feed = 'end';
			return $items;
		}
		$keyword = $movie->name;
		$itemsObj = self::getSearchShortMovieRange ($keyword, $m_feed);
		$ico = SmartConfig::getPluginIco('s_torrent');
		foreach($itemsObj as $v){
			$v->icon_path = $ico;
			$v->tType = 'torrent';
			$items[] = $v;
		}
		return $items;
	}
	public static function getTorrentFile($torrent_id, $dloadPath=null){
		if (preg_match("/forum/",$torrent_id)){
			if (!preg_match("|^http|",$torrent_id))
				$torrent_id = self::getDomainName() . $torrent_id;
			$doc = iconv('windows-1251', 'UTF-8', self::http_get_document($torrent_id));
			if (preg_match('|genmed"><b><a href="(.+?)"|', $doc, $match))
				$torrent_id = $match[1];
			else if (preg_match('|href="magnet:\?xt=(.*?)"|ms', $doc, $match))
				$torrent_id = 'magnet:?xt='.$match[1];
			else
				return array("status" => false,"descr" => "Этот файл не является торрент файлом. Возможно произошла ошибка при загрузке торрент файла");
		}
		if (preg_match("|magnet:\?xt=|",$torrent_id)){
			$torrentFile["status"] = true;
			$torrentFile["path"] = $torrent_id;
			return $torrentFile;
		}
		if (!preg_match("|^http|",$torrent_id))
			$torrent_id = self::getDomainName() . '/forum/' . $torrent_id;
		$doc = self::http_get_document($torrent_id);
		return SmartConfig::checkTorrent($dloadPath, $doc);
	}
	public function meinMenuOpenFolderDialog($user_input){
		if (self::checkLogIn() == 'false'){
			$alertOff = (HD::getItemStr(self::$cName . 'AlertOff') != '') ? HD::getItemStr(self::$cName . 'AlertOff') : false;
			$add_params['action'] = $user_input->action;
			if ((!isset($user_input->closed_dialog))&&($alertOff == false)){
				$add_params['closed_dialog']= true;
				ControlFactory::add_multiline_label($defs, '', "Для полноценного использования каталога и источника ".self::$cName." необходима авторизация (POPUP MENU на каталоге), без авторизации не доступны торрент файлы, только магнет линки!",5);		
				ControlFactory::add_close_dialog_and_apply_button($defs, $this, array ('action' => 'eneyIn'), 'classAction', base64_decode('0JDQstGC0L7RgNC40LfQsNGG0LjRjyDQvdCwIA') . self::$cName, 600);
				ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id, 'Продолжить без авторизации', 600);
				$add_params['alertOff']= true;
				ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id, 'Больше не показывать', 600);
				return  ActionFactory::show_dialog('Внимание!',$defs, true,900,$attrs);
			}
			if (isset($user_input->alertOff))
				if (HD::saveItemStr(self::$cName . 'AlertOff', 1) == false)
					return ActionFactory::show_title_dialog("Сохранение не удалось");
		}
		return ActionFactory::open_folder();
	}
	public static function http_get_img ($url){
		if (preg_match("|^//|",$url))
			return 'http:' . $url;
		if (preg_match("|https|",$url))
			return DuneSystem::$properties['plugin_cgi_url'] . "do?img=" .  $url;	
		return $url;
	}
	public static function cookie(){
		return DuneSystem::$properties['tmp_dir_path'] . "/" . self::$cName . "Cookie";
	}
	public static function http_get_document ($url, $opts=null){
		if (!isset($opts[CURLOPT_COOKIEJAR])){
			$cgr = true;
			if (!file_exists(self::cookie()))
				$cgr = self::testEneyIn();
			if ($cgr == true)
				$opts[CURLOPT_COOKIEJAR] = $opts[CURLOPT_COOKIEFILE] = self::cookie();
		}
		if (is_null(self::$proxy)){
			self::$proxy = false;
			$sitesProxy = HD::getItemsArr('sitesProxy');
			if (isset($sitesProxy[self::$cName])){
				$proxySettings = (HD::getItemsArr('proxySettings') != array()) ? HD::getItemsArr('proxySettings') : array();
				if (isset($proxySettings['proxy'])){
					self::$proxy['proxy'] = $proxySettings['proxy'];
					if ((isset($proxySettings['proxyType']))&&($proxySettings['proxyType'] == 'SOCKS5'))
						self::$proxy['proxyType'] = $proxySettings['proxyType'];
					if (isset($proxySettings['proxyAccount']))
						self::$proxy['proxyAccount'] = $proxySettings['proxyAccount'];
				}
			}
		}
		if (self::$proxy == true){
			$opts[CURLOPT_PROXY] = self::$proxy['proxy'];
			if (isset(self::$proxy['proxyType']))
				$opts[CURLOPT_PROXYTYPE] = CURLPROXY_SOCKS5;
			if (isset(self::$proxy['proxyAccount']))
				$opts[CURLOPT_PROXYUSERPWD] = self::$proxy['proxyAccount'];
		}
		return HD::http_get_document($url, $opts);
	}
}
?>
