<?php
if (!class_exists('DuneSystem')){
	if (preg_match('|plugins/(.*?)/lib|', __DIR__, $matches)){
		$tmp_path = '/tmp/plugins/'.$matches[1];
		$plugin_name = $matches[1];
		$install_dir = str_replace('/lib/wox', '',  __DIR__);
		if (file_exists('/persistfs/plugins_data'))
			$data_dir = "/persistfs/plugins_data/$plugin_name";
		else
			$data_dir = "/flashdata/plugins_data/$plugin_name";
        $port = HD::http_local_port();
		$www_url = "http://127.0.0.1:$port/plugins/$plugin_name/";
		$cgi_url = "http://127.0.0.1:$port/cgi-bin/plugins/$plugin_name/";
	}

	function hd_print($str){
		echo $str;
	}
	class DuneSystem{
		public static $properties = array ();
	};
	DuneSystem::$properties['plugin_name']      = $plugin_name;
	DuneSystem::$properties['install_dir_path'] = $install_dir;
	DuneSystem::$properties['tmp_dir_path']     = $tmp_path;
	DuneSystem::$properties['plugin_www_url']   = $www_url;
	DuneSystem::$properties['plugin_cgi_url']   = $cgi_url;
	DuneSystem::$properties['data_dir_path']    = $data_dir;
}
class Pickfilm_Class {
	static $cName = 'Pickfilm';
	static $className = 'Pickfilm_Class';
	static $DomainName = null;
	static $proxyArr = null;
	static $proxyArrMd5 = null;
	static $proxy = null;
	public static function getDomainName(){
		if (null === self::$DomainName)
			self::$DomainName = (HD::getItemStr(self::$cName . 'DomainName') != '') ? HD::getItemStr(self::$cName . 'DomainName') : 'http://pickfilm.ru';
		return self::$DomainName;
	}
	public static function getMainMenuInfo(){
		return array (
			'name' => self::$cName,
			'descr' => '||'.self::$cName.'|каталог и источник торрентов с сайта ' . self::$cName . '||Если сайт не доступен используйте прокси или VPN, а так же официальные зеркала (сайты с похожим дизайном и названием могут не являтся зеркалом)'
		);
	}
	public static function get_media_url_str($k, $arr=null){
		if ($arr == true)
			return SmartVodCategoryListScreen::get_media_url_str($k, $arr);
		return SmartVodCategoryListScreen::get_media_url_str($k);
	}
	public static function getSearchMediaUrlStr($k, $arr=null){
		return SmartVodListScreen::get_media_url_str($k, $arr);
	}
	public static function getPopUpMenuItems ($selected_media_url, $parent_media_url){
		$menu_items = array();
		if ($parent_media_url == 'main_menu'){
			$menu_items[] = array(
				'caption' => 'Задать зеркало ' . self::$cName,
				'params' => array ('action' => 'mirror'),
				'icon_url' => SmartConfig::getPluginIco('s_' . self::$className)
			);
			$menu_items[] = array(
				'caption' => 'Прокси для ' . self::$cName,
				'params' => array ('action' => 'proxy'),
				'icon_url' => SmartConfig::getPluginIco('s_proxy')
			);
			$menu_items[] = 'is_separator';
		}
		$parent_media_url = MediaURL::decode($parent_media_url);
		if ($parent_media_url->screen_id == 'vod_torrentlist'){
			
			$menu_items[] = array(
				'caption' => 'Изменить действие для торрентов',
				'params' => array ('action' => 'torrentActionSetup'),
				'icon_url' => SmartConfig::getPluginIco('s_torrent')
			);
			$menu_items[] = array(
				'caption' => 'Выбрать действие торрента',
				'conID' => 'add_actions',
				'params' => array ('torrentAction' => 1),
				'icon_url' => SmartConfig::getPluginIco('s_list')
			);
			$menu_items[] = 'is_separator';
			$menu_items[] = array(
				'caption' => 'Настройки TorrServer',
				'conID' => 'classSetupTorrServer',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_torrserver')
			);
			$menu_items[] = array(
				'caption' => 'Настройки PeerflixServer',
				'conID' => 'classSetupPeerflixServer',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_peerflixserver')
			);
			$menu_items[] = array(
				'caption' => 'Настройки Transmission',
				'conID' => 'classSetupTransmission',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_transmission')
			);
			$menu_items[] = array(
				'caption' => 'Настройки Transmission UPnP',
				'conID' => 'classSetupTransmissionUPnP',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_transmissionupnp')
			);
			$menu_items[] = 'is_separator';
		}
		if ((isset($parent_media_url->screen_id))&&($parent_media_url->screen_id != 'vod_series')){
			$menu_items[] = array(
				'caption' => 'Добавить в Главное меню',
				'params' => array ('action' => 'addToMainMenu'),
				'icon_url' => SmartConfig::getPluginIco('s_home')
			);
		}
		
		return $menu_items;
	}
	public static function getScreenActionMapArr($media_url){
		$actionsArr = array();
		return $actionsArr;
	}
	public static function getVodCategories($media_url){
		$categories[] = array('id'=> 'search', 'class' => 'SmartSearchScreen', 'caption' => 'Поиск');
		$categories[] = array('id'=> '/new/all/', 'class' => 'SmartVodListScreen', 'caption' => 'Все');
		$categories[] = array('id'=> '/new-torrent/', 'class' => 'SmartVodListScreen', 'caption' => 'Фильмы');
		$categories[] = array('id'=> '/last-tv-torrent/', 'class' => 'SmartVodListScreen', 'caption' => 'Сериалы');
		$categories[] = array('id'=> '/last-multfilm-torrent/', 'class' => 'SmartVodListScreen', 'caption' => 'Мультфильмы');
		$categories[] = array('id'=> '/new/documentary/', 'class' => 'SmartVodListScreen', 'caption' => 'Передачи');
		$categories[] = array('id'=> '/new/music/', 'class' => 'SmartVodListScreen', 'caption' => 'Музыка');
		$categories[] = array('id'=> '/tags/', 'class' => 'SmartVodTetragonListScreen', 'caption' => 'Подборки');
		return $categories;
	}
	public static function getShortMovieRange ($media_url, &$m_feed){
		if ($m_feed === 'end')
			return $items;
		$url =  self::getDomainName() . $media_url->categoryId;
		if ($m_feed > 0)
			$url .= ($m_feed+1) . '.html?pages=50';
		$doc = self::http_get_document($url);
		++$m_feed;
		if ((preg_match("|float_right'><em>|", $doc))||
		($media_url->categoryId =='/tags/'))
			$m_feed = 'end';
		return self::parseSitePage($doc, $media_url->categoryId);
	}
	public static function getSearchShortMovieRange ($keyword, &$m_feed){
		if (is_object($keyword))
			$keyword = $keyword->searchStr;
		if ($m_feed === 'end')
			return array();
		$doc = HD::http_get_document(self::getDomainName() . '/search/' . urlencode($keyword) . '/' . ($m_feed+1) . '.html');
		++$m_feed;
		if (preg_match("|float_right'><em>|", $doc))
			$m_feed = 'end';
		return self::parseSitePage($doc);
	}
	public static function parseSitePage($doc, $categoryId=null){
		$items = array();
		if (($categoryId == true)&&($categoryId =='/tags/')){
			if (preg_match_all('|item_tag">.*?href="(.*?)".*?url\((.+?)\).*?>(.*?)</a>|ms', $doc, $match)){
				foreach ($match[1] as $k => $v){
					$name	= HD::str_remove_tag($match[3][$k]);
					$img = $match[2][$k];
					if (!preg_match('|^http|',$match[2][$k]))
						$img = self::getDomainName() . $match[2][$k];	
					$short_movie = new ShortMovie(
						strval($v),
						strval($name),
						strval(self::http_get_img ($img))
					);
					$info = '||Подборка|' .  $name;
					$short_movie->info = $info;
					$short_movie->goToScreen = 'SmartVodListScreen';
					array_push ($items, $short_movie);
				}
			}
		}
		if (preg_match_all ('|class=\'film-image\' alt="(.+?)".*?href="(.+?)".*?url\((.+?)\).*?film-download|ms', $doc, $match)){
			foreach ($match[2] as $k => $v){
				$name	= HD::str_remove_tag($match[1][$k]);
				$img = $match[3][$k];
				if (!preg_match('|^http|',$match[3][$k]))
					$img = self::getDomainName() . $match[3][$k];	
				$short_movie = new ShortMovie(
					strval($v),
					strval($name),
					strval(self::http_get_img ($img))
				);
				$info = '||' . $name;
				if (preg_match('|alternativeHeadline">(.+?)<|ms', $match[0][$k], $matches))
					$info .= '|' . HD::str_remove_tag($matches[1]);
				if (preg_match("|cn-icon.*?title='(.+?)'|ms", $match[0][$k], $matches))
					$info .= '||' . HD::str_remove_tag($matches[1]);
				if (preg_match('|film-genre\'>(.+?)</div|ms', $match[0][$k], $matches))
					$info .= '|' . HD::str_remove_tag($matches[1]);
				if (preg_match('|class="qa-icon.*?>(.+?)<|ms', $match[0][$k], $matches)){
					$qlty = HD::str_remove_tag(str_replace('tag', ' ', $matches[1]));
					$info .= '|' . $qlty;
				}
				if (preg_match('|nav-tag_blue">.*?>(.+?)</div>|ms', $match[0][$k], $matches))
					$info .= '|' . HD::str_remove_tag(str_replace('tag', ' ', $matches[1]));
				if (preg_match_all('| class="align-l">(.+?)</div>|ms', $match[0][$k], $matches))
					foreach ($matches[1] as $vel)
						$info .= '|' . HD::str_remove_tag($vel);
				$short_movie->info = $info;
				if ($qlty == true){
					$short_movie->right_top_img = $short_movie->left_bottom_img = false;
					$right_top_img = SmartConfig::getQualityIco($qlty);
					$short_movie->right_top_img = $right_top_img;
				}
				array_push ($items, $short_movie);
			}
		}
		return $items;
	}
	public static function load_movie($movie_id, $mUrl, $getMovieInfo){
		$arr = array();
		$arr['caption'] = $arr['class_info']['catalog_info']['caption'] = $mUrl->caption;
		$arr['poster_url'] = $arr['class_info']['catalog_info']['poster_url'] = $mUrl->poster_url;
		if (isset($mUrl->caption_original))
			$arr['caption_original'] = $arr['class_info']['catalog_info']['caption_original'] = $mUrl->caption_original;
		if (isset($mUrl->year))
			$arr ['year'] = $arr['class_info']['catalog_info']['year'] = $mUrl->year;
		if (!preg_match("|^http|",$movie_id))
			$movie_id = self::getDomainName() . $movie_id;
		$doc = self::http_get_document($movie_id);
		if (preg_match("|film_name'>(.*?)<|ms", $doc, $match))
			$arr ['caption'] = HD::str_remove_tag($match[1]);
		if (preg_match("|film_name_orig'>(.*?)<|ms", $doc, $match))
			$arr ['caption_original'] = HD::str_remove_tag($match[1]);
		if (preg_match('|slideshow1\' href="(.*?)"|ms', $doc, $match))
			$arr ['poster_url'] = HD::str_remove_tag($match[1]);
		if (preg_match('|Страны</strong>:(.*?)</p|ms', $doc, $match))
			$arr ['country'] = HD::str_remove_tag($match[1]);
		if (preg_match("|lass='justify'>(.*?)</|ms", $doc, $match))
			$arr ['description'] = HD::str_remove_tag($match[1]);
		if (preg_match("|В ролях</strong>:(.*?)</div>|ms", $doc, $match))
			$arr ['actors'] = HD::str_remove_tag(str_replace('</a></li><li>', ', ', $match[1]));
		if (preg_match("|ежиссер</strong>:(.*?)</div>|ms", $doc, $match))
			$arr ['director'] = HD::str_remove_tag(str_replace('</a></li><li>', ', ', $match[1]));
		if (preg_match_all ('|class=\'slideshow\' href="(.*?)"|ms', $doc, $matches))
			foreach ($matches[1] as $k => $v)
				$arr ['background_urls'][] = self::http_get_img ($v);
		if (preg_match('|render_youtube" obj_id="(.+?)"|ms', $doc, $match))
			$arr['class_info']['trailers'][]= 'https://www.youtube.com/watch?v=' . $match[1];
		if (preg_match('|kinopoisk_id.+?(\d*);|ms', $doc, $match))
			$arr['class_info']['dbIDs']['kpID'] = $match[1];
		else if (preg_match('|kinopoisk.ru/film/(\d*)|ms', $doc, $match))
			$arr['class_info']['dbIDs']['kpID'] = $match[1];
		else if (preg_match('|kinopoisk.ru/rating/(\d*?)\.|ms', $doc, $match))
			$arr['class_info']['dbIDs']['kpID'] = $match[1];
		else{
			$kpIDs = HD::getItemsArr('kpIDs');
			if (isset($kpIDs[$movie_id]))
				$arr['class_info']['dbIDs']['kpID'] = $kpIDs[$movie_id];
		}
		if (preg_match('|zt\/(\d*?)\.png|ms', $doc, $match))
			$arr['class_info']['dbIDs']['imdbID'] = 'tt' . HD::str_remove_tag($match[1]);
		if (!isset($arr['class_info']['dbIDs']['kpID']))
			$arr['class_info']['goToScreen'] = 'SmartVodTorrentsScreen';
		else
			$arr = SmartConfig::getMovieInfoArr($getMovieInfo, $movie_id, $mUrl, $arr);
		if (preg_match_all("|upload1'>.*?<div class='c3'>(.*?)<.*?href=\"(.*?)\".*?<center class=\"box\"|ms", $doc, $matches)){
			foreach($matches[2] as $k => $v){
				if (preg_match('|torrent-info.+?download-event\'>(.+?)</|ms', $matches[0][$k], $match))
					$capt = HD::str_remove_tag($match[1]);
				$arr['class_info']['torrent'][$v]['caption'] = $capt;
				$arr['class_info']['torrent'][$v]['size'] = $matches[1][$k];
				if (preg_match('|torrent-info.+?download-event\'>(.+?)<center class="box"|ms', $matches[0][$k], $match)){
					$info = '';
					$tmp = explode("<br/>", $match[1]);
					unset ($tmp[0]);
					foreach($tmp as $vel)
						$info .= "||" . str_replace("@[emailprotected]", "", HD::str_remove_tag($vel));
					$arr['class_info']['torrent'][$v]['info'] =  str_replace(array("||||",'[]'), array( "||",''), $info);
				}
			}
		}else
			$arr['class_info']['torrent'] = 'notrt';
		return $arr;
	}
	public static function getShortTorrentRange ($movie, $media_url, &$m_feed){
		$items = array();
		if ($m_feed === 'end')
			return $items;
		$icon_path = SmartConfig::getPluginIco('s_torrent');
		if (isset($movie->class_info['torrent'])){
			if ($movie->class_info['torrent'] == 'notrt'){
				$icon_path = SmartConfig::getPluginIco(0);
				$short_movie = new ShortMovie(
					strval('notrt'),
					strval('Торренты удалены по требованию правообладателя'),
					strval($movie->poster_url)
				);
				$short_movie->icon_path = $icon_path;
				$info = '||Торренты удалены по требованию правообладателя|'. self::$cName;
				$short_movie->info = $info;
				array_push ($items, $short_movie);
				$m_feed = 'end';
				return $items;
			}
			foreach ($movie->class_info['torrent'] as $k => $v){
				$caption = $v['caption'];
				$short_movie = new ShortMovie(
					strval(trim($k)),
					strval($caption),
					strval($movie->poster_url)
				);
				$short_movie->icon_path = $icon_path;
				$short_movie->tType = 'torrent';
				$short_movie->extra_item = $v['size'];
				$info = '||' . $caption . '|'. $v['info'];
				$short_movie->info = $info;
				$short_movie->details_box_width = true;
				array_push ($items, $short_movie);
			}
			$m_feed = 'end';
			return $items;
		}
		$keyword = $movie->name;
		$year = $movie->year  != '' ? $movie->year : false;
		$obj = self::getSearchShortMovieRange ($keyword, $m_feed);
		foreach($obj as $k => $v){
			if (HD::strSanitizing($v->name) == HD::strSanitizing($movie->name)){
				$searchTorrentUrl = $v->id;
				break;
			}
		}
		if (!isset($searchTorrentUrl)){
			if (count($obj) > 0){
				$v = array_shift($obj);
				$searchTorrentUrl = $v->id;
			}
		}
		if (!isset($searchTorrentUrl))
			return $items;
		if (!preg_match("|^http|",$searchTorrentUrl))
			$searchTorrentUrl = self::getDomainName() . $searchTorrentUrl;
		$doc = self::http_get_document($searchTorrentUrl);
		if (preg_match_all("|class='c1'>.*?<div class='c3'>(.*?)<.*?href=\"(.*?)\".*?<center class=\"box\"|ms", $doc, $matches)){
			if (preg_match('|slideshow1\' href="(.*?)"|ms', $doc, $match))
				$poster_url = HD::str_remove_tag($match[1]);
			foreach($matches[2] as $k => $v){
				if (preg_match('|torrent-info.+?download-event\'>(.+?)</|ms', $matches[0][$k], $match))
					$caption = HD::str_remove_tag($match[1]);
				if (preg_match('|torrent-info.+?download-event\'>(.+?)<center class="box"|ms', $matches[0][$k], $match)){
					$info = '';
					$tmp = explode("<br/>", $match[1]);
					unset ($tmp[0]);
					foreach($tmp as $vel)
						$info .= "||" . str_replace("@[emailprotected]", "", HD::str_remove_tag($vel));
					$info =  str_replace(array("||||",'[]'), array( "||",''), $info);
				}
				$short_movie = new ShortMovie(
					strval(trim($v)),
					strval($caption),
					strval($poster_url)
				);
				$short_movie->icon_path = $icon_path;
				$short_movie->tType = 'torrent';
				$short_movie->extra_item = $matches[1][$k];
				$short_movie->info = $info;
				$short_movie->details_box_width = true;
				array_push ($items, $short_movie);
			}
		}else
			echo '--------------------------';
		$m_feed = 'end';
		return $items;
	}
	public static function getTorrentFile($torrent_id, $dloadPath=null){
		$url = $torrent_id;
		if (!preg_match("|^http|", $torrent_id))
			$url = self::getDomainName() . $torrent_id;
		$doc = self::http_get_document($url);
		return SmartConfig::checkTorrent($dloadPath, $doc);
	}
	public static function getVodSourceInfo($v){
		$ico = SmartConfig::getPluginIco(self::$className);
		$sources['caption'] = self::$cName;
		$sources['detailed_info'] = '||'.self::$cName.'|Торрент файлы найденные на '.self::$cName.' по названию. Так как поиск производится по названию возможны неточности.';
		$sources['icon_path'] = $ico;
		$sources['detailed_icon_path'] = $ico;
		$sources['goTo'] = 'SmartVodTorrentsScreen';
		$sources['class_name'] = $v;
		$sources['type'] = SmartConfig::getPluginIco('torrentSource');
		return $sources;
	}
	public static function http_get_img ($url){
		if (self::$proxy == true){
			$path_parts = parse_url(self::getDomainName());
			if (!preg_match("|^http|",$url))
				return DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . self::getDomainName() . $url . "&proxy=" . self::$cName;
			if (preg_match("|".$path_parts['host']."|",$url))
				return DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . $url . "&proxy=" . self::$cName;
		}
		if (!preg_match("|^http|",$url))
			$url = self::getDomainName() . $url;
		return $url;
		// return DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . $url;
	}
	public static function http_get_document ($url, $opts=null){
		
		if (is_null(self::$proxy)){
			self::$proxy = false;
			$sitesProxy = HD::getItemsArr('sitesProxy');
			if (isset($sitesProxy[self::$cName])){
				$proxySettings = (HD::getItemsArr('proxySettings') != array()) ? HD::getItemsArr('proxySettings') : array();
				if (isset($proxySettings['proxy'])){
					self::$proxy['proxy'] = $proxySettings['proxy'];
					if ((isset($proxySettings['proxyType']))&&($proxySettings['proxyType'] == 'SOCKS5'))
						self::$proxy['proxyType'] = $proxySettings['proxyType'];
					if (isset($proxySettings['proxyAccount']))
						self::$proxy['proxyAccount'] = $proxySettings['proxyAccount'];
				}
			}
		}
		if (self::$proxy == true){
			$opts[CURLOPT_PROXY] = self::$proxy['proxy'];
			if (isset(self::$proxy['proxyType']))
				$opts[CURLOPT_PROXYTYPE] = CURLPROXY_SOCKS5;
			if (isset(self::$proxy['proxyAccount']))
				$opts[CURLOPT_PROXYUSERPWD] = self::$proxy['proxyAccount'];
		}
		return HD::http_get_document($url, $opts);
	}
}
?>
