<?php
if (!class_exists('DuneSystem')){
	if (preg_match('|plugins/(.*?)/lib|', __DIR__, $matches)){
		$tmp_path = '/tmp/plugins/'.$matches[1];
		$plugin_name = $matches[1];
		$install_dir = str_replace('/lib/wox', '',  __DIR__);
		if (file_exists('/persistfs/plugins_data'))
			$data_dir = "/persistfs/plugins_data/$plugin_name";
		else
			$data_dir = "/flashdata/plugins_data/$plugin_name";
        $port = HD::http_local_port();
		$www_url = "http://127.0.0.1:$port/plugins/$plugin_name/";
		$cgi_url = "http://127.0.0.1:$port/cgi-bin/plugins/$plugin_name/";
	}

	function hd_print($str){
		echo $str;
	}
	class DuneSystem{
		public static $properties = array ();
	};
	DuneSystem::$properties['plugin_name']      = $plugin_name;
	DuneSystem::$properties['install_dir_path'] = $install_dir;
	DuneSystem::$properties['tmp_dir_path']     = $tmp_path;
	DuneSystem::$properties['plugin_www_url']   = $www_url;
	DuneSystem::$properties['plugin_cgi_url']   = $cgi_url;
	DuneSystem::$properties['data_dir_path']    = $data_dir;
}
class RezkaTracker_Class {
	static $cName = 'Rezka Tracker';
	static $className = 'RezkaTracker_Class';
	static $DomainName = null;
	static $proxyArr = null;
	static $proxyArrMd5 = null;
	static $proxy = null;
	public static function getDomainName(){
		if (null === self::$DomainName)
			self::$DomainName = (HD::getItemStr(self::$cName . 'DomainName') != '') ? HD::getItemStr(self::$cName . 'DomainName') : 'https://rezka.cc';
		return self::$DomainName;
	}
	public static function getMainMenuInfo(){
		return array (
			'name' => self::$cName,
			'descr' => '||'.self::$cName.'|каталог и источник торрентов с сайта '.self::$cName.'.|Если сайт не доступен используйте прокси или VPN, а так же официальные зеркала (сайты с похожим дизайном и названием могут не являтся зеркалом)'
		);
	}
	public static function get_media_url_str($k, $arr=null){
		if ($arr == true)
			return SmartVodCategoryListScreen::get_media_url_str($k, $arr);
		return SmartVodCategoryListScreen::get_media_url_str($k);
	}
	public static function getSearchMediaUrlStr($k, $arr=null){
		return SmartVodListScreen::get_media_url_str($k, $arr);
	}
	public static function getScreenActionMapArr($media_url){
		$actionsArr = array();
		// if((isset($media_url->screen_id))&&($media_url->screen_id != 'vod_category_list')){
			// $actionsArr[0]['create_action'] = 'classAction';
			// $actionsArr[0]['params'] = array ('indiClass' => self::$className,'action' => 'sort');
			// $actionsArr[0]['caption'] = 'Сортировки';
			// $actionsArr[0]['key'] = GUI_EVENT_KEY_C_YELLOW;
		// }
		return $actionsArr;
	}
	public static function getPopUpMenuItems ($selected_media_url, $parent_media_url){
		$menu_items = array();
		if ($parent_media_url == 'main_menu'){
			$menu_items[] = array(
				'caption' => 'Задать зеркало ' . self::$cName,
				'params' => array ('action' => 'mirror'),
				'icon_url' => SmartConfig::getPluginIco('s_' . self::$className)
			);
			$menu_items[] = array(
				'caption' => 'Прокси для ' . self::$cName,
				'params' => array ('action' => 'proxy'),
				'icon_url' => SmartConfig::getPluginIco('s_proxy')
			);
			$menu_items[] = 'is_separator';
		}
		$parent_media_url = MediaURL::decode($parent_media_url);
		if ($parent_media_url->screen_id == 'vod_torrentlist'){
			
			$menu_items[] = array(
				'caption' => 'Изменить действие для торрентов',
				'params' => array ('action' => 'torrentActionSetup'),
				'icon_url' => SmartConfig::getPluginIco('s_torrent')
			);
			$menu_items[] = array(
				'caption' => 'Выбрать действие торрента',
				'conID' => 'add_actions',
				'params' => array ('torrentAction' => 1),
				'icon_url' => SmartConfig::getPluginIco('s_list')
			);
			$menu_items[] = 'is_separator';
			$menu_items[] = array(
				'caption' => 'Настройки TorrServer',
				'conID' => 'classSetupTorrServer',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_torrserver')
			);
			$menu_items[] = array(
				'caption' => 'Настройки PeerflixServer',
				'conID' => 'classSetupPeerflixServer',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_peerflixserver')
			);
			$menu_items[] = array(
				'caption' => 'Настройки Transmission',
				'conID' => 'classSetupTransmission',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_transmission')
			);
			$menu_items[] = array(
				'caption' => 'Настройки Transmission UPnP',
				'conID' => 'classSetupTransmissionUPnP',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_transmissionupnp')
			);
			$menu_items[] = 'is_separator';
		}
		if ((isset($parent_media_url->screen_id))&&($parent_media_url->screen_id != 'vod_series')){
			$menu_items[] = array(
				'caption' => 'Добавить в Главное меню',
				'params' => array ('action' => 'addToMainMenu'),
				'icon_url' => SmartConfig::getPluginIco('s_home')
			);
		}
		return $menu_items;
	}
	public static function getVodCategories($media_url){
		static $categories = null;
		if (is_null($categories)){
			$categories['categories'][] = array('id'=> 'search', 'class' => 'SmartSearchScreen', 'caption' => 'Поиск');
			$categories['categories'][] = array('id'=> 'all', 'class' => 'SmartVodListScreen', 'caption' => 'Все');
			$doc = self::http_get_document(self::getDomainName());
			if(preg_match('|main-menu">(.+?)</div|ms', $doc, $matches))
				if (preg_match_all('|<a href="(.*?)".*?item">(.*?)</|ms', $matches[1], $matches))
					foreach ($matches[2] as $k => $v)
						$categories['categories'][] = array('id'=> $matches[1][$k], 'class' => 'SmartVodListScreen', 'caption' => HD::str_remove_tag($v));
		}
		return $categories['categories'];
	}
	public static function getShortMovieRange ($media_url, &$m_feed){
		if ($m_feed === 'end')
			return $items;
		if ($media_url->categoryId == 'all')
			$url = self::getDomainName();
		else
			$url = self::getDomainName() . $media_url->categoryId;
		if ($m_feed > 0)
			$url .= '/page/' . ($m_feed + 1);
		$doc = self::http_get_document($url);
		++$m_feed;
		if (!preg_match('|">\&raquo;</a></ul>|ms', $doc))
			$m_feed = 'end';
		return self::parseSitePage($doc);
	}
	public static function parseSitePage($doc){
		$items = array();
		if(preg_match('|cardlist">(.+?)</div|ms', $doc, $match))
			$doc = $match[1];
		if (preg_match_all('|href="(.+?)".+?src="(.+?)".+?alt="(.+?)".*?</a>|ms', $doc, $match)){
			foreach ($match[1] as $k => $v){
				$caption = HD::str_remove_tag($match[3][$k]);
				if (class_exists('ShortMovie')) {
					$short_movie = new ShortMovie(
						strval(trim($v)),
						strval($caption),
						strval(self::http_get_img ($match[2][$k]))
					);
					$info = '||' . $caption;
					if (preg_match('|card-item-type.*?">(.*?)</|ms', $match[0][$k], $m))
						$info .= '|' . HD::str_remove_tag($m[1]);
					if (preg_match('|param">(.*?)</|ms', $match[0][$k], $m))
						$info .= '|' . HD::str_remove_tag($m[1]);
					if (preg_match('|small title="(.*?)".*?">(.*?)</small>|ms', $match[0][$k], $m)){
						$info .= '||' . HD::str_remove_tag($m[2]);
						$info .= '|' . HD::str_remove_tag($m[1]);
						$short_movie->extra_item = HD::str_remove_tag($m[2]);
					}
					$short_movie->info = $info;
					array_push ($items, $short_movie);
				}
			}
		}
		return $items;
	}
	public static function getSearchShortMovieRange ($keyword, &$m_feed){
		if (is_object($keyword))
			$keyword = $keyword->searchStr;
		if ($m_feed === 'end')
			return array();
		$otps [CURLOPT_POST] = true;
		$otps [CURLOPT_POSTFIELDS] = "q=". urlencode ($keyword);
		$doc = self::http_get_document(self::getDomainName() . '/ajax_search', $otps);
		$m_feed = 'end';
		return self::parseSitePage($doc);
	}
	public static function load_movie($movie_id, $mUrl, $getMovieInfo){
		$arr = array();
		$arr['caption'] = $arr['class_info']['catalog_info']['caption'] = $mUrl->caption;
		$arr['poster_url'] = $arr['class_info']['catalog_info']['poster_url'] = $mUrl->poster_url;
		if (isset($mUrl->caption_original))
			$arr['caption_original'] = $arr['class_info']['catalog_info']['caption_original'] = $mUrl->caption_original;
		if (isset($mUrl->year))
			$arr ['year'] = $arr['class_info']['catalog_info']['year'] = $mUrl->year;
		if (!preg_match("|^http|",$movie_id))
			$url = self::getDomainName() . $movie_id;
		else
			$url = preg_replace('#((http.*)://.+?\/)#i', self::getDomainName() . "/", $movie_id);
		$doc = self::http_get_document($url);
		if (preg_match('|<div style="padding-top: 15px;"><a href="(.+?)">Перейти|ms', $doc, $match)){
			$movie_id = $match[1];
			if (!preg_match("|^http|",$movie_id))
				$url = self::getDomainName() . $movie_id;
			$doc = self::http_get_document($url);
		}
		if (preg_match('|si-title">(.+?)</|ms', $doc, $match))
			$arr['caption_original'] = $arr['caption'] = HD::str_remove_tag($match[1]);
		if (preg_match('|si-data">(.+?)</div|ms', $doc, $match)){
			if (preg_match_all ("|<li>(.+?)</li>|ms", $match[1], $match)){
				if (isset($match[1][0]))
					$arr['caption_original'] = HD::str_remove_tag($match[1][0]);
				if (isset($match[1][1])){
					if (preg_match('|\D|', $match[1][1]))
						$arr['country'] = HD::str_remove_tag($match[1][1]);
					else
						$arr ['year'] = HD::str_remove_tag($match[1][1]);
				}
				if (isset($match[1][2])){
					if (isset($arr['country']))
						$arr ['country'] = $arr['country'] . ', ' . HD::str_remove_tag($match[1][2]);
					else
						$arr ['country'] = HD::str_remove_tag($match[1][2]);
				}
			}
		}
		if (preg_match('|story">(.*?)</div>|ms', $doc, $match))
			$arr['description'] = HD::str_remove_tag($match[1]);
		if (preg_match('|cover">.+?src="(.*?)"|ms', $doc, $match))
			$arr['poster_url'] = self::http_get_img($match[1]);
		$arr['class_info']['goToScreen'] = 'SmartVodTorrentsScreen';
		$kpIDs = HD::getItemsArr('kpIDs');
		if (isset($kpIDs[$movie_id]))
			$arr['class_info']['dbIDs']['kpID'] = $kpIDs[$movie_id];
		if ($getMovieInfo != 'min')
			$arr = SmartConfig::getMovieInfoArr($getMovieInfo, $movie_id, $mUrl, $arr);
		if (isset($arr['class_info']['dbIDs']['kpID']))
			unset ($arr['class_info']['goToScreen']);
		if (!isset($arr['class_info']['dbIDs']['kpID']))
			$arr['class_info']['goToScreen'] = 'SmartVodTorrentsScreen';
		if (preg_match('|param">(.*?)</div>|ms', $doc, $match))
			$arr ['rate_details'][' '] = HD::str_remove_tag($match[1]);
		if (preg_match_all('|dwn-links-list">(.+?)</div|ms', $doc, $match)){
			foreach($match[1] as $vel){
				if (preg_match_all ('|href="(.+?)".+?>(.+?)</a>|ms', $vel, $matches)){
					foreach($matches[1] as $k => $v){
						$capt = $matches[2][$k];
						if (preg_match('|-(\d+?)-sezon|ms', $v, $m))
							$capt .= ' ' . $m[1] . ' сезон';
						if (preg_match('|-(\d+?)-seriya|ms', $v, $m))
							$capt .= ' ' . $m[1] . ' серия';
						if (preg_match('|polnostyu|ms', $v))
							$capt .= ' полностью';
						$arr['class_info']['torrent'][$v]['caption'] = $capt;
					}
				}
			}
		}
		return $arr;
	}
	public static function getShortTorrentRange ($movie, $media_url, &$m_feed){
		$items = array();
		if ($m_feed === 'end')
			return $items;
		$icon_path = SmartConfig::getPluginIco('s_torrent');
		if (isset($movie->class_info['torrent'])){
			foreach ($movie->class_info['torrent'] as $k => $v){
				$caption = $v['caption'];
				$short_movie = new ShortMovie(
					strval(trim($k)),
					strval($caption),
					strval($movie->poster_url)
				);
				$short_movie->icon_path = $icon_path;
				$short_movie->tType = 'torrent';
				$info = '||' . $caption . '|'. self::$cName;
				$short_movie->info = $info;
				$short_movie->details_box_width = true;
				array_push ($items, $short_movie);
			}
			$m_feed = 'end';
			return $items;
		}
		$keyword = $movie->name;
		$year = $movie->year  != '' ? $movie->year : false;
		$obj = self::getSearchShortMovieRange ($keyword, $m_feed);
		foreach($obj as $k => $v){
			if (HD::strSanitizing($v->name) == HD::strSanitizing($movie->name)){
				$searchTorrentUrl = $v->id;
				break;
			}
		}
		if (!isset($searchTorrentUrl)){
			if (count($obj) > 0){
				$v = array_shift($obj);
				$searchTorrentUrl = $v->id;
			}
		}
		if (!isset($searchTorrentUrl))
			return $items;
		if (!preg_match("|^http|",$searchTorrentUrl))
			$searchTorrentUrl = self::getDomainName() . $searchTorrentUrl;
		$doc = self::http_get_document($searchTorrentUrl);
		if (preg_match('|<div style="padding-top: 15px;"><a href="(.+?)">Перейти|ms', $doc, $match)){
			$url = $match[1];
			if (!preg_match("|^http|",$match[1]))
				$url = self::getDomainName() .$match[1];
			$doc = self::http_get_document($url);
		}
		if (preg_match_all('|dwn-links-list">(.+?)</div|ms', $doc, $match)){
			foreach($match[1] as $vel){
				$c = ' ';
				if (preg_match('|dwn-title">(.+?)</a>|ms', $vel, $m1))
					$c .= HD::str_remove_tag($m1[1]);
				if (preg_match_all ('|href="(.+?)".+?>(.+?)</a>|ms', $vel, $matches)){
					foreach($matches[1] as $k => $v){
						$caption = $matches[2][$k] . $c;
						if (preg_match('|-(\d+?)-sezon|ms', $v, $m))
							$caption .= ' ' . $m[1] . ' сезон';
						if (preg_match('|-(\d+?)-seriya|ms', $v, $m))
							$caption .= ' ' . $m[1] . ' серия';
						if (preg_match('|polnostyu|ms', $v))
							$caption .= ' полностью';
						$short_movie = new ShortMovie(
							strval(trim($v)),
							strval(trim($caption)),
							strval($movie->poster_url)
						);
						$short_movie->icon_path = $icon_path;
						$short_movie->tType = 'torrent';
						$info = '||' . $caption . '|'. self::$cName;
						$short_movie->info = $info;
						$short_movie->details_box_width = true;
						array_push ($items, $short_movie);
					}
				}
			}
		}
		$m_feed = 'end';
		return $items;
	}
	public static function getTorrentFile($torrent_id, $dloadPath=null){
		$url = $torrent_id;
		if (!preg_match("|^http|",$torrent_id))
			$url = self::getDomainName() . $torrent_id;
		$doc = self::http_get_document($url);
		return SmartConfig::checkTorrent($dloadPath, $doc);
	}
	public static function getVodSourceInfo($v){
		$ico = SmartConfig::getPluginIco(self::$className);
		$sources['caption'] = self::$cName;
		$sources['detailed_info'] = '||'.self::$cName.'|Торрент файлы найденные на '.self::$cName.' по названию. Так как поиск производится по названию возможны неточности.';
		$sources['icon_path'] = $ico;
		$sources['detailed_icon_path'] = $ico;
		$sources['goTo'] = 'SmartVodTorrentsScreen';
		$sources['class_name'] = $v;
		$sources['type'] = SmartConfig::getPluginIco('torrentSource');
		return $sources;
	}
	public static function http_get_img ($url){
		if (self::$proxy == true){
			$path_parts = parse_url(self::getDomainName());
			if (!preg_match("|^http|",$url))
				return DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . self::getDomainName() . $url . "&proxy=" . self::$cName;
			if (preg_match("|".$path_parts['host']."|",$url))
				return DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . $url . "&proxy=" . self::$cName;
		}
		if (!preg_match("|^http|",$url))
			$url = self::getDomainName() . $url;
		return $url;
		// return DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . $url;
	}
	public static function http_get_document ($url, $opts=null){
		
		if (is_null(self::$proxy)){
			self::$proxy = false;
			$sitesProxy = HD::getItemsArr('sitesProxy');
			if (isset($sitesProxy[self::$cName])){
				$proxySettings = (HD::getItemsArr('proxySettings') != array()) ? HD::getItemsArr('proxySettings') : array();
				if (isset($proxySettings['proxy'])){
					self::$proxy['proxy'] = $proxySettings['proxy'];
					if ((isset($proxySettings['proxyType']))&&($proxySettings['proxyType'] == 'SOCKS5'))
						self::$proxy['proxyType'] = $proxySettings['proxyType'];
					if (isset($proxySettings['proxyAccount']))
						self::$proxy['proxyAccount'] = $proxySettings['proxyAccount'];
				}
			}
		}
		if (self::$proxy == true){
			$opts[CURLOPT_PROXY] = self::$proxy['proxy'];
			if (isset(self::$proxy['proxyType']))
				$opts[CURLOPT_PROXYTYPE] = CURLPROXY_SOCKS5;
			if (isset(self::$proxy['proxyAccount']))
				$opts[CURLOPT_PROXYUSERPWD] = self::$proxy['proxyAccount'];
		}
		return HD::http_get_document($url, $opts);
	}
}
?>
