<?php
if (!class_exists('DuneSystem')){
	if (preg_match('|plugins/(.*?)/lib|', __DIR__, $matches)){
		$tmp_path = '/tmp/plugins/'.$matches[1];
		$plugin_name = $matches[1];
		$install_dir = str_replace('/lib/wox', '',  __DIR__);
		if (file_exists('/persistfs/plugins_data'))
			$data_dir = "/persistfs/plugins_data/$plugin_name";
		else
			$data_dir = "/flashdata/plugins_data/$plugin_name";
        $port = HD::http_local_port();
		$www_url = "http://127.0.0.1:$port/plugins/$plugin_name/";
		$cgi_url = "http://127.0.0.1:$port/cgi-bin/plugins/$plugin_name/";
	}

	function hd_print($str){
		echo $str;
	}
	class DuneSystem{
		public static $properties = array ();
	};
	DuneSystem::$properties['plugin_name']      = $plugin_name;
	DuneSystem::$properties['install_dir_path'] = $install_dir;
	DuneSystem::$properties['tmp_dir_path']     = $tmp_path;
	DuneSystem::$properties['plugin_www_url']   = $www_url;
	DuneSystem::$properties['plugin_cgi_url']   = $cgi_url;
	DuneSystem::$properties['data_dir_path']    = $data_dir;
}
class Rezka_Class {
	static $cName = 'Rezka';
	static $className = 'Rezka_Class';
	static $DomainName = null;
	static $proxyArr = null;
	static $proxyArrMd5 = null;
	static $proxy = null;
	public static function getDomainName(){
		if (null === self::$DomainName)
			self::$DomainName = (HD::getItemStr(self::$cName . 'DomainName') != '') ? HD::getItemStr(self::$cName . 'DomainName') : 'https://rezka.ag';
		return self::$DomainName;
	}
	public static function getMainMenuInfo(){
		return array (
			'name' => self::$cName,
			'descr' => '||'.self::$cName.'|каталог и источник видео с сайта ' . self::$cName . '||Если сайт не доступен используйте прокси или VPN, а так же официальные зеркала (сайты с похожим дизайном и названием могут не являтся зеркалом)'
			);
	}
	public static function get_media_url_str($k, $arr=null){
		if ($arr == true)
			return SmartVodCategoryListScreen::get_media_url_str($k, $arr);
		return SmartVodCategoryListScreen::get_media_url_str($k);
	}
	public static function getSearchMediaUrlStr($k, $arr=null){
		return SmartVodListScreen::get_media_url_str($k, $arr);
	}
	public static function getScreenActionMapArr($media_url){
		$actionsArr = array();
		if((isset($media_url->screen_id))&&($media_url->screen_id == 'vod_list')){
			$actionsArr[0]['create_action'] = 'classAction';
			$actionsArr[0]['params'] = array ('indiClass' => self::$className,'action' => 'sort');
			$actionsArr[0]['caption'] = 'Сортировки';
			$actionsArr[0]['key'] = GUI_EVENT_KEY_C_YELLOW;
		}
		return $actionsArr;
	}
	public static function getPopUpMenuItems ($selected_media_url, $parent_media_url){
		$menu_items = array();
		if ($parent_media_url == 'main_menu'){
			$menu_items[] = array(
				'caption' => 'Задать зеркало ' . self::$cName,
				'params' => array ('action' => 'mirror'),
				'icon_url' => SmartConfig::getPluginIco('s_' . self::$className)
			);
			$menu_items[] = array(
				'caption' => 'Прокси для ' . self::$cName,
				'params' => array ('action' => 'proxy'),
				'icon_url' => SmartConfig::getPluginIco('s_proxy')
			);
			$menu_items[] = 'is_separator';
		}
		$parent_media_url = MediaURL::decode($parent_media_url);
		if ((isset($parent_media_url->screen_id))&&($parent_media_url->screen_id != 'vod_series')){
			$menu_items[] = array(
				'caption' => 'Добавить в Главное меню',
				'params' => array ('action' => 'addToMainMenu'),
				'icon_url' => SmartConfig::getPluginIco('s_home')
			);
		}
		return $menu_items;
	}
	public static function getVodCategories($media_url){
		static $categories = null;
		if (is_null($categories)){
			$categories['categories'][] = array('id'=> 'search', 'class' => 'SmartSearchScreen', 'caption' => 'Поиск');
			$doc = self::http_get_document(self::getDomainName());
			$tmp = preg_split('|b-topnav__item-link|ms', $doc, -1, PREG_SPLIT_NO_EMPTY);
			unset ($tmp[0]);
			foreach ($tmp as $k => $v){
				if (preg_match('|" href="(.*?)">(.*?)<|ms', $v, $matches)){
					if (preg_match('|\/collections\/|',$matches[1])){
						$categories['categories'][] = array('id'=> $matches[1], 'class' => 'SmartVodRectangleListScreen', 'caption' => HD::str_remove_tag($matches[2]));
						continue;
					}
					if (preg_match('~\/new\/|\/announce\/|\/show\/~',$matches[1])){
						$categories['categories'][] = array('id'=> $matches[1], 'class' => 'SmartVodListScreen', 'caption' => HD::str_remove_tag($matches[2]));
						continue;
					}
					$id = $k + 1;
					$categories['categories'][] = array('id'=> $id, 'class' => 'SmartVodCategoryListScreen', 'caption' => HD::str_remove_tag($matches[2]));
					if (preg_match_all ('|<a href="(.*?)">(.*?)</a>|ms', $v, $match)){
						$categories['subCategories'][$id][] = array('id'=> $matches[1], 'class' => 'SmartVodListScreen', 'caption' => 'Все ' . HD::str_remove_tag(trim($matches[2])));
						foreach ($match[1] as $key => $vel)
							$categories['subCategories'][$id][] = array('id'=> HD::str_remove_tag($vel), 'class' => 'SmartVodListScreen', 'caption' => HD::str_remove_tag($match[2][$key]));
					}
				}
			}
		}
		if (isset($media_url->categoryId))
			return $categories['subCategories'][$media_url->categoryId];
		return $categories['categories'];
	}
	public static function getShortMovieRange ($media_url, &$m_feed){
		$items = array();
		if ($m_feed === 'end')
			return $items;
		$sorting = (HD::getItemsArr(self::$className . '_sorting') != array()) ? HD::getItemsArr(self::$className . '_sorting') :  array('sort' => 'last');
		$url =  $media_url->categoryId;
		if (!preg_match("|^http|",$url))
			$url = self::getDomainName() . $url;
		if ($m_feed > 0)
			$url .=   'page/'. ($m_feed+1) . '/';
		if (!preg_match("|\/collections\/|",$media_url->categoryId))
			$url .=  '?filter=' . $sorting['sort'];
		$doc = self::http_get_document($url);
		++$m_feed;
		if ((preg_match('|no-page"><span class="b-navigation__next|', $doc))||(preg_match('|do=top|', $media_url->categoryId)))
			$m_feed = 'end';
		return self::parseSitePage($doc);
	}
	public static function getSearchShortMovieRange ($keyword, &$m_feed){
		// static $token = null;
		if (is_object($keyword))
			$keyword = $keyword->searchStr;
		if ($m_feed === 'end')
			return array();
		$url =  self::getDomainName() . '/search/?do=search&subaction=search&q=' . urlencode($keyword);
		if ($m_feed > 0)
			$url = $url .'&page='. ($m_feed+1);
		// if ($token == false){
			// $doc = HD::http_get_document(self::getDomainName());
			// preg_match('|member_user_token" value="(.*)"|iuUm', $doc, $m);
			// $token=$m[1];
		// }
		$header[] = "Cookie: dle_user_token=" . md5(time());
		$opts[CURLOPT_HTTPHEADER] = $header;
		$doc = self::http_get_document($url, $opts);
		if ((preg_match('|class="no-page"><span class="b-navigation__next|', $doc))||
		(!preg_match('|navigation__next|', $doc)))
			$m_feed = 'end';
		else
			++$m_feed;
		return self::parseSitePage($doc);
	}
	public static function parseSitePage($doc){
		$items = array();
		if (preg_match_all ('|_inline_item".*?src="(.*?)".*?href="(.*?)">(.*?)</a>(.*?)</|ms', $doc, $match)){
			foreach ($match[2] as $k => $v){
				$caption = HD::str_remove_tag($match[3][$k]);
				if (class_exists('ShortMovie')) {
					$short_movie = new ShortMovie(
						strval(trim($v)),
						strval($caption),
						strval(self::http_get_img ($match[1][$k]))
					);
					$info = '||' . $caption;
					if (preg_match('|class="info">(.*?)</|ms', $match[0][$k], $m)){
						$info .= '|' . HD::str_remove_tag($m[1]);
						$short_movie->extra_item = HD::str_remove_tag($m[1]);
					}
					$x=explode(',',HD::str_remove_tag($match[4][$k]));
					$info .= '|' . trim($x[0]);
					$info .= '|' . trim($x[1]);
					if (isset($x[2]))
						$info .= '|' . trim($x[2]);
					$short_movie->info = $info;
					array_push ($items, $short_movie);
				}else{
					$arr['rezkaId'] = strval($v);
					$arr['infoArr']['caption'] = $caption;
					$arr['infoArr']['poster_url'] = self::http_get_img ($match[1][$k]);
					$info = '||' . $caption;
					if (preg_match('|class="info">(.*?)</|ms', $match[0][$k], $m)){
						$info .= '|' . HD::str_remove_tag($m[1]);
						$short_movie->extra_item = HD::str_remove_tag($m[1]);
					}
					$x=explode(',',HD::str_remove_tag($match[4][$k]));
					$info .= '|' . trim($x[0]);
					$info .= '|' . trim($x[1]);
					if (isset($x[2]))
						$info .= '|' . trim($x[2]);
					$arr['infoArr']['detailed_info'] = $info;
					array_push ($items, $arr);
				}
			}
		}
		if (preg_match_all ('|collections_item" data-url="(.*?)".*?src="(.*?)".*?tooltip">(.*?)<.*?title">(.*?)<|ms', $doc, $match)){
			foreach ($match[1] as $k => $v){
				$caption = $match[4][$k] . ' (' . $match[3][$k] . ')';
				$short_movie = new ShortMovie(
					strval(trim($v)),
					strval($caption),
					strval(self::http_get_img ($match[2][$k]))
				);
				$info = '||' . $caption;
				$short_movie->info = $info;
				$short_movie->goToScreen = 'SmartVodListScreen';
				array_push ($items, $short_movie);
			}
		}
		return $items;
	}
	public static function loadTrailers($infoArr, $movie){
		$id = $infoArr['id'];
		$opts [CURLOPT_POST] = true;
		$opts [CURLOPT_POSTFIELDS] = "id=" . HD::str_remove_tag($id);
		$jsd = json_decode(self::http_get_document(self::getDomainName() . '/engine/ajax/gettrailervideo.php', $opts));
		if (preg_match('|src="(.+?)"|ms', $jsd->code, $match)){
			if (preg_match('|yout|ms', $match[1])){
				$trailer = $match[1];
				$items[md5 ($trailer)]['is_stream_url'] = false;
				$items[md5 ($trailer)]['file_info']['icon_path'] =  'plugin_file://icons/s_youtube.png';
				$items[md5 ($trailer)]['title'] = 'Rezka Youtube trailer '.self::$cName;
			}else{
				$doc = self::http_get_document($match[1]);
				if (preg_match('|player">.*?set_video_player.*?\((.*?)\)|ms', $doc, $matches)){
					$tmp = explode (',', $matches[1]);
					$trailer = trim(str_replace("'",'',$tmp[3]));
				}
				$trailer = str_replace(array ('https://', 'http://'), array ('https://mp4://','http://mp4://'),  $trailer);
				$items[md5 ($trailer)]['is_stream_url'] = true;
				$items[md5 ($trailer)]['file_info']['icon_path'] =  'plugin_file://icons/s_Rezka_Class.png';
				$items[md5 ($trailer)]['title'] = 'Rezka trailer '.self::$cName;
			}
			$items[md5 ($trailer)]['id'] = md5 ($trailer);
			
			$items[md5 ($trailer)]['playback_url'] = $trailer;
			$items[md5 ($trailer)]['file_info']['details_box_width'] = true;
			$items[md5 ($trailer)]['file_info']['poster_url'] = $movie->poster_url;
			$items[md5 ($trailer)]['file_info']['class_name'] = self::$className;
			$items[md5 ($trailer)]['file_info']['description'] = $movie->description;
			$items[md5 ($trailer)]['file_info']['detailed_info'] = '||Трейлер c '.self::$cName.'|' . $movie->name . '|'  . $movie->name_original . '||' . $movie->description;
			return $items;
		}else
			echo 'ska';
	}
	public static function load_movie($movie_id, $mUrl, $getMovieInfo){
		$arr = array();
		$arr['caption'] = $arr['class_info']['catalog_info']['caption'] = $mUrl->caption;
		$arr['poster_url'] = $arr['class_info']['catalog_info']['poster_url'] = self::http_get_img($mUrl->poster_url);
		if (isset($mUrl->caption_original))
			$arr['caption_original'] = $arr['class_info']['catalog_info']['caption_original'] = $mUrl->caption_original;
		if (isset($mUrl->year))
			$arr ['year'] = $arr['class_info']['catalog_info']['year'] = $mUrl->year;
		if (!preg_match("|^http|",$movie_id))
			$url = self::getDomainName() . $movie_id;
		else
			$url = preg_replace('#((http.*)://.+?\/)#i', self::getDomainName() . "/", $movie_id);
		$doc = self::http_get_document($url);
		if (preg_match('|h1 itemprop="name">(.*?)</|ms', $doc, $match))
			$arr['caption_original'] = $arr['caption'] = HD::str_remove_tag($match[1]);
		if (preg_match('|alternativeHeadline">(.*?)</|ms', $doc, $match))
			$arr['caption_original'] = HD::str_remove_tag($match[1]);
		if (preg_match('|description_text">(.*?)</div>|ms', $doc, $match))
			$arr['description'] = HD::str_remove_tag($match[1]);
		if (preg_match('|image" src="(.*?)"|ms', $doc, $match))
			$arr['poster_url'] = self::http_get_img($match[1]);
		if (preg_match('|ежиссер.*?:(.*?)</tr>|ms', $doc, $match))
			$arr['director'] = HD::str_remove_tag($match[1]);
		if (preg_match('|<h2>.*?ктеры.*?:(.*?)</tr>|ms', $doc, $match))
			$arr['actors'] = HD::str_remove_tag($match[1]);
		if (preg_match('|<h2>.*?анр.*?:(.*?)</tr>|ms', $doc, $match))
			$arr['genres'] = HD::str_remove_tag($match[1]);
		if (preg_match('|<h2>.*?трана.*?:(.*?)</tr>|ms', $doc, $match))
			$arr ['country'] = HD::str_remove_tag($match[1]);
		if (preg_match('|<h2>.*?ереводе.*?:(.*?)</tr>|ms', $doc, $match))
			$arr ['details']['Перевод'] = HD::str_remove_tag($match[1]);
		if (preg_match('|<h2>.*?логан.*?:(.*?)</tr>|ms', $doc, $match))
			$arr ['details']['Слоган'] = HD::str_remove_tag($match[1]);
		if (preg_match('|<h2>.*?ыхода.*?:(.*?)</tr>|ms', $doc, $match)){
			$rDate = HD::str_remove_tag($match[1]);
			if (preg_match('|\d\d\d\d|ms', $rDate, $m))
				$arr ['year'] = $m[0];
			$arr ['details']['Дата выхода'] = HD::str_remove_tag($match[1]);
		}
		if (preg_match('|<h2>.*?ачестве.*?:(.*?)</tr>|ms', $doc, $match))
			$arr ['rate_details']['Качество'] = HD::str_remove_tag($match[1]);
		if (preg_match('|duration">(.+?)мин|ms', $doc, $match)){
			$arr ['length'] = HD::str_remove_tag($match[1]);
		}
		if (preg_match('|kp">.*?/help/(.*?)/.*?"bold">(.*?)</|ms', $doc, $match)){
			$arr ['rate_kinopoisk'] = HD::str_remove_tag($match[2]);
			$kpUrl = urldecode(base64_decode($match[1]));
			if (preg_match('|kinopoisk.ru/film/.*-(\d*)/video/|ms', $kpUrl, $match))
				$arr['class_info']['dbIDs']['kpID'] = $match[1];
			else if (preg_match('|kinopoisk.ru/film/(\d*)|ms', $kpUrl, $match))
				$arr['class_info']['dbIDs']['kpID'] = $match[1];
			else if (preg_match('|kinopoisk.ru/rating/(\d*?)\.|ms', $kpUrl, $match))
				$arr['class_info']['dbIDs']['kpID'] = $match[1];
		}else{
			$kpIDs = HD::getItemsArr('kpIDs');
			if (isset($kpIDs[$movie_id]))
				$arr['class_info']['dbIDs']['kpID'] = $kpIDs[$movie_id];
		}
		if (preg_match('|imdb">.*?/help/(.*?)/.*?"bold">(.*?)</|ms', $doc, $match)){
			$arr ['rate_imdb'] = HD::str_remove_tag($match[2]);
			$imdbUrl = urldecode(base64_decode($match[1]));
			if (preg_match('|imdb.com/title/tt(\d*?)/|ms', $imdbUrl, $match))
				$arr['class_info']['dbIDs']['imdbID'] = 'tt' . $match[1];
		}
		if (preg_match('|imdb">.*?/help/(.*?)/.*?"bold">(.*?)</|ms', $doc, $match)){
			$arr ['rate_imdb'] = HD::str_remove_tag($match[2]);
			$imdbUrl = urldecode(base64_decode($match[1]));
			if (preg_match('|imdb.com/title/tt(\d*?)/|ms', $imdbUrl, $match))
				$arr['class_info']['dbIDs']['imdbID'] = 'tt' . $match[1];
		}
		if (preg_match('|data-id="(\d+?)" |ms', $doc, $match)){
			$arr['class_info']['trailers'][0]['classFunction']['id'] = $match[1];
			$arr['class_info']['trailers'][0]['classFunction']['class'] = self::$className;
		}
		$arrRezka = rezka::getRezkaIframe ($movie_id, 'doc', $doc);
		if ($arrRezka == true)
			$arr['class_info']['linksArr'][self::$className] = $arrRezka;
		if ($getMovieInfo != 'min')
			$arr = SmartConfig::getMovieInfoArr($getMovieInfo, $movie_id, $mUrl, $arr);
		return $arr;
	}
	public static function getVodSourceInfo($v){
		$ico = SmartConfig::getPluginIco($v);
		$arr['caption'] = self::$cName;
		$arr['icon_path'] = $ico;
		$arr['detailed_icon_path'] = $ico;
		$arr['class_name'] = $v;
		$arr['detailed_info'] = '||' . self::$cName . '|видео с сайта '.self::$cName.'. Поиск видео на сайте '.self::$cName.' производится по названию возможны неточности.';
		$arr['type'] = SmartConfig::getPluginIco('onlineSource');
		return $arr;
	}
	public static function getIframe($params){
hd_print("EEE getIframe(params): ".print_r($params,1)."\n");
		$iframeInfo = array();
		if ((isset($params['caption_original']))&&(preg_match('|(.*?)\n|', $params['caption_original'], $m)))
			$params['caption_original'] = $m[1];
		if ((isset($params['country']))&&(preg_match('|(\d{4})|', $params['country'], $m))){
			$params['year'] = $m[1];
			unset($params['country']);
		}
		if (isset($params['movie_id']))
			$rezkaId =  $params['movie_id'];
		if (isset($params['linksArr'][self::$className])){
			foreach ($params['linksArr'][self::$className] as $k => $v){
				$v = preg_replace ('|http.*\:\/\/.*?\/|', self::getDomainName() . '/', $v);
				if (($k == 'm')||(preg_match('|^http|', $k)))
					$k = self::$cName;
				if (preg_match("|EpisodId_|", $v))
					$iframeInfo['urls'][$k]['goTo'] = 'VodSeriesListScreen';
				else
					$iframeInfo['urls'][$k]['goTo'] = 'VodSeasonListScreen';
				$iframeInfo['urls'][$k]['link'] = $v;
			}
			return $iframeInfo;
		}
		if (HD::strSanitizing($params['caption_original']) != HD::strSanitizing($params['caption'])){
			$year = 'null';
			if (isset($params['caption_original'])){
				$keyword = $params['caption_original'];
				$m_feed= 0;
				$arr = self::getSearchShortMovieRange ($keyword, $m_feed);
				foreach ($arr as $k => $v){
					if (HD::strSanitizing($keyword) == HD::strSanitizing($v['infoArr']['caption'])){
						extract ($v);
						$iframeInfo['infoArr'] = $infoArr;
						break;
					}
				}
			}
		}
		if (!isset($rezkaId)){
			$keyword = $params['caption'];
			$m_feed= 0;
			$arr = self::getSearchShortMovieRange ($keyword, $m_feed);
			foreach ($arr as $k => $v){
				if (HD::strSanitizing($keyword) == HD::strSanitizing($v['infoArr']['caption'])){
					extract ($v);
					$iframeInfo['infoArr'] = $infoArr;
					break;
				}
			}
			if (!isset($rezkaId))
				if (count($arr) > 0){
					extract ($arr[0]);
					$iframeInfo['infoArr'] = $infoArr;
				}
		}
		if (isset($rezkaId)){
			$iframe = rezka::getRezkaIframe ($rezkaId, 'video_id');
			if ($iframe == false){
				echo "\n".self::$cName.":search failed";
				return array("status"=>false);
			}
			foreach ($iframe as $k => $v){
				if (($k == 'm')||(preg_match('|^http|', $k)))
					$k = self::$cName;
				if (preg_match("|EpisodId_|", $v))
					$iframeInfo['urls'][$k]['goTo'] = 'VodSeriesListScreen';
				else
					$iframeInfo['urls'][$k]['goTo'] = 'VodSeasonListScreen';
				$iframeInfo['urls'][$k]['link'] = $v;
			}
		}else{
			echo "\n".self::$cName.":search failed";
			return array("status"=>false);
		}
		return $iframeInfo;
	}
	public static function getSeasons($media_url){
		$urls = rezka::getRezkaIframe ($media_url->link, 'seasons');
		foreach ($urls as $k => $v){
			$uArr[$k]['caption'] = $k;
			$uArr[$k]['link'] = $v;
			$uArr[$k]['detailed_info'] = '||' . $k . $media_url->detailed_info;
			$uArr[$k]['class_name'] = $media_url->class_name;
			$uArr[$k]['poster_url'] = $media_url->poster_url;
			$uArr[$k]['goTo'] = 'VodSeasonListScreen';
			if (preg_match("|SeasonId|",$v)){
				$uArr[$k]['season'] = $k;
				$uArr[$k]['goTo'] = 'VodSeriesListScreen';
			}
		}
		return $uArr;
	}
	public static function get_series_list($media_url, $movie){
		
		if (preg_match('|EpisodId_|', $media_url->link)){
			$qltyMax = false;
			if (preg_match('|(.+?)\sQ:(\d+)|', $media_url->caption, $m))
				$qltyMax = $m[2];
			$hash_patrs = $media_url->caption;
			if (isset($media_url->hash_patrs)){
				$hash_patrs = implode("", (array)$media_url->hash_patrs);
			}
			$items[$media_url->caption]['id'] = md5 ($hash_patrs);
			$items[$media_url->caption]['title'] = $media_url->caption;
			$items[$media_url->caption]['playback_url'] = $media_url->link;
			$items[$media_url->caption]['is_stream_url'] = false;
			$items[$media_url->caption]['file_info']['poster_url'] = $media_url->poster_url;
			$items[$media_url->caption]['file_info']['details_box_width'] = true;
			$items[$media_url->caption]['file_info']['class_name'] = $media_url->class_name;
			if (isset($media_url->description))
				$items[$media_url->caption]['file_info']['description'] = $media_url->description;
			$items[$media_url->caption]['file_info']['detailed_info'] = $media_url->detailed_info;
			if ($qltyMax == true)
				$items[$media_url->caption]['file_info']['qltyMax'] = $qltyMax;
			return $items;
		}
		$episodes  = rezka::getRezkaIframe ($media_url->link, 'episodes');
		if ($episodes == true){
			$items = array();
			foreach ($episodes as $key => $vel){
				$qltyMax = false;
				if (preg_match('|(.+?)\sQ:(\d+?)$|', $key, $m)){
					$key = $m[1];
					$qltyMax = $m[2];
				}
				$tvshow_se = VideoInfo::tvshow_se_parse($key);
				if (isset($tvshow_se['S']))
					$media_url->hash_patrs->season = $tvshow_se['S'];
				if (isset($tvshow_se['E']))
					$media_url->hash_patrs->episode = $tvshow_se['E'];
				else
					$media_url->hash_patrs->episode = $key;
				$hash_patrs = implode("", (array)$media_url->hash_patrs);
				$items[$key]['id'] = md5 ($hash_patrs);
				$items[$key]['title'] = $key;
				$items[$key]['playback_url'] = $vel;
				$items[$key]['is_stream_url'] = false;
				$items[$key]['file_info']['poster_url'] = $media_url->poster_url;
				$items[$key]['file_info']['details_box_width'] = true;
				$items[$key]['file_info']['class_name'] = $media_url->class_name;
				$items[$key]['file_info']['detailed_info'] = $media_url->detailed_info;
				if (isset($media_url->description))
					$items[$key]['file_info']['description'] = $media_url->description;
				if ($qltyMax == true)
					$items[$key]['file_info']['qltyMax'] = $qltyMax;
			}
		}
		return $items;
	}
	public function classAction ($defs, $user_input, $select_url = null){
		hd_restore_warnings();
		$post_action = null;
		$caption = 'Error!';
		$msg = 'classAction: action';
		$width = 1050;
		$parent_media_url = MediaURL::decode($user_input->parent_media_url);
		if ($user_input->action == 'sort'){
			$sorting = (HD::getItemsArr(self::$className . '_sorting') != array()) ? HD::getItemsArr(self::$className . '_sorting') :  array('vod_torrentlist' => '0', 'sort' => 0);
			$add_params['control_id']= $user_input->control_id;
			$add_params['action'] = $user_input->action;
			$add_params['indiClass'] = self::$className;
			if ((isset($user_input->selected_control_id))&&(isset($user_input->action_type))){
				if (isset($user_input->initial_sel_ndx))
					$add_params['initial_sel_ndx'] = $user_input->initial_sel_ndx;
				$sorting['sort'] = $user_input->sorting;
				if (HD::saveItemsArr(self::$className . '_sorting', $sorting) == false)
					return ActionFactory::show_title_dialog("Сохранение не удалось");
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
				$action = ActionFactory::close_dialog_and_run($action);
				return ActionFactory::invalidate_folders(array($user_input->parent_media_url), $action);
			}
			$add_params['initial_sel_ndx'] = 0;
			$sorting = $sorting['sort'];
			$sorting_ops['last']		= 'Последние поступления';
			$sorting_ops['popular']		= 'Популярные';
			$sorting_ops['soon']		= 'В ожидании';
			$sorting_ops['watching']	= 'Сейчас смотрят';
			ControlFactory::add_combobox($defs, $this, $add_params,
				'sorting', '',
				$sorting, $sorting_ops, 800, true, false
			);
			$attrs['initial_sel_ndx'] = isset($user_input->initial_sel_ndx) ? $user_input->initial_sel_ndx : -1;
			return ActionFactory::show_dialog("Cортировка:", $defs, true, 0, $attrs);
		}
		if (isset($user_input->selected_media_url))
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
		else{
			$msg = 'classAction: selected_media_url';
			return ActionFactory::show_title_dialog($caption, $post_action, $msg, 0);
		}
		$class_name = $selected_media_url->class_name;
		$parent_media_url = MediaURL::decode($user_input->parent_media_url);
		
		return ActionFactory::show_title_dialog($caption, $post_action, $msg, 0);
	}
	public static function http_get_img ($url){
		if (self::$proxy == true){
			$path_parts = parse_url(self::getDomainName());
			if (!preg_match("|^http|",$url))
				return DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . self::getDomainName() . $url . "&proxy=" . self::$cName;
			if (preg_match("|".$path_parts['host']."|",$url))
				return DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . $url . "&proxy=" . self::$cName;
		}
		if (!preg_match("|^http|",$url))
			$url = self::getDomainName() . $url;
		// return $url;
		return DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . $url;
	}
	public static function http_get_document ($url, $opts=null){
		
		if (is_null(self::$proxy)){
			self::$proxy = false;
			$sitesProxy = HD::getItemsArr('sitesProxy');
			if (isset($sitesProxy[self::$cName])){
				$proxySettings = (HD::getItemsArr('proxySettings') != array()) ? HD::getItemsArr('proxySettings') : array();
				if (isset($proxySettings['proxy'])){
					self::$proxy['proxy'] = $proxySettings['proxy'];
					if ((isset($proxySettings['proxyType']))&&($proxySettings['proxyType'] == 'SOCKS5'))
						self::$proxy['proxyType'] = $proxySettings['proxyType'];
					if (isset($proxySettings['proxyAccount']))
						self::$proxy['proxyAccount'] = $proxySettings['proxyAccount'];
				}
			}
		}
		if (self::$proxy == true){
			$opts[CURLOPT_PROXY] = self::$proxy['proxy'];
			if (isset(self::$proxy['proxyType']))
				$opts[CURLOPT_PROXYTYPE] = CURLPROXY_SOCKS5;
			if (isset(self::$proxy['proxyAccount']))
				$opts[CURLOPT_PROXYUSERPWD] = self::$proxy['proxyAccount'];
		}
hd_print("EEE rezka http_get_document(): url='$url'\n");
		return HD::http_get_document($url, $opts);
	}
}
?>
