<?php
if (!class_exists('DuneSystem')){
	if (preg_match('|plugins/(.*?)/lib|', __DIR__, $matches)){
		$tmp_path = '/tmp/plugins/'.$matches[1];
		$plugin_name = $matches[1];
		$install_dir = str_replace('/lib/wox', '',  __DIR__);
		if (file_exists('/persistfs/plugins_data'))
			$data_dir = "/persistfs/plugins_data/$plugin_name";
		else
			$data_dir = "/flashdata/plugins_data/$plugin_name";
        $port = HD::http_local_port();
		$www_url = "http://127.0.0.1:$port/plugins/$plugin_name/";
		$cgi_url = "http://127.0.0.1:$port/cgi-bin/plugins/$plugin_name/";
	}

	function hd_print($str){
		echo $str;
	}
	class DuneSystem{
		public static $properties = array ();
	};
	DuneSystem::$properties['plugin_name']      = $plugin_name;
	DuneSystem::$properties['install_dir_path'] = $install_dir;
	DuneSystem::$properties['tmp_dir_path']     = $tmp_path;
	DuneSystem::$properties['plugin_www_url']   = $www_url;
	DuneSystem::$properties['plugin_cgi_url']   = $cgi_url;
	DuneSystem::$properties['data_dir_path']    = $data_dir;
}



class Rutor_Class {
	static $cName = 'Rutor';
	static $className = 'Rutor_Class';
	static $DomainName = null;
	static $proxyArr = null;
	static $proxyArrMd5 = null;
	static $proxy = null;
	public static function getDomainName(){
		if (null === self::$DomainName)
			self::$DomainName = (HD::getItemStr(self::$cName . 'DomainName') != '') ? HD::getItemStr(self::$cName . 'DomainName') : 'http://rutor.is';
		return self::$DomainName;
	}
	public static function getMainMenuInfo(){
		return array (
			'name' => self::$cName,
			'descr' => '||'.self::$cName.'|каталог и источник торрентов с сайта '.self::$cName.'.|Если сайт не доступен используйте прокси или VPN, а так же официальные зеркала (сайты с похожим дизайном и названием могут не являтся зеркалом)'
		);
	}
	public static function get_media_url_str($k, $arr=null){
		if ($arr == true)
			return SmartVodCategoryListScreen::get_media_url_str($k, $arr);
		return SmartVodCategoryListScreen::get_media_url_str($k);
	}
	public static function getSearchMediaUrlStr($k, $arr = null){
		return SmartVodSimpleListScreen::get_media_url_str($k, $arr);
	}
	public static function getPopUpMenuItems ($selected_media_url, $parent_media_url){
		$menu_items = array();
		if ($parent_media_url == 'main_menu'){
			$menu_items[] = array(
				'caption' => 'Задать зеркало ' . self::$cName,
				'params' => array ('action' => 'mirror'),
				'icon_url' => SmartConfig::getPluginIco('s_' . self::$className)
			);
			$menu_items[] = array(
				'caption' => 'Прокси для ' . self::$cName,
				'params' => array ('action' => 'proxy'),
				'icon_url' => SmartConfig::getPluginIco('s_proxy')
			);
			$menu_items[] = 'is_separator';
		}
		$parent_media_url = MediaURL::decode($parent_media_url);
		if ($parent_media_url->screen_id == 'vod_torrentlist'){
			
			$menu_items[] = array(
				'caption' => 'Изменить действие для торрентов',
				'params' => array ('action' => 'torrentActionSetup'),
				'icon_url' => SmartConfig::getPluginIco('s_torrent')
			);
			$menu_items[] = array(
				'caption' => 'Выбрать действие торрента',
				'conID' => 'add_actions',
				'params' => array ('torrentAction' => 1),
				'icon_url' => SmartConfig::getPluginIco('s_list')
			);
			$menu_items[] = 'is_separator';
			$menu_items[] = array(
				'caption' => 'Настройки TorrServer',
				'conID' => 'classSetupTorrServer',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_torrserver')
			);
			$menu_items[] = array(
				'caption' => 'Настройки PeerflixServer',
				'conID' => 'classSetupPeerflixServer',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_peerflixserver')
			);
			$menu_items[] = array(
				'caption' => 'Настройки Transmission',
				'conID' => 'classSetupTransmission',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_transmission')
			);
			$menu_items[] = array(
				'caption' => 'Настройки Transmission UPnP',
				'conID' => 'classSetupTransmissionUPnP',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_transmissionupnp')
			);
			$menu_items[] = 'is_separator';
		}
		if ((isset($parent_media_url->screen_id))&&($parent_media_url->screen_id != 'vod_series')){
			$menu_items[] = array(
				'caption' => 'Добавить в Главное меню',
				'params' => array ('action' => 'addToMainMenu'),
				'icon_url' => SmartConfig::getPluginIco('s_home')
			);
		}
		
		return $menu_items;
	}
	public static function getVodCategories($media_url){
		static $categories = null;
		$category = null;
		if (isset($media_url->categoryId))
			$category = $media_url->categoryId;
		
		if (is_null($categories)){
			$categories[] = array('id'=> 'search', 'class' => 'SmartSearchScreen', 'caption' => 'Поиск');
			$categories[] = array('id'=> '/top', 'class' => 'SmartVodSimpleListScreen', 'caption' => 'Топ');
			$doc = self::http_get_document(self::getDomainName() . '/browse/');
			if (preg_match('|category_id">(.*?)</select>|ms',$doc, $matches)){
				if(preg_match_all ('|="(.*?)">(.*?)<|', $matches[1], $match)){
					foreach ($match[1] as $k => $v)
						$categories[] = array('id'=> "/$v/0/sortCatrgory", 'class' => 'SmartVodSimpleListScreen', 'caption' => $match[2][$k]);
				}
			}
		}
		return $categories;
	}
	public static function getScreenActionMapArr($media_url){
		$actionsArr = array();
		if ((isset($media_url->categoryId))&&($media_url->categoryId == '/top'))
			return $actionsArr;
		if((isset($media_url->screen_id))&&($media_url->screen_id != 'vod_category_list')){
			$actionsArr[0]['create_action'] = 'classAction';
			$actionsArr[0]['params'] = array ('indiClass' => self::$className,'action' => 'sort');
			$actionsArr[0]['caption'] = 'Сортировки';
			$actionsArr[0]['key'] = GUI_EVENT_KEY_C_YELLOW;
		}
		return $actionsArr;
	}
	public function classAction ($defs, $user_input, $select_url = null){
		hd_restore_warnings();
		$post_action = null;
		$caption = 'Error!';
		$msg = 'classAction: action';
		$width = 1050;
		$parent_media_url = MediaURL::decode($user_input->parent_media_url);
		if ($user_input->action == 'sort'){
			$sorting = (HD::getItemsArr(self::$className . '_sorting') != array()) ? HD::getItemsArr(self::$className . '_sorting') : array('vod_torrentlist' => '0', 'other' => '0');
			$add_params['control_id']= $user_input->control_id;
			$add_params['action'] = $user_input->action;
			$add_params['indiClass'] = self::$className;
			if ((isset($user_input->selected_control_id))&&(isset($user_input->action_type))){
				if (isset($user_input->initial_sel_ndx))
					$add_params['initial_sel_ndx'] = $user_input->initial_sel_ndx;
				if ($user_input->selected_control_id == 'sorting'){
					if ($parent_media_url->screen_id == 'vod_torrentlist')
						$sorting['vod_torrentlist'] = $user_input->sorting;
					else
						$sorting['other'] = $user_input->sorting;
					if (HD::saveItemsArr(self::$className . '_sorting', $sorting) == false)
						return ActionFactory::show_title_dialog("Сохранение не удалось");
				}
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
				$action = ActionFactory::close_dialog_and_run($action);
				return ActionFactory::invalidate_folders(array($user_input->parent_media_url), $action);
			}
			$sorting_ops['0']			= 'дате добавления';
			$sorting_ops['2']			= 'раздающим';
			$sorting_ops['4']			= 'качающим';
			$sorting_ops['6']			= 'названию';
			$sorting_ops['8']			= 'размеру';
			$sorting_ops['10']			= 'релевантности';
			if ($parent_media_url->screen_id == 'vod_torrentlist')
				$s = $sorting['vod_torrentlist'];
			else
				$s = $sorting['other'];
			ControlFactory::add_combobox($defs, $this, $add_params,
				'sorting', '',
				$s, $sorting_ops, 600, true, false
			);
			$attrs['initial_sel_ndx'] = isset($user_input->initial_sel_ndx) ? $user_input->initial_sel_ndx : -1;
			return ActionFactory::show_dialog("Cортировка:", $defs, true, 0, $attrs);
		}
		return ActionFactory::show_title_dialog($caption, $post_action, $msg, 0);
	}
	public static function getSearchShortMovieRange ($keyword, &$m_feed){
		if (is_object($keyword))
			$keyword = $keyword->searchStr;
		$arr['searchStr'] =  str_replace(" ", "%20", $keyword);
		$arr['categoryId'] =  'search';
		$obj = (object) $arr;
		return self::getShortMovieRange ($obj, &$m_feed);
	}
	public static function getShortTorrentRange ($movie, $media_url, &$m_feed){
		$items = array();
		if ($m_feed === 'end')
			return $items;
		$icon_path = SmartConfig::getPluginIco('s_torrent');
		if (($m_feed == 0)&&(isset($movie->class_info['torrent'][self::$className]))){
			$caption = $movie->class_info['torrent'][self::$className]['caption'];
			$path_parts = parse_url(self::getDomainName());
			if (preg_match("|".$path_parts['host']."|", $movie->class_info['torrent'][self::$className]['id'])){
				$tmp = explode($path_parts['host'], $v);
				$movie->class_info['torrent'][self::$className]['id'] = $tmp[1];
			}
			$short_movie = new ShortMovie(
				strval(trim($movie->class_info['torrent'][self::$className]['id'])),
				strval($caption),
				strval($movie->poster_url)
			);
			$short_movie->icon_path = $icon_path;
			$short_movie->tType = 'torrent';
			$info = '||' . $caption . '|'. self::$cName;
			$info .= '||Добавлен:|' . $movie->class_info['torrent'][self::$className]['add_date'];
			$info .= '||Размер|' . $movie->class_info['torrent'][self::$className]['size'];
			$info .= '||Seed:|' . $movie->class_info['torrent'][self::$className] ['S'];
			$info .= '||Leech:|' . $movie->class_info['torrent'][self::$className]['L'];
			$short_movie->info = $info;
			$short_movie->extra_item = $movie->class_info['torrent'][self::$className]['size']
			. '|S:' . $movie->class_info['torrent'][self::$className]['S']
			. '|L:' . $movie->class_info['torrent'][self::$className]['L'];
			$short_movie->details_box_width = true;
			array_push ($items, $short_movie);
		}
		if ($m_feed == 0){
			$sorting = (HD::getItemsArr(self::$className . '_sorting') != array()) ? HD::getItemsArr(self::$className . '_sorting') : array('vod_torrentlist' => '0', 'other' => '0');
			if (isset($movie->class_info[self::$className]['searchTorrentUrl']))
				$url = self::getDomainName() .  str_replace('/0/0/', "/0/".$sorting['vod_torrentlist']."/", $movie->class_info[self::$className]['searchTorrentUrl']);
			else
				$url = self::getDomainName() . str_replace('sort', $sorting['vod_torrentlist'], "/search/0/0/000/sort/") . str_replace(" ", "%20", $movie->name);
		}else
			$url = self::getDomainName() . $m_feed;
		$doc = self::http_get_document($url);
		if (preg_match('|<a href="(/search/\d/.*?)"|', $doc, $match))
			$m_feed = $match[1];
		else
			$m_feed = 'end';
		$doc = preg_replace('|<td align="right">\d+?<img.*?/>|', '', $doc);  
		if (preg_match_all('|<tr class="...">(.+?)</td.*?href="(.+?)">(.+?)</td>.*?align="right">(.+?)</td.+?class="green">(.+?)</span.+?class="red">(.+?)</span|ms', $doc, $matches)){
			foreach ($matches[2] as $k => $v){
				$caption = HD::str_remove_tag(str_replace('|', '*', $matches[3][$k]));
				$path_parts = parse_url(self::getDomainName());
				if (preg_match("|".$path_parts['host']."|",$v)){
				$tmp = explode($path_parts['host'], $v);
					$v = $tmp[1];
				}
				$short_movie = new ShortMovie(
					strval(trim($v)),
					strval($caption),
					strval($movie->poster_url)
				);
				$short_movie->tType = 'torrent';
				$short_movie->icon_path = $icon_path;
				$info = '||' . $caption . '|'. self::$cName;
				$size = HD::str_remove_tag($matches[4][$k]);
				$s = HD::str_remove_tag($matches[5][$k]);
				$l = HD::str_remove_tag($matches[6][$k]);
				$info .= '||Добавлен:|' . HD::str_remove_tag($matches[1][$k]);
				$info .= '||Размер|' . $size;
				$info .= '||Seed:|' . $s;
				$info .= '||Leech:|' . $l;
				$short_movie->info = $info;
				$short_movie->extra_item = $size 
				. '|S:' . $s
				. '|L:' . $l;
				$short_movie->details_box_width = true;
				array_push ($items, $short_movie);
			}
		}
		// }else
			// $m_feed = 'end';
		// echo 'ss';
		return $items;
	}
	public static function getShortMovieRange ($media_url, &$m_feed){
		$items = array();
		if ($m_feed === 'end')
			return $items;
		if ($media_url->categoryId == '/top')
			$doc = self::http_get_document(self::getDomainName() . $media_url->categoryId);
		else if (isset($media_url->searchStr)){
			$sorting = (HD::getItemsArr(self::$className . '_sorting') != array()) ? HD::getItemsArr(self::$className . '_sorting') : array('vod_torrentlist' => '0', 'other' => '0');
			$doc = self::http_get_document(self::getDomainName() . "/search/$m_feed/0/000/" .  $sorting['other'] .'/' . $media_url->searchStr);
		}else{
			$sorting = (HD::getItemsArr(self::$className . '_sorting') != array()) ? HD::getItemsArr(self::$className . '_sorting') : array('vod_torrentlist' => '0', 'other' => '0');
			$doc = self::http_get_document(self::getDomainName() . "/browse/$m_feed" .  str_replace('sortCatrgory', $sorting['other'], $media_url->categoryId));
		}
		if (preg_match('|<b>След.&nbsp;&gt;&gt;</b></p>|', $doc))
			$m_feed = 'end';
		else
			++$m_feed;
		$doc = preg_replace('|right">\d*?<img.*?</td|','',$doc);
		if (preg_match_all('|<tr class=".*?"><td>(.*?)</td>.*?href="(.*?)".*?href="(.*?)".*?href="(.*?)">(.*?)<.*?<td.*?>(.*?)</td>.*?green">(.*?)</span>.*?red">(.*?)</span>|ms', $doc, $matches)){
			$poster_url = SmartConfig::getPluginIco(self::$className);
			foreach ($matches[4] as $k => $v){
				$caption = HD::str_remove_tag(str_replace('|', '*', $matches[5][$k]));
				$path_parts = parse_url(self::getDomainName());
				if (preg_match("|".$path_parts['host']."|",$v)){
					$tmp = explode($path_parts['host'], $v);
					$v = $tmp[1];
				}
				$short_movie = new ShortMovie(
					strval(trim($v)),
					strval($caption),
					strval($poster_url)
				);
				$info = '||' . $caption . '|'. self::$cName;
				$size = HD::str_remove_tag($matches[6][$k]);
				$s = HD::str_remove_tag($matches[7][$k]);
				$l = HD::str_remove_tag($matches[8][$k]);
				$info .= '||Добавлен:|' . HD::str_remove_tag($matches[1][$k]);
				$info .= '||Размер|' . $size;
				$info .= '||Seed:|' . $s;
				$info .= '||Leech:|' . $l;
				$short_movie->info = $info;
				$short_movie->shape = 'tetragon';
				$short_movie->extra_item = $size 
				. '|S:' . $s
				. '|L:' . $l;
				array_push ($items, $short_movie);
			}
		}
		return $items;
	}
	public static function load_movie($movie_id, $mUrl, $getMovieInfo){
		$arr = array();
		$arr['caption'] = $arr['class_info']['catalog_info']['caption'] = $mUrl->caption;
		$arr['poster_url'] = $arr['class_info']['catalog_info']['poster_url'] = $mUrl->poster_url;
		if (isset($mUrl->caption_original))
			$arr['caption_original'] = $arr['class_info']['catalog_info']['caption_original'] = $mUrl->caption_original;
		if (isset($mUrl->year))
			$arr ['year'] = $arr['class_info']['catalog_info']['year'] = $mUrl->year;
		if (!preg_match("|^http|",$movie_id))
			$movie_id = self::getDomainName() . $movie_id;
		$doc = self::http_get_document($movie_id);
		if (preg_match('|id="details">(.+?)<td class="header">|ms', $doc, $match)){
			if (preg_match('|src="(.*?)"|ms', $match[1], $m))
				$arr['poster_url'] = self::http_get_img ($m[1]);
			$match[1] = str_replace("&gt;","",$match[1]);
			$match[1] = preg_replace('/class="hidewrap">(.+?)<tr>/ms', "", $match[1]);
			$match[1] = trim(html_entity_decode(strip_tags($match[1]), ENT_QUOTES,'UTF-8'));
			$match[1] = preg_replace("/\s*\r+/", "", $match[1]);
			$arr['description'] = strip_tags (str_replace("<br", "\n<br", $match[1]));
		}
		if (preg_match('|<h1>(.*?)</|ms', $doc, $match))
			$capt = $arr ['caption'] = HD::str_remove_tag($match[1]);
		
		if (preg_match('|Страна:(.*?)<br|ms', $doc, $match))
			$arr ['country'] = HD::str_remove_tag($match[1]);
		if (preg_match('|<b>Год в.*?>(.+?)<br|ms', $doc, $match)){
			$year = HD::str_remove_tag($match[1]);
			if (preg_match('|\d{4}$|', $year))
				$arr ['year'] = $year;
			else{
				$arr ['country'] .= ', ' . $year;
				$arr ['year'] = $year;
			}
		}
		if (preg_match('|Жанр:(.*?)<br|ms', $doc, $match))
			$arr['genres'] = HD::str_remove_tag($match[1]);
		if (preg_match('|Режиссер:(.*?)<br|ms', $doc, $match))
			$arr['director'] = HD::str_remove_tag($match[1]);
		if (preg_match('|В ролях:(.*?)<br|ms', $doc, $match))
			$arr['actors'] = HD::str_remove_tag($match[1]);
		if (preg_match('|Студия:(.*?)<br|ms', $doc, $match))
			$arr ['details']['Студия:'] = HD::str_remove_tag($match[1]);
		if (preg_match('|kinopoisk.ru/film/(\d*)|ms', $doc, $match))
			$arr['class_info']['dbIDs']['kpID'] = $match[1];
		else if (preg_match('|kinopoisk.ru/rating/(\d*?)\.|ms', $doc, $match))
			$arr['class_info']['dbIDs']['kpID'] = $match[1];
		else{
			$kpIDs = HD::getItemsArr('kpIDs');
			if (isset($kpIDs[$movie_id]))
				$arr['class_info']['dbIDs']['kpID'] = $kpIDs[$movie_id];
		}
		if (preg_match('|imdb.com/title/tt(\d*?)/|ms', $doc, $match))
			$arr['class_info']['dbIDs']['imdbID'] = 'tt'.$match[1];
		if (!isset($arr['class_info']['dbIDs']['kpID'])){
			$arr['class_info']['goToScreen'] = 'SmartVodTorrentsScreen';
			$arr['class_info']['noTrailers'] = true;
		}else
			$arr = SmartConfig::getMovieInfoArr($getMovieInfo, $movie_id, $mUrl, $arr);
		if ($capt == $arr['caption'])
			$arr['class_info']['goToScreen'] = 'SmartVodTorrentsScreen';
		
		if (preg_match('|;"><a href="(.*?)"|ms', $doc, $match))
			$arr['class_info'][self::$className]['searchTorrentUrl'] = str_replace(" ", "%20", $match[1]);
		if (preg_match('|<h1>(.*?)</|ms', $doc, $match))
			$arr['class_info']['torrent'][self::$className]['caption'] = HD::str_remove_tag($match[1]);
		if (preg_match('|torrent/(\d*?)/|', $movie_id, $match))
			$arr['class_info']['torrent'][self::$className]['id'] = '/download/'.$match[1];
		if (preg_match('|>Раздают</td><td>(.*?)</|ms', $doc, $match))
			$arr['class_info']['torrent'][self::$className] ['S'] = HD::str_remove_tag($match[1]);
		if (preg_match('|>Качают</td><td>(.*?)</|ms', $doc, $match))
			$arr['class_info']['torrent'][self::$className]['L'] = HD::str_remove_tag($match[1]);
		if (preg_match('|обавлен</td><td>(.*?)</|ms', $doc, $match))
			$arr['class_info']['torrent'][self::$className]['add_date'] = HD::str_remove_tag($match[1]);
		if (preg_match('|азмер</td><td>(.*?)\(|ms', $doc, $match))
			$arr['class_info']['torrent'][self::$className]['size'] = HD::str_remove_tag($match[1]);
		return $arr;
	}
	public static function getVodSourceInfo($v){
		$ico = SmartConfig::getPluginIco(self::$className);
		$sources['caption'] = self::$cName;
		$sources['detailed_info'] = '||'.self::$cName.'|Торрент файлы найденные на '.self::$cName.' по названию. Так как поиск производится по названию возможны неточности.';
		$sources['icon_path'] = $ico;
		$sources['detailed_icon_path'] = $ico;
		$sources['goTo'] = 'SmartVodTorrentsScreen';
		$sources['class_name'] = $v;
		$sources['type'] = SmartConfig::getPluginIco('torrentSource');
		return $sources;
	}
	public static function getTorrentFile($torrent_id, $dloadPath=null){
		$url = $torrent_id;
		if (!preg_match("|^http|", $torrent_id))
			$url = self::getDomainName() . $torrent_id;
		$doc = self::http_get_document($url);
		return SmartConfig::checkTorrent($dloadPath, $doc);
	}
	public static function http_get_img ($url){
		if (preg_match("|https|",$url))
			return DuneSystem::$properties['plugin_cgi_url'] . "do?img=" .  $url;	
		return $url;
	}
	public static function http_get_document ($url, $opts=null){
		if (is_null(self::$proxy)){
			self::$proxy = false;
			$sitesProxy = HD::getItemsArr('sitesProxy');
			if (isset($sitesProxy[self::$cName])){
				$proxySettings = (HD::getItemsArr('proxySettings') != array()) ? HD::getItemsArr('proxySettings') : array();
				if (isset($proxySettings['proxy'])){
					self::$proxy['proxy'] = $proxySettings['proxy'];
					if ((isset($proxySettings['proxyType']))&&($proxySettings['proxyType'] == 'SOCKS5'))
						self::$proxy['proxyType'] = $proxySettings['proxyType'];
					if (isset($proxySettings['proxyAccount']))
						self::$proxy['proxyAccount'] = $proxySettings['proxyAccount'];
				}
			}
		}
		if (self::$proxy == true){
			$opts[CURLOPT_PROXY] = self::$proxy['proxy'];
			if (isset(self::$proxy['proxyType']))
				$opts[CURLOPT_PROXYTYPE] = CURLPROXY_SOCKS5;
			if (isset(self::$proxy['proxyAccount']))
				$opts[CURLOPT_PROXYUSERPWD] = self::$proxy['proxyAccount'];
		}
		return HD::http_get_document($url, $opts);
	}
}
?>
