<?php
if (!class_exists('DuneSystem')){
	if (preg_match('|plugins/(.*?)/lib|', __DIR__, $matches)){
		$tmp_path = '/tmp/plugins/'.$matches[1];
		$plugin_name = $matches[1];
		$install_dir = str_replace('/lib/wox', '',  __DIR__);
		if (file_exists('/persistfs/plugins_data'))
			$data_dir = "/persistfs/plugins_data/$plugin_name";
		else
			$data_dir = "/flashdata/plugins_data/$plugin_name";
        $port = HD::http_local_port();
		$www_url = "http://127.0.0.1:$port/plugins/$plugin_name/";
		$cgi_url = "http://127.0.0.1:$port/cgi-bin/plugins/$plugin_name/";
	}

	function hd_print($str){
		echo $str;
	}
	class DuneSystem{
		public static $properties = array ();
	};
	DuneSystem::$properties['plugin_name']      = $plugin_name;
	DuneSystem::$properties['install_dir_path'] = $install_dir;
	DuneSystem::$properties['tmp_dir_path']     = $tmp_path;
	DuneSystem::$properties['plugin_www_url']   = $www_url;
	DuneSystem::$properties['plugin_cgi_url']   = $cgi_url;
	DuneSystem::$properties['data_dir_path']    = $data_dir;
}
class Seasonvar_Class {
	static $cName = 'Seasonvar';
	static $className = 'Seasonvar_Class';
	static $DomainName = null;
	static $proxyArr = null;
	static $proxyArrMd5 = null;
	static $proxy = null;
	public static function getDomainName(){
		if (null === self::$DomainName)
			self::$DomainName = (HD::getItemStr(self::$cName . 'DomainName') != '') ? HD::getItemStr(self::$cName . 'DomainName') : 'http://seasonvar.ru';
		return self::$DomainName;
	}
	public static function getMainMenuInfo(){
		return array (
			'name' => self::$cName,
			'descr' => '||'.self::$cName.'|каталог и источник видео с сайта ' . self::$cName . '||Если сайт не доступен используйте прокси или VPN, а так же официальные зеркала (сайты с похожим дизайном и названием могут не являтся зеркалом)'
			);
	}
	public static function get_media_url_str($k, $arr=null){
		if ($arr == true)
			return SmartVodCategoryListScreen::get_media_url_str($k, $arr);
		return SmartVodCategoryListScreen::get_media_url_str($k);
	}
	public static function getSearchMediaUrlStr($k, $arr=null){
		return SmartVodListScreen::get_media_url_str($k, $arr);
	}
	public static function getScreenActionMapArr($media_url){
		$actionsArr = array();
		if((isset($media_url->categoryId))&&((preg_match('|all_|', $media_url->categoryId))||
			(preg_match('|_genre_|', $media_url->categoryId))||
			(preg_match('|_country|', $media_url->categoryId)))){
			$actionsArr[0]['create_action'] = 'classAction';
			$actionsArr[0]['params'] = array ('indiClass' => self::$className,'action' => 'sort');
			$actionsArr[0]['caption'] = 'Сортировки';
			$actionsArr[0]['key'] = GUI_EVENT_KEY_C_YELLOW;
		}
		return $actionsArr;
	}
	public static function getPopUpMenuItems ($selected_media_url, $parent_media_url){
		$menu_items = array();
		if ($parent_media_url == 'main_menu'){
			$menu_items[] = array(
				'caption' => 'Задать зеркало ' . self::$cName,
				'params' => array ('action' => 'mirror'),
				'icon_url' => SmartConfig::getPluginIco('s_' . self::$className)
			);
			$menu_items[] = array(
				'caption' => 'Прокси для ' . self::$cName,
				'params' => array ('action' => 'proxy'),
				'icon_url' => SmartConfig::getPluginIco('s_proxy')
			);
			$menu_items[] = 'is_separator';
		}
		$parent_media_url = MediaURL::decode($parent_media_url);
		if ((isset($parent_media_url->screen_id))&&($parent_media_url->screen_id != 'vod_series')){
			$menu_items[] = array(
				'caption' => 'Добавить в Главное меню',
				'params' => array ('action' => 'addToMainMenu'),
				'icon_url' => SmartConfig::getPluginIco('s_home')
			);
		}
		return $menu_items;
	}
	public static function getVodCategories($media_url){
		static $categories = null;
		if (is_null($categories)){
			$categories['categories'][] = array('id'=> 'search', 'class' => 'SmartSearchScreen', 'caption' => 'Поиск');
			$categories['categories'][] = array('id'=> 'all_', 'class' => 'SmartVodListScreen', 'caption' => 'Все Сериалы');
			$categories['categories'][] = array('id'=> 'all_eng', 'class' => 'SmartVodListScreen', 'caption' => 'Все Зарубежные');
			$categories['categories'][] = array('id'=> 'all_rus', 'class' => 'SmartVodListScreen', 'caption' => 'Все Русские');
			$categories['categories'][] = array('id'=> 'update', 'class' => 'SmartVodListScreen', 'caption' => 'Последние обновления');
			$categories['categories'][] = array('id'=> 'top', 'class' => 'SmartVodCategoryListScreen', 'caption' => 'Лучшие сериалы');
			$categories['subCategories']['top'][] = array('id'=> '/?mode=top&period=1', 'class' => 'SmartVodListScreen', 'caption' => 'Все жанры лучшие за день');
			$categories['subCategories']['top'][] = array('id'=> '/?mode=top&period=7', 'class' => 'SmartVodListScreen', 'caption' => 'Все жанры лучшие за неделю');
			$categories['subCategories']['top'][] = array('id'=> '/?mode=top&period=31', 'class' => 'SmartVodListScreen', 'caption' => 'Все жанры лучшие за месяц');
			$doc = self::http_get_document(self::getDomainName());
			if (preg_match('|genre">(.*?)</select|ms', $doc, $match)){
				if (preg_match_all ('| <option value="(.*?)">(.*?)</option>|', $match[1], $match)){
					foreach($match[1] as $k => $v){
						$categories['subCategories']['top'][] = array('id'=> "/?mode=top&genre=$v&period=1", 'class' => 'SmartVodListScreen', 'caption' => HD::get_upper(HD::str_remove_tag($match[2][$k])) . ' лучшие за день');
						$categories['subCategories']['top'][] = array('id'=> "/?mode=top&genre=$v&period=7", 'class' => 'SmartVodListScreen', 'caption' =>HD::get_upper(HD::str_remove_tag($match[2][$k])) . ' лучшие за неделю');
						$categories['subCategories']['top'][] = array('id'=> "/?mode=top&genre=$v&period=31", 'class' => 'SmartVodListScreen', 'caption' => HD::get_upper(HD::str_remove_tag($match[2][$k])) . ' лучшие за месяц');
					}
				}
			}
			$categories['categories'][] = array('id'=> 'genre', 'class' => 'SmartVodCategoryListScreen', 'caption' => 'Жанры');
			$categories['categories'][] = array('id'=> 'genre_eng', 'class' => 'SmartVodCategoryListScreen', 'caption' => 'Жанры Зарубежные');
			$categories['categories'][] = array('id'=> 'genre_rus', 'class' => 'SmartVodCategoryListScreen', 'caption' => 'Жанры Русские');
			if (preg_match('|genre">(.*?)</select|ms', $doc, $match)){
				if (preg_match_all ('| <option value="(.*?)">(.*?)</option>|', $match[1], $match)){
					foreach($match[1] as $k => $v){
						$categories['subCategories']['genre'][] = array('id'=> $v. '_genre_', 'class' => 'SmartVodListScreen', 'caption' => HD::get_upper(HD::str_remove_tag($match[2][$k])));
						$categories['subCategories']['genre_eng'][] = array('id'=> $v . '_genre_eng', 'class' => 'SmartVodListScreen', 'caption' =>HD::get_upper(HD::str_remove_tag($match[2][$k])));
						$categories['subCategories']['genre_rus'][] = array('id'=> $v. '_genre_rus', 'class' => 'SmartVodListScreen', 'caption' => HD::get_upper(HD::str_remove_tag($match[2][$k])));	
					}
				}
			}
			$categories['categories'][] = array('id'=> 'country', 'class' => 'SmartVodCategoryListScreen', 'caption' => 'Страны');
			if (preg_match('|country">(.*?)</select|ms', $doc, $match)){
				if (preg_match_all ('| <option value="(.*?)">(.*?)</option>|', $match[1], $match)){
					unset ($match[1][0]);
					foreach($match[1] as $k => $v)
						$categories['subCategories']['country'][] = array('id'=> $v . '_country', 'class' => 'SmartVodListScreen', 'caption' => HD::get_upper(HD::str_remove_tag($match[2][$k])));
				}
			}
		}
		if (isset($media_url->categoryId))
			return $categories['subCategories'][$media_url->categoryId];
		return $categories['categories'];
	}
	public static function getShortMovieRange ($media_url, &$m_feed){
		static $seasonvar_arr = null;
		if ($m_feed === 'end')
			return $items;
		$sorting = (HD::getItemsArr(self::$className . '_sorting') != array()) ? HD::getItemsArr(self::$className . '_sorting') :  array('sort' => 'newest');
		$sort = $sorting['sort'];
		if ((is_null($seasonvar_arr))||(!isset($seasonvar_arr[$media_url->categoryId][$sort]))){
			$seasonvar_arr = array();
			if (preg_match("|mode=top|",$media_url->categoryId)){
				$doc = self::http_get_document(self::getDomainName() . $media_url->categoryId);
				if (preg_match_all ('|info".*? href="(.*?)">(.*?)</a>.*?<p>(.*?)</p>|ms', $doc, $match)){
					foreach ($match[1] as $k => $v){
							$items[$v]['url']				= $v;
							if (preg_match('|serial-(.*?)-|', $v, $matches))
								$items[$v]['img']			= 'http://cdn.seasonvar.ru/oblojka/'.$matches[1].'.jpg';
							$items[$v]['name']				= preg_replace('|\(\d*?\)|','', HD::str_remove_tag($match[2][$k]));
							$items[$v]['new']	= HD::str_remove_tag($match[3][$k]);
						}
				}
				$m_feed = 'end';
				return self::parseSitePage($items);
			}
			if ($media_url->categoryId == 'update'){
				$doc = self::http_get_document(self::getDomainName());
				$tmp = explode('news">', $doc);
				unset($tmp[0]);
				foreach ($tmp as $vel){
					if (preg_match('|head">(.*?)</div|ms', $vel, $matches))
						$date = HD::str_remove_tag($matches[1]);
					if (preg_match_all ('|href="(.*?)" data-id="(.*?)".*?news_n">(.*?)</div>(.*?)<span class="news_s">(.*?)</|ms', $vel, $match)){
						foreach ($match[1] as $k => $v){
							$items[$v]['url']	= $v;
							$items[$v]['img']	= 'http://cdn.seasonvar.ru/oblojka/'.$match[2][$k].'.jpg';
							$items[$v]['name']	= preg_replace('|\(\d*?\)|','',HD::str_remove_tag($match[3][$k]));
							$items[$v]['new']	= trim($match[5][$k]) . ' ' . trim($match[4][$k]);
							$items[$v]['date']	= $date;
						}
					}
				}
				$m_feed = 'end';
				return self::parseSitePage($items);
			}
			if (preg_match('|all_(.*)|', $media_url->categoryId, $matches))
				$postfields = "filter%5BsortTo%5D%5B%5D=$sort&filter%5BengName%5D=&filter%5Bonly%5D=".$matches[1]."&filter%5Brait%5D=kp&filter%5Bhd%5D=&filter%5Bsub%5D=&filter%5Bblock%5D=&filter%5Bhistory%5D=&filter%5Bmark%5D=&filter%5Bnw%5D=&filter%5Bexp%5D=&beforeSend=";
			if (preg_match('|(.*)_genre_(.*)|', $media_url->categoryId, $matches))
				$postfields = "filter%5BquotG%5D%5B%5D=".$matches[1]."&filter%5BsortTo%5D%5B%5D=$sort&filter%5BengName%5D=&filter%5Bonly%5D=".$matches[2]."&filter%5Brait%5D=kp&filter%5Bhd%5D=&filter%5Bsub%5D=&filter%5Bblock%5D=&filter%5Bhistory%5D=&filter%5Bmark%5D=&filter%5Bnw%5D=&filter%5Bexp%5D=&beforeSend=";
			if (preg_match('|(.*)_country|', $media_url->categoryId, $matches))
				$postfields = "filter%5BquotC%5D%5B%5D=".$matches[1]."&filter%5BsortTo%5D%5B%5D=$sort&filter%5BengName%5D=&filter%5Bonly%5D=&filter%5Brait%5D=kp&filter%5Bhd%5D=&filter%5Bsub%5D=&filter%5Bblock%5D=&filter%5Bhistory%5D=&filter%5Bmark%5D=&filter%5Bnw%5D=&filter%5Bexp%5D=&beforeSend=";
			$opts [CURLOPT_POST] = true;
			$opts [CURLOPT_POSTFIELDS] = $postfields;
			$header[] = "X-Requested-With: XMLHttpRequest";
			$opts[CURLOPT_HTTPHEADER] = $header;	
			$doc =  self::http_get_document(self::getDomainName() . '/index.php', $opts);
			if (preg_match_all ('|<a data-id="(.*?)" href="(.*?)".*?>(.*?)</a>|ms', $doc, $match)){
				$i=0;
				foreach ($match[2] as $k => $v){
					$seasonvar_arr[$media_url->categoryId][$sort][$i]['url']	= $v;
					$seasonvar_arr[$media_url->categoryId][$sort][$i]['img']	= 'http://cdn.seasonvar.ru/oblojka/'.$match[1][$k].'.jpg';
					$seasonvar_arr[$media_url->categoryId][$sort][$i]['name']	= preg_replace('|\(\d*?\)|', '', HD::str_remove_tag($match[3][$k]));
					if (preg_match('|data-trailer="(.*?)"|ms', $match[0][$k], $m))
						$seasonvar_arr[$media_url->categoryId][$sort][$i]['new']	= HD::str_remove_tag($m[1]);
					$i++;
				}
			}
		}
		if (($m_feed * 50) < (count($seasonvar_arr[$media_url->categoryId][$sort]))){
			$i = $m_feed * 50;
			do {
				if (isset($seasonvar_arr[$media_url->categoryId][$sort][$i]))
					$items[$i] = $seasonvar_arr[$media_url->categoryId][$sort][$i];
				$i++;
			} while ($i < (($m_feed * 50) + 50));
			$m_feed++;
			return self::parseSitePage($items);
		}else{
			$m_feed = 'end';
			return false;
		}
	}
	public static function getSearchShortMovieRange ($keyword, &$m_feed){
		if (is_object($keyword))
			$keyword = $keyword->searchStr;
		if ($m_feed === 'end')
			return array();
		$url =  self::getDomainName() . '/?mode=search&query=' . urlencode($keyword);
		if ($m_feed > 0)
			$url = $url .'&page='. ($m_feed+1);
		$doc = self::http_get_document($url);
		++$m_feed;
		if (!preg_match('|<div class="pgs-search-page">|', $doc))
			$m_feed = 'end';
		if (preg_match_all ('|info".*? href="(.*?)">(.*?)</a>.*?<p>(.*?)</p>|ms', $doc, $match)){
			foreach ($match[1] as $k => $v){
				$items[$v]['url']				= $v;
				if (preg_match('|serial-(.*?)-|', $v, $matches))
					$items[$v]['img']			= self::http_get_img ('http://cdn.seasonvar.ru/oblojka/'.$matches[1].'.jpg');
				$items[$v]['name']				= preg_replace('|\(\d*?\)|','',HD::str_remove_tag($match[2][$k]));
				$items[$v]['date']	= HD::str_remove_tag($match[3][$k]);
				
				$info = '||' . $items[$v]['name'] . '|' . $items[$v]['date'];
				$items[$v]['infoArr']['caption'] = $items[$v]['name'];
				if (preg_match('|<br><a href=".*?>(.*?)</a>|', $match[0][$k], $m)){
					$items[$v]['new'] = $m[1];
					$items[$v]['infoArr']['caption_original'] = $items[$v]['new'];
				}
				$items[$v]['infoArr']['poster_url'] = $items[$v]['img'];
				$items[$v]['infoArr']['detailed_info'] = $info;
			}
			if (class_exists('ShortMovie'))
				return self::parseSitePage($items);
			return $items;
		}else
			return array();		
	}
	public static function parseSitePage($arr){
		$items = array();
		foreach ($arr as $k => $v){
			$short_movie = new ShortMovie(
				strval(trim($v['url'])),
				strval($v['name']),
				strval(self::http_get_img ($v['img']))
			);
			$info = '||' . $v['name'];
			if (isset($v['new']))
				$info .= '|' . $v['new'];
			else
				$info .= '|' . self::$cName;
			if (isset($v['date']))
				$info .= '|' . $v['date'];
			$short_movie->info = $info;
			array_push ($items, $short_movie);
		}
		return $items;
	}
	public static function load_movie($movie_id, $mUrl, $getMovieInfo){
		$arr = array();
		$arr['caption'] = $arr['class_info']['catalog_info']['caption'] = $mUrl->caption;
		$arr['poster_url'] = $arr['class_info']['catalog_info']['poster_url'] = $mUrl->poster_url;
		if (isset($mUrl->caption_original))
			$arr['caption_original'] = $arr['class_info']['catalog_info']['caption_original'] = $mUrl->caption_original;
		if (isset($mUrl->year))
			$arr ['year'] = $arr['class_info']['catalog_info']['year'] = $mUrl->year;
		if (!preg_match("|^http|",$movie_id))
			$url = self::getDomainName() . $movie_id;
		else
			$url = preg_replace('#((http.*)://.+?\/)#i', self::getDomainName() . "/", $movie_id);
		$doc = self::http_get_document($url);
		if (preg_match('|itemprop="name">(.*?)</|ms', $doc, $match)){
			$match[1] = str_replace(array('Сериал','онлайн'), "", $match[1]);
			$arr['caption_original'] = $arr['caption'] = HD::str_remove_tag($match[1]);
			if (preg_match('|(.*)/(.*)|',  $match[1], $match)){
				$arr['caption'] = trim($match[1]);
				$arr['caption_original']  = trim($match[2]);
			}
		}
		if (preg_match('|description">(.*?)</p>|ms', $doc, $match))
			$arr ['description'] = HD::str_remove_tag($match[1]);
		if (preg_match('|image" content="(.+?)"|ms', $doc, $match))
			$arr['poster_url'] = ($match[1]);
		if (preg_match('|ригиналю+?>(.+?)</|ms', $doc, $match))
			$arr['caption_original'] = HD::str_remove_tag($match[1]);
		if (preg_match('|(.*?)ежиссер:(.*)|ms', $doc, $m)){
			if (preg_match_all('|<span itemprop="name">(.+?)</|ms', $m[1], $match))
				$arr['actors'] = implode (', ', $match[1]);
			if (preg_match_all('|<span itemprop="name">(.+?)</|ms', $m[2], $match))
				$arr['director'] = implode (', ', $match[1]);
		}else if (preg_match_all('|<span itemprop="name">(.+?)</|ms', $doc, $match))
				$arr['actors'] = implode (', ', $match[1]);
		if (preg_match('|genre">(.*?)</|ms', $doc, $match))
			$arr['genres'] = HD::str_remove_tag($match[1]);
		if (preg_match('|.*?трана.*?:(.*?)</|ms', $doc, $match))
			$arr ['country'] = HD::str_remove_tag($match[1]);
		if (preg_match('|ышел.*?:(.*?)</|ms', $doc, $match))
			$arr ['year'] = HD::str_remove_tag($match[1]);
		if (preg_match('|rating">.*?иноПоиск.*?>(.*?)</|ms', $doc, $match))
			$arr ['rate_kinopoisk'] = HD::str_remove_tag($match[1]);
		if (preg_match('|rating">.*?IMDB.*?>(.*?)</|ms', $doc, $match))
			$arr ['rate_imdb'] = HD::str_remove_tag($match[1]);
		$arr['class_info']['linksArr'][self::$className] = Seasonvar::getSeasonvarIframe ($movie_id, 'video_id');
		$kpIDs = HD::getItemsArr('kpIDs');
		if (isset($kpIDs[$movie_id]))
			$arr['class_info']['dbIDs']['kpID'] = $kpIDs[$movie_id];
		
		if ($getMovieInfo != 'min')
			$arr = SmartConfig::getMovieInfoArr($getMovieInfo, $movie_id, $mUrl, $arr);
		return $arr;
	}
	public function classAction ($defs, $user_input, $select_url = null){
		hd_restore_warnings();
		$post_action = null;
		$caption = 'Error!';
		$msg = 'classAction: action';
		$width = 1050;
		$parent_media_url = MediaURL::decode($user_input->parent_media_url);
		if ($user_input->action == 'sort'){
			$sorting = (HD::getItemsArr(self::$className . '_sorting') != array()) ? HD::getItemsArr(self::$className . '_sorting') :  array('sort' => 'newest');
			$add_params['control_id']= $user_input->control_id;
			$add_params['action'] = $user_input->action;
			$add_params['indiClass'] = self::$className;
			if ((isset($user_input->selected_control_id))&&(isset($user_input->action_type))){
				if (isset($user_input->initial_sel_ndx))
					$add_params['initial_sel_ndx'] = $user_input->initial_sel_ndx;
				$sorting['sort'] = $user_input->sorting;
				if (HD::saveItemsArr(self::$className . '_sorting', $sorting) == false)
					return ActionFactory::show_title_dialog("Сохранение не удалось");
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
				$action = ActionFactory::close_dialog_and_run($action);
				return ActionFactory::invalidate_folders(array($user_input->parent_media_url), $action);
			}
			$add_params['initial_sel_ndx'] = 0;
			$sorting = $sorting['sort'];
			$sorting_ops['name']		= 'По названию';
			$sorting_ops['kinopoisk']	= 'По kinopoisk';
			$sorting_ops['imdb']		= 'По imdb';
			$sorting_ops['god']			= 'По году';
			$sorting_ops['view']		= 'По популярности';
			$sorting_ops['newest']		= 'По добавлению';
			ControlFactory::add_combobox($defs, $this, $add_params,
				'sorting', '',
				$sorting, $sorting_ops, 800, true, false
			);
			$attrs['initial_sel_ndx'] = isset($user_input->initial_sel_ndx) ? $user_input->initial_sel_ndx : -1;
			return ActionFactory::show_dialog("Cортировка:", $defs, true, 0, $attrs);
		}
		if (isset($user_input->selected_media_url))
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
		else{
			$msg = 'classAction: selected_media_url';
			return ActionFactory::show_title_dialog($caption, $post_action, $msg, 0);
		}
		$class_name = $selected_media_url->class_name;
		$parent_media_url = MediaURL::decode($user_input->parent_media_url);
		
		return ActionFactory::show_title_dialog($caption, $post_action, $msg, 0);
	}
	public static function getVodSourceInfo($v){
		$ico = SmartConfig::getPluginIco($v);
		$arr['caption'] = self::$cName;
		$arr['icon_path'] = $ico;
		$arr['detailed_icon_path'] = $ico;
		$arr['class_name'] = $v;
		$arr['detailed_info'] = '||' . self::$cName . '|видео с сайта '.self::$cName.'. Поиск видео на сайте '.self::$cName.' производится по названию возможны неточности.';
		$arr['type'] = SmartConfig::getPluginIco('onlineSource');
		return $arr;
	}
	public static function getIframe($params){
		$iframeInfo = array();
		if ((isset($params['caption_original']))&&(preg_match('|(.*?)\n|', $params['caption_original'], $m)))
			$params['caption_original'] = $m[1];
		if ((isset($params['country']))&&(preg_match('|(\d{4})|', $params['country'], $m))){
			$params['year'] = $m[1];
			unset($params['country']);
		}
		if (isset($params['movie_id']))
			$url =  $params['movie_id'];
		if (isset($params['linksArr'][self::$className])){
			foreach ($params['linksArr'][self::$className] as $k => $v){
				$iframeInfo['urls'][self::$cName]['goTo'] = 'VodSeasonListScreen';
				$iframeInfo['urls'][self::$cName]['link'] = $v;
			}
			return $iframeInfo;
		}
		if (!isset($params['is_serial']))
			return array("status"=>false);
		if (HD::strSanitizing($params['caption_original']) != HD::strSanitizing($params['caption'])){
			$year = 'null';
			if (isset($params['caption_original'])){
				$keyword = $params['caption_original'];
				$m_feed= 0;
				$arr = self::getSearchShortMovieRange ($keyword, $m_feed);
				foreach ($arr as $k => $v){
					if (HD::strSanitizing($keyword) == HD::strSanitizing($v['infoArr']['caption'])){
						extract ($v);
						$iframeInfo['infoArr'] = $infoArr;
						break;
					}
				}
			}
		}
		if (!isset($url)){
			$keyword = $params['caption'];
			$m_feed= 0;
			$arr = self::getSearchShortMovieRange ($keyword, $m_feed);
			foreach ($arr as $k => $v){
				if (HD::strSanitizing($keyword) == HD::strSanitizing($v['infoArr']['caption'])){
					extract ($v);
					$iframeInfo['infoArr'] = $infoArr;
					break;
				}
			}
			if (!isset($url))
				if ((isset($arr[0]))&&(is_array($arr))){
					extract ($arr[0]);
					$iframeInfo['infoArr'] = $infoArr;
				}
		}
		if (isset($url)){
			$iframe  = Seasonvar::getSeasonvarIframe ($url, 'video_id');
			foreach ($iframe as $k => $v){
				$iframeInfo['urls'][self::$cName]['goTo'] = 'VodSeasonListScreen';
				$iframeInfo['urls'][self::$cName]['link'] = $v;
			}
		}else{
			echo "\n".self::$cName.":search failed";
			return array("status"=>false);
		}
		return $iframeInfo;
	}
	public static function getSeasons($media_url){
		if (preg_match("|seasonvarId_|", $media_url->link)){
			if (!preg_match("|http|",$media_url->link))
				$media_url->link = self::getDomainName() . str_replace('seasonvarId_', '', $media_url->link);
			$urls = Seasonvar::getSeasonvarIframe ($media_url->link, 'seasons');
		}
		if (preg_match("|seasonvarSeasonId_|", $media_url->link)){
			if (!preg_match("|http|",$media_url->link))
				$media_url->link = self::getDomainName() . str_replace('seasonvarSeasonId_', '', $media_url->link);
			$urls = Seasonvar::getSeasonvarIframe ($media_url->link, 'translation');
		}
		foreach ($urls as $k => $v){
			$uArr[$k]['caption'] = $k;
			$uArr[$k]['link'] = $v;
			$uArr[$k]['detailed_info'] = '||' . $k . $media_url->detailed_info;
			$uArr[$k]['class_name'] = $media_url->class_name;
			$uArr[$k]['poster_url'] = $media_url->poster_url;
			$uArr[$k]['goTo'] = 'VodSeasonListScreen';
			if (preg_match("|seasonvarDubId_|",$v))
				$uArr[$k]['goTo'] = 'VodSeriesListScreen';
			if (preg_match("|seasonvarSeasonId_|", $v))
				$uArr[$k]['season'] = $k;
		}
		return $uArr;
	}
	public static function get_series_list($media_url, $movie){
		$episodes  = Seasonvar::getSeasonvarIframe ($media_url->link, 'season');
		if ($episodes == true){
			$items = array();
			foreach ($episodes as $key => $vel){
				$qltyMax = false;
				if (preg_match('|(.+?)\sQ:(\d+?)$|', $key, $m)){
					$key = $m[1];
					$qltyMax = $m[2];
				}
				$tvshow_se = VideoInfo::tvshow_se_parse($key);
				if (isset($tvshow_se['S']))
					$media_url->hash_patrs->season = $tvshow_se['S'];
				if (isset($tvshow_se['E']))
					$media_url->hash_patrs->episode = $tvshow_se['E'];
				else
					$media_url->hash_patrs->episode = $key;
				$hash_patrs = implode("", (array)$media_url->hash_patrs);
				$items[$key]['id'] = md5 ($hash_patrs);
				$items[$key]['title'] = $key;
				$items[$key]['playback_url'] = $vel;
				$items[$key]['is_stream_url'] = false;
				$items[$key]['file_info']['poster_url'] = $media_url->poster_url;
				$items[$key]['file_info']['details_box_width'] = true;
				$items[$key]['file_info']['class_name'] = $media_url->class_name;
				$items[$key]['file_info']['detailed_info'] = $media_url->detailed_info;
				if (isset($media_url->description))
					$items[$key]['file_info']['description'] = $media_url->description;
				if ($qltyMax == true)
					$items[$key]['file_info']['qltyMax'] = $qltyMax;
			}
		}
		return $items;
	}
	public static function http_get_img ($url){
		if (self::$proxy == true){
			$path_parts = parse_url(self::getDomainName());
			if (!preg_match("|^http|",$url))
				return DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . self::getDomainName() . $url . "&proxy=" . self::$cName;
			if (preg_match("|".$path_parts['host']."|",$url))
				return DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . $url . "&proxy=" . self::$cName;
		}
		if (!preg_match("|^http|",$url))
			$url = self::getDomainName() . $url;
		return $url;
		// return DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . $url;
	}
	public static function http_get_document ($url, $opts=null){
		
		if (is_null(self::$proxy)){
			self::$proxy = false;
			$sitesProxy = HD::getItemsArr('sitesProxy');
			if (isset($sitesProxy[self::$cName])){
				$proxySettings = (HD::getItemsArr('proxySettings') != array()) ? HD::getItemsArr('proxySettings') : array();
				if (isset($proxySettings['proxy'])){
					self::$proxy['proxy'] = $proxySettings['proxy'];
					if ((isset($proxySettings['proxyType']))&&($proxySettings['proxyType'] == 'SOCKS5'))
						self::$proxy['proxyType'] = $proxySettings['proxyType'];
					if (isset($proxySettings['proxyAccount']))
						self::$proxy['proxyAccount'] = $proxySettings['proxyAccount'];
				}
			}
		}
		if (self::$proxy == true){
			$opts[CURLOPT_PROXY] = self::$proxy['proxy'];
			if (isset(self::$proxy['proxyType']))
				$opts[CURLOPT_PROXYTYPE] = CURLPROXY_SOCKS5;
			if (isset(self::$proxy['proxyAccount']))
				$opts[CURLOPT_PROXYUSERPWD] = self::$proxy['proxyAccount'];
		}
		return HD::http_get_document($url, $opts);
	}
}
?>
