<?
if (!class_exists('DuneSystem')){
	if (preg_match('|plugins/(.*?)/lib|', __DIR__, $matches)){
		$tmp_path = '/tmp/plugins/'.$matches[1];
		$plugin_name = $matches[1];
		$install_dir = str_replace('/lib/wox', '',  __DIR__);
		if (file_exists('/persistfs/plugins_data'))
			$data_dir = "/persistfs/plugins_data/$plugin_name";
		else
			$data_dir = "/flashdata/plugins_data/$plugin_name";
        $port = HD::http_local_port();
		$www_url = "http://127.0.0.1:$port/plugins/$plugin_name/";
		$cgi_url = "http://127.0.0.1:$port/cgi-bin/plugins/$plugin_name/";
	}

	function hd_print($str){
		echo $str;
	}
	class DuneSystem{
		public static $properties = array ();
	};
	DuneSystem::$properties['plugin_name']      = $plugin_name;
	DuneSystem::$properties['install_dir_path'] = $install_dir;
	DuneSystem::$properties['tmp_dir_path']     = $tmp_path;
	DuneSystem::$properties['plugin_www_url']   = $www_url;
	DuneSystem::$properties['plugin_cgi_url']   = $cgi_url;
	DuneSystem::$properties['data_dir_path']    = $data_dir;
}

class VideoCDN_Class {
	static $cName = 'VideoCDN';
	static $className = 'VideoCDN_Class';
	static $DomainName = null;
	static $altDomainName = null;
	static $proxyArr = null;
	static $proxyArrMd5 = null;
	static $proxy = null;
	
	public static function getMainMenuInfo(){
		return false;
	}
	public static function getScreenActionMapArr($media_url){
		$actionsArr = array();
		return $actionsArr;
	}
	public static function getPopUpMenuItems ($selected_media_url, $parent_media_url){
		$menu_items = array();
		$parent_media_url = MediaURL::decode($parent_media_url);
		if ((isset($parent_media_url->screen_id))&&($parent_media_url->screen_id != 'vod_series')){
			$menu_items[] = array(
				'caption' => 'Добавить в Главное меню',
				'params' => array ('action' => 'addToMainMenu'),
				'icon_url' => SmartConfig::getPluginIco('s_home')
			);
		}
		return $menu_items;
	}
	public static function getVodSourceInfo($v){
		$ico = SmartConfig::getPluginIco($v);
		$arr['caption'] = self::$cName;
		$arr['icon_path'] = $ico;
		$arr['detailed_icon_path'] = $ico;
		$arr['class_name'] = $v;
		$arr['detailed_info'] = '||' . self::$cName . '|видео с сервиса '.self::$cName.'.';
		$arr['type'] = SmartConfig::getPluginIco('onlineSource');
		return $arr;
	}
	public static function getIframe($params){
		$iframeInfo = array($params);
		if ((isset($params['kpID']))&&($params['kpID'] != ''))
			$urls = videocdn::getIframe($params['kpID'],'kp_id');
		if ($urls == true){
			foreach ($urls as $k => $v){
				if (($k == 'm')||(preg_match('|^http|', $k)))
					$k = self::$cName;
				if ((preg_match("|EpisodId_|", $v))||(preg_match("|SeasonId_|", $v)))
					$iframeInfo['urls'][$k]['goTo'] = 'VodSeriesListScreen';
				else
					$iframeInfo['urls'][$k]['goTo'] = 'VodSeasonListScreen';
				$iframeInfo['urls'][$k]['link'] = $v;
			}
			return $iframeInfo;
		}else{
			echo "\n".self::$cName.":search failed";
			return array("status"=>false);
		}
		return $iframeInfo;
	}
	public static function getSeasons($media_url){
		$urls = videocdn::getIframe($media_url->link, 'seasons');
		foreach ($urls as $k => $v){
			$uArr[$k]['caption'] = $k;
			$uArr[$k]['link'] = $v;
			$uArr[$k]['detailed_info'] = '||' . $k . $media_url->detailed_info;
			$uArr[$k]['class_name'] = $media_url->class_name;
			$uArr[$k]['poster_url'] = $media_url->poster_url;
			$uArr[$k]['goTo'] = 'VodSeasonListScreen';
			if (preg_match("|SeasonId|",$v)){
				$uArr[$k]['season'] = $k;
				$uArr[$k]['goTo'] = 'VodSeriesListScreen';
			}
		}
		return $uArr;
	}
	public static function get_series_list($media_url, $movie){
		if (preg_match('|EpisodId_|', $media_url->link)){
			$qltyMax = false;
			if (preg_match('|(.+?)\sQ:(\d+)|', $media_url->caption, $m))
				$qltyMax = $m[2];
			$hash_patrs = $media_url->caption;
			if (isset($media_url->hash_patrs)){
				$hash_patrs = implode("", (array)$media_url->hash_patrs);
			}
			$items[$media_url->caption]['id'] = md5 ($hash_patrs);
			$items[$media_url->caption]['title'] = $media_url->caption;
			$items[$media_url->caption]['playback_url'] = $media_url->link;
			$items[$media_url->caption]['is_stream_url'] = false;
			$items[$media_url->caption]['file_info']['poster_url'] = $media_url->poster_url;
			$items[$media_url->caption]['file_info']['details_box_width'] = true;
			$items[$media_url->caption]['file_info']['class_name'] = $media_url->class_name;
			if (isset($media_url->description))
				$items[$media_url->caption]['file_info']['description'] = $media_url->description;
			$items[$media_url->caption]['file_info']['detailed_info'] = $media_url->detailed_info;
			if ($qltyMax == true)
				$items[$media_url->caption]['file_info']['qltyMax'] = $qltyMax;
			return $items;
		}
		$episodes = videocdn::getIframe($media_url->link, 'episodes');
		if ($episodes == true){
			$items = array();
			foreach ($episodes as $key => $vel){
				$qltyMax = false;
				if (preg_match('|(.+?)\sQ:(\d+?)$|', $key, $m)){
					$key = $m[1];
					$qltyMax = $m[2];
				}
				$tvshow_se = VideoInfo::tvshow_se_parse($key);
				if (isset($tvshow_se['S']))
					$media_url->hash_patrs->season = $tvshow_se['S'];
				if (isset($tvshow_se['E']))
					$media_url->hash_patrs->episode = $tvshow_se['E'];
				else
					$media_url->hash_patrs->episode = $key;
				$hash_patrs = implode("", (array)$media_url->hash_patrs);
				$items[$key]['id'] = md5 ($hash_patrs);
				$items[$key]['title'] = $key;
				$items[$key]['playback_url'] = $vel;
				$items[$key]['is_stream_url'] = false;
				$items[$key]['file_info']['poster_url'] = $media_url->poster_url;
				$items[$key]['file_info']['details_box_width'] = true;
				$items[$key]['file_info']['class_name'] = $media_url->class_name;
				$items[$key]['file_info']['detailed_info'] = $media_url->detailed_info;
				if (isset($media_url->description))
					$items[$key]['file_info']['description'] = $media_url->description;
				if ($qltyMax == true)
					$items[$key]['file_info']['qltyMax'] = $qltyMax;
			}
		}
		return $items;
	}
}
