<?php
if (!class_exists('DuneSystem')){
	if (preg_match('|plugins/(.*?)/lib|', __DIR__, $matches)){
		$tmp_path = '/tmp/plugins/'.$matches[1];
		$plugin_name = $matches[1];
		$install_dir = str_replace('/lib/wox', '',  __DIR__);
		if (file_exists('/persistfs/plugins_data'))
			$data_dir = "/persistfs/plugins_data/$plugin_name";
		else
			$data_dir = "/flashdata/plugins_data/$plugin_name";
        $port = HD::http_local_port();
		$www_url = "http://127.0.0.1:$port/plugins/$plugin_name/";
		$cgi_url = "http://127.0.0.1:$port/cgi-bin/plugins/$plugin_name/";
	}

	function hd_print($str){
		echo $str;
	}
	class DuneSystem{
		public static $properties = array ();
	};
	DuneSystem::$properties['plugin_name']      = $plugin_name;
	DuneSystem::$properties['install_dir_path'] = $install_dir;
	DuneSystem::$properties['tmp_dir_path']     = $tmp_path;
	DuneSystem::$properties['plugin_www_url']   = $www_url;
	DuneSystem::$properties['plugin_cgi_url']   = $cgi_url;
	DuneSystem::$properties['data_dir_path']    = $data_dir;
}
class Videoplenka_Class {
	static $cName = 'Videoplenka';
	static $className = 'Videoplenka_Class';
	static $DomainName = null;
	static $proxyArr = null;
	static $proxyArrMd5 = null;
	static $proxy = null;
	public static function getDomainName(){
		if (null === self::$DomainName)
			self::$DomainName = (HD::getItemStr(self::$cName . 'DomainName') != '') ? HD::getItemStr(self::$cName . 'DomainName') : 'https://torr.lafa.site';
		return self::$DomainName;
	}
	public static function getMainMenuInfo(){
		return array (
			'name' => self::$cName,
			'descr' => '||'.self::$cName.'|каталог и источник торрентов с сайта ' . self::$cName . '||Если сайт не доступен используйте прокси или VPN, а так же официальные зеркала (сайты с похожим дизайном и названием могут не являтся зеркалом)'
		);
	}
	public static function get_media_url_str($k, $arr=null){
		if ($arr == true)
			return SmartVodCategoryListScreen::get_media_url_str($k, $arr);
		return SmartVodCategoryListScreen::get_media_url_str($k);
	}
	public static function getSearchMediaUrlStr($k, $arr=null){
		return SmartVodListScreen::get_media_url_str($k, $arr);
	}
	public static function getPopUpMenuItems ($selected_media_url, $parent_media_url){
		$menu_items = array();
		if ($parent_media_url == 'main_menu'){
			$menu_items[] = array(
				'caption' => 'Задать зеркало ' . self::$cName,
				'params' => array ('action' => 'mirror'),
				'icon_url' => SmartConfig::getPluginIco('s_' . self::$className)
			);
			$menu_items[] = array(
				'caption' => 'Прокси для ' . self::$cName,
				'params' => array ('action' => 'proxy'),
				'icon_url' => SmartConfig::getPluginIco('s_proxy')
			);
			$menu_items[] = 'is_separator';
		}
		$parent_media_url = MediaURL::decode($parent_media_url);
		if ($parent_media_url->screen_id == 'vod_torrentlist'){
			
			$menu_items[] = array(
				'caption' => 'Изменить действие для торрентов',
				'params' => array ('action' => 'torrentActionSetup'),
				'icon_url' => SmartConfig::getPluginIco('s_torrent')
			);
			$menu_items[] = array(
				'caption' => 'Выбрать действие торрента',
				'conID' => 'add_actions',
				'params' => array ('torrentAction' => 1),
				'icon_url' => SmartConfig::getPluginIco('s_list')
			);
			$menu_items[] = 'is_separator';
			$menu_items[] = array(
				'caption' => 'Настройки TorrServer',
				'conID' => 'classSetupTorrServer',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_torrserver')
			);
			$menu_items[] = array(
				'caption' => 'Настройки PeerflixServer',
				'conID' => 'classSetupPeerflixServer',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_peerflixserver')
			);
			$menu_items[] = array(
				'caption' => 'Настройки Transmission',
				'conID' => 'classSetupTransmission',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_transmission')
			);
			$menu_items[] = array(
				'caption' => 'Настройки Transmission UPnP',
				'conID' => 'classSetupTransmissionUPnP',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_transmissionupnp')
			);
			$menu_items[] = 'is_separator';
		}
		if ((isset($parent_media_url->screen_id))&&($parent_media_url->screen_id != 'vod_series')){
			$menu_items[] = array(
				'caption' => 'Добавить в Главное меню',
				'params' => array ('action' => 'addToMainMenu'),
				'icon_url' => SmartConfig::getPluginIco('s_home')
			);
		}
		
		return $menu_items;
	}
	public static function getScreenActionMapArr($media_url){
		$actionsArr = array();
		if((isset($media_url->screen_id))&&($media_url->screen_id == 'vod_torrentlist')){
			$actionsArr[0]['create_action'] = 'classAction';
			$actionsArr[0]['params'] = array ('indiClass' => self::$className,'action' => 'sort');
			$actionsArr[0]['caption'] = 'Сортировки';
			$actionsArr[0]['key'] = GUI_EVENT_KEY_C_YELLOW;
		}
		return $actionsArr;
	}
	public static function getVodCategories($media_url){
		static $categories = null;
		if (is_null($categories)){
			$categories['categories'][] = array('id'=> 'search', 'class' => 'SmartSearchScreen', 'caption' => 'Поиск');
			$categories['categories'][] = array('id'=> '/film/', 'class' => 'SmartVodCategoryListScreen', 'caption' => 'Фильмы');
			$categories['categories'][] = array('id'=> '/serialy/', 'class' => 'SmartVodCategoryListScreen', 'caption' => 'Сериалы');
			$categories['categories'][] = array('id'=> '/multfilm/', 'class' => 'SmartVodCategoryListScreen', 'caption' => 'Мультфильмы');
			$categories['categories'][] = array('id'=> '/music/', 'class' => 'SmartVodCategoryListScreen', 'caption' => 'Музыка');
		}
		if (isset($media_url->categoryId)){
			if (!isset($categories['subCategories'][$media_url->categoryId])){
				$categories['subCategories'][$media_url->categoryId][] = array('id'=> $media_url->categoryId, 'class' => 'SmartVodListScreen', 'caption' => 'Все ' . $media_url->caption);
				$doc = iconv('WINDOWS-1251', 'UTF-8',self::http_get_document(self::getDomainName() . $media_url->categoryId));
				if (preg_match_all('|menu_new_link" href="(.+?)".*?>(.+?)</a>|ms', $doc, $matches))
					foreach ($matches[1] as $k => $v)
						$categories['subCategories'][$media_url->categoryId][] = array('id'=> $v, 'class' => 'SmartVodListScreen', 'caption' => HD::str_remove_tag(preg_replace("|\s|", ' ', $matches[2][$k])));
			}
			return $categories['subCategories'][$media_url->categoryId];
		}
		return $categories['categories'];
	}
	public static function getShortMovieRange ($media_url, &$m_feed){
		if ($m_feed === 'end')
			return $items;
		$url =  self::getDomainName() . $media_url->categoryId;
		if ($m_feed > 0){
			if (preg_match('|\.php|', $media_url->categoryId))
				$url .= '&page='. $m_feed;
			else
				$url .= 'page/'. $m_feed;
		}
		$doc = iconv('WINDOWS-1251', 'UTF-8', self::http_get_document($url));
		++$m_feed;
		if (!preg_match('|<b>»</b>|', $doc))
			$m_feed = 'end';
		return self::parseSitePage($doc);
	}
	public static function getSearchShortMovieRange ($keyword, &$m_feed){
		if (is_object($keyword))
			$keyword = $keyword->searchStr;
		if ($m_feed === 'end')
			return array();
		$url =  self::getDomainName() . '/torrentz/search/' . str_replace('+', '%20', urlencode($keyword)) . '/';
		if ($m_feed > 0)
			$url .= 'page/'. $m_feed;
		$doc = iconv('WINDOWS-1251', 'UTF-8', HD::http_get_document($url));
		++$m_feed;	
		if (!preg_match('|<b>»</b>|', $doc))
			$m_feed = 'end';
		return self::parseSitePage($doc);
	}
	public static function parseSitePage($doc){
		$items = array();
		if (preg_match_all('|tt_container.*?original="(.+?)".*?href="(.+?)".*?alt="(.+?)".*?<br>(.+?)</div>.*?<br>(.+?)<br>|ms', $doc, $match)){
			foreach ($match[2] as $k => $v){
				$name	= HD::str_remove_tag($match[3][$k]);
				if (preg_match('|(.*)\((.*?)\)|', $name, $mm)){
					$name = HD::str_remove_tag($mm[1]);
					$year = HD::str_remove_tag($mm[2]);
				}
				$img = $match[1][$k];
				if (!preg_match('|^http|',$img))
					$img = self::getDomainName() . $img;	
				$short_movie = new ShortMovie(
					strval($v),
					strval($name),
					strval(self::http_get_img ($img))
				);
				$info = '||' . $name;
				$info .= '|Год: ';
				if ($year == true)
					$info .= $year;
				$info .= '||' . HD::str_remove_tag($match[4][$k]);
				$info .= '|' . HD::str_remove_tag($match[5][$k]);
				$short_movie->info = $info;
				if (preg_match('|src="(.+?)"|ms', $match[0][$k], $matches)){
					$short_movie->right_top_img = $short_movie->left_bottom_img = false;
					$short_movie->right_top_img = self::http_get_img (self::getDomainName() . $matches[1]);
				}
				$short_movie->year = $year;
				array_push ($items, $short_movie);
			}
		}
		return $items;
	}
	public static function load_movie($movie_id, $mUrl, $getMovieInfo){
		$arr = array();
		$arr['caption'] = $arr['class_info']['catalog_info']['caption'] = $mUrl->caption;
		$arr['poster_url'] = $arr['class_info']['catalog_info']['poster_url'] = $mUrl->poster_url;
		if (isset($mUrl->caption_original))
			$arr['caption_original'] = $arr['class_info']['catalog_info']['caption_original'] = $mUrl->caption_original;
		if (isset($mUrl->year))
			$arr ['year'] = $arr['class_info']['catalog_info']['year'] = $mUrl->year;
		if (!preg_match("|^http|",$movie_id))
			$movie_id = self::getDomainName() . $movie_id;
		$doc = iconv('WINDOWS-1251', 'UTF-8',HD::http_get_document($movie_id));
		
		if (preg_match('|notop"><span itemprop="name">(.*?)</td>|ms', $doc, $match)){
			$arr ['caption'] = HD::str_remove_tag($match[1]);
			if (preg_match('|<br>|', $match[1])){
				$tmp = explode('<br>',$match[1]);
				$arr ['caption'] = HD::str_remove_tag($tmp[0]);
				$arr ['caption_original'] = str_replace (array("(",')'),'', HD::str_remove_tag($tmp[1]));
			}
		}
		if (preg_match('|mage" content="(.*?)"|ms', $doc, $match))
			$arr ['poster_url'] =  self::http_get_img ($match[1]);
		if (preg_match('|Страна:(.*?)</tr|ms', $doc, $match))
			$arr ['country'] = HD::str_remove_tag($match[1]);
		if (preg_match('|Категория:(.*?)</tr|ms', $doc, $match))
			$arr ['genres'] = HD::str_remove_tag($match[1]);
		if (preg_match('|Год выпуска:(.*?)</tr|ms', $doc, $match))
			$arr ['year'] = HD::str_remove_tag($match[1]);
		if (preg_match('|Время:(.*?)</tr|ms', $doc, $match))
			if (preg_match('|(\d*):(\d*):(\d*)|', HD::str_remove_tag(trim($match[1])), $m))
				$arr ['length'] = ($m[1]*60) + $m[2];
		if (preg_match('|Премьера:(.*?)</tr|ms', $doc, $match))
			$arr ['details']['Дата выхода:'] = HD::str_remove_tag($match[1]);
		if (preg_match('|Режиссер:(.*?)</tr|ms', $doc, $match))
			$arr ['director'] = HD::str_remove_tag($match[1]);
		if (preg_match('|В ролях:(.*?)</tr|ms', $doc, $match))
			$arr ['actors'] = HD::str_remove_tag($match[1]);
		if (preg_match('|span_descr">(.*?)</tr|ms', $doc, $match))
			$arr ['description'] = HD::str_remove_tag($match[1]);
		if (preg_match_all ('|class="indexlazyimg".*?sources="(.*?)"|ms', $doc, $matches))
			foreach ($matches[1] as $k => $v)
				$arr ['background_urls'][] = self::http_get_img ($v);
		if (preg_match('|kinopoisk_id.+?(\d*);|ms', $doc, $match))
			$arr['class_info']['dbIDs']['kpID'] = $match[1];
		else if (preg_match('|kinopoisk.ru/film/(\d*)|ms', $doc, $match))
			$arr['class_info']['dbIDs']['kpID'] = $match[1];
		else if (preg_match('|kinopoisk.ru/rating/(\d*?)\.|ms', $doc, $match))
			$arr['class_info']['dbIDs']['kpID'] = $match[1];
		else if (preg_match('|kp_id=(\d*?)"|ms', $doc, $match))
			$arr['class_info']['dbIDs']['kpID'] = $match[1];
		else{
			$kpIDs = HD::getItemsArr('kpIDs');
			if (isset($kpIDs[$movie_id]))
				$arr['class_info']['dbIDs']['kpID'] = $kpIDs[$movie_id];
		}
		if (!isset($arr['class_info']['dbIDs']['kpID']))
			$arr['class_info']['goToScreen'] = 'SmartVodTorrentsScreen';
		else
			$arr = SmartConfig::getMovieInfoArr($getMovieInfo, $movie_id, $mUrl, $arr);
		if (preg_match('|<table id="tablesorter"|ms', $doc)){
			$m = explode('<table id="tablesorter"',$doc);
			if (preg_match_all('|class="ttip".*?>(.*?)<.*?href="(/downloadt.*?)".*?</table>|ms', $m[1], $matches))
				foreach ($matches[2] as $k => $v){
					if (preg_match('|data-sort-value.+?>(.+?)</|ms', $matches[0][$k], $match))
						$size = HD::str_remove_tag($match[1]);
					$arr['class_info']['torrent'][$v]['size'] = $size;
					$arr['class_info']['ssk'][$v] = $size;
					if (preg_match('|style="float:left;">(.+?)</|ms', $matches[0][$k], $match))
						$arr['class_info']['torrent'][$v]['caption'] = HD::str_remove_tag($match[1]);
					if (preg_match('|dl_trad">(.+?)</td|ms', $matches[0][$k], $match))
						$arr['class_info']['torrent'][$v]['dub'] = HD::str_remove_tag($match[1]);
					if (preg_match('|class="expand-child".*?>(.+?)<div id="spsp|ms', $matches[0][$k], $match))
						$arr['class_info']['torrent'][$v]['fInfo'] = HD::str_remove_tag($match[1]);
					if (preg_match('|seeders_.*?>(.+?)</span>|ms', $matches[0][$k], $match))
						$seed = HD::str_remove_tag($match[1]);
					$arr['class_info']['torrent'][$v]['seed'] = HD::str_remove_tag($match[1]);
					$arr['class_info']['sk'][$v] = $seed;
					if (preg_match('|leechers_.*?>(.+?)</span>|ms', $matches[0][$k], $match))
						$arr['class_info']['torrent'][$v]['leech'] = HD::str_remove_tag($match[1]);
				}
		}else
			$arr['class_info']['torrent'] = 'notrt';
		return $arr;
	}
	public static function getTorrentFile($torrent_id, $dloadPath=null){
		$url = $torrent_id;
		if (!preg_match("|^http|", $torrent_id))
			$url = self::getDomainName() . $torrent_id;
		$doc = self::http_get_document($url);
		return SmartConfig::checkTorrent($dloadPath, $doc);
	}
	public static function getVodSourceInfo($v){
		$ico = SmartConfig::getPluginIco(self::$className);
		$sources['caption'] = self::$cName;
		$sources['detailed_info'] = '||'.self::$cName.'|Торрент файлы найденные на '.self::$cName.' по названию. Так как поиск производится по названию возможны неточности.';
		$sources['icon_path'] = $ico;
		$sources['detailed_icon_path'] = $ico;
		$sources['goTo'] = 'SmartVodTorrentsScreen';
		$sources['class_name'] = $v;
		$sources['type'] = SmartConfig::getPluginIco('torrentSource');
		return $sources;
	}
	public static function getShortTorrentRange ($movie, $media_url, &$m_feed){
		$items = array();
		if ($m_feed === 'end')
			return $items;
		$icon_path = SmartConfig::getPluginIco('s_torrent');
		$sorting = (HD::getItemsArr(self::$className . '_sorting') != array()) ? HD::getItemsArr(self::$className . '_sorting') : array('vod_torrentlist' => '0');	
		if (isset($movie->class_info['torrent'])){
			if ($movie->class_info['torrent'] == 'notrt'){
				$icon_path = SmartConfig::getPluginIco(0);
				$short_movie = new ShortMovie(
					strval('notrt'),
					strval('Торренты удалены по требованию правообладателя'),
					strval($movie->poster_url)
				);
				$short_movie->icon_path = $icon_path;
				$info = '||Торренты удалены по требованию правообладателя|'. self::$cName;
				$short_movie->info = $info;
				array_push ($items, $short_movie);
				$m_feed = 'end';
				return $items;
			}
			
			if ($sorting['vod_torrentlist'] == 1){
				$ssk = $movie->class_info['ssk'];
				natsort($ssk);
				$ssk = array_reverse ($ssk, true);
				foreach ($ssk as $k => $v)
					$sortedItems[$k] = $movie->class_info['torrent'][$k];
			}else if ($sorting['vod_torrentlist'] == 2){
				$sk = $movie->class_info['sk'];
				arsort($sk);
				foreach ($sk as $k => $v)
					$sortedItems[$k] = $movie->class_info['torrent'][$k];
			}else
				$sortedItems = $movie->class_info['torrent'];
			foreach ($sortedItems as $k => $v){
				$caption = $v['caption'];
				$short_movie = new ShortMovie(
					strval(trim($k)),
					strval($caption),
					strval($movie->poster_url)
				);
				$short_movie->icon_path = $icon_path;
				$short_movie->tType = 'torrent';
				$short_movie->extra_item = $v['size'];
				$info = '||' . $caption . 
				'|' . $v['dub'].
				'||Размер: '. $v['size'] . 
				'||S: '. $v['seed'] . ' L: '. $v['leech'] . 
				'||' . $v['fInfo'];
				$short_movie->info = $info;
				array_push ($items, $short_movie);
			}
			$m_feed = 'end';
			return $items;
		}
		$keyword = $movie->name;
		$year = $movie->year  != '' ? $movie->year : false;
		$obj = self::getSearchShortMovieRange ($keyword, $m_feed);
		foreach($obj as $k => $v){
			if (HD::strSanitizing($v->name) == HD::strSanitizing($movie->name)){
				if (($year == true)&&(isset($v->year)))
					if ($v->year == $movie->year){
						$searchTorrentUrl = $v->id;
						break;
					}
			}
		}
		if (!isset($searchTorrentUrl)){
			if (count($obj) > 0){
				$v = array_shift($obj);
				$searchTorrentUrl = $v->id;
			}
		}
		if (!isset($searchTorrentUrl))
			return $items;
		if (!preg_match("|^http|",$searchTorrentUrl))
			$searchTorrentUrl = self::getDomainName() . $searchTorrentUrl;
		$doc = iconv('WINDOWS-1251', 'UTF-8',self::http_get_document($searchTorrentUrl));
		
		if (preg_match('|mage" content="(.*?)"|ms', $doc, $match))
			$poster_url =  self::http_get_img ($match[1]);
		if (preg_match('|<table id="tablesorter"|ms', $doc)){
			$m = explode('<table id="tablesorter"',$doc);
			if (preg_match_all('|class="ttip".*?>(.*?)<.*?href="(/downloadt.*?)".*?</table>|ms', $m[1], $matches)){
				foreach ($matches[2] as $k => $v){
					if (preg_match('|data-sort-value.+?>(.+?)</|ms', $matches[0][$k], $match))
						$size = HD::str_remove_tag($match[1]);
					$arr['class_info']['torrent'][$v]['size'] = $size;
					$arr['class_info']['ssk'][$v] = $size;
					if (preg_match('|style="float:left;">(.+?)</|ms', $matches[0][$k], $match))
						$arr['class_info']['torrent'][$v]['caption'] = HD::str_remove_tag($match[1]);
					if (preg_match('|dl_trad">(.+?)</td|ms', $matches[0][$k], $match))
						$arr['class_info']['torrent'][$v]['dub'] = HD::str_remove_tag($match[1]);
					if (preg_match('|class="expand-child".*?>(.+?)<div id="spsp|ms', $matches[0][$k], $match))
						$arr['class_info']['torrent'][$v]['fInfo'] = HD::str_remove_tag($match[1]);
					if (preg_match('|seeders_.*?>(.+?)</span>|ms', $matches[0][$k], $match))
						$seed = HD::str_remove_tag($match[1]);
					$arr['class_info']['torrent'][$v]['seed'] = HD::str_remove_tag($match[1]);
					$arr['class_info']['sk'][$v] = $seed;
					if (preg_match('|leechers_.*?>(.+?)</span>|ms', $matches[0][$k], $match))
						$arr['class_info']['torrent'][$v]['leech'] = HD::str_remove_tag($match[1]);
				}
				if ($sorting['vod_torrentlist'] == 1){
					$ssk = $arr['class_info']['ssk'];
					natsort($ssk);
					$ssk = array_reverse ($ssk, true);
					foreach ($ssk as $k => $v)
						$sortedItems[$k] = $arr['class_info']['torrent'][$k];
				}else if ($sorting['vod_torrentlist'] == 2){
					$sk = $arr['class_info']['sk'];
					arsort($sk);
					foreach ($sk as $k => $v)
						$sortedItems[$k] = $arr['class_info']['torrent'][$k];
				}else
					$sortedItems = $arr['class_info']['torrent'];
				foreach ($sortedItems as $k => $v){
					$caption = $v['caption'];
					$short_movie = new ShortMovie(
						strval(trim($k)),
						strval($caption),
						strval($poster_url)
					);
					$short_movie->icon_path = $icon_path;
					$short_movie->tType = 'torrent';
					$short_movie->extra_item = $v['size'];
					$info = '||' . $caption . 
					'|' . $v['dub'].
					'||Размер: '. $v['size'] . 
					'||S: '. $v['seed'] . ' L: '. $v['leech'] . 
					'||' . $v['fInfo'];
					$short_movie->info = $info;
					array_push ($items, $short_movie);
				}
				$m_feed = 'end';
				return $items;
			}else{
				$icon_path = SmartConfig::getPluginIco(0);
				$short_movie = new ShortMovie(
					strval('notrt'),
					strval('Торренты удалены по требованию правообладателя'),
					strval($movie->poster_url)
				);
				$short_movie->icon_path = $icon_path;
				$info = '||Торренты удалены по требованию правообладателя|'. self::$cName;
				$short_movie->info = $info;
				array_push ($items, $short_movie);
				$m_feed = 'end';
				return $items;
			}
		}
		$m_feed = 'end';
		return $items;
	}
	public function classAction ($defs, $user_input, $select_url = null){
		hd_restore_warnings();
		$post_action = null;
		$caption = 'Error!';
		$msg = 'classAction: action';
		$width = 1050;
		$parent_media_url = MediaURL::decode($user_input->parent_media_url);
		if ($user_input->action == 'sort'){
			$sorting = (HD::getItemsArr(self::$className . '_sorting') != array()) ? HD::getItemsArr(self::$className . '_sorting') : array('vod_torrentlist' => '0');	
			$add_params['control_id']= $user_input->control_id;
			$add_params['action'] = $user_input->action;
			$add_params['indiClass'] = self::$className;
			if ((isset($user_input->selected_control_id))&&(isset($user_input->action_type))){
				if (isset($user_input->initial_sel_ndx))
					$add_params['initial_sel_ndx'] = $user_input->initial_sel_ndx;
				$sorting['vod_torrentlist'] = $user_input->sorting;
				if (HD::saveItemsArr(self::$className . '_sorting', $sorting) == false)
					return ActionFactory::show_title_dialog("Сохранение не удалось");
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
				$action = ActionFactory::close_dialog_and_run($action);
				return ActionFactory::invalidate_folders(array($user_input->parent_media_url), $action);
			}
			$add_params['initial_sel_ndx'] = 0;
			$sorting = $sorting['vod_torrentlist'];
			$sorting_ops[0]	= 'Выдача';
			$sorting_ops[1]	= 'Размер';
			$sorting_ops[2]	= 'Раздающие';
			$sorting = $sorting['vod_torrentlist'];
			ControlFactory::add_combobox($defs, $this, $add_params,
				'sorting', '',
				$sorting, $sorting_ops, 800, true, false
			);
			$attrs['initial_sel_ndx'] = isset($user_input->initial_sel_ndx) ? $user_input->initial_sel_ndx : -1;
			return ActionFactory::show_dialog("Cортировка:", $defs, true, 0, $attrs);
		}
		if (isset($user_input->selected_media_url))
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
		else{
			$msg = 'classAction: selected_media_url';
			return ActionFactory::show_title_dialog($caption, $post_action, $msg, 0);
		}
		$class_name = $selected_media_url->class_name;
		$parent_media_url = MediaURL::decode($user_input->parent_media_url);
		
		return ActionFactory::show_title_dialog($caption, $post_action, $msg, 0);
	}
	public static function http_get_img ($url){
		if (self::$proxy == true){
			$path_parts = parse_url(self::getDomainName());
			if (!preg_match("|^http|",$url))
				return DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . self::getDomainName() . $url . "&proxy=" . self::$cName;
			if (preg_match("|".$path_parts['host']."|",$url))
				return DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . $url . "&proxy=" . self::$cName;
		}
		if (!preg_match("|^http|",$url))
			$url = self::getDomainName() . $url;
		return DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . $url;
	}
	public static function http_get_document ($url, $opts=null){
		if (is_null(self::$proxy)){
			self::$proxy = false;
			$sitesProxy = HD::getItemsArr('sitesProxy');
			if (isset($sitesProxy[self::$cName])){
				$proxySettings = (HD::getItemsArr('proxySettings') != array()) ? HD::getItemsArr('proxySettings') : array();
				if (isset($proxySettings['proxy'])){
					self::$proxy['proxy'] = $proxySettings['proxy'];
					if ((isset($proxySettings['proxyType']))&&($proxySettings['proxyType'] == 'SOCKS5'))
						self::$proxy['proxyType'] = $proxySettings['proxyType'];
					if (isset($proxySettings['proxyAccount']))
						self::$proxy['proxyAccount'] = $proxySettings['proxyAccount'];
				}
			}
		}
		if (self::$proxy == true){
			$opts[CURLOPT_PROXY] = self::$proxy['proxy'];
			if (isset(self::$proxy['proxyType']))
				$opts[CURLOPT_PROXYTYPE] = CURLPROXY_SOCKS5;
			if (isset(self::$proxy['proxyAccount']))
				$opts[CURLOPT_PROXYUSERPWD] = self::$proxy['proxyAccount'];
		}
		return HD::http_get_document($url, $opts);
	}
}
