<?php
if (!class_exists('DuneSystem')){
	if (preg_match('|plugins/(.*?)/lib|', __DIR__, $matches)){
		$tmp_path = '/tmp/plugins/'.$matches[1];
		$plugin_name = $matches[1];
		$install_dir = str_replace('/lib/wox', '',  __DIR__);
		if (file_exists('/persistfs/plugins_data'))
			$data_dir = "/persistfs/plugins_data/$plugin_name";
		else
			$data_dir = "/flashdata/plugins_data/$plugin_name";
        $port = HD::http_local_port();
		$www_url = "http://127.0.0.1:$port/plugins/$plugin_name/";
		$cgi_url = "http://127.0.0.1:$port/cgi-bin/plugins/$plugin_name/";
	}

	function hd_print($str){
		echo $str;
	}
	class DuneSystem{
		public static $properties = array ();
	};
	DuneSystem::$properties['plugin_name']      = $plugin_name;
	DuneSystem::$properties['install_dir_path'] = $install_dir;
	DuneSystem::$properties['tmp_dir_path']     = $tmp_path;
	DuneSystem::$properties['plugin_www_url']   = $www_url;
	DuneSystem::$properties['plugin_cgi_url']   = $cgi_url;
	DuneSystem::$properties['data_dir_path']    = $data_dir;
}
class ZonaPlus_Class {
	static $cName = 'ZonaPlus';
	static $className = 'ZonaPlus_Class';
	static $DomainName = null;
	static $proxyArr = null;
	static $proxyArrMd5 = null;
	static $proxy = null;
	public static function getDomainName(){
		if (null === self::$DomainName)
			self::$DomainName = (HD::getItemStr(self::$cName . 'DomainName') != '') ? HD::getItemStr(self::$cName . 'DomainName') : 'https://w122.zona.plus';
		return self::$DomainName;
	}
	public static function getMainMenuInfo(){
		return array (
			'name' => self::$cName,
			'descr' => '||'.self::$cName.'|каталог видео с сайта ' . self::$cName . '||Если сайт не доступен используйте прокси или VPN, а так же официальные зеркала (сайты с похожим дизайном и названием могут не являтся зеркалом)'
		);
	}
	public static function get_media_url_str($k, $arr=null){
		if ($arr == true)
			return SmartVodCategoryListScreen::get_media_url_str($k, $arr);
		return SmartVodCategoryListScreen::get_media_url_str($k);
	}
	public static function getSearchMediaUrlStr($k, $arr=null){
		return SmartVodListScreen::get_media_url_str($k, $arr);
	}
	public static function getScreenActionMapArr($media_url){
		$actionsArr = array();
		if ((isset($media_url->screen_id))&&($media_url->screen_id == 'vod_list')){
			$actionsArr[0]['create_action'] = 'classAction';
			$actionsArr[0]['params'] = array ('indiClass' => self::$className,'action' => 'sort');
			$actionsArr[0]['caption'] = 'Сортировки';
			$actionsArr[0]['key'] = GUI_EVENT_KEY_C_YELLOW;
		}
		return $actionsArr;
	}
	public static function getPopUpMenuItems ($selected_media_url, $parent_media_url){
		$menu_items = array();
		if ($parent_media_url == 'main_menu'){
			$menu_items[] = array(
				'caption' => 'Задать зеркало ' . self::$cName,
				'params' => array ('action' => 'mirror'),
				'icon_url' => SmartConfig::getPluginIco('s_' . self::$className)
			);
			$menu_items[] = array(
				'caption' => 'Прокси для ' . self::$cName,
				'params' => array ('action' => 'proxy'),
				'icon_url' => SmartConfig::getPluginIco('s_proxy')
			);
			$menu_items[] = 'is_separator';
		}
		$parent_media_url = MediaURL::decode($parent_media_url);
		if ((isset($parent_media_url->screen_id))&&($parent_media_url->screen_id != 'vod_series')){
			$menu_items[] = array(
				'caption' => 'Добавить в Главное меню',
				'params' => array ('action' => 'addToMainMenu'),
				'icon_url' => SmartConfig::getPluginIco('s_home')
			);
		}
		return $menu_items;
	}
	public static function getVodCategories($media_url){
		static $categories = null;
		if (is_null($categories)){
			$categories['categories'][] = array('id'=> 'search', 'class' => 'SmartSearchScreen', 'caption' => 'Поиск');
			$categories['categories'][] = array('id'=>  '/movies', 'class' => 'SmartVodCategoryListScreen', 'caption' => 'Фильмы');
			$categories['categories'][] = array('id'=>  '/tvseries', 'class' => 'SmartVodCategoryListScreen', 'caption' => 'Сериалы');
		}
		if (isset($media_url->categoryId)){
			if (!isset($categories['subCategories'][$media_url->categoryId])){
				$doc = self::http_get_document(self::getDomainName() . $media_url->categoryId);
				$categories['subCategories'][$media_url->categoryId][] = array('id'=> $media_url->categoryId, 'class' => 'SmartVodListScreen', 'caption' => 'Все ' . $media_url->caption);
				if (preg_match_all('|filters-item".*?name="(.+?)".+?>(.+?)</.*?</span>|ms', $doc, $matches)){
					foreach($matches[0] as $k => $v){
						if ($matches[1][$k] == 'sort')
							continue;
						$categories['subCategories'][$media_url->categoryId][] = array('id'=>  $matches[1][$k], 'class' => 'SmartVodCategoryListScreen', 'caption' => $matches[2][$k]);
						if (preg_match_all('|value="(.+?)".*?>(.+?)</|ms', $v, $match)){
							foreach ($match[1] as $key => $vel){
								if (trim($vel) == '0')
									continue;
								$categories['subCategories'][$matches[1][$k]][] = array('id'=> $media_url->categoryId .'/filter/'.$vel, 'class' => 'SmartVodListScreen', 'caption' => HD::get_upper($match[2][$key]));
							}
						}
					}
				}
			}
			return $categories['subCategories'][$media_url->categoryId];
		}
		return $categories['categories'];
	}
	
	public static function getShortMovieRange ($media_url, &$m_feed){
		if ($m_feed === 'end')
			return $items;
		$sorting = (HD::getItemsArr(self::$className . '_sorting') != array()) ? HD::getItemsArr(self::$className . '_sorting') :  array('sort' => '');
		if ((!preg_match('/filter/',$media_url->categoryId))&&($sorting['sort'] != ''))
			$sorting['sort'] = '/filter/' . $sorting['sort'];
		$url =  self::getDomainName() . $media_url->categoryId . $sorting['sort'];
		if ($m_feed > 0)
			$url = $url .'?page='. ($m_feed+1);
		$doc = self::http_get_document($url);
		++$m_feed;
		if (!preg_match('|rel="next"|ms', $doc))
			$m_feed = 'end';
		return self::parseSitePage($doc);
	}
	public static function getSearchShortMovieRange ($keyword, &$m_feed){
		if (is_object($keyword))
			$keyword = $keyword->searchStr;
		if ($m_feed === 'end')
			return array();
		$opts [CURLOPT_POST] = true;
		$opts [CURLOPT_POSTFIELDS] = "query=" . urlencode($keyword);
		$doc = self::http_get_document(self::getDomainName() . '/search/' . urlencode($keyword));
		$m_feed = 'end';
		return self::parseSitePage($doc);
	}
	public static function parseSitePage($doc){
		$items = array();
		if (preg_match_all('|itemprop="url" href="(.+?)".*?url\((.+?)\).*?itemprop="name">(.+?)</.*?year">(.+?)</|ms', $doc, $match)){
			foreach($match[1] as $k => $v){
				if (preg_match('~news-kino-serials~', $v))
					continue;
				$img = $match[2][$k];
				if (!preg_match('|^http|',$match[2][$k]))
					$img = self::getDomainName() . $img;

				$name = HD::str_remove_tag($match[3][$k]);
				$info = '||' . $name;
				$info .= '|' . HD::str_remove_tag($match[4][$k]);
				if (preg_match('|rating">(.+?)</|ms', $match[0][$k], $matches))
					$info .= '||Рейтинг: ' . HD::str_remove_tag($matches[1]);
				if (class_exists('ShortMovie')){
					$short_movie = new ShortMovie(
						strval($v),
						strval($name),
						strval(self::http_get_img($img))
					);
					$short_movie->info = $info;
					array_push ($items, $short_movie);
				}else{
					$items[$v]['url'] = $v;
					$items[$v]['infoArr']['caption'] = $name;
					$items[$v]['infoArr']['poster_url'] = $img;
					$items[$v]['infoArr']['detailed_info'] = $info;
				}
			}
		}
		return $items;
	}
	public static function load_movie($movie_id, $mUrl, $getMovieInfo){
		$arr = array();
		$arr['caption'] = $arr['class_info']['catalog_info']['caption'] = $mUrl->caption;
		$arr['poster_url'] = $arr['class_info']['catalog_info']['poster_url'] = $mUrl->poster_url;
		if (isset($mUrl->caption_original))
			$arr['caption_original'] = $arr['class_info']['catalog_info']['caption_original'] = $mUrl->caption_original;
		if (isset($mUrl->year))
			$arr ['year'] = $arr['class_info']['catalog_info']['year'] = $mUrl->year;
		if (!preg_match("|^http|",$movie_id))
			$url = self::getDomainName() . $movie_id;
		else
			$url = preg_replace('#((http.*)://.+?\/)#i', self::getDomainName() . "/", $movie_id);
		$doc = self::http_get_document($url);
		if (preg_match('|itemprop="name">(.*?)</|ms', $doc, $match))
			$capt = $arr['caption_original'] =  $arr ['caption'] = HD::str_remove_tag($match[1]);
		if (preg_match('|alternateName">(.*?)</|ms', $doc, $match))
			$arr['caption_original'] = HD::str_remove_tag($match[1]);
		if (preg_match('|thumbnailUrl" src="(.+?)"|ms', $doc, $matches))
			$arr['poster_url'] = ($matches[1]);
		if (preg_match('|itemprop="description".*?>(.*?)</div|ms', $doc, $matches))
			$arr['description'] = HD::str_remove_tag($matches[1]);
		if (preg_match('|countries".*?>(.+?)</dd|ms', $doc, $matches))
			$arr['country'] = HD::str_remove_tag($matches[1]);
		if (preg_match('|genres".*?>(.+?)</dd|ms', $doc, $matches))
			$arr['genres'] = HD::str_remove_tag($matches[1]);
		if (preg_match('|copyrightYear".*?>(.+?)</dd|ms', $doc, $matches))
			$arr['year'] = HD::str_remove_tag($matches[1]);
		if (preg_match('|director".*?>(.*?)</dd|ms', $doc, $matches))
			$arr['director'] = HD::str_remove_tag($matches[1]);
		if (preg_match('|Актёры.*?>(.*?)</dd|ms', $doc, $matches))
			$arr['actors'] = HD::str_remove_tag($matches[1]);
		if (preg_match('|rating-mobi".*?>(.+?)</|ms', $doc, $matches))
			$arr ['rate_details']['Рейтинг:'] = round(HD::str_remove_tag($matches[1]), 1);
		if (preg_match('|rating-imdb".*?>(.+?)</|ms', $doc, $matches))
			$arr['rate_imdb'] = round(HD::str_remove_tag($matches[1]), 1);
		if (preg_match('|rating-kp".*?>(.+?)</|ms', $doc, $matches))
			$arr ['rate_kinopoisk'] = round(HD::str_remove_tag($matches[1]), 1);
		if (preg_match('|datetime="PT(.+?)M|ms', $doc, $matches))
			$arr ['length'] = HD::str_remove_tag($matches[1]);
		if (preg_match('|scenarist".*?>(.+?)</|ms', $doc, $matches))
			$arr ['scenario'] = HD::str_remove_tag($matches[1]);
		if (preg_match('|poster="(.+?)"|ms', $doc, $matches))
			$arr ['background_urls'][] = HD::str_remove_tag($matches[1]);
		if (preg_match('|wrap" data-id="(\d*?)"|ms', $doc, $match))
			$arr['class_info']['dbIDs']['kpID'] = $match[1];
		else{
			$kpIDs = HD::getItemsArr('kpIDs');
			if (isset($kpIDs[$movie_id]))
				$arr['class_info']['dbIDs']['kpID'] = $kpIDs[$movie_id];
		}
		if ($getMovieInfo != 'min')
			$arr = SmartConfig::getMovieInfoArr($getMovieInfo, $movie_id, $mUrl, $arr);
		// if ((isset($arr['class_info']['dbIDs']['kpID']))&&($arr['class_info']['dbIDs']['kpID'] != ''))
			// $arrZona = zonaMobi::getZonaMobiIframe ($arr['class_info']['dbIDs']['kpID'], 'kpId', self::getDomainName());
		// else
			$arrZona = zonaMobi::getZonaMobiIframe ($movie_id, 'doc', $doc);
		if ($arrZona == true)
			$arr['class_info']['linksArr'][self::$className] = $arrZona;
		return $arr;
	}
	public static function getVodSourceInfo($v){
		$ico = SmartConfig::getPluginIco($v);
		$arr['caption'] = self::$cName;
		$arr['icon_path'] = $ico;
		$arr['detailed_icon_path'] = $ico;
		$arr['class_name'] = $v;
		$arr['detailed_info'] = '||' . self::$cName . '|видео с сайта '.self::$cName.'. Поиск видео на сайте '.self::$cName.' производится по названию возможны неточности.';
		$arr['type'] = SmartConfig::getPluginIco('onlineSource');
		return $arr;
	}
	public static function getIframe($params){
		$iframeInfo = array($params);
		if (isset($params['linksArr'][self::$className])){
			foreach ($params['linksArr'][self::$className] as $k => $v){
				if (($k == 'm')||(preg_match('|^http|', $k)))
					$k = self::$cName;
				if (preg_match("|EpisodId_|", $v))
					$iframeInfo['urls'][$k]['goTo'] = 'VodSeriesListScreen';
				else
					$iframeInfo['urls'][$k]['goTo'] = 'VodSeasonListScreen';
				$iframeInfo['urls'][$k]['link'] = $v;
			}
			return $iframeInfo;
		}else if (isset($params['kpID'])){
			$urls = zonaMobi::getZonaMobiIframe ($params['kpID'], 'kpId', self::getDomainName());
			if ($urls == true){
				foreach ($urls as $k => $v){
					if (($k == 'm')||(preg_match('|^http|', $k)))
						$k = self::$cName;
					if (preg_match("|EpisodId_|", $v))
						$iframeInfo['urls'][$k]['goTo'] = 'VodSeriesListScreen';
					else
						$iframeInfo['urls'][$k]['goTo'] = 'VodSeasonListScreen';
					$iframeInfo['urls'][$k]['link'] = $v;
				}
			}else{
				echo "\n".self::$cName.":search failed";
				return array("status"=>false);
			}
			return $iframeInfo;
		}else{
			if (HD::strSanitizing($params['caption_original']) != HD::strSanitizing($params['caption'])){
				$year = 'null';
				if (isset($params['caption_original'])){
					$keyword = $params['caption_original'];
					$m_feed= 0;
					$arr = self::getSearchShortMovieRange ($keyword, $m_feed);
					foreach ($arr as $k => $v){
						if (HD::strSanitizing($keyword) == HD::strSanitizing($v['infoArr']['caption'])){
							extract ($v);
							$iframeInfo['infoArr'] = $infoArr;
							break;
						}
					}
				}
			}
			if (!isset($url)){
				$keyword = $params['caption'];
				$m_feed= 0;
				$arr = self::getSearchShortMovieRange ($keyword, $m_feed);
				foreach ($arr as $k => $v){
					if (HD::strSanitizing($keyword) == HD::strSanitizing($v['infoArr']['caption'])){
						extract ($v);
						$iframeInfo['infoArr'] = $infoArr;
						break;
					}
				}
				if (!isset($url))
					if (count($arr) > 0){
						$f = array_shift($arr);
						extract ($f);
						$iframeInfo['infoArr'] = $infoArr;
					}
			}
			if (isset($url)){
				if (!preg_match("|^http|",$url))
					$url = self::getDomainName() . $url;
				$urls = zonaMobi::getZonaMobiIframe ($url, 'video_id',  self::getDomainName());
			}else{
				echo "\n".self::$cName.":search failed";
				return array("status"=>false);
			}
		}
		if ($urls == true){
			foreach ($urls as $k => $v){
				$k = self::$cName;
				if (preg_match("|EpisodId_|", $v))
					$iframeInfo['urls'][$k]['goTo'] = 'VodSeriesListScreen';
				else
					$iframeInfo['urls'][$k]['goTo'] = 'VodSeasonListScreen';
				$iframeInfo['urls'][$k]['link'] = $url;
			}
			return $iframeInfo;
		}else{
			echo "\n".self::$cName.":search failed";
			return array("status"=>false);
		}
		return $iframeInfo;
	}
	public static function get_series_list($media_url, $movie){
		if (preg_match('|EpisodId_|', $media_url->link)){
			$qltyMax = false;
			if (preg_match('|(.+?)\sQ:(\d+)|', $media_url->caption, $m))
				$qltyMax = $m[2];
			$hash_patrs = $media_url->caption;
			if (isset($media_url->hash_patrs)){
				$hash_patrs = implode("", (array)$media_url->hash_patrs);
			}
			$items[$media_url->caption]['id'] = md5 ($hash_patrs);
			$items[$media_url->caption]['title'] = $media_url->caption;
			$items[$media_url->caption]['playback_url'] = $media_url->link;
			$items[$media_url->caption]['is_stream_url'] = false;
			$items[$media_url->caption]['file_info']['poster_url'] = $media_url->poster_url;
			$items[$media_url->caption]['file_info']['details_box_width'] = true;
			$items[$media_url->caption]['file_info']['class_name'] = $media_url->class_name;
			if (isset($media_url->description))
				$items[$media_url->caption]['file_info']['description'] = $media_url->description;
			$items[$media_url->caption]['file_info']['detailed_info'] = $media_url->detailed_info;
			if ($qltyMax == true)
				$items[$media_url->caption]['file_info']['qltyMax'] = $qltyMax;
			return $items;
		}
		$episodes  = zonaMobi::getZonaMobiIframe ($media_url->link, 'season', self::getDomainName());
		if ($episodes == true){
			$items = array();
			foreach ($episodes as $key => $vel){
				$qltyMax = false;
				if (preg_match('|(.+?)\sQ:(\d+?)$|', $key, $m)){
					$key = $m[1];
					$qltyMax = $m[2];
				}
				$tvshow_se = VideoInfo::tvshow_se_parse($key);
				if (isset($tvshow_se['S']))
					$media_url->hash_patrs->season = $tvshow_se['S'];
				if (isset($tvshow_se['E']))
					$media_url->hash_patrs->episode = $tvshow_se['E'];
				else
					$media_url->hash_patrs->episode = $key;
				$hash_patrs = implode("", (array)$media_url->hash_patrs);
				$items[$key]['id'] = md5 ($hash_patrs);
				$items[$key]['title'] = $key;
				$items[$key]['playback_url'] = $vel;
				$items[$key]['is_stream_url'] = false;
				$items[$key]['file_info']['poster_url'] = $media_url->poster_url;
				$items[$key]['file_info']['details_box_width'] = true;
				$items[$key]['file_info']['class_name'] = $media_url->class_name;
				$items[$key]['file_info']['detailed_info'] = $media_url->detailed_info;
				if (isset($media_url->description))
					$items[$key]['file_info']['description'] = $media_url->description;
				if ($qltyMax == true)
					$items[$key]['file_info']['qltyMax'] = $qltyMax;
			}
		}
		return $items;
	}
	public static function getSeasons($media_url){
		$urls = zonaMobi::getZonaMobiIframe ($media_url->link, 'video_id', self::getDomainName());
		foreach ($urls as $k => $v){
			$uArr[$k]['caption'] = $k;
			$uArr[$k]['link'] = $v;
			$uArr[$k]['detailed_info'] = '||' . $k . $media_url->detailed_info;
			$uArr[$k]['class_name'] = $media_url->class_name;
			$uArr[$k]['poster_url'] = $media_url->poster_url;
			$uArr[$k]['goTo'] = 'VodSeasonListScreen';
			if (preg_match("|SeasonId|",$v)){
				$uArr[$k]['season'] = $k;
				$uArr[$k]['goTo'] = 'VodSeriesListScreen';
			}
		}
		return $uArr;
	}
	public function classAction ($defs, $user_input, $select_url = null){
		hd_restore_warnings();
		$post_action = null;
		$caption = 'Error!';
		$msg = 'classAction: action';
		$width = 1050;
		$parent_media_url = MediaURL::decode($user_input->parent_media_url);
		if ($user_input->action == 'sort'){
			$sorting = (HD::getItemsArr(self::$className . '_sorting') != array()) ? HD::getItemsArr(self::$className . '_sorting') :  array('sort' => '');
			$add_params['control_id']= $user_input->control_id;
			$add_params['action'] = $user_input->action;
			$add_params['indiClass'] = self::$className;
			if ((isset($user_input->selected_control_id))&&(isset($user_input->action_type))){
				if (isset($user_input->initial_sel_ndx))
					$add_params['initial_sel_ndx'] = $user_input->initial_sel_ndx;
				$sorting['sort'] = $user_input->sorting;
				if (HD::saveItemsArr(self::$className . '_sorting', $sorting) == false)
					return ActionFactory::show_title_dialog("Сохранение не удалось");
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
				$action = ActionFactory::close_dialog_and_run($action);
				return ActionFactory::invalidate_folders(array($user_input->parent_media_url), $action);
			}
			$add_params['initial_sel_ndx'] = 0;
			$sorting = $sorting['sort'];
			$sorting_ops['']		= 'По популярности';
			$sorting_ops['/sort-rating']	= 'По рейтингу';
			$sorting_ops['/sort-date']		= 'По дате выхода';
			ControlFactory::add_combobox($defs, $this, $add_params,
				'sorting', '',
				$sorting, $sorting_ops, 800, true, false
			);
			$attrs['initial_sel_ndx'] = isset($user_input->initial_sel_ndx) ? $user_input->initial_sel_ndx : -1;
			return ActionFactory::show_dialog("Cортировка:", $defs, true, 0, $attrs);
		}
		if (isset($user_input->selected_media_url))
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
		else{
			$msg = 'classAction: selected_media_url';
			return ActionFactory::show_title_dialog($caption, $post_action, $msg, 0);
		}
		$class_name = $selected_media_url->class_name;
		$parent_media_url = MediaURL::decode($user_input->parent_media_url);
		
		return ActionFactory::show_title_dialog($caption, $post_action, $msg, 0);
	}
	public static function http_get_img ($url){
		if (self::$proxy == true){
			$path_parts = parse_url(self::getDomainName());
			if (!preg_match("|^http|",$url))
				return DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . self::getDomainName() . $url . "&proxy=" . self::$cName;
			if (preg_match("|".$path_parts['host']."|",$url))
				return DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . $url . "&proxy=" . self::$cName;
		}
		if (!preg_match("|^http|",$url))
			$url = self::getDomainName() . $url;
		return $url;
		// return DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . $url;
	}
	public static function http_get_document ($url, $opts=null){
		
		if (is_null(self::$proxy)){
			self::$proxy = false;
			$sitesProxy = HD::getItemsArr('sitesProxy');
			if (isset($sitesProxy[self::$cName])){
				$proxySettings = (HD::getItemsArr('proxySettings') != array()) ? HD::getItemsArr('proxySettings') : array();
				if (isset($proxySettings['proxy'])){
					self::$proxy['proxy'] = $proxySettings['proxy'];
					if ((isset($proxySettings['proxyType']))&&($proxySettings['proxyType'] == 'SOCKS5'))
						self::$proxy['proxyType'] = $proxySettings['proxyType'];
					if (isset($proxySettings['proxyAccount']))
						self::$proxy['proxyAccount'] = $proxySettings['proxyAccount'];
				}
			}
		}
		if (self::$proxy == true){
			$opts[CURLOPT_PROXY] = self::$proxy['proxy'];
			if (isset(self::$proxy['proxyType']))
				$opts[CURLOPT_PROXYTYPE] = CURLPROXY_SOCKS5;
			if (isset(self::$proxy['proxyAccount']))
				$opts[CURLOPT_PROXYUSERPWD] = self::$proxy['proxyAccount'];
		}
		$rcpc = zonaMobi::getRCPC(self::$DomainName);
		if (is_null($rcpc))
            return false;
		$headers[] = 'Cookie: ' . $rcpc;
		$opts[CURLOPT_HTTPHEADER] = $headers;
		return HD::http_get_document($url, $opts);
	}
}
?>
