<?php

function
safely_get_value_of_global_variables ($name, $key)
{
  return (isset ($name[$key]) ) ? ($name[$key]) : ('');
}

class DuneSystem
{
  public static $properties = array ();
};
DuneSystem::$properties['plugin_name']      = safely_get_value_of_global_variables ($_ENV, 'PLUGIN_NAME');
DuneSystem::$properties['install_dir_path'] = safely_get_value_of_global_variables ($_ENV, 'PLUGIN_INSTALL_DIR_PATH');
DuneSystem::$properties['tmp_dir_path']     = safely_get_value_of_global_variables ($_ENV, 'PLUGIN_TMP_DIR_PATH');
DuneSystem::$properties['plugin_www_url']   = safely_get_value_of_global_variables ($_ENV, 'PLUGIN_WWW_URL');
DuneSystem::$properties['plugin_cgi_url']   = safely_get_value_of_global_variables ($_ENV, 'PLUGIN_CGI_URL');
DuneSystem::$properties['data_dir_path']    = safely_get_value_of_global_variables ($_ENV, 'PLUGIN_DATA_DIR_PATH');

class HD{
	public static function getItemsArr($path, $macAdr=null) {
		$items = array();
		if ($macAdr==true)
			$path .= '_' . str_replace(":", "", self::get_mac_addr());
		if ($path=='data_dir_path')
			$link = DuneSystem::$properties['data_dir_path'] . '/'. $path;
		else
			$link = self::get_data_path() . '/'. $path;
		if (file_exists($link))
			$items = unserialize(file_get_contents($link));
		return $items;
	}
	public static function http_get_document($url, $opts = null){
		$silent = 1;
        $ch = curl_init();
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 	0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 	0);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT,    30);
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION,    true);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER,    true);
        curl_setopt($ch, CURLOPT_TIMEOUT,           30);
        curl_setopt($ch, CURLOPT_USERAGENT,         'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/80.0.3987.122 Safari/537.36');
        curl_setopt($ch, CURLOPT_URL,               $url);

        if (isset($opts)){
            foreach ($opts as $k => $v){
				if ($k == 'getHttpCode')
					$getHttpCode = true;
				else if ($k == 'hideUrl')
					$hideUrl = true;
				else if ($k == 'silent')
					$silent = true;
				else{
					
					curl_setopt($ch, $k, $v);
				}
			}
        }
		if (!isset($silent)){
			if (isset($opts[CURLOPT_PROXY]))
				if (!isset($silent))
					echo 'Use Proxy';
			if (isset($opts[CURLOPT_PROXYTYPE]))
				if (!isset($silent))
					echo 'Use Proxy: SOCKS5';
			if (isset($opts[CURLOPT_PROXYUSERPWD]))
				if (!isset($silent))
					echo 'Use Proxy: PROXYUSERPWD';
			if (isset($hideUrl))
				if (!isset($silent))
					echo("HTTP fetching 'url'...");
			else if (!isset($silent))
					echo("HTTP fetching '$url'...");
		}
        $content = curl_exec($ch);
        $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);

        if($content === false){
            $err_msg['Error:'] = "HTTP error $http_code (" . curl_error($ch) . ')';
			if (!isset($silent))
				echo($err_msg['Error:']);
        }
        if ($http_code != 200){
            $err_msg['Request:'] = "HTTP request failed ($http_code): " ;
			if (!isset($silent))
				echo($err_msg['Request:']);
        }
        curl_close($ch);
		if ((!isset($err_msg))&&(!isset($silent)))
			echo("HTTP OK ($http_code)");
		if (isset($getHttpCode)){
			$err_msg['httpCode'] = $http_code;
			return $err_msg;
		}
        return $content;
    }
	public static function get_ip_address(){
        static $ip_address = null;
        if (is_null($ip_address)){
hd_print("EEE: get_ip_address2()");
            preg_match_all('/Link encap:Ethernet.*?inet'.(false ? '6?' : '').' addr: ?([^ ]+)/ms', `ifconfig`, $ips);
			if ($ips[1][0]!= '127.0.0.1')
				$ip_address = $ips[1][0];
			else if ($ips[1][1]!= '127.0.0.1')
				$ip_address = $ips[1][1];
        }
hd_print("EEE: get_ip_address2(): $ip_address");
        return $ip_address;
    }
	public static function isDomainAvailible($domain, $timeout=null){
		if ($timeout==false)
			$timeout=1;
		$curlInit = curl_init($domain);
		curl_setopt($curlInit,CURLOPT_CONNECTTIMEOUT,$timeout);
		if (!preg_match('|/echo$|', $domain)){
			curl_setopt($curlInit,CURLOPT_HEADER,true);
			curl_setopt($curlInit,CURLOPT_NOBODY,true);
		}
		curl_setopt($curlInit,CURLOPT_RETURNTRANSFER,true);
		$response = curl_exec($curlInit);
		curl_close($curlInit);
		if ((preg_match('|/echo$|', $domain))&&($response))
			return $response;
		if ($response){
			if (!preg_match('/404/', $response))
				return true;
		}
		return false;
	}
	public static function isServerAvailable ($ip=null, $port=null){
		if ($ip == true){
			$ip = str_replace(array('https://', 'http://'), '', $ip);
			if ($port == true)
				$hosts[] = "$ip:$port";
			else
				$hosts[] = $ip;
		}else if (($port == true)&&(preg_match("/(\d{1,3}\.\d{1,3}\.\d{1,3})\.\d{1,3}$/", self::get_ip_address(), $match)))
			for ($i = 1; $i<255; $i++)
				$hosts[] = $match[1] . ".$i:$port";
		else
			return false;
		$timeout = 1;
		$trueArr = $status = $sockets = array();
		foreach ($hosts as $id => $host) {
			$s = @stream_socket_client ($host, $errno, $errstr, $timeout, STREAM_CLIENT_ASYNC_CONNECT|STREAM_CLIENT_CONNECT);
			if($s)
				$sockets[$id] = $s;
		}
		while (count($sockets)) {
			$read = $write = $sockets;
			// hd_silence_warnings();
			$n = stream_select ($read, $write, $e = null, $timeout);
			// hd_restore_warnings();
			if ($n > 0) {
				foreach ($read as $r) {
					$id = array_search($r, $sockets);
					$data = fread($r, 8192);
					if (strlen($data) == 0) {
						fclose($r);
						unset ($sockets[$id]);
					}else 
						$status[$id] = 1;
				}
				foreach ($write as $w) {
					$id = array_search($w, $sockets);
					// hd_silence_warnings();
					@fwrite ($w, "HEAD / HTTP/1.0\r\nHost: " . $hosts[$id] . "\r\n\r\n");
					// hd_restore_warnings();
				}
			}else
				break;
		}
		if (count($status) > 0)
			foreach ($status as $k => $v)
				$trueArr [$hosts[$k]]= $hosts[$k];
		if ($ip== true){
			if ($port == true){
				if(isset($trueArr ["$ip:$port"]))
					return true;
				else
					return false;
			}else{
				if(isset($trueArr [$ip]))
					return true;
				else
					return false;
			}
		}
		return $trueArr;
	}
	public static function get_data_path($reset=null) {
		static $link = null;
		if ($reset== true)
			$link = null;
		if (is_null($link))	{
			$link = DuneSystem::$properties['data_dir_path'];
			if (file_exists($link . '/data_dir_path'))
				$link = smbtree::get_folder_info ('data_dir_path');
		}
		return $link;
	}
	public static function saveItemStr($path, $item, $macAdr=null) {
		if ($macAdr == true)
			$path .= '_' . str_replace(":", "", self::get_mac_addr());
		$link = self::get_data_path() . "/$path";
		if (file_put_contents ($link, $item) !== false)
			return true;
		else
			return false;
	}
	public static function getItemStr($path, $macAdr=null) {
		$item = '';
		if ($macAdr == true)
			$path .= '_' . str_replace(":", "", self::get_mac_addr());
		$link = self::get_data_path() . "/$path";
		if (file_exists($link))
			$item = file_get_contents($link);
		return $item;
	}
	public static function is_android(){
        return is_file("/system/dunehd/init") || getenv("FS_PREFIX");
    }
	public static function get_platform_kind(){
		static $platform_kind = null;
		if (is_null($platform_kind)){
			$ini_arr = parse_ini_file('/tmp/run/versions.txt');
			if (preg_match('|87\d\d|', $ini_arr['platform_kind']))
				$platform_kind = '87xx';
			if (preg_match('|864\d|', $ini_arr['platform_kind']))
				$platform_kind = '864x';
			if (preg_match('|867\d|', $ini_arr['platform_kind']))
				$platform_kind = '867x';
			if (preg_match('|865\d|', $ini_arr['platform_kind']))
				$platform_kind = '865x';
			if (preg_match('|android|', $ini_arr['platform_kind']))
				$platform_kind = 'android';
		}
		return $platform_kind;
	}
}

class smbtree
{
  private $cmd            = 'smbtree';
  private $descriptorspec = array ();
  private $cwd            = '/';
  private $env            = array ();
  private $smbtree_output = '';
  private $return_value   = 0;
  private $no_pass        = true;
  private $debuglevel     = 0;

  public function __construct (){
    $this->cmd = '/tango/firmware/bin/smbtree ';
    $this->cwd = '/tmp';

    $this->descriptorspec = array
      (
        0 => array("pipe", "r"),
        1 => array("pipe", "w"),
        2 => array("pipe", "w")
      );
    $this->env = array ('LD_LIBRARY_PATH' => '/tango/firmware/lib');

    $no_pass = true;
  }
  
  private function get_auth_options (){
    if ($this->is_no_pass ())
      return '-N';

    return '';
  }

  private function get_debug_level (){
    return '--debuglevel ' . $this->debuglevel;
  }

  private function is_no_pass (){
    return $this->no_pass;
  }

  /*
   * @return 0 if success
   */
  private function execute ($args = ''){
    $process = proc_open ($this->cmd
      . $this->get_auth_options () . ' '
      . $this->get_debug_level () . ' '
      . $args,
      $this->descriptorspec, $pipes, $this->cwd, $this->env);

    if (is_resource ($process))
    {
      //fclose ($pipes[0]);
      
      $this->smbtree_output = stream_get_contents ($pipes[1]);
      fclose ($pipes[1]);
      fclose ($pipes[2]);
    
      // Важно закрывать все каналы перед вызовом
      // proc_close во избежание мертвой блокировки
      $this->return_value = proc_close ($process);
    }

    return $this->return_value;
  }

  private function parse_smbtree_output ($input_lines){
    $output = array ();

    if (!strlen ($input_lines))
      return array ();

    $output_lines = explode ("\n", $input_lines);
    if ($output_lines == false)
      return array ();

    foreach ($output_lines as $line)
    {
      if (strlen ($line))
      {
        $detail_info = explode ("\t", $line);

        if (count ($detail_info))
        {
		  $q = isset($detail_info[1]) ? $detail_info[1] : '';
		  $output[$detail_info[0]] = array
            (
              'name'     => $detail_info[0],
              'comment'  => $q,
            );
        }
      }
    }

    return $output;
  }

  public function get_xdomains (){
    if ($this->execute ('--xdomains') != 0)
      return array ();

    return $this->parse_smbtree_output ($this->smbtree_output);
  }

  public function get_domains (){
    if ($this->execute ('--domains') != 0)
      return array ();

    return $this->parse_smbtree_output ($this->smbtree_output);
  }

  public function get_workgroup_servers ($domain){
    if ($this->execute ('--workgroup-servers=' . $domain) != 0)
      return array ();

    return $this->parse_smbtree_output ($this->smbtree_output);
  }

  public function get_server_shares ($server){
    if ($this->execute ('--server-shares=' . $server) != 0)
      return array ();

    return $this->parse_smbtree_output ($this->smbtree_output);
  }
  public static function get_df_smb (){
	$df_smb = array();
	$out_mount = file_get_contents("/proc/mounts");
	if (preg_match_all('|(.+) /tmp/mnt/smb/(.+?) |', $out_mount, $match))
		foreach ($match[2] as $k => $v)
			$df_smb[str_replace(array('/','\134'), '', $match[1][$k])]=$v;
	return $df_smb;
  }
	public function get_network_folder_smb (){
		$d = array();
		$network = parse_ini_file('/config/network_folders.properties',true);
		foreach ($network as $k => $v)
			if (preg_match("|(.*)\.(.*)|", $k, $match))
				$network_folder[$match[2]][$match[1]] = $v;
		foreach ($network_folder as $k => $v){
			if ($v['type']==0){
				$dd['foldername'] =$v['name'];
				if ($v['user'] != '')
				$dd['user'] =$v['user'];
				if ($v['password'] != '')
				$dd['password'] =$v['password'];
				$d[$v['server']][$v['directory']] = $dd;
			}
		}
		return $d;
	}
	public function get_server_shares_smb (){
		$d=array();
		$data = self::get_xdomains ();
		foreach ($data as $domain){
			$data = self::get_workgroup_servers ($domain['name']);
			 foreach ($data as $shares)
			 $d[$shares['name']] = self::get_server_shares ($shares['name']);
		}
		return $d;
	}
  
	public function get_ip_network_folder_smb (){
		$d=array();
		$network_folder_smb = self::get_network_folder_smb ();
		foreach ($network_folder_smb as $k => $v){
			if (!preg_match('@((25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(25[0-5]|2[0-4]\d|[01]?\d\d?)@', $k)){
				$out = shell_exec ('export LD_LIBRARY_PATH=/firmware/lib:$LD_LIBRARY_PATH&&/firmware/bin/nmblookup "'.$k.'" -S');
				if (preg_match('/(.*) (.*)<00>/', $out, $matches)){
					$ip = '//'. $matches[1] . '/';
					if ($matches[2] == $k)
						foreach ($v as $key => $vel)
							$d[$ip.$key] = $vel;
				}
			}else{
				foreach ($v as $key => $vel)
					$d['//'.$k.'/'.$key] = $vel;
			}
		}
		return $d;
	}
  
	public function get_ip_server_shares_smb (){
		$d=array();
		$my_ip = HD::get_ip_address();
		$server_shares_smb = self::get_server_shares_smb ();
		foreach ($server_shares_smb as $k => $v)
		{
			$out = shell_exec ('export LD_LIBRARY_PATH=/firmware/lib:$LD_LIBRARY_PATH&&/firmware/bin/nmblookup '.$k.' -R');
			if (preg_match('/(.*) (.*)<00>/', $out, $matches)){
			if ($my_ip == $matches[1])
				continue;
			$ip = '//'. $matches[1] . '/';
			if ($matches[2] == $k)
				foreach ($v as $key => $vel){
					$vel['foldername'] = $key . ' in ' . $k;
					$d[$ip.$key] = $vel;
				}
			}
		}
		return $d;
	}
	public static function write_request($server_id, $cmd_name, $cmd_id, $params){
        $dir_path = "/tmp/run/ipc__$server_id";
        if (!is_dir($dir_path))
            return false;

        $pid = posix_getpid();
        $path = "$dir_path/$cmd_name.$pid-$cmd_id.cmd";
        $tmp_path = "$path.tmp";

        $fp = fopen($tmp_path, "w");
        if ($fp === false)
            return false;

        foreach ($params as $key => $value)
            fprintf($fp, "$key = $value\n");

        fclose($fp);

        if (false === rename($tmp_path, $path)){
            unlink($tmp_path);
            return false;
        }
        $path = "$dir_path/$cmd_name.$pid-$cmd_id.res";
		sleep (1);
		if (!file_exists($path))
			return false;
		$res = parse_ini_file($path,true);
		unlink($path);
		$path = '/tmp/run/network_mount_list.xml';
		if (!file_exists($path))
			return false;
		$doc = file_get_contents($path);
        $xml = simplexml_load_string($doc);
        if ($xml === false){
            echo("Error parsing $path.");
            return;
        }

        foreach ($xml->children() as $elt){
            $elt_name = $elt->getName();
            if ($elt_name != 'mount')
                continue;
			
            $id = intval($elt["id"]);
            $path = strval($elt["path"]);
			$type = strval($elt["type"]);
			if (($id == $res['id'])&&($type == $params['type']))
				return $path;
        }
	}
	public static function get_mount_smb ($ip_smb){
		$d = array();
		foreach ($ip_smb as $k => $vel){
			$df_smb = self::get_df_smb ();
			if (isset($df_smb[str_replace(array('/','\134'), '',$k)])){
				$d['/tmp/mnt/smb/'.$df_smb[str_replace(array('/','\134'), '',$k)]]['foldername'] = $vel['foldername'];
				$d['/tmp/mnt/smb/'.$df_smb[str_replace(array('/','\134'), '',$k)]]['ip'] = $k;
				if ((isset($vel['user']))&&($vel['user'] != ''))
					$d['/tmp/mnt/smb/'.$df_smb[str_replace(array('/','\134'), '',$k)]]['user'] = $vel['user'];
				if ((isset($vel['password']))&&($vel['password'] != ''))
					$d['/tmp/mnt/smb/'.$df_smb[str_replace(array('/','\134'), '',$k)]]['password'] = $vel['password'];
			}else{
				$q = false;
				if (count($df_smb)>0)
					$n = count($df_smb);
				else $n = 0;
				$username='guest';
				$password='';
				if ((isset($vel['user']))&&($vel['user'] != ''))
					$username=$vel['user'];
				if ((isset($vel['password']))&&($vel['password'] != ''))
					$password=$vel['password'];
				$path_parts = pathinfo($k);
				$wr = self::write_request('network_manager', 'mount', $n,
				array(
					'type' => 'smb',
					'server' => str_replace("//", "",$path_parts['dirname']),
					'dir' => $path_parts['basename'],
					'user_name' => $username,
					'password' => $password,
					'proto' => '',
				));
				if ($wr==false){
					$fn = '/tmp/mnt/smb/'. $n;
					if (!file_exists($fn))
						mkdir($fn,0777,true);
					$q = exec("mount -t cifs -o username=$username,password=$password,posixpaths,rsize=32768,wsize=130048 \"$k\" \"$fn\" 2>&1 &");
				}else
					$fn = $wr;
				if ($q==true){
					$d['err_'.$vel['foldername']]['foldername'] = $vel['foldername'];
					$d['err_'.$vel['foldername']]['ip'] = $k;
					$d['err_'.$vel['foldername']]['err'] = trim($q);
					if ((isset($vel['user']))&&($vel['user'] != ''))
						$d['err_'.$vel['foldername']]['user'] = $vel['user'];
					if ((isset($vel['password']))&&($vel['password'] != ''))
						$d['err_'.$vel['foldername']]['password'] = $vel['password'];
				}else{
					$d[$fn]['foldername'] = $vel['foldername'];
					$d[$fn]['ip'] = $k;
					if ((isset($vel['user']))&&($vel['user'] != ''))
						$d[$fn]['user'] = $vel['user'];
					if ((isset($vel['password']))&&($vel['password'] != ''))
						$d[$fn]['password'] = $vel['password'];
				}
			}
		}
		return $d;
	}
  public function get_smb_infs ($item=false){
	$q = 1;
	$path = DuneSystem::$properties['data_dir_path'].'/smb_setup';
	if ($item==false){
	if (file_exists($path))
		$q = file_get_contents($path);
	}else{
		$data = fopen($path,"w");
		if (!$data)
		return ActionFactory::show_title_dialog("Не могу записать items Что-то здесь не так!!!");
		fwrite($data, $item);
		@fclose($data);
		$q =  $item;
	}
	return $q;
  }
 public function get_mount_all_smb (){
	$q = self::get_smb_infs ();
	if ($q!=3)
		$a = self::get_mount_smb (self::get_ip_network_folder_smb());
	if ($q==1)
		return $a;
	$b = self::get_mount_smb (self::get_ip_server_shares_smb());
	if ($q==3)
		return $b;
	return array_merge($b,$a);	
  }
  public function get_network_folder_nfs (){
	$d = array();
	$network = parse_ini_file('/config/network_folders.properties',true);
	foreach ($network as $k => $v){
		if (preg_match("|(.*)\.(.*)|", $k, $match))
			$network_folder[$match[2]][$match[1]] = $v;
	}
	foreach ($network_folder as $k => $v){
		if ($v['type']==1){
			$p = 'udp';
			if ($v['protocol']==1)
				$p = 'tcp';
			$nfs[$v['server'].':'.$v['directory']]['foldername'] = $v['name'];
			$nfs[$v['server'].':'.$v['directory']]['protocol'] =$p;
			$nfs[$v['server'].':'.$v['directory']]['server'] = $v['server'];
			$nfs[$v['server'].':'.$v['directory']]['directory'] = $v['directory'];
		}
	}
	return $nfs;
  }
	public function get_df_nfs (){
		$df_nfs = array();
		$out_mount = file_get_contents("/proc/mounts");
		if (preg_match_all('|(.+) /tmp/mnt/network/(.+?) |', $out_mount, $match))
		foreach ($match[2] as $k => $v)
			$df_nfs[$match[1][$k]]=$v;
		return $df_nfs;
	}
	public function get_mount_nfs (){
		$d = array();
		$ip_nfs = self::get_network_folder_nfs ();
		$df_nfs = self::get_df_nfs ();
		foreach ($ip_nfs as $k => $vel){
			if (isset($df_nfs[$k])){
				$d['/tmp/mnt/network/'.$df_nfs[$k]]['foldername'] = $vel['foldername'];
				$d['/tmp/mnt/network/'.$df_nfs[$k]]['ip'] = $k;
				$d['/tmp/mnt/network/'.$df_nfs[$k]]['protocol'] = $vel['protocol'];
			}else{
				$q = false;
				if (count($df_nfs)>0)
					$n = count($df_nfs) + 100;
				else $n = 100;
				$wr = self::write_request('network_manager', 'mount', $n,
				array(
						'type' => 'nfs',
						'server' => $vel['server'],
						'dir' => $vel['directory'],
						'proto' => $vel['protocol'],
					));
				echo $wr;
				if ($wr==false){
					$fn = '/tmp/mnt/network/'. $n;
					if (!file_exists($fn))
						mkdir($fn,0777,true);
					$q = shell_exec("mount -t nfs -o ".$vel['protocol']." $k $fn 2>&1");
				}else
					$fn = $wr;
				if ($q==true){
					$d['err_'.$vel['foldername']]['foldername'] = $vel['foldername'];
					$d['err_'.$vel['foldername']]['ip'] = $k;
					$d['err_'.$vel['foldername']]['protocol'] = $vel['protocol'];
					$d['err_'.$vel['foldername']]['err'] = trim($q);
				}else{
					$d[$fn]['foldername'] = $vel['foldername'];
					$d[$fn]['ip'] = $k;
					$d[$fn]['protocol'] = $vel['protocol'];
				}
			}
		}
		return $d;
	}
  public static function get_folder_info ($param){
	$select_folder = false;
	if (file_exists(DuneSystem::$properties['data_dir_path'] .'/'. $param)){
		$saveFolder = unserialize(file_get_contents(DuneSystem::$properties['data_dir_path'] .'/'. $param));
		if (isset($saveFolder['filepath']))
			$select_folder = $saveFolder['filepath'];
		else
			foreach ($saveFolder as  $k => $v){
				if ((isset($v['foldername']))&&(isset($v['user'])))
					$q = self::get_mount_smb ($saveFolder);
				if ((isset($v['foldername']))&&(!isset($v['user'])))
					$q = self::get_mount_nfs ();
				$select_folder = key($q).$v['foldername'];
			}
	}
	return $select_folder;
  }
  public static function get_bug_platform_kind(){
		static $bug_platform_kind = null;
		
		if (is_null($bug_platform_kind))
		{
			$arr = file('/tmp/run/versions.txt'); $v = '';
			foreach($arr as $line)
			{
				if ( stristr($line, 'platform_kind=') )
				{
					$v = trim( substr($line, 14) );
				}
			}
			$platform_kind = $v;
			if (($platform_kind =='8672')||($platform_kind =='8673')||($platform_kind =='8758'))
				$bug_platform_kind = true;
			else
				$bug_platform_kind = false;
			
		}
		return $bug_platform_kind;
	}
}
